/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(oe){for(var e=[],b=0,S=oe.length;b<S;b++)e[b]=Ce[oe[b]];return e};define(Ce[72],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=S,e.$$h=k,e.$_h=O;function b(A){return(T,p,a)=>{let R=null,y=null;if(typeof a.value=="function"?(R="value",y=a.value):typeof a.get=="function"&&(R="get",y=a.get),!y)throw new Error("not supported");a[R]=A(y,p)}}function S(A,T,p){let a=null,R=null;if(typeof p.value=="function"?(a="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(a="get",R=p.get),!R)throw new Error("not supported");const y=`$memoize$${T}`;p[a]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[y]}}function k(A,T,p){return b((a,R)=>{const y=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=p?p():void 0),clearTimeout(this[y]),T&&(this[u]=T(this[u],...E),E=[this[u]]),this[y]=setTimeout(()=>{a.apply(this,E),this[u]=p?p():void 0},A)}})}function O(A,T,p){return b((a,R)=>{const y=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...n){if(this[u]||(this[u]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...n)),this[f])return;const s=this[E]+A;s<=Date.now()?(this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0},s-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(oe,e,b,S){S===void 0&&(S=b);var k=Object.getOwnPropertyDescriptor(e,b);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[b]}}),Object.defineProperty(oe,S,k)}:function(oe,e,b,S){S===void 0&&(S=b),oe[S]=e[b]}),Wn=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),qe=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var b in oe)b!=="default"&&Object.prototype.hasOwnProperty.call(oe,b)&&Bn(e,oe,b);return Wn(e,oe),e};define(Ce[135],Ie([1,0,18]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0,e.$9c=k,e.$0c=O,e.$$c=A,e.$_c=T,e.$ad=p,e.$bd=a,b=qe(b);const S=(E,f)=>E===f;e.$8c=S;function k(E=e.$8c){return(f,n)=>b.$wb(f,n,E)}function O(){return(E,f)=>JSON.stringify(E)===JSON.stringify(f)}function A(){return(E,f)=>E.equals(f)}function T(E,f,n){if(n!==void 0){const s=E;return s==null||f===void 0||f===null?f===s:n(s,f)}else{const s=E;return(o,h)=>o==null||h===void 0||h===null?h===o:s(o,h)}}function p(E,f){if(E===f)return!0;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let n=0;n<E.length;n++)if(!p(E[n],f[n]))return!1;return!0}if(E&&typeof E=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const n=E,s=f,o=Object.keys(n),h=Object.keys(s),i=new Set(h);if(o.length!==h.length)return!1;for(const r of o)if(!i.has(r)||!p(n[r],s[r]))return!1;return!0}return!1}function a(E){return JSON.stringify(u(E))}let R=0;const y=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const f=E,n=Object.create(null);for(const s of Object.keys(f).sort())n[s]=u(f[s]);return n}else{let f=y.get(E);return f===void 0&&(f=R++,y.set(E,f)),f+"----2b76a038c20c4bcc"}return E}}),define(Ce[97],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0;class b{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.$6P=b,e.$7P=new b("id#")}),define(Ce[136],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=A,e.$Wn=y,e.$Xn=u,e.$Yn=E,e.$Zn=f,e.$1n=n,e.$2n=s,e.$3n=o,e.$4n=h,e.$5n=i,e.$6n=r;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b||(e.ScanError=b={}));var S;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(S||(e.SyntaxKind=S={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,c=!1){let l=0;const m=t.length;let d="",$=0,I=S.Unknown,D=b.None;function v(L){let G=0,B=0;for(;G<L;){const F=t.charCodeAt(l);if(F>=R._0&&F<=R._9)B=B*16+F-R._0;else if(F>=R.A&&F<=R.F)B=B*16+F-R.A+10;else if(F>=R.a&&F<=R.f)B=B*16+F-R.a+10;else break;l++,G++}return G<L&&(B=-1),B}function C(L){l=L,d="",$=0,I=S.Unknown,D=b.None}function P(){const L=l;if(t.charCodeAt(l)===R._0)l++;else for(l++;l<t.length&&a(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===R.dot)if(l++,l<t.length&&a(t.charCodeAt(l)))for(l++;l<t.length&&a(t.charCodeAt(l));)l++;else return D=b.UnexpectedEndOfNumber,t.substring(L,l);let G=l;if(l<t.length&&(t.charCodeAt(l)===R.E||t.charCodeAt(l)===R.e))if(l++,(l<t.length&&t.charCodeAt(l)===R.plus||t.charCodeAt(l)===R.minus)&&l++,l<t.length&&a(t.charCodeAt(l))){for(l++;l<t.length&&a(t.charCodeAt(l));)l++;G=l}else D=b.UnexpectedEndOfNumber;return t.substring(L,G)}function g(){let L="",G=l;for(;;){if(l>=m){L+=t.substring(G,l),D=b.UnexpectedEndOfString;break}const B=t.charCodeAt(l);if(B===R.doubleQuote){L+=t.substring(G,l),l++;break}if(B===R.backslash){if(L+=t.substring(G,l),l++,l>=m){D=b.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case R.doubleQuote:L+='"';break;case R.backslash:L+="\\";break;case R.slash:L+="/";break;case R.b:L+="\b";break;case R.f:L+="\f";break;case R.n:L+=`
`;break;case R.r:L+="\r";break;case R.t:L+="	";break;case R.u:{const V=v(4);V>=0?L+=String.fromCharCode(V):D=b.InvalidUnicode;break}default:D=b.InvalidEscapeCharacter}G=l;continue}if(B>=0&&B<=31)if(p(B)){L+=t.substring(G,l),D=b.UnexpectedEndOfString;break}else D=b.InvalidCharacter;l++}return L}function w(){if(d="",D=b.None,$=l,l>=m)return $=m,I=S.EOF;let L=t.charCodeAt(l);if(T(L)){do l++,d+=String.fromCharCode(L),L=t.charCodeAt(l);while(T(L));return I=S.Trivia}if(p(L))return l++,d+=String.fromCharCode(L),L===R.carriageReturn&&t.charCodeAt(l)===R.lineFeed&&(l++,d+=`
`),I=S.LineBreakTrivia;switch(L){case R.openBrace:return l++,I=S.OpenBraceToken;case R.closeBrace:return l++,I=S.CloseBraceToken;case R.openBracket:return l++,I=S.OpenBracketToken;case R.closeBracket:return l++,I=S.CloseBracketToken;case R.colon:return l++,I=S.ColonToken;case R.comma:return l++,I=S.CommaToken;case R.doubleQuote:return l++,d=g(),I=S.StringLiteral;case R.slash:{const G=l-1;if(t.charCodeAt(l+1)===R.slash){for(l+=2;l<m&&!p(t.charCodeAt(l));)l++;return d=t.substring(G,l),I=S.LineCommentTrivia}if(t.charCodeAt(l+1)===R.asterisk){l+=2;const B=m-1;let F=!1;for(;l<B;){if(t.charCodeAt(l)===R.asterisk&&t.charCodeAt(l+1)===R.slash){l+=2,F=!0;break}l++}return F||(l++,D=b.UnexpectedEndOfComment),d=t.substring(G,l),I=S.BlockCommentTrivia}return d+=String.fromCharCode(L),l++,I=S.Unknown}case R.minus:if(d+=String.fromCharCode(L),l++,l===m||!a(t.charCodeAt(l)))return I=S.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return d+=P(),I=S.NumericLiteral;default:for(;l<m&&M(L);)l++,L=t.charCodeAt(l);if($!==l){switch(d=t.substring($,l),d){case"true":return I=S.TrueKeyword;case"false":return I=S.FalseKeyword;case"null":return I=S.NullKeyword}return I=S.Unknown}return d+=String.fromCharCode(L),l++,I=S.Unknown}}function M(L){if(T(L)||p(L))return!1;switch(L){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function N(){let L;do L=w();while(L>=S.LineCommentTrivia&&L<=S.Trivia);return L}return{setPosition:C,getPosition:()=>l,scan:c?N:w,getToken:()=>I,getTokenValue:()=>d,getTokenOffset:()=>$,getTokenLength:()=>l-$,getTokenError:()=>D}}function T(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function p(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function a(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function y(t,c){const l=[],m=new Object;let d;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function D(v,C,P,g){$.value=v,$.offset=C,$.length=P,$.type=g,$.colonOffset=void 0,d=$}try{i(t,{onObjectBegin:(v,C)=>{if(c<=v)throw m;d=void 0,I=c>v,l.push("")},onObjectProperty:(v,C,P)=>{if(c<C||(D(v,C,P,"property"),l[l.length-1]=v,c<=C+P))throw m},onObjectEnd:(v,C)=>{if(c<=v)throw m;d=void 0,l.pop()},onArrayBegin:(v,C)=>{if(c<=v)throw m;d=void 0,l.push(0)},onArrayEnd:(v,C)=>{if(c<=v)throw m;d=void 0,l.pop()},onLiteralValue:(v,C,P)=>{if(c<C||(D(v,C,P,r(v)),c<=C+P))throw m},onSeparator:(v,C,P)=>{if(c<=C)throw m;if(v===":"&&d&&d.type==="property")d.colonOffset=C,I=!1,d=void 0;else if(v===","){const g=l[l.length-1];typeof g=="number"?l[l.length-1]=g+1:(I=!0,l[l.length-1]=""),d=void 0}}})}catch(v){if(v!==m)throw v}return{path:l,previousNode:d,isAtPropertyKey:I,matches:v=>{let C=0;for(let P=0;C<v.length&&P<l.length;P++)if(v[C]===l[P]||v[C]==="*")C++;else if(v[C]!=="**")return!1;return C===v.length}}}function u(t,c=[],l=O.DEFAULT){let m=null,d=[];const $=[];function I(v){Array.isArray(d)?d.push(v):m!==null&&(d[m]=v)}return i(t,{onObjectBegin:()=>{const v={};I(v),$.push(d),d=v,m=null},onObjectProperty:v=>{m=v},onObjectEnd:()=>{d=$.pop()},onArrayBegin:()=>{const v=[];I(v),$.push(d),d=v,m=null},onArrayEnd:()=>{d=$.pop()},onLiteralValue:I,onError:(v,C,P)=>{c.push({error:v,offset:C,length:P})}},l),d[0]}function E(t,c=[],l=O.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(v){m.type==="property"&&(m.length=v-m.offset,m=m.parent)}function $(v){return m.children.push(v),v}i(t,{onObjectBegin:v=>{m=$({type:"object",offset:v,length:-1,parent:m,children:[]})},onObjectProperty:(v,C,P)=>{m=$({type:"property",offset:C,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:v,offset:C,length:P,parent:m})},onObjectEnd:(v,C)=>{m.length=v+C-m.offset,m=m.parent,d(v+C)},onArrayBegin:(v,C)=>{m=$({type:"array",offset:v,length:-1,parent:m,children:[]})},onArrayEnd:(v,C)=>{m.length=v+C-m.offset,m=m.parent,d(v+C)},onLiteralValue:(v,C,P)=>{$({type:r(v),offset:C,length:P,parent:m,value:v}),d(C+P)},onSeparator:(v,C,P)=>{m.type==="property"&&(v===":"?m.colonOffset=C:v===","&&d(C))},onError:(v,C,P)=>{c.push({error:v,offset:C,length:P})}},l);const D=m.children[0];return D&&delete D.parent,D}function f(t,c){if(!t)return;let l=t;for(const m of c)if(typeof m=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let d=!1;for(const $ of l.children)if(Array.isArray($.children)&&$.children[0].value===m){l=$.children[1],d=!0;break}if(!d)return}else{const d=m;if(l.type!=="array"||d<0||!Array.isArray(l.children)||d>=l.children.length)return;l=l.children[d]}return l}function n(t){if(!t.parent||!t.parent.children)return[];const c=n(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;c.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&c.push(l)}return c}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const c=Object.create(null);for(const l of t.children){const m=l.children[1];m&&(c[l.children[0].value]=s(m))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,c,l=!1){return c>=t.offset&&c<t.offset+t.length||l&&c===t.offset+t.length}function h(t,c,l=!1){if(o(t,c,l)){const m=t.children;if(Array.isArray(m))for(let d=0;d<m.length&&m[d].offset<=c;d++){const $=h(m[d],c,l);if($)return $}return t}}function i(t,c,l=O.DEFAULT){const m=A(t,!1);function d(ce){return ce?()=>ce(m.getTokenOffset(),m.getTokenLength()):()=>!0}function $(ce){return ce?we=>ce(we,m.getTokenOffset(),m.getTokenLength()):()=>!0}const I=d(c.onObjectBegin),D=$(c.onObjectProperty),v=d(c.onObjectEnd),C=d(c.onArrayBegin),P=d(c.onArrayEnd),g=$(c.onLiteralValue),w=$(c.onSeparator),M=d(c.onComment),N=$(c.onError),L=l&&l.disallowComments,G=l&&l.allowTrailingComma;function B(){for(;;){const ce=m.scan();switch(m.getTokenError()){case b.InvalidUnicode:F(k.InvalidUnicode);break;case b.InvalidEscapeCharacter:F(k.InvalidEscapeCharacter);break;case b.UnexpectedEndOfNumber:F(k.UnexpectedEndOfNumber);break;case b.UnexpectedEndOfComment:L||F(k.UnexpectedEndOfComment);break;case b.UnexpectedEndOfString:F(k.UnexpectedEndOfString);break;case b.InvalidCharacter:F(k.InvalidCharacter);break}switch(ce){case S.LineCommentTrivia:case S.BlockCommentTrivia:L?F(k.InvalidCommentToken):M();break;case S.Unknown:F(k.InvalidSymbol);break;case S.Trivia:case S.LineBreakTrivia:break;default:return ce}}}function F(ce,we=[],re=[]){if(N(ce),we.length+re.length>0){let Pe=m.getToken();for(;Pe!==S.EOF;){if(we.indexOf(Pe)!==-1){B();break}else if(re.indexOf(Pe)!==-1)break;Pe=B()}}}function V(ce){const we=m.getTokenValue();return ce?g(we):D(we),B(),!0}function ae(){switch(m.getToken()){case S.NumericLiteral:{let ce=0;try{ce=JSON.parse(m.getTokenValue()),typeof ce!="number"&&(F(k.InvalidNumberFormat),ce=0)}catch{F(k.InvalidNumberFormat)}g(ce);break}case S.NullKeyword:g(null);break;case S.TrueKeyword:g(!0);break;case S.FalseKeyword:g(!1);break;default:return!1}return B(),!0}function $e(){return m.getToken()!==S.StringLiteral?(F(k.PropertyNameExpected,[],[S.CloseBraceToken,S.CommaToken]),!1):(V(!1),m.getToken()===S.ColonToken?(w(":"),B(),se()||F(k.ValueExpected,[],[S.CloseBraceToken,S.CommaToken])):F(k.ColonExpected,[],[S.CloseBraceToken,S.CommaToken]),!0)}function _(){I(),B();let ce=!1;for(;m.getToken()!==S.CloseBraceToken&&m.getToken()!==S.EOF;){if(m.getToken()===S.CommaToken){if(ce||F(k.ValueExpected,[],[]),w(","),B(),m.getToken()===S.CloseBraceToken&&G)break}else ce&&F(k.CommaExpected,[],[]);$e()||F(k.ValueExpected,[],[S.CloseBraceToken,S.CommaToken]),ce=!0}return v(),m.getToken()!==S.CloseBraceToken?F(k.CloseBraceExpected,[S.CloseBraceToken],[]):B(),!0}function ge(){C(),B();let ce=!1;for(;m.getToken()!==S.CloseBracketToken&&m.getToken()!==S.EOF;){if(m.getToken()===S.CommaToken){if(ce||F(k.ValueExpected,[],[]),w(","),B(),m.getToken()===S.CloseBracketToken&&G)break}else ce&&F(k.CommaExpected,[],[]);se()||F(k.ValueExpected,[],[S.CloseBracketToken,S.CommaToken]),ce=!0}return P(),m.getToken()!==S.CloseBracketToken?F(k.CloseBracketExpected,[S.CloseBracketToken],[]):B(),!0}function se(){switch(m.getToken()){case S.OpenBracketToken:return ge();case S.OpenBraceToken:return _();case S.StringLiteral:return V(!0);default:return ae()}}return B(),m.getToken()===S.EOF?l.allowEmptyContent?!0:(F(k.ValueExpected,[],[]),!1):se()?(m.getToken()!==S.EOF&&F(k.EndOfFileExpected,[],[]),!0):(F(k.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(oe,e){typeof define=="function"&&define.amd?define(Ce[137],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(ue,be){for(var de=0;de<be.length;de++){var X=be[de];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ue,X.key,X)}}function b(ue,be,de){return be&&e(ue.prototype,be),de&&e(ue,de),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function S(ue,be){if(ue){if(typeof ue=="string")return k(ue,be);var de=Object.prototype.toString.call(ue).slice(8,-1);if(de==="Object"&&ue.constructor&&(de=ue.constructor.name),de==="Map"||de==="Set")return Array.from(ue);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return k(ue,be)}}function k(ue,be){(be==null||be>ue.length)&&(be=ue.length);for(var de=0,X=new Array(be);de<be;de++)X[de]=ue[de];return X}function O(ue,be){var de=typeof Symbol<"u"&&ue[Symbol.iterator]||ue["@@iterator"];if(de)return(de=de.call(ue)).next.bind(de);if(Array.isArray(ue)||(de=S(ue))||be&&ue&&typeof ue.length=="number"){de&&(ue=de);var X=0;return function(){return X>=ue.length?{done:!0}:{done:!1,value:ue[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=A();function T(ue){oe.defaults=ue}var p=/[&<>"']/,a=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(be){return u[be]};function f(ue,be){if(be){if(p.test(ue))return ue.replace(a,E)}else if(R.test(ue))return ue.replace(y,E);return ue}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ue){return ue.replace(n,function(be,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var o=/(^|[^\[])\^/g;function h(ue,be){ue=typeof ue=="string"?ue:ue.source,be=be||"";var de={replace:function(Z,me){return me=me.source||me,me=me.replace(o,"$1"),ue=ue.replace(Z,me),de},getRegex:function(){return new RegExp(ue,be)}};return de}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ue,be,de){if(ue){var X;try{X=decodeURIComponent(s(de)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}be&&!r.test(de)&&(de=$(be,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var c={},l=/^[^:]+:\/*[^/]*$/,m=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ue,be){c[" "+ue]||(l.test(ue)?c[" "+ue]=ue+"/":c[" "+ue]=C(ue,"/",!0)),ue=c[" "+ue];var de=ue.indexOf(":")===-1;return be.substring(0,2)==="//"?de?be:ue.replace(m,"$1")+be:be.charAt(0)==="/"?de?be:ue.replace(d,"$1")+be:ue+be}var I={exec:function(){}};function D(ue){for(var be=1,de,X;be<arguments.length;be++){de=arguments[be];for(X in de)Object.prototype.hasOwnProperty.call(de,X)&&(ue[X]=de[X])}return ue}function v(ue,be){var de=ue.replace(/\|/g,function(me,pe,Oe){for(var ze=!1,ke=pe;--ke>=0&&Oe[ke]==="\\";)ze=!ze;return ze?"|":" |"}),X=de.split(/ \|/),Z=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>be)X.splice(be);else for(;X.length<be;)X.push("");for(;Z<X.length;Z++)X[Z]=X[Z].trim().replace(/\\\|/g,"|");return X}function C(ue,be,de){var X=ue.length;if(X===0)return"";for(var Z=0;Z<X;){var me=ue.charAt(X-Z-1);if(me===be&&!de)Z++;else if(me!==be&&de)Z++;else break}return ue.slice(0,X-Z)}function P(ue,be){if(ue.indexOf(be[1])===-1)return-1;for(var de=ue.length,X=0,Z=0;Z<de;Z++)if(ue[Z]==="\\")Z++;else if(ue[Z]===be[0])X++;else if(ue[Z]===be[1]&&(X--,X<0))return Z;return-1}function g(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(ue,be){if(be<1)return"";for(var de="";be>1;)be&1&&(de+=ue),be>>=1,ue+=ue;return de+ue}function M(ue,be,de,X){var Z=be.href,me=be.title?f(be.title):null,pe=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){X.state.inLink=!0;var Oe={type:"link",raw:de,href:Z,title:me,text:pe,tokens:X.inlineTokens(pe)};return X.state.inLink=!1,Oe}return{type:"image",raw:de,href:Z,title:me,text:f(pe)}}function N(ue,be){var de=ue.match(/^(\s+)(?:```)/);if(de===null)return be;var X=de[1];return be.split(`
`).map(function(Z){var me=Z.match(/^\s+/);if(me===null)return Z;var pe=me[0];return pe.length>=X.length?Z.slice(X.length):Z}).join(`
`)}var L=function(){function ue(de){this.options=de||oe.defaults}var be=ue.prototype;return be.space=function(X){var Z=this.rules.block.newline.exec(X);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},be.code=function(X){var Z=this.rules.block.code.exec(X);if(Z){var me=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?me:C(me,`
`)}}},be.fences=function(X){var Z=this.rules.block.fences.exec(X);if(Z){var me=Z[0],pe=N(me,Z[3]||"");return{type:"code",raw:me,lang:Z[2]?Z[2].trim():Z[2],text:pe}}},be.heading=function(X){var Z=this.rules.block.heading.exec(X);if(Z){var me=Z[2].trim();if(/#$/.test(me)){var pe=C(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:me,tokens:this.lexer.inline(me)}}},be.hr=function(X){var Z=this.rules.block.hr.exec(X);if(Z)return{type:"hr",raw:Z[0]}},be.blockquote=function(X){var Z=this.rules.block.blockquote.exec(X);if(Z){var me=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},be.list=function(X){var Z=this.rules.block.list.exec(X);if(Z){var me,pe,Oe,ze,ke,Ae,Ne,j,U,K,H,ie,fe=Z[1].trim(),Re=fe.length>1,Ue={type:"list",raw:"",ordered:Re,start:Re?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Re?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Re?fe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ie=!1,!(!(Z=Ke.exec(X))||this.rules.block.hr.test(X)));){if(me=Z[0],X=X.substring(me.length),j=Z[2].split(`
`,1)[0],U=X.split(`
`,1)[0],this.options.pedantic?(ze=2,H=j.trimLeft()):(ze=Z[2].search(/[^ ]/),ze=ze>4?1:ze,H=j.slice(ze),ze+=Z[1].length),Ae=!1,!j&&/^ *$/.test(U)&&(me+=U+`
`,X=X.substring(U.length+1),ie=!0),!ie)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(K=X.split(`
`,1)[0],j=K,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(j)||et.test(j)||_e.test(j)||tt.test(X)));){if(j.search(/[^ ]/)>=ze||!j.trim())H+=`
`+j.slice(ze);else if(!Ae)H+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),me+=K+`
`,X=X.substring(K.length+1)}Ue.loose||(Ne?Ue.loose=!0:/\n *\n *$/.test(me)&&(Ne=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(H),pe&&(Oe=pe[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:me,task:!!pe,checked:Oe,loose:!1,text:H}),Ue.raw+=me}Ue.items[Ue.items.length-1].raw=me.trimRight(),Ue.items[Ue.items.length-1].text=H.trimRight(),Ue.raw=Ue.raw.trimRight();var rt=Ue.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,Ue.items[ke].tokens=this.lexer.blockTokens(Ue.items[ke].text,[]);var ft=Ue.items[ke].tokens.filter(function(st){return st.type==="space"}),ct=ft.every(function(st){for(var ut=st.raw.split(""),gt=0,pt=O(ut),Be;!(Be=pt()).done;){var je=Be.value;if(je===`
`&&(gt+=1),gt>1)return!0}return!1});!Ue.loose&&ft.length&&ct&&(Ue.loose=!0,Ue.items[ke].loose=!0)}return Ue}},be.html=function(X){var Z=this.rules.block.html.exec(X);if(Z){var me={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(Z[0]):f(Z[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},be.def=function(X){var Z=this.rules.block.def.exec(X);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var me=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:Z[0],href:Z[2],title:Z[3]}}},be.table=function(X){var Z=this.rules.block.table.exec(X);if(Z){var me={type:"table",header:v(Z[1]).map(function(Ne){return{text:Ne}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=Z[0];var pe=me.align.length,Oe,ze,ke,Ae;for(Oe=0;Oe<pe;Oe++)/^ *-+: *$/.test(me.align[Oe])?me.align[Oe]="right":/^ *:-+: *$/.test(me.align[Oe])?me.align[Oe]="center":/^ *:-+ *$/.test(me.align[Oe])?me.align[Oe]="left":me.align[Oe]=null;for(pe=me.rows.length,Oe=0;Oe<pe;Oe++)me.rows[Oe]=v(me.rows[Oe],me.header.length).map(function(Ne){return{text:Ne}});for(pe=me.header.length,ze=0;ze<pe;ze++)me.header[ze].tokens=this.lexer.inline(me.header[ze].text);for(pe=me.rows.length,ze=0;ze<pe;ze++)for(Ae=me.rows[ze],ke=0;ke<Ae.length;ke++)Ae[ke].tokens=this.lexer.inline(Ae[ke].text);return me}}},be.lheading=function(X){var Z=this.rules.block.lheading.exec(X);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},be.paragraph=function(X){var Z=this.rules.block.paragraph.exec(X);if(Z){var me=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:me,tokens:this.lexer.inline(me)}}},be.text=function(X){var Z=this.rules.block.text.exec(X);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},be.escape=function(X){var Z=this.rules.inline.escape.exec(X);if(Z)return{type:"escape",raw:Z[0],text:f(Z[1])}},be.tag=function(X){var Z=this.rules.inline.tag.exec(X);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):f(Z[0]):Z[0]}},be.link=function(X){var Z=this.rules.inline.link.exec(X);if(Z){var me=Z[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=C(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Oe=P(Z[2],"()");if(Oe>-1){var ze=Z[0].indexOf("!")===0?5:4,ke=ze+Z[1].length+Oe;Z[2]=Z[2].substring(0,Oe),Z[0]=Z[0].substring(0,ke).trim(),Z[3]=""}}var Ae=Z[2],Ne="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],Ne=j[3])}else Ne=Z[3]?Z[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(me)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),M(Z,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},be.reflink=function(X,Z){var me;if((me=this.rules.inline.reflink.exec(X))||(me=this.rules.inline.nolink.exec(X))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=Z[pe.toLowerCase()],!pe||!pe.href){var Oe=me[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return M(me,pe,me[0],this.lexer)}},be.emStrong=function(X,Z,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(X);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=pe[1]||pe[2]||"";if(!Oe||Oe&&(me===""||this.rules.inline.punctuation.exec(me))){var ze=pe[0].length-1,ke,Ae,Ne=ze,j=0,U=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,Z=Z.slice(-1*X.length+ze);(pe=U.exec(Z))!=null;)if(ke=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ke){if(Ae=ke.length,pe[3]||pe[4]){Ne+=Ae;continue}else if((pe[5]||pe[6])&&ze%3&&!((ze+Ae)%3)){j+=Ae;continue}if(Ne-=Ae,!(Ne>0)){if(Ae=Math.min(Ae,Ae+Ne+j),Math.min(ze,Ae)%2){var K=X.slice(1,ze+pe.index+Ae);return{type:"em",raw:X.slice(0,ze+pe.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=X.slice(2,ze+pe.index+Ae-1);return{type:"strong",raw:X.slice(0,ze+pe.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},be.codespan=function(X){var Z=this.rules.inline.code.exec(X);if(Z){var me=Z[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Oe=/^ /.test(me)&&/ $/.test(me);return pe&&Oe&&(me=me.substring(1,me.length-1)),me=f(me,!0),{type:"codespan",raw:Z[0],text:me}}},be.br=function(X){var Z=this.rules.inline.br.exec(X);if(Z)return{type:"br",raw:Z[0]}},be.del=function(X){var Z=this.rules.inline.del.exec(X);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},be.autolink=function(X,Z){var me=this.rules.inline.autolink.exec(X);if(me){var pe,Oe;return me[2]==="@"?(pe=f(this.options.mangle?Z(me[1]):me[1]),Oe="mailto:"+pe):(pe=f(me[1]),Oe=pe),{type:"link",raw:me[0],text:pe,href:Oe,tokens:[{type:"text",raw:pe,text:pe}]}}},be.url=function(X,Z){var me;if(me=this.rules.inline.url.exec(X)){var pe,Oe;if(me[2]==="@")pe=f(this.options.mangle?Z(me[0]):me[0]),Oe="mailto:"+pe;else{var ze;do ze=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ze!==me[0]);pe=f(me[0]),me[1]==="www."?Oe="http://"+pe:Oe=pe}return{type:"link",raw:me[0],text:pe,href:Oe,tokens:[{type:"text",raw:pe,text:pe}]}}},be.inlineText=function(X,Z){var me=this.rules.inline.text.exec(X);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):f(me[0]):me[0]:pe=f(this.options.smartypants?Z(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},ue}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=D({},G),G.gfm=D({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=D({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=h(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=h(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=h(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=h(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=h(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=h(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=h(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=h(B.reflink).replace("label",B._label).replace("ref",G._label).getRegex(),B.nolink=h(B.nolink).replace("ref",G._label).getRegex(),B.reflinkSearch=h(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=D({},B),B.pedantic=D({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=D({},B.normal,{escape:h(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=h(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=D({},B.gfm,{br:h(B.br).replace("{2,}","*").getRegex(),text:h(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ue){var be="",de,X,Z=ue.length;for(de=0;de<Z;de++)X=ue.charCodeAt(de),Math.random()>.5&&(X="x"+X.toString(16)),be+="&#"+X+";";return be}var ae=function(){function ue(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||oe.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:G.normal,inline:B.normal};this.options.pedantic?(X.block=G.pedantic,X.inline=B.pedantic):this.options.gfm&&(X.block=G.gfm,this.options.breaks?X.inline=B.breaks:X.inline=B.gfm),this.tokenizer.rules=X}ue.lex=function(X,Z){var me=new ue(Z);return me.lex(X)},ue.lexInline=function(X,Z){var me=new ue(Z);return me.inlineTokens(X)};var be=ue.prototype;return be.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},be.blockTokens=function(X,Z){var me=this;Z===void 0&&(Z=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Ne,j,U){return j+"    ".repeat(U.length)});for(var pe,Oe,ze,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(pe=Ne.call({lexer:me},X,Z))?(X=X.substring(pe.raw.length),Z.push(pe),!0):!1}))){if(pe=this.tokenizer.space(X)){X=X.substring(pe.raw.length),pe.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(pe);continue}if(pe=this.tokenizer.code(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Z.push(pe);continue}if(pe=this.tokenizer.fences(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.heading(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.hr(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.blockquote(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.list(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.html(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.def(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.lheading(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,j=X.slice(1),U=void 0;me.options.extensions.startBlock.forEach(function(K){U=K.call({lexer:this},j),typeof U=="number"&&U>=0&&(Ne=Math.min(Ne,U))}),Ne<1/0&&Ne>=0&&(ze=X.substring(0,Ne+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ze))){Oe=Z[Z.length-1],ke&&Oe.type==="paragraph"?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Z.push(pe),ke=ze.length!==X.length,X=X.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Z.push(pe);continue}if(X){var Ae="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Z},be.inline=function(X,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:X,tokens:Z}),Z},be.inlineTokens=function(X,Z){var me=this;Z===void 0&&(Z=[]);var pe,Oe,ze,ke=X,Ae,Ne,j;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)U.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Ne||(j=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(pe=H.call({lexer:me},X,Z))?(X=X.substring(pe.raw.length),Z.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.tag(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&pe.type==="text"&&Oe.type==="text"?(Oe.raw+=pe.raw,Oe.text+=pe.text):Z.push(pe);continue}if(pe=this.tokenizer.link(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&pe.type==="text"&&Oe.type==="text"?(Oe.raw+=pe.raw,Oe.text+=pe.text):Z.push(pe);continue}if(pe=this.tokenizer.emStrong(X,ke,j)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.codespan(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.br(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.del(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.autolink(X,V)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(X,V))){X=X.substring(pe.raw.length),Z.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ie=X.slice(1),fe=void 0;me.options.extensions.startInline.forEach(function(Re){fe=Re.call({lexer:this},ie),typeof fe=="number"&&fe>=0&&(H=Math.min(H,fe))}),H<1/0&&H>=0&&(ze=X.substring(0,H+1))}(),pe=this.tokenizer.inlineText(ze,F)){X=X.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(j=pe.raw.slice(-1)),Ne=!0,Oe=Z[Z.length-1],Oe&&Oe.type==="text"?(Oe.raw+=pe.raw,Oe.text+=pe.text):Z.push(pe);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Z},b(ue,null,[{key:"rules",get:function(){return{block:G,inline:B}}}]),ue}(),$e=function(){function ue(de){this.options=de||oe.defaults}var be=ue.prototype;return be.code=function(X,Z,me){var pe=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(X,pe);Oe!=null&&Oe!==X&&(me=!0,X=Oe)}return X=X.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+f(pe,!0)+'">'+(me?X:f(X,!0))+`</code></pre>
`:"<pre><code>"+(me?X:f(X,!0))+`</code></pre>
`},be.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},be.html=function(X){return X},be.heading=function(X,Z,me,pe){if(this.options.headerIds){var Oe=this.options.headerPrefix+pe.slug(me);return"<h"+Z+' id="'+Oe+'">'+X+"</h"+Z+`>
`}return"<h"+Z+">"+X+"</h"+Z+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(X,Z,me){var pe=Z?"ol":"ul",Oe=Z&&me!==1?' start="'+me+'"':"";return"<"+pe+Oe+`>
`+X+"</"+pe+`>
`},be.listitem=function(X){return"<li>"+X+`</li>
`},be.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(X){return"<p>"+X+`</p>
`},be.table=function(X,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+Z+`</table>
`},be.tablerow=function(X){return`<tr>
`+X+`</tr>
`},be.tablecell=function(X,Z){var me=Z.header?"th":"td",pe=Z.align?"<"+me+' align="'+Z.align+'">':"<"+me+">";return pe+X+("</"+me+`>
`)},be.strong=function(X){return"<strong>"+X+"</strong>"},be.em=function(X){return"<em>"+X+"</em>"},be.codespan=function(X){return"<code>"+X+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(X){return"<del>"+X+"</del>"},be.link=function(X,Z,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<a href="'+f(X)+'"';return Z&&(pe+=' title="'+Z+'"'),pe+=">"+me+"</a>",pe},be.image=function(X,Z,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<img src="'+X+'" alt="'+me+'"';return Z&&(pe+=' title="'+Z+'"'),pe+=this.options.xhtml?"/>":">",pe},be.text=function(X){return X},ue}(),_=function(){function ue(){}var be=ue.prototype;return be.strong=function(X){return X},be.em=function(X){return X},be.codespan=function(X){return X},be.del=function(X){return X},be.html=function(X){return X},be.text=function(X){return X},be.link=function(X,Z,me){return""+me},be.image=function(X,Z,me){return""+me},be.br=function(){return""},ue}(),ge=function(){function ue(){this.seen={}}var be=ue.prototype;return be.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(X,Z){var me=X,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[X];do pe++,me=X+"-"+pe;while(this.seen.hasOwnProperty(me))}return Z||(this.seen[X]=pe,this.seen[me]=0),me},be.slug=function(X,Z){Z===void 0&&(Z={});var me=this.serialize(X);return this.getNextSafeSlug(me,Z.dryrun)},ue}(),se=function(){function ue(de){this.options=de||oe.defaults,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new ge}ue.parse=function(X,Z){var me=new ue(Z);return me.parse(X)},ue.parseInline=function(X,Z){var me=new ue(Z);return me.parseInline(X)};var be=ue.prototype;return be.parse=function(X,Z){Z===void 0&&(Z=!0);var me="",pe,Oe,ze,ke,Ae,Ne,j,U,K,H,ie,fe,Re,Ue,Ke,_e,tt,nt,et,rt=X.length;for(pe=0;pe<rt;pe++){if(H=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(et=this.options.extensions.renderers[H.type].call({parser:this},H),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){me+=et||"";continue}switch(H.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(H.tokens),H.depth,s(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(U="",j="",ke=H.header.length,Oe=0;Oe<ke;Oe++)j+=this.renderer.tablecell(this.parseInline(H.header[Oe].tokens),{header:!0,align:H.align[Oe]});for(U+=this.renderer.tablerow(j),K="",ke=H.rows.length,Oe=0;Oe<ke;Oe++){for(Ne=H.rows[Oe],j="",Ae=Ne.length,ze=0;ze<Ae;ze++)j+=this.renderer.tablecell(this.parseInline(Ne[ze].tokens),{header:!1,align:H.align[ze]});K+=this.renderer.tablerow(j)}me+=this.renderer.table(U,K);continue}case"blockquote":{K=this.parse(H.tokens),me+=this.renderer.blockquote(K);continue}case"list":{for(ie=H.ordered,fe=H.start,Re=H.loose,ke=H.items.length,K="",Oe=0;Oe<ke;Oe++)Ke=H.items[Oe],_e=Ke.checked,tt=Ke.task,Ue="",Ke.task&&(nt=this.renderer.checkbox(_e),Re?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):Ue+=nt),Ue+=this.parse(Ke.tokens,Re),K+=this.renderer.listitem(Ue,tt,_e);me+=this.renderer.list(K,ie,fe);continue}case"html":{me+=this.renderer.html(H.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;pe+1<rt&&X[pe+1].type==="text";)H=X[++pe],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);me+=Z?this.renderer.paragraph(K):K;continue}default:{var ft='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return me},be.parseInline=function(X,Z){Z=Z||this.renderer;var me="",pe,Oe,ze,ke=X.length;for(pe=0;pe<ke;pe++){if(Oe=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(ze=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){me+=ze||"";continue}switch(Oe.type){case"escape":{me+=Z.text(Oe.text);break}case"html":{me+=Z.html(Oe.text);break}case"link":{me+=Z.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,Z));break}case"image":{me+=Z.image(Oe.href,Oe.title,Oe.text);break}case"strong":{me+=Z.strong(this.parseInline(Oe.tokens,Z));break}case"em":{me+=Z.em(this.parseInline(Oe.tokens,Z));break}case"codespan":{me+=Z.codespan(Oe.text);break}case"br":{me+=Z.br();break}case"del":{me+=Z.del(this.parseInline(Oe.tokens,Z));break}case"text":{me+=Z.text(Oe.text);break}default:{var Ae='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return me},ue}();function ce(ue,be,de){if(typeof ue>"u"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof be=="function"&&(de=be,be=null),be=D({},ce.defaults,be||{}),g(be),de){var X=be.highlight,Z;try{Z=ae.lex(ue,be)}catch(ke){return de(ke)}var me=function(Ae){var Ne;if(!Ae)try{be.walkTokens&&ce.walkTokens(Z,be.walkTokens),Ne=se.parse(Z,be)}catch(j){Ae=j}return be.highlight=X,Ae?de(Ae):de(null,Ne)};if(!X||X.length<3||(delete be.highlight,!Z.length))return me();var pe=0;ce.walkTokens(Z,function(ke){ke.type==="code"&&(pe++,setTimeout(function(){X(ke.text,ke.lang,function(Ae,Ne){if(Ae)return me(Ae);Ne!=null&&Ne!==ke.text&&(ke.text=Ne,ke.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Oe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(ke.message+"",!0)+"</pre>";throw ke}try{var ze=ae.lex(ue,be);if(be.walkTokens){if(be.async)return Promise.all(ce.walkTokens(ze,be.walkTokens)).then(function(){return se.parse(ze,be)}).catch(Oe);ce.walkTokens(ze,be.walkTokens)}return se.parse(ze,be)}catch(ke){Oe(ke)}}ce.options=ce.setOptions=function(ue){return D(ce.defaults,ue),T(ce.defaults),ce},ce.getDefaults=A,ce.defaults=oe.defaults,ce.use=function(){for(var ue=arguments.length,be=new Array(ue),de=0;de<ue;de++)be[de]=arguments[de];var X=D.apply(void 0,[{}].concat(be)),Z=ce.defaults.extensions||{renderers:{},childTokens:{}},me;be.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=Z.renderers?Z.renderers[ze.name]:null;ke?Z.renderers[ze.name]=function(){for(var Ae=arguments.length,Ne=new Array(Ae),j=0;j<Ae;j++)Ne[j]=arguments[j];var U=ze.renderer.apply(this,Ne);return U===!1&&(U=ke.apply(this,Ne)),U}:Z.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[ze.level]?Z[ze.level].unshift(ze.tokenizer):Z[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?Z.startBlock?Z.startBlock.push(ze.start):Z.startBlock=[ze.start]:ze.level==="inline"&&(Z.startInline?Z.startInline.push(ze.start):Z.startInline=[ze.start]))}ze.childTokens&&(Z.childTokens[ze.name]=ze.childTokens)})),pe.renderer&&function(){var ze=ce.defaults.renderer||new $e,ke=function(j){var U=ze[j];ze[j]=function(){for(var K=arguments.length,H=new Array(K),ie=0;ie<K;ie++)H[ie]=arguments[ie];var fe=pe.renderer[j].apply(ze,H);return fe===!1&&(fe=U.apply(ze,H)),fe}};for(var Ae in pe.renderer)ke(Ae);X.renderer=ze}(),pe.tokenizer&&function(){var ze=ce.defaults.tokenizer||new L,ke=function(j){var U=ze[j];ze[j]=function(){for(var K=arguments.length,H=new Array(K),ie=0;ie<K;ie++)H[ie]=arguments[ie];var fe=pe.tokenizer[j].apply(ze,H);return fe===!1&&(fe=U.apply(ze,H)),fe}};for(var Ae in pe.tokenizer)ke(Ae);X.tokenizer=ze}(),pe.walkTokens){var Oe=ce.defaults.walkTokens;X.walkTokens=function(ze){var ke=[];return ke.push(pe.walkTokens.call(this,ze)),Oe&&(ke=ke.concat(Oe.call(this,ze))),ke}}me&&(X.extensions=Z),ce.setOptions(X)})},ce.walkTokens=function(ue,be){for(var de=[],X=function(){var Oe=me.value;switch(de=de.concat(be.call(ce,Oe)),Oe.type){case"table":{for(var ze=O(Oe.header),ke;!(ke=ze()).done;){var Ae=ke.value;de=de.concat(ce.walkTokens(Ae.tokens,be))}for(var Ne=O(Oe.rows),j;!(j=Ne()).done;)for(var U=j.value,K=O(U),H;!(H=K()).done;){var ie=H.value;de=de.concat(ce.walkTokens(ie.tokens,be))}break}case"list":{de=de.concat(ce.walkTokens(Oe.items,be));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Oe.type]?ce.defaults.extensions.childTokens[Oe.type].forEach(function(fe){de=de.concat(ce.walkTokens(Oe[fe],be))}):Oe.tokens&&(de=de.concat(ce.walkTokens(Oe.tokens,be)))}},Z=O(ue),me;!(me=Z()).done;)X();return de},ce.parseInline=function(ue,be){if(typeof ue>"u"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");be=D({},ce.defaults,be||{}),g(be);try{var de=ae.lexInline(ue,be);return be.walkTokens&&ce.walkTokens(de,be.walkTokens),se.parseInline(de,be)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(X.message+"",!0)+"</pre>";throw X}},ce.Parser=se,ce.parser=se.parse,ce.Renderer=$e,ce.TextRenderer=_,ce.Lexer=ae,ce.lexer=ae.lex,ce.Tokenizer=L,ce.Slugger=ge,ce.parse=ce;var we=ce.options,re=ce.setOptions,Pe=ce.use,Me=ce.walkTokens,Y=ce.parseInline,q=ce,ee=se.parse,ve=ae.lex;oe.Lexer=ae,oe.Parser=se,oe.Renderer=$e,oe.Slugger=ge,oe.TextRenderer=_,oe.Tokenizer=L,oe.getDefaults=A,oe.lexer=ve,oe.marked=ce,oe.options=we,oe.parse=q,oe.parseInline=Y,oe.parser=ee,oe.setOptions=re,oe.use=Pe,oe.walkTokens=Me,Object.defineProperty(oe,"__esModule",{value:!0})}),define(Ce[138],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=b;function b(n){const s=O(n);if(s&&s.length>0)return new Uint32Array(s)}let S=0;const k=new Uint32Array(10);function O(n){if(S=0,A(n,y,p.InitialConsonant),S>0||(A(n,u,p.Vowel),S>0)||(A(n,E,p.FinalConsonant),S>0)||(A(n,f,p.CompatibilityJamo),S))return k.subarray(0,S);if(n>=44032&&n<=55203){const s=n-44032,o=s%588,h=Math.floor(s/588),i=Math.floor(o/28),r=o%28-1;if(h<y.length?A(h,y,0):p.InitialConsonant+h-p.CompatibilityJamo<f.length&&A(p.InitialConsonant+h,f,p.CompatibilityJamo),i<u.length?A(i,u,0):p.Vowel+i-p.CompatibilityJamo<f.length&&A(p.Vowel+i-p.CompatibilityJamo,f,p.CompatibilityJamo),r>=0&&(r<E.length?A(r,E,0):p.FinalConsonant+r-p.CompatibilityJamo<f.length&&A(p.FinalConsonant+r-p.CompatibilityJamo,f,p.CompatibilityJamo)),S>0)return k.subarray(0,S)}}function A(n,s,o){n>=o&&n<o+s.length&&T(s[n-o])}function T(n){n!==a.NUL&&(k[S++]=n&255,n>>8&&(k[S++]=n>>8&255),n>>16&&(k[S++]=n>>16&255))}var p;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var a;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(a||(a={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const y=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),u=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l]),E=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,R.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),f=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.E,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,a.Q,R.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l])}),define(Ce[139],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=b,e.rot=S,e.$Pm=T;function b(p,a,R){return Math.min(Math.max(p,a),R)}function S(p,a){return(a+p%a)%a}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=k;class O{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=O;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const R=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function T(p,a,R,y,u,E,f,n){const s=f-R,o=n-y,h=u-R,i=E-y,r=p-R,t=a-y,c=s*s+o*o,l=s*h+o*i,m=s*r+o*t,d=h*h+i*i,$=h*r+i*t,I=1/(c*d-l*l),D=(d*m-l*$)*I,v=(c*$-l*m)*I;return D>=0&&v>=0&&D+v<1}}),define(Ce[140],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$dd=O,e.$ed=u;class b{constructor(f,n,s){this.owner=f,this.debugNameSource=n,this.referenceFn=s}getDebugName(f){return O(f,this)}}e.$cd=b;const S=new Map,k=new WeakMap;function O(E,f){const n=k.get(E);if(n)return n;const s=A(E,f);if(s){let o=S.get(s)??0;o++,S.set(s,o);const h=o===1?s:`${s}#${o}`;return k.set(E,h),h}}function A(E,f){const n=k.get(E);if(n)return n;const s=f.owner?R(f.owner)+".":"";let o;const h=f.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(o=h(),o!==void 0)return s+o}else return s+h;const i=f.referenceFn;if(i!==void 0&&(o=u(i),o!==void 0))return s+o;if(f.owner!==void 0){const r=T(f.owner,E);if(r!==void 0)return s+r}}function T(E,f){for(const n in E)if(E[n]===f)return n}const p=new Map,a=new WeakMap;function R(E){const f=a.get(E);if(f)return f;const n=y(E);let s=p.get(n)??0;s++,p.set(n,s);const o=s===1?n:`${n}#${s}`;return a.set(E,o),o}function y(E){const f=E.constructor;return f?f.name:"Object"}function u(E){const f=E.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(s?s[1]:void 0)?.trim()}}),define(Ce[141],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=S,e.$Md=k;let b;function S(n){b=n}function k(){return b}class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([T(E("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[T(" "),a(R(s.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),a(R(s.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),a(R(s.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([p("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleDerivedRecomputed(s,o){const h=this.d.get(s);console.log(...this.b([p("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(h),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([p("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([p("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([p("transaction"),a(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=O;function A(n){const s=new Array,o=[];let h="";function i(t){if("length"in t)for(const c of t)c&&i(c);else"text"in t?(h+=`%c${t.text}`,s.push(t.style),t.data&&o.push(...t.data)):"data"in t&&o.push(...t.data)}i(n);const r=[h,...s];return r.push(...o),r}function T(n){return a(n,{color:"black"})}function p(n){return a(f(`${n}: `,10),{color:"black",bold:!0})}function a(n,s={color:"black"}){function o(i){return Object.entries(i).reduce((r,[t,c])=>`${r}${t}:${c};`,"")}const h={color:s.color};return s.strikeThrough&&(h["text-decoration"]="line-through"),s.bold&&(h["font-weight"]="bold"),{text:n,style:o(h)}}function R(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,s):u(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,s){let o="[ ",h=!0;for(const i of n){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${R(i,s-o.length)}`}return o+=" ]",o}function u(n,s){let o="{ ",h=!0;for(const[i,r]of Object.entries(n)){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${i}: ${R(r,s-o.length)}`}return o+=" }",o}function E(n,s){let o="";for(let h=1;h<=s;h++)o+=n;return o}function f(n,s){for(;n.length<s;)n+=" ";return n}}),define(Ce[142],Ie([1,0,135,140,141]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=A,e.$Xd=p,e.$Yd=R,e.$2d=E,e.$3d=n,e.$4d=s,e.$5d=o,e.$7d=i,e.$9d=t;let O;function A(l){O=l}let T;function p(l){T=l}let a;function R(l){a=l}class y{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,d){const $=d===void 0?void 0:m,I=d===void 0?m:d;return a({owner:$,debugName:()=>{const D=(0,S.$ed)(I);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(I.toString());if(C)return`${this.debugName}.${C[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:I},D=>I(this.read(D),D))}recomputeInitiallyAndOnChange(m,d){return m.add(O(this,d)),this}keepObserved(m){return m.add(T(this)),this}get a(){return this.get()}}e.$Zd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(m){const d=this.b.size;this.b.add(m),d===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function E(l,m){const d=new h(l,m);try{l(d)}finally{d.finish()}}let f;function n(l){if(f)l(f);else{const m=new h(l,void 0);f=m;try{l(m)}finally{m.finish(),f=void 0}}}async function s(l,m){const d=new h(l,m);try{await l(d)}finally{d.finish()}}function o(l,m,d){l?m(l):E(m,d)}class h{constructor(m,d){this._fn=m,this.b=d,this.a=[],(0,k.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,S.$ed)(this._fn)}updateObserver(m,d){this.a.push({observer:m,observable:d}),m.beginUpdate(d)}finish(){const m=this.a;for(let d=0;d<m.length;d++){const{observer:$,observable:I}=m[d];$.endUpdate(I)}this.a=null,(0,k.$Md)()?.handleEndTransaction()}}e.$6d=h;function i(l,m){let d;return typeof l=="string"?d=new S.$cd(void 0,l,void 0):d=new S.$cd(l,void 0,void 0),new r(d,m,b.$8c)}class r extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,d,$){super(),this.e=m,this.g=$,this.d=d}get(){return this.d}set(m,d,$){if($===void 0&&this.g(this.d,m))return;let I;d||(d=I=new h(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(m),(0,k.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:m,change:$,didChange:!0,hadValue:!0});for(const v of this.b)d.updateObserver(v,this),v.handleChange(this,$)}finally{I&&I.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$8d=r;function t(l,m){let d;return typeof l=="string"?d=new S.$cd(void 0,l,void 0):d=new S.$cd(l,void 0,void 0),new c(d,m,b.$8c)}class c extends r{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$0d=c}),function(){function oe(k){const O=[];typeof k=="number"&&O.push("code/timeOrigin",k);function A(p){O.push(p,Date.now())}function T(){const p=[];for(let a=0;a<O.length;a+=2)p.push({name:O[a],startTime:O[a+1]});return p}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(k+A.startTime)});return O}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function b(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=b(S))}(),define(Ce[143],Ie([1,0,40]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0;const S=Symbol("unset");class k{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||b.Iterable.empty()}insert(p,a,R){this.d(p,y=>y._value=a,R)}mutate(p,a){this.d(p,R=>R._value=a(R._value===S?void 0:R._value))}mutatePath(p,a){this.d(p,()=>{},R=>a(R))}delete(p){const a=this.c(p);if(!a)return;let R=a.length-1;const y=a[R].node._value;if(y!==S){for(this.b--,a[R].node._value=S;R>0;R--){const{node:u,part:E}=a[R];if(u.children?.size||u._value!==S)break;a[R-1].node.children.delete(E)}return y}}*deleteRecursive(p){const a=this.c(p);if(!a)return;const R=a[a.length-1].node;for(let y=a.length-1;y>0;y--){const u=a[y-1];if(u.node.children.delete(a[y].part),u.node.children.size>0||u.node._value!==S)break}for(const y of O(R))y._value!==S&&(this.b--,yield y._value)}find(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return;a=y}return a._value===S?void 0:a._value}hasKeyOrParent(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;if(y._value!==S)return!0;a=y}return!1}hasKeyOrChildren(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;a=y}return!0}hasKey(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;a=y}return a._value!==S}c(p){const a=[{part:"",node:this.a}];let R=0;for(const y of p){const u=a[R].node.children?.get(y);if(!u)return;a.push({part:y,node:u}),R++}return a}d(p,a,R){let y=this.a;for(const f of p){if(y.children)if(y.children.has(f))y=y.children.get(f);else{const n=new A;y.children.set(f,n),y=n}else{const n=new A;y.children=new Map([[f,n]]),y=n}R?.(y)}const u=y._value===S?0:1;a(y);const E=y._value===S?0:1;this.b+=E-u}*values(){for(const{_value:p}of O(this.a))p!==S&&(yield p)}}e.$SI=k;function*O(T){const p=[T];for(;p.length>0;){const a=p.pop();if(yield a,a.children)for(const R of a.children.values())p.push(R)}}class A{constructor(){this._value=S}get value(){return this._value===S?void 0:this._value}set value(p){this._value=p===void 0?S:p}}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var b=e();for(var S in b)(typeof exports=="object"?exports:oe)[S]=b[S]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function b(S){if(e[S])return e[S].exports;var k=e[S]={i:S,l:!1,exports:{}};return oe[S].call(k.exports,k,k.exports,b),k.l=!0,k.exports}return b.m=oe,b.c=e,b.d=function(S,k,O){b.o(S,k)||Object.defineProperty(S,k,{enumerable:!0,get:O})},b.r=function(S){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},b.t=function(S,k){if(1&k&&(S=b(S)),8&k||4&k&&typeof S=="object"&&S&&S.__esModule)return S;var O=Object.create(null);if(b.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:S}),2&k&&typeof S!="string")for(var A in S)b.d(O,A,function(T){return S[T]}.bind(null,A));return O},b.n=function(S){var k=S&&S.__esModule?function(){return S.default}:function(){return S};return b.d(k,"a",k),k},b.o=function(S,k){return Object.prototype.hasOwnProperty.call(S,k)},b.p="",b(b.s=0)}([function(oe,e,b){(function(S){var k;e=oe.exports=Pe,k=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],a=0,R=a++;p[R]="0|[1-9]\\d*";var y=a++;p[y]="[0-9]+";var u=a++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=a++;p[E]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var f=a++;p[f]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var n=a++;p[n]="(?:"+p[R]+"|"+p[u]+")";var s=a++;p[s]="(?:"+p[y]+"|"+p[u]+")";var o=a++;p[o]="(?:-("+p[n]+"(?:\\."+p[n]+")*))";var h=a++;p[h]="(?:-?("+p[s]+"(?:\\."+p[s]+")*))";var i=a++;p[i]="[0-9A-Za-z-]+";var r=a++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=a++,c="v?"+p[E]+p[o]+"?"+p[r]+"?";p[t]="^"+c+"$";var l="[v=\\s]*"+p[f]+p[h]+"?"+p[r]+"?",m=a++;p[m]="^"+l+"$";var d=a++;p[d]="((?:<|>)?=?)";var $=a++;p[$]=p[y]+"|x|X|\\*";var I=a++;p[I]=p[R]+"|x|X|\\*";var D=a++;p[D]="[v=\\s]*("+p[I]+")(?:\\.("+p[I]+")(?:\\.("+p[I]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var v=a++;p[v]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[r]+"?)?)?";var C=a++;p[C]="^"+p[d]+"\\s*"+p[D]+"$";var P=a++;p[P]="^"+p[d]+"\\s*"+p[v]+"$";var g=a++;p[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=a++;p[w]="(?:~>?)";var M=a++;p[M]="(\\s*)"+p[w]+"\\s+",T[M]=new RegExp(p[M],"g");var N=a++;p[N]="^"+p[w]+p[D]+"$";var L=a++;p[L]="^"+p[w]+p[v]+"$";var G=a++;p[G]="(?:\\^)";var B=a++;p[B]="(\\s*)"+p[G]+"\\s+",T[B]=new RegExp(p[B],"g");var F=a++;p[F]="^"+p[G]+p[D]+"$";var V=a++;p[V]="^"+p[G]+p[v]+"$";var ae=a++;p[ae]="^"+p[d]+"\\s*("+l+")$|^$";var $e=a++;p[$e]="^"+p[d]+"\\s*("+c+")$|^$";var _=a++;p[_]="(\\s*)"+p[d]+"\\s*("+l+"|"+p[D]+")",T[_]=new RegExp(p[_],"g");var ge=a++;p[ge]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var se=a++;p[se]="^\\s*("+p[v]+")\\s+-\\s+("+p[v]+")\\s*$";var ce=a++;p[ce]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)k(we,p[we]),T[we]||(T[we]=new RegExp(p[we]));function re(U,K){if(U instanceof Pe)return U;if(typeof U!="string"||U.length>O||!(K?T[m]:T[t]).test(U))return null;try{return new Pe(U,K)}catch{return null}}function Pe(U,K){if(U instanceof Pe){if(U.loose===K)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Pe))return new Pe(U,K);k("SemVer",U,K),this.loose=K;var H=U.trim().match(K?T[m]:T[t]);if(!H)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var fe=+ie;if(fe>=0&&fe<A)return fe}return ie}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=re,e.valid=function(U,K){var H=re(U,K);return H?H.version:null},e.clean=function(U,K){var H=re(U.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(U){return k("SemVer.compare",this.version,this.loose,U),U instanceof Pe||(U=new Pe(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Pe.prototype.compareMain=function(U){return U instanceof Pe||(U=new Pe(U,this.loose)),Y(this.major,U.major)||Y(this.minor,U.minor)||Y(this.patch,U.patch)},Pe.prototype.comparePre=function(U){if(U instanceof Pe||(U=new Pe(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ie=U.prerelease[K];if(k("prerelease compare",K,H,ie),H===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(H===void 0)return-1;if(H!==ie)return Y(H,ie)}while(++K)},Pe.prototype.inc=function(U,K){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,K,H,ie){typeof H=="string"&&(ie=H,H=void 0);try{return new Pe(U,H).inc(K,ie).version}catch{return null}},e.diff=function(U,K){if(ue(U,K))return null;var H=re(U),ie=re(K);if(H.prerelease.length||ie.prerelease.length){for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ie[fe])return"pre"+fe;return"prerelease"}for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ie[fe])return fe},e.compareIdentifiers=Y;var Me=/^[0-9]+$/;function Y(U,K){var H=Me.test(U),ie=Me.test(K);return H&&ie&&(U=+U,K=+K),H&&!ie?-1:ie&&!H?1:U<K?-1:U>K?1:0}function q(U,K,H){return new Pe(U,H).compare(new Pe(K,H))}function ee(U,K,H){return q(U,K,H)>0}function ve(U,K,H){return q(U,K,H)<0}function ue(U,K,H){return q(U,K,H)===0}function be(U,K,H){return q(U,K,H)!==0}function de(U,K,H){return q(U,K,H)>=0}function X(U,K,H){return q(U,K,H)<=0}function Z(U,K,H,ie){var fe;switch(K){case"===":typeof U=="object"&&(U=U.version),typeof H=="object"&&(H=H.version),fe=U===H;break;case"!==":typeof U=="object"&&(U=U.version),typeof H=="object"&&(H=H.version),fe=U!==H;break;case"":case"=":case"==":fe=ue(U,H,ie);break;case"!=":fe=be(U,H,ie);break;case">":fe=ee(U,H,ie);break;case">=":fe=de(U,H,ie);break;case"<":fe=ve(U,H,ie);break;case"<=":fe=X(U,H,ie);break;default:throw new TypeError("Invalid operator: "+K)}return fe}function me(U,K){if(U instanceof me){if(U.loose===K)return U;U=U.value}if(!(this instanceof me))return new me(U,K);k("comparator",U,K),this.loose=K,this.parse(U),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(U,K){return Y(K,U)},e.major=function(U,K){return new Pe(U,K).major},e.minor=function(U,K){return new Pe(U,K).minor},e.patch=function(U,K){return new Pe(U,K).patch},e.compare=q,e.compareLoose=function(U,K){return q(U,K,!0)},e.rcompare=function(U,K,H){return q(K,U,H)},e.sort=function(U,K){return U.sort(function(H,ie){return e.compare(H,ie,K)})},e.rsort=function(U,K){return U.sort(function(H,ie){return e.rcompare(H,ie,K)})},e.gt=ee,e.lt=ve,e.eq=ue,e.neq=be,e.gte=de,e.lte=X,e.cmp=Z,e.Comparator=me;var pe={};function Oe(U,K){if(U instanceof Oe)return U.loose===K?U:new Oe(U.raw,K);if(U instanceof me)return new Oe(U.value,K);if(!(this instanceof Oe))return new Oe(U,K);if(this.loose=K,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function ze(U){return!U||U.toLowerCase()==="x"||U==="*"}function ke(U,K,H,ie,fe,Re,Ue,Ke,_e,tt,nt,et,rt){return((K=ze(H)?"":ze(ie)?">="+H+".0.0":ze(fe)?">="+H+"."+ie+".0":">="+K)+" "+(Ke=ze(_e)?"":ze(tt)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Ke)).trim()}function Ae(U,K){for(var H=0;H<U.length;H++)if(!U[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<U.length;H++)if(k(U[H].semver),U[H].semver!==pe&&U[H].semver.prerelease.length>0){var ie=U[H].semver;if(ie.major===K.major&&ie.minor===K.minor&&ie.patch===K.patch)return!0}return!1}return!0}function Ne(U,K,H){try{K=new Oe(K,H)}catch{return!1}return K.test(U)}function j(U,K,H,ie){var fe,Re,Ue,Ke,_e;switch(U=new Pe(U,ie),K=new Oe(K,ie),H){case">":fe=ee,Re=X,Ue=ve,Ke=">",_e=">=";break;case"<":fe=ve,Re=de,Ue=ee,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(U,K,ie))return!1;for(var tt=0;tt<K.set.length;++tt){var nt=K.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===pe&&(ft=new me(">=0.0.0")),et=et||ft,rt=rt||ft,fe(ft.semver,et.semver,ie)?et=ft:Ue(ft.semver,rt.semver,ie)&&(rt=ft)}),et.operator===Ke||et.operator===_e||(!rt.operator||rt.operator===Ke)&&Re(U,rt.semver)||rt.operator===_e&&Ue(U,rt.semver))return!1}return!0}me.prototype.parse=function(U){var K=this.loose?T[ae]:T[$e],H=U.match(K);if(!H)throw new TypeError("Invalid comparator: "+U);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Pe(H[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(U){return k("Comparator.test",U,this.loose),this.semver===pe||(typeof U=="string"&&(U=new Pe(U,this.loose)),Z(U,this.operator,this.semver,this.loose))},me.prototype.intersects=function(U,K){if(!(U instanceof me))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Oe(U.value,K),Ne(this.value,H,K);if(U.operator==="")return H=new Oe(this.value,K),Ne(U.semver,H,K);var ie=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Re=this.semver.version===U.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ke=Z(this.semver,"<",U.semver,K)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),_e=Z(this.semver,">",U.semver,K)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ie||fe||Re&&Ue||Ke||_e},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(U){var K=this.loose;U=U.trim(),k("range",U,K);var H=K?T[se]:T[ge];U=U.replace(H,ke),k("hyphen replace",U),U=U.replace(T[_],"$1$2$3"),k("comparator trim",U,T[_]),U=(U=(U=U.replace(T[M],"$1~")).replace(T[B],"$1^")).split(/\s+/).join(" ");var ie=K?T[ae]:T[$e],fe=U.split(" ").map(function(Re){return function(Ue,Ke){return k("comp",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){k("caret",et,rt);var ft=rt?T[V]:T[F];return et.replace(ft,function(ct,st,ut,gt,pt){var Be;return k("caret",et,ct,st,ut,gt,pt),ze(st)?Be="":ze(ut)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=st==="0"?">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+".0 <"+(+st+1)+".0.0":pt?(k("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=st==="0"?ut==="0"?">="+st+"."+ut+"."+gt+pt+" <"+st+"."+ut+"."+(+gt+1):">="+st+"."+ut+"."+gt+pt+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+gt+pt+" <"+(+st+1)+".0.0"):(k("no pr"),Be=st==="0"?ut==="0"?">="+st+"."+ut+"."+gt+" <"+st+"."+ut+"."+(+gt+1):">="+st+"."+ut+"."+gt+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+gt+" <"+(+st+1)+".0.0"),k("caret return",Be),Be})}(nt,tt)}).join(" ")}(Ue,Ke),k("caret",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?T[L]:T[N];return et.replace(ft,function(ct,st,ut,gt,pt){var Be;return k("tilde",et,ct,st,ut,gt,pt),ze(st)?Be="":ze(ut)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":pt?(k("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=">="+st+"."+ut+"."+gt+pt+" <"+st+"."+(+ut+1)+".0"):Be=">="+st+"."+ut+"."+gt+" <"+st+"."+(+ut+1)+".0",k("tilde return",Be),Be})}(nt,tt)}).join(" ")}(Ue,Ke),k("tildes",Ue),Ue=function(_e,tt){return k("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?T[P]:T[C];return et.replace(ft,function(ct,st,ut,gt,pt,Be){k("xRange",et,ct,st,ut,gt,pt,Be);var je=ze(ut),Q=je||ze(gt),x=Q||ze(pt);return st==="="&&x&&(st=""),je?ct=st===">"||st==="<"?"<0.0.0":"*":st&&x?(Q&&(gt=0),x&&(pt=0),st===">"?(st=">=",Q?(ut=+ut+1,gt=0,pt=0):x&&(gt=+gt+1,pt=0)):st==="<="&&(st="<",Q?ut=+ut+1:gt=+gt+1),ct=st+ut+"."+gt+"."+pt):Q?ct=">="+ut+".0.0 <"+(+ut+1)+".0.0":x&&(ct=">="+ut+"."+gt+".0 <"+ut+"."+(+gt+1)+".0"),k("xRange return",ct),ct})}(nt,tt)}).join(" ")}(Ue,Ke),k("xrange",Ue),Ue=function(_e,tt){return k("replaceStars",_e,tt),_e.trim().replace(T[ce],"")}(Ue,Ke),k("stars",Ue),Ue}(Re,K)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Re){return!!Re.match(ie)})),fe=fe.map(function(Re){return new me(Re,K)})},Oe.prototype.intersects=function(U,K){if(!(U instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ie){return U.set.some(function(fe){return fe.every(function(Re){return ie.intersects(Re,K)})})})})},e.toComparators=function(U,K){return new Oe(U,K).set.map(function(H){return H.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Pe(U,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],U))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(U,K,H){var ie=null,fe=null;try{var Re=new Oe(K,H)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ie&&fe.compare(Ue)!==-1||(fe=new Pe(ie=Ue,H)))}),ie},e.minSatisfying=function(U,K,H){var ie=null,fe=null;try{var Re=new Oe(K,H)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ie&&fe.compare(Ue)!==1||(fe=new Pe(ie=Ue,H)))}),ie},e.validRange=function(U,K){try{return new Oe(U,K).range||"*"}catch{return null}},e.ltr=function(U,K,H){return j(U,K,"<",H)},e.gtr=function(U,K,H){return j(U,K,">",H)},e.outside=j,e.prerelease=function(U,K){var H=re(U,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(U,K,H){return U=new Oe(U,H),K=new Oe(K,H),U.intersects(K)},e.coerce=function(U){if(U instanceof Pe)return U;if(typeof U!="string")return null;var K=U.match(T[g]);return K==null?null:re((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,b(1))},function(oe,e){var b,S,k=oe.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(s){if(b===setTimeout)return setTimeout(s,0);if((b===O||!b)&&setTimeout)return b=setTimeout,setTimeout(s,0);try{return b(s,0)}catch{try{return b.call(null,s,0)}catch{return b.call(this,s,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:O}catch{b=O}try{S=typeof clearTimeout=="function"?clearTimeout:A}catch{S=A}})();var p,a=[],R=!1,y=-1;function u(){R&&p&&(R=!1,p.length?a=p.concat(a):y=-1,a.length&&E())}function E(){if(!R){var s=T(u);R=!0;for(var o=a.length;o;){for(p=a,a=[];++y<o;)p&&p[y].run();y=-1,o=a.length}p=null,R=!1,function(h){if(S===clearTimeout)return clearTimeout(h);if((S===A||!S)&&clearTimeout)return S=clearTimeout,clearTimeout(h);try{S(h)}catch{try{return S.call(null,h)}catch{return S.call(this,h)}}}(s)}}function f(s,o){this.fun=s,this.array=o}function n(){}k.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)o[h-1]=arguments[h];a.push(new f(s,o)),a.length!==1||R||T(E)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=n,k.addListener=n,k.once=n,k.off=n,k.removeListener=n,k.removeAllListeners=n,k.emit=n,k.prependListener=n,k.prependOnceListener=n,k.listeners=function(s){return[]},k.binding=function(s){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(s){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Ce[144],Ie([1,0,6,4]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.ScrollbarVisibility=void 0;var k;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(k||(e.ScrollbarVisibility=k={}));class O{constructor(f,n,s,o,h,i,r){this.c=f,this._scrollStateBrand=void 0,this.c&&(n=n|0,s=s|0,o=o|0,h=h|0,i=i|0,r=r|0),this.rawScrollLeft=o,this.rawScrollTop=r,n<0&&(n=0),o+n>s&&(o=s-n),o<0&&(o=0),h<0&&(h=0),r+h>i&&(r=i-h),r<0&&(r=0),this.width=n,this.scrollWidth=s,this.scrollLeft=o,this.height=h,this.scrollHeight=i,this.scrollTop=r}equals(f){return this.rawScrollLeft===f.rawScrollLeft&&this.rawScrollTop===f.rawScrollTop&&this.width===f.width&&this.scrollWidth===f.scrollWidth&&this.scrollLeft===f.scrollLeft&&this.height===f.height&&this.scrollHeight===f.scrollHeight&&this.scrollTop===f.scrollTop}withScrollDimensions(f,n){return new O(this.c,typeof f.width<"u"?f.width:this.width,typeof f.scrollWidth<"u"?f.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof f.height<"u"?f.height:this.height,typeof f.scrollHeight<"u"?f.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(f){return new O(this.c,this.width,this.scrollWidth,typeof f.scrollLeft<"u"?f.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof f.scrollTop<"u"?f.scrollTop:this.rawScrollTop)}createScrollEvent(f,n){const s=this.width!==f.width,o=this.scrollWidth!==f.scrollWidth,h=this.scrollLeft!==f.scrollLeft,i=this.height!==f.height,r=this.scrollHeight!==f.scrollHeight,t=this.scrollTop!==f.scrollTop;return{inSmoothScrolling:n,oldWidth:f.width,oldScrollWidth:f.scrollWidth,oldScrollLeft:f.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:f.height,oldScrollHeight:f.scrollHeight,oldScrollTop:f.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:o,scrollLeftChanged:h,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$at=O;class A extends S.$Wc{constructor(f){super(),this._scrollableBrand=void 0,this.j=this.B(new b.$me),this.onScroll=this.j.event,this.c=f.smoothScrollDuration,this.f=f.scheduleAtNextAnimationFrame,this.g=new O(f.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(f){this.c=f}validateScrollPosition(f){return this.g.withScrollPosition(f)}getScrollDimensions(){return this.g}setScrollDimensions(f,n){const s=this.g.withScrollDimensions(f,n);this.n(s,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(f){const n=this.g.withScrollPosition(f);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(f,n){if(this.c===0)return this.setScrollPositionNow(f);if(this.h){f={scrollLeft:typeof f.scrollLeft>"u"?this.h.to.scrollLeft:f.scrollLeft,scrollTop:typeof f.scrollTop>"u"?this.h.to.scrollTop:f.scrollTop};const s=this.g.withScrollPosition(f);if(this.h.to.scrollLeft===s.scrollLeft&&this.h.to.scrollTop===s.scrollTop)return;let o;n?o=new R(this.h.from,s,this.h.startTime,this.h.duration):o=this.h.combine(this.g,s,this.c),this.h.dispose(),this.h=o}else{const s=this.g.withScrollPosition(f);this.h=R.start(this.g,s,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const f=this.h.tick(),n=this.g.withScrollPosition(f);if(this.n(n,!0),!!this.h){if(f.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(f,n){const s=this.g;s.equals(f)||(this.g=f,this.j.fire(this.g.createScrollEvent(s,n)))}}e.$bt=A;class T{constructor(f,n,s){this.scrollLeft=f,this.scrollTop=n,this.isDone=s}}e.$ct=T;function p(E,f){const n=f-E;return function(s){return E+n*u(s)}}function a(E,f,n){return function(s){return s<n?E(s/n):f((s-n)/(1-n))}}class R{constructor(f,n,s,o){this.from=f,this.to=n,this.duration=o,this.startTime=s,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(f,n,s){if(Math.abs(f-n)>2.5*s){let h,i;return f<n?(h=f+.75*s,i=n-.75*s):(h=f-.75*s,i=n+.75*s),a(p(f,h),p(i,n),.33)}return p(f,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(f){this.to=f.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(f){const n=(f-this.startTime)/this.duration;if(n<1){const s=this.c(n),o=this.d(n);return new T(s,o,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(f,n,s){return R.start(f,n,s)}static start(f,n,s){s=s+10;const o=Date.now()-10;return new R(f,n,o,s)}}e.$dt=R;function y(E){return Math.pow(E,3)}function u(E){return 1-y(1-E)}}),define(Ce[145],Ie([1,0,14,4]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=k,e.$Ae=O,e.$Be=A,e.$Ce=T,e.$De=a,e.$Ee=R,e.$Fe=y,e.$Ge=u,e.$He=E,e.$Ie=f,e.$Je=n,e.$Ke=s,e.$Le=o,e.$Me=h,e.$Ne=i;function k(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(c=>typeof c=="function"):!1}function A(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new p(r,t)}class p{constructor(t,c){this.e=t,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(c=>c(t))}h(t){this.c.error.length===0?(0,b.$3)(t):this.c.error.slice(0).forEach(c=>c(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,c){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener(t,c){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const m=l.indexOf(c);m>=0&&l.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(r,t){const c=[];let l;for(;(l=r.read())!==null;)c.push(l);return t(c)}function R(r,t,c){const l=[];let m;for(;(m=r.read())!==null&&l.length<c;)l.push(m);return m===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof m<"u"){const d=m;return m=void 0,d}return r.read()}}}function y(r,t){return new Promise((c,l)=>{const m=[];u(r,{onData:d=>{t&&m.push(d)},onError:d=>{t?l(d):c(void 0)},onEnd:()=>{c(t?t(m):void 0)}})})}function u(r,t,c){r.on("error",l=>{c?.isCancellationRequested||t.onError(l)}),r.on("end",()=>{c?.isCancellationRequested||t.onEnd()}),r.on("data",l=>{c?.isCancellationRequested||t.onData(l)})}function E(r,t){return new Promise((c,l)=>{const m=new S.$Vc,d=[],$=v=>{if(d.push(v),d.length>t)return m.dispose(),r.pause(),c({stream:r,buffer:d,ended:!1})},I=v=>(m.dispose(),l(v)),D=()=>(m.dispose(),c({stream:r,buffer:d,ended:!0}));m.add((0,S.$Uc)(()=>r.removeListener("error",I))),r.on("error",I),m.add((0,S.$Uc)(()=>r.removeListener("end",D))),r.on("end",D),m.add((0,S.$Uc)(()=>r.removeListener("data",$))),r.on("data",$)})}function f(r,t){const c=T(t);return c.end(r),c}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function s(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function o(r,t,c){const l=T(c);return u(r,{onData:m=>l.write(t.data(m)),onError:m=>l.error(t.error?t.error(m):m),onEnd:()=>l.end()}),l}function h(r,t,c){let l=!1;return{read:()=>{const m=t.read();return l?m:(l=!0,m!==null?c([r,m]):r)}}}function i(r,t,c){let l=!1;const m=T(c);return u(t,{onData:d=>l?m.write(d):(l=!0,m.write(c([r,d]))),onError:d=>m.error(d),onEnd:()=>{l||(l=!0,m.write(r)),m.end()}}),m}}),define(Ce[23],Ie([1,0,47,145]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=R,e.$Re=y,e.$Se=u,e.$Te=E,e.$Ue=f,e.$Ve=n,e.$We=s,e.$Xe=o,e.$Ye=h,e.$Ze=i,e.$1e=r,e.$2e=t,e.$3e=c,e.$4e=l,e.$5e=m,e.$6e=d,e.$7e=$,e.$8e=I,e.$9e=C,S=qe(S);const k=typeof Buffer<"u",O=new b.$X(()=>new Uint8Array(256));let A,T;class p{static alloc(g){return k?new p(Buffer.allocUnsafe(g)):new p(new Uint8Array(g))}static wrap(g){return k&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new p(g)}static fromString(g,w){return!(w?.dontUseNodeBuffer||!1)&&k?new p(Buffer.from(g)):(A||(A=new TextEncoder),new p(A.encode(g)))}static fromByteArray(g){const w=p.alloc(g.length);for(let M=0,N=g.length;M<N;M++)w.buffer[M]=g[M];return w}static concat(g,w){if(typeof w>"u"){w=0;for(let L=0,G=g.length;L<G;L++)w+=g[L].byteLength}const M=p.alloc(w);let N=0;for(let L=0,G=g.length;L<G;L++){const B=g[L];M.set(B,N),N+=B.byteLength}return M}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=p.alloc(this.byteLength);return g.set(this),g}toString(){return k?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(g,w){return new p(this.buffer.subarray(g,w))}set(g,w){if(g instanceof p)this.buffer.set(g.buffer,w);else if(g instanceof Uint8Array)this.buffer.set(g,w);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),w);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return u(this.buffer,g)}writeUInt32BE(g,w){E(this.buffer,g,w)}readUInt32LE(g){return f(this.buffer,g)}writeUInt32LE(g,w){n(this.buffer,g,w)}readUInt8(g){return s(this.buffer,g)}writeUInt8(g,w){o(this.buffer,g,w)}indexOf(g,w=0){return a(this.buffer,g instanceof p?g.buffer:g,w)}}e.$Oe=p;function a(P,g,w=0){const M=g.byteLength,N=P.byteLength;if(M===0)return 0;if(M===1)return P.indexOf(g[0]);if(M>N-w)return-1;const L=O.value;L.fill(g.length);for(let V=0;V<g.length;V++)L[g[V]]=g.length-V-1;let G=w+g.length-1,B=G,F=-1;for(;G<N;)if(P[G]===g[B]){if(B===0){F=G;break}G--,B--}else G+=Math.max(g.length-B,L[P[G]]),B=g.length-1;return F}function R(P,g){return P[g+0]<<0>>>0|P[g+1]<<8>>>0}function y(P,g,w){P[w+0]=g&255,g=g>>>8,P[w+1]=g&255}function u(P,g){return P[g]*2**24+P[g+1]*2**16+P[g+2]*2**8+P[g+3]}function E(P,g,w){P[w+3]=g,g=g>>>8,P[w+2]=g,g=g>>>8,P[w+1]=g,g=g>>>8,P[w]=g}function f(P,g){return P[g+0]<<0>>>0|P[g+1]<<8>>>0|P[g+2]<<16>>>0|P[g+3]<<24>>>0}function n(P,g,w){P[w+0]=g&255,g=g>>>8,P[w+1]=g&255,g=g>>>8,P[w+2]=g&255,g=g>>>8,P[w+3]=g&255}function s(P,g){return P[g]}function o(P,g,w){P[w]=g}function h(P){return S.$De(P,g=>p.concat(g))}function i(P){return S.$Ke(P)}function r(P){return S.$Fe(P,g=>p.concat(g))}async function t(P){return P.ended?p.concat(P.buffer):p.concat([...P.buffer,await r(P.stream)])}function c(P){return S.$Ie(P,g=>p.concat(g))}function l(P){return S.$Le(P,{data:g=>typeof g=="string"?p.fromString(g):p.wrap(g)},g=>p.concat(g))}function m(P){return S.$Ce(g=>p.concat(g),P)}function d(P,g){return S.$Me(P,g,w=>p.concat(w))}function $(P,g){return S.$Ne(P,g,w=>p.concat(w))}function I(P){let g=0,w=0,M=0;const N=new Uint8Array(Math.floor(P.length/4*3)),L=B=>{switch(w){case 3:N[M++]=g|B,w=0;break;case 2:N[M++]=g|B>>>2,g=B<<6,w=3;break;case 1:N[M++]=g|B>>>4,g=B<<4,w=2;break;default:g=B<<2,w=1}};for(let B=0;B<P.length;B++){const F=P.charCodeAt(B);if(F>=65&&F<=90)L(F-65);else if(F>=97&&F<=122)L(F-97+26);else if(F>=48&&F<=57)L(F-48+52);else if(F===43||F===45)L(62);else if(F===47||F===95)L(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${P[B]}`)}}const G=M;for(;w>0;)L(0);return p.wrap(N).slice(0,G)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:P},g=!0,w=!1){const M=w?v:D;let N="";const L=P.byteLength%3;let G=0;for(;G<P.byteLength-L;G+=3){const B=P[G+0],F=P[G+1],V=P[G+2];N+=M[B>>>2],N+=M[(B<<4|F>>>4)&63],N+=M[(F<<2|V>>>6)&63],N+=M[V&63]}if(L===1){const B=P[G+0];N+=M[B>>>2],N+=M[B<<4&63],g&&(N+="==")}else if(L===2){const B=P[G+0],F=P[G+1];N+=M[B>>>2],N+=M[(B<<4|F>>>4)&63],N+=M[F<<2&63],g&&(N+="=")}return N}}),define(Ce[146],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(Ce[35],Ie([1,0,98]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=k;var S;(function(A){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=T})(S||(e.ThemeColor=S={}));function k(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(h){const i=T.exec(h.id);if(!i)return p(b.$5j.error);const[,r,t]=i,c=["codicon","codicon-"+r];return t&&c.push("codicon-modifier-"+t.substring(1)),c}A.asClassNameArray=p;function a(h){return p(h).join(" ")}A.asClassName=a;function R(h){return"."+p(h).join(".")}A.asCSSSelector=R;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||S.isThemeColor(h.color))}A.isThemeIcon=y;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(h){const i=u.exec(h);if(!i)return;const[,r]=i;return{id:r}}A.fromString=E;function f(h){return{id:h}}A.fromId=f;function n(h,i){let r=h.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function s(h){const i=h.id.lastIndexOf("~");if(i!==-1)return h.id.substring(i+1)}A.getModifier=s;function o(h,i){return h.id===i.id&&h.color?.id===i.color?.id}A.isEqual=o})(O||(e.ThemeIcon=O={}))}),define(Ce[147],Ie([1,0,28,29,138,13]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=A,e.$Ik=p,e.$Jk=a,e.$Kk=u,e.$Lk=D,e.$Mk=v,e.$Nk=N,e.$Ok=L,e.$Pk=G,e.$Qk=B,e.$Rk=ee,e.$Tk=de,e.$Uk=me,e.$Vk=pe,O=qe(O);function A(...ke){return function(Ae,Ne){for(let j=0,U=ke.length;j<U;j++){const K=ke[j](Ae,Ne);if(K)return K}return null}}e.$Gk=T.bind(void 0,!1),e.$Hk=T.bind(void 0,!0);function T(ke,Ae,Ne){if(!Ne||Ne.length<Ae.length)return null;let j;return ke?j=O.$Hf(Ne,Ae):j=Ne.indexOf(Ae)===0,j?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function p(ke,Ae){const Ne=Ae.toLowerCase().indexOf(ke.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+ke.length}]}function a(ke,Ae){return R(ke.toLowerCase(),Ae.toLowerCase(),0,0)}function R(ke,Ae,Ne,j){if(Ne===ke.length)return[];if(j===Ae.length)return null;if(ke[Ne]===Ae[j]){let U=null;return(U=R(ke,Ae,Ne+1,j+1))?t({start:j,end:j+1},U):null}return R(ke,Ae,Ne,j+1)}function y(ke){return b.CharCode.a<=ke&&ke<=b.CharCode.z}function u(ke){return b.CharCode.A<=ke&&ke<=b.CharCode.Z}function E(ke){return b.CharCode.Digit0<=ke&&ke<=b.CharCode.Digit9}function f(ke){return ke===b.CharCode.Space||ke===b.CharCode.Tab||ke===b.CharCode.LineFeed||ke===b.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>n.add(ke.charCodeAt(0)));function s(ke){return f(ke)||n.has(ke)}function o(ke,Ae){return ke===Ae||s(ke)&&s(Ae)}const h=new Map;function i(ke){if(h.has(ke))return h.get(ke);let Ae;const Ne=(0,k.$Ek)(ke);return Ne&&(Ae=Ne),h.set(ke,Ae),Ae}function r(ke){return y(ke)||u(ke)||E(ke)}function t(ke,Ae){return Ae.length===0?Ae=[ke]:ke.end===Ae[0].start?Ae[0].start=ke.start:Ae.unshift(ke),Ae}function c(ke,Ae){for(let Ne=Ae;Ne<ke.length;Ne++){const j=ke.charCodeAt(Ne);if(u(j)||E(j)||Ne>0&&!r(ke.charCodeAt(Ne-1)))return Ne}return ke.length}function l(ke,Ae,Ne,j){if(Ne===ke.length)return[];if(j===Ae.length)return null;if(ke[Ne]!==Ae[j].toLowerCase())return null;{let U=null,K=j+1;for(U=l(ke,Ae,Ne+1,j+1);!U&&(K=c(Ae,K))<Ae.length;)U=l(ke,Ae,Ne+1,K),K++;return U===null?null:t({start:j,end:j+1},U)}}function m(ke){let Ae=0,Ne=0,j=0,U=0,K=0;for(let Ue=0;Ue<ke.length;Ue++)K=ke.charCodeAt(Ue),u(K)&&Ae++,y(K)&&Ne++,r(K)&&j++,E(K)&&U++;const H=Ae/ke.length,ie=Ne/ke.length,fe=j/ke.length,Re=U/ke.length;return{upperPercent:H,lowerPercent:ie,alphaPercent:fe,numericPercent:Re}}function d(ke){const{upperPercent:Ae,lowerPercent:Ne}=ke;return Ne===0&&Ae>.6}function $(ke){const{upperPercent:Ae,lowerPercent:Ne,alphaPercent:j,numericPercent:U}=ke;return Ne>.2&&Ae<.8&&j>.6&&U<.2}function I(ke){let Ae=0,Ne=0,j=0,U=0;for(let K=0;K<ke.length;K++)j=ke.charCodeAt(K),u(j)&&Ae++,y(j)&&Ne++,f(j)&&U++;return(Ae===0||Ne===0)&&U===0?ke.length<=30:Ae<=5}function D(ke,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!I(ke))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Ne=m(Ae);if(!$(Ne)){if(!d(Ne))return null;Ae=Ae.toLowerCase()}let j=null,U=0;for(ke=ke.toLowerCase();U<Ae.length&&(j=l(ke,Ae,0,U))===null;)U=c(Ae,U+1);return j}function v(ke,Ae,Ne=!1){if(!Ae||Ae.length===0)return null;let j=null,U=0;for(ke=ke.toLowerCase(),Ae=Ae.toLowerCase();U<Ae.length&&(j=C(ke,Ae,0,U,Ne),j===null);)U=P(Ae,U+1);return j}function C(ke,Ae,Ne,j,U){let K=0;if(Ne===ke.length)return[];if(j===Ae.length)return null;if(!o(ke.charCodeAt(Ne),Ae.charCodeAt(j))){const fe=i(ke.charCodeAt(Ne));if(!fe)return null;for(let Re=0;Re<fe.length;Re++)if(!o(fe[Re],Ae.charCodeAt(j+Re)))return null;K+=fe.length-1}let H=null,ie=j+K+1;if(H=C(ke,Ae,Ne+1,ie,U),!U)for(;!H&&(ie=P(Ae,ie))<Ae.length;)H=C(ke,Ae,Ne+1,ie,U),ie++;if(!H)return null;if(ke.charCodeAt(Ne)!==Ae.charCodeAt(j)){const fe=i(ke.charCodeAt(Ne));if(!fe)return H;for(let Re=0;Re<fe.length;Re++)if(fe[Re]!==Ae.charCodeAt(j+Re))return H}return t({start:j,end:j+K+1},H)}function P(ke,Ae){for(let Ne=Ae;Ne<ke.length;Ne++)if(s(ke.charCodeAt(Ne))||Ne>0&&s(ke.charCodeAt(Ne-1)))return Ne;return ke.length}const g=A(e.$Hk,D,p),w=A(e.$Hk,D,a),M=new S.$Fc(1e4);function N(ke,Ae,Ne=!1){if(typeof ke!="string"||typeof Ae!="string")return null;let j=M.get(ke);j||(j=new RegExp(O.$pf(ke),"i"),M.set(ke,j));const U=j.exec(Ae);return U?[{start:U.index,end:U.index+U[0].length}]:Ne?w(ke,Ae):g(ke,Ae)}function L(ke,Ae){const Ne=de(ke,ke.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?B(Ne):null}function G(ke,Ae,Ne,j,U,K){const H=Math.min(13,ke.length);for(;Ne<H;Ne++){const ie=de(ke,Ae,Ne,j,U,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ie)return ie}return[0,K]}function B(ke){if(typeof ke>"u")return[];const Ae=[],Ne=ke[1];for(let j=ke.length-1;j>1;j--){const U=ke[j]+Ne,K=Ae[Ae.length-1];K&&K.end===U?K.end=U+1:Ae.push({start:U,end:U+1})}return Ae}const F=128;function V(){const ke=[],Ae=[];for(let Ne=0;Ne<=F;Ne++)Ae[Ne]=0;for(let Ne=0;Ne<=F;Ne++)ke.push(Ae.slice(0));return ke}function ae(ke){const Ae=[];for(let Ne=0;Ne<=ke;Ne++)Ae[Ne]=0;return Ae}const $e=ae(2*F),_=ae(2*F),ge=V(),se=V(),ce=V(),we=!1;function re(ke,Ae,Ne,j,U){function K(ie,fe,Re=" "){for(;ie.length<fe;)ie=Re+ie;return ie}let H=` |   |${j.split("").map(ie=>K(ie,3)).join("|")}
`;for(let ie=0;ie<=Ne;ie++)ie===0?H+=" |":H+=`${Ae[ie-1]}|`,H+=ke[ie].slice(0,U+1).map(fe=>K(fe.toString(),3)).join("|")+`
`;return H}function Pe(ke,Ae,Ne,j){ke=ke.substr(Ae),Ne=Ne.substr(j),console.log(re(se,ke,ke.length,Ne,Ne.length)),console.log(re(ce,ke,ke.length,Ne,Ne.length)),console.log(re(ge,ke,ke.length,Ne,Ne.length))}function Me(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;const Ne=ke.codePointAt(Ae);switch(Ne){case b.CharCode.Underline:case b.CharCode.Dash:case b.CharCode.Period:case b.CharCode.Space:case b.CharCode.Slash:case b.CharCode.Backslash:case b.CharCode.SingleQuote:case b.CharCode.DoubleQuote:case b.CharCode.Colon:case b.CharCode.DollarSign:case b.CharCode.LessThan:case b.CharCode.GreaterThan:case b.CharCode.OpenParen:case b.CharCode.CloseParen:case b.CharCode.OpenSquareBracket:case b.CharCode.CloseSquareBracket:case b.CharCode.OpenCurlyBrace:case b.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Zf(Ne)}}function Y(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;switch(ke.charCodeAt(Ae)){case b.CharCode.Space:case b.CharCode.Tab:return!0;default:return!1}}function q(ke,Ae,Ne){return Ae[ke]!==Ne[ke]}function ee(ke,Ae,Ne,j,U,K,H=!1){for(;Ae<Ne&&U<K;)ke[Ae]===j[U]&&(H&&($e[Ae]=U),Ae+=1),U+=1;return Ae===Ne}var ve;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ue;(function(ke){ke.Default=[-100,0];function Ae(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}ke.isDefault=Ae})(ue||(e.FuzzyScore=ue={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Ne){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Ne}}e.$Sk=be;function de(ke,Ae,Ne,j,U,K,H=be.default){const ie=ke.length>F?F:ke.length,fe=j.length>F?F:j.length;if(Ne>=ie||K>=fe||ie-Ne>fe-K||!ee(Ae,Ne,ie,U,K,fe,!0))return;X(ie,fe,Ne,K,Ae,U);let Re=1,Ue=1,Ke=Ne,_e=K;const tt=[!1];for(Re=1,Ke=Ne;Ke<ie;Re++,Ke++){const ct=$e[Ke],st=_[Ke],ut=Ke+1<ie?_[Ke+1]:fe;for(Ue=ct-K+1,_e=ct;_e<ut;Ue++,_e++){let gt=Number.MIN_SAFE_INTEGER,pt=!1;_e<=st&&(gt=Z(ke,Ae,Ke,Ne,j,U,_e,fe,K,ge[Re-1][Ue-1]===0,tt));let Be=0;gt!==Number.MAX_SAFE_INTEGER&&(pt=!0,Be=gt+se[Re-1][Ue-1]);const je=_e>ct,Q=je?se[Re][Ue-1]+(ge[Re][Ue-1]>0?-5:0):0,x=_e>ct+1&&ge[Re][Ue-1]>0,De=x?se[Re][Ue-2]+(ge[Re][Ue-2]>0?-5:0):0;if(x&&(!je||De>=Q)&&(!pt||De>=Be))se[Re][Ue]=De,ce[Re][Ue]=ve.LeftLeft,ge[Re][Ue]=0;else if(je&&(!pt||Q>=Be))se[Re][Ue]=Q,ce[Re][Ue]=ve.Left,ge[Re][Ue]=0;else if(pt)se[Re][Ue]=Be,ce[Re][Ue]=ve.Diag,ge[Re][Ue]=ge[Re-1][Ue-1]+1;else throw new Error("not possible")}}if(we&&Pe(ke,Ne,j,K),!tt[0]&&!H.firstMatchCanBeWeak)return;Re--,Ue--;const nt=[se[Re][Ue],K];let et=0,rt=0;for(;Re>=1;){let ct=Ue;do{const st=ce[Re][ct];if(st===ve.LeftLeft)ct=ct-2;else if(st===ve.Left)ct=ct-1;else break}while(ct>=1);et>1&&Ae[Ne+Re-1]===U[K+Ue-1]&&!q(ct+K-1,j,U)&&et+1>ge[Re][ct]&&(ct=Ue),ct===Ue?et++:et=1,rt||(rt=ct),Re--,Ue=ct-1,nt.push(Ue)}fe-K===ie&&H.boostFullMatch&&(nt[0]+=2);const ft=rt-ie;return nt[0]-=ft,nt}function X(ke,Ae,Ne,j,U,K){let H=ke-1,ie=Ae-1;for(;H>=Ne&&ie>=j;)U[H]===K[ie]&&(_[H]=ie,H--),ie--}function Z(ke,Ae,Ne,j,U,K,H,ie,fe,Re,Ue){if(Ae[Ne]!==K[H])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return H===Ne-j?Ke=ke[Ne]===U[H]?7:5:q(H,U,K)&&(H===0||!q(H-1,U,K))?(Ke=ke[Ne]===U[H]?7:5,_e=!0):Me(K,H)&&(H===0||!Me(K,H-1))?Ke=5:(Me(K,H-1)||Y(K,H-1))&&(Ke=5,_e=!0),Ke>1&&Ne===j&&(Ue[0]=!0),_e||(_e=q(H,U,K)||Me(K,H-1)||Y(K,H-1)),Ne===j?H>fe&&(Ke-=_e?3:5):Re?Ke+=_e?2:0:Ke+=_e?0:1,H+1===ie&&(Ke-=_e?3:5),Ke}function me(ke,Ae,Ne,j,U,K,H){return Oe(ke,Ae,Ne,j,U,K,!0,H)}function pe(ke,Ae,Ne,j,U,K,H){return Oe(ke,Ae,Ne,j,U,K,!1,H)}function Oe(ke,Ae,Ne,j,U,K,H,ie){let fe=de(ke,Ae,Ne,j,U,K,ie);if(fe&&!H)return fe;if(ke.length>=3){const Re=Math.min(7,ke.length-1);for(let Ue=Ne+1;Ue<Re;Ue++){const Ke=ze(ke,Ue);if(Ke){const _e=de(Ke,Ke.toLowerCase(),Ne,j,U,K,ie);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function ze(ke,Ae){if(Ae+1>=ke.length)return;const Ne=ke[Ae],j=ke[Ae+1];if(Ne!==j)return ke.slice(0,Ae)+j+Ne+ke.slice(Ae+2)}}),define(Ce[99],Ie([1,0,147,13,35]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=p,e.$Xk=R,e.$Yk=u,e.$Zk=E,e.$1k=n,e.$2k=s;const O="$(",A=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function p(o){return o.replace(T,(h,i)=>i?h:`\\${h}`)}const a=new RegExp(`\\\\${A.source}`,"g");function R(o){return o.replace(a,h=>`\\${h}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(o){return o.indexOf(O)===-1?o:o.replace(y,(h,i,r,t)=>r?h:i||t||"")}function E(o){return o?o.replace(/\$\((.*?)\)/g,(h,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(o){f.lastIndex=0;let h="";const i=[];let r=0;for(;;){const t=f.lastIndex,c=f.exec(o),l=o.substring(t,c?.index);if(l.length>0){h+=l;for(let m=0;m<l.length;m++)i.push(r)}if(!c)break;r+=c[0].length}return{text:h,iconOffsets:i}}function s(o,h,i=!1){const{text:r,iconOffsets:t}=h;if(!t||t.length===0)return(0,b.$Nk)(o,r,i);const c=(0,S.$nf)(r," "),l=r.length-c.length,m=(0,b.$Nk)(o,c,i);if(m)for(const d of m){const $=t[d.start+l]+l;d.start+=$,d.end+=$}return m}}),define(Ce[36],Ie([1,0,13]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),b=qe(b);var S;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(S||(S={})),function(k){const O="error",A="warning",T="warn",p="info",a="ignore";function R(u){return u?b.$Gf(O,u)?k.Error:b.$Gf(A,u)||b.$Gf(T,u)?k.Warning:b.$Gf(p,u)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function y(u){switch(u){case k.Error:return O;case k.Warning:return A;case k.Info:return p;default:return a}}k.toString=y}(S||(S={})),e.default=S}),define(Ce[59],Ie([1,0,18,28,13]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const n=f.charCodeAt(0),s=this.b.charCodeAt(this.c);return n-s}value(){return this.b[this.c]}}e.$Hi=O;class A{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===S.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,k.$Af)(f,this.b,0,f.length,this.c,this.d):(0,k.$Cf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=A;class T{constructor(f=!0,n=!0){this.f=f,this.g=n}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let n=f.length-1;n>=0;n--,this.c--){const s=this.b.charCodeAt(n);if(!(s===S.CharCode.Slash||this.f&&s===S.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===S.CharCode.Slash||this.f&&n===S.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,k.$Af)(f,this.b,0,f.length,this.d,this.e):(0,k.$Cf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=T;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(f,n){this.f=f,this.g=n,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,k.$Bf)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,k.$Bf)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,k.$zf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,k.$zf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=a;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class u{static forUris(f=()=>!1,n=()=>!1){return new u(new a(f,n))}static forPaths(f=!1){return new u(new T(void 0,!f))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new A)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,n){if(n){const s=n.slice(0);(0,b.$Yb)(s);for(const o of s)this.set(o,f)}else{const s=f.slice(0);(0,b.$Yb)(s);for(const o of s)this.set(o[0],o[1])}}set(f,n){const s=this.b.reset(f);let o;this.c||(this.c=new R,this.c.segment=s.value());const h=[];for(o=this.c;;){const r=s.cmp(o.segment);if(r>0)o.left||(o.left=new R,o.left.segment=s.value()),h.push([y.Left,o]),o=o.left;else if(r<0)o.right||(o.right=new R,o.right.segment=s.value()),h.push([y.Right,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new R,o.mid.segment=s.value()),h.push([y.Mid,o]),o=o.mid;else break}const i=o.value;o.value=n,o.key=f;for(let r=h.length-1;r>=0;r--){const t=h[r][1];t.updateHeight();const c=t.balanceFactor();if(c<-1||c>1){const l=h[r][0],m=h[r+1][0];if(l===y.Right&&m===y.Right)h[r][1]=t.rotateLeft();else if(l===y.Left&&m===y.Left)h[r][1]=t.rotateRight();else if(l===y.Right&&m===y.Left)t.right=h[r+1][1]=h[r+1][1].rotateRight(),h[r][1]=t.rotateLeft();else if(l===y.Left&&m===y.Right)t.left=h[r+1][1]=h[r+1][1].rotateLeft(),h[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(h[r-1][0]){case y.Left:h[r-1][1].left=h[r][1];break;case y.Right:h[r-1][1].right=h[r][1];break;case y.Mid:h[r-1][1].mid=h[r][1];break}else this.c=h[0][1]}}return i}get(f){return this.d(f)?.value}d(f){const n=this.b.reset(f);let s=this.c;for(;s;){const o=n.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(f){const n=this.d(f);return!(n?.value===void 0&&n?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,n){const s=this.b.reset(f),o=[];let h=this.c;for(;h;){const i=s.cmp(h.segment);if(i>0)o.push([y.Left,h]),h=h.left;else if(i<0)o.push([y.Right,h]),h=h.right;else if(s.hasNext())s.next(),o.push([y.Mid,h]),h=h.mid;else break}if(h){if(n?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const i=this.f(h.right);if(i.key){const{key:r,value:t,segment:c}=i;this.e(i.key,!1),h.key=r,h.value=t,h.segment=c}}else{const i=h.left??h.right;if(o.length>0){const[r,t]=o[o.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),o[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),o[i][1]=r.rotateRight()),i>0)switch(o[i-1][0]){case y.Left:o[i-1][1].left=o[i][1];break;case y.Right:o[i-1][1].right=o[i][1];break;case y.Mid:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const n=this.b.reset(f);let s=this.c,o;for(;s;){const h=n.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(n.hasNext())n.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(f){return this.g(f,!1)}g(f,n){const s=this.b.reset(f);let o=this.c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):n?o.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[n,s]of this)f(s,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const n=[];return this.j(f,n),n[Symbol.iterator]()}j(f,n){f&&(f.left&&this.j(f.left,n),f.value&&n.push([f.key,f.value]),f.mid&&this.j(f.mid,n),f.right&&this.j(f.right,n))}_isBalanced(){const f=n=>{if(!n)return!0;const s=n.balanceFactor();return s<-1||s>1?!1:f(n.left)&&f(n.right)};return f(this.c)}}e.$Li=u}),define(Ce[37],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=S;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(k){return b.test(k)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){k(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,a="";return a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a}}()}),define(Ce[148],Ie([1,0,18,40,37]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=e.$nu=void 0,e.$lu=O,e.$mu=A,e.$ou=a;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,u,E){const f={id:(0,k.$2g)(),name:y,uri:u,data:E};return{asString:async()=>"",asFile:()=>f,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return S.Iterable.some(this,([f,n])=>n.asFile())&&E.push("files"),R(p(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const f=this.a.get(u);f?f.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const f of E)yield[u,f]}b(u){return p(u)}}e.$nu=T;function p(y){return y.toLowerCase()}function a(y,u){return R(p(y),u.map(p))}function R(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const E=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[f,n,s]=E;return s==="*"?u.some(o=>o.startsWith(n+"/")):!1}e.$pu=Object.freeze({create:y=>(0,b.$Ob)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$pu.split(y).filter(u=>!u.startsWith("#"))})}),define(Ce[149],Ie([1,0,28]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$vu=k;var S;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function k(O){let A=0,T=0,p=0,a=S.Unknown;for(let R=0,y=O.length;R<y;R++){const u=O.charCodeAt(R);u===b.CharCode.CarriageReturn?(A===0&&(T=R),A++,R+1<y&&O.charCodeAt(R+1)===b.CharCode.LineFeed?(a|=S.CRLF,R++):a|=S.Invalid,p=R+1):u===b.CharCode.LineFeed&&(a|=S.LF,A===0&&(T=R),A++,p=R+1)}return A===0&&(T=O.length),[A,T,O.length-p,a]}}),define(Ce[150],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$it={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[151],Ie([1,0,28,152]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=e.IndentAction=void 0;var k;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class O{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let R=0,y=a.notIn.length;R<y;R++)switch(a.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case S.StandardTokenType.Other:return!0;case S.StandardTokenType.Comment:return this.c;case S.StandardTokenType.String:return this.b;case S.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,R){if(a.getTokenCount()===0)return!0;const y=a.findTokenIndexAtOffset(R-2),u=a.getStandardTokenType(y);return this.isOK(u)}g(a,R){for(let y=a;y<=R;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(b.CharCode.Digit0,b.CharCode.Digit9)),this.e||(this.e=this.g(b.CharCode.a,b.CharCode.z)),this.e||(this.e=this.g(b.CharCode.A,b.CharCode.Z))),this.e}}e.$Su=O;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of a)T(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),T(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),T(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),T(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&T(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Tu=A;function T(p,a,R){p.has(a)?p.get(a).push(R):p.set(a,[R])}}),define(Ce[153],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.NodeColor=e.$3C=void 0,e.$5C=k,e.$6C=O,e.$7C=a,e.$8C=R,e.$9C=y,e.$0C=u,e.$$C=E,e.$_C=f;class b{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$4C)return k(this.right);let s=this;for(;s.parent!==e.$4C&&s.parent.left!==s;)s=s.parent;return s.parent===e.$4C?e.$4C:s.parent}prev(){if(this.left!==e.$4C)return O(this.left);let s=this;for(;s.parent!==e.$4C&&s.parent.right!==s;)s=s.parent;return s.parent===e.$4C?e.$4C:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$3C=b;var S;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(S||(e.NodeColor=S={})),e.$4C=new b(null,S.Black),e.$4C.parent=e.$4C,e.$4C.left=e.$4C,e.$4C.right=e.$4C,e.$4C.color=S.Black;function k(n){for(;n.left!==e.$4C;)n=n.left;return n}function O(n){for(;n.right!==e.$4C;)n=n.right;return n}function A(n){return n===e.$4C?0:n.size_left+n.piece.length+A(n.right)}function T(n){return n===e.$4C?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function p(){e.$4C.parent=e.$4C}function a(n,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$4C&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$4C?n.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function R(n,s){const o=s.left;s.left=o.right,o.right!==e.$4C&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$4C?n.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function y(n,s){let o,h;if(s.left===e.$4C?(h=s,o=h.right):s.right===e.$4C?(h=s,o=h.left):(h=k(s.right),o=h.right),h===n.root){n.root=o,o.color=S.Black,s.detach(),p(),n.root.parent=e.$4C;return}const i=h.color===S.Red;if(h===h.parent.left?h.parent.left=o:h.parent.right=o,h===s?(o.parent=h.parent,f(n,o)):(h.parent===s?o.parent=h:o.parent=h.parent,f(n,o),h.left=s.left,h.right=s.right,h.parent=s.parent,h.color=s.color,s===n.root?n.root=h:s===s.parent.left?s.parent.left=h:s.parent.right=h,h.left!==e.$4C&&(h.left.parent=h),h.right!==e.$4C&&(h.right.parent=h),h.size_left=s.size_left,h.lf_left=s.lf_left,f(n,h)),s.detach(),o.parent.left===o){const t=A(o),c=T(o);if(t!==o.parent.size_left||c!==o.parent.lf_left){const l=t-o.parent.size_left,m=c-o.parent.lf_left;o.parent.size_left=t,o.parent.lf_left=c,E(n,o.parent,l,m)}}if(f(n,o.parent),i){p();return}let r;for(;o!==n.root&&o.color===S.Black;)o===o.parent.left?(r=o.parent.right,r.color===S.Red&&(r.color=S.Black,o.parent.color=S.Red,a(n,o.parent),r=o.parent.right),r.left.color===S.Black&&r.right.color===S.Black?(r.color=S.Red,o=o.parent):(r.right.color===S.Black&&(r.left.color=S.Black,r.color=S.Red,R(n,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=S.Black,r.right.color=S.Black,a(n,o.parent),o=n.root)):(r=o.parent.left,r.color===S.Red&&(r.color=S.Black,o.parent.color=S.Red,R(n,o.parent),r=o.parent.left),r.left.color===S.Black&&r.right.color===S.Black?(r.color=S.Red,o=o.parent):(r.left.color===S.Black&&(r.right.color=S.Black,r.color=S.Red,a(n,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=S.Black,r.left.color=S.Black,R(n,o.parent),o=n.root));o.color=S.Black,p()}function u(n,s){for(f(n,s);s!==n.root&&s.parent.color===S.Red;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===S.Red?(s.parent.color=S.Black,o.color=S.Black,s.parent.parent.color=S.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,a(n,s)),s.parent.color=S.Black,s.parent.parent.color=S.Red,R(n,s.parent.parent))}else{const o=s.parent.parent.left;o.color===S.Red?(s.parent.color=S.Black,o.color=S.Black,s.parent.parent.color=S.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,R(n,s)),s.parent.color=S.Black,s.parent.parent.color=S.Red,a(n,s.parent.parent))}n.root.color=S.Black}function E(n,s,o,h){for(;s!==n.root&&s!==e.$4C;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}function f(n,s){let o=0,h=0;if(s!==n.root){for(;s!==n.root&&s===s.parent.right;)s=s.parent;if(s!==n.root)for(s=s.parent,o=A(s.left)-s.size_left,h=T(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=h;s!==n.root&&(o!==0||h!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}}}),define(Ce[100],Ie([1,0,28,101,33,52,153,102]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.$iD=void 0,e.$gD=y,e.$hD=u;const p=65535;function a(h){let i;return h[h.length-1]<65536?i=new Uint16Array(h.length):i=new Uint32Array(h.length),i.set(h,0),i}class R{constructor(i,r,t,c,l){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=c,this.isBasicASCII=l}}function y(h,i=!0){const r=[0];let t=1;for(let c=0,l=h.length;c<l;c++){const m=h.charCodeAt(c);m===b.CharCode.CarriageReturn?c+1<l&&h.charCodeAt(c+1)===b.CharCode.LineFeed?(r[t++]=c+2,c++):r[t++]=c+1:m===b.CharCode.LineFeed&&(r[t++]=c+1)}return i?a(r):r}function u(h,i){h.length=0,h[0]=0;let r=1,t=0,c=0,l=0,m=!0;for(let $=0,I=i.length;$<I;$++){const D=i.charCodeAt($);D===b.CharCode.CarriageReturn?$+1<I&&i.charCodeAt($+1)===b.CharCode.LineFeed?(l++,h[r++]=$+2,$++):(t++,h[r++]=$+1):D===b.CharCode.LineFeed?(c++,h[r++]=$+1):m&&D!==b.CharCode.Tab&&(D<32||D>126)&&(m=!1)}const d=new R(a(h),t,c,l,m);return h.length=0,d}class E{constructor(i,r,t,c,l){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=c,this.length=l}}e.$iD=E;class f{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$jD=f;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==A.$4C&&i.iterate(i.root,t=>(t!==A.$4C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let c=0;c<t.length;c++){const l=t[c];if(l.node.parent===null||l.nodeStartOffset>=i){t[c]=null,r=!0;continue}}if(r){const c=[];for(const l of t)l!==null&&c.push(l);this.b=c}}}class o{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new f("",[0])],this.g={line:0,column:0},this.root=A.$4C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let c=null;for(let l=0,m=i.length;l<m;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=y(i[l].buffer));const d=new E(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),c=this.S(c,d)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=p,t=r-Math.floor(r/3),c=t*2;let l="",m=0;const d=[];if(this.iterate(this.root,$=>{const I=this.R($),D=I.length;if(m<=t||m+D<c)return l+=I,m+=D,!0;const v=l.replace(/\r\n|\r|\n/g,i);return d.push(new f(v,y(v))),l=I,m=D,!0}),m>0){const $=l.replace(/\r\n|\r|\n/g,i);d.push(new f($,y($)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,c=>{if(c===A.$4C)return!0;const l=this.R(c),m=l.length,d=i.G(r),$=i.G(r+m),I=i.getValueInRange2(d,$);return r+=m,l===I})}getOffsetAt(i,r){let t=0,c=this.root;for(;c!==A.$4C;)if(c.left!==A.$4C&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){t+=c.size_left;const l=this.B(c,i-c.lf_left-2);return t+=l+r-1}else i-=c.lf_left+c.piece.lineFeedCnt,t+=c.size_left+c.piece.length,c=c.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const c=i;for(;r!==A.$4C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const l=this.A(r,i-r.size_left);if(t+=r.lf_left+l.index,l.index===0){const m=this.getOffsetAt(t+1,1),d=c-m;return new S.$Kt(t+1,d+1)}return new S.$Kt(t+1,l.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.$4C){const l=this.getOffsetAt(t+1,1),m=c-i-l;return new S.$Kt(t+1,m+1)}else r=r.right;return new S.$Kt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,c);return r?r!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,r):l}getValueInRange2(i,r){if(i.node===r.node){const d=i.node,$=this.a[d.piece.bufferIndex].buffer,I=this.u(d.piece.bufferIndex,d.piece.start);return $.substring(I+i.remainder,I+r.remainder)}let t=i.node;const c=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let m=c.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==A.$4C;){const d=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){m+=d.substring($,$+r.remainder);break}else m+=d.substr($,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let r=0,t="",c=!1;return this.iterate(this.root,l=>{if(l===A.$4C)return!0;const m=l.piece;let d=m.length;if(d===0)return!0;const $=this.a[m.bufferIndex].buffer,I=this.a[m.bufferIndex].lineStarts,D=m.start.line,v=m.end.line;let C=I[D]+m.start.column;if(c&&($.charCodeAt(C)===b.CharCode.LineFeed&&(C++,d--),i[r++]=t,t="",c=!1,d===0))return!0;if(D===v)return!this.f&&$.charCodeAt(C+d-1)===b.CharCode.CarriageReturn?(c=!0,t+=$.substr(C,d-1)):t+=$.substr(C,d),!0;t+=this.f?$.substring(C,Math.max(C,I[D+1]-this.e)):$.substring(C,I[D+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let P=D+1;P<v;P++)t=this.f?$.substring(I[P],I[P+1]-this.e):$.substring(I[P],I[P+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&$.charCodeAt(I[v]+m.end.column-1)===b.CharCode.CarriageReturn?(c=!0,m.end.column===0?r--:t=$.substr(I[v],m.end.column-1)):t=$.substr(I[v],m.end.column),!0}),c&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],c=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(c)}else{const r=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(c)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.$4C)return"";const c=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.substring(l,l+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],c=this.u(r.node.piece.bufferIndex,r.node.piece.start),l=c+r.remainder,m=c+r.node.piece.length;return t.buffer.substring(l,m)}}findMatchesInNode(i,r,t,c,l,m,d,$,I,D,v){const C=this.a[i.piece.bufferIndex],P=this.u(i.piece.bufferIndex,i.piece.start),g=this.u(i.piece.bufferIndex,l),w=this.u(i.piece.bufferIndex,m);let M;const N={line:0,column:0};let L,G;r._wordSeparators?(L=C.buffer.substring(g,w),G=B=>B+g,r.reset(0)):(L=C.buffer,G=B=>B,r.reset(g));do if(M=r.next(L),M){if(G(M.index)>=w)return D;this.s(i,G(M.index)-P,N);const B=this.t(i.piece.bufferIndex,l,N),F=N.line===l.line?N.column-l.column+c:N.column+1,V=F+M[0].length;if(v[D++]=(0,T.$cD)(new k.$Lt(t+B,F,t+B,V),M,$),G(M.index)+M[0].length>=w||D>=I)return D}while(M);return D}findMatchesLineByLine(i,r,t,c){const l=[];let m=0;const d=new T.$fD(r.wordSeparators,r.regex);let $=this.H(i.startLineNumber,i.startColumn);if($===null)return[];const I=this.H(i.endLineNumber,i.endColumn);if(I===null)return[];let D=this.s($.node,$.remainder);const v=this.s(I.node,I.remainder);if($.node===I.node)return this.findMatchesInNode($.node,d,i.startLineNumber,i.startColumn,D,v,r,t,c,m,l),l;let C=i.startLineNumber,P=$.node;for(;P!==I.node;){const w=this.t(P.piece.bufferIndex,D,P.piece.end);if(w>=1){const N=this.a[P.piece.bufferIndex].lineStarts,L=this.u(P.piece.bufferIndex,P.piece.start),G=N[D.line+w],B=C===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(P,d,C,B,D,this.s(P,G-L),r,t,c,m,l),m>=c)return l;C+=w}const M=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const N=this.getLineContent(C).substring(M,i.endColumn-1);return m=this.n(r,d,N,i.endLineNumber,M,m,l,t,c),l}if(m=this.n(r,d,this.getLineContent(C).substr(M),C,M,m,l,t,c),m>=c)return l;C++,$=this.H(C,1),P=$.node,D=this.s($.node,$.remainder)}if(C===i.endLineNumber){const w=C===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(C).substring(w,i.endColumn-1);return m=this.n(r,d,M,i.endLineNumber,w,m,l,t,c),l}const g=C===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(I.node,d,C,g,D,v,r,t,c,m,l),l}n(i,r,t,c,l,m,d,$,I){const D=i.wordSeparators;if(!$&&i.simpleSearch){const C=i.simpleSearch,P=C.length,g=t.length;let w=-P;for(;(w=t.indexOf(C,w+P))!==-1;)if((!D||(0,T.$eD)(D,t,g,w,P))&&(d[m++]=new O.$aw(new k.$Lt(c,w+1+l,c,w+1+P+l),null),m>=I))return m;return m}let v;r.reset(0);do if(v=r.next(t),v&&(d[m++]=(0,T.$cD)(new k.$Lt(c,v.index+1+l,c,v.index+1+v[0].length+l),v,$),m>=I))return m;while(v);return m}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$4C){const{node:c,remainder:l,nodeStartOffset:m}=this.G(i),d=c.piece,$=d.bufferIndex,I=this.s(c,l);if(c.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&m+d.length===i&&r.length<p){this.F(c,r),this.y();return}if(m===i)this.o(r,c),this.h.validate(i);else if(m+c.piece.length>i){const D=[];let v=new E(d.bufferIndex,I,d.end,this.t(d.bufferIndex,I,d.end),this.u($,d.end)-this.u($,I));if(this.K()&&this.M(r)&&this.I(c,l)===10){const w={line:v.start.line+1,column:0};v=new E(v.bufferIndex,w,v.end,this.t(v.bufferIndex,w,v.end),v.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(c,l-1)===13){const w=this.s(c,l-1);this.C(c,w),r="\r"+r,c.piece.length===0&&D.push(c)}else this.C(c,I);else this.C(c,I);const C=this.w(r);v.length>0&&this.S(c,v);let P=c;for(let g=0;g<C.length;g++)P=this.S(P,C[g]);this.v(D)}else this.q(r,c)}else{const c=this.w(r);let l=this.T(null,c[0]);for(let m=1;m<c.length;m++)l=this.S(l,c[m])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===A.$4C)return;const t=this.G(i),c=this.G(i+r),l=t.node,m=c.node;if(l===m){const C=this.s(l,t.remainder),P=this.s(l,c.remainder);if(t.nodeStartOffset===i){if(r===l.piece.length){const g=l.next();(0,A.$9C)(this,l),this.N(g),this.y();return}this.D(l,P),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+r){this.C(l,C),this.O(l),this.y();return}this.E(l,C,P),this.y();return}const d=[],$=this.s(l,t.remainder);this.C(l,$),this.h.validate(i),l.piece.length===0&&d.push(l);const I=this.s(m,c.remainder);this.D(m,I),m.piece.length===0&&d.push(m);const D=l.next();for(let C=D;C!==A.$4C&&C!==m;C=C.next())d.push(C);const v=l.piece.length===0?l.prev():l;this.v(d),this.O(v),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const m=r.piece,d={line:m.start.line+1,column:0},$=new E(m.bufferIndex,d,m.end,this.t(m.bufferIndex,d,m.end),m.length-1);r.piece=$,i+=`
`,(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const c=this.w(i);let l=this.T(r,c[c.length-1]);for(let m=c.length-2;m>=0;m--)l=this.T(l,c[m]);this.N(l),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),c=this.S(r,t[0]);let l=c;for(let m=1;m<t.length;m++)l=this.S(l,t[m]);this.N(c)}s(i,r,t){const c=i.piece,l=i.piece.bufferIndex,m=this.a[l].lineStarts,$=m[c.start.line]+c.start.column+r;let I=c.start.line,D=c.end.line,v=0,C=0,P=0;for(;I<=D&&(v=I+(D-I)/2|0,P=m[v],v!==D);)if(C=m[v+1],$<P)D=v-1;else if($>=C)I=v+1;else break;return t?(t.line=v,t.column=$-P,null):{line:v,column:$-P}}t(i,r,t){if(t.column===0)return t.line-r.line;const c=this.a[i].lineStarts;if(t.line===c.length-1)return t.line-r.line;const l=c[t.line+1],m=c[t.line]+t.column;if(l>m+1)return t.line-r.line;const d=m-1;return this.a[i].buffer.charCodeAt(d)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,A.$9C)(this,i[r])}w(i){if(i.length>p){const D=[];for(;i.length>p;){const C=i.charCodeAt(p-1);let P;C===b.CharCode.CarriageReturn||C>=55296&&C<=56319?(P=i.substring(0,p-1),i=i.substring(p-1)):(P=i.substring(0,p),i=i.substring(p));const g=y(P);D.push(new E(this.a.length,{line:0,column:0},{line:g.length-1,column:P.length-g[g.length-1]},g.length-1,P.length)),this.a.push(new f(P,g))}const v=y(i);return D.push(new E(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new f(i,v)),D}let r=this.a[0].buffer.length;const t=y(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let D=0;D<t.length;D++)t[D]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let D=0;D<t.length;D++)t[D]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,d=l-this.a[0].lineStarts[m],$={line:m,column:d},I=new E(0,c,$,this.t(0,c,$),l-r);return this.g=$,[I]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,c="";const l=this.h.get2(i);if(l){t=l.node;const m=this.B(t,i-l.nodeStartLineNumber-1),d=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)c=d.substring($+m,$+t.piece.length);else{const I=this.B(t,i-l.nodeStartLineNumber);return d.substring($+m,$+I-r)}}else{let m=0;const d=i;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const $=this.B(t,i-t.lf_left-2),I=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,v=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:d-(i-1-t.lf_left)}),D.substring(v+$,v+I-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const $=this.B(t,i-t.lf_left-2),I=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);c=I.substring(D+$,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$4C;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const d=this.B(t,0),$=this.u(t.piece.bufferIndex,t.piece.start);return c+=m.substring($,$+d-r),c}else{const d=this.u(t.piece.bufferIndex,t.piece.start);c+=m.substr(d,t.piece.length)}t=t.next()}return c}y(){let i=this.root,r=1,t=0;for(;i!==A.$4C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,c=this.s(i,r),l=c.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const m=this.t(i.piece.bufferIndex,t.start,c);if(m!==l)return{index:m,remainder:0}}return{index:l,remainder:c.column}}B(i,r){if(r<0)return 0;const t=i.piece,c=this.a[t.bufferIndex].lineStarts,l=t.start.line+r+1;return l>t.end.line?c[t.end.line]+t.end.column-c[t.start.line]-t.start.column:c[l]-c[t.start.line]-t.start.column}C(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),m=r,d=this.u(t.bufferIndex,m),$=this.t(t.bufferIndex,t.start,m),I=$-c,D=d-l,v=t.length+D;i.piece=new E(t.bufferIndex,t.start,m,$,v),(0,A.$$C)(this,i,D,I)}D(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),m=r,d=this.t(t.bufferIndex,m,t.end),$=this.u(t.bufferIndex,m),I=d-c,D=l-$,v=t.length+D;i.piece=new E(t.bufferIndex,m,t.end,d,v),(0,A.$$C)(this,i,D,I)}E(i,r,t){const c=i.piece,l=c.start,m=c.end,d=c.length,$=c.lineFeedCnt,I=r,D=this.t(c.bufferIndex,c.start,I),v=this.u(c.bufferIndex,r)-this.u(c.bufferIndex,l);i.piece=new E(c.bufferIndex,c.start,I,D,v),(0,A.$$C)(this,i,v-d,D-$);const C=new E(c.bufferIndex,t,m,this.t(c.bufferIndex,t,m),this.u(c.bufferIndex,m)-this.u(c.bufferIndex,t)),P=this.S(i,C);this.N(P)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=r;const l=y(r,!1);for(let P=0;P<l.length;P++)l[P]+=c;if(t){const P=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-P}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const m=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[m],$={line:m,column:d},I=i.piece.length+r.length,D=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,$),C=v-D;i.piece=new E(i.piece.bufferIndex,i.piece.start,$,v,I),this.g=$,(0,A.$$C)(this,i,r.length,C)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let c=0;for(;r!==A.$4C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){c+=r.size_left;const l={node:r,remainder:i-r.size_left,nodeStartOffset:c};return this.h.set(l),l}else i-=r.size_left+r.piece.length,c+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,c=0;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return c+=t.size_left,{node:t,remainder:Math.min(l+r-1,m),nodeStartOffset:c}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+r-1<=t.piece.length)return{node:t,remainder:l+r-1,nodeStartOffset:c};r-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,c+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$4C;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(r-1,l),nodeStartOffset:m}}else if(t.piece.length>=r-1){const l=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:l}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(c)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$4C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,c=r.start.line,l=t[c]+r.start.column;return c===t.length-1||t[c+1]>l+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$4C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],c=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,l,d,m),(0,A.$$C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const $={line:r.piece.start.line+1,column:0},I=r.piece.length-1,D=this.t(r.piece.bufferIndex,$,r.piece.end);r.piece=new E(r.piece.bufferIndex,$,r.piece.end,D,I),(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r);const v=this.w(`\r
`);this.S(i,v[0]);for(let C=0;C<t.length;C++)(0,A.$9C)(this,t[C])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$9C)(this,t);else{const c=t.piece,l={line:c.start.line+1,column:0},m=c.length-1,d=this.t(c.bufferIndex,l,c.end);t.piece=new E(c.bufferIndex,l,c.end,d,m),(0,A.$$C)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.$4C)return r(A.$4C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===A.$4C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,c=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return r.buffer.substring(c,l)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,c)}S(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$4C)i.right=t,t.parent=i;else{const l=(0,A.$5C)(i.right);l.left=t,t.parent=l}return(0,A.$0C)(this,t),t}T(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$4C)i.left=t,t.parent=i;else{const c=(0,A.$6C)(i.left);c.right=t,t.parent=c}return(0,A.$0C)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$kD=o}),define(Ce[154],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_=e.$v_=void 0;class b{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$v_=b;class S{constructor(O){this.identifier=O}}e.$w_=S}),define(Ce[155],Ie([9,10]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(Ce[156],Ie([1,0,6,4,155]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=R,k=qe(k);class O extends S.$Wc{constructor(u,E="",f="",n=!0,s){super(),this.j=this.B(new b.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=f,this.z=n,this.D=s}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$kj=O;class A extends S.$Wc{constructor(){super(...arguments),this.f=this.B(new b.$me),this.onWillRun=this.f.event,this.m=this.B(new b.$me),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let f;try{await this.u(u,E)}catch(n){f=n}this.m.fire({action:u,error:f})}async u(u,E){await u.run(E)}}e.$lj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const f of u)f.length&&(E.length?E=[...E,new T,...f]:E=f);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=T;class p{get actions(){return this.a}constructor(u,E,f,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=n,this.a=f}async run(){}}e.$nj=p;class a extends O{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,k.localize(0,null),void 0,!1)}}e.$oj=a;function R(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(Ce[157],Ie([9,10]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ce[158],Ie([1,0,157]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=R,e.$3m=y;const S=60,k=S*60,O=k*24,A=O*7,T=O*30,p=O*365;function a(u,E,f,n){typeof u!="number"&&(u=u.getTime());const s=Math.round((new Date().getTime()-u)/1e3);if(s<-30)return(0,b.localize)(0,null,a(new Date().getTime()+s*1e3,!1));if(!n&&s<30)return(0,b.localize)(1,null);let o;return s<S?(o=s,E?o===1?f?(0,b.localize)(2,null,o):(0,b.localize)(3,null,o):f?(0,b.localize)(4,null,o):(0,b.localize)(5,null,o):o===1?f?(0,b.localize)(6,null,o):(0,b.localize)(7,null,o):f?(0,b.localize)(8,null,o):(0,b.localize)(9,null,o)):s<k?(o=Math.floor(s/S),E?o===1?f?(0,b.localize)(10,null,o):(0,b.localize)(11,null,o):f?(0,b.localize)(12,null,o):(0,b.localize)(13,null,o):o===1?f?(0,b.localize)(14,null,o):(0,b.localize)(15,null,o):f?(0,b.localize)(16,null,o):(0,b.localize)(17,null,o)):s<O?(o=Math.floor(s/k),E?o===1?f?(0,b.localize)(18,null,o):(0,b.localize)(19,null,o):f?(0,b.localize)(20,null,o):(0,b.localize)(21,null,o):o===1?f?(0,b.localize)(22,null,o):(0,b.localize)(23,null,o):f?(0,b.localize)(24,null,o):(0,b.localize)(25,null,o)):s<A?(o=Math.floor(s/O),E?o===1?(0,b.localize)(26,null,o):(0,b.localize)(27,null,o):o===1?(0,b.localize)(28,null,o):(0,b.localize)(29,null,o)):s<T?(o=Math.floor(s/A),E?o===1?f?(0,b.localize)(30,null,o):(0,b.localize)(31,null,o):f?(0,b.localize)(32,null,o):(0,b.localize)(33,null,o):o===1?f?(0,b.localize)(34,null,o):(0,b.localize)(35,null,o):f?(0,b.localize)(36,null,o):(0,b.localize)(37,null,o)):s<p?(o=Math.floor(s/T),E?o===1?f?(0,b.localize)(38,null,o):(0,b.localize)(39,null,o):f?(0,b.localize)(40,null,o):(0,b.localize)(41,null,o):o===1?f?(0,b.localize)(42,null,o):(0,b.localize)(43,null,o):f?(0,b.localize)(44,null,o):(0,b.localize)(45,null,o)):(o=Math.floor(s/p),E?o===1?f?(0,b.localize)(46,null,o):(0,b.localize)(47,null,o):f?(0,b.localize)(48,null,o):(0,b.localize)(49,null,o):o===1?f?(0,b.localize)(50,null,o):(0,b.localize)(51,null,o):f?(0,b.localize)(52,null,o):(0,b.localize)(53,null,o))}function R(u,E){const f=Math.abs(u/1e3);return f<1?E?(0,b.localize)(54,null,u):(0,b.localize)(55,null,u):f<S?E?(0,b.localize)(56,null,Math.round(u)/1e3):(0,b.localize)(57,null,Math.round(u)/1e3):f<k?E?(0,b.localize)(58,null,Math.round(u/(1e3*S))):(0,b.localize)(59,null,Math.round(u/(1e3*S))):f<O?E?(0,b.localize)(60,null,Math.round(u/(1e3*k))):(0,b.localize)(61,null,Math.round(u/(1e3*k))):(0,b.localize)(62,null,Math.round(u/(1e3*O)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[159],Ie([9,10]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ce[48],Ie([1,0,18,15,159]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=a,e.$sj=R,b=qe(b),S=qe(S),k=qe(k);function O(y,u){return u&&(y.stack||y.stacktrace)?k.localize(0,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function p(y=null,u=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const E=b.$Jb(y),f=p(E[0],u);return E.length>1?k.localize(4,null,f,E.length):f}if(S.$fg(y))return y;if(y.detail){const E=y.detail;if(E.error)return O(E.error,u);if(E.exception)return O(E.exception,u)}return y.stack?O(y,u):y.message?y.message:k.localize(5,null)}function a(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function R(y,u){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=u,E}}),define(Ce[160],Ie([1,0,47,20]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=T,e.$yr=p,e.$zr=a,e.$Ar=R,e.$Br=y,e.$Cr=u,e.$Dr=E,e.$Er=f,e.$Fr=n,e.$Gr=s,e.$Hr=$,e.$Ir=I,e.$Jr=D;const k=new b.$X(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),O=new b.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new b.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(v,C,P=!1){const g=v||"",w=C||"",M=k.value.collator.compare(g,w);return k.value.collatorIsNumeric&&M===0&&g!==w?g<w?-1:1:M}function p(v,C){const P=O.value.collator;return v=v||"",C=C||"",r(P,v,C)}function a(v,C){const P=O.value.collator;return v=v||"",C=C||"",m(v,C)||r(P,v,C)}function R(v,C){const P=O.value.collator;return v=v||"",C=C||"",l(v,C)||r(P,v,C)}function y(v,C){return v=v||"",C=C||"",v===C?0:v<C?-1:1}function u(v,C){const[P,g]=h(v),[w,M]=h(C);let N=k.value.collator.compare(g,M);if(N===0){if(k.value.collatorIsNumeric&&g!==M)return g<M?-1:1;if(N=k.value.collator.compare(P,w),k.value.collatorIsNumeric&&N===0&&P!==w)return P<w?-1:1}return N}function E(v,C){v=v||"",C=C||"";const P=i(v),g=i(C),w=O.value.collator,M=A.value.collator;return r(M,P,g)||r(w,v,C)}function f(v,C){v=v||"",C=C||"";const P=i(v),g=i(C),w=O.value.collator,M=A.value.collator;return r(M,P,g)||m(v,C)||r(w,v,C)}function n(v,C){v=v||"",C=C||"";const P=i(v),g=i(C),w=O.value.collator,M=A.value.collator;return r(M,P,g)||l(v,C)||r(w,v,C)}function s(v,C){v=v||"",C=C||"";const P=i(v).toLowerCase(),g=i(C).toLowerCase();return P!==g?P<g?-1:1:v!==C?v<C?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function h(v,C=!1){const P=v?o.exec(v):[];let g=[P&&P[1]||"",P&&P[3]||""];return C&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function i(v){const C=v?o.exec(v):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function r(v,C,P){const g=v.compare(C,P);return g!==0?g:C.length!==P.length?C.length<P.length?-1:1:0}function t(v){const C=v.charAt(0);return C.toLocaleUpperCase()!==C}function c(v){const C=v.charAt(0);return C.toLocaleLowerCase()!==C}function l(v,C){return t(v)&&c(C)?-1:c(v)&&t(C)?1:0}function m(v,C){return c(v)&&t(C)?-1:t(v)&&c(C)?1:0}function d(v,C,P=!1){return P||(v=v&&v.toLowerCase(),C=C&&C.toLowerCase()),v===C?0:v<C?-1:1}function $(v,C,P=!1){const g=v.split(S.sep),w=C.split(S.sep),M=g.length-1,N=w.length-1;let L,G;for(let B=0;;B++){if(L=M===B,G=N===B,L&&G)return T(g[B],w[B],P);if(L)return-1;if(G)return 1;const F=d(g[B],w[B],P);if(F!==0)return F}}function I(v,C,P){const g=v.toLowerCase(),w=C.toLowerCase(),M=D(v,C,P);if(M)return M;const N=g.endsWith(P),L=w.endsWith(P);if(N!==L)return N?-1:1;const G=T(g,w);return G!==0?G:g.localeCompare(w)}function D(v,C,P){const g=v.toLowerCase(),w=C.toLowerCase(),M=g.startsWith(P),N=w.startsWith(P);if(M!==N)return M?-1:1;if(M&&N){if(g.length<w.length)return-1;if(g.length>w.length)return 1}return 0}}),define(Ce[53],Ie([1,0,28,20,21,13,15]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=T,e.$yg=p,e.$zg=a,e.$Ag=R,e.$Bg=y,e.$Cg=n,e.$Dg=s,e.$Eg=o,e.$Fg=h,e.$Gg=i,e.$Hg=r,e.$Ig=t,e.$Jg=c,e.$Kg=l,e.$Lg=m,e.$Mg=d,e.$Ng=D;function T(v){return v===b.CharCode.Slash||v===b.CharCode.Backslash}function p(v){return v.replace(/[\\/]/g,S.$ic.sep)}function a(v){return v.indexOf("/")===-1&&(v=p(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function R(v,C=S.$ic.sep){if(!v)return"";const P=v.length,g=v.charCodeAt(0);if(T(g)){if(T(v.charCodeAt(1))&&!T(v.charCodeAt(2))){let M=3;const N=M;for(;M<P&&!T(v.charCodeAt(M));M++);if(N!==M&&!T(v.charCodeAt(M+1))){for(M+=1;M<P;M++)if(T(v.charCodeAt(M)))return v.slice(0,M+1).replace(/[\\/]/g,C)}}return C}else if(h(g)&&v.charCodeAt(1)===b.CharCode.Colon)return T(v.charCodeAt(2))?v.slice(0,2)+C:v.slice(0,2);let w=v.indexOf("://");if(w!==-1){for(w+=3;w<P;w++)if(T(v.charCodeAt(w)))return v.slice(0,w+1)}return""}function y(v){if(!k.$i||!v||v.length<5)return!1;let C=v.charCodeAt(0);if(C!==b.CharCode.Backslash||(C=v.charCodeAt(1),C!==b.CharCode.Backslash))return!1;let P=2;const g=P;for(;P<v.length&&(C=v.charCodeAt(P),C!==b.CharCode.Backslash);P++);return!(g===P||(C=v.charCodeAt(P+1),isNaN(C)||C===b.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,E=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(v,C=k.$i){const P=C?u:E;return!(!v||v.length===0||/^\s+$/.test(v)||(P.lastIndex=0,P.test(v))||C&&f.test(v)||v==="."||v===".."||C&&v[v.length-1]==="."||C&&v.length!==v.trim().length||v.length>255)}function s(v,C,P){const g=v===C;return!P||g?g:!v||!C?!1:(0,O.$Gf)(v,C)}function o(v,C,P,g=S.sep){if(v===C)return!0;if(!v||!C||C.length>v.length)return!1;if(P){if(!(0,O.$Hf)(v,C))return!1;if(C.length===v.length)return!0;let M=C.length;return C.charAt(C.length-1)===g&&M--,v.charAt(M)===g}return C.charAt(C.length-1)!==g&&(C+=g),v.indexOf(C)===0}function h(v){return v>=b.CharCode.A&&v<=b.CharCode.Z||v>=b.CharCode.a&&v<=b.CharCode.z}function i(v,C){return k.$i&&v.endsWith(":")&&(v+=S.sep),(0,S.$kc)(v)||(v=(0,S.$lc)(C,v)),v=(0,S.$jc)(v),r(v)}function r(v){return k.$i?(v=(0,O.$of)(v,S.sep),v.endsWith(":")&&(v+=S.sep)):(v=(0,O.$of)(v,S.sep),v||(v=S.sep)),v}function t(v){const C=(0,S.$jc)(v);return k.$i?v.length>3?!1:c(C)&&(v.length===2||C.charCodeAt(2)===b.CharCode.Backslash):C===S.$ic.sep}function c(v,C=k.$i){return C?h(v.charCodeAt(0))&&v.charCodeAt(1)===b.CharCode.Colon:!1}function l(v,C=k.$i){return c(v,C)?v[0]:void 0}function m(v,C,P){return C.length>v.length?-1:v===C?0:(P&&(v=v.toLowerCase(),C=C.toLowerCase()),v.indexOf(C))}function d(v){const C=v.split(":");let P,g,w;for(const M of C){const N=Number(M);(0,A.$jg)(N)?g===void 0?g=N:w===void 0&&(w=N):P=P?[P,M].join(":"):M}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:g!==void 0?g:void 0,column:w!==void 0?w:g!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(v,C,P=8){let g="";for(let M=0;M<P;M++){let N;M===0&&k.$i&&!C&&(P===3||P===4)?N=I:N=$,g+=N.charAt(Math.floor(Math.random()*N.length))}let w;return C?w=`${C}-${g}`:w=g,v?(0,S.$lc)(v,w):w}}),define(Ce[73],Ie([1,0,20]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=O,e.$0s=A,e.$$s=T,e.$_s=a,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const y=(0,b.$qc)(R),u=S[y.toLowerCase()];return u!==void 0?u:A(R)}function A(R){const y=(0,b.$qc)(R);return k[y.toLowerCase()]}function T(R){for(const y in k)if(k[y]===R)return y}const p=/^(.+)\/(.+?)(;.+)?$/;function a(R,y){const u=p.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:R}}),define(Ce[49],Ie([1,0,23,2,38]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=A,e.$ci=p;function O(a){return JSON.stringify(a,T)}function A(a){let R=JSON.parse(a);return R=p(R),R}function T(a,R){return R instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function p(a,R=0){if(!a||R>200)return a;if(typeof a=="object"){switch(a.$mid){case k.MarshalledId.Uri:return S.URI.revive(a);case k.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case k.MarshalledId.Date:return new Date(a.source)}if(a instanceof b.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let y=0;y<a.length;++y)a[y]=p(a[y],R+1);else for(const y in a)Object.hasOwnProperty.call(a,y)&&(a[y]=p(a[y],R+1))}return a}}),define(Ce[16],Ie([1,0,14,21,13,2,20]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=a,e.$Tg=y,b=qe(b),S=qe(S),A=qe(A);var T;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(f,n){return O.URI.isUri(f)?(0,k.$Gf)(f.scheme,n):(0,k.$Hf)(f,n+":")}function a(f,...n){return n.some(s=>p(f,s))}e.$Qg="vscode-tkn",e.$Rg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,s){this.f=y(n,s)}getServerRootPath(){return this.f}get g(){return A.$ic.join(this.f,T.vscodeRemoteResource)}set(n,s,o){this.a[n]=s,this.b[n]=o}setConnectionToken(n,s){this.c[n]=s}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return b.$3(t),n}const s=n.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const h=this.b[s],i=this.c[s];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Rg}=${encodeURIComponent(i)}`),O.URI.from({scheme:S.$o?this.d:T.vscodeRemoteResource,authority:`${o}:${h}`,path:this.g,query:r})}}e.$Sg=new R;function y(f,n){return A.$ic.join(n??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(n){const s=this.b(n,oe);return this.uriToBrowserUri(s)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Sg.rewrite(n):n.scheme===T.file&&(S.$m||S.$q===`${T.vscodeFileResource}://${u.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const s=this.b(n,oe);return this.uriToFileUri(s)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,s){return O.URI.isUri(n)?n:O.URI.parse(s.toUrl(n))}}e.$Zg=new u;var E;(function(f){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(n.get("3"));const s="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(s);if(t)return n.get(t)}f.getHeadersFromQuery=o;function h(i,r,t){if(!globalThis.crossOriginIsolated)return;const c=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,c):i[s]=c}f.addSearchParam=h})(E||(e.COI=E={}))}),define(Ce[24],Ie([1,0,28,53,16,20,21,13,2]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=a,e.$ph=y,e.$qh=E,S=qe(S),O=qe(O);function a(f){return(0,p.$yc)(f,!0)}class R{constructor(n){this.a=n}compare(n,s,o=!1){return n===s?0:(0,T.$zf)(this.getComparisonKey(n,o),this.getComparisonKey(s,o))}isEqual(n,s,o=!1){return n===s?!0:!n||!s?!1:this.getComparisonKey(n,o)===this.getComparisonKey(s,o)}getComparisonKey(n,s=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,s,o=!1){if(n.scheme===s.scheme){if(n.scheme===k.Schemas.file)return S.$Eg(a(n),a(s),this.a(n))&&n.query===s.query&&(o||n.fragment===s.fragment);if((0,e.$lh)(n.authority,s.authority))return S.$Eg(n.path,s.path,this.a(n),"/")&&n.query===s.query&&(o||n.fragment===s.fragment)}return!1}joinPath(n,...s){return p.URI.joinPath(n,...s)}basenameOrAuthority(n){return(0,e.$dh)(n)||n.authority}basename(n){return O.$ic.basename(n.path)}extname(n){return O.$ic.extname(n.path)}dirname(n){if(n.path.length===0)return n;let s;return n.scheme===k.Schemas.file?s=p.URI.file(O.$oc(a(n))).path:(s=O.$ic.dirname(n.path),n.authority&&s.length&&s.charCodeAt(0)!==b.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),s="/")),n.with({path:s})}normalizePath(n){if(!n.path.length)return n;let s;return n.scheme===k.Schemas.file?s=p.URI.file(O.$jc(a(n))).path:s=O.$ic.normalize(n.path),n.with({path:s})}relativePath(n,s){if(n.scheme!==s.scheme||!(0,e.$lh)(n.authority,s.authority))return;if(n.scheme===k.Schemas.file){const i=O.$nc(a(n),a(s));return A.$i?S.$yg(i):i}let o=n.path||"/";const h=s.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(o.length,h.length);i<r&&!(o.charCodeAt(i)!==h.charCodeAt(i)&&o.charAt(i).toLowerCase()!==h.charAt(i).toLowerCase());i++);o=h.substr(0,i)+o.substr(i)}return O.$ic.relative(o,h)}resolvePath(n,s){if(n.scheme===k.Schemas.file){const o=p.URI.file(O.$mc(a(n),s));return n.with({authority:o.authority,path:o.path})}return s=S.$zg(s),n.with({path:O.$ic.resolve(n.path,s)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,s){return n===s||n!==void 0&&s!==void 0&&(0,T.$Gf)(n,s)}hasTrailingPathSeparator(n,s=O.sep){if(n.scheme===k.Schemas.file){const o=a(n);return o.length>S.$Ag(o).length&&o[o.length-1]===s}else{const o=n.path;return o.length>1&&o.charCodeAt(o.length-1)===b.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,s=O.sep){return(0,e.$mh)(n,s)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,s=O.sep){let o=!1;if(n.scheme===k.Schemas.file){const h=a(n);o=h!==void 0&&h.length===S.$Ag(h).length&&h[h.length-1]===s}else{s="/";const h=n.path;o=h.length===1&&h.charCodeAt(h.length-1)===b.CharCode.Slash}return!o&&!(0,e.$mh)(n,s)?n.with({path:n.path+"/"}):n}}e.$8g=R,e.$9g=new R(()=>!1),e.$0g=new R(f=>f.scheme===k.Schemas.file?!A.$k:!0),e.$$g=new R(f=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function y(f,n){const s=[];for(let o=0;o<f.length;o++){const h=n(f[o]);f.some((i,r)=>r===o?!1:(0,e.$ah)(h,n(i)))||s.push(f[o])}return s}var u;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function n(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,c]=r.split(":");t&&c&&o.set(t,c)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&o.set(f.META_DATA_MIME,i),o}f.parseMetaData=n})(u||(e.DataUri=u={}));function E(f,n,s){if(n){let o=f.path;return o&&o[0]!==O.$ic.sep&&(o=O.$ic.sep+o),f.with({scheme:s,authority:n,path:o})}return f.with({scheme:s})}}),define(Ce[11],Ie([1,0,22,14,6,4,24,21,146,47]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=R,e.$sh=y,e.$th=u,e.$uh=E,e.$vh=f,e.$wh=n,e.$xh=s,e.$yh=o,e.$Gh=I,e.$Hh=D,e.$Ih=v,e.$Jh=C,e.$Kh=P,e.$Zh=ge,e.$8h=ue;function R(de){return!!de&&typeof de.then=="function"}function y(de){const X=new b.$xe,Z=de(X.token),me=new Promise((pe,Oe)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Oe(new S.$7)});Promise.resolve(Z).then(ke=>{ze.dispose(),X.dispose(),pe(ke)},ke=>{ze.dispose(),X.dispose(),Oe(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,Oe){return me.then(pe,Oe)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}function u(de,X,Z){return new Promise((me,pe)=>{const Oe=X.onCancellationRequested(()=>{Oe.dispose(),me(Z)});de.then(me,pe).finally(()=>Oe.dispose())})}function E(de,X){return new Promise((Z,me)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),me(new S.$7)});de.then(Z,me).finally(()=>pe.dispose())})}async function f(de){let X=-1;const Z=de.map((me,pe)=>me.then(Oe=>(X=pe,Oe)));try{return await Promise.race(Z)}finally{de.forEach((me,pe)=>{pe!==X&&me.cancel()})}}function n(de,X,Z){let me;const pe=setTimeout(()=>{me?.(void 0),Z?.()},X);return Promise.race([de.finally(()=>clearTimeout(pe)),new Promise(Oe=>me=Oe)])}function s(de){return new Promise((X,Z)=>{const me=de();R(me)?me.then(X,Z):X(me)})}function o(){let de,X;return{promise:new Promise((me,pe)=>{de=me,X=pe}),resolve:de,reject:X}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const Z=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(Z,Z).then(me)})}return new Promise((Z,me)=>{this.b.then(Z,me)})}return this.a=X(),new Promise((Z,me)=>{this.a.then(pe=>{this.a=null,Z(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$zh=h;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=i;class r{constructor(){this.a=new Map}queue(X,Z){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$Bh=r;const t=(de,X)=>{let Z=!0;const me=setTimeout(()=>{Z=!1,X()},de);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(me),Z=!1}}},c=de=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,de())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class l{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,Z=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,Oe)=>{this.d=pe,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=Z===p.$he?c(me):t(Z,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=l;class m{constructor(X){this.a=new l(X),this.b=new h}trigger(X,Z){return this.a.trigger(()=>this.b.queue(X),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=m;class d{constructor(){this.a=!1,this.b=new Promise((X,Z)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=d;class $ extends d{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=$;function I(de,X){return X?new Promise((Z,me)=>{const pe=setTimeout(()=>{Oe.dispose(),Z()},de),Oe=X.onCancellationRequested(()=>{clearTimeout(pe),Oe.dispose(),me(new S.$7)})}):y(Z=>I(de,Z))}function D(de,X=0,Z){const me=setTimeout(()=>{de(),Z&&pe.dispose()},X),pe=(0,O.$Uc)(()=>{clearTimeout(me),Z?.deleteAndLeak(pe)});return Z?.add(pe),pe}function v(de){const X=[];let Z=0;const me=de.length;function pe(){return Z<me?de[Z++]():null}function Oe(ze){ze!=null&&X.push(ze);const ke=pe();return ke?ke.then(Oe):Promise.resolve(X)}return Promise.resolve(null).then(Oe)}function C(de,X=me=>!!me,Z=null){let me=0;const pe=de.length,Oe=()=>{if(me>=pe)return Promise.resolve(Z);const ze=de[me++];return Promise.resolve(ze()).then(Ae=>X(Ae)?Promise.resolve(Ae):Oe())};return Oe()}function P(de,X=me=>!!me,Z=null){if(de.length===0)return Promise.resolve(Z);let me=de.length;const pe=()=>{me=-1;for(const Oe of de)Oe.cancel?.()};return new Promise((Oe,ze)=>{for(const ke of de)ke.then(Ae=>{--me>=0&&X(Ae)?(pe(),Oe(Ae)):me===0&&Oe(Z)}).catch(Ae=>{--me>=0&&(pe(),ze(Ae))})})}class g{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new k.$me}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,me)=>{this.g.push({factory:X,c:Z,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const Z=X.factory();Z.then(X.c,X.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=g;class w extends g{constructor(){super(1)}}e.$Mh=w;class M{constructor(){this.a=new se,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=M;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new re;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,Z=A.$9g){const me=Z.getComparisonKey(X);return this.a.get(me)?.size??0}queueFor(X,Z,me=A.$9g){const pe=me.getComparisonKey(X);let Oe=this.a.get(pe);if(!Oe){Oe=new w;const ze=this.f++,ke=k.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$6c),this.d.set(ze,ke),this.a.set(pe,Oe)}return Oe.queue(Z)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=N;class L{constructor(X,Z){this.b=!1,this.a=-1,typeof X=="function"&&typeof Z=="number"&&this.setIfNotSet(X,Z)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,Z){if(this.b)throw new S.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},Z)}setIfNotSet(X,Z){if(this.b)throw new S.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},Z))}}e.$Ph=L;class G{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,Z,me=globalThis){if(this.f)throw new S.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=me.setInterval(()=>{X()},Z);this.d=(0,O.$Uc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=G;class B{constructor(X,Z){this.b=-1,this.a=X,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=B;class F{constructor(X,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=X,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class V extends B{constructor(X,Z){super(X,Z),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=V;class ae extends O.$Wc{constructor(X,Z){super(),this.g=X,this.h=Z,this.a=[],this.b=this.B(new O.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of X)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=ae,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(de,X)=>{(0,T.$B)(()=>{if(Z)return;const me=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$Wh=(de,X,Z)=>{const me=de.requestIdleCallback(X,typeof Z=="number"?{timeout:Z}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,de.cancelIdleCallback(me))}}},e.$Vh=de=>(0,e.$Wh)(globalThis,de)}();class $e{constructor(X,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=$e;class _ extends $e{constructor(X){super(globalThis,X)}}e.$Yh=_;async function ge(de,X,Z){let me;for(let pe=0;pe<Z;pe++)try{return await de()}catch(Oe){me=Oe,await I(X)}throw me}class se{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,Z,me){return this.a={taskId:X,cancel:()=>me?.(),promise:Z},Z.then(()=>this.d(X),()=>this.d(X)),Z}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:Z,resolve:me,reject:pe}=o();this.b={run:X,promise:Z,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=se;class ce{constructor(X,Z=()=>Date.now()){this.d=X,this.f=Z,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=ce;var we;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(we||(we={}));class re{get isRejected(){return this.d?.outcome===we.Rejected}get isResolved(){return this.d?.outcome===we.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===we.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,Z)=>{this.a=X,this.b=Z})}complete(X){return new Promise(Z=>{this.a(X),this.d={outcome:we.Resolved,value:X},Z()})}error(X){return new Promise(Z=>{this.b(X),this.d={outcome:we.Rejected,value:X},Z()})}cancel(){return this.error(new S.$7)}}e.$3h=re;var Pe;(function(de){async function X(me){let pe;const Oe=await Promise.all(me.map(ze=>ze.then(ke=>ke,ke=>{pe||(pe=ke)})));if(typeof pe<"u")throw pe;return Oe}de.settled=X;function Z(me){return new Promise(async(pe,Oe)=>{try{await me(pe,Oe)}catch(ze){Oe(ze)}})}de.withAsyncBody=Z})(Pe||(e.Promises=Pe={}));class Me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new S.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=Me;class Y{constructor(X){this.b=X,this.a=new a.$X(()=>new Me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=Y;var q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(q||(q={}));class ee{static fromArray(X){return new ee(Z=>{Z.emitMany(X)})}static fromPromise(X){return new ee(async Z=>{Z.emitMany(await X)})}static fromPromises(X){return new ee(async Z=>{await Promise.all(X.map(async me=>Z.emitOne(await me)))})}static merge(X){return new ee(async Z=>{await Promise.all(X.map(async me=>{for await(const pe of me)Z.emitOne(pe)}))})}static{this.EMPTY=ee.fromArray([])}constructor(X,Z){this.a=q.Initial,this.b=[],this.d=null,this.f=Z,this.g=new k.$me,queueMicrotask(async()=>{const me={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X(me)),this.k()}catch(pe){this.l(pe)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,Z){return new ee(async me=>{for await(const pe of X)me.emitOne(Z(pe))})}map(X){return ee.map(this,X)}static filter(X,Z){return new ee(async me=>{for await(const pe of X)Z(pe)&&me.emitOne(pe)})}filter(X){return ee.filter(this,X)}static coalesce(X){return ee.filter(X,Z=>!!Z)}coalesce(){return ee.coalesce(this)}static async toPromise(X){const Z=[];for await(const me of X)Z.push(me);return Z}toPromise(){return ee.toPromise(this)}h(X){this.a===q.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===q.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(X){this.a===q.Initial&&(this.a=q.DoneError,this.d=X,this.g.fire())}}e.$6h=ee;class ve extends ee{constructor(X,Z){super(Z),this.m=X}cancel(){this.m.cancel()}}e.$7h=ve;function ue(de){const X=new b.$xe,Z=de(X.token);return new ve(X,async me=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),me.reject(new S.$7)});try{for await(const Oe of Z){if(X.token.isCancellationRequested)return;me.emitOne(Oe)}pe.dispose(),X.dispose()}catch(Oe){pe.dispose(),X.dispose(),me.reject(Oe)}})}class be{constructor(X){this.a=new re,this.b=new ee(pe=>{if(Z){pe.reject(Z);return}return me&&pe.emitMany(me),this.d=Oe=>pe.reject(Oe),this.f=Oe=>pe.emitOne(Oe),this.a.p},X);let Z,me;this.f=pe=>{me||(me=[]),me.push(pe)},this.d=pe=>{Z||(Z=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=be}),define(Ce[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=R,e.$xk=n,e.$yk=M,e.$zk=N,e.$Ak=L,e.$Bk=G,e.$Ck=B,e.$Dk=$e;function R(){return Object.create(null)}e.$vk="**",e.$wk="/";const y="[/\\\\]",u="[^/\\\\]",E=/\//g;function f(_,ge){switch(_){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${ge?`|${y}${u}+`:""})*?`}}function n(_,ge){if(!_)return[];const se=[];let ce=!1,we=!1,re="";for(const Pe of _){switch(Pe){case ge:if(!ce&&!we){se.push(re),re="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":we=!0;break;case"]":we=!1;break}re+=Pe}return re&&se.push(re),se}function s(_){if(!_)return"";let ge="";const se=n(_,e.$wk);if(se.every(ce=>ce===e.$vk))ge=".*";else{let ce=!1;se.forEach((we,re)=>{if(we===e.$vk){if(ce)return;ge+=f(2,re===se.length-1)}else{let Pe=!1,Me="",Y=!1,q="";for(const ee of we){if(ee!=="}"&&Pe){Me+=ee;continue}if(Y&&(ee!=="]"||!q)){let ve;ee==="-"?ve=ee:(ee==="^"||ee==="!")&&!q?ve="^":ee===e.$wk?ve="":ve=(0,a.$if)(ee),q+=ve;continue}switch(ee){case"{":Pe=!0;continue;case"[":Y=!0;continue;case"}":{const ue=`(?:${n(Me,",").map(be=>s(be)).join("|")})`;ge+=ue,Pe=!1,Me="";break}case"]":{ge+="["+q+"]",Y=!1,q="";break}case"?":ge+=u;continue;case"*":ge+=f(1);continue;default:ge+=(0,a.$if)(ee)}}re<se.length-1&&(se[re+1]!==e.$vk||re+2<se.length)&&(ge+=y)}ce=we===e.$vk})}return ge}const o=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new A.$Fc(1e4),m=function(){return!1},d=function(){return null};function $(_,ge){if(!_)return d;let se;typeof _!="string"?se=_.pattern:se=_,se=se.trim();const ce=`${se}_${!!ge.trimForExclusions}`;let we=l.get(ce);if(we)return I(we,_);let re;return o.test(se)?we=v(se.substr(4),se):(re=h.exec(D(se,ge)))?we=C(re[1],se):(ge.trimForExclusions?r:i).test(se)?we=P(se,ge):(re=t.exec(D(se,ge)))?we=g(re[1].substr(1),se,!0):(re=c.exec(D(se,ge)))?we=g(re[1],se,!1):we=w(se),l.set(ce,we),I(we,_)}function I(_,ge){if(typeof ge=="string")return _;const se=function(ce,we){return(0,O.$Eg)(ce,ge.base,!p.$k)?_((0,a.$nf)(ce.substr(ge.base.length),T.sep),we):null};return se.allBasenames=_.allBasenames,se.allPaths=_.allPaths,se.basenames=_.basenames,se.patterns=_.patterns,se}function D(_,ge){return ge.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function v(_,ge){return function(se,ce){return typeof se=="string"&&se.endsWith(_)?ge:null}}function C(_,ge){const se=`/${_}`,ce=`\\${_}`,we=function(Pe,Me){return typeof Pe!="string"?null:Me?Me===_?ge:null:Pe===_||Pe.endsWith(se)||Pe.endsWith(ce)?ge:null},re=[_];return we.basenames=re,we.patterns=[ge],we.allBasenames=re,we}function P(_,ge){const se=ae(_.slice(1,-1).split(",").map(Me=>$(Me,ge)).filter(Me=>Me!==d),_),ce=se.length;if(!ce)return d;if(ce===1)return se[0];const we=function(Me,Y){for(let q=0,ee=se.length;q<ee;q++)if(se[q](Me,Y))return _;return null},re=se.find(Me=>!!Me.allBasenames);re&&(we.allBasenames=re.allBasenames);const Pe=se.reduce((Me,Y)=>Y.allPaths?Me.concat(Y.allPaths):Me,[]);return Pe.length&&(we.allPaths=Pe),we}function g(_,ge,se){const ce=T.sep===T.$ic.sep,we=ce?_:_.replace(E,T.sep),re=T.sep+we,Pe=T.$ic.sep+_;let Me;return se?Me=function(Y,q){return typeof Y=="string"&&(Y===we||Y.endsWith(re)||!ce&&(Y===_||Y.endsWith(Pe)))?ge:null}:Me=function(Y,q){return typeof Y=="string"&&(Y===we||!ce&&Y===_)?ge:null},Me.allPaths=[(se?"*/":"./")+_],Me}function w(_){try{const ge=new RegExp(`^${s(_)}$`);return function(se){return ge.lastIndex=0,typeof se=="string"&&ge.test(se)?_:null}}catch{return d}}function M(_,ge,se){return!_||typeof ge!="string"?!1:N(_)(ge,void 0,se)}function N(_,ge={}){if(!_)return m;if(typeof _=="string"||L(_)){const se=$(_,ge);if(se===d)return m;const ce=function(we,re){return!!se(we,re)};return se.allBasenames&&(ce.allBasenames=se.allBasenames),se.allPaths&&(ce.allPaths=se.allPaths),ce}return F(_,ge)}function L(_){const ge=_;return ge?typeof ge.base=="string"&&typeof ge.pattern=="string":!1}function G(_){return _.allBasenames||[]}function B(_){return _.allPaths||[]}function F(_,ge){const se=ae(Object.getOwnPropertyNames(_).map(Me=>V(Me,_[Me],ge)).filter(Me=>Me!==d)),ce=se.length;if(!ce)return d;if(!se.some(Me=>!!Me.requiresSiblings)){if(ce===1)return se[0];const Me=function(ee,ve){let ue;for(let be=0,de=se.length;be<de;be++){const X=se[be](ee,ve);if(typeof X=="string")return X;(0,S.$rh)(X)&&(ue||(ue=[]),ue.push(X))}return ue?(async()=>{for(const be of ue){const de=await be;if(typeof de=="string")return de}return null})():null},Y=se.find(ee=>!!ee.allBasenames);Y&&(Me.allBasenames=Y.allBasenames);const q=se.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return q.length&&(Me.allPaths=q),Me}const we=function(Me,Y,q){let ee,ve;for(let ue=0,be=se.length;ue<be;ue++){const de=se[ue];de.requiresSiblings&&q&&(Y||(Y=(0,T.$pc)(Me)),ee||(ee=Y.substr(0,Y.length-(0,T.$qc)(Me).length)));const X=de(Me,Y,ee,q);if(typeof X=="string")return X;(0,S.$rh)(X)&&(ve||(ve=[]),ve.push(X))}return ve?(async()=>{for(const ue of ve){const be=await ue;if(typeof be=="string")return be}return null})():null},re=se.find(Me=>!!Me.allBasenames);re&&(we.allBasenames=re.allBasenames);const Pe=se.reduce((Me,Y)=>Y.allPaths?Me.concat(Y.allPaths):Me,[]);return Pe.length&&(we.allPaths=Pe),we}function V(_,ge,se){if(ge===!1)return d;const ce=$(_,se);if(ce===d)return d;if(typeof ge=="boolean")return ce;if(ge){const we=ge.when;if(typeof we=="string"){const re=(Pe,Me,Y,q)=>{if(!q||!ce(Pe,Me))return null;const ee=we.replace("$(basename)",()=>Y),ve=q(ee);return(0,S.$rh)(ve)?ve.then(ue=>ue?_:null):ve?_:null};return re.requiresSiblings=!0,re}}return ce}function ae(_,ge){const se=_.filter(Me=>!!Me.basenames);if(se.length<2)return _;const ce=se.reduce((Me,Y)=>{const q=Y.basenames;return q?Me.concat(q):Me},[]);let we;if(ge){we=[];for(let Me=0,Y=ce.length;Me<Y;Me++)we.push(ge)}else we=se.reduce((Me,Y)=>{const q=Y.patterns;return q?Me.concat(q):Me},[]);const re=function(Me,Y){if(typeof Me!="string")return null;if(!Y){let ee;for(ee=Me.length;ee>0;ee--){const ve=Me.charCodeAt(ee-1);if(ve===k.CharCode.Slash||ve===k.CharCode.Backslash)break}Y=Me.substr(ee)}const q=ce.indexOf(Y);return q!==-1?we[q]:null};re.basenames=ce,re.patterns=we,re.allBasenames=ce;const Pe=_.filter(Me=>!Me.basenames);return Pe.push(re),Pe}function $e(_,ge){return(0,b.$wb)(_,ge,(se,ce)=>typeof se=="string"&&typeof ce=="string"?se===ce:typeof se!="string"&&typeof ce!="string"?se.base===ce.base&&se.pattern===ce.pattern:!1)}}),define(Ce[60],Ie([1,0,14,99,24,13,2]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=a,e.$5k=R,e.$6k=y,e.$7k=u,e.$8k=E,e.$9k=f,e.$0k=n,e.$$k=s;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(h="",i=!1){if(this.value=h,typeof this.value!="string")throw(0,b.$9)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(h,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,S.$Wk)(h):h).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,i){return this.value+=`
${E(i,h)}
`,this}appendLink(h,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(h),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(h,i){const r=new RegExp((0,O.$if)(i),"g");return h.replace(r,(t,c)=>h.charAt(c-1)!=="\\"?`\\${t}`:t)}}e.$3k=p;function a(o){return R(o)?!o.value:Array.isArray(o)?o.every(a):!0}function R(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function y(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons&&o.supportHtml===h.supportHtml&&(o.baseUri===h.baseUri||!!o.baseUri&&!!h.baseUri&&(0,k.$_g)(A.URI.from(o.baseUri),A.URI.from(h.baseUri)))}function u(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(o,h){const i=o.match(/^`+/gm)?.reduce((t,c)=>t.length>c.length?t:c).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${h}`,o,`${"`".repeat(r)}`].join(`
`)}function f(o){return o.replace(/"/g,"&quot;")}function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const h=[],i=o.split("|").map(t=>t.trim());o=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),l=t?t[1]:"",m=c?c[1]:"",d=isFinite(parseInt(m)),$=isFinite(parseInt(l));d&&h.push(`width="${m}"`),$&&h.push(`height="${l}"`)}return{href:o,dimensions:h}}}),define(Ce[103],Ie([1,0,18,53,20,21,24,13]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=p,e.$Ww=R,e.$Xw=u,e.$Yw=E,e.$Zw=o,e.$1w=i,e.$2w=r,e.$3w=t,e.$4w=c,e.$5w=l;function p(d,$){const{os:I,tildify:D,relative:v}=$;if(v){const g=a(d,v,I);if(typeof g=="string")return g}let C=d.fsPath;if(I===O.OperatingSystem.Windows&&!O.$i?C=C.replace(/\//g,"\\"):I!==O.OperatingSystem.Windows&&O.$i&&(C=C.replace(/\\/g,"/")),I!==O.OperatingSystem.Windows&&D?.userHome){const g=D.userHome.fsPath;let w;d.scheme!==D.userHome.scheme&&d.path[0]===k.$ic.sep&&d.path[1]!==k.$ic.sep?w=D.userHome.with({path:d.path}).fsPath:w=C,C=u(w,g,I)}return(I===O.OperatingSystem.Windows?k.$hc:k.$ic).normalize(R(C,I===O.OperatingSystem.Windows))}function a(d,$,I){const D=I===O.OperatingSystem.Windows?k.$hc:k.$ic,v=I===O.OperatingSystem.Linux?A.$9g:A.$$g,C=$.getWorkspace(),P=(0,b.$Qb)(C.folders);if(!P)return;d.scheme!==P.uri.scheme&&d.path[0]===k.$ic.sep&&d.path[1]!==k.$ic.sep&&(d=P.uri.with({path:d.path}));const g=$.getWorkspaceFolder(d);if(!g)return;let w;if(v.isEqual(g.uri,d)?w="":w=v.relativePath(g.uri,d)??"",w&&(w=D.normalize(w)),C.folders.length>1&&!$.noPrefix){const M=g.name?g.name:v.basenameOrAuthority(g.uri);w=w?`${M} \u2022 ${w}`:M}return w}function R(d,$=O.$i){return(0,S.$Jg)(d,$)?d.charAt(0).toUpperCase()+d.slice(1):d}let y=Object.create(null);function u(d,$,I=O.OS){if(I===O.OperatingSystem.Windows||!d||!$)return d;let D=y.original===$?y.normalized:void 0;D||(D=$,O.$i&&(D=(0,S.$yg)(D)),D=`${(0,T.$of)(D,k.$ic.sep)}${k.$ic.sep}`,y={original:$,normalized:D});let v=d;return O.$i&&(v=(0,S.$yg)(v)),(I===O.OperatingSystem.Linux?v.startsWith(D):(0,T.$Hf)(v,D))?`~/${v.substr(D.length)}`:d}function E(d,$){return d.replace(/^~($|\/|\\)/,`${$}$1`)}const f="\u2026",n="\\\\",s="~";function o(d,$=k.sep){const I=new Array(d.length);let D=!1;for(let v=0;v<d.length;v++){const C=d[v];if(C===""){I[v]=`.${$}`;continue}if(!C){I[v]=C;continue}D=!0;let P="",g=C;g.indexOf(n)===0?(P=g.substr(0,g.indexOf(n)+n.length),g=g.substr(g.indexOf(n)+n.length)):g.indexOf($)===0?(P=g.substr(0,g.indexOf($)+$.length),g=g.substr(g.indexOf($)+$.length)):g.indexOf(s)===0&&(P=g.substr(0,g.indexOf(s)+s.length),g=g.substr(g.indexOf(s)+s.length));const w=g.split($);for(let M=1;D&&M<=w.length;M++)for(let N=w.length-M;D&&N>=0;N--){D=!1;let L=w.slice(N,N+M).join($);for(let G=0;!D&&G<d.length;G++)if(G!==v&&d[G]&&d[G].indexOf(L)>-1){const B=N+M===w.length,F=N>0&&d[G].indexOf($)>-1?$+L:L,V=d[G].endsWith(F);D=!B||V}if(!D){let G="";(w[0].endsWith(":")||P!=="")&&(N===1&&(N=0,M++,L=w[0]+$+L),N>0&&(G=w[0]+$),G=P+G),N>0&&(G=G+f+$),G=G+L,N+M<w.length&&(G=G+$+f),I[v]=G}}D&&(I[v]=C)}return I}var h;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function i(d,$=Object.create(null)){const I=[];let D=!1,v="";for(const C of d)if(C==="$"||D&&C==="{")v&&I.push({value:v,type:h.TEXT}),v="",D=!0;else if(C==="}"&&D){const P=$[v];if(typeof P=="string")P.length&&I.push({value:P,type:h.VARIABLE});else if(P){const g=I[I.length-1];(!g||g.type!==h.SEPARATOR)&&I.push({value:P.label,type:h.SEPARATOR})}v="",D=!1}else v+=C;return v&&!D&&I.push({value:v,type:h.TEXT}),I.filter((C,P)=>{if(C.type===h.SEPARATOR){const g=I[P-1],w=I[P+1];return[g,w].every(M=>M&&(M.type===h.VARIABLE||M.type===h.TEXT)&&M.value.length>0)}return!0}).map(C=>C.value).join("")}function r(d,$){return O.$j||$?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):d.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function t(d,$){return O.$j||$?d.replace(/\(&&\w\)|&&/g,""):O.$i?d.replace(/&&|&/g,I=>I==="&"?"&&":"&"):d.replace(/&&/g,"_")}function c(d){return d.replace(/&/g,"&&")}function l(d){if(d.endsWith("]")){const $=d.lastIndexOf(" [",d.length-2);if($!==-1){const I=m(d.substring(0,$)),D=d.substring($);return{name:I.name+D,parentPath:I.parentPath}}}return m(d)}function m(d){const $=d.indexOf("/")!==-1?k.$ic:k.$hc,I=$.basename(d),D=$.dirname(d);return I.length?{name:I,parentPath:D}:{name:D,parentPath:""}}}),define(Ce[161],Ie([1,0,23,38,2]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=p,e.$On=R,e.$Pn=y;function O(u){return u.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const f=this.a.transformIncoming(E);return f===E?E:O(k.URI.from(f))}transformOutgoing(E){const f=this.a.transformOutgoing(E);return f===E?E:O(k.URI.from(f))}transformOutgoingURI(E){const f=this.a.transformOutgoing(E);return f===E?E:k.URI.from(f)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Ln=A,e.$Mn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,E,f){if(!u||f>200)return null;if(typeof u=="object"){if(u instanceof k.URI)return E.transformOutgoing(u);for(const n in u)if(Object.hasOwnProperty.call(u,n)){const s=T(u[n],E,f+1);s!==null&&(u[n]=s)}}return null}function p(u,E){const f=T(u,E,0);return f===null?u:f}function a(u,E,f,n){if(!u||n>200)return null;if(typeof u=="object"){if(u.$mid===S.MarshalledId.Uri)return f?k.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof b.$Oe)return null;for(const s in u)if(Object.hasOwnProperty.call(u,s)){const o=a(u[s],E,f,n+1);o!==null&&(u[s]=o)}}return null}function R(u,E){const f=a(u,E,!1,0);return f===null?u:f}function y(u,E){const f=a(u,E,!0,0);return f===null?u:f}}),define(Ce[162],Ie([1,0,11,6,4,49,15]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=p;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var a;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(a||(e.StorageState=a={}));class R extends k.$Wc{static{this.a=100}constructor(E,f=Object.create(null)){super(),this.r=E,this.s=f,this.b=this.B(new S.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new b.$Dh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((f,n)=>this.w(n,f)),E.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(E,f){if(this.c===a.Closed)return;let n=!1;(0,A.$og)(f)?n=this.f.delete(E):this.f.get(E)!==f&&(this.f.set(E,f),n=!0),n&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,f){const n=this.f.get(E);return(0,A.$og)(n)?f:n}getBoolean(E,f){const n=this.get(E);return(0,A.$og)(n)?f:n==="true"}getNumber(E,f){const n=this.get(E);return(0,A.$og)(n)?f:parseInt(n,10)}getObject(E,f){const n=this.get(E);return(0,A.$og)(n)?f:(0,O.$bi)(n)}async set(E,f,n=!1){if(this.c===a.Closed)return;if((0,A.$og)(f))return this.delete(E,n);const s=(0,A.$hg)(f)||Array.isArray(f)?(0,O.$ai)(f):String(f);if(this.f.get(E)!==s)return this.f.set(E,s),this.j.set(E,s),this.h.delete(E),this.b.fire({key:E,external:n}),this.D()}async delete(E,f=!1){if(!(this.c===a.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:f}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===a.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$bq=R;class y{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((f,n)=>this.a.set(n,f)),E.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$cq=y}),define(Ce[163],Ie([1,0,13,21,23]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=void 0,e.$$t=R,e.$_t=y,b=qe(b),S=qe(S),k=qe(k);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let a;function R(){return a||(a=S.$D()?A():p()),a}function y(f,n,s){const o=new Uint16Array(f.buffer,n,s);return s>0&&(o[0]===65279||o[0]===65534)?u(f,n,s):A().decode(o)}function u(f,n,s){const o=[];let h=0;for(let i=0;i<s;i++){const r=k.$Qe(f,n);n+=2,o[h++]=String.fromCharCode(r)}return o.join("")}class E{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const s=this.a-this.d;s<=1&&(s===0||b.$Kf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const s=n.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=n;return}for(let o=0;o<s;o++)this.b[this.d++]=n.charCodeAt(o)}}e.$au=E}),define(Ce[164],Ie([1,0,23,163]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$cu=A,b=qe(b);function k(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,R,y,u){this.oldPosition=a,this.oldText=R,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${k(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${k(this.oldText)}")`:`(replace@${this.oldPosition} "${k(this.oldText)}" with "${k(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,R,y){const u=R.length;b.$Te(a,u,y),y+=4;for(let E=0;E<u;E++)b.$Re(a,R.charCodeAt(E),y),y+=2;return y}static d(a,R){const y=b.$Se(a,R);return R+=4,(0,S.$_t)(a,R,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(a,R){return b.$Te(a,this.oldPosition,R),R+=4,b.$Te(a,this.newPosition,R),R+=4,R=O.c(a,this.oldText,R),R=O.c(a,this.newText,R),R}static read(a,R,y){const u=b.$Se(a,R);R+=4;const E=b.$Se(a,R);R+=4;const f=O.d(a,R);R+=O.a(f);const n=O.d(a,R);return R+=O.a(n),y.push(new O(u,f,E,n)),R}}e.$bu=O;function A(p,a){return p===null||p.length===0?a:new T(p,a).compress()}class T{constructor(a,R){this.a=a,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,R=0,y=this.n(a),u=this.l(R);for(;a<this.f||R<this.h;){if(y===null){this.k(u),u=this.l(++R);continue}if(u===null){this.m(y),y=this.n(++a);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++R);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++a);continue}if(u.oldPosition<y.newPosition){const[o,h]=T.r(u,y.newPosition-u.oldPosition);this.k(o),u=h;continue}if(y.newPosition<u.oldPosition){const[o,h]=T.q(y,u.oldPosition-y.newPosition);this.m(o),y=h;continue}let n,s;if(u.oldEnd===y.newEnd)n=y,s=u,y=this.n(++a),u=this.l(++R);else if(u.oldEnd<y.newEnd){const[o,h]=T.q(y,u.oldLength);n=o,s=u,y=h,u=this.l(++R)}else{const[o,h]=T.r(u,y.newLength);n=y,s=o,y=this.n(++a),u=h}this.d[this.e++]=new O(n.oldPosition,n.oldText,s.newPosition,s.newText),this.g+=n.newLength-n.oldLength,this.j+=s.newLength-s.oldLength}const E=T.s(this.d);return T.t(E)}k(a){this.d[this.e++]=T.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=T.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,R){return new O(R.oldPosition-a,R.oldText,R.newPosition,R.newText)}static p(a,R){return new O(R.oldPosition,R.oldText,R.newPosition+a,R.newText)}static q(a,R){const y=a.newText.substr(0,R),u=a.newText.substr(R);return[new O(a.oldPosition,a.oldText,a.newPosition,y),new O(a.oldEnd,"",a.newPosition+R,u)]}static r(a,R){const y=a.oldText.substr(0,R),u=a.oldText.substr(R);return[new O(a.oldPosition,y,a.newPosition,a.newText),new O(a.oldPosition+R,u,a.newEnd,"")]}static s(a){if(a.length===0)return a;const R=[];let y=0,u=a[0];for(let E=1;E<a.length;E++){const f=a[E];u.oldEnd===f.oldPosition?u=new O(u.oldPosition,u.oldText+f.oldText,u.newPosition,u.newText+f.newText):(R[y++]=u,u=f)}return R[y++]=u,R}static t(a){if(a.length===0)return a;const R=[];let y=0;for(let u=0;u<a.length;u++){const E=a[u];E.oldText!==E.newText&&(R[y++]=E)}return R}}}),define(Ce[165],Ie([1,0,41,20]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=k,e.$tu=O;function k(A,T,p,a,R,y){if(Array.isArray(A)){let u=0;for(const E of A){const f=k(E,T,p,a,R,y);if(f===10)return f;f>u&&(u=f)}return u}else{if(typeof A=="string")return a?A==="*"?5:A===p?10:0:0;if(A){const{language:u,pattern:E,scheme:f,hasAccessToAllModels:n,notebookType:s}=A;if(!a&&!n)return 0;s&&R&&(T=R);let o=0;if(f)if(f===T.scheme)o=10;else if(f==="*")o=5;else return 0;if(u)if(u===p)o=10;else if(u==="*")o=Math.max(o,5);else return 0;if(s)if(s===y)o=10;else if(s==="*"&&y!==void 0)o=Math.max(o,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,S.$jc)(E.base)},h===T.fsPath||(0,b.$yk)(h,T.fsPath))o=10;else return 0}return o}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Ce[166],Ie([1,0,6,13,33,52,100,149,164,4]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=void 0,S=qe(S);class R extends a.$Wc{constructor(u,E,f,n,s,o,h){super(),this.m=this.B(new b.$me),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=n,this.h=s,this.c=new A.$kD(u,f,h)}equals(u){return!(u instanceof R)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const f=u+E,n=this.getPositionAt(u),s=this.getPositionAt(f);return new k.$Lt(n.lineNumber,n.column,s.lineNumber,s.column)}getValueInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const f=this.n(E);return this.c.getValueInRange(u,f)}getValueLengthInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const f=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let s=0;const o=this.n(E),h=this.getEOL();if(o.length!==h.length){const i=o.length-h.length,r=u.endLineNumber-u.startLineNumber;s=i*r}return n-f+s}getCharacterCountInRange(u,E=O.EndOfLinePreference.TextDefined){if(this.j){let f=0;const n=u.startLineNumber,s=u.endLineNumber;for(let o=n;o<=s;o++){const h=this.getLineContent(o),i=o===n?u.startColumn-1:0,r=o===s?u.endColumn-1:h.length;for(let t=i;t<r;t++)S.$Kf(h.charCodeAt(t))?(f=f+1,t=t+1):f=f+1}return f+=this.n(E).length*(s-n),f}return this.getValueLengthInRange(u,E)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=S.$vf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=S.$xf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,f){let n=this.g,s=this.h,o=this.j,h=!0,i=[];for(let $=0;$<u.length;$++){const I=u[$];h&&I._isTracked&&(h=!1);const D=I.range;if(I.text){let w=!0;o||(w=!S.$Vf(I.text),o=w),!n&&w&&(n=S.$Uf(I.text)),!s&&w&&(s=S.$Xf(I.text))}let v="",C=0,P=0,g=0;if(I.text){let w;[C,P,g,w]=(0,T.$vu)(I.text);const M=this.getEOL(),N=M===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;w===T.StringEOL.Unknown||w===N?v=I.text:v=I.text.replace(/\r\n|\r|\n/g,M)}i[$]={sortIndex:$,identifier:I.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:v,eolCount:C,firstLineLength:P,lastLineLength:g,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let $=0,I=i.length-1;$<I;$++){const D=i[$].range.getEndPosition(),v=i[$+1].range.getStartPosition();if(v.isBeforeOrEqual(D)){if(v.isBefore(D))throw new Error("Overlapping ranges are not allowed!");r=!0}}h&&(i=this.s(i));const t=f||E?R._getInverseEditRanges(i):[],c=[];if(E)for(let $=0;$<i.length;$++){const I=i[$],D=t[$];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let v=D.startLineNumber;v<=D.endLineNumber;v++){let C="";v===D.startLineNumber&&(C=this.getLineContent(I.range.startLineNumber),S.$vf(C)!==-1)||c.push({lineNumber:v,oldContent:C})}}let l=null;if(f){let $=0;l=[];for(let I=0;I<i.length;I++){const D=i[I],v=t[I],C=this.getValueInRange(D.range),P=D.rangeOffset+$;$+=D.text.length-C.length,l[I]={sortIndex:D.sortIndex,identifier:D.identifier,range:v,text:C,textChange:new p.$bu(D.rangeOffset,C,P,D.text)}}r||l.sort((I,D)=>I.sortIndex-D.sortIndex)}this.g=n,this.h=s,this.j=o;const m=this.t(i);let d=null;if(E&&c.length>0){c.sort(($,I)=>I.lineNumber-$.lineNumber),d=[];for(let $=0,I=c.length;$<I;$++){const D=c[$].lineNumber;if($>0&&c[$-1].lineNumber===D)continue;const v=c[$].oldContent,C=this.getLineContent(D);C.length===0||C===v||S.$vf(C)!==-1||d.push(D)}}return this.m.fire(),new O.$ew(l,m,d)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const f=u[0].range,n=u[u.length-1].range,s=new k.$Lt(f.startLineNumber,f.startColumn,n.endLineNumber,n.endColumn);let o=f.startLineNumber,h=f.startColumn;const i=[];for(let m=0,d=u.length;m<d;m++){const $=u[m],I=$.range;E=E||$.forceMoveMarkers,i.push(this.getValueInRange(new k.$Lt(o,h,I.startLineNumber,I.startColumn))),$.text.length>0&&i.push($.text),o=I.endLineNumber,h=I.endColumn}const r=i.join(""),[t,c,l]=(0,T.$vu)(r);return{sortIndex:0,identifier:u[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:c,lastLineLength:l,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(R.w);const E=[];for(let f=0;f<u.length;f++){const n=u[f],s=n.range.startLineNumber,o=n.range.startColumn,h=n.range.endLineNumber,i=n.range.endColumn;if(s===h&&o===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new k.$Lt(s,o,h,i);E.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,f,n){return this.c.findMatchesLineByLine(u,E,f,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const f=u.startLineNumber,n=u.startColumn,[s,o,h]=(0,T.$vu)(E);let i;if(E.length>0){const r=s+1;r===1?i=new k.$Lt(f,n,f,n+o):i=new k.$Lt(f,n,f+r-1,h+1)}else i=new k.$Lt(f,n,f,n);return i}static _getInverseEditRanges(u){const E=[];let f=0,n=0,s=null;for(let o=0,h=u.length;o<h;o++){const i=u[o];let r,t;s?s.range.endLineNumber===i.range.startLineNumber?(r=f,t=n+(i.range.startColumn-s.range.endColumn)):(r=f+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let c;if(i.text.length>0){const l=i.eolCount+1;l===1?c=new k.$Lt(r,t,r,t+i.firstLineLength):c=new k.$Lt(r,t,r+l-1,i.lastLineLength+1)}else c=new k.$Lt(r,t,r,t);f=c.endLineNumber,n=c.endColumn,E.push(c),s=i}return E}static u(u,E){const f=k.$Lt.compareRangesUsingEnds(u.range,E.range);return f===0?u.sortIndex-E.sortIndex:f}static w(u,E){const f=k.$Lt.compareRangesUsingEnds(u.range,E.range);return f===0?E.sortIndex-u.sortIndex:-f}}e.$lD=R}),define(Ce[167],Ie([1,0,28,13,52,100,166]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,S=qe(S);class T{constructor(R,y,u,E,f,n,s,o,h){this.a=R,this.b=y,this.c=u,this.d=E,this.e=f,this.f=n,this.g=s,this.h=o,this.j=h}k(R){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?R===k.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(R){const y=this.k(R),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let f=0,n=u.length;f<n;f++){const s=u[f].buffer.replace(/\r\n|\r|\n/g,y),o=(0,O.$gD)(s);u[f]=new O.$jD(s,o)}const E=new A.$lD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&S.$6f(R)&&(this.b=S.$5f,R=R.substr(1));const y=R.charCodeAt(R.length-1);y===b.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=y):(this.m(R,!1),this.c=!1,this.d=y)}m(R,y){!y&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const y=(0,O.$hD)(this.e,R);this.a.push(new O.$jD(R,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=S.$Uf(R)),this.k||(this.k=S.$Xf(R)))}finish(R=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const y=(0,O.$gD)(R.buffer);R.lineStarts=y,this.d===b.CharCode.CarriageReturn&&this.f++}}}e.$mD=p}),define(Ce[104],Ie([1,0,23,21]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdb=p,e.$Gdb=R,S=qe(S);var k;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(k||(k={}));function O(y){for(let u=0,E=y.length;u<E;u+=4){const f=y[u+0],n=y[u+1],s=y[u+2],o=y[u+3];y[u+0]=o,y[u+1]=s,y[u+2]=n,y[u+3]=f}}function A(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return S.$D()||O(u),b.$Oe.wrap(u)}function T(y){const u=y.buffer;if(S.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(y){const u=new Uint32Array(a(y));let E=0;if(u[E++]=y.id,y.type==="full")u[E++]=k.Full,u[E++]=y.data.length,u.set(y.data,E),E+=y.data.length;else{u[E++]=k.Delta,u[E++]=y.deltas.length;for(const f of y.deltas)u[E++]=f.start,u[E++]=f.deleteCount,f.data?(u[E++]=f.data.length,u.set(f.data,E),E+=f.data.length):u[E++]=0}return A(u)}function a(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const E of y.deltas)E.data&&(u+=E.data.length)}return u}function R(y){const u=T(y);let E=0;const f=u[E++];if(u[E++]===k.Full){const h=u[E++],i=u.subarray(E,E+h);return E+=h,{id:f,type:"full",data:i}}const s=u[E++],o=[];for(let h=0;h<s;h++){const i=u[E++],r=u[E++],t=u[E++];let c;t>0&&(c=u.subarray(E,E+t),E+=t),o[h]={start:i,deleteCount:r,data:c}}return{id:f,type:"delta",deltas:o}}}),define(Ce[168],Ie([9,10]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ce[169],Ie([9,10]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[170],Ie([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[171],Ie([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[172],Ie([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[173],Ie([9,10]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[174],Ie([9,10]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ce[175],Ie([9,10]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(Ce[176],Ie([9,10]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ce[177],Ie([9,10]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(Ce[178],Ie([9,10]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[179],Ie([9,10]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[180],Ie([9,10]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(Ce[181],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[182],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[183],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[184],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[185],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[186],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[187],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[188],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[189],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[190],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[191],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[192],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[193],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(Ce[194],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ce[195],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(Ce[196],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[197],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ce[198],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[199],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[200],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[201],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[202],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ce[203],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[204],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[205],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[206],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[207],Ie([1,0,28,14,171]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...R){switch(R.length){case 1:return(0,k.localize)(0,null,R[0]);case 2:return(0,k.localize)(1,null,R[0],R[1]);case 3:return(0,k.localize)(2,null,R[0],R[1],R[2]);default:return}}const T=(0,k.localize)(3,null),p=(0,k.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,S.$0)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case b.CharCode.OpenParen:this.k(O.LParen);break;case b.CharCode.CloseParen:this.k(O.RParen);break;case b.CharCode.ExclamationMark:if(this.h(b.CharCode.Equals)){const u=this.h(b.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case b.CharCode.SingleQuote:this.o();break;case b.CharCode.Slash:this.q();break;case b.CharCode.Equals:if(this.h(b.CharCode.Equals)){const u=this.h(b.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(b.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case b.CharCode.LessThan:this.k(this.h(b.CharCode.Equals)?O.LtEq:O.Lt);break;case b.CharCode.GreaterThan:this.k(this.h(b.CharCode.Equals)?O.GtEq:O.Gt);break;case b.CharCode.Ampersand:this.h(b.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case b.CharCode.Pipe:this.h(b.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case b.CharCode.Space:case b.CharCode.CarriageReturn:case b.CharCode.Tab:case b.CharCode.LineFeed:case b.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?b.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,E=this.c.substring(this.d,this.e),f={type:O.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:y}),this.f.push(f)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),E=a.b.get(u);E?this.k(E):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==b.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,E=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(p);return}const n=this.c.charCodeAt(y);if(u)u=!1;else if(n===b.CharCode.Slash&&!E){y++;break}else n===b.CharCode.OpenSquareBracket?E=!0:n===b.CharCode.Backslash?u=!0:n===b.CharCode.CloseSquareBracket&&(E=!1);y++}for(;y<this.c.length&&a.a.has(this.c.charCodeAt(y));)y++;this.e=y;const f=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=a}),define(Ce[105],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const b={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(b)}),define(Ce[74],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class b{constructor(k,O=[],A=!1){this.ctor=k,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$Ci=b}),define(Ce[61],Ie([1,0,74]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=O,e.$Ps=A;const S=[];var k;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function O(T,p,a){p instanceof b.$Ci||(p=new b.$Ci(p,[],!!a)),S.push([T,p])}function A(){return S}}),define(Ce[208],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class b{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$rr=b;class S{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(A);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new b(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),p=this.c(A,T);if(p)return p}}c(O,A){for(const[T,p]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const a=this.c(p,A);if(a)return a;A.delete(T)}}}e.$sr=S}),define(Ce[3],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=k,e.$Gi=O;var b;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(b||(e._util=b={})),e.$Ei=k("instantiationService");function S(A,T,p){T[b.DI_TARGET]===T?T[b.DI_DEPENDENCIES].push({id:A,index:p}):(T[b.DI_DEPENDENCIES]=[{id:A,index:p}],T[b.DI_TARGET]=T)}function k(A){if(b.serviceIds.has(A))return b.serviceIds.get(A);const T=function(p,a,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(T,p,R)};return T.toString=()=>A,b.serviceIds.set(A,T),T}function O(A){return A}}),define(Ce[42],Ie([1,0,15,2,3]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=A,e.$cj=p,e.$dj=a,e.$ej=R,e.$fj=y,e.$gj=u,e.$hj=f,e.$ij=n,e.$jj=s,b=qe(b),e.$_i=(0,k.$Fi)("configurationService");function O(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof S.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof S.URI)}var T;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p(o){switch(o){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function a(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function R(o,h){const i=Object.create(null);for(const r in o)y(i,r,o[r],h);return i}function y(o,h,i,r){const t=h.split("."),c=t.pop();let l=o;for(let m=0;m<t.length;m++){const d=t[m];let $=l[d];switch(typeof $){case"undefined":$=l[d]=Object.create(null);break;case"object":if($===null){r(`Ignoring ${h} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:r(`Ignoring ${h} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify($)}`);return}l=$}if(typeof l=="object"&&l!==null)try{l[c]=i}catch{r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}else r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}function u(o,h){const i=h.split(".");E(o,i)}function E(o,h){const i=h.shift();if(h.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,h),Object.keys(r).length===0&&delete o[i])}}function f(o,h,i){function r(l,m){let d=l;for(const $ of m){if(typeof d!="object"||d===null)return;d=d[$]}return d}const t=h.split("."),c=r(o,t);return typeof c>"u"?i:c}function n(o,h,i){Object.keys(h).forEach(r=>{r!=="__proto__"&&(r in o?b.$hg(o[r])&&b.$hg(h[r])?n(o[r],h[r],i):i&&(o[r]=h[r]):o[r]=h[r])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(Ce[32],Ie([1,0,28,21,13,207,3,170,14]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=R,e.$Ej=m,e.$Fj=d,e.$Yj=re;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",S.$j),a.set("isLinux",S.$k),a.set("isWindows",S.$i),a.set("isWeb",S.$o),a.set("isMacNative",S.$j&&!S.$o),a.set("isEdge",S.$H),a.set("isFirefox",S.$F),a.set("isChrome",S.$E),a.set("isSafari",S.$G);function R(Y,q){if(a.get(Y)!==void 0)throw(0,p.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(Y,q)}const y=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},f=(0,T.localize)(0,null),n=(0,T.localize)(1,null),s=(0,T.localize)(2,null),o=(0,T.localize)(3,null),h=(0,T.localize)(4,null),i=(0,T.localize)(5,null),r=(0,T.localize)(6,null),t=(0,T.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=E){this.k=q,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const ve=this.D(),ue=ve.type===O.TokenType.Str?i:void 0;throw this.h.push({message:h,offset:ve.offset,lexeme:O.$Aj.getLexeme(ve),additionalInfo:ue}),c.c}return ee}catch(ee){if(ee!==c.c)throw ee;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const ee=this.o();q.push(ee)}return q.length===1?q[0]:l.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const ee=this.s();q.push(ee)}return q.length===1?q[0]:l.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),I.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const ee=this.l();return this.A(O.TokenType.RParen,o),ee?.negate()}case O.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),l.true();case O.TokenType.False:return this.z(),l.false();case O.TokenType.LParen:{this.z();const ee=this.l();return this.A(O.TokenType.RParen,o),ee}case O.TokenType.Str:{const ee=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==O.TokenType.RegexStr)throw this.B("REGEX",ue);const be=ue.lexeme,de=be.lastIndexOf("/"),X=de===be.length-1?void 0:this.w(be.substring(de+1));let Z;try{Z=new RegExp(be.substring(1,de),X)}catch{throw this.B("REGEX",ue)}return V.create(ee,Z)}switch(ue.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const be=[ue.lexeme];this.z();let de=this.D(),X=0;for(let ze=0;ze<ue.lexeme.length;ze++)ue.lexeme.charCodeAt(ze)===b.CharCode.OpenParen?X++:ue.lexeme.charCodeAt(ze)===b.CharCode.CloseParen&&X--;for(;!this.E()&&de.type!==O.TokenType.And&&de.type!==O.TokenType.Or;){switch(de.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ze=0;ze<de.lexeme.length;ze++)de.lexeme.charCodeAt(ze)===b.CharCode.OpenParen?X++:ue.lexeme.charCodeAt(ze)===b.CharCode.CloseParen&&X--}if(X<0)break;be.push(O.$Aj.getLexeme(de)),this.z(),de=this.D()}const Z=be.join(""),me=Z.lastIndexOf("/"),pe=me===Z.length-1?void 0:this.w(Z.substring(me+1));let Oe;try{Oe=new RegExp(Z.substring(1,me),pe)}catch{throw this.B("REGEX",ue)}return l.regex(ee,Oe)}case O.TokenType.QuotedStr:{const be=ue.lexeme;this.z();let de=null;if(!(0,k.$df)(be)){const X=be.indexOf("/"),Z=be.lastIndexOf("/");if(X!==Z&&X>=0){const me=be.slice(X+1,Z),pe=be[Z+1]==="i"?"i":"";try{de=new RegExp(me,pe)}catch{throw this.B("REGEX",ue)}}}if(de===null)throw this.B("REGEX",ue);return V.create(ee,de)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,s);const ue=this.u();return l.notIn(ee,ue)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ue=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.equals(ee,ue);switch(ue){case"true":return l.has(ee);case"false":return l.not(ee);default:return l.equals(ee,ue)}}case O.TokenType.NotEq:{this.z();const ue=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.notEquals(ee,ue);switch(ue){case"true":return l.not(ee);case"false":return l.has(ee);default:return l.notEquals(ee,ue)}}case O.TokenType.Lt:return this.z(),B.create(ee,this.u());case O.TokenType.LtEq:return this.z(),F.create(ee,this.u());case O.TokenType.Gt:return this.z(),L.create(ee,this.u());case O.TokenType.GtEq:return this.z(),G.create(ee,this.u());case O.TokenType.In:return this.z(),l.in(ee,this.u());default:return l.has(ee)}}case O.TokenType.EOF:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:t}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ee){if(this.C(q))return this.z();throw this.B(ee,this.D())}B(q,ee,ve){const ue=(0,T.localize)(8,null,q,O.$Aj.getLexeme(ee)),be=ee.offset,de=O.$Aj.getLexeme(ee);return this.h.push({message:ue,offset:be,lexeme:de,additionalInfo:ve}),c.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=c;class l{static false(){return I.INSTANCE}static true(){return D.INSTANCE}static has(q){return v.create(q)}static equals(q,ee){return C.create(q,ee)}static notEquals(q,ee){return w.create(q,ee)}static regex(q,ee){return V.create(q,ee)}static in(q,ee){return P.create(q,ee)}static notIn(q,ee){return g.create(q,ee)}static not(q){return M.create(q)}static and(...q){return _.create(q,null,!0)}static or(...q){return ge.create(q,null,!0)}static greater(q,ee){return L.create(q,ee)}static greaterEquals(q,ee){return G.create(q,ee)}static smaller(q,ee){return B.create(q,ee)}static smallerEquals(q,ee){return F.create(q,ee)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Dj=l;function m(Y){const q=new c({regexParsingWithErrorRecovery:!1});return Y.map(ee=>(q.parse(ee),q.lexingErrors.length>0?q.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(9,null,ve.additionalInfo):(0,T.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function d(Y,q){const ee=Y?Y.substituteConstants():void 0,ve=q?q.substituteConstants():void 0;return!ee&&!ve?!0:!ee||!ve?!1:ee.equals(ve)}function $(Y,q){return Y.cmp(q)}class I{static{this.INSTANCE=new I}constructor(){this.type=u.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Gj=I;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return I.INSTANCE}}e.$Hj=D;class v{static create(q,ee=null){const ve=a.get(q);return typeof ve=="boolean"?ve?D.INSTANCE:I.INSTANCE:new v(q,ee)}constructor(q,ee){this.key=q,this.c=ee,this.type=u.Defined}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=a.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:I.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ij=v;class C{static create(q,ee,ve=null){if(typeof ee=="boolean")return ee?v.create(q,ve):M.create(q,ve);const ue=a.get(q);return typeof ue=="boolean"?ee===(ue?"true":"false")?D.INSTANCE:I.INSTANCE:new C(q,ee,ve)}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.Equals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=a.get(this.c);if(typeof q=="boolean"){const ee=q?"true":"false";return this.d===ee?D.INSTANCE:I.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Jj=C;class P{static create(q,ee){return new P(q,ee)}constructor(q,ee){this.d=q,this.f=ee,this.type=u.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:we(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ee=q.getValue(this.f),ve=q.getValue(this.d);return Array.isArray(ee)?ee.includes(ve):typeof ve=="string"&&typeof ee=="object"&&ee!==null?y.call(ee,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Kj=P;class g{static create(q,ee){return new g(q,ee)}constructor(q,ee){this.d=q,this.f=ee,this.type=u.NotIn,this.c=P.create(q,ee)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=g;class w{static create(q,ee,ve=null){if(typeof ee=="boolean")return ee?M.create(q,ve):v.create(q,ve);const ue=a.get(q);return typeof ue=="boolean"?ee===(ue?"true":"false")?I.INSTANCE:D.INSTANCE:new w(q,ee,ve)}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=a.get(this.c);if(typeof q=="boolean"){const ee=q?"true":"false";return this.d===ee?I.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Mj=w;class M{static create(q,ee=null){const ve=a.get(q);return typeof ve=="boolean"?ve?I.INSTANCE:D.INSTANCE:new M(q,ee)}constructor(q,ee){this.c=q,this.d=ee,this.type=u.Not}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=a.get(this.c);return typeof q=="boolean"?q?I.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Nj=M;function N(Y,q){if(typeof Y=="string"){const ee=parseFloat(Y);isNaN(ee)||(Y=ee)}return typeof Y=="string"||typeof Y=="number"?q(Y):I.INSTANCE}class L{static create(q,ee,ve=null){return N(ee,ue=>new L(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.Greater}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=L;class G{static create(q,ee,ve=null){return N(ee,ue=>new G(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Pj=G;class B{static create(q,ee,ve=null){return N(ee,ue=>new B(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Qj=B;class F{static create(q,ee,ve=null){return N(ee,ue=>new F(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Rj=F;class V{static create(q,ee){return new V(q,ee)}constructor(q,ee){this.d=q,this.f=ee,this.type=u.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ee=this.f?this.f.source:"",ve=q.f?q.f.source:"";return ee<ve?-1:ee>ve?1:0}equals(q){if(q.type===this.type){const ee=this.f?this.f.source:"",ve=q.f?q.f.source:"";return this.d===q.d&&ee===ve}return!1}substituteConstants(){return this}evaluate(q){const ee=q.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Sj=V;class ae{static create(q){return new ae(q)}constructor(q){this.c=q,this.type=u.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new ae(this.c.map(q))}negate(){return this.c}}e.$Tj=ae;function $e(Y){let q=null;for(let ee=0,ve=Y.length;ee<ve;ee++){const ue=Y[ee].substituteConstants();if(Y[ee]!==ue&&q===null){q=[];for(let be=0;be<ee;be++)q[be]=Y[be]}q!==null&&(q[ee]=ue)}return q===null?Y:q}class _{static create(q,ee,ve){return _.d(q,ee,ve)}constructor(q,ee){this.expr=q,this.c=ee,this.type=u.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ee=0,ve=this.expr.length;ee<ve;ee++){const ue=$(this.expr[ee],q.expr[ee]);if(ue!==0)return ue}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].equals(q.expr[ee]))return!1;return!0}return!1}substituteConstants(){const q=$e(this.expr);return q===this.expr?this:_.create(q,this.c,!1)}evaluate(q){for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].evaluate(q))return!1;return!0}static d(q,ee,ve){const ue=[];let be=!1;for(const de of q)if(de){if(de.type===u.True){be=!0;continue}if(de.type===u.False)return I.INSTANCE;if(de.type===u.And){ue.push(...de.expr);continue}ue.push(de)}if(ue.length===0&&be)return D.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort($);for(let de=1;de<ue.length;de++)ue[de-1].equals(ue[de])&&(ue.splice(de,1),de--);if(ue.length===1)return ue[0];for(;ue.length>1;){const de=ue[ue.length-1];if(de.type!==u.Or)break;ue.pop();const X=ue.pop(),Z=ue.length===0,me=ge.create(de.expr.map(pe=>_.create([pe,X],null,ve)),null,Z);me&&(ue.push(me),ue.sort($))}if(ue.length===1)return ue[0];if(ve){for(let de=0;de<ue.length;de++)for(let X=de+1;X<ue.length;X++)if(ue[de].negate().equals(ue[X]))return I.INSTANCE;if(ue.length===1)return ue[0]}return new _(ue,ee)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ee of this.expr)q.push(...ee.keys());return q}map(q){return new _(this.expr.map(ee=>ee.map(q)),null)}negate(){if(!this.c){const q=[];for(const ee of this.expr)q.push(ee.negate());this.c=ge.create(q,this,!0)}return this.c}}e.$Uj=_;class ge{static create(q,ee,ve){return ge.d(q,ee,ve)}constructor(q,ee){this.expr=q,this.c=ee,this.type=u.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ee=0,ve=this.expr.length;ee<ve;ee++){const ue=$(this.expr[ee],q.expr[ee]);if(ue!==0)return ue}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].equals(q.expr[ee]))return!1;return!0}return!1}substituteConstants(){const q=$e(this.expr);return q===this.expr?this:ge.create(q,this.c,!1)}evaluate(q){for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(this.expr[ee].evaluate(q))return!0;return!1}static d(q,ee,ve){let ue=[],be=!1;if(q){for(let de=0,X=q.length;de<X;de++){const Z=q[de];if(Z){if(Z.type===u.False){be=!0;continue}if(Z.type===u.True)return D.INSTANCE;if(Z.type===u.Or){ue=ue.concat(Z.expr);continue}ue.push(Z)}}if(ue.length===0&&be)return I.INSTANCE;ue.sort($)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let de=1;de<ue.length;de++)ue[de-1].equals(ue[de])&&(ue.splice(de,1),de--);if(ue.length===1)return ue[0];if(ve){for(let de=0;de<ue.length;de++)for(let X=de+1;X<ue.length;X++)if(ue[de].negate().equals(ue[X]))return D.INSTANCE;if(ue.length===1)return ue[0]}return new ge(ue,ee)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ee of this.expr)q.push(...ee.keys());return q}map(q){return new ge(this.expr.map(ee=>ee.map(q)),null)}negate(){if(!this.c){const q=[];for(const ee of this.expr)q.push(ee.negate());for(;q.length>1;){const ee=q.shift(),ve=q.shift(),ue=[];for(const be of Me(ee))for(const de of Me(ve))ue.push(_.create([be,de],null,!1));q.unshift(ge.create(ue,null,!1))}this.c=ge.create(q,this,!0)}return this.c}}e.$Vj=ge;class se extends v{static{this.d=[]}static all(){return se.d.values()}constructor(q,ee,ve){super(q,null),this.f=ee,typeof ve=="object"?se.d.push({...ve,key:q}):ve!==!0&&se.d.push({key:q,description:ve,type:ee!=null?typeof ee:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return C.create(this.key,q)}notEqualsTo(q){return w.create(this.key,q)}}e.$Wj=se,e.$Xj=(0,A.$Fi)("contextKeyService");function ce(Y,q){return Y<q?-1:Y>q?1:0}function we(Y,q,ee,ve){return Y<ee?-1:Y>ee?1:q<ve?-1:q>ve?1:0}function re(Y,q){if(Y.type===u.False||q.type===u.True)return!0;if(Y.type===u.Or)return q.type===u.Or?Pe(Y.expr,q.expr):!1;if(q.type===u.Or){for(const ee of q.expr)if(re(Y,ee))return!0;return!1}if(Y.type===u.And){if(q.type===u.And)return Pe(q.expr,Y.expr);for(const ee of Y.expr)if(re(ee,q))return!0;return!1}return Y.equals(q)}function Pe(Y,q){let ee=0,ve=0;for(;ee<Y.length&&ve<q.length;){const ue=Y[ee].cmp(q[ve]);if(ue<0)return!1;ue===0&&ee++,ve++}return ee===Y.length}function Me(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(Ce[209],Ie([1,0,32,3]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$pt=e.AccessibilitySupport=e.$ot=void 0,e.$qt=O,e.$ot=(0,S.$Fi)("accessibilityService");var k;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(k||(e.AccessibilitySupport=k={})),e.$pt=new b.$Wj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$rt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[106],Ie([1,0,18,26,21,144,322,150,210,168,209]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=$,e.cursorStyleToString=N,e.filterValidationDecorations=Ae,b=qe(b),S=qe(S),k=qe(k),a=qe(a);var y;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class f{constructor(x,De,Je,xe){this.id=x,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(x,De){return s(x,De)}compute(x,De,Je){return Je}}class n{constructor(x,De){this.newValue=x,this.didChange=De}}e.ApplyUpdateResult=n;function s(Q,x){if(typeof Q!="object"||typeof x!="object"||!Q||!x)return new n(x,Q!==x);if(Array.isArray(Q)||Array.isArray(x)){const Je=Array.isArray(Q)&&Array.isArray(x)&&b.$wb(Q,x);return new n(x,!Je)}let De=!1;for(const Je in x)if(x.hasOwnProperty(Je)){const xe=s(Q[Je],x[Je]);xe.didChange&&(Q[Je]=xe.newValue,De=!0)}return new n(Q,De)}class o{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,De){return s(x,De)}validate(x){return this.defaultValue}}class h{constructor(x,De,Je,xe){this.id=x,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(x,De){return s(x,De)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,De,Je){return Je}}function i(Q,x){return typeof Q>"u"?x:Q==="false"?!1:!!Q}class r extends h{constructor(x,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(x,De,Je,xe)}validate(x){return i(x,this.defaultValue)}}function t(Q,x,De,Je){if(typeof Q>"u")return x;let xe=parseInt(Q,10);return isNaN(xe)?x:(xe=Math.max(De,xe),xe=Math.min(Je,xe),xe|0)}class c extends h{static clampedInt(x,De,Je,xe){return t(x,De,Je,xe)}constructor(x,De,Je,xe,ht,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Je,$t.minimum=xe,$t.maximum=ht),super(x,De,Je,$t),this.minimum=xe,this.maximum=ht}validate(x){return c.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function l(Q,x,De,Je){if(typeof Q>"u")return x;const xe=m.float(Q,x);return m.clamp(xe,De,Je)}class m extends h{static clamp(x,De,Je){return x<De?De:x>Je?Je:x}static float(x,De){if(typeof x=="number")return x;if(typeof x>"u")return De;const Je=parseFloat(x);return isNaN(Je)?De:Je}constructor(x,De,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(x,De,Je,ht),this.validationFn=xe}validate(x){return this.validationFn(m.float(x,this.defaultValue))}}class d extends h{static string(x,De){return typeof x!="string"?De:x}constructor(x,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(x,De,Je,xe)}validate(x){return d.string(x,this.defaultValue)}}function $(Q,x,De,Je){return typeof Q!="string"?x:Je&&Q in Je?Je[Q]:De.indexOf(Q)===-1?x:Q}class I extends h{constructor(x,De,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(x,De,Je,ht),this.c=xe}validate(x){return $(x,this.defaultValue,this.c)}}class D extends f{constructor(x,De,Je,xe,ht,$t,Ft=void 0){typeof Ft<"u"&&(Ft.type="string",Ft.enum=ht,Ft.default=xe),super(x,De,Je,Ft),this.c=ht,this.d=$t}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function v(Q){switch(Q){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class C extends f{constructor(){super(je.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(x){switch(x){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,De,Je){return Je===R.AccessibilitySupport.Unknown?x.accessibilitySupport:Je}}class P extends f{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:a.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertSpace:i(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(g||(e.TextEditorCursorBlinkingStyle=g={}));function w(Q){switch(Q){case"blink":return g.Blink;case"smooth":return g.Smooth;case"phase":return g.Phase;case"expand":return g.Expand;case"solid":return g.Solid}}var M;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(Q){switch(Q){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(Q){switch(Q){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class G extends o{constructor(){super(je.editorClassName)}compute(x,De,Je){const xe=["monaco-editor"];return De.get(je.extraEditorClassName)&&xe.push(De.get(je.extraEditorClassName)),x.extraEditorClassName&&xe.push(x.extraEditorClassName),De.get(je.mouseStyle)==="default"?xe.push("mouse-default"):De.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),De.get(je.showUnused)&&xe.push("showUnused"),De.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class B extends r{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(x,De,Je){return Je&&x.emptySelectionClipboard}}class F extends f{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:a.localize(16,null),included:k.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:a.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{cursorMoveOnType:i(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":$(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":$(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(De.loop,this.defaultValue.loop)}}}class V extends f{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?V.OFF:x==="true"?V.ON:x:x?V.ON:V.OFF}}e.EditorFontLigatures=V;class ae extends f{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",ae.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?ae.OFF:x==="true"?ae.TRANSLATE:x:x?ae.TRANSLATE:ae.OFF}compute(x,De,Je){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=ae;class $e extends o{constructor(){super(je.fontInfo)}compute(x,De,Je){return x.fontInfo}}class _ extends h{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(x){const De=m.float(x,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(De,6,100)}compute(x,De,Je){return x.fontInfo.fontSize}}class ge extends f{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ge.d,maximum:ge.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ge.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(c.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,ge.d,ge.e))}}class se extends f{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Je,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Je,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Je,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Je,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Je,description:a.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{multiple:$(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??$(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??$(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??$(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??$(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??$(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:d.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:d.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:d.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:d.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:d.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends f{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:a.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),delay:c.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:i(De.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(De.above,this.defaultValue.above)}}}var we;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class re extends o{constructor(){super(je.layoutInfo)}compute(x,De,Je){return re.computeLayout(De,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const De=x.height/x.lineHeight,Je=Math.floor(x.paddingTop/x.lineHeight);let xe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(xe=Math.max(xe,De-1));const ht=(Je+x.viewLineCount+xe)/(x.pixelRatio*x.height),$t=Math.floor(x.viewLineCount/ht);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:$t}}static c(x,De){const Je=x.outerWidth,xe=x.outerHeight,ht=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:we.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const $t=De.stableMinimapLayoutInput,Ft=$t&&x.outerHeight===$t.outerHeight&&x.lineHeight===$t.lineHeight&&x.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&x.pixelRatio===$t.pixelRatio&&x.scrollBeyondLastLine===$t.scrollBeyondLastLine&&x.paddingTop===$t.paddingTop&&x.paddingBottom===$t.paddingBottom&&x.minimap.enabled===$t.minimap.enabled&&x.minimap.side===$t.minimap.side&&x.minimap.size===$t.minimap.size&&x.minimap.showSlider===$t.minimap.showSlider&&x.minimap.renderCharacters===$t.minimap.renderCharacters&&x.minimap.maxColumn===$t.minimap.maxColumn&&x.minimap.scale===$t.minimap.scale&&x.verticalScrollbarWidth===$t.verticalScrollbarWidth&&x.isViewportWrapping===$t.isViewportWrapping,zt=x.lineHeight,Yt=x.typicalHalfwidthCharacterWidth,fi=x.scrollBeyondLastLine,Ze=x.minimap.renderCharacters;let Pt=ht>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Kt=x.minimap.maxColumn,Qt=x.minimap.size,mt=x.minimap.side,vt=x.verticalScrollbarWidth,ii=x.viewLineCount,Zt=x.remainingWidth,qt=x.isViewportWrapping,yt=Ze?2:3;let Nt=Math.floor(ht*xe);const li=Nt/ht;let Vt=!1,Xe=!1,xt=yt*Pt,ni=Pt/ht,hi=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:jt,extraLinesBeyondLastLine:Ht,desiredRatio:oi,minimapLineCount:Rt}=re.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:fi,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:xe,lineHeight:zt,pixelRatio:ht});if(ii/Rt>1)Vt=!0,Xe=!0,Pt=1,xt=1,ni=Pt/ht;else{let bt=!1,ei=Pt+1;if(Qt==="fit"){const Ct=Math.ceil((jt+ii+Ht)*xt);qt&&Ft&&Zt<=De.stableFitRemainingWidth?(bt=!0,ei=De.stableFitMaxMinimapScale):bt=Ct>Nt}if(Qt==="fill"||bt){Vt=!0;const Ct=Pt;xt=Math.min(zt*ht,Math.max(1,Math.floor(1/oi))),qt&&Ft&&Zt<=De.stableFitRemainingWidth&&(ei=De.stableFitMaxMinimapScale),Pt=Math.min(ei,Math.max(1,Math.floor(xt/yt))),Pt>Ct&&(hi=Math.min(2,Pt/Ct)),ni=Pt/ht/hi,Nt=Math.ceil(Math.max(si,jt+ii+Ht)*xt),qt?(De.stableMinimapLayoutInput=x,De.stableFitRemainingWidth=Zt,De.stableFitMaxMinimapScale=Pt):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const kt=Math.floor(Kt*ni),Lt=Math.min(kt,Math.max(0,Math.floor((Zt-vt-2)*ni/(Yt+ni)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(ht*Lt);const Ut=At/ht;At=Math.floor(At*hi);const ri=Ze?we.Text:we.Blocks,_t=mt==="left"?0:Je-Lt-vt;return{renderMinimap:ri,minimapLeft:_t,minimapWidth:Lt,minimapHeightIsEditorHeight:Vt,minimapIsSampling:Xe,minimapScale:Pt,minimapLineHeight:xt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:li}}static computeLayout(x,De){const Je=De.outerWidth|0,xe=De.outerHeight|0,ht=De.lineHeight|0,$t=De.lineNumbersDigitCount|0,Ft=De.typicalHalfwidthCharacterWidth,zt=De.maxDigitWidth,Yt=De.pixelRatio,fi=De.viewLineCount,Ze=x.get(je.wordWrapOverride2),Pt=Ze==="inherit"?x.get(je.wordWrapOverride1):Ze,Kt=Pt==="inherit"?x.get(je.wordWrap):Pt,Qt=x.get(je.wordWrapColumn),mt=De.isDominatedByLongLines,vt=x.get(je.glyphMargin),ii=x.get(je.lineNumbers).renderType!==ze.Off,Zt=x.get(je.lineNumbersMinChars),qt=x.get(je.scrollBeyondLastLine),yt=x.get(je.padding),Nt=x.get(je.minimap),li=x.get(je.scrollbar),Vt=li.verticalScrollbarSize,Xe=li.verticalHasArrows,xt=li.arrowSize,ni=li.horizontalScrollbarSize,hi=x.get(je.folding),kt=x.get(je.showFoldingControls)!=="never";let Lt=x.get(je.lineDecorationsWidth);hi&&kt&&(Lt+=16);let At=0;if(ii){const Gt=Math.max($t,Zt);At=Math.round(Gt*zt)}let Ut=0;vt&&(Ut=ht*De.glyphMarginDecorationLaneCount);let ri=0,_t=ri+Ut,si=_t+At,jt=si+Lt;const Ht=Je-Ut-At-Lt;let oi=!1,Rt=!1,St=-1;Pt==="inherit"&&mt?(oi=!0,Rt=!0):Kt==="on"||Kt==="bounded"?Rt=!0:Kt==="wordWrapColumn"&&(St=Qt);const bt=re.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Ft,pixelRatio:Yt,scrollBeyondLastLine:qt,paddingTop:yt.top,paddingBottom:yt.bottom,minimap:Nt,verticalScrollbarWidth:Vt,viewLineCount:fi,remainingWidth:Ht,isViewportWrapping:Rt},De.memory||new E);bt.renderMinimap!==we.None&&bt.minimapLeft===0&&(ri+=bt.minimapWidth,_t+=bt.minimapWidth,si+=bt.minimapWidth,jt+=bt.minimapWidth);const ei=Ht-bt.minimapWidth,Ct=Math.max(1,Math.floor((ei-Vt-2)/Ft)),di=Xe?xt:0;return Rt&&(St=Math.max(1,Ct),Kt==="bounded"&&(St=Math.min(St,Qt))),{width:Je,height:xe,glyphMarginLeft:ri,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:At,decorationsLeft:si,decorationsWidth:Lt,contentLeft:jt,contentWidth:ei,minimap:bt,viewportColumn:Ct,isWordWrapMinified:oi,isViewportWrapping:Rt,wrappingColumn:St,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:ni,overviewRuler:{top:di,width:Vt,height:xe-2*di,right:0}}}}e.EditorLayoutInfoComputer=re;class Pe extends f{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(x){return $(x,"simple",["simple","advanced"])}compute(x,De,Je){return De.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Je}}var Me;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(Me||(e.ShowLightbulbIconMode=Me={}));class Y extends f{constructor(){const x={enabled:Me.On};super(je.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Me.Off,Me.OnCode,Me.On],default:x.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:$(x.enabled,this.defaultValue.enabled,[Me.Off,Me.OnCode,Me.On])}}}class q extends f{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:a.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends f{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,k.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,k.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:a.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:$(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:d.string(De.fontFamily,this.defaultValue.fontFamily),padding:i(De.padding,this.defaultValue.padding)}}}class ve extends f{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):c.clampedInt(x,this.defaultValue,0,1e3)}compute(x,De,Je){return Je<0?c.clampedInt(-Je*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ue extends m{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>m.clamp(x,0,150),{markdownDescription:a.localize(66,null)})}compute(x,De,Je){return x.fontInfo.lineHeight}}class be extends f{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:x.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),autohide:i(De.autohide,this.defaultValue.autohide),size:$(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(De.side,this.defaultValue.side,["right","left"]),showSlider:$(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(De.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(De.scale,1,1,3),maxColumn:c.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(De.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function de(Q){return Q==="ctrlCmd"?k.$j?"metaKey":"ctrlKey":"altKey"}class X extends f{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{top:c.clampedInt(De.top,0,0,1e3),bottom:c.clampedInt(De.bottom,0,0,1e3)}}}class Z extends f{constructor(){const x={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:a.localize(85,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),cycle:i(De.cycle,this.defaultValue.cycle)}}}class me extends o{constructor(){super(je.pixelRatio)}compute(x,De,Je){return x.pixelRatio}}class pe extends f{constructor(){super(je.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Oe extends f{constructor(){const x={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:x.strings,description:a.localize(89,null)},comments:{anyOf:De,default:x.comments,description:a.localize(90,null)},other:{anyOf:De,default:x.other,description:a.localize(91,null)}},default:x,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Yt=x?"on":"off";return{comments:Yt,strings:Yt,other:Yt}}if(!x||typeof x!="object")return this.defaultValue;const{other:De,comments:Je,strings:xe}=x,ht=["on","inline","off"];let $t,Ft,zt;return typeof De=="boolean"?$t=De?"on":"off":$t=$(De,this.defaultValue.other,ht),typeof Je=="boolean"?Ft=Je?"on":"off":Ft=$(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?zt=xe?"on":"off":zt=$(xe,this.defaultValue.strings,ht),{other:$t,comments:Ft,strings:zt}}}var ze;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends f{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(x){let De=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(De=ze.Custom,Je=x):x==="interval"?De=ze.Interval:x==="relative"?De=ze.Relative:x==="on"?De=ze.On:De=ze.Off),{renderType:De,renderFn:Je}}}function Ae(Q){const x=Q.get(je.renderValidationDecorations);return x==="editable"?Q.get(je.readOnly):x!=="on"}class Ne extends f{constructor(){const x=[],De={type:"number",description:a.localize(98,null)};super(je.rulers,"rulers",x,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:x,description:a.localize(100,null)})}validate(x){if(Array.isArray(x)){const De=[];for(const Je of x)if(typeof Je=="number")De.push({column:c.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;De.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return De.sort((Je,xe)=>Je.column-xe.column),De}return this.defaultValue}}class j extends f{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function U(Q,x){if(typeof Q!="string")return x;switch(Q){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class K extends f{constructor(){const x={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x,Je=c.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(De.vertical,this.defaultValue.vertical),horizontal:U(De.horizontal,this.defaultValue.horizontal),useShadows:i(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:c.clampedInt(De.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(De.verticalSliderSize,xe,0,1e3),scrollByPage:i(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends f{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:a.localize(119,null)}})}applyUpdate(x,De){let Je=!1;De.allowedCharacters&&x&&(S.$ho(x.allowedCharacters,De.allowedCharacters)||(x={...x,allowedCharacters:De.allowedCharacters},Je=!0)),De.allowedLocales&&x&&(S.$ho(x.allowedLocales,De.allowedLocales)||(x={...x,allowedLocales:De.allowedLocales},Je=!0));const xe=super.applyUpdate(x,De);return Je?new n(xe.newValue,!0):xe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{nonBasicASCII:Ke(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,De){if(typeof x!="object"||!x)return De;const Je={};for(const[xe,ht]of Object.entries(x))ht===!0&&(Je[xe]=!0);return Je}}class ie extends f{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(126,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),mode:$(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:d.string(De.fontFamily,this.defaultValue.fontFamily)}}}class fe extends f{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:a.localize(133,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:d.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Re extends f{constructor(){const x={enabled:T.$it.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$it.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends f{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:x.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:x.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:x.highlightActiveIndentation,description:a.localize(149,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{bracketPairs:Ke(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(Q,x,De){const Je=De.indexOf(Q);return Je===-1?x:De[Je]}class _e extends f{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:x.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:x.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertMode:$(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(De.showIcons,this.defaultValue.showIcons),showStatusBar:i(De.showStatusBar,this.defaultValue.showStatusBar),preview:i(De.preview,this.defaultValue.preview),previewMode:$(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(De.showMethods,this.defaultValue.showMethods),showFunctions:i(De.showFunctions,this.defaultValue.showFunctions),showConstructors:i(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(De.showFields,this.defaultValue.showFields),showVariables:i(De.showVariables,this.defaultValue.showVariables),showClasses:i(De.showClasses,this.defaultValue.showClasses),showStructs:i(De.showStructs,this.defaultValue.showStructs),showInterfaces:i(De.showInterfaces,this.defaultValue.showInterfaces),showModules:i(De.showModules,this.defaultValue.showModules),showProperties:i(De.showProperties,this.defaultValue.showProperties),showEvents:i(De.showEvents,this.defaultValue.showEvents),showOperators:i(De.showOperators,this.defaultValue.showOperators),showUnits:i(De.showUnits,this.defaultValue.showUnits),showValues:i(De.showValues,this.defaultValue.showValues),showConstants:i(De.showConstants,this.defaultValue.showConstants),showEnums:i(De.showEnums,this.defaultValue.showEnums),showEnumMembers:i(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(De.showKeywords,this.defaultValue.showKeywords),showWords:i(De.showWords,this.defaultValue.showWords),showColors:i(De.showColors,this.defaultValue.showColors),showFiles:i(De.showFiles,this.defaultValue.showFiles),showReferences:i(De.showReferences,this.defaultValue.showReferences),showFolders:i(De.showFolders,this.defaultValue.showFolders),showTypeParameters:i(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(De.showSnippets,this.defaultValue.showSnippets),showUsers:i(De.showUsers,this.defaultValue.showUsers),showIssues:i(De.showIssues,this.defaultValue.showIssues)}}}class tt extends f{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(x.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends f{constructor(){const x=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const De=[];for(const Je of x)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&De.push(Je)}catch{}return De}return this.defaultValue}}var et;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends f{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(x){switch(x){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(x,De,Je){return De.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?et.None:Je}}class ft extends o{constructor(){super(je.wrappingInfo)}compute(x,De,Je){const xe=De.get(je.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class ct extends f{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showDropSelector:$(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends f{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showPasteSelector:$(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ut="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.$j?gt:k.$k?pt:ut,fontWeight:"normal",fontSize:k.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var je;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.placeholder=88]="placeholder",Q[Q.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=90]="quickSuggestions",Q[Q.quickSuggestionsDelay=91]="quickSuggestionsDelay",Q[Q.readOnly=92]="readOnly",Q[Q.readOnlyMessage=93]="readOnlyMessage",Q[Q.renameOnType=94]="renameOnType",Q[Q.renderControlCharacters=95]="renderControlCharacters",Q[Q.renderFinalNewline=96]="renderFinalNewline",Q[Q.renderLineHighlight=97]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=99]="renderValidationDecorations",Q[Q.renderWhitespace=100]="renderWhitespace",Q[Q.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Q[Q.roundedSelection=102]="roundedSelection",Q[Q.rulers=103]="rulers",Q[Q.scrollbar=104]="scrollbar",Q[Q.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=106]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=107]="scrollPredominantAxis",Q[Q.selectionClipboard=108]="selectionClipboard",Q[Q.selectionHighlight=109]="selectionHighlight",Q[Q.selectOnLineNumbers=110]="selectOnLineNumbers",Q[Q.showFoldingControls=111]="showFoldingControls",Q[Q.showUnused=112]="showUnused",Q[Q.snippetSuggestions=113]="snippetSuggestions",Q[Q.smartSelect=114]="smartSelect",Q[Q.smoothScrolling=115]="smoothScrolling",Q[Q.stickyScroll=116]="stickyScroll",Q[Q.stickyTabStops=117]="stickyTabStops",Q[Q.stopRenderingLineAfter=118]="stopRenderingLineAfter",Q[Q.suggest=119]="suggest",Q[Q.suggestFontSize=120]="suggestFontSize",Q[Q.suggestLineHeight=121]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Q[Q.suggestSelection=123]="suggestSelection",Q[Q.tabCompletion=124]="tabCompletion",Q[Q.tabIndex=125]="tabIndex",Q[Q.unicodeHighlighting=126]="unicodeHighlighting",Q[Q.unusualLineTerminators=127]="unusualLineTerminators",Q[Q.useShadowDOM=128]="useShadowDOM",Q[Q.useTabStops=129]="useTabStops",Q[Q.wordBreak=130]="wordBreak",Q[Q.wordSegmenterLocales=131]="wordSegmenterLocales",Q[Q.wordSeparators=132]="wordSeparators",Q[Q.wordWrap=133]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=136]="wordWrapColumn",Q[Q.wordWrapOverride1=137]="wordWrapOverride1",Q[Q.wordWrapOverride2=138]="wordWrapOverride2",Q[Q.wrappingIndent=139]="wrappingIndent",Q[Q.wrappingStrategy=140]="wrappingStrategy",Q[Q.showDeprecated=141]="showDeprecated",Q[Q.inlayHints=142]="inlayHints",Q[Q.editorClassName=143]="editorClassName",Q[Q.pixelRatio=144]="pixelRatio",Q[Q.tabFocusMode=145]="tabFocusMode",Q[Q.layoutInfo=146]="layoutInfo",Q[Q.wrappingInfo=147]="wrappingInfo",Q[Q.defaultColorDecorators=148]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new r(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:Be(new I(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:Be(new C),accessibilityPageSize:Be(new c(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:Be(new d(je.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:Be(new r(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new r(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Be(new I(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:Be(new I(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:Be(new I(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:Be(new I(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:Be(new I(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:Be(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:Be(new r(je.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new I(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:Be(new Re),bracketPairGuides:Be(new Ue),stickyTabStops:Be(new r(je.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:Be(new r(je.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:Be(new d(je.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:Be(new c(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:Be(new r(je.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:Be(new I(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:Be(new c(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:Be(new r(je.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:Be(new P),contextmenu:Be(new r(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new r(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:Be(new D(je.cursorBlinking,"cursorBlinking",g.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:Be(new I(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:Be(new D(je.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(261,null)})),cursorSurroundingLines:Be(new c(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:Be(new I(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:Be(new c(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:Be(new r(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new r(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new r(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new r(je.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:Be(new B),dropIntoEditor:Be(new ct),stickyScroll:Be(new q),experimentalWhitespaceRendering:Be(new I(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:Be(new d(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new m(je.fastScrollSensitivity,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:a.localize(272,null)})),find:Be(new F),fixedOverflowWidgets:Be(new r(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new r(je.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:Be(new I(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:Be(new r(je.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:Be(new r(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:Be(new c(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:Be(new r(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:Be(new d(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:Be(new $e),fontLigatures2:Be(new V),fontSize:Be(new _),fontWeight:Be(new ge),fontVariations:Be(new ae),formatOnPaste:Be(new r(je.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:Be(new r(je.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:Be(new r(je.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:Be(new se),hideCursorInOverviewRuler:Be(new r(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:Be(new ce),inDiffEditor:Be(new r(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new m(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>m.clamp(Q,-5,20),{description:a.localize(286,null)})),lightbulb:Be(new Y),lineDecorationsWidth:Be(new ve),lineHeight:Be(new ue),lineNumbers:Be(new ke),lineNumbersMinChars:Be(new c(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new r(je.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:Be(new r(je.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:Be(new I(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:Be(new be),mouseStyle:Be(new I(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new m(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:Be(new r(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:k.$j?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:Be(new r(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:Be(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:Be(new I(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:Be(new c(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:Be(new I(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:Be(new r(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:Be(new c(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new X),pasteAs:Be(new st),parameterHints:Be(new Z),peekWidgetDefaultFocus:Be(new I(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:Be(new pe),definitionLinkOpensInPeek:Be(new r(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:Be(new Oe),quickSuggestionsDelay:Be(new c(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:Be(new r(je.readOnly,"readOnly",!1)),readOnlyMessage:Be(new j),renameOnType:Be(new r(je.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:Be(new r(je.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:Be(new I(je.renderFinalNewline,"renderFinalNewline",k.$k?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:Be(new I(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Be(new r(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:Be(new I(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new I(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:Be(new c(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new r(je.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:Be(new Ne),scrollbar:Be(new K),scrollBeyondLastColumn:Be(new c(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:Be(new r(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:Be(new r(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:Be(new r(je.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:k.$k})),selectionHighlight:Be(new r(je.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:Be(new r(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new I(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:Be(new r(je.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:Be(new r(je.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:Be(new ee),snippetSuggestions:Be(new I(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:Be(new tt),smoothScrolling:Be(new r(je.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:Be(new c(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new _e),inlineSuggest:Be(new ie),inlineEdit:Be(new fe),inlineCompletionsAccessibilityVerbose:Be(new r(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:Be(new c(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new c(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new r(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:Be(new I(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:Be(new I(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:Be(new c(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new H),unusualLineTerminators:Be(new I(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:Be(new r(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new r(je.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:Be(new I(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:Be(new nt),wordSeparators:Be(new d(je.wordSeparators,"wordSeparators",p.$jt,{description:a.localize(360,null)})),wordWrap:Be(new I(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:Be(new d(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new d(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new c(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:Be(new I(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new I(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new G),defaultColorDecorators:Be(new r(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:Be(new me),tabFocusMode:Be(new r(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:Be(new re),wrappingInfo:Be(new ft),wrappingIndent:Be(new rt),wrappingStrategy:Be(new Pe)}}),define(Ce[107],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,b.$Fi)("environmentService"),e.$Ni=(0,b.$Gi)(e.$Mi)}),define(Ce[30],Ie([1,0,59,20,13,15,2,174,3,21,16,47]),function(oe,e,b,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=s,e.$cl=h,e.$dl=i,e.$el=r,e.$fl=t,e.$gl=c,e.$hl=l,e.$il=m,e.$jl=d,e.$kl=$,e.$ml=v,e.$nl=C,e.$ol=P,e.$pl=g,e.$ql=w,e.$tl=B,e.$Fl=ge,e.$Gl=se,e.$Il=we,e.$_k=(0,p.$Fi)("fileService");function u(re){return re.create===!0}var E;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var f;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var n;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function s(re){const Pe=re;return!!Pe&&typeof Pe.onDidChange=="function"}var o;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function h(re){return!!(re.capabilities&o.FileReadWrite)}function i(re){return!!(re.capabilities&o.FileFolderCopy)}function r(re){return!!(re.capabilities&o.FileClone)}function t(re){return!!(re.capabilities&o.FileOpenReadWriteClose)}function c(re){return!!(re.capabilities&o.FileReadStream)}function l(re){return h(re)?!!(re.capabilities&o.FileAtomicRead):!1}function m(re){return h(re)?!!(re.capabilities&o.FileAtomicWrite):!1}function d(re){return!!(re.capabilities&o.FileAtomicDelete)}function $(re){return!!(re.capabilities&o.Readonly)}var I;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class D extends Error{static create(Pe,Me){const Y=new D(Pe.toString(),Me);return P(Y,Me),Y}constructor(Pe,Me){super(Pe),this.code=Me}}e.$ll=D;function v(re,Pe){return D.create(re,Pe)}function C(re){return re||v((0,T.localize)(0,null),I.Unknown)}function P(re,Pe){return re.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",re}function g(re){if(!re)return I.Unknown;if(re instanceof D)return re.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Pe)return I.Unknown;switch(Pe[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function w(re){if(re instanceof F)return re.fileOperationResult;switch(g(re)){case I.FileNotFound:return $e.FILE_NOT_FOUND;case I.FileIsADirectory:return $e.FILE_IS_DIRECTORY;case I.FileNotADirectory:return $e.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return $e.FILE_WRITE_LOCKED;case I.NoPermissions:return $e.FILE_PERMISSION_DENIED;case I.FileExists:return $e.FILE_MOVE_CONFLICT;case I.FileTooLarge:return $e.FILE_TOO_LARGE;default:return $e.FILE_OTHER_ERROR}}var M;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(Pe,Me,Y){this.resource=Pe,this.operation=Me,this.target=Y}isOperation(Pe){return this.operation===Pe}}e.$rl=N;var L;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class G{static{this.a=null}constructor(Pe,Me){this.c=Me,this.b=void 0,this.d=new y.$X(()=>{const Y=b.$Li.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new y.$X(()=>{const Y=b.$Li.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new y.$X(()=>{const Y=b.$Li.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Pe){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==G.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(Pe,...Me){return this.h(Pe,{includeChildren:!1},...Me)}affects(Pe,...Me){return this.h(Pe,{includeChildren:!0},...Me)}h(Pe,Me,...Y){if(!Pe)return!1;const q=Y.length>0;return!!((!q||Y.includes(L.ADDED))&&(this.d.value.get(Pe)||Me.includeChildren&&this.d.value.findSuperstr(Pe))||(!q||Y.includes(L.UPDATED))&&(this.f.value.get(Pe)||Me.includeChildren&&this.f.value.findSuperstr(Pe))||(!q||Y.includes(L.DELETED))&&(this.g.value.findSubstr(Pe)||Me.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$sl=G;function B(re,Pe,Me){return!re||!Pe||re===Pe||Pe.length>re.length?!1:(Pe.charAt(Pe.length-1)!==S.sep&&(Pe+=S.sep),Me?(0,k.$Hf)(re,Pe):re.indexOf(Pe)===0)}class F extends Error{constructor(Pe,Me,Y){super(Pe),this.fileOperationResult=Me,this.options=Y}}e.$ul=F;class V extends F{constructor(Pe,Me,Y,q){super(Pe,Me,q),this.fileOperationResult=Me,this.size=Y}}e.$vl=V;class ae extends F{constructor(Pe,Me,Y){super(Pe,$e.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Me}}e.$wl=ae;var $e;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})($e||(e.FileOperationResult=$e={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var _;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$El="";function ge(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function se(re,Pe){if(!Pe.hasProvider(A.URI.from({scheme:re.scheme})))return new Promise(Me=>{const Y=Pe.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===re.scheme&&q.added&&(Y.dispose(),Me())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Pe){return(0,O.$jg)(Pe)||(Pe=0),Pe<ce.KB?(0,T.localize)(1,null,Pe.toFixed(0)):Pe<ce.MB?(0,T.localize)(2,null,(Pe/ce.KB).toFixed(2)):Pe<ce.GB?(0,T.localize)(3,null,(Pe/ce.MB).toFixed(2)):Pe<ce.TB?(0,T.localize)(4,null,(Pe/ce.GB).toFixed(2)):(0,T.localize)(5,null,(Pe/ce.TB).toFixed(2))}}e.$Hl=ce;function we(re){const Pe=typeof re=="string"||re?.scheme===R.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===R.Schemas.file?1024*ce.MB:Pe?10*ce.MB:a.$o?50*ce.MB:1024*ce.MB}}),define(Ce[75],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class b{constructor(...k){this.a=new Map;for(const[O,A]of k)this.set(O,A)}set(k,O){const A=this.a.get(k);return this.a.set(k,O),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$Di=b}),define(Ce[211],Ie([1,0,11,14,4,74,208,3,75,212]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const R=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class u{constructor(s=new p.$Di,o=!1,h,i=R){this.i=s,this.j=o,this.k=h,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ei,this),this._globalGraph=i?h?._globalGraph??new A.$sr(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Rc)(this.h),this.h.clear();for(const s of this.g)(0,k.$Qc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s,o){this.m();const h=this,i=new class extends u{dispose(){h.h.delete(i),super.dispose()}}(s,this.j,this,this.l);return this.h.add(i),o?.add(i),i}invokeFunction(s,...o){this.m();const h=f.traceInvocation(this.l,s);let i=!1;try{return s({get:t=>{if(i)throw(0,S.$0)("service accessor is only valid during the invocation of its target method");const c=this.s(t,h);if(!c)throw new Error(`[invokeFunction] unknown service '${t}'`);return c}},...o)}finally{i=!0,h.stop()}}createInstance(s,...o){this.m();let h,i;return s instanceof O.$Ci?(h=f.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(o),h)):(h=f.traceCreation(this.l,s),i=this.o(s,o,h)),h.stop(),i}o(s,o=[],h){const i=T._util.getServiceDependencies(s).sort((c,l)=>c.index-l.index),r=[];for(const c of i){const l=this.s(c.id,h);l||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${c.id}.`,!1),r.push(l)}const t=i.length>0?i[0].index:o.length;if(o.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${o.length} static arguments`);const c=t-o.length;c>0?o=o.concat(new Array(c)):o=o.slice(0,t)}return Reflect.construct(s,o.concat(r))}q(s,o){if(this.i.get(s)instanceof O.$Ci)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const h=this.r(s);return h instanceof O.$Ci?this.u(s,h,o.branch(s,!0)):(o.branch(s,!1),h)}u(s,o,h){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,h)}finally{this.t.delete(s)}}v(s,o,h){const i=new A.$sr(c=>c.id.toString());let r=0;const t=[{id:s,desc:o,_trace:h}];for(;t.length;){const c=t.pop();if(i.lookupOrInsertNode(c),r++>1e3)throw new y(i);for(const l of T._util.getServiceDependencies(c.desc.ctor)){const m=this.r(l.id);if(m||this.y(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(l.id)),m instanceof O.$Ci){const d={id:l.id,desc:m,_trace:c._trace.branch(l.id,!0)};i.insertEdge(c,d),t.push(d)}}}for(;;){const c=i.roots();if(c.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:l}of c){if(this.r(l.id)instanceof O.$Ci){const d=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,d)}i.removeNode(l)}}return this.r(s)}w(s,o,h=[],i,r){if(this.i.get(s)instanceof O.$Ci)return this.x(s,o,h,i,r,this.g);if(this.k)return this.k.w(s,o,h,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,h=[],i,r,t){if(i){const c=new u(void 0,this.j,this,this.l);c.c=String(s);const l=new Map,m=new b.$Yh(()=>{const d=c.o(o,h,r);for(const[$,I]of l){const D=d[$];if(typeof D=="function")for(const v of I)v.disposable=D.apply(d,v.listener)}return l.clear(),t.add(d),d});return new Proxy(Object.create(null),{get(d,$){if(!m.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let v=l.get($);return v||(v=new a.$7c,l.set($,v)),(P,g,w)=>{if(m.isInitialized)return m.value[$](P,g,w);{const M={listener:[P,g,w],disposable:void 0},N=v.push(M);return(0,k.$Uc)(()=>{N(),M.disposable?.dispose()})}}}if($ in d)return d[$];const I=m.value;let D=I[$];return typeof D!="function"||(D=D.bind(I),d[$]=D),D},set(d,$,I){return m.value[$]=I,!0},getPrototypeOf(d){return o.prototype}})}else{const c=this.o(o,h,r);return t.add(c),c}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$tr=u;var E;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(E||(E={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new f(E.Invocation,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(s,o){return s?new f(E.Creation,o.name):f.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const h=new f(E.Branch,s.toString());return this.h.push([s,o,h]),h}stop(){const s=Date.now()-this.g;f.f+=s;let o=!1;function h(r,t){const c=[],l=new Array(r+1).join("	");for(const[m,d,$]of t.h)if(d&&$){o=!0,c.push(`${l}CREATES -> ${m}`);const I=h(r+1,$);I&&c.push(I)}else c.push(`${l}uses -> ${m}`);return c.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(s>2||o)&&f.all.add(i.join(`
`))}}e.$ur=f}),define(Ce[12],Ie([1,0,175,48,6,76,4,29,21,24,15,2,32,3]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=n,e.log=o,e.$nk=D,e.$ok=v,e.$pk=C,e.$qk=P,b=qe(b),e.$_j=(0,E.$Fi)("logService"),e.$ak=(0,E.$Fi)("loggerService");function f(){return new Date().toISOString()}function n(g){return(0,R.$jg)(g)}var s;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$ck=s.Info;function o(g,w,M){switch(w){case s.Trace:g.trace(M);break;case s.Debug:g.debug(M);break;case s.Info:g.info(M);break;case s.Warning:g.warn(M);break;case s.Error:g.error(M);break;case s.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function h(g,w=!1){let M="";for(let N=0;N<g.length;N++){let L=g[N];if(L instanceof Error&&(L=(0,S.$qj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(N>0?" ":"")+L}return M}class i extends A.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new k.$me),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==s.Off&&this.b<=w}}e.$ek=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...M){this.f(s.Trace)&&this.g(s.Trace,h([w,...M],!0))}debug(w,...M){this.f(s.Debug)&&this.g(s.Debug,h([w,...M]))}info(w,...M){this.f(s.Info)&&this.g(s.Info,h([w,...M]))}warn(w,...M){this.f(s.Warning)&&this.g(s.Warning,h([w,...M]))}error(w,...M){if(this.f(s.Error))if(w instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=w.stack,this.g(s.Error,h(N))}else this.g(s.Error,h([w,...M]))}flush(){}}e.$fk=r;class t extends i{constructor(w=e.$ck){super(),this.setLevel(w),this.g=!p.$i}trace(w,...M){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}debug(w,...M){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}info(w,...M){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}warn(w,...M){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...M):console.warn(`[main ${f()}]`,w,...M))}error(w,...M){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...M):console.error(`[main ${f()}]`,w,...M))}flush(){}}e.$gk=t;class c extends i{constructor(w=e.$ck,M=!0){super(),this.g=M,this.setLevel(w)}trace(w,...M){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...M):console.log(w,...M))}debug(w,...M){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...M):console.log(w,...M))}info(w,...M){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...M):console.log(w,...M))}warn(w,...M){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...M):console.log(w,...M))}error(w,...M){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...M):console.error(w,...M))}flush(){}}e.$hk=c;class l extends i{constructor(w,M=e.$ck){super(),this.g=w,this.setLevel(M)}trace(w,...M){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(w),...M])}debug(w,...M){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(w),...M])}info(w,...M){this.f(s.Info)&&this.g.log(s.Info,[this.h(w),...M])}warn(w,...M){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(w),...M])}error(w,...M){this.f(s.Error)&&this.g.log(s.Error,[this.h(w),...M])}h(w){return typeof w=="string"?w:(0,S.$qj)(w,this.f(s.Trace))}flush(){}}e.$ik=l;class m extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const M of this.g)M.setLevel(w);super.setLevel(w)}trace(w,...M){for(const N of this.g)N.trace(w,...M)}debug(w,...M){for(const N of this.g)N.debug(w,...M)}info(w,...M){for(const N of this.g)N.info(w,...M)}warn(w,...M){for(const N of this.g)N.warn(w,...M)}error(w,...M){for(const N of this.g)N.error(w,...M)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$jk=m;class d extends A.$Wc{constructor(w,M,N){if(super(),this.h=w,this.j=M,this.b=new T.$Cc,this.c=this.B(new k.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$me),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,R.$fg)(w)?[...this.b.values()].find(M=>M.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,M){const N=this.n(w),L=(0,R.$fg)(w)?w:M?.id??(0,O.$tj)(N.toString()).toString(16);let G=this.b.get(N)?.logger;const B=M?.logLevel==="always"?s.Trace:M?.logLevel;G||(G=this.s(N,B??this.getLogLevel(N)??this.h,{...M,id:L}));const F={logger:G,info:{resource:N,id:L,logLevel:B,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(F.info),this.b.set(N,F),G}n(w){return(0,R.$fg)(w)?(0,a.$gh)(this.j,`${w}.log`):w}setLogLevel(w,M){if(y.URI.isUri(w)){const N=w,L=M,G=this.b.get(N);G&&L!==G.info.logLevel&&(G.info.logLevel=L===this.h?void 0:L,G.logger?.setLevel(L),this.b.set(G.info.resource,G),this.f.fire([N,L]))}else{this.h=w;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,M){const N=this.m(w);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,M]))}getLogLevel(w){let M;return w&&(M=this.b.get(w)?.info.logLevel),M??this.h}registerLogger(w){const M=this.b.get(w.resource);M?M.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const M=this.b.get(w);M&&(M.logger&&M.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=d;class ${constructor(){this.onDidChangeLogLevel=new k.$me().event}setLevel(w){}getLevel(){return s.Info}trace(w,...M){}debug(w,...M){}info(w,...M){}warn(w,...M){}error(w,...M){}critical(w,...M){}dispose(){}flush(){}}e.$lk=$;class I extends ${}e.$mk=I;function D(g){if(g.verbose)return s.Trace;if(typeof g.logLevel=="string"){const w=P(g.logLevel.toLowerCase());if(w!==void 0)return w}return e.$ck}function v(g){switch(g){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function C(g){switch(g){case s.Trace:return{original:"Trace",value:b.localize(0,null)};case s.Debug:return{original:"Debug",value:b.localize(1,null)};case s.Info:return{original:"Info",value:b.localize(2,null)};case s.Warning:return{original:"Warning",value:b.localize(3,null)};case s.Error:return{original:"Error",value:b.localize(4,null)};case s.Off:return{original:"Off",value:b.localize(5,null)}}}function P(g){switch(g){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$rk=new u.$Wj("logLevel",v(s.Info))}),define(Ce[213],Ie([1,0,4,12]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class k extends b.$Wc{constructor(A,T=[]){super(),this.a=new S.$jk([A,...T]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$oR=k});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[108],Ie([1,0,36,176,3]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,b=ti(b);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function a(f,n){return n-f}p.compare=a;const R=Object.create(null);R[p.Error]=(0,S.localize)(0,null),R[p.Warning]=(0,S.localize)(1,null),R[p.Info]=(0,S.localize)(2,null);function y(f){return R[f]||""}p.toString=y;function u(f){switch(f){case b.default.Error:return p.Error;case b.default.Warning:return p.Warning;case b.default.Info:return p.Info;case b.default.Ignore:return p.Hint}}p.fromSeverity=u;function E(f){switch(f){case p.Error:return b.default.Error;case p.Warning:return b.default.Warning;case p.Info:return b.default.Info;case p.Hint:return b.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var T;(function(p){const a="";function R(u){return y(u,!0)}p.makeKey=R;function y(u,E){const f=[a];return u.source?f.push(u.source.replace("\xA6","\\\xA6")):f.push(a),u.code?typeof u.code=="string"?f.push(u.code.replace("\xA6","\\\xA6")):f.push(u.code.value.replace("\xA6","\\\xA6")):f.push(a),u.severity!==void 0&&u.severity!==null?f.push(A.toString(u.severity)):f.push(a),u.message&&E?f.push(u.message.replace("\xA6","\\\xA6")):f.push(a),u.startLineNumber!==void 0&&u.startLineNumber!==null?f.push(u.startLineNumber.toString()):f.push(a),u.startColumn!==void 0&&u.startColumn!==null?f.push(u.startColumn.toString()):f.push(a),u.endLineNumber!==void 0&&u.endLineNumber!==null?f.push(u.endLineNumber.toString()):f.push(a),u.endColumn!==void 0&&u.endColumn!==null?f.push(u.endColumn.toString()):f.push(a),f.push(a),f.join("\xA6")}p.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Cu=(0,k.$Fi)("markerService")});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[214],Ie([1,0,6,36,3]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sw=e.$rw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$pw=e.Severity=void 0,e.$qw=T,S=ti(S),e.Severity=S.default,e.$pw=(0,k.$Fi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class a{constructor(){this.progress=new R,this.onDidClose=b.Event.None,this.onDidChangeVisibility=b.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$rw=a;class R{infinite(){}done(){}total(u){}worked(u){}}e.$sw=R}),define(Ce[109],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,b.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(oe,e,b,S){var k=arguments.length,O=k<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,b):S,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(oe,e,b,S);else for(var T=oe.length-1;T>=0;T--)(A=oe[T])&&(O=(k<3?A(O):k>3?A(e,b,O):A(e,b))||O);return k>3&&O&&Object.defineProperty(e,b,O),O},Ve=this&&this.__param||function(oe,e){return function(b,S){e(b,S,oe)}};define(Ce[77],Ie([1,0,11,22,4,3]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.$uw=e.ProgressLocation=e.$tw=void 0,e.$tw=(0,O.$Fi)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$uw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$vw=T;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$ww=p;let a=class extends k.$Wc{constructor(u,E){super(),this.a=new b.$3h,E.withProgress(u,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,k.$Uc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$xw=a,e.$xw=a=Qe([Ve(1,e.$tw)],a);class R extends k.$Wc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new k.$Vc)}start(u){this.stop();const E=++this.a,f=new S.$xe;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,k.$Uc)(()=>clearTimeout(this.f))),this.b.add((0,k.$Uc)(()=>f.cancel())),this.b.add((0,k.$Uc)(()=>this.c?this.c.done():void 0)),{id:E,token:f.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$yw=R,e.$zw=(0,O.$Fi)("editorProgressService")}),define(Ce[31],Ie([1,0,62,15]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,b=qe(b),S=qe(S);class k{constructor(){this.a=new Map}add(A,T){b.ok(S.$fg(A)),b.ok(S.$hg(T)),b.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$qo=new k}),define(Ce[78],Ie([1,0,6,31]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,S=qe(S),e.$ro={JSONContribution:"base.contributions.json"};function k(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class O{constructor(){this.b=new b.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,a){this.a[k(p)]=a,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;S.$qo.add(e.$ro.JSONContribution,A)}),define(Ce[54],Ie([1,0,18,6,15,169,42,78,31]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=n,e.$Ho=s,e.$Io=o,e.$Jo=i,e.$Ko=r,k=qe(k),O=qe(O);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$vo={Configuration:"base.contributions.configuration"};var R;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const y=p.$qo.as(T.$ro.JSONContribution);class u{constructor(){this.h=new Set,this.i=new S.$me,this.onDidSchemaChange=this.i.event,this.j=new S.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$Co,this.g),this.v()}registerConfiguration(c,l=!0){this.registerConfigurations([c],l)}registerConfigurations(c,l=!0){const m=new Set;this.n(c,l,m),y.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:m})}deregisterConfigurations(c){const l=new Set;this.o(c,l),y.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:c,remove:l}){const m=new Set;this.o(l,m),this.n(c,!1,m),y.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:m})}registerDefaultConfigurations(c){const l=new Set;this.k(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(c,l){const m=[];for(const{overrides:d,source:$}of c)for(const I in d)if(l.add(I),e.$Fo.test(I)){const D=this.a.get(I),v=D?.valuesSources??new Map;if($)for(const w of Object.keys(d[I]))v.set(w,$);const C={...D?.value||{},...d[I]};this.a.set(I,{source:$,value:C,valuesSources:v});const P=(0,A.$jj)(I),g={type:"object",default:C,description:O.localize(1,null,P),$ref:e.$Co,defaultDefaultValue:C,source:k.$fg($)?void 0:$,defaultValueSource:$};m.push(...n(I)),this.d[I]=g,this.b.properties[I]=g}else{this.a.set(I,{value:d[I],source:$});const D=this.d[I];D&&(this.w(I,D),this.r(I,D))}this.m(m)}deregisterDefaultConfigurations(c){const l=new Set;this.l(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(c,l){for(const{overrides:m,source:d}of c)for(const $ in m){const I=this.a.get($),D=k.$fg(d)?d:d?.id,v=k.$fg(I?.source)?I?.source:I?.source?.id;if(D===v)if(l.add($),this.a.delete($),e.$Fo.test($))delete this.d[$],delete this.b.properties[$];else{const C=this.d[$];C&&(this.w($,C),this.r($,C))}}this.u()}deltaConfiguration(c){let l=!1;const m=new Set;c.removedDefaults&&(this.l(c.removedDefaults,m),l=!0),c.addedDefaults&&(this.k(c.addedDefaults,m),l=!0),c.removedConfigurations&&this.o(c.removedConfigurations,m),c.addedConfigurations&&this.n(c.addedConfigurations,!1,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...c){this.i.fire()}registerOverrideIdentifiers(c){this.m(c),this.i.fire()}m(c){for(const l of c)this.h.add(l);this.u()}n(c,l,m){c.forEach(d=>{this.p(d,l,d.extensionInfo,d.restrictedProperties,void 0,m),this.c.push(d),this.q(d)})}o(c,l){const m=d=>{if(d.properties)for(const $ in d.properties){l.add($);const I=this.d[$];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[$],this.s($,d.properties[$])}d.allOf?.forEach($=>m($))};for(const d of c){m(d);const $=this.c.indexOf(d);$!==-1&&this.c.splice($,1)}}p(c,l=!0,m,d,$=R.WINDOW,I){$=k.$og(c.scope)?$:c.scope;const D=c.properties;if(D)for(const C in D){const P=D[C];if(l&&i(C,P)){delete D[C];continue}if(P.source=m,P.defaultDefaultValue=D[C].default,this.w(C,P),e.$Fo.test(C)?P.scope=void 0:(P.scope=k.$og(P.scope)?$:P.scope,P.restricted=k.$og(P.restricted)?!!d?.includes(C):P.restricted),D[C].hasOwnProperty("included")&&!D[C].included){this.f[C]=D[C],delete D[C];continue}else this.d[C]=D[C],D[C].policy?.name&&this.e.set(D[C].policy.name,C);!D[C].deprecationMessage&&D[C].markdownDeprecationMessage&&(D[C].deprecationMessage=D[C].markdownDeprecationMessage),I.add(C)}const v=c.allOf;if(v)for(const C of v)this.p(C,l,m,d,$,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(c){const l=m=>{const d=m.properties;if(d)for(const I in d)this.r(I,d[I]);m.allOf?.forEach(l)};l(c)}r(c,l){switch(e.$wo.properties[c]=l,l.scope){case R.APPLICATION:e.$xo.properties[c]=l;break;case R.MACHINE:e.$yo.properties[c]=l;break;case R.MACHINE_OVERRIDABLE:e.$zo.properties[c]=l;break;case R.WINDOW:e.$Ao.properties[c]=l;break;case R.RESOURCE:e.$Bo.properties[c]=l;break;case R.LANGUAGE_OVERRIDABLE:e.$Bo.properties[c]=l,this.g.properties[c]=l;break}}s(c,l){switch(delete e.$wo.properties[c],l.scope){case R.APPLICATION:delete e.$xo.properties[c];break;case R.MACHINE:delete e.$yo.properties[c];break;case R.MACHINE_OVERRIDABLE:delete e.$zo.properties[c];break;case R.WINDOW:delete e.$Ao.properties[c];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[c],delete this.g.properties[c];break}}u(){for(const c of this.h.values()){const l=`[${c}]`,m={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Co};this.w(l,m),e.$wo.properties[l]=m,e.$xo.properties[l]=m,e.$yo.properties[l]=m,e.$zo.properties[l]=m,e.$Ao.properties[l]=m,e.$Bo.properties[l]=m}}v(){const c={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=c,e.$xo.patternProperties[e.$Eo]=c,e.$yo.patternProperties[e.$Eo]=c,e.$zo.patternProperties[e.$Eo]=c,e.$Ao.patternProperties[e.$Eo]=c,e.$Bo.patternProperties[e.$Eo]=c,this.i.fire()}w(c,l){const m=this.a.get(c);let d=m?.value,$=m?.source;k.$mg(d)&&(d=l.defaultDefaultValue,$=void 0),k.$mg(d)&&(d=o(l.type)),l.default=d,l.defaultValueSource=$}}const E="\\[([^\\]]+)\\]",f=new RegExp(E,"g");e.$Eo=`^(${E})+$`,e.$Fo=new RegExp(e.$Eo);function n(t){const c=[];if(e.$Fo.test(t)){let l=f.exec(t);for(;l?.length;){const m=l[1].trim();m&&c.push(m),l=f.exec(t)}}return(0,b.$Ob)(c)}function s(t){return t.reduce((c,l)=>`${c}[${l}]`,"")}function o(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$qo.add(e.$vo.Configuration,h);function i(t,c){return t.trim()?e.$Fo.test(t)?O.localize(7,null,t):h.getConfigurationProperties()[t]!==void 0?O.localize(8,null,t):c.policy?.name&&h.getPolicyConfigurations().get(c.policy?.name)!==void 0?O.localize(9,null,t,c.policy?.name,h.getPolicyConfigurations().get(c.policy?.name)):null:O.localize(6,null)}function r(){const t=[],c=h.getConfigurationProperties();for(const l of Object.keys(c))t.push([l,c[l].scope]);return t.push(["launch",R.RESOURCE]),t.push(["task",R.RESOURCE]),t}}),define(Ce[215],Ie([1,0,18,6,136,4,29,26,15,2,42,54,30,31]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=r,b=qe(b),k=qe(k),T=qe(T),p=qe(p);function f(m){return Object.isFrozen(m)?m:T.$eo(m)}class n{static createEmptyModel(d){return new n({},[],[],void 0,d)}constructor(d,$,I,D,v){this.b=d,this.c=$,this.d=I,this.raw=D,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const d=this.raw.map($=>{if($ instanceof n)return $;const I=new s("",this.f);return I.parseRaw($),I.configurationModel});this.g=d.reduce(($,I)=>I===$?I:$.merge(I),d[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,R.$hj)(this.contents,d):this.contents}inspect(d,$){const I=this;return{get value(){return f(I.rawConfiguration.getValue(d))},get override(){return $?f(I.rawConfiguration.getOverrideValue(d,$)):void 0},get merged(){return f($?I.rawConfiguration.override($).getValue(d):I.rawConfiguration.getValue(d))},get overrides(){const D=[];for(const{contents:v,identifiers:C,keys:P}of I.rawConfiguration.overrides){const g=new n(v,P,[],void 0,I.f).getValue(d);g!==void 0&&D.push({identifiers:C,value:g})}return D.length?f(D):void 0}}}getOverrideValue(d,$){const I=this.j($);return I?d?(0,R.$hj)(I,d):I:void 0}getKeysForOverrideIdentifier(d){const $=[];for(const I of this.overrides)I.identifiers.includes(d)&&$.push(...I.keys);return b.$Ob($)}getAllOverrideIdentifiers(){const d=[];for(const $ of this.overrides)d.push(...$.identifiers);return b.$Ob(d)}override(d){let $=this.a.get(d);return $||($=this.h(d),this.a.set(d,$)),$}merge(...d){const $=T.$do(this.contents),I=T.$do(this.overrides),D=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const C of d)if(v.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i($,C.contents);for(const P of C.overrides){const[g]=I.filter(w=>b.$wb(w.identifiers,P.identifiers));g?(this.i(g.contents,P.contents),g.keys.push(...P.keys),g.keys=b.$Ob(g.keys)):I.push(T.$do(P))}for(const P of C.keys)D.indexOf(P)===-1&&D.push(P)}return new n($,D,I,v.every(C=>C instanceof n)?void 0:v,this.f)}h(d){const $=this.j(d);if(!$||typeof $!="object"||!Object.keys($).length)return this;const I={};for(const D of b.$Ob([...Object.keys(this.contents),...Object.keys($)])){let v=this.contents[D];const C=$[D];C&&(typeof v=="object"&&typeof C=="object"?(v=T.$do(v),this.i(v,C)):v=C),I[D]=v}return new n(I,this.keys,this.overrides,void 0,this.f)}i(d,$){for(const I of Object.keys($)){if(I in d&&p.$hg(d[I])&&p.$hg($[I])){this.i(d[I],$[I]);continue}d[I]=T.$do($[I])}}j(d){let $=null,I=null;const D=v=>{v&&(I?this.i(I,v):I=T.$do(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===d?$=v.contents:v.identifiers.includes(d)&&D(v.contents);return D($),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,$){this.k(d,$,!0)}setValue(d,$){this.k(d,$,!1)}removeValue(d){const $=this.keys.indexOf(d);$!==-1&&(this.keys.splice($,1),(0,R.$gj)(this.contents,d),y.$Fo.test(d)&&this.overrides.splice(this.overrides.findIndex(I=>b.$wb(I.identifiers,(0,y.$Go)(d))),1))}k(d,$,I){(0,R.$fj)(this.contents,d,$,D=>this.f.error(D)),I=I||this.keys.indexOf(d)===-1,I&&this.keys.push(d),y.$Fo.test(d)&&this.overrides.push({identifiers:(0,y.$Go)(d),keys:Object.keys(this.contents[d]),contents:(0,R.$ej)(this.contents[d],D=>this.f.error(D))})}}e.$Lo=n;class s{constructor(d,$){this.f=d,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,$){if(!p.$og(d)){const I=this.h(d);this.parseRaw(I,$)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,$){this.a=d;const{contents:I,keys:D,overrides:v,restricted:C,hasExcludedProperties:P}=this.i(d,$);this.b=new n(I,D,v,P?[d]:void 0,this.g),this.c=C||[]}h(d){let $={},I=null,D=[];const v=[],C=[];function P(w){Array.isArray(D)?D.push(w):I!==null&&(D[I]=w)}const g={onObjectBegin:()=>{const w={};P(w),v.push(D),D=w,I=null},onObjectProperty:w=>{I=w},onObjectEnd:()=>{D=v.pop()},onArrayBegin:()=>{const w=[];P(w),v.push(D),D=w,I=null},onArrayEnd:()=>{D=v.pop()},onLiteralValue:P,onError:(w,M,N)=>{C.push({error:w,offset:M,length:N})}};if(d)try{k.$5n(d,g),$=D[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return $}i(d,$){const I=E.$qo.as(y.$vo.Configuration).getConfigurationProperties(),D=this.j(d,I,!0,$);d=D.raw;const v=(0,R.$ej)(d,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`)),C=Object.keys(d),P=this.l(d,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:v,keys:C,overrides:P,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(d,$,I,D){let v=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:v};const C={},P=[];for(const g in d)if(y.$Fo.test(g)&&I){const w=this.j(d[g],$,!1,D);C[g]=w.raw,v=v||w.hasExcludedProperties,P.push(...w.restricted)}else{const w=$[g],M=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&P.push(g),!D.exclude?.includes(g)&&(D.include?.includes(g)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&w?.restricted))?C[g]=d[g]:v=!0}return{raw:C,restricted:P,hasExcludedProperties:v}}l(d,$){const I=[];for(const D of Object.keys(d))if(y.$Fo.test(D)){const v={};for(const C in d[D])v[C]=d[D][C];I.push({identifiers:(0,y.$Go)(D),keys:Object.keys(v),contents:(0,R.$ej)(v,$)})}return I}}e.$Mo=s;class o extends O.$Wc{constructor(d,$,I,D,v){super(),this.c=d,this.f=$,this.g=D,this.h=v,this.b=this.B(new S.$me),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),v),this.B(this.g.watch(I.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(S.Event.any(S.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),S.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&I.isEqual(C.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=o;class h{constructor(d,$,I,D,v,C,P,g,w,M,N,L,G){this.a=d,this.b=$,this.c=I,this.overrideIdentifiers=D,this.d=v,this.f=C,this.g=P,this.h=g,this.i=w,this.j=M,this.k=N,this.l=L,this.m=G}get value(){return f(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(d,$,I,D,v,C,P,g,w,M){this.j=d,this.l=$,this.m=I,this.n=D,this.p=v,this.q=C,this.r=P,this.s=g,this.t=w,this.u=M,this.h=null,this.i=new A.$Cc,this.v=null}getValue(d,$,I){return this.w(d,$,I).getValue(d)}updateValue(d,$,I={}){let D;I.resource?(D=this.t.get(I.resource),D||(D=n.createEmptyModel(this.u),this.t.set(I.resource,D))):D=this.s,$===void 0?D.removeValue(d):D.setValue(d,$),I.resource||(this.h=null)}inspect(d,$,I){const D=this.w(d,$,I),v=this.A($.resource,I),C=$.resource?this.t.get($.resource)||this.s:this.s,P=new Set;for(const g of D.overrides)for(const w of g.identifiers)D.getOverrideValue(d,w)!==void 0&&P.add(w);return new h(d,$,D.getValue(d),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this.q:void 0,v||void 0,C)}keys(d){const $=this.A(void 0,d);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(d){this.j=d,this.h=null,this.i.clear()}updatePolicyConfiguration(d){this.l=d}updateApplicationConfiguration(d){this.m=d,this.h=null,this.i.clear()}updateLocalUserConfiguration(d){this.n=d,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(d){this.p=d,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(d){this.q=d,this.h=null,this.i.clear()}updateFolderConfiguration(d,$){this.r.set(d,$),this.i.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.i.delete(d)}compareAndUpdateDefaultConfiguration(d,$){const I=[];if(!$){const{added:D,updated:v,removed:C}=c(this.j,d);$=[...D,...v,...C]}for(const D of $)for(const v of(0,y.$Go)(D)){const C=this.j.getKeysForOverrideIdentifier(v),P=d.getKeysForOverrideIdentifier(v),g=[...P.filter(w=>C.indexOf(w)===-1),...C.filter(w=>P.indexOf(w)===-1),...C.filter(w=>!T.$ho(this.j.override(v).getValue(w),d.override(v).getValue(w)))];I.push([v,g])}return this.updateDefaultConfiguration(d),{keys:$,overrides:I}}compareAndUpdatePolicyConfiguration(d){const{added:$,updated:I,removed:D}=c(this.l,d),v=[...$,...I,...D];return v.length&&this.updatePolicyConfiguration(d),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:$,updated:I,removed:D,overrides:v}=c(this.applicationConfiguration,d),C=[...$,...I,...D];return C.length&&this.updateApplicationConfiguration(d),{keys:C,overrides:v}}compareAndUpdateLocalUserConfiguration(d){const{added:$,updated:I,removed:D,overrides:v}=c(this.localUserConfiguration,d),C=[...$,...I,...D];return C.length&&this.updateLocalUserConfiguration(d),{keys:C,overrides:v}}compareAndUpdateRemoteUserConfiguration(d){const{added:$,updated:I,removed:D,overrides:v}=c(this.remoteUserConfiguration,d),C=[...$,...I,...D];return C.length&&this.updateRemoteUserConfiguration(d),{keys:C,overrides:v}}compareAndUpdateWorkspaceConfiguration(d){const{added:$,updated:I,removed:D,overrides:v}=c(this.workspaceConfiguration,d),C=[...$,...I,...D];return C.length&&this.updateWorkspaceConfiguration(d),{keys:C,overrides:v}}compareAndUpdateFolderConfiguration(d,$){const I=this.folderConfigurations.get(d),{added:D,updated:v,removed:C,overrides:P}=c(I,$),g=[...D,...v,...C];return(g.length||!I)&&this.updateFolderConfiguration(d,$),{keys:g,overrides:P}}compareAndDeleteFolderConfiguration(d){const $=this.folderConfigurations.get(d);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:I,updated:D,removed:v,overrides:C}=c($,void 0);return{keys:[...I,...D,...v],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(d,$,I){let D=this.x($,I);return $.overrideIdentifier&&(D=D.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(d)!==void 0&&(D=D.merge(this.l)),D}x({resource:d},$){let I=this.y();if($&&d){const D=$.getFolder(d);D&&(I=this.z(D.uri)||I);const v=this.t.get(d);v&&(I=I.merge(v))}return I}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(d){let $=this.i.get(d);if(!$){const I=this.y(),D=this.r.get(d);D?($=I.merge(D),this.i.set(d,$)):$=I}return $}A(d,$){if($&&d){const I=$.getFolder(d);if(I)return this.r.get(I.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((d,$)=>{const{contents:I,overrides:D,keys:v}=this.r.get($);return d.push([$,{contents:I,overrides:D,keys:v}]),d},[])}}allKeys(){const d=new Set;return this.j.keys.forEach($=>d.add($)),this.userConfiguration.keys.forEach($=>d.add($)),this.q.keys.forEach($=>d.add($)),this.r.forEach($=>$.keys.forEach(I=>d.add(I))),[...d.values()]}B(){const d=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>d.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>d.add($)),this.q.getAllOverrideIdentifiers().forEach($=>d.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(I=>d.add(I))),[...d.values()]}D(d){const $=new Set;return this.j.getKeysForOverrideIdentifier(d).forEach(I=>$.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(I=>$.add(I)),this.q.getKeysForOverrideIdentifier(d).forEach(I=>$.add(I)),this.r.forEach(I=>I.getKeysForOverrideIdentifier(d).forEach(D=>$.add(D))),[...$.values()]}static parse(d,$){const I=this.E(d.defaults,$),D=this.E(d.policy,$),v=this.E(d.application,$),C=this.E(d.user,$),P=this.E(d.workspace,$),g=d.folders.reduce((w,M)=>(w.set(a.URI.revive(M[0]),this.E(M[1],$)),w),new A.$Cc);return new i(I,D,v,C,n.createEmptyModel($),P,g,n.createEmptyModel($),new A.$Cc,$)}static E(d,$){return new n(d.contents,d.keys,d.overrides,void 0,$)}}e.$Oo=i;function r(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const d=new Set,$=new Map;for(const D of m)D.keys.forEach(v=>d.add(v)),D.overrides.forEach(([v,C])=>{const P=(0,A.$zc)($,v,new Set);C.forEach(g=>P.add(g))});const I=[];return $.forEach((D,v)=>I.push([v,[...D.values()]])),{keys:[...d.values()],overrides:I}}class t{constructor(d,$,I,D,v){this.change=d,this.f=$,this.g=I,this.h=D,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of d.keys)this.affectedKeys.add(C);for(const[,C]of d.overrides)for(const P of C)this.affectedKeys.add(P);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(d,$){const I=this.a+d,D=this.d.indexOf(I);if(D<0)return!1;const v=D+I.length;if(v>=this.d.length)return!1;const C=this.d.charCodeAt(v);if(C!==this.b&&C!==this.c)return!1;if($){const P=this.previousConfiguration?this.previousConfiguration.getValue(d,$,this.f?.workspace):void 0,g=this.g.getValue(d,$,this.h);return!T.$ho(P,g)}return!0}}e.$Qo=t;function c(m,d){const{added:$,removed:I,updated:D}=l(d?.rawConfiguration,m?.rawConfiguration),v=[],C=m?.getAllOverrideIdentifiers()||[],P=d?.getAllOverrideIdentifiers()||[];if(d){const g=P.filter(w=>!C.includes(w));for(const w of g)v.push([w,d.getKeysForOverrideIdentifier(w)])}if(m){const g=C.filter(w=>!P.includes(w));for(const w of g)v.push([w,m.getKeysForOverrideIdentifier(w)])}if(d&&m){for(const g of C)if(P.includes(g)){const w=l({contents:m.getOverrideValue(void 0,g)||{},keys:m.getKeysForOverrideIdentifier(g)},{contents:d.getOverrideValue(void 0,g)||{},keys:d.getKeysForOverrideIdentifier(g)});v.push([g,[...w.added,...w.removed,...w.updated]])}}return{added:$,removed:I,updated:D,overrides:v}}function l(m,d){const $=m?d?m.keys.filter(v=>d.keys.indexOf(v)===-1):[...m.keys]:[],I=d?m?d.keys.filter(v=>m.keys.indexOf(v)===-1):[...d.keys]:[],D=[];if(m&&d){for(const v of d.keys)if(m.keys.indexOf(v)!==-1){const C=(0,R.$hj)(d.contents,v),P=(0,R.$hj)(m.contents,v);T.$ho(C,P)||D.push(v)}}return{added:$,removed:I,updated:D}}}),define(Ce[110],Ie([1,0,14,3]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=a,e.$Ql=(0,S.$Fi)("remoteAuthorityResolverService");var k;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class O{constructor(y){this.id=y,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class A{constructor(y,u){this.host=y,this.port=u,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=A;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends b.$db{static isNotAvailable(y){return y instanceof p&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof p&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof p&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof p&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof p&&y.isHandled}constructor(y,u=T.Unknown,E){super(y),this._message=y,this._code=u,this._detail=E,this.isHandled=u===T.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Tl=p;function a(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}}),define(Ce[63],Ie([1,0,16]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=S,e.$hn=k,e.$in=O,e.$jn=A;function S(p){return p.scheme===b.Schemas.vscodeRemote?p.authority:void 0}function k(p){if(!p)return;const a=p.indexOf("+");return a<0?p:p.substr(0,a)}function O(p){const{host:a,port:R}=T(p);if(typeof R>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:R}}function A(p,a){let{host:R,port:y}=T(p);return typeof y>"u"&&(y=a),{host:R,port:y}}function T(p){const a=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const R=p.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(Ce[19],Ie([1,0,13,3,63]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=y,e.$un=u,e.$vn=E,e.$wn=f,e.$xn=n,e.$yn=s,b=qe(b),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(o){o.WIN32_X64="win32-x64",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,i){if(typeof h>"u"||h===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof h=="string"||typeof i=="string"){const r=typeof h=="string"?h:h.value,t=typeof i=="string"?i:i.value;return b.$Gf(r,t)}return h._lower===i._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$qn=p;class a{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const i of h)this.add(i)}add(h){this.c.add(p.toKey(h))}delete(h){return this.c.delete(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}}e.$rn=a;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(p.toKey(h))}get(h){return this.c.get(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}set(h,i){this.c.set(p.toKey(h),i)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=R;function y(o){return u(o)}function u(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}function E(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}function f(o,h){if(h){const i=`onResolveRemoteAuthority:${(0,k.$hn)(h)}`;return!!o.activationEvents?.includes(i)}return!1}function n(o){return o.map(h=>{const[i,r]=h.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function s(o){return o.map(h=>h.split("@")[0])}e.$zn=(0,S.$Fi)("IBuiltinExtensionsScannerService")}),define(Ce[111],Ie([1,0,21,172,19,3]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=T,e.$dp=p,e.$ep=a,e.$fp=R,e.$gp=y,e.$hp=u,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function p(t){switch(t){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function a(t,c){switch(t){case b.Platform.Windows:return c==="x64"?k.TargetPlatform.WIN32_X64:c==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case b.Platform.Linux:return c==="x64"?k.TargetPlatform.LINUX_X64:c==="arm64"?k.TargetPlatform.LINUX_ARM64:c==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return c==="x64"?k.TargetPlatform.ALPINE_X64:c==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case b.Platform.Mac:return c==="x64"?k.TargetPlatform.DARWIN_X64:c==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case b.Platform.Web:return k.TargetPlatform.WEB}}function R(t,c){return c===k.TargetPlatform.WEB&&!t.includes(k.TargetPlatform.WEB)}function y(t,c,l){return R(c,l)?!1:t===k.TargetPlatform.UNDEFINED||t===k.TargetPlatform.UNIVERSAL?!0:t===k.TargetPlatform.UNKNOWN?!1:t===l}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.$ip=(0,O.$Fi)("extensionGalleryService");var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(o||(e.ExtensionGalleryErrorCode=o={}));class h extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$jp=h;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$kp=r,e.$lp=(0,O.$Fi)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$pp=(0,O.$Fi)("IExtensionTipsService"),e.$qp=(0,S.localize2)(0,"Extensions"),e.$rp=(0,S.localize2)(1,"Preferences")}),define(Ce[112],Ie([1,0,14,19]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=void 0;class k{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const p of A){const a=this.readActivationEvents(p);a.length>0&&(T[S.$qn.toKey(p.identifier)]=a)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${S.$qn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const p in A.contributes){const a=this.a.get(p);if(!a)continue;const R=A.contributes[p],y=Array.isArray(R)?R:[R];try{a(y,T)}catch(u){(0,b.$3)(u)}}return T}}e.$LG=k,e.$MG=new k});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[216],Ie([1,0,24,36,173,323,19,105]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=R,e.$Xp=y,e.$Yp=u,e.$Zp=E,e.$1p=f,e.$2p=n,e.$3p=s,e.$4p=o,S=ti(S),k=qe(k),O=qe(O);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function R(r){return r=r.trim(),r==="*"||p.test(r)}function y(r){if(!R(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(r){if(!r)return null;const t=r.majorBase,c=r.majorMustEqual,l=r.minorBase;let m=r.minorMustEqual;const d=r.patchBase;let $=r.patchMustEqual;r.hasCaret&&(t===0||(m=!1),$=!1);let I=0;if(r.preRelease){const D=a.exec(r.preRelease);if(D){const[,v,C,P]=D;I=Date.UTC(Number(v),Number(C)-1,Number(P))}}return{majorBase:t,majorMustEqual:c,minorBase:l,minorMustEqual:m,patchBase:d,patchMustEqual:$,isMinimum:r.hasGreaterEquals,notBefore:I}}function E(r,t,c){let l;typeof r=="string"?l=u(y(r)):l=r;let m;t instanceof Date?m=t.getTime():typeof t=="string"&&(m=new Date(t).getTime());let d;if(typeof c=="string"?d=u(y(c)):d=c,!l||!d)return!1;const $=l.majorBase,I=l.minorBase,D=l.patchBase;let v=d.majorBase,C=d.minorBase,P=d.patchBase;const g=d.notBefore;let w=d.majorMustEqual,M=d.minorMustEqual,N=d.patchMustEqual;return d.isMinimum?$>v?!0:$<v?!1:I>C?!0:I<C||m&&m<g?!1:D>=P:($===1&&v===0&&(!w||!M||!N)&&(v=1,C=0,P=0,w=!0,M=!1,N=!1),$<v?!1:$>v?!w:I<C?!1:I>C?!M:D<P?!1:D>P?!N:!(m&&m<g))}function f(r,t,c,l,m){const d=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return d.push([S.default.Error,k.localize(0,null)]),d;if(typeof l.name!="string")return d.push([S.default.Error,k.localize(1,null,"name")]),d;if(typeof l.version!="string")return d.push([S.default.Error,k.localize(2,null,"version")]),d;if(!l.engines)return d.push([S.default.Error,k.localize(3,null,"engines")]),d;if(typeof l.engines.vscode!="string")return d.push([S.default.Error,k.localize(4,null,"engines.vscode")]),d;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return d.push([S.default.Error,k.localize(5,null,"extensionDependencies")]),d;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return d.push([S.default.Error,k.localize(6,null,"activationEvents")]),d;if(typeof l.main>"u"&&typeof l.browser>"u")return d.push([S.default.Error,k.localize(7,null,"activationEvents","main","browser")]),d}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&d.push([S.default.Warning,k.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return d.push([S.default.Error,k.localize(9,null,"main")]),d;{const D=(0,b.$gh)(c,l.main);(0,b.$ah)(D,c)||d.push([S.default.Warning,k.localize(10,null,D.path,c.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return d.push([S.default.Error,k.localize(11,null,"browser")]),d;{const D=(0,b.$gh)(c,l.browser);(0,b.$ah)(D,c)||d.push([S.default.Warning,k.localize(12,null,D.path,c.path)])}}if(!O.valid(l.version))return d.push([S.default.Error,k.localize(13,null)]),d;const $=[];if(!n(r,t,l,m,$))for(const D of $)d.push([S.default.Error,D]);if(l.enabledApiProposals?.length){const D=[];if(!o([...l.enabledApiProposals],D))for(const v of D)d.push([S.default.Error,v])}return d}function n(r,t,c,l,m){return l||typeof c.main>"u"&&typeof c.browser>"u"?!0:h(r,t,c.engines.vscode,m)}function s(r,t,c){return r==="*"||h(t,c,r)}function o(r,t){if(r.length===0)return!0;const c=Array.isArray(t)?t:void 0,l=(c?void 0:t)??T.allApiProposals,m=[],d=(0,A.$xn)(r);for(const{proposalName:$,version:I}of d){const D=l[$];D&&I&&D.version!==I&&(D.version?m.push(k.localize(14,null,$,I,D.version)):m.push(k.localize(15,null,$,I)))}return c?.push(...m),m.length===0}function h(r,t,c,l=[]){const m=u(y(c));if(!m)return l.push(k.localize(16,null,c)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return l.push(k.localize(17,null,c)),!1}else if(!m.majorMustEqual)return l.push(k.localize(18,null,c)),!1;return E(r,t,m)?!0:(l.push(k.localize(19,null,r,c)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,c=r.length;t<c;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Ce[217],Ie([1,0,23,14,4,177,54,3,12,31]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=u,e.$8p=E,e.$9p=f,e.$0p=n,e.$$p=s,e.$_p=o,e.$5p=(0,T.$Fi)("requestService");class R{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const c in this.b)c.toLowerCase()==="authorization"||c.toLowerCase()==="proxy-authorization"?t[c]="*****":t[c]=this.b[c];this.a=t}return this.a}}class y extends k.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(0,null),when:p.$rk.isEqualTo((0,p.$ok)(p.LogLevel.Trace)).serialize()})}async c(t,c,l){const m=`${t} #${++this.b}: ${c.url}`;this.a.trace(`${m} - begin`,c.type,new R(c.headers??{}));try{const d=await l();return this.a.trace(`${m} - end`,c.type,d.res.statusCode,d.res.headers),d}catch(d){throw this.a.error(`${m} - error`,c.type,(0,S.$_)(d)),d}}}e.$6p=y;function u(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function E(r){return r.res.statusCode===204}async function f(r){return E(r)?null:(await(0,b.$1e)(r.stream)).toString()}async function n(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);return f(r)}async function s(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);if(E(r))return null;const c=(await(0,b.$1e)(r.stream)).toString();try{return JSON.parse(c)}catch(l){throw l.message+=`:
`+c,l}}function o(r){i(r)}let h;function i(r){const t=a.$qo.as(A.$vo.Configuration),c=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[h],remove:c?[c]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ce[218],Ie([1,0,21,79,37]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=A,e.$tp=T;function O(p){if(b.$u===b.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,a,R,y,u,E,f,n,s,o){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=f,h["common.devDeviceId"]=n,h.sessionID=(0,k.$2g)()+Date.now(),h.commitHash=y,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,b.$h)(b.$u),h["common.nodePlatform"]=S.$fc,h["common.nodeArch"]=R,h["common.product"]=o||"desktop",s&&(h["common.msftInternal"]=s);let i=0;const r=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),b.$l&&(h["common.snap"]="true");const t=O(a);return t&&(h["common.platformDetail"]=t),h}function T(p){const a=S.env.USERDNSDOMAIN;if(!a)return!1;const R=a.toLowerCase();return p.some(y=>R===y)}}),define(Ce[113],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,b.$Fi)("telemetryService"),e.$_l=(0,b.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var S;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(S||(e.TelemetryLevel=S={}));var k;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(Ce[64],Ie([1,0,26,15,63,218,113]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=R,e.$Cp=y,e.$Dp=u,e.$Ep=E,e.$Fp=n,e.$Gp=o,e.$Hp=h,e.$Ip=t;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$up=T;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=p,e.$wp=new p;class a{async publicLog(l,m,d){}async publicLogError(l,m,d){}}e.$xp=a,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function R(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry)}function y(c,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}function u(c){const l=c.getValue(A.$hm),m=c.getValue(A.$im);if(c.getValue(A.$jm)===!1||m===!1)return A.TelemetryLevel.NONE;switch(l??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function E(c){const l={},m={},d={};s(c,d);for(let $ in d){$=$.length>150?$.substr($.length-149):$;const I=d[$];typeof I=="number"?m[$]=I:typeof I=="boolean"?m[$]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${I.length}`),l[$]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(l[$]=I)}return{properties:l,measurements:m}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(c){if(!c)return"none";const l=(0,k.$hn)(c);return f.has(l)?l:"other"}function s(c,l,m=0,d){if(c)for(const $ of Object.getOwnPropertyNames(c)){const I=c[$],D=d?d+$:$;Array.isArray(I)?l[D]=(0,b.$io)(I):I instanceof Date?l[D]=I.toISOString():(0,S.$hg)(I)?m<2?s(I,l,m+1,D+"."):l[D]=(0,b.$io)(I):l[D]=I}}function o(c,l){const m=c.msftInternalDomains||[],d=l.getValue("telemetry.internalTesting");return(0,O.$tp)(m)||d}function h(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}function i(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let m=c;const d=[];for(const v of l)for(;;){const C=v.exec(c);if(!C)break;d.push([C.index,v.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(m="";;){const v=I.exec(c);if(!v)break;const C=d.some(([P,g])=>v.index<g&&P<I.lastIndex);!$.test(v[0])&&!C&&(m+=c.substring(D,v.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<c.length&&(m+=c.substr(D)),m}function r(c){if(!c)return c;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of l)if(m.regex.test(c))return`<REDACTED: ${m.label}>`;return c}function t(c,l){return(0,b.$fo)(c,m=>{if(m instanceof T||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let d=m.replaceAll("%20"," ");d=i(d,l);for(const $ of l)d=d.replace($,"");return d=r(d),d}})}}),define(Ce[219],Ie([1,0,13,111,19,21,2,14,79,64]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=R,e.$Lp=f,e.$Mp=n,e.$Np=s,e.$Op=o,e.$Pp=h,e.$Qp=i,e.$Rp=r,e.$Tp=t,e.$Up=l;function R(m,d){return m.uuid&&d.uuid?m.uuid===d.uuid:m.id===d.id?!0:(0,b.$Bf)(m.id,d.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(d){const $=d.manifest?d.manifest.version:d.version,I=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new u(d.identifier,$,I)}static parse(d){const $=y.exec(d);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(d,$,I=k.TargetPlatform.UNDEFINED){this.identifier=d,this.version=$,this.targetPlatform=I,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof u?R(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Kp=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(m){const d=E.exec(m);return d&&d[1]?[s(d[1]),d[2]]:[s(m),void 0]}function n(m,d){return`${m}.${d}`}function s(m){return m.toLowerCase()}function o(m,d){return s(n(m??k.$mn,d))}function h(m,d){const $=[],I=D=>{for(const v of $)if(v.some(C=>R(d(C),d(D))))return v;return null};for(const D of m){const v=I(D);v?v.push(D):$.push([D])}return $}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function r(m){return{id:new a.$up(m.identifier.id),name:new a.$up(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Sp=new k.$qn("pprice.better-merge");function t(m,d){const $=[],I=d.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const D=I.shift();if(D&&$.every(v=>!R(v.identifier,{id:D}))){const v=m.filter(C=>R(C.identifier,{id:D}));v.length===1&&($.push(v[0]),I.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function c(m,d){if(!O.$k)return!1;let $;try{$=(await m.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await m.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){d.debug("Error while getting the os-release file.",(0,T.$_)(D))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(m,d){const $=await c(m,d),I=(0,S.$ep)($?"alpine":O.$u,p.$gc);return d.debug("ComputeTargetPlatform:",I),I}}),define(Ce[220],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=b,e.$Ds=S,e.$Es=k,e.$Fs=O,e.$Gs=A,e.$Hs=T;function b(p){return[...p.entries()]}function S(p){return p?[...p.entries()]:[]}function k(p){return new Map(p)}function O(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(a=>[a[0],b(a[1].map),S(a[1].descriptionMap)])}function T(p){return new Map(p.map(a=>[a[0],{map:k(a[1]),descriptionMap:O(a[2])}]))}}),define(Ce[221],Ie([1,0,3,32,31]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new S.$Wj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var R;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ms=(0,b.$Fi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var E;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var o;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(o||(e.ProfileSource=o={}));var h;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(c){const l=this.b(c.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,c)}getTerminalBackend(c){return this.a.get(this.b(c))}b(c){return c?.toLowerCase()??""}}k.$qo.add(e.$ns.Backend,new r),e.$os=(0,b.$Fi)("localPtyService"),e.$ps=(0,b.$Fi)("terminalLogService")}),define(Ce[222],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wxb=void 0;class b{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,O,A=5){const T=O(p=>{const a=typeof p=="string"?p:p.data;let R=this.a.get(k);if(R){R.data.push(a);return}const y=setTimeout(()=>this.flushBuffer(k),A);R={data:[a],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(k),T.dispose()}},this.a.set(k,R)});return T}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const O=this.a.get(k);O&&(this.a.delete(k),this.b(k,O.data.join("")))}}e.$wxb=b}),define(Ce[223],Ie([1,0,11,98,324,35,6,15,2,178,78,31]),function(oe,e,b,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.$zx=e.IconFontDefinition=e.IconContribution=e.$wx=void 0,e.$xx=s,e.$yx=o,y=qe(y),e.$wx={IconContribution:"base.contributions.icons"};var u;(function(t){function c(l,m){let d=l.defaults;for(;O.ThemeIcon.isThemeIcon(d);){const $=n.getIcon(d.id);if(!$)return;d=$.defaults}return d}t.getDefinition=c})(u||(e.IconContribution=u={}));var E;(function(t){function c(m){return{weight:m.weight,style:m.style,src:m.src.map(d=>({format:d.format,location:d.location.toString()}))}}t.toJSONObject=c;function l(m){const d=$=>(0,T.$fg)($)?$:void 0;if(m&&Array.isArray(m.src)&&m.src.every($=>(0,T.$fg)($.format)&&(0,T.$fg)($.location)))return{weight:d(m.weight),style:d(m.style),src:m.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}t.fromJSONObject=l})(E||(e.IconFontDefinition=E={}));class f{constructor(){this.a=new A.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,l,m,d){const $=this.b[c];if($){if(m&&!$.description){$.description=m,this.d.properties[c].markdownDescription=`${m} $(${c})`;const v=this.e.enum.indexOf(c);v!==-1&&(this.e.enumDescriptions[v]=m),this.a.fire()}return $}const I={id:c,description:m,defaults:l,deprecationMessage:d};this.b[c]=I;const D={$ref:"#/definitions/icons"};return d&&(D.deprecationMessage=d),m&&(D.markdownDescription=`${m}: $(${c})`),this.d.properties[c]=D,this.e.enum.push(c),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const l=this.e.enum.indexOf(c);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,l){const m=this.f[c];return m||(this.f[c]=l,this.a.fire(),l)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=($,I)=>$.id.localeCompare(I.id),l=$=>{for(;O.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map($=>this.b[$]);for(const $ of d.filter(I=>!!I.description).sort(c))m.push(`|<i class="${l($)}"></i>|${$.id}|${O.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const $ of d.filter(I=>!O.ThemeIcon.isThemeIcon(I.defaults)).sort(c))m.push(`|<i class="${l($)}"></i>|${$.id}|`);return m.join(`
`)}}const n=new f;y.$qo.add(e.$wx.IconContribution,n);function s(t,c,l,m){return n.registerIcon(t,c,l,m)}function o(){return n}function h(){const t=(0,k.$1j)();for(const c in t){const l="\\"+t[c].toString(16);n.registerIcon(c,{fontCharacter:l})}}h(),e.$zx="vscode://schemas/icons";const i=y.$qo.as(R.$ro.JSONContribution);i.registerSchema(e.$zx,n.getIconSchema());const r=new b.$Rh(()=>i.notifySchemaChanged(e.$zx),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Ax=s("widget-close",S.$5j.close,(0,a.localize)(2,null)),e.$Bx=s("goto-previous-location",S.$5j.arrowUp,(0,a.localize)(3,null)),e.$Cx=s("goto-next-location",S.$5j.arrowDown,(0,a.localize)(4,null)),e.$Dx=O.ThemeIcon.modify(S.$5j.sync,"spin"),e.$Ex=O.ThemeIcon.modify(S.$5j.loading,"spin")}),define(Ce[224],Ie([1,0,6,4,21,2,42,3,12]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Kw=e.$Hw=e.$Fw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bw=e.$Aw=void 0,e.$Cw=y,e.$Dw=E,e.$Ew=f,e.$Gw=n,e.$Iw=s,e.$Jw=o,e.$Aw=(0,T.$Fi)("tunnelService"),e.$Bw=(0,T.$Fi)("sharedTunnelsService");var a;(function(r){r.Http="http",r.Https="https"})(a||(e.TunnelProtocol=a={}));var R;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(R||(e.TunnelPrivacyId=R={}));function y(r){return!!r.forwardPort}var u;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function f(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const c of t){const l=c.split("=")[1];if(/^https?:/.exec(l)){const m=E(O.URI.parse(l));if(m)return m}}}e.$Fw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Fw.indexOf(r)>=0}e.$Hw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(r){return e.$Hw.indexOf(r)>=0}function o(r,t,c,l){if(c===k.OperatingSystem.Windows)return!1;if(c===k.OperatingSystem.Macintosh&&s(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(m?.length===4&&parseInt(m[1])>=18)return!1}return r<1024}class h{constructor(t,c,l){this.remoteAddress=t,this.localAddress=c,this.b=l,this.a=new b.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Kw=h;let i=class extends S.$Wc{constructor(t,c){super(),this.r=t,this.s=c,this.a=new b.$me,this.onTunnelOpened=this.a.event,this.b=new b.$me,this.onTunnelClosed=this.b.event,this.c=new b.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],c=Array.from(this.f.values());for(const l of c){const m=Array.from(l.values());for(const d of m){const $=await d.value;$&&typeof $!="string"&&t.push($)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:c}of t.values())await c.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,c,l,m,d){this.z(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:l,privacy:m,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(s(t)||n(t))&&(t=e.$Fw[0]);const l=this.D(t,c);if(l)return++l.refcount,l.value}openTunnel(t,c,l,m,d,$=!1,I,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${l} on local port ${d}.`);const v=this.g??t;if(!v)return;if(c||(c="localhost"),m||(m=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(v,c,l,m,d,$,I,D);return C?C.then(P=>{if(P){if(typeof P=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(c,l),P}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(c,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.w(P);return(P.tunnelRemoteHost!==c||P.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),I&&P.privacy!==I&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.f.get(t.tunnelRemoteHost);if(c){const l=c.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,c,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const m=l.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(c),m}}async closeTunnel(t,c){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const l=this.f.get(t);if(l&&l.has(c)){const m=l.get(c);m.refcount=0,await this.y(t,c,m)}}z(t,c,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(c,{refcount:1,value:l})}async C(t,c){const l=this.f.get(t);if(l){const m=l.get(c),d=m?await m.value:void 0;(!d||typeof d=="string")&&l.delete(c),l.size===0&&this.f.delete(t)}}D(t,c){const l=[t];n(t)?(l.push(...e.$Fw),l.push(...e.$Hw)):s(t)&&l.push(...e.$Hw);const m=l.map(d=>this.f.get(d));for(const d of m){const $=d?.get(c);if($)return $}}canTunnel(t){return!!E(t)}G(t,c,l,m,d,$,I){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${l} on local port ${m}.`);const D=l;this.n.add(D);const v=m===void 0?l:m,C={elevationRequired:d?this.isPortPrivileged(v):!1},P={remoteAddress:{host:c,port:l},localAddressPort:m,privacy:$,public:$?$!==R.Private:void 0,protocol:I},g=t.forwardPort(P,C);return g?(this.z(c,l,g),g.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),g}};e.$Lw=i,e.$Lw=i=Qe([Ve(0,p.$_j),Ve(1,A.$_i)],i)}),define(Ce[225],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,b.$Fi)("IUriIdentityService")}),define(Ce[226],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Mw=void 0,e.$Mw=(0,b.$Fi)("editSessionIdentityService");var S;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(S||(e.EditSessionIdentityMatch=S={}))}),define(Ce[227],Ie([1,0,16]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=S,e.$5M=k,e.$6M=O,e.$7M=A,e.$8M=T;function S(p){return p.scheme!==b.Schemas.file&&p.scheme!==b.Schemas.vscodeRemote}function k(p){if(p.folders.length)return p.folders.every(a=>S(a.uri))?p.folders[0].uri:void 0;if(p.configuration&&S(p.configuration))return p.configuration}function O(p){return k(p)?.scheme}function A(p){return k(p)?.authority}function T(p){return k(p)!==void 0}}),define(Ce[50],Ie([1,0,180,20,59,24,2,3,16]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=a,e.$Qi=R,e.$Ti=y,e.$Ui=u,e.$Vi=E,e.$Wi=n,e.$Xi=s,e.$1i=i,e.$6i=r,e.$7i=t,e.$9i=c,e.$0i=l,e.$$i=m,e.$Oi=(0,T.$Fi)("contextService");function a(d){const $=d;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function R(d){return typeof d?.id=="string"&&!a(d)&&!u(d)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function y(d,$){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,S.$pc)(d)}:$?e.$Ri:e.$Si;const I=d;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function u(d){const $=d;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function E(d){const $=d;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const I=d;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(d?.id)return{id:d.id}}var f;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function n(d){const $=d;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function s(d){const $=d;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class o{constructor($,I,D,v,C){this.h=$,this.j=D,this.k=v,this.l=C,this.c=k.$Li.forUris(this.l,()=>!0),this.folders=I}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=k.$Li.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=o;class h{constructor($,I){this.raw=I,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,O.$gh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=h;function i(d){return new h({uri:d,index:0,name:(0,O.$ch)(d)},{uri:d.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,b.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function r(d,$){return O.$0g.isEqualOrParent(d,$.untitledWorkspacesHome)}function t(d){let $;return A.URI.isUri(d)?$=d:$=d.configuration,$?.scheme===p.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function c(d){return d.id===e.$8i}function l(d,$){return!r(d,$)&&!t(d)}function m(d){return(typeof d=="string"?(0,S.$qc)(d):(0,O.$eh)(d))===e.$3i}}),define(Ce[114],Ie([1,0,76,6,4,24,2,179,107,30,3,12,50,29,225,11,37,13,15]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=r,e.$Ml=t,e.$Nl=c;var i;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(d){const $=d;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$Ll=(0,R.$Fi)("IUserDataProfilesService");function t(d,$){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:A.URI.revive(d.location).with({scheme:$}),globalStorageHome:A.URI.revive(d.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(d.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(d.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(d.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(d.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(d.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(d.cacheHome).with({scheme:$}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}function c(d,$,I,D,v,C){return{id:d,name:$,location:I,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:C&&v?.useDefaultFlags?.globalState?C.globalStorageHome:(0,O.$gh)(I,"globalStorage"),settingsResource:C&&v?.useDefaultFlags?.settings?C.settingsResource:(0,O.$gh)(I,"settings.json"),keybindingsResource:C&&v?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,O.$gh)(I,"keybindings.json"),tasksResource:C&&v?.useDefaultFlags?.tasks?C.tasksResource:(0,O.$gh)(I,"tasks.json"),snippetsHome:C&&v?.useDefaultFlags?.snippets?C.snippetsHome:(0,O.$gh)(I,"snippets"),extensionsResource:C&&v?.useDefaultFlags?.extensions?C.extensionsResource:(0,O.$gh)(I,"extensions.json"),cacheHome:(0,O.$gh)(D,d),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let l=class extends k.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,I,D,v){super(),this.t=$,this.u=I,this.w=D,this.y=v,this.f=!0,this.h=this.B(new S.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new S.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new S.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new S.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Cc,workspaces:new E.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),I=[$];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,h.$fg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}I.push(c((0,O.$dh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},$))}}catch(C){this.y.error(C)}const D=new E.$Cc,v=new Map;if(I.length)try{const C=this.Q();if(C.workspaces)for(const[P,g]of Object.entries(C.workspaces)){const w=A.URI.parse(P),M=I.find(N=>N.id===g);M&&D.set(w,M)}if(C.emptyWindows)for(const[P,g]of Object.entries(C.emptyWindows)){const w=I.find(M=>M.id===g);w&&v.set(P,w)}}catch(C){this.y.error(C)}this.z={profiles:I,workspaces:D,emptyWindows:v}}return this.z}D(){const $=c("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const I="Temp",D=new RegExp(`${(0,o.$if)(I)}\\s(\\d+)`);let v=0;for(const P of this.profiles){const g=D.exec(P.name),w=g?parseInt(g[1]):0;v=w>v?w:v}const C=`${I} ${v+1}`;return this.createProfile((0,b.$tj)((0,s.$2g)()).toString(16),C,{transient:!0},$)}async createNamedProfile($,I,D){return this.createProfile((0,b.$tj)((0,s.$2g)()).toString(16),$,I,D)}async createProfile($,I,D,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F($,I,D);return v&&await this.setProfileForWorkspace(v,C),C}async F($,I,D){if(!(0,h.$fg)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(I);return v||(v=(async()=>{try{if(this.profiles.find(w=>w.name===I||w.id===$))throw new Error(`Profile with ${I} name already exists`);const P=c($,I,(0,O.$gh)(this.profilesHome,$),this.g,D,this.defaultProfile);await this.u.createFolder(P.location);const g=[];return this.j.fire({profile:P,join(w){g.push(w)}}),await n.Promises.settled(g),this.I([P],[],[]),P}finally{this.r.delete(I)}})(),this.r.set(I,v)),v}async updateProfile($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(v=>v.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);return D=c(D.id,I.name??D.name,D.location,this.g,{shortName:I.shortName??D.shortName,icon:I.icon===null?void 0:I.icon??D.icon,transient:I.transient??D.isTransient,useDefaultFlags:I.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(v=>v.id===$.id);if(!I)throw new Error(`Profile '${$.name}' does not exist`);const D=[];this.m.fire({profile:I,join(v){D.push(v)}});try{await Promise.allSettled(D)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])I.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])I.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[I],[]);try{await this.u.del(I.cacheHome,{recursive:!0})}catch(v){(0,a.$ql)(v)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(v)}}async setProfileForWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(v=>v.id===I.id);if(!D)throw new Error(`Profile '${I.name}' does not exist`);this.L($,D)}unsetWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,I)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(I=>I.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,I.resource))).map(I=>this.u.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(I=>!this.H(I));await Promise.allSettled($.map(I=>this.removeProfile(I)))}getProfileForWorkspace($){const I=this.G($),D=A.URI.isUri(I)?this.C.workspaces.get(I):this.C.emptyWindows.get(I);return D||((0,u.$Pi)($)?this.s.folders.get($.uri):(0,u.$Ui)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Pi)($)?$.uri:(0,u.$Ui)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.C.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.folders.values()].some(I=>this.w.extUri.isEqual(I.location,$.location)))}I($,I,D){const v=[...this.profiles,...$],C=[],P=this.s.profiles;this.s.profiles=[];for(let g of v){if(g.isDefault||I.some(M=>g.id===M.id))continue;g=D.find(M=>g.id===M.id)??g;const w=P.find(M=>g.id===M.id);if(g.isTransient)this.s.profiles.push(g);else{if(w){for(const[M,N]of this.s.emptyWindows.entries())if(g.id===N.id){this.L({id:M},g);break}for(const[M,N]of this.s.workspaces.entries())if(g.id===N.id){this.L({id:"",configPath:M},g);break}for(const[M,N]of this.s.folders.entries())if(g.id===N.id){this.L({id:"",uri:M},g);break}}C.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags})}}this.P(C),this.z=void 0,this.J($,I,D)}J($,I,D){this.h.fire({added:$,removed:I,updated:D,all:this.profiles})}L($,I,D){if(D=I?.isTransient?!0:D,D)(0,u.$Pi)($)?(this.s.folders.delete($.uri),I&&this.s.folders.set($.uri,I)):(0,u.$Ui)($)?(this.s.workspaces.delete($.configPath),I&&this.s.workspaces.set($.configPath,I)):(this.s.emptyWindows.delete($.id),I&&this.s.emptyWindows.set($.id,I));else{this.L($,void 0,!0);const v=this.G($);A.URI.isUri(v)?(this.C.workspaces.delete(v),I&&this.C.workspaces.set(v,I)):(this.C.emptyWindows.delete(v),I&&this.C.emptyWindows.set(v,I)),this.M()}}M(){const $={};for(const[D,v]of this.C.workspaces.entries())$[D.toString()]=v.id;const I={};for(const[D,v]of this.C.emptyWindows.entries())I[D.toString()]=v.id;this.R({workspaces:$,emptyWindows:I}),this.z=void 0}N($){const I={},D=this.D();if($.workspaces)for(const[C,P]of Object.entries($.workspaces)){const g=A.URI.parse(P);I[C]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}const v={};if($.emptyWindows)for(const[C,P]of Object.entries($.emptyWindows)){const g=A.URI.parse(P);v[C]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}return{workspaces:I,emptyWindows:v}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Ol=l,e.$Ol=l=Qe([Ve(0,p.$Mi),Ve(1,a.$_k),Ve(2,f.$Jl),Ve(3,y.$_j)],l);class m extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Pl=m}),define(Ce[228],Ie([1,0,11,6,4,65,15,162,3,114]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=E,e.$iq=n,e.$kq=o,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,p.$Fi)("storageService");var R;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var y;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(h){const i=h.get(e.$eq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends k.$Wc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new S.$pe),this.c=this.B(new S.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new S.$me),this.onWillSaveState=this.f.event,this.h=this.B(new b.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return S.Event.filter(this.b.event,c=>c.scope===i&&(r===void 0||c.key===r),t)}n(){this.j.value=(0,b.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:c}=r;if(t===e.$eq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:c})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,c,l=!1){if((0,A.$og)(r)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,c),this.P(t)?.set(i,r,l)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],c=this.J(i);for(const l of Object.keys(c))c[l]===r&&t.push(l);return t}z(i,r,t,c=!1){const l=this.J(r);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(r)?.set(e.$eq,JSON.stringify(l),c)):typeof l[i]=="number"&&(delete l[i],this.P(r)?.set(e.$eq,JSON.stringify(l),c))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$dq,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),c=this.P(y.WORKSPACE);switch(i){case R.NONE:await b.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await b.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return o(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,a.$Kl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const c=new Set;for(const[l,m]of i)c.add(l),r.get(l)!==m&&this.u(t,{key:l,external:!0});for(const[l]of r.items)c.has(l)||this.u(t,{key:l,external:!0})})}}e.$hq=f;function n(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class s extends f{constructor(){super(),this.U=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$jq=s;async function o(h,i,r,t,c,l){const m=w=>{try{return JSON.parse(w)}catch{return w}},d=new Map,$=new Map;h.forEach((w,M)=>{d.set(M,w),$.set(M,m(w))});const I=new Map,D=new Map;i.forEach((w,M)=>{I.set(M,w),D.set(M,m(w))});const v=new Map,C=new Map;r.forEach((w,M)=>{v.set(M,w),C.set(M,m(w))}),console.group(t!==c?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const P=[];if(d.forEach((w,M)=>{P.push({key:M,value:w})}),console.table(P),console.groupEnd(),console.log($),t!==c){console.group(`Storage: Profile (path: ${c}, profile specific)`);const w=[];I.forEach((M,N)=>{w.push({key:N,value:M})}),console.table(w),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${l})`);const g=[];v.forEach((w,M)=>{g.push({key:M,value:w})}),console.table(g),console.groupEnd(),console.log(C)}}),define(Ce[80],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class b{static{this.a=!1}constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const O=this.c++;return this.b.set(O,k),this.e(),O}get(k,O){return this.b.has(k)?this.b.get(k)[O]:void 0}delete(k){this.b.delete(k),this.e()}e(){b.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$hoc=b}),define(Ce[51],Ie([1,0,16,24,30,3]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=e.$moc=void 0;class A{constructor(){this.a=new Set(Object.keys(b.Schemas)),this.b=new Map,this.extUri=new S.$8g(p=>{const a=this.b.get(p.scheme);return!(a===void 0||a&k.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,a){a===null?this.b.delete(p.scheme):this.b.set(p.scheme,a)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$moc=A,e.$noc=(0,O.$Fi)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,b.$Fi)("IExtHostInitDataService")}),define(Ce[229],Ie([1,0,185,12,213,27]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0;let A=class extends k.$oR{constructor(p,a,R){const y=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=R.remote.isRemote?(0,b.localize)(0,null):p?(0,b.localize)(1,null):(0,b.localize)(2,null);super(a.createLogger(y,{name:u}))}};e.$vqc=A,e.$vqc=A=Qe([Ve(1,S.$ak),Ve(2,O.$eQ)],A)}),define(Ce[230],Ie([1,0,11]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=void 0;class S{constructor(A,T,p){this.h=new Map,this.a=A,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new b.$Rh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of a.values())R.complete()}catch(R){for(const y of a.values())y.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let p=this.f[A];return typeof p>"u"&&(p=T),p}update(A,T){this.f[A]=T;const p=this.h.get(A);if(p!==void 0)return p.p;const a=new b.$3h;return this.h.set(A,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$5oc=S;class k extends S{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$6oc=k}),define(Ce[231],Ie([1,0,6,2]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0;class k{constructor(A){this.c=A,this.a=new b.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new b.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,p,a){const y=this.c.getNotebookDocument(S.URI.revive(A)).acceptModelChanged(T.value,p,a);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(S.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(S.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$Ypc=k}),define(Ce[17],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,b.$Fi)("IExtHostRpcService");class S{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$2P=S}),define(Ce[232],Ie([1,0,19,6]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class k{#e;constructor(A,T){this.a=b.$qn.toKey(A.identifier),this.#e=T,this.onDidChange=S.Event.map(S.Event.filter(this.#e.onDidChangePassword,p=>p.extensionId===this.a),p=>({key:p.key}))}get(A){return this.#e.get(this.a,A)}store(A,T){return this.#e.store(this.a,A,T)}delete(A){return this.#e.delete(this.a,A)}}e.$cpc=k}),define(Ce[66],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,e.$Coc=(0,b.$Fi)("IURITransformerService");class S{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Doc=S});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[115],Ie([1,0,194,15,2,4,3,31,30,16,48,156,36]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$eG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7F=e.EditorInputCapabilities=e.$6F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$WF=n,e.$XF=s,e.$YF=o,e.$ZF=h,e.$1F=i,e.$2F=r,e.$3F=t,e.$4F=c,e.$5F=l,e.$8F=v,e.$9F=P,e.$0F=g,e.$$F=w,e.$_F=M,e.$aG=N,e.$bG=L,e.$cG=G,e.$dG=_,e.$fG=ce,e.$gG=re,e.$hG=Pe,e.$iG=Me,u=ti(u),e.$RF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SF={id:"default",displayName:(0,b.localize)(0,null),providerDisplayName:(0,b.localize)(1,null)},e.$TF="workbench.editor.sidebysideEditor",e.$UF="workbench.editors.textDiffEditor",e.$VF="workbench.editors.binaryResourceDiffEditor";var E;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var f;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function n(Y){const q=Y;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function s(Y){const q=Y;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function o(Y,q,ee){for(const ve of ee.visibleEditorPanes)if(ve.group.id===q&&Y.matches(ve.input))return ve.getViewState()}function h(Y){if(v(Y))return!1;const q=Y;return k.URI.isUri(q?.resource)}function i(Y){if(v(Y))return!1;const q=Y;return q?.original!==void 0&&q.modified!==void 0}function r(Y){if(v(Y))return!1;const q=Y;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Y){if(v(Y)||i(Y))return!1;const q=Y;return q?.primary!==void 0&&q.secondary!==void 0}function c(Y){if(v(Y))return!1;const q=Y;return q?q.resource===void 0||q.resource.scheme===a.Schemas.untitled||q.forceUntitled===!0:!1}function l(Y){if(v(Y))return!1;const q=Y;return k.URI.isUri(q?.base?.resource)&&k.URI.isUri(q?.input1?.resource)&&k.URI.isUri(q?.input2?.resource)&&k.URI.isUri(q?.result?.resource)}var m;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var d;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class ${constructor(){this.a=new Map}registerSource(q,ee){let ve=this.a.get(q);return ve||(ve={source:q,label:ee},this.a.set(q,ve)),ve.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$6F=new $;var I;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class D extends O.$Wc{}e.$7F=D;function v(Y){return Y instanceof D}function C(Y){const q=Y;return k.URI.isUri(q?.preferredResource)}function P(Y){const q=Y;return v(q?.primary)&&v(q?.secondary)}function g(Y){const q=Y;return v(q?.modified)&&v(q?.original)}function w(Y,q,ee,ve,ue){return Me(ve,[(0,y.$pj)({id:"workbench.action.openLargeFile",label:(0,b.localize)(2,null),run:()=>{const be={...ee,limits:{size:Number.MAX_VALUE}};Y.openEditor(q,be)}}),(0,y.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,b.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function M(Y){return v(Y?.editor)}function N(Y){const q=Y;return M(Y)&&q?.group!==void 0}function L(Y){const q=Y;return typeof q?.groupId=="number"&&v(q.editor)}function G(Y){return typeof Y?.groupId=="number"}var B;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var F;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var V;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class ae{getOriginalUri(q,ee){if(!q)return;if(l(q))return e.$eG.getOriginalUri(q.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:be}=this.a(q);if(ue&&be){if(ee?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===V.ANY)return this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(be,{filterByScheme:ee.filterByScheme});q=ee.supportSideBySide===V.PRIMARY?ue:be}}if(i(q)||r(q)||t(q)||l(q))return;const ve=C(q)?q.preferredResource:q.resource;return!ve||!ee||!ee.filterByScheme?ve:this.b(ve,ee.filterByScheme)}a(q){return P(q)||t(q)?{primary:q.primary,secondary:q.secondary}:g(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,ee){if(!q)return;if(l(q))return e.$eG.getCanonicalUri(q.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:be}=this.a(q);if(ue&&be){if(ee?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===V.ANY)return this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:ee.filterByScheme});q=ee.supportSideBySide===V.PRIMARY?ue:be}}if(i(q)||r(q)||t(q)||l(q))return;const ve=q.resource;return!ve||!ee||!ee.filterByScheme?ve:this.b(ve,ee.filterByScheme)}b(q,ee){if(Array.isArray(ee)){if(ee.some(ve=>q.scheme===ve))return q}else if(ee===q.scheme)return q}}var $e;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})($e||(e.EditorCloseMethod=$e={}));function _(Y,q,ee,ve){if(!Y.isSticky(q))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return ee===$e.MOUSE||ee===$e.KEYBOARD;case"mouse":return ee===$e.MOUSE;case"keyboard":return ee===$e.KEYBOARD}return!1}e.$eG=new ae;var ge;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class se{constructor(){this.c=new Map,this.d=new Map}start(q){const ee=this.a=q.get(A.$Ei);for(const[ve,ue]of this.c)this.e(ve,ue,ee);this.c.clear()}e(q,ee,ve){const ue=ve.createInstance(ee);this.d.set(q,ue)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,S.$qg)(this.b)}registerEditorSerializer(q,ee){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,ee,this.a):this.c.set(q,ee),(0,O.$Uc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}T.$qo.add(e.$RF.EditorFactory,new se);async function ce(Y,q,ee){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const ue=k.URI.revive(ve.fileUri);if(!ue){ee.info("Cannot resolve the path because it is not valid.",ve);return}if(!await q.canHandleResource(ue)){ee.info("Cannot resolve the path because it cannot be handled",ve);return}let de=ve.exists,X=ve.type;if(typeof de!="boolean"||typeof X!="number")try{X=(await q.stat(ue)).isDirectory?p.FileType.Directory:p.FileType.Unknown,de=!0}catch(me){ee.error(me),de=!1}if(!de&&ve.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",ve);return}if(X===p.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",ve);return}const Z={...ve.options,pinned:!0};return de?{resource:ue,options:Z}:{resource:ue,options:Z,forceUntitled:!0}}))}var we;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(we||(e.EditorsOrder=we={}));function re(Y){const q=Y;if(!q)return!1;const ee=q;if(ee.modified)return re(ee.modified);const ve=q;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Pe(Y){return(0,R.$rj)(Y)}function Me(Y,q,ee){const ve=(0,R.$sj)(Y,q);return ve.forceMessage=ee?.forceMessage,ve.forceSeverity=ee?.forceSeverity,ve.allowDialog=ee?.allowDialog,ve}}),define(Ce[233],Ie([1,0,6,195,3,4,29,31,26,98,223]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$oG=e.ViewContentGroups=e.$mG=e.ViewContainerLocation=e.Extensions=e.$lG=e.$kG=e.$jG=void 0,e.$nG=E,e.$jG="views",e.$kG=(0,S.localize)(0,null),e.$lG=(0,R.$xx)("default-view-icon",a.$5j.window,(0,S.localize)(1,null));var y;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel",c[c.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$mG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(c){switch(c){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class f extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new b.$me),this.onDidRegister=this.c.event,this.f=this.B(new b.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,m,d){const $=this.get(l.id);if($)return $;const I=l;return I.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$zc)(this.g,m,[]).push(I),d?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:m}),I}deregisterViewContainer(l){for(const m of this.g.keys()){const d=this.g.get(m),$=d?.indexOf(l);if($!==-1){d?.splice($,1),d.length===0&&this.g.delete(m),this.f.fire({viewContainer:l,viewContainerLocation:m});return}}}get(l){return this.all.filter(m=>m.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(d=>d?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(m=>this.getViewContainerLocation(m)===l)}}T.$qo.add(y.ViewContainersRegistry,new f);var n;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(n||(e.ViewContentGroups=n={}));function s(c,l){const m=c.group??n.More,d=l.group??n.More;return m!==d?m.localeCompare(d):(c.order??5)-(l.order??5)}class o extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new b.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new b.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new b.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new b.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Jc}registerViews(l,m){this.registerViews2([{views:l,viewContainer:m}])}registerViews2(l){l.forEach(({views:m,viewContainer:d})=>this.r(m,d)),this.c.fire(l)}deregisterViews(l,m){const d=this.s(l,m);d.length&&this.f.fire({views:d,viewContainer:m})}moveViews(l,m){for(const d of this.m.keys())if(d!==m){const $=this.s(l,d);$.length&&(this.r($,m),this.g.fire({views:$,from:d,to:m}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const m of this.j){const d=(this.m.get(m)||[]).filter($=>$.id===l)[0];if(d)return d}return null}getViewContainer(l){for(const m of this.j)if((this.m.get(m)||[]).filter($=>$.id===l)[0])return m;return null}registerViewWelcomeContent(l,m){return this.n.add(l,m),this.h.fire(l),(0,O.$Uc)(()=>{this.n.delete(l,m),this.h.fire(l)})}registerViewWelcomeContent2(l,m){const d=new Map;for(const[$,I]of m)this.n.add(l,I),d.set($,(0,O.$Uc)(()=>{this.n.delete(l,I),this.h.fire(l)}));return this.h.fire(l),d}getViewWelcomeContent(l){const m=[];return this.n.forEach(l,d=>m.push(d)),m.sort(s)}r(l,m){let d=this.m.get(m);d||(d=[],this.m.set(m,d),this.j.push(m));for(const $ of l){if(this.getView($.id)!==null)throw new Error((0,S.localize)(2,null,$.id));d.push($)}}s(l,m){const d=this.m.get(m);if(!d)return[];const $=[],I=[];for(const D of d)l.includes(D)?$.push(D):I.push(D);return $.length&&(I.length?this.m.set(m,I):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),$}}T.$qo.add(y.ViewsRegistry,new o),e.$oG=(0,k.$Fi)("viewDescriptorService");var h;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var i;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(l,m){this.c=!1,this.d=!1,(0,p.$go)(this,l),this.d=!!m,this.resolve=async d=>{if(m&&!this.c){const $=await m(d);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$pG=r;class t extends Error{constructor(l){super((0,S.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$qG=t}),define(Ce[234],Ie([1,0,196,32]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG=new S.$Wj("chatSessionResponseVote","",{type:"string",description:(0,b.localize)(0,null)}),e.$vG=new S.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,b.localize)(1,null)}),e.$wG=new S.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,b.localize)(2,null)}),e.$xG=new S.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,b.localize)(3,null)}),e.$yG=new S.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,b.localize)(4,null)}),e.$zG=new S.$Wj("chatResponse",!1,{type:"boolean",description:(0,b.localize)(5,null)}),e.$AG=new S.$Wj("chatRequest",!1,{type:"boolean",description:(0,b.localize)(6,null)}),e.$BG=new S.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,b.localize)(7,null)}),e.$CG=new S.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,b.localize)(8,null)}),e.$DG=new S.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,b.localize)(9,null)}),e.$EG=new S.$Wj("inChatInput",!1,{type:"boolean",description:(0,b.localize)(10,null)}),e.$FG=new S.$Wj("inChat",!1,{type:"boolean",description:(0,b.localize)(11,null)}),e.$GG=new S.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,b.localize)(12,null)}),e.$HG=new S.$Wj("chatCursorAtTop",!1),e.$IG=new S.$Wj("chatInputHasAgent",!1),e.$JG=new S.$Wj("chatLocation",void 0),e.$KG=new S.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,b.localize)(13,null)})}),define(Ce[235],Ie([1,0,325,11,22,6,40,4,49,142,13,32,19,3,12,109,217,228,234]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.ChatAgentLocation=void 0,e.$OH=m,e.$PH=d;var r;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function($){function I(D){switch(D){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=I}(r||(e.ChatAgentLocation=r={})),e.$JH=(0,E.$Fi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(I){this.f=I,this.b=new Map,this.d=new O.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$GG.bindTo(this.f)}registerAgent(I,D){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const C=this,P=D.slashCommands;D={...D,get slashCommands(){return P.filter(w=>!w.when||C.f.contextMatchesRules(y.$Dj.deserialize(w.when)))}};const g={data:D};return this.b.set(I,g),(0,T.$Uc)(()=>{this.b.delete(I),this.d.fire(void 0)})}registerAgentImplementation(I,D){const v=this.b.get(I);if(!v)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return v.data.isDefault&&this.e.set(!0),v.impl=D,this.d.fire(new c(v.data,D)),(0,T.$Uc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(I,D){I.isDynamic=!0;const v={data:I,impl:D};return this.b.set(I.id,v),this.d.fire(new c(I,D)),(0,T.$Uc)(()=>{this.b.delete(I.id),this.d.fire(void 0)})}registerAgentCompletionProvider(I,D){return this.g.set(I,D),{dispose:()=>{this.g.delete(I)}}}async getAgentCompletionItems(I,D,v){return await this.g.get(I)?.(D,v)??[]}updateAgent(I,D){const v=this.b.get(I);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);v.data.metadata={...v.data.metadata,...D},this.d.fire(new c(v.data,v.impl))}getDefaultAgent(I){return(0,b.$hb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this.h(I))return this.b.get(I)?.data}h(I){const D=this.b.get(I);return!D?.data.when||this.f.contextMatchesRules(y.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(I){const D=A.Iterable.find(this.b.values(),v=>m(v.data)===I)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(I=>I.data).filter(I=>this.h(I.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).filter(I=>this.h(I.data.id)).map(I=>new c(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(D=>D.name===I)}agentHasDupeName(I){const D=this.getAgent(I);return D?this.getAgentsByName(D.name).filter(v=>v.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(I,D,v,C,P){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return await g.impl.invoke(D,v,C,P)}async getFollowups(I,D,v,C,P){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return g.impl?.provideFollowups?g.impl.provideFollowups(D,v,C,P):[]}};e.$KH=t,e.$KH=t=Qe([Ve(0,y.$Xj)],t);class c{constructor(I,D){this.b=I,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,D,v,C){return this.d.invoke(I,D,v,C)}async provideFollowups(I,D,v,C){return this.d.provideFollowups?this.d.provideFollowups(I,D,v,C):[]}provideWelcomeMessage(I,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I,D)}provideSampleQuestions(I,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I,D)}}e.$LH=c,e.$MH=(0,E.$Fi)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(I,D,v,C){if(this.g=D,this.h=v,this.i=C,this.e=(0,a.$7d)(this,Object.create(null)),this.f=!1,!I.chatParticipantRegistry)return;this.d=I.chatParticipantRegistry;const P=C.get(i.b,o.StorageScope.APPLICATION);try{this.e.set(JSON.parse(P??"{}"),void 0)}catch{C.remove(i.b,o.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(I=>this.h.warn("Failed to fetch chat participant registry",I)).then(()=>(0,S.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const I=await this.g.request({type:"GET",url:this.d},k.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,s.$$p)(I);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const v=D.restrictedChatParticipants;this.e.set(v,void 0),this.i.store(i.b,JSON.stringify(v),o.StorageScope.APPLICATION,o.StorageTarget.MACHINE)}getAgentNameRestriction(I){const D=this.l(I.name,I).get(),v=!I.fullName||this.l(I.fullName.replace(/\s/g,""),I).get();return D&&v}l(I,D){return this.e.map(C=>C[I.toLowerCase()]).map(C=>C?C.some(P=>(0,R.$Gf)(P,P.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$NH=l,e.$NH=l=i=Qe([Ve(0,n.$sk),Ve(1,s.$5p),Ve(2,f.$_j),Ve(3,o.$fq)],l);function m($){return`${$.extensionId.value}.${$.id}`}function d($){const I="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new u.$qn("")),(0,p.$ci)(I)}}),define(Ce[236],Ie([1,0,2,33,3]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.$hH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$fH=O,e.$gH=A;function O(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof b.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(S.$Lt.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(O)}var T;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var p;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$hH=(0,k.$Fi)("IChatService"),e.$iH="accessibility.voice.keywordActivation"}),define(Ce[237],Ie([1,0,6,11,198]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Itb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new b.$me,this.o=new b.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,a,R){const y={command:T};if(p&&Object.keys(p).length>0&&(y.arguments=p),this.u("request",y),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(y.seq);if(E){this.f.delete(y.seq);const f={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,k.localize)(0,null,R,T)};E(f)}},R)}return a&&this.f.set(y.seq,a),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,S.$Gh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,a=this.f.get(p.request_seq);a&&(this.f.delete(p.request_seq),a(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,a)=>T.set(a,p)),await(0,S.$Gh)(500),T.forEach((p,a)=>{p({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Itb=O}),define(Ce[81],Ie([1,0,2,199,32,3]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AK=e.MemoryRangeType=e.State=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$zK=p,e.$BK=R,S=qe(S),e.$nJ="workbench.view.debug",e.$oJ="workbench.debug.variablesView",e.$pJ="workbench.debug.watchExpressionsView",e.$qJ="workbench.debug.callStackView",e.$rJ="workbench.debug.loadedScriptsView",e.$sJ="workbench.debug.breakPointsView",e.$tJ="workbench.debug.disassemblyView",e.$uJ="workbench.panel.repl",e.$vJ="workbench.panel.repl.view",e.$wJ=new k.$Wj("debugType",void 0,{type:"string",description:S.localize(0,null)}),e.$xJ=new k.$Wj("debugConfigurationType",void 0,{type:"string",description:S.localize(1,null)}),e.$yJ=new k.$Wj("debugState","inactive",{type:"string",description:S.localize(2,null)}),e.$zJ="debugUx",e.$AJ=new k.$Wj(e.$zJ,"default",{type:"string",description:S.localize(3,null)}),e.$BJ=new k.$Wj("hasDebugged",!1,{type:"boolean",description:S.localize(4,null)}),e.$CJ=new k.$Wj("inDebugMode",!1,{type:"boolean",description:S.localize(5,null)}),e.$DJ=new k.$Wj("inDebugRepl",!1,{type:"boolean",description:S.localize(6,null)}),e.$EJ=new k.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:S.localize(7,null)}),e.$FJ=new k.$Wj("inBreakpointWidget",!1,{type:"boolean",description:S.localize(8,null)}),e.$GJ=new k.$Wj("breakpointsFocused",!0,{type:"boolean",description:S.localize(9,null)}),e.$HJ=new k.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:S.localize(10,null)}),e.$IJ=new k.$Wj("watchExpressionsExist",!1,{type:"boolean",description:S.localize(11,null)}),e.$JJ=new k.$Wj("variablesFocused",!0,{type:"boolean",description:S.localize(12,null)}),e.$KJ=new k.$Wj("expressionSelected",!1,{type:"boolean",description:S.localize(13,null)}),e.$LJ=new k.$Wj("breakpointInputFocused",!1,{type:"boolean",description:S.localize(14,null)}),e.$MJ=new k.$Wj("callStackItemType",void 0,{type:"string",description:S.localize(15,null)}),e.$NJ=new k.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:S.localize(16,null)}),e.$OJ=new k.$Wj("callStackItemStopped",!1,{type:"boolean",description:S.localize(17,null)}),e.$PJ=new k.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:S.localize(18,null)}),e.$QJ=new k.$Wj("watchItemType",void 0,{type:"string",description:S.localize(19,null)}),e.$RJ=new k.$Wj("canViewMemory",void 0,{type:"boolean",description:S.localize(20,null)}),e.$SJ=new k.$Wj("breakpointItemType",void 0,{type:"string",description:S.localize(21,null)}),e.$TJ=new k.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:S.localize(22,null)}),e.$UJ=new k.$Wj("breakpointHasModes",!1,{type:"boolean",description:S.localize(23,null)}),e.$VJ=new k.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:S.localize(24,null)}),e.$WJ=new k.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:S.localize(25,null)}),e.$XJ=new k.$Wj("loadedScriptsItemType",void 0,{type:"string",description:S.localize(26,null)}),e.$YJ=new k.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:S.localize(27,null)}),e.$ZJ=new k.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:S.localize(28,null)}),e.$1J=new k.$Wj("stepBackSupported",!1,{type:"boolean",description:S.localize(29,null)}),e.$2J=new k.$Wj("restartFrameSupported",!1,{type:"boolean",description:S.localize(30,null)}),e.$3J=new k.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:S.localize(31,null)}),e.$4J=new k.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:S.localize(32,null)}),e.$5J=new k.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:S.localize(33,null)}),e.$6J=new k.$Wj("breakpointsExist",!1,{type:"boolean",description:S.localize(34,null)}),e.$7J=new k.$Wj("debuggersAvailable",!1,{type:"boolean",description:S.localize(35,null)}),e.$8J=new k.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:S.localize(36,null)}),e.$9J=new k.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:S.localize(37,null)}),e.$0J=new k.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:S.localize(38,null)}),e.$$J=new k.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:S.localize(39,null)}),e.$_J=new k.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:S.localize(40,null)}),e.$aK=new k.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:S.localize(41,null)}),e.$bK=new k.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:S.localize(42,null)}),e.$cK=new k.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:S.localize(43,null)}),e.$dK=new k.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:S.localize(44,null)}),e.$eK=new k.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:S.localize(45,null)}),e.$fK=new k.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:S.localize(46,null)}),e.$gK=new k.$Wj("variableIsReadonly",!1,{type:"boolean",description:S.localize(47,null)}),e.$hK=new k.$Wj("variableValue",!1,{type:"string",description:S.localize(48,null)}),e.$iK=new k.$Wj("variableType",!1,{type:"string",description:S.localize(49,null)}),e.$jK=new k.$Wj("variableInterfaces",!1,{type:"array",description:S.localize(50,null)}),e.$kK=new k.$Wj("variableName",!1,{type:"string",description:S.localize(51,null)}),e.$lK=new k.$Wj("variableLanguage",!1,{type:"string",description:S.localize(52,null)}),e.$mK=new k.$Wj("variableExtensionId",!1,{type:"string",description:S.localize(53,null)}),e.$nK=new k.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:S.localize(54,null)}),e.$oK=new k.$Wj("multiSessionRepl",!1,{type:"boolean",description:S.localize(55,null)}),e.$pK=new k.$Wj("multiSessionDebug",!1,{type:"boolean",description:S.localize(56,null)}),e.$qK=new k.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:S.localize(57,null)}),e.$rK=new k.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:S.localize(58,null)}),e.$sK=new k.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:S.localize(59,null)}),e.$tK=new k.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:S.localize(60,null)});const A=i=>S.localize(61,null,i);e.$uK=A,e.$vK="editor.contrib.debug",e.$wK="editor.contrib.breakpoint",e.$xK="debug",e.$yK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:S.localize(62,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function p(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var a;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$AK="vscode-debug-memory";function R(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$CK=(0,O.$Fi)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var h;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:b.URI.revive(r.iconPath.light),dark:b.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(h||(e.IDebugVisualization=h={}))}),define(Ce[238],Ie([1,0,13,2,20,26,16,33,22,18]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7H=void 0,e.$UH=y,e.$VH=u,e.$WH=E,e.$XH=f,e.$YH=n,e.$ZH=s,e.$1H=o,e.$2H=i,e.$3H=c,e.$4H=l,e.$5H=d,e.$6H=I;const R=/{([^}]+)}/g;function y(v,C,P){return v.replace(R,function(g,w){return C&&w.length>0&&w[0]!=="_"?g:P&&P.hasOwnProperty(w)?P[w]:g})}function u(v){const C={};for(const P of Object.keys(v))P.startsWith("!")||(C[P]=v[P]);return C}function E(v){return v.configuration.request==="attach"&&!f(v)&&(!v.parentSession||E(v.parentSession))}function f(v){let C=v.configuration.type;if(C)return C==="vslsShare"&&(C=v.configuration.adapterProxy.configuration.type),(0,b.$Gf)(C,"extensionhost")||(0,b.$Gf)(C,"pwa-extensionhost")?v:v.parentSession?f(v.parentSession):void 0}function n(v){return v.type&&(v.label||v.program||v.runtime)}function s(v,C,P){let g,w=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(v);){const L=N.index+1,G=L+N[0].length;if(L<=C&&G>=P){g=N[0],w=L;break}}if(g){const L=/\w+/g;let G=null;for(;(G=L.exec(g))&&!(G.index+1+w+G[0].length>=P););G&&(g=g.substring(0,L.lastIndex))}return g?{start:w,end:w+g.length-1}:{start:0,end:0}}async function o(v,C,P,g){if(v.evaluatableExpressionProvider.has(C)){const w=v.evaluatableExpressionProvider.ordered(C),M=(0,a.$Jb)(await Promise.all(w.map(async N=>{try{return await N.provideEvaluatableExpression(C,P,g??p.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const L=M[0].range;return N||(N=C.getLineContent(P.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const w=C.getLineContent(P.lineNumber),{start:M,end:N}=s(w,P.column,P.column),L=w.substring(M-1,N);return{matchingExpression:L,range:new T.$Lt(P.lineNumber,M,P.lineNumber,M+L.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(v){return!!(v&&v.match(h))}function r(v){if(typeof v.path=="string"&&!(typeof v.sourceReference=="number"&&v.sourceReference>0)){if(i(v.path))return S.URI.parse(v.path);if((0,k.$kc)(v.path))return S.URI.file(v.path)}return v.path}function t(v){if(typeof v.path=="object"){const C=S.URI.revive(v.path);if(C)return C.scheme===A.Schemas.file?C.fsPath:C.toString()}return v.path}function c(v,C){const P=C?r:t,g=(0,O.$do)(v);return m(g,(w,M)=>{w&&M&&(M.path=P(M))}),g}function l(v,C){const P=C?r:t,g=(0,O.$do)(v);return m(g,(w,M)=>{!w&&M&&(M.path=P(M))}),g}function m(v,C){switch(v.type){case"event":{const P=v;switch(P.event){case"output":C(!1,P.body.source);break;case"loadedSource":C(!1,P.body.source);break;case"breakpoint":C(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=v;switch(P.command){case"setBreakpoints":C(!0,P.arguments.source);break;case"breakpointLocations":C(!0,P.arguments.source);break;case"source":C(!0,P.arguments.source);break;case"gotoTargets":C(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(g=>C(!1,g));break;default:break}break}case"response":{const P=v;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(g=>C(!1,g.source));break;case"loadedSources":P.body.sources.forEach(g=>C(!1,g));break;case"scopes":P.body.scopes.forEach(g=>C(!1,g.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(g=>C(!1,g.source));break;case"setBreakpoints":P.body.breakpoints.forEach(g=>C(!1,g.source));break;case"disassemble":P.body?.instructions.forEach(w=>C(!1,w.location));break;default:break}break}}}function d(v){return v.filter(C=>!C.presentation?.hidden).sort((C,P)=>C.presentation?P.presentation?C.presentation.group?P.presentation.group?C.presentation.group!==P.presentation.group?C.presentation.group.localeCompare(P.presentation.group):$(C.presentation.order,P.presentation.order):-1:P.presentation.group?1:$(C.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function $(v,C){return typeof v!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:v-C}async function I(v,C){const P=v.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(P!=="none"&&(await C.saveAll(),P==="allEditorsInActiveGroup")){const g=C.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await C.save({editor:g.input,groupId:g.group.id})}await v.reloadConfiguration()}const D=(v,C)=>!v||!C?v===C:v.name===C.name&&v.path===C.path&&v.sourceReference===C.sourceReference;e.$7H=D}),define(Ce[239],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.CellExecutionUpdateType=void 0;var S;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(S||(e.CellExecutionUpdateType=S={})),e.$UK=(0,b.$Fi)("INotebookExecutionService")}),define(Ce[240],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$XK=e.ProxyKernelState=e.$WK=void 0,e.$WK=100;var S;(function(k){k[k.Disconnected=1]="Disconnected",k[k.Connected=2]="Connected",k[k.Initializing=3]="Initializing"})(S||(e.ProxyKernelState=S={})),e.$XK=(0,b.$Fi)("INotebookKernelService"),e.$YK=(0,b.$Fi)("INotebookKernelHistoryService")}),define(Ce[241],Ie([1,0,4,33,52,167,102]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wZb=void 0;class T extends b.$Wc{constructor(a,R,y){super(),this._source=a,this.b=R,this.c=y,this.a=void 0}f(a){const R=a.getLineCount();return new S.$Lt(1,1,R,this.g(a,R))}g(a,R){if(R<1||R>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const a=new O.$mD;a.acceptChunk(this._source);const R=a.finish(!0),{textBuffer:y,disposable:u}=R.create(k.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const R=new O.$mD;R.acceptChunk(a);const y=R.finish(!0),{textBuffer:u,disposable:E}=y.create(k.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$wZb=T}),define(Ce[55],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.TestPosition=e.TestIdPathParts=void 0;var b;(function(O){O.Delimiter="\0"})(b||(e.TestIdPathParts=b={}));var S;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(S||(e.TestPosition=S={}));class k{static fromExtHostTestItem(A,T,p=A.parent){if(A._isRoot)return new k([T]);const a=[A.id];for(let R=p;R&&R.id!==T;R=R.parent)a.push(R.id);return a.push(T),new k(a.reverse())}static isRoot(A){return!A.includes(b.Delimiter)}static root(A){const T=A.indexOf(b.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new k(A.split(b.Delimiter))}static join(A,T){return new k([...A.path,T])}static joinToString(A,T){return A.toString()+b.Delimiter+T}static parentId(A){const T=A.lastIndexOf(b.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(b.Delimiter);return T===-1?A:A.slice(T+b.Delimiter.length)}static isChild(A,T){return T.startsWith(A)&&T[A.length]===b.Delimiter}static compare(A,T){return A===T?S.IsSame:k.isChild(A,T)?S.IsChild:k.isChild(T,A)?S.IsParent:S.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let p=0;for(;p<A-1;){for(let a=1;a<A;a++){const R=T(a-1),y=T(a);if(R.path[p]!==y.path[p])return p}p++}return p}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new k(this.path,1)}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new k(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new k(this.path,A)}compare(A){if(typeof A=="string")return k.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return S.Disconnected;return A.d>this.d?S.IsChild:A.d<this.d?S.IsParent:S.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=b.Delimiter,this.c+=this.path[A]}return this.c}}e.$TI=k}),define(Ce[56],Ie([1,0,2,101,33,55]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$2I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$1I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ZI=e.$YI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$XI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$WI=e.$VI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$UI=e.TestResultState=void 0;var A;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$UI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(B){B[B.Run=2]="Run",B[B.Debug=4]="Debug",B[B.Coverage=8]="Coverage",B[B.HasNonDefaultProfile=16]="HasNonDefaultProfile",B[B.HasConfigurable=32]="HasConfigurable",B[B.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$VI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const a=B=>"runId"in B;e.$WI=a;var R;(function(B){B.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),B.deserialize=(F,V)=>({range:k.$Lt.lift(V.range),uri:F.asCanonicalUri(b.URI.revive(V.uri))})})(R||(e.IRichLocation=R={}));var y;(function(B){B[B.Error=0]="Error",B[B.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(B){B.serialize=F=>({message:F.message,type:y.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.serialize(F.location)}),B.deserialize=(F,V)=>({message:V.message,type:y.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&R.deserialize(F,V.location)})})(u||(e.ITestErrorMessage=u={}));const E=(B,F)=>`${F?"s":"e"}${B}`;e.$XI=E;var f;(function(B){B.serialize=F=>({message:F.message,type:y.Output,offset:F.offset,length:F.length,location:F.location&&R.serialize(F.location)}),B.deserialize=(F,V)=>({message:V.message,type:y.Output,offset:V.offset,length:V.length,location:V.location&&R.deserialize(F,V.location)})})(f||(e.ITestOutputMessage=f={}));var n;(function(B){B.serialize=F=>F.type===y.Error?u.serialize(F):f.serialize(F),B.deserialize=(F,V)=>V.type===y.Error?u.deserialize(F,V):f.deserialize(F,V)})(n||(e.ITestMessage=n={}));var s;(function(B){B.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),B.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(n.serialize)}),B.deserialize=(F,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(ae=>n.deserialize(F,ae))})})(s||(e.ITestTaskState=s={}));const o="\0",h=(B,F)=>B+o+F;e.$YI=h;const i=B=>{const F=B.indexOf(o);return{ctrlId:B.slice(0,F),tagId:B.slice(F+1)}};e.$ZI=i;var r;(function(B){B.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),B.deserialize=(F,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?F.asCanonicalUri(b.URI.revive(V.uri)):void 0,range:V.range?k.$Lt.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(r||(e.ITestItem=r={}));var t;(function(B){B[B.NotExpandable=0]="NotExpandable",B[B.Expandable=1]="Expandable",B[B.BusyExpanding=2]="BusyExpanding",B[B.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var c;(function(B){B.serialize=F=>({expand:F.expand,item:r.serialize(F.item)}),B.deserialize=(F,V)=>({controllerId:O.$TI.root(V.item.extId),expand:V.expand,item:r.deserialize(F,V.item)})})(c||(e.InternalTestItem=c={}));var l;(function(B){B.serialize=F=>{let V;return F.item&&(V={},F.item.label!==void 0&&(V.label=F.item.label),F.item.tags!==void 0&&(V.tags=F.item.tags),F.item.busy!==void 0&&(V.busy=F.item.busy),F.item.uri!==void 0&&(V.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(V.range=F.item.range?.toJSON()),F.item.description!==void 0&&(V.description=F.item.description),F.item.error!==void 0&&(V.error=F.item.error),F.item.sortText!==void 0&&(V.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:V}},B.deserialize=F=>{let V;return F.item&&(V={},F.item.label!==void 0&&(V.label=F.item.label),F.item.tags!==void 0&&(V.tags=F.item.tags),F.item.busy!==void 0&&(V.busy=F.item.busy),F.item.range!==void 0&&(V.range=F.item.range?k.$Lt.lift(F.item.range):null),F.item.description!==void 0&&(V.description=F.item.description),F.item.error!==void 0&&(V.error=F.item.error),F.item.sortText!==void 0&&(V.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:V}}})(l||(e.ITestItemUpdate=l={}));const m=(B,F)=>{F.expand!==void 0&&(B.expand=F.expand),F.item!==void 0&&(B.item=B.item?Object.assign(B.item,F.item):F.item)};e.$1I=m;var d;(function(B){B.serializeWithoutMessages=F=>({...c.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(s.serializeWithoutMessages)}),B.serialize=F=>({...c.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(s.serialize)}),B.deserialize=(F,V)=>({...c.deserialize(F,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(ae=>s.deserialize(F,ae)),retired:!0})})(d||(e.TestResultItem=d={}));var $;(function(B){B.empty=()=>({covered:0,total:0}),B.sum=(F,V)=>{F.covered+=V.covered,F.total+=V.total}})($||(e.ICoverageCount=$={}));var I;(function(B){B.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),B.deserialize=(F,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:F.asCanonicalUri(b.URI.revive(V.uri))}),B.empty=(F,V)=>({id:F,uri:V,statement:$.empty()})})(I||(e.IFileCoverage=I={}));function D(B){return{...B,location:B.location?.toJSON()}}function v(B){return B.location=B.location?S.$Kt.isIPosition(B.location)?S.$Kt.lift(B.location):k.$Lt.lift(B.location):void 0,B}e.$2I=3;var C;(function(B){B[B.Declaration=0]="Declaration",B[B.Statement=1]="Statement",B[B.Branch=2]="Branch"})(C||(e.DetailType=C={}));var P;(function(B){B.serialize=F=>F.type===C.Declaration?w.serialize(F):M.serialize(F),B.deserialize=F=>F.type===C.Declaration?w.deserialize(F):M.deserialize(F)})(P||(e.CoverageDetails=P={}));var g;(function(B){B.serialize=D,B.deserialize=v})(g||(e.IBranchCoverage=g={}));var w;(function(B){B.serialize=D,B.deserialize=v})(w||(e.IDeclarationCoverage=w={}));var M;(function(B){B.serialize=F=>({...D(F),branches:F.branches?.map(g.serialize)}),B.deserialize=F=>({...v(F),branches:F.branches?.map(g.deserialize)})})(M||(e.IStatementCoverage=M={}));var N;(function(B){B[B.Add=0]="Add",B[B.Update=1]="Update",B[B.DocumentSynced=2]="DocumentSynced",B[B.Remove=3]="Remove",B[B.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",B[B.Retire=5]="Retire",B[B.AddTag=6]="AddTag",B[B.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var L;(function(B){B.deserialize=(F,V)=>V.op===N.Add?{op:V.op,item:c.deserialize(F,V.item)}:V.op===N.Update?{op:V.op,item:l.deserialize(V.item)}:V.op===N.DocumentSynced?{op:V.op,uri:F.asCanonicalUri(b.URI.revive(V.uri)),docv:V.docv}:V,B.serialize=F=>F.op===N.Add?{op:F.op,item:c.serialize(F.item)}:F.op===N.Update?{op:F.op,item:l.serialize(F.item)}:F})(L||(e.TestsDiffOp=L={}));class G{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const V=this.w();for(const ae of F)switch(ae.op){case N.Add:this.l(c.deserialize(this.k,ae.item),V);break;case N.Update:this.p(l.deserialize(ae.item),V);break;case N.Remove:this.q(ae.itemId,V);break;case N.Retire:this.v(ae.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(ae.amount);break;case N.AddTag:this.c.set(ae.tag.id,ae.tag);break;case N.RemoveTag:this.c.delete(ae.id);break}V.complete?.()}l(F,V){const ae=O.$TI.parentId(F.item.extId)?.toString();let $e;if(!ae)$e=this.x(F),this.g.add($e),this.f.set(F.item.extId,$e);else if(this.f.has(ae)){const _=this.f.get(ae);_.children.add(F.item.extId),$e=this.x(F,_),this.f.set(F.item.extId,$e)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return V.add?.($e),F.expand===t.BusyExpanding&&this.h++,$e}p(F,V){const ae=this.f.get(F.extId);if(ae)return F.expand!==void 0&&(ae.expand===t.BusyExpanding&&this.h--,F.expand===t.BusyExpanding&&this.h++),(0,e.$1I)(ae,F),V.update?.(ae),ae}q(F,V){const ae=this.f.get(F);if(!ae)return;const $e=O.$TI.parentId(ae.item.extId)?.toString();$e?this.f.get($e).children.delete(ae.item.extId):this.g.delete(ae);const _=[[F]];for(;_.length;)for(const ge of _.pop()){const se=this.f.get(ge);se&&(_.push(se.children),this.f.delete(ge),V.remove?.(se,se!==ae),se.expand===t.BusyExpanding&&this.h--)}}v(F){}updatePendingRoots(F){this.j+=F}w(){return{}}}e.$3I=G}),define(Ce[242],Ie([1,0,99,202,56]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$oGb=e.$nGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[k.TestResultState.Errored]:(0,S.localize)(0,null),[k.TestResultState.Failed]:(0,S.localize)(1,null),[k.TestResultState.Passed]:(0,S.localize)(2,null),[k.TestResultState.Queued]:(0,S.localize)(3,null),[k.TestResultState.Running]:(0,S.localize)(4,null),[k.TestResultState.Skipped]:(0,S.localize)(5,null),[k.TestResultState.Unset]:(0,S.localize)(6,null)},a=(y,u)=>(0,S.localize)(7,null,(0,b.$Yk)(y),p[u]);e.$nGb=a,e.$oGb={[k.TestRunProfileBitset.Debug]:(0,S.localize)(8,null),[k.TestRunProfileBitset.Run]:(0,S.localize)(9,null),[k.TestRunProfileBitset.Coverage]:(0,S.localize)(10,null)};var R;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Ce[82],Ie([1,0,11,6,4,62,56,55]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const a=(h,i)=>h===i,y=Object.entries({range:(h,i)=>h===i?!0:!h||!i?!1:h.equalsRange(i),busy:a,label:a,description:a,error:a,sortText:a,tags:(h,i)=>!(h.length!==i.length||h.some(r=>!i.includes(r)))}),u=(h,i)=>{let r;for(const[t,c]of y)c(h[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class E extends k.$Wc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new b.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new S.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.$1I)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.$1I)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const c=this.M(t);return c.isOpen()?this.L(t,r-1):c.wait().then(()=>this.L(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case p.RemoveChild:this.O(T.$TI.joinToString(i.fullId,r.id));break;case p.Upsert:this.z(r.item,i);break;case p.Bulk:for(const t of r.ops)this.w(i,t);break;case p.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$gd)(r)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$TI.fromExtHostTestItem(i,this.root.id,r?.actual),c=this.s.getApiFor(i);c.parent&&c.parent!==r?.actual&&this.s.getChildren(c.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,r);return}if(l.actual===i){this.H(i,l,r);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const m=this.s.getChildren(l.actual),d=l.actual,$=u(this.s.toITestItem(d),this.s.toITestItem(i));this.s.getApiFor(d).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=A.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(i.tags,d.tags,t.toString()),delete $.tags),this.w(l,{op:p.SetProp,update:$})),this.I(i,l,r);for(const[D,v]of m)this.s.getChildren(i).get(v.id)||this.O(T.$TI.joinToString(t,v.id));const I=l.expandLevels;I!==void 0&&queueMicrotask(()=>{l.expand===A.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),I))}),this.y(l.actual.uri)}C(i,r,t){const c=new Set(r.map(l=>l.id));for(const l of i)c.delete(l.id)||this.D(l);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,A.$YI)(this.s.controllerId,l.id))}}}),c.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$YI)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$YI)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const c=this.s.getApiFor(i);c.parent=t?.actual,c.listener=l=>this.w(r,l),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[c,l]of this.s.getChildren(i))this.z(l,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[c,l]of this.s.getChildren(i.actual)){const m=this.expand(T.$TI.joinToString(i.fullId,l.id),r);(0,b.$rh)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new b.$Eh;return l.open(),l}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new b.$Eh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let c;try{c=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,b.$rh)(c)?c.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const c=t.pop();if(c){this.s.getApiFor(c.actual).listener=void 0;for(const l of c.actual.tags)this.F(l.id);this.tree.delete(c.fullId.toString());for(const[l,m]of this.s.getChildren(c.actual))t.push(this.tree.get(T.$TI.joinToString(c.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$QP=E;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$RP=f;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=n;class s extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=s;const o=(h,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(c,l){for(const m of t.values())c.call(l,m,this)},[Symbol.iterator](){return t.entries()},replace(c){const l=new Map,m=new Set(t.keys()),d={op:p.Bulk,ops:[]};for(const $ of c){if(!($ instanceof r))throw new n($.id);const I=i($).controllerId;if(I!==h.controllerId)throw new s($.id,I,h.controllerId);if(l.has($.id))throw new f($.id);l.set($.id,$),m.delete($.id),d.ops.push({op:p.Upsert,item:$})}for(const $ of m.keys())d.ops.push({op:p.RemoveChild,id:$});h.listener?.(d),t=l},add(c){if(!(c instanceof r))throw new n(c.id);t.set(c.id,c),h.listener?.({op:p.Upsert,item:c})},delete(c){t.delete(c)&&h.listener?.({op:p.RemoveChild,id:c})},get(c){return t.get(c)},toJSON(){return Array.from(t.values())}}};e.$UP=o}),define(Ce[116],Ie([1,0,82]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const S=new WeakMap,k=(A,T)=>{const p={controllerId:T};return S.set(A,p),p};e.$VP=k;const O=A=>{const T=S.get(A);if(!T)throw new b.$SP(A?.id||"<unknown>");return T};e.$WP=O}),define(Ce[83],Ie([1,0,28,16,2]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cDb=e.$bDb=e.$aDb=void 0,e.$dDb=O,e.$eDb=T,e.$aDb="vscode-cdn.net",e.$bDb=`vscode-resource.${e.$aDb}`,e.$cDb=`'self' https://*.${e.$aDb}`;function O(p,a){return p.scheme===S.Schemas.http||p.scheme===S.Schemas.https?p:(a&&a.authority&&a.isRemote&&p.scheme===S.Schemas.file&&(p=k.URI.from({scheme:S.Schemas.vscodeRemote,authority:a.authority,path:p.path})),k.URI.from({scheme:S.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$bDb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,a=>{const R=a.charCodeAt(0);return R>=b.CharCode.a&&R<=b.CharCode.z||R>=b.CharCode.A&&R<=b.CharCode.Z||R>=b.CharCode.Digit0&&R<=b.CharCode.Digit9?a:"-"+R.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(a,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Ce[243],Ie([1,0,6,4,83]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0;class O{constructor(T,p,a){this.d=T,this.e=p,this.f=a,this.a=0,this.b=new S.$Vc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const y of this.c.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,a,R,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const E=this,f=this.a++,n=new b.$me,s=new b.$me,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,k.$dDb)(i,E.f)}get cspSource(){return k.$cDb}set options(i){this.b=i,E.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return E.d.$postMessage(f,i)}},h=new class{constructor(){this.editor=T,this.line=p,this.height=a,this.webview=o,this.onDidDispose=s.event}dispose(){E.c.has(f)&&(E.c.delete(f),E.d.$disposeEditorInset(f),s.fire(),s.dispose(),n.dispose())}};return this.d.$createEditorInset(f,u.id,u.value.document.uri,p+1,a,R||{},y.identifier,y.extensionLocation),this.c.set(f,{editor:T,inset:h,onDidReceiveMessage:n}),h}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$Aoc=O}),define(Ce[117],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0,e.$wM="__",e.$xM=(0,b.$Fi)("IAuthenticationService"),e.$yM=(0,b.$Fi)("IAuthenticationExtensionsService")}),define(Ce[244],Ie([1,0,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,b.$Fi)("configurationResolverService");var S;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(S||(e.VariableKind=S={}));class k extends Error{constructor(A,T){super(T),this.variable=A}}e.$PQ=k}),define(Ce[245],Ie([1,0,20,79,15,26,21,103,203,244,13]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,b=qe(b),S=qe(S),k=qe(k),O=qe(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,f,n,s){this.h=new Map,this.a=E,this.b=f,this.g=n,s&&(this.c=s.then(o=>this.i(o)))}i(E){if(A.$i){const f=Object.create(null);return Object.keys(E).forEach(n=>{f[n.toLowerCase()]=E[n]}),f}return E}resolveWithEnvironment(E,f,n){return this.l({env:this.i(E),userHome:void 0},f?f.uri:void 0,n)}async resolveAsync(E,f){const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,f)}async j(E,f,n,s){const o=O.$do(f);A.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):A.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):A.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,o,n,s)}async resolveAnyAsync(E,f,n){return this.j(E,f,n)}async resolveAnyMap(E,f,n){const s=new Map;return{newConfig:await this.j(E,f,n,s),resolvedVariables:s}}resolveWithInteractionReplace(E,f,n,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,f,n,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,f){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,f)}async l(E,f,n,s,o){if(k.$fg(n))return this.m(E,f,n,s,o);if(Array.isArray(n))return Promise.all(n.map(h=>this.l(E,f,h,s,o)));if(k.$hg(n)){const h=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(E,f,r,s,o),await this.l(E,f,n[r],s,o)]));for(const[r,t]of i)h[r]=t;return h}return n}m(E,f,n,s,o){return(0,R.$yf)(n,y.VARIABLE_REGEXP,async(h,i)=>{if(i.includes(y.VARIABLE_LHS))return h;let r=await this.o(E,h,i,f,s);return o?.set(i,r),r!==h&&k.$fg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(E,f,r,s,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,f,n,s,o){let h;const i=n.split(":");i.length>1&&(n=i[0],h=i[1]);const r=l=>{const m=this.a.getFilePath();if(m)return(0,T.$Ww)(m);throw new a.$PQ(l,(0,p.localize)(0,null,f))},t=l=>{const m=r(l);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,T.$Ww)(d)}throw new a.$PQ(l,(0,p.localize)(1,null,f,b.$pc(m)))},c=l=>{if(h){const m=this.a.getFolderUri(h);if(m)return m;throw new a.$PQ(l,(0,p.localize)(2,null,f,h))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new a.$PQ(l,(0,p.localize)(3,null,f)):new a.$PQ(l,(0,p.localize)(4,null,f))};switch(n){case"env":if(h){if(E.env){const l=E.env[A.$i?h.toLowerCase():h];if(k.$fg(l))return l}return""}throw new a.$PQ(a.VariableKind.Env,(0,p.localize)(5,null,f));case"config":if(h){const l=this.a.getConfigurationValue(s,h);if(k.$og(l))throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(6,null,f,h));if(k.$hg(l))throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(7,null,f,h));return l}throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(8,null,f));case"command":return this.p(a.VariableKind.Command,f,h,o,"command");case"input":return this.p(a.VariableKind.Input,f,h,o,"input");case"extensionInstallFolder":if(h){const l=await this.a.getExtension(h);if(!l)throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,f,h));return this.n(l.extensionLocation)}throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,f));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Ww)(this.n(c(a.VariableKind.WorkspaceFolder)));case"cwd":return s||h?(0,T.$Ww)(this.n(c(a.VariableKind.Cwd))):S.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Ww)(b.$pc(this.n(c(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new a.$PQ(a.VariableKind.UserHome,(0,p.localize)(11,null,f))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new a.$PQ(a.VariableKind.LineNumber,(0,p.localize)(12,null,f))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new a.$PQ(a.VariableKind.SelectedText,(0,p.localize)(13,null,f))}case"file":return r(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return b.$pc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||h?b.$nc(this.n(c(a.VariableKind.RelativeFile)),r(a.VariableKind.RelativeFile)):r(a.VariableKind.RelativeFile);case"relativeFileDirname":{const l=b.$oc(r(a.VariableKind.RelativeFileDirname));if(s||h){const m=b.$nc(this.n(c(a.VariableKind.RelativeFileDirname)),l);return m.length===0?".":m}return l}case"fileDirname":return b.$oc(r(a.VariableKind.FileDirname));case"fileExtname":return b.$qc(r(a.VariableKind.FileExtname));case"fileBasename":return b.$pc(r(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=b.$pc(r(a.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-b.$qc(l).length)}case"fileDirnameBasename":return b.$pc(b.$oc(r(a.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||f}case"execInstallFolder":{const l=this.a.getAppRoot();return l||f}case"pathSeparator":case"/":return b.sep;default:try{const l=h?`${n}:${h}`:n;return this.p(a.VariableKind.Unknown,f,l,o,void 0)}catch{return f}}}}p(E,f,n,s,o){if(n&&s){const h=o===void 0?s[n]:s[o+":"+n];if(typeof h=="string")return h;throw new a.$PQ(E,(0,p.localize)(14,null,f))}return f}}e.$5Q=y}),define(Ce[118],Ie([1,0,3,115]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$jE=void 0,e.$kE=a,e.$lE=u,e.$mE=E,e.$jE=(0,b.$Fi)("editorGroupsService");var k;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(k||(e.GroupDirection=k={}));var O;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function a(f){const n=f;return(0,S.$8F)(n?.editor)&&(0,S.$8F)(n?.replacement)}var R;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(f){const n=f;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function E(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?k.DOWN:k.RIGHT}}),define(Ce[246],Ie([1,0,3,118]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=k,e.$nE=(0,b.$Fi)("editorService"),e.$oE=-1,e.$pE=-2,e.$qE=-3;function k(O){const A=O;return typeof O=="number"||(0,S.$lE)(A)}}),define(Ce[247],Ie([1,0,3,107]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,b.$Gi)(S.$Mi)}),define(Ce[119],Ie([1,0,19,6,20,4,11]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=e.$Lcc=e.$Kcc=e.$Jcc=void 0,k=qe(k);class T{constructor(h,i){this.versionId=h,this.removedDueToLooping=i}}e.$Jcc=T;class p{static isHostExtension(h,i,r){if(i.getExtensionDescription(h))return!1;const t=r.getExtensionDescription(h);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(h,i){this.j=h,this.c=new S.$me,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new b.$sn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const i=this.j.readActivationEvents(h);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,i){this.e=s(this.e,i),this.e=this.e.concat(h);const r=p.l(this.e);return this.e=s(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(h){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,d){this.addNode(m),this.addNode(d),this.c.has(m)?this.c.get(m).push(d):this.c.set(m,[d])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,d){const $=i.getArcs(m);for(let I=0;I<$.length;I++)if(!d.has($[I]))return!1;return!0}getNodes(){return this.e}},r=new b.$sn;for(const m of h)if(r.set(m.identifier,m),m.extensionDependencies)for(const d of m.extensionDependencies)i.addArc(b.$qn.toKey(m.identifier),b.$qn.toKey(d));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const c=i.getNodes().filter(m=>!t.has(m));let l;do{l=!1;for(let m=0;m<c.length;m++){const d=c[m];i.hasOnlyGoodArcs(d,t)&&(c.splice(m,1),m--,t.add(d),l=!0)}}while(l);return c.map(m=>r.get(m))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const i=this.h.get(h);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const i=this.f.get(h);return i||void 0}getExtensionDescriptionByUUID(h){for(const i of this.g)if(i.uuid===h)return i}getExtensionDescriptionByIdOrUUID(h,i){return this.getExtensionDescription(h)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Kcc=p;class a{constructor(h,i){this.versionId=h,this.extensions=i}}e.$Lcc=a;class R{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const i=await this.d.acquire(h);return new y(this,i)}deltaExtensions(h,i,r){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,i){return this.c.getExtensionDescriptionByIdOrUUID(h,i)}}e.$Mcc=R;class y extends O.$Wc{constructor(h,i){super(),this.f=h,this.c=!1,this.B(i)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$Ncc=y;class u{constructor(h){this.name=h;const i=(0,A.$yh)();this.promise=i.promise,this.c=i.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const i=new u(h);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};h.resolve((0,O.$Uc)(t))}}var f;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(f||(f={}));function n(o,h){const i=o.isBuiltin?f.Builtin:o.isUnderDevelopment?f.Dev:f.User,r=h.isBuiltin?f.Builtin:h.isUnderDevelopment?f.Dev:f.User;if(i!==r)return i-r;const t=k.$ic.basename(o.extensionLocation.path),c=k.$ic.basename(h.extensionLocation.path);return t<c?-1:t>c?1:0}function s(o,h){const i=new b.$rn(h);return o.filter(r=>!i.has(r.identifier))}}),define(Ce[84],Ie([1,0,23]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$An=A,e.$Bn=T;var S;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(S||(e.UIKind=S={}));var k;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(k||(e.ExtensionHostExitCode=k={}));var O;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(a){const R=b.$Oe.alloc(1);switch(a){case O.Initialized:R.writeUInt8(1,0);break;case O.Ready:R.writeUInt8(2,0);break;case O.Terminate:R.writeUInt8(3,0);break}return R}function T(a,R){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return R===O.Initialized;case 2:return R===O.Ready;case 3:return R===O.Terminate;default:return!1}}var p;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[67],Ie([1,0,3,6,113,12,27,84,63,64,26,2,4,188]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=s;let f=class extends u.$Wc{constructor(h,i){super(),this.s=h,this.t=i,this.a=this.B(new S.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new S.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=k.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:a.$zp,name:(0,E.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,O.$bk)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===k.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=k.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=k.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=k.TelemetryLevel.USAGE:!1}}instantiateLogger(h,i,r){const t=this.getTelemetryDetails(),c=new n(i,r,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...l,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(h,i,r){this.f=h,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const i=Object.create(null);switch(i["common.extname"]=`${h.publisher}.${h.name}`,i["common.extversion"]=h.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$hn)((0,a.$Fp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const c=r.filter(l=>!l.isDisposed);c.length===0?this.r.delete(t):this.r.set(t,c)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,i){const t=this.r.get(h.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(h.value),!1;let c=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),c=!0);return c}};e.$fQ=f,e.$fQ=f=Qe([Ve(0,A.$eQ),Ve(1,O.$ak)],f);class n{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,i,r,t,c,l,m){this.g=r,this.h=t,this.i=c,this.j=l,this.a=new S.$me,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(h,i){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let i="properties"in h?h.properties??{}:h;return i=(0,a.$Ip)(i,[]),this.c&&(i=(0,R.$go)(i,this.c)),this.b||(i=(0,R.$go)(i,this.j)),"properties"in h?h.properties=i:h=i,h}k(h,i){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(h,i),this.h.trace(h,i))}logUsage(h,i){this.d.isUsageEnabled&&this.k(h,i)}logError(h,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,i);else{const r={name:h.name,message:h.message,stack:h.stack,cause:h.cause},t=(0,a.$Ip)(r,[]),c=new Error(t.message,{cause:t.cause});c.stack=t.stack,c.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const h=this,i={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=n;function s(o){const h=Date.now()-new Date(o).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$iQ=(0,b.$Fi)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,6,2,219,112,19,3]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.ActivationKind=e.$9G=e.$8G=e.$5G=e.ExtensionHostStartup=e.$4G=e.$3G=e.$2G=e.$1G=void 0,e.$6G=u,e.$7G=E,e.$0G=o,e.$$G=h,e.$1G=Object.freeze({identifier:new A.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:S.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2G="extensions.webWorker",e.$3G=(0,T.$Fi)("extensionService");class p{constructor(t){this.dependency=t}}e.$4G=p;var a;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,c,l){this.c=t,this.d=c.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$MG.createActivationEventsMap(this.d)}}set(t,c,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],d=[],$=[],I=[],D=y(this.d),v=y(c),C=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=v.get(N.identifier);if(!L){m.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,L)){m.push(N.identifier),D.delete(N.identifier);continue}}for(const N of c){const L=D.get(N.identifier);if(!L){d.push(N);continue}if(!C(L,N)){m.push(L.identifier),D.delete(L.identifier);continue}}const P=new A.$rn(this.e),g=new A.$rn(l);for(const N of this.e)g.has(N)||$.push(N);for(const N of l)P.has(N)||I.push(N);const w=O.$MG.createActivationEventsMap(d),M={versionId:t,toRemove:m,toAdd:d,addActivationEvents:w,myToRemove:$,myToAdd:I};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:c,toAdd:l,myToRemove:m,myToAdd:d}=t,$=new A.$rn(c),I=new A.$rn(m);for(let D=0;D<this.d.length;D++)$.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)I.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of l)this.d.push(D);for(const D of d)this.e.push(D);return this.f=null,t}containsExtension(t){for(const c of this.e)if(A.$qn.equals(c,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const c of this.d){if(!this.containsExtension(c.identifier))continue;const l=O.$MG.readActivationEvents(c);for(const m of l)t.add(m)}return t}}e.$5G=R;function y(r){const t=new A.$sn;for(const c of r)t.set(c.identifier,c);return t}function u(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function E(r,t){if(!u(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class f{constructor(t,c,l,m){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=m}}e.$8G=f;class n{constructor(t,c){this.description=t,this.value=c}}e.$9G=n;var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,k.$Op)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function h(r,t){const c=(0,k.$Mp)(r.manifest.publisher,r.manifest.name);return{id:c,identifier:new A.$qn(c),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None,this.onWillStop=b.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,c){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_G=i}),define(Ce[248],Ie([1,0,14,119,19,25,12,11]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=e.$Zoc=e.$Yoc=e.$Xoc=e.$Woc=void 0,b=qe(b);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,h,i,r){this.startup=o,this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=r}}e.$Woc=p;class a{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,h){return o===-1||h===-1?-1:h-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Xoc=a;class R{constructor(o,h,i,r,t,c){this.activationFailed=o,this.activationFailedError=h,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=c}}e.$Yoc=R;class y extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Zoc=y;class u extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$1oc=u;class E extends R{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(o,h,i,r){this.g=r,this.a=o,this.b=h,this.c=i,this.d=new k.$sn,this.f=Object.create(null)}dispose(){for(const[o,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const o=[];for(const[h,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const h=this.d.get(o);return!!(h&&h.value)}getActivatedExtension(o){const h=this.d.get(o);if(!h||!h.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return h.value}async activateByEvent(o,h){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:h,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,h){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:h}])}async h(o){const h=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(h.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const h=this.a.getExtensionDescription(o.id);if(!h){const t=new Error(`Cannot activate unknown extension '${o.id.value}'`),c=this.k(o,null,[],new E(t));return this.c.onExtensionActivationError(o.id,t,new O.$4G(o.id.value)),c}const i=[],r=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const t of r){if(this.m(t))continue;const c=this.d.get(t);if(c){i.push(c);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:o.reason}));continue}const l=this.a.getExtensionDescription(t);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:o.reason}));continue}const m=h.displayName||h.identifier.value,d=new Error(`Cannot activate the '${m}' extension because it depends on unknown extension '${t}'`),$=this.k(o,h.displayName,[],new E(d));return this.c.onExtensionActivationError(h.identifier,d,new O.$4G(t)),$}return this.k(o,h.displayName,i,null)}k(o,h,i,r){const t=new n(o.id,h,o.reason,i,r,this.c,this.g);return this.d.set(o.id,t),t}l(o){return S.$Kcc.isHostExtension(o,this.a,this.b)}m(o){const h=this.b.getExtensionDescription(o);return h?!h.main&&!h.browser:!1}};e.$2oc=f,e.$2oc=f=Qe([Ve(3,A.$_j)],f);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,h,i,r,t,c,l){this.c=o,this.d=h,this.f=i,this.g=r,this.h=t,this.j=c,this.k=l,this.a=new T.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const h=this.g[o];if(h.value&&!h.value.activationFailed){this.g.splice(o,1),o--;continue}if(h.value&&h.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);i.detail=h.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const h=new Error;if(o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this.h=new E(h),this.b&&b.$6(o))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};n=Qe([Ve(6,A.$_j)],n)});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[120],Ie([1,0,205,14,36,111,78,31,19,109,112,105]),function(oe,e,b,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,b=qe(b),k=ti(k);const u=T.$qo.as(A.$ro.JSONContribution);class E{constructor(t,c,l){this.a=t,this.b=c,this.c=l}d(t,c){this.a({type:t,message:c,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(k.default.Error,t)}warn(t){this.d(k.default.Warning,t)}info(t){this.d(k.default.Info,t)}}e.$UG=E;class f{static a(t){const c=new p.$rn;for(let l=0,m=t.length;l<m;l++)c.add(t[l].description.identifier);return c}static compute(t,c){if(!t||!t.length)return new f(c,[]);if(!c||!c.length)return new f([],t);const l=this.a(t),m=this.a(c),d=c.filter(I=>!l.has(I.description.identifier)),$=t.filter(I=>!m.has(I.description.identifier));return new f(d,$)}constructor(t,c){this.added=t,this.removed=c}}e.$VG=f;class n{constructor(t,c){this.name=t,this.defaultExtensionKind=c,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=f.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,S.$3)(t)}}}e.$WG=n;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[b.localize(0,null),b.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$XG={properties:{engines:{type:"object",description:b.localize(2,null),properties:{vscode:{type:"string",description:b.localize(3,null),default:"^1.22.0"}}},publisher:{description:b.localize(4,null),type:"string"},displayName:{description:b.localize(5,null),type:"string"},categories:{description:b.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$pn},{type:"string",const:"Languages",deprecationMessage:b.localize(7,null)}]}},galleryBanner:{type:"object",description:b.localize(8,null),properties:{color:{description:b.localize(9,null),type:"string"},theme:{description:b.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:b.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:b.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:b.localize(13,null)},enabledApiProposals:{markdownDescription:b.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:b.localize(15,null),type:"string",enum:["none"],enumDescriptions:[b.localize(16,null)]},activationEvents:{description:b.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:b.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:b.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:b.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:b.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:b.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:b.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:b.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:b.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:b.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:b.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:b.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:b.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:b.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:b.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:b.localize(32,null)},{label:"onUri",body:"onUri",description:b.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:b.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:b.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:b.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:b.localize(37,null)},{label:"onRenderer",description:b.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:b.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:b.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:b.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:b.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:b.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:b.localize(44,null)},{label:"*",description:b.localize(45,null),body:"*"}]}},badges:{type:"array",description:b.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:b.localize(47,null)},href:{type:"string",description:b.localize(48,null)},description:{type:"string",description:b.localize(49,null)}}}},markdown:{type:"string",description:b.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:b.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:b.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionPack:{description:b.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionKind:{description:b.localize(54,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:b.localize(55,null)},{body:["workspace"],description:b.localize(56,null)},{body:["ui","workspace"],description:b.localize(57,null)},{body:["workspace","ui"],description:b.localize(58,null)},{body:[],description:b.localize(59,null)}]},capabilities:{description:b.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:b.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:b.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[b.localize(63,null),b.localize(64,null),b.localize(65,null)]},description:{type:"string",markdownDescription:b.localize(66,null)}}},untrustedWorkspaces:{description:b.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:b.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)]},restrictedConfigurations:{description:b.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:b.localize(73,null)}}}}},sponsor:{description:b.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:b.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:b.localize(76,null),type:"string"},"vscode:uninstall":{description:b.localize(77,null),type:"string"}}},icon:{type:"string",description:b.localize(78,null)},l10n:{type:"string",description:b.localize(79,null)},pricing:{type:"string",markdownDescription:b.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const c=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,c),t.activationEventsGenerator&&R.$MG.register(t.extensionPoint,t.activationEventsGenerator),e.$XG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(o,e.$XG),c}getExtensionPoints(){return Array.from(this.a.values())}}e.$YG=h;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$qo.add(i.ExtensionsRegistry,new h),e.$ZG=T.$qo.as(i.ExtensionsRegistry),u.registerSchema(o,e.$XG),u.registerSchema(a.$tk,{properties:{extensionEnabledApiProposals:{description:b.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Ce[249],Ie([1,0,6,40,4,13,197,19,3,12,25,120]),function(oe,e,b,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.ChatMessageRole=void 0;var u;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$aH=(0,p.$Fi)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$bH=y.$ZG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(n,s)=>{for(const o of n)s.push(`onLanguageModelChat:${o.vendor}`)}});let f=class{constructor(s,o){this.e=s,this.f=o,this.a=new k.$Vc,this.b=new Map,this.c=new Set,this.d=this.a.add(new b.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$bH.setHandler(h=>{this.c.clear();for(const r of h){if(!(0,R.$6G)(r.description,"chatProvider")){r.collector.error((0,A.localize)(2,null));continue}for(const t of S.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,A.localize)(3,null,t.vendor));continue}if((0,O.$df)(t.vendor)){r.collector.error((0,A.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(5,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(s){return this.b.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this.e.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const h=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(h)}const o=[];for(const[h,i]of this.b)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$qn.equals(r,s.extension)))&&o.push(h);return this.f.trace("[LM] selected language models",s,o),o}registerLanguageModelChat(s,o){if(this.f.trace("[LM] registering language model chat",s,o.metadata),!this.c.has(o.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${o.metadata.vendor}.`);if(this.b.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this.b.set(s,o),this.d.fire({added:[{identifier:s,metadata:o.metadata}]}),(0,k.$Uc)(()=>{this.b.delete(s)&&(this.d.fire({removed:[s]}),this.f.trace("[LM] UNregistered language model chat",s,o.metadata))})}makeLanguageModelChatRequest(s,o,h,i,r,t){const c=this.b.get(s);if(!c)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return c.provideChatResponse(h,o,i,r,t)}computeTokenLength(s,o,h){const i=this.b.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(o,h)}};e.$cH=f,e.$cH=f=Qe([Ve(0,R.$3G),Ve(1,a.$_j)],f)}),define(Ce[250],Ie([1,0,200,15,26,120,32,6]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=void 0,b=qe(b),S=qe(S),k=qe(k);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:b.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:b.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:b.localize(2,null),default:""}}};var a;(function(u){function E(f,n,s){if(!f)return;const o=S.$fg(f.type)?f.type:void 0;if(!o||o.length===0){s.error(b.localize(3,null));return}const h=[];if(Array.isArray(f.required))for(const i of f.required)S.$fg(i)&&h.push(i);return{extensionId:n.value,taskType:o,required:h,properties:f.properties?k.$do(f.properties):{},when:f.when?A.$Dj.deserialize(f.when):void 0}}u.from=E})(a||(a={}));const R=O.$ZG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const f of u)f.type&&E.push(`onTaskType:${f.type}`)},jsonSchema:{description:b.localize(4,null),type:"array",items:p}});class y{constructor(){this.d=new T.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,f)=>{R.setHandler((n,s)=>{this.c=void 0;try{for(const o of s.removed){const h=o.value;for(const i of h)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of s.added){const h=o.value;for(const i of h){const r=a.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const f of this.all()){const n={type:"object",additionalProperties:!1};f.required.length>0&&(n.required=f.required.slice(0)),f.properties!==void 0?n.properties=k.$do(f.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[f.taskType]},E.push(n)}this.c={oneOf:E}}return this.c}}e.$HI=new y}),define(Ce[251],Ie([1,0,201,15,24,26,32,250,42]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$RI=e.JsonSchemaVersion=e.ExecutionEngine=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$LI=e.ShellQuoting=e.$KI=e.$JI=e.$II=void 0,b=qe(b),S=qe(S),k=qe(k),O=qe(O),e.$II="settings",e.$JI=new A.$Wj("taskRunning",!1,b.localize(0,null)),e.$KI=b.localize2(2,"Tasks");var a;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$LI="$customized",function(F){function V(ae){if(!ae)return F.Strong;switch(ae.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=V}(a||(e.ShellQuoting=a={}));var R;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var y;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(y||(e.RevealKind=y={})),function(F){function V(ae){switch(ae.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=V}(y||(e.RevealKind=y={}));var u;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(F){function V(ae){switch(ae.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=V}(u||(e.RevealProblemKind=u={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E||(e.PanelKind=E={})),function(F){function V(ae){switch(ae.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=V}(E||(e.PanelKind=E={}));var f;(function(F){F.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(f||(e.PresentationOptions=f={}));var n;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(F){function V($e){switch($e.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=V;function ae($e){switch($e){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=ae}(n||(e.RuntimeType=n={}));var s;(function(F){function V(ae){return S.$fg(ae)?ae:ae.value}F.value=V})(s||(e.CommandString=s={}));var o;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function V($e){return $e===F.Clean._id||$e===F.Build._id||$e===F.Rebuild._id||$e===F.Test._id}F.is=V;function ae($e){if($e!==void 0)return S.$fg($e)?V($e)?{_id:$e,isDefault:!1}:void 0:$e}F.from=ae})(o||(e.TaskGroup=o={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function V(ae){switch(ae){case F.User:return p.ConfigurationTarget.USER;case F.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=V})(i||(e.TaskSourceKind=i={}));var r;(function(F){F.parallel="parallel",F.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var c;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class l{constructor(V,ae,$e,_,ge,se){this._label="",this._id=V,ae&&(this._label=ae),$e&&(this.type=$e),this.runOptions=_,this.configurationProperties=ge,this._source=se}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,ae=!1){if(V===void 0)return!1;if(S.$fg(V))return V===this._label||V===this.configurationProperties.identifier||ae&&V===this._id;const $e=this.getDefinition(!0);return $e!==void 0&&$e._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$MI=l;class m extends l{constructor(V,ae,$e,_,ge,se,ce,we){super(V,$e,void 0,ce,we,ae),this.command={},this._source=ae,this.hasDefinedMatchers=se,ge&&(this.command=ge)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let ae;switch(this.command?this.command.runtime:void 0){case n.Shell:ae="shell";break;case n.Process:ae="process";break;case n.CustomExecution:ae="customExecution";break;case void 0:ae="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ae,_key:this._id,id:this._id}}}static is(V){return V instanceof m}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let ae=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ae+=this._source.kind);const $e={type:e.$LI,folder:V,id:ae};return JSON.stringify($e)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new m(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$NI=m;class d extends l{constructor(V,ae,$e,_,ge,se,ce){super(V,$e,_,se,ce,ae),this._source=ae,this.configures=ge}static is(V){return V instanceof d}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let ae=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ae+=this._source.kind);const $e={type:e.$LI,folder:V,id:ae};return JSON.stringify($e)}}e.$OI=d;class $ extends l{constructor(V,ae,$e,_,ge,se,ce,we,re){super(V,$e,_,we,re,ae),this.defines=ge,this.hasDefinedMatchers=ce,this.command=se,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof $}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new $(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$PI=$;class I extends l{constructor(V,ae,$e,_,ge,se){super(V,$e,_,ge,se,ae),this._source=ae}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new I(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$QI=I;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var v;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class C{constructor(V){this.c=new Map;for(let ae=0;ae<V.length;ae++)this.c.set(V[ae].uri.toString(),ae)}compare(V,ae){const $e=V.getWorkspaceFolder(),_=ae.getWorkspaceFolder();if($e&&_){let ge=this.c.get($e.uri.toString());ge=ge===void 0?0:ge+1;let se=this.c.get(_.uri.toString());return se=se===void 0?0:se+1,ge===se?V._label.localeCompare(ae._label):ge-se}else return!$e&&_?-1:$e&&!_?1:0}}e.$RI=C;var P;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(P||(e.TaskEventKind=P={}));var g;(function(F){F.SingleRun="singleRun",F.Background="background"})(g||(e.TaskRunType=g={}));var w;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var M;(function(F){function V(we){return{taskId:we._id,taskName:we.configurationProperties.name,runType:we.configurationProperties.isBackground?g.Background:g.SingleRun,group:we.configurationProperties.group,__task:we}}function ae(we,re,Pe){return{...V(we),kind:P.Start,terminalId:re,resolvedVariables:Pe}}F.start=ae;function $e(we,re,Pe){return{...V(we),kind:P.ProcessStarted,terminalId:re,processId:Pe}}F.processStarted=$e;function _(we,re,Pe){return{...V(we),kind:P.ProcessEnded,terminalId:re,exitCode:Pe}}F.processEnded=_;function ge(we,re,Pe){return{...V(we),kind:P.Terminated,exitReason:Pe,terminalId:re}}F.terminated=ge;function se(we,re,Pe){return{...V(re),kind:we,terminalId:Pe}}F.general=se;function ce(){return{kind:P.Changed}}F.changed=ce})(M||(e.TaskEvent=M={}));var N;(function(F){function V($e){const _=Object.keys($e).sort();let ge="";for(const se of _){let ce=$e[se];ce instanceof Object?ce=V(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),ge+=se+","+ce+","}return ge}function ae($e){const ge={_key:V($e),type:$e.taskType};return Object.assign(ge,$e),ge}F.create=ae})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var G;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var B;(function(F){function V(ae,$e){const _=T.$HI.get(ae.type);if(_===void 0){const we=O.$do(ae);return delete we._key,N.create(we)}const ge=Object.create(null);ge.type=_.taskType;const se=new Set;_.required.forEach(we=>se.add(we));const ce=_.properties;for(const we of Object.keys(ce)){const re=ae[we];if(re!=null)ge[we]=re;else if(se.has(we)){const Pe=ce[we];if(Pe.default!==void 0)ge[we]=O.$do(Pe.default);else switch(Pe.type){case"boolean":ge[we]=!1;break;case"number":case"integer":ge[we]=0;break;case"string":ge[we]="";break;default:$e.error(b.localize(1,null,JSON.stringify(ae,void 0,0),we));return}}}return N.create(ge)}F.createTaskIdentifier=V})(B||(e.TaskDefinition=B={}))}),define(Ce[252],Ie([1,0,14]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;class S{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,b.$3)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Occ=S;class k extends S{constructor(){super(),this.h=!0,this.i=new b.$7}}e.$Pcc=k}),define(Ce[39],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Qw=void 0,e.$Rw=k,e.$Sw=O;class b{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++b.count}}e.$Qw=b;const S=[];function k(T){const p=new b(T);return S[p.nid]=p,p}function O(T){return S[T].sid}class A{constructor(p){this.value=p}}e.$Tw=A}),define(Ce[5],Ie([1,0,39]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var S;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(S||(e.TextEditorRevealType=S={}));var k;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(k||(e.TabInputKind=k={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var a;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class y{static{this.a=0}static mixin(s){return s._id=y.a++,s}}e.$tN=y;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var f;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$uN={MainThreadAuthentication:(0,b.$Rw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.$Rw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,b.$Rw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,b.$Rw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,b.$Rw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,b.$Rw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,b.$Rw)("MainThreadChatSkills"),MainThreadClipboard:(0,b.$Rw)("MainThreadClipboard"),MainThreadCommands:(0,b.$Rw)("MainThreadCommands"),MainThreadComments:(0,b.$Rw)("MainThreadComments"),MainThreadConfiguration:(0,b.$Rw)("MainThreadConfiguration"),MainThreadConsole:(0,b.$Rw)("MainThreadConsole"),MainThreadDebugService:(0,b.$Rw)("MainThreadDebugService"),MainThreadDecorations:(0,b.$Rw)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.$Rw)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.$Rw)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.$Rw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.$Rw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.$Rw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.$Rw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.$Rw)("MainThreadEditorTabs"),MainThreadErrors:(0,b.$Rw)("MainThreadErrors"),MainThreadTreeViews:(0,b.$Rw)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.$Rw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,b.$Rw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.$Rw)("MainThreadLanguages"),MainThreadLogger:(0,b.$Rw)("MainThreadLogger"),MainThreadMessageService:(0,b.$Rw)("MainThreadMessageService"),MainThreadOutputService:(0,b.$Rw)("MainThreadOutputService"),MainThreadProgress:(0,b.$Rw)("MainThreadProgress"),MainThreadQuickDiff:(0,b.$Rw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,b.$Rw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.$Rw)("MainThreadStatusBar"),MainThreadSecretState:(0,b.$Rw)("MainThreadSecretState"),MainThreadStorage:(0,b.$Rw)("MainThreadStorage"),MainThreadSpeech:(0,b.$Rw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,b.$Rw)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.$Rw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,b.$Rw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,b.$Rw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.$Rw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.$Rw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.$Rw)("MainThreadCustomEditors"),MainThreadUrls:(0,b.$Rw)("MainThreadUrls"),MainThreadUriOpeners:(0,b.$Rw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,b.$Rw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,b.$Rw)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.$Rw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,b.$Rw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,b.$Rw)("MainThreadExtensionService"),MainThreadSCM:(0,b.$Rw)("MainThreadSCM"),MainThreadSearch:(0,b.$Rw)("MainThreadSearch"),MainThreadShare:(0,b.$Rw)("MainThreadShare"),MainThreadTask:(0,b.$Rw)("MainThreadTask"),MainThreadWindow:(0,b.$Rw)("MainThreadWindow"),MainThreadLabelService:(0,b.$Rw)("MainThreadLabelService"),MainThreadNotebook:(0,b.$Rw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.$Rw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.$Rw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.$Rw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.$Rw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.$Rw)("MainThreadInteractive"),MainThreadTheming:(0,b.$Rw)("MainThreadTheming"),MainThreadTunnelService:(0,b.$Rw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,b.$Rw)("MainThreadManagedSockets"),MainThreadTimeline:(0,b.$Rw)("MainThreadTimeline"),MainThreadTesting:(0,b.$Rw)("MainThreadTesting"),MainThreadLocalization:(0,b.$Rw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,b.$Rw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,b.$Rw)("MainThreadAiEmbeddingVector")},e.$vN={ExtHostCommands:(0,b.$Rw)("ExtHostCommands"),ExtHostConfiguration:(0,b.$Rw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.$Rw)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.$Rw)("ExtHostDebugService"),ExtHostDecorations:(0,b.$Rw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.$Rw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.$Rw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.$Rw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.$Rw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.$Rw)("ExtHostEditors"),ExtHostTreeViews:(0,b.$Rw)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.$Rw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.$Rw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.$Rw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.$Rw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.$Rw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.$Rw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,b.$Rw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,b.$Rw)("ExtHostStatusBar"),ExtHostShare:(0,b.$Rw)("ExtHostShare"),ExtHostExtensionService:(0,b.$Rw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.$Rw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.$Rw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,b.$Rw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,b.$Rw)("ExtHostSCM"),ExtHostSearch:(0,b.$Rw)("ExtHostSearch"),ExtHostTask:(0,b.$Rw)("ExtHostTask"),ExtHostWorkspace:(0,b.$Rw)("ExtHostWorkspace"),ExtHostWindow:(0,b.$Rw)("ExtHostWindow"),ExtHostWebviews:(0,b.$Rw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.$Rw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.$Rw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.$Rw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.$Rw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.$Rw)("ExtHostEditorTabs"),ExtHostProgress:(0,b.$Rw)("ExtHostProgress"),ExtHostComments:(0,b.$Rw)("ExtHostComments"),ExtHostSecretState:(0,b.$Rw)("ExtHostSecretState"),ExtHostStorage:(0,b.$Rw)("ExtHostStorage"),ExtHostUrls:(0,b.$Rw)("ExtHostUrls"),ExtHostUriOpeners:(0,b.$Rw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,b.$Rw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,b.$Rw)("ExtHostOutputService"),ExtHostLabelService:(0,b.$Rw)("ExtHostLabelService"),ExtHostNotebook:(0,b.$Rw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.$Rw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.$Rw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.$Rw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.$Rw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,b.$Rw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,b.$Rw)("ExtHostInteractive"),ExtHostChatAgents2:(0,b.$Rw)("ExtHostChatAgents"),ExtHostChatVariables:(0,b.$Rw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,b.$Rw)("ExtHostChatSkills"),ExtHostChatProvider:(0,b.$Rw)("ExtHostChatProvider"),ExtHostSpeech:(0,b.$Rw)("ExtHostSpeech"),ExtHostEmbeddings:(0,b.$Rw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,b.$Rw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,b.$Rw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,b.$Rw)("ExtHostTheming"),ExtHostTunnelService:(0,b.$Rw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,b.$Rw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,b.$Rw)("ExtHostAuthentication"),ExtHostTimeline:(0,b.$Rw)("ExtHostTimeline"),ExtHostTesting:(0,b.$Rw)("ExtHostTesting"),ExtHostTelemetry:(0,b.$Rw)("ExtHostTelemetry"),ExtHostLocalization:(0,b.$Rw)("ExtHostLocalization")}}),define(Ce[85],Ie([1,0,3,12,5,17]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=e.$koc=e.$joc=void 0,k=qe(k),e.$joc=(0,b.$Fi)("IExtHostApiDeprecationService");let A=class{constructor(p,a){this.c=a,this.a=new Set,this.b=p.getProxy(k.$uN.MainThreadTelemetry)}report(p,a,R){const y=this.d(p,a);this.a.has(y)||(this.a.add(y),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:p}))}d(p,a){return`${p}-${a.identifier.value}`}};e.$koc=A,e.$koc=A=Qe([Ve(0,O.$1P),Ve(1,S.$_j)],A),e.$loc=Object.freeze(new class{report(T,p,a){}})}),define(Ce[253],Ie([1,0,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;class S{constructor(O){const A=O.getProxy(b.$uN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$yoc=S}),define(Ce[254],Ie([1,0,26,5,27,17]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0;let A=class{constructor(R,y){this.a=R.getProxy(S.$uN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,y){const u=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u.e(R,y,E,arguments)}})}e(R,y,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:p(E,this.b)}),this.c&&this.f(R,u,E)}};e.$uqc=A,e.$uqc=A=Qe([Ve(0,O.$1P),Ve(1,k.$eQ)],A);const T=1e5;function p(a,R){const y=[];if(a.length)for(let u=0;u<a.length;u++){let E=a[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const f=E;f.stack?E=f.stack:E=f.toString()}y.push(E)}if(R){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,b.$io)(y);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[255],Ie([1,0,2,5,25]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;class O{constructor(T){this.a=T.getProxy(S.$uN.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,k.$7G)(T,"showLocal"),this.a.$showOpenDialog(p).then(a=>a?a.map(R=>b.URI.revive(R)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?b.URI.revive(p):void 0)}}e.$Apc=O}),define(Ce[256],Ie([1,0,22,6,4,5]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class A{constructor(p){this.b=new Map,this.c=new S.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(O.$uN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,a,R){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,a),this.b.set(y,{id:a,provider:R}),(0,k.$Uc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(p,a,R){R??=b.CancellationToken.None;let y=!1;typeof a=="string"&&(a=[a],y=!0);const u=await this.a.$computeEmbeddings(p,a,R);if(u.length!==a.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,a,R){const y=this.b.get(p);if(!y)return[];const u=await y.provider.provideEmbeddings(a,R);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Dpc=A}),define(Ce[257],Ie([1,0,4,5]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0;class k{constructor(A){this.b=0,this.a=A.getProxy(S.$uN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,b.$Uc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Upc=k}),define(Ce[86],Ie([1,0,21,13,2,3,12,5,27,17]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=e.$dpc=void 0;let R=class{constructor(u,E,f){this.f=f,this.d=new Map,this.a=E.getProxy(T.$uN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===b.$g}getMessage(u,E){const{message:f,args:n,comment:s}=E;if(this.c)return(0,S.$ff)(f,n??{});let o=f;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const h=this.d.get(u)?.contents[o];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,S.$ff)(h??f,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const f=await this.g(u);if(!f){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(f),s=JSON.parse(n);E=u.isBuiltin?s.contents?.bundle:s}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${f}: ${n.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:f})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return k.URI.revive(E)}return u.l10n?k.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$dpc=R,e.$dpc=R=Qe([Ve(0,p.$eQ),Ve(1,a.$1P),Ve(2,A.$_j)],R),e.$epc=(0,O.$Fi)("IExtHostLocalizationService")}),define(Ce[258],Ie([1,0,12,5,27,17,2,49]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0;let p=class extends b.$kk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,T.$ci)(E))),this.r=y.getProxy(S.$uN.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(A.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,E){return new a(this.r,y,u,E)}};e.$tqc=p,e.$tqc=p=Qe([Ve(0,O.$1P),Ve(1,k.$eQ)],p);class a extends b.$fk{constructor(y,u,E,f){super(f?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,f).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const E=[[y,u]];this.m?this.u(E):this.n.push(...E)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ce[87],Ie([1,0,5,3,4,17,23]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=e.$fpc=void 0,e.$fpc=(0,S.$Fi)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(b.$uN.MainThreadManagedSockets)}setFactory(y,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,E=await this.c.makeConnection(),f=new k.$Vc;return this.d.set(u,new a(u,E,f)),f.add((0,k.$Uc)(()=>this.d.delete(u))),f.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),f.dispose()})),f.add(E.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),f.dispose()})),f.add(E.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,A.$Oe.wrap(n)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$gpc=T,e.$gpc=T=Qe([Ve(0,O.$1P)],T);class p{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class a extends k.$Wc{constructor(y,u,E){super(),this.socketId=y,this.actual=u,this.B(E)}}}),define(Ce[259],Ie([1,0,5,12,25]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0;function O(T){return T&&T.title}let A=class{constructor(p,a){this.b=a,this.a=p.getProxy(b.$uN.MainThreadMessageService)}showMessage(p,a,R,y,u){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let f;typeof y=="string"||O(y)?f=[y,...u]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,f=u),E.useCustom&&(0,k.$7G)(p,"resolvers");const n=[];let s=!1;for(let o=0;o<f.length;o++){const h=f[o];if(typeof h=="string")n.push({title:h,handle:o,isCloseAffordance:!1});else if(typeof h=="object"){const{title:i,isCloseAffordance:r}=h;n.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(s?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):s=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(a,R,E,n).then(o=>{if(typeof o=="number")return f[o]})}};e.$Wpc=A,e.$Wpc=A=Qe([Ve(1,S.$_j)],A)}),define(Ce[260],Ie([1,0,4,15,2,25,5]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;class T{constructor(a){this.b=new Map,this.a=a.getProxy(A.$uN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,R,y){if((0,O.$7G)(a,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,y),this.a.$registerProfileContentHandler(R,y.name,y.description,a.identifier.value),(0,b.$Uc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(a,R,y,u){const E=this.b.get(a);if(!E)throw new Error(`Unknown handler with id: ${a}`);return E.saveProfile(R,y,u)}async $readProfile(a,R,y){const u=this.b.get(a);if(!u)throw new Error(`Unknown handler with id: ${a}`);return u.readProfile((0,S.$fg)(R)?R:k.URI.revive(R),y)}}e.$6pc=T}),define(Ce[88],Ie([1,0,5,6,3]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0;class O{constructor(T){this.b=new S.$me,this.onDidChangePassword=this.b.event,this.a=T.getProxy(b.$uN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,a){return this.a.$setPassword(T,p,a)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$apc=O,e.$bpc=(0,k.$Fi)("IExtHostSecretState")}),define(Ce[261],Ie([1,0,22,4,5]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(k.$uN.MainThreadSpeech)}async $createSpeechToTextSession(T,p,a){const R=this.c.get(T);if(!R)return;const y=new S.$Vc,u=new b.$xe;this.d.set(p,u);const E=await R.provideSpeechToTextSession(u.token,a?{language:a}:void 0);E&&(y.add(E.onDidChange(f=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,f)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,a){const R=this.c.get(T);if(!R)return;const y=new S.$Vc,u=new b.$xe;this.d.set(p,u);const E=await R.provideTextToSpeechSession(u.token,a?{language:a}:void 0);E&&(this.f.set(p,E),y.add(E.onDidChange(f=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,f)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const a=this.c.get(T);if(!a)return;const R=new S.$Vc,y=new b.$xe;this.d.set(p,y);const u=await a.provideKeywordRecognitionSession(y.token);u&&(R.add(u.onDidChange(E=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),R.add(y.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,a){const R=O.a++;return this.c.set(R,a),this.b.$registerProvider(R,p,{extension:T,displayName:T.value}),(0,S.$Uc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$aqc=O}),define(Ce[89],Ie([1,0,5,6,3]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$3oc=void 0;class O{constructor(T,p){this.c=p,this.b=new S.$me,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(b.$uN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,a){const R=await this.a.$initializeExtensionStorage(T,p);let y;return R&&(y=this.d(T,p,R)),y||a}setValue(T,p,a){return this.a.$setValue(T,p,a)}$acceptValue(T,p,a){const R=this.d(T,p,a);R&&this.b.fire({shared:T,key:p,value:R})}d(T,p,a){try{return JSON.parse(a)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${R}`)}}}e.$3oc=O,e.$4oc=(0,k.$Fi)("IExtHostStorage")}),define(Ce[262],Ie([1,0,4,16,2,5]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=void 0;class A{static{this.a=new Set([S.Schemas.http,S.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$uN.MainThreadUriOpeners)}registerExternalUriOpener(p,a,R,y){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const u=y.schemes.find(E=>!A.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(a,R),this.b.$registerUriOpener(a,y.schemes,p,y.label),(0,b.$Uc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri(p,a,R){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener with id: ${p}`);const u=k.URI.revive(a);return y.canOpenExternalUri(u,R)}async $openUri(p,a,R){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener id: '${p}'`);return y.openExternalUri(k.URI.revive(a.resolvedUri),{sourceUri:k.URI.revive(a.sourceUri)},R)}}e.$mqc=A}),define(Ce[263],Ie([1,0,5,2,4,14,19]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;class T{static{this.a=0}constructor(a){this.c=new A.$rn,this.d=new Map,this.b=a.getProxy(b.$uN.MainThreadUrls)}registerUriHandler(a,R){const y=a.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=T.a++;return this.c.add(y),this.d.set(u,R),this.b.$registerUriHandler(u,y,a.displayName||a.name),(0,k.$Uc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(a,R){const y=this.d.get(a);if(!y)return Promise.resolve(void 0);try{y.handleUri(S.URI.revive(R))}catch(u){(0,O.$3)(u)}return Promise.resolve(void 0)}async createAppUri(a){return S.URI.revive(await this.b.$createAppUri(a))}}e.$nqc=T}),define(Ce[264],Ie([1,0,23,5]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vtb=O,e.$wtb=T,S=qe(S);class k{constructor(){this.buffers=[]}add(a){let R=this.buffers.indexOf(a);return R<0&&(R=this.buffers.length,this.buffers.push(a)),R}}function O(p,a){if(a.serializeBuffersForPostMessage){const R=new k,u=JSON.stringify(p,(f,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n)};if(ArrayBuffer.isView(n)){const s=A(n);if(s)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n.buffer),view:{type:s,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),E=R.buffers.map(f=>{const n=new Uint8Array(f);return b.$Oe.wrap(n)});return{message:u,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return S.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return S.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return S.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return S.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return S.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return S.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return S.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return S.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return S.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return S.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return S.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,a){const R=a.map(E=>{const f=new ArrayBuffer(E.byteLength);return new Uint8Array(f).set(E.buffer),f}),y=a.length?(E,f)=>{if(f&&typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const n=f,{index:s}=n,o=R[s];if(n.view)switch(n.view.type){case S.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(o,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(o,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(o,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(o,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(o,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(o,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(o,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(o,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(o,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(o,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(o,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return f}:void 0;return{message:JSON.parse(p,y),arrayBuffers:R}}}),define(Ce[68],Ie([1,0,6,4,16,26,2,216,264,83,5]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=e.$Noc=void 0,e.$Ooc=u,e.$Qoc=n,e.$Roc=s,O=qe(O),R=qe(R);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,t,c,l,m,d,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new b.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new b.$me,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=c,this.#n=l,this.#s=m,this.#r=d,this.#l=u(d),this.#d=E(d),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,a.$dDb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===k.Schemas.https||r.scheme===k.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$cDb}return a.$cDb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),O.$ho(this.#o,r)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,p.$vtb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===k.Schemas.vscodeRemote,c=this.#r.extensionLocation.scheme===k.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,d,$,I,D)=>{const v=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),C=(0,a.$dDb)(v,{isRemote:t,authority:c}).toString();return`${m}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,d,$,I,D)=>{const v=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),C=(0,a.$dDb)(v,{isRemote:t,authority:c}).toString();return`${m}${C}${D}`})}}e.$Noc=y;function u(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class f extends S.$Wc{constructor(r,t,c,l,m){super(),this.c=t,this.f=c,this.g=l,this.h=m,this.b=new Map,this.a=r.getProxy(R.$uN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,c){const l=this.j(r);if(l){const{message:m}=(0,p.$wtb)(t,c.value);l._onMessageEmitter.fire(m)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,c){const l=new y(r,this.a,o(t),this.c,this.f,c,this.h);this.b.set(r,l);const m=l._onDidDispose(()=>{m.dispose(),this.deleteWebview(r)});return l}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Poc=f;function n(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||h(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function h(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ce[121],Ie([1,0,6,16,13,2,3,17,5]),function(oe,e,b,S,k,O,A,T,p){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=e.$pqc=void 0;let R=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new b.$me,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=u.getProxy(p.$uN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:f})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let f;if(typeof u=="string"){f=u;try{u=O.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,k.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,f,E)}async asExternalUri(u,E){if((0,k.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(u,E);return O.URI.from(f)}};e.$pqc=R,e.$pqc=R=a=Qe([Ve(0,T.$1P)],R),e.$qqc=(0,A.$Fi)("IExtHostWindow")}),define(Ce[265],Ie([1,0,254,27,17]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0;let O=class extends b.$uqc{constructor(T,p){super(T,p)}f(T,p,a){p.apply(console,a)}};e.$Esc=O,e.$Esc=O=Qe([Ve(0,k.$1P),Ve(1,S.$eQ)],O)}),define(Ce[266],Ie([1,0,11,23,22,28,14,6,4,38,161,252,39]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Qcc=h,e.$Rcc=i,A=qe(A);function f(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const n="$$ref$$",s={[n]:-1};class o{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function h(M,N=null,L=!1){const G=[];return{jsonString:(L?f:JSON.stringify)(M,(F,V)=>{if(typeof V>"u")return s;if(typeof V=="object"){if(V instanceof S.$Oe){const ae=G.push(V)-1;return{[n]:ae}}if(N)return N(F,V)}return V}),referencedBuffers:G}}function i(M,N,L){return JSON.parse(M,(G,B)=>{if(B){const F=B[n];if(typeof F=="number")return N[F];if(L&&B.$mid===a.MarshalledId.Uri)return L.transformIncoming(B)}return B})}function r(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,L)=>L&&L.$mid===a.MarshalledId.Uri?M.transformOutgoing(L):L:null}var c;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const m=()=>{},d=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class I extends p.$Wc{static{E=d}static{this.a=3*1e3}constructor(N,L=null,G=null){super(),this[E]=!0,this.b=this.B(new T.$me),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=G,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let B=0,F=u.$Qw.count;B<F;B++)this.m[B]=null,this.s[B]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new b.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(B=>this.L(B)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(A.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+I.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+I.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,R.$On)(N,this.g):N}getProxy(N){const{nid:L,sid:G}=N;return this.s[L]||(this.s[L]=this.J(L,G)),this.s[L]}J(N,L){const G={get:(B,F)=>(typeof F=="string"&&!B[F]&&F.charCodeAt(0)===O.CharCode.DollarSign&&(B[F]=(...V)=>this.U(N,F,V)),F===$?L:B[F])};return new Proxy(Object.create(null),G)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,G=N.length;L<G;L++){const B=N[L];if(!this.m[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,G=v.read(N,0),B=G.readUInt8(),F=G.readUInt32();switch(B){case g.RequestJSONArgs:case g.RequestJSONArgsWithCancellation:{let{rpcId:V,method:ae,args:$e}=P.deserializeRequestJSONArgs(G);this.g&&($e=(0,R.$On)($e,this.g)),this.M(L,F,V,ae,$e,B===g.RequestJSONArgsWithCancellation);break}case g.RequestMixedArgs:case g.RequestMixedArgsWithCancellation:{let{rpcId:V,method:ae,args:$e}=P.deserializeRequestMixedArgs(G);this.g&&($e=(0,R.$On)($e,this.g)),this.M(L,F,V,ae,$e,B===g.RequestMixedArgsWithCancellation);break}case g.Acknowledged:{this.f?.logIncoming(L,F,c.LocalSide,"ack"),this.G(F);break}case g.Cancel:{this.N(L,F);break}case g.ReplyOKEmpty:{this.O(L,F,void 0);break}case g.ReplyOKJSON:{let V=P.deserializeReplyOKJSON(G);this.g&&(V=(0,R.$On)(V,this.g)),this.O(L,F,V);break}case g.ReplyOKJSONWithBuffers:{const V=P.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(L,F,V);break}case g.ReplyOKVSBuffer:{const V=P.deserializeReplyOKVSBuffer(G);this.O(L,F,V);break}case g.ReplyErrError:{let V=P.deserializeReplyErrError(G);this.g&&(V=(0,R.$On)(V,this.g)),this.P(L,F,V);break}case g.ReplyErrEmpty:{this.P(L,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,G,B,F,V){this.f?.logIncoming(N,L,c.OtherSide,`receiveRequest ${(0,u.$Sw)(G)}.${B}(`,F);const ae=String(L);let $e,_;if(V){const se=new k.$xe;F.push(se.token),$e=this.Q(G,B,F),_=()=>se.cancel()}else $e=this.Q(G,B,F),_=m;this.u[ae]=_;const ge=P.serializeAcknowledged(L);this.f?.logOutgoing(ge.byteLength,L,c.OtherSide,"ack"),this.c.send(ge),$e.then(se=>{delete this.u[ae];const ce=P.serializeReplyOK(L,se,this.h);this.f?.logOutgoing(ce.byteLength,L,c.OtherSide,"reply:",se),this.c.send(ce)},se=>{delete this.u[ae];const ce=P.serializeReplyErr(L,se);this.f?.logOutgoing(ce.byteLength,L,c.OtherSide,"replyErr:",se),this.c.send(ce)})}N(N,L){this.f?.logIncoming(N,L,c.OtherSide,"receiveCancel");const G=String(L);this.u[G]?.()}O(N,L,G){this.f?.logIncoming(N,L,c.LocalSide,"receiveReply:",G);const B=String(L);if(!this.w.hasOwnProperty(B))return;const F=this.w[B];delete this.w[B],F.resolveOk(G)}P(N,L,G){this.f?.logIncoming(N,L,c.LocalSide,"receiveReplyErr:",G);const B=String(L);if(!this.w.hasOwnProperty(B))return;const F=this.w[B];delete this.w[B];let V;G&&(G.$isError?(V=new Error,V.name=G.name,V.message=G.message,V.stack=G.stack):V=G),F.resolveErr(V)}Q(N,L,G){try{return Promise.resolve(this.S(N,L,G))}catch(B){return Promise.reject(B)}}S(N,L,G){const B=this.m[N];if(!B)throw new Error("Unknown actor "+(0,u.$Sw)(N));const F=B[L];if(typeof F!="function")throw new Error("Unknown method "+L+" on actor "+(0,u.$Sw)(N));return F.apply(B,G)}U(N,L,G){if(this.j)return new y.$Pcc;let B=null;if(G.length>0&&k.CancellationToken.isCancellationToken(G[G.length-1])&&(B=G.pop()),B&&B.isCancellationRequested)return Promise.reject(A.$8());const F=P.serializeRequestArguments(G,this.h),V=++this.t,ae=String(V),$e=new y.$Occ,_=new p.$Vc;B&&_.add(B.onCancellationRequested(()=>{const se=P.serializeCancel(V);this.f?.logOutgoing(se.byteLength,V,c.LocalSide,"cancel"),this.c.send(P.serializeCancel(V))})),this.w[ae]=new D($e,_),this.F(V);const ge=P.serializeRequest(V,N,L,F,!!B);return this.f?.logOutgoing(ge.byteLength,V,c.LocalSide,`request: ${(0,u.$Sw)(N)}.${L}(`,G),this.c.send(ge),$e}}e.$Scc=I;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class v{static alloc(N,L,G){const B=new v(S.$Oe.alloc(G+1+4),0);return B.writeUInt8(N),B.writeUInt32(L),B}static read(N,L){return new v(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let G=0,B=N.length;G<B;G++){const F=N[G];switch(L+=1,F.type){case w.String:L+=this.sizeLongString(F.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(F.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(F.value);for(let V=0;V<F.buffers.length;++V)L+=this.sizeVSBuffer(F.buffers[V]);break;case w.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,G=N.length;L<G;L++){const B=N[L];switch(B.type){case w.String:this.writeUInt8(w.String),this.writeLongString(B.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(B.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let F=0;F<B.buffers.length;++F)this.writeBuffer(B.buffers[F]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let G=0;G<N;G++)switch(this.readUInt8()){case w.String:L[G]=this.readLongString();break;case w.VSBuffer:L[G]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const F=this.readUInt32(),V=this.readLongString(),ae=[];for(let $e=0;$e<F;++$e)ae.push(this.readVSBuffer());L[G]=new u.$Tw(i(V,ae,null));break}case w.Undefined:L[G]=void 0;break}return L}}var C;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(C||(C={}));class P{static a(N){for(let L=0,G=N.length;L<G;L++)if(N[L]instanceof S.$Oe||N[L]instanceof u.$Tw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const G=[];for(let B=0,F=N.length;B<F;B++){const V=N[B];if(V instanceof S.$Oe)G[B]={type:w.VSBuffer,value:V};else if(typeof V>"u")G[B]={type:w.Undefined};else if(V instanceof u.$Tw){const{jsonString:ae,referencedBuffers:$e}=h(V.value,L);G[B]={type:w.SerializedObjectWithBuffers,value:S.$Oe.fromString(ae),buffers:$e}}else G[B]={type:w.String,value:S.$Oe.fromString(r(V,L))}}return{type:C.Mixed,args:G}}return{type:C.Simple,args:r(N,L)}}static serializeRequest(N,L,G,B,F){switch(B.type){case C.Simple:return this.b(N,L,G,B.args,F);case C.Mixed:return this.c(N,L,G,B.args,F)}}static b(N,L,G,B,F){const V=S.$Oe.fromString(G),ae=S.$Oe.fromString(B);let $e=0;$e+=v.sizeUInt8(),$e+=v.sizeShortString(V),$e+=v.sizeLongString(ae);const _=v.alloc(F?g.RequestJSONArgsWithCancellation:g.RequestJSONArgs,N,$e);return _.writeUInt8(L),_.writeShortString(V),_.writeLongString(ae),_.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),G=N.readShortString(),B=N.readLongString();return{rpcId:L,method:G,args:JSON.parse(B)}}static c(N,L,G,B,F){const V=S.$Oe.fromString(G);let ae=0;ae+=v.sizeUInt8(),ae+=v.sizeShortString(V),ae+=v.sizeMixedArray(B);const $e=v.alloc(F?g.RequestMixedArgsWithCancellation:g.RequestMixedArgs,N,ae);return $e.writeUInt8(L),$e.writeShortString(V),$e.writeMixedArray(B),$e.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),G=N.readShortString(),B=N.readMixedArray(),F=new Array(B.length);for(let V=0,ae=B.length;V<ae;V++){const $e=B[V];typeof $e=="string"?F[V]=JSON.parse($e):F[V]=$e}return{rpcId:L,method:G,args:F}}static serializeAcknowledged(N){return v.alloc(g.Acknowledged,N,0).buffer}static serializeCancel(N){return v.alloc(g.Cancel,N,0).buffer}static serializeReplyOK(N,L,G){if(typeof L>"u")return this.d(N);if(L instanceof S.$Oe)return this.e(N,L);if(L instanceof u.$Tw){const{jsonString:B,referencedBuffers:F}=h(L.value,G,!0);return this.g(N,B,F)}else return this.f(N,f(L,G))}static d(N){return v.alloc(g.ReplyOKEmpty,N,0).buffer}static e(N,L){let G=0;G+=v.sizeVSBuffer(L);const B=v.alloc(g.ReplyOKVSBuffer,N,G);return B.writeVSBuffer(L),B.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const G=S.$Oe.fromString(L);let B=0;B+=v.sizeLongString(G);const F=v.alloc(g.ReplyOKJSON,N,B);return F.writeLongString(G),F.buffer}static g(N,L,G){const B=S.$Oe.fromString(L);let F=0;F+=v.sizeUInt32,F+=v.sizeLongString(B);for(const ae of G)F+=v.sizeVSBuffer(ae);const V=v.alloc(g.ReplyOKJSONWithBuffers,N,F);V.writeUInt32(G.length),V.writeLongString(B);for(const ae of G)V.writeBuffer(ae);return V.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const G=N.readUInt32(),B=N.readLongString(),F=[];for(let V=0;V<G;++V)F.push(N.readVSBuffer());return new u.$Tw(i(B,F,L))}static serializeReplyErr(N,L){const G=L?f(A.$5(L),null):void 0;if(typeof G!="string")return this.h(N);const B=S.$Oe.fromString(G);let F=0;F+=v.sizeLongString(B);const V=v.alloc(g.ReplyErrError,N,F);return V.writeLongString(B),V.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return v.alloc(g.ReplyErrEmpty,N,0).buffer}}var g;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var w;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(w||(w={}))}),define(Ce[267],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=void 0;const b=function(O){const A=T=>{globalThis.removeEventListener("message",A);const p=T.data;Object.defineProperties(globalThis,{postMessage:{value(a,R){p.postMessage(a,R)}},onmessage:{get(){return p.onmessage},set(a){p.onmessage=a}}}),p.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class S extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${b})('${A}'))`,a=new Blob([p],{type:"application/javascript"}),R=URL.createObjectURL(a),y=new MessageChannel,u=R,E={type:"_newWorker",id:u,port:y.port2,url:R,options:T};O(E,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(f){y.port1.onmessage=f}},onmessageerror:{get(){return y.port1.onmessageerror},set(f){y.port1.onmessageerror=f}}}),y.port1.addEventListener("messageerror",f=>{const n=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",f=>{const n=new MessageEvent("message",{data:f.data});this.dispatchEvent(n)}),y.port1.start()}}e.$Gsc=S}),define(Ce[268],Ie([1,0,23,29,16,61,3]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$QK=void 0,e.$RK=R,e.$SK=y,e.$QK=(0,A.$Fi)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),a=7;function R(E){if(E.scheme!==k.Schemas.vscodeNotebookCell)return;const f=E.fragment.indexOf("s");if(f<0)return;const n=parseInt(E.fragment.substring(0,f).replace(p,""),a),s=(0,b.$8e)(E.fragment.substring(f+1)).toString();if(!isNaN(n))return{handle:n,notebook:E.with({scheme:s,fragment:null})}}function y(E,f){const n=f.toString(a),o=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,b.$9e)(b.$Oe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:k.Schemas.vscodeNotebookCell,fragment:o})}class u{constructor(){this.a=new S.$Cc}getNotebook(f){if(f.scheme===k.Schemas.vscodeNotebookCell){const n=R(f);if(n){const s=this.a.get(n.notebook);if(s)return s}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$TK=u,(0,O.$Os)(e.$QK,u,O.InstantiationType.Delayed)}),define(Ce[90],Ie([1,0,23,41,40,73,16,20,21,32,268]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$yL=e.CellStatusbarAlignment=e.$xL=e.NotebookEditorPriority=e.$uL=e.$tL=e.$rL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qL=e.$pL=e.$oL=e.$nL=e.CellKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$sL=l,e.$vL=d,e.$wL=$,e.$zL=v,e.$AL=P,S=qe(S),e.$iL="workbench.editor.notebook",e.$jL="workbench.editor.notebookTextDiffEditor",e.$kL="workbench.editor.interactive",e.$lL="workbench.editor.repl",e.$mL="replNotebook.input.execute";var y;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(y||(e.CellKind=y={})),e.$nL=["application/json","application/javascript","text/html","image/svg+xml",O.$8s.latex,O.$8s.markdown,"image/png","image/jpeg",O.$8s.text],e.$oL=[O.$8s.latex,O.$8s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$8s.text],e.$pL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qL="_notAvailable";var u;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var f;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var n;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var s;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var h;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var i;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(V){V.scheme=A.Schemas.vscodeNotebookCell;function ae(we,re){return(0,R.$SK)(we,re)}V.generate=ae;function $e(we){return(0,R.$RK)(we)}V.parse=$e;function _(we,re){return we.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${we.scheme!==A.Schemas.file?we.scheme:""}`})}V.generateCellOutputUri=_;function ge(we){if(we.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!re)return;const Pe=re[1]&&re[1]!==""?re[1]:void 0,Me=re[2];return{outputId:Pe,notebook:we.with({scheme:Me||A.Schemas.file,fragment:null})}}V.parseCellOutputUri=ge;function se(we,re,Pe){return V.generate(we,re).with({scheme:Pe})}V.generateCellPropertyUri=se;function ce(we,re){if(we.scheme===re)return V.parse(we.with({scheme:V.scheme}))}V.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const t=V=>p.$i?V.replace(/\//g,"\\"):V;class c{constructor(ae=[],$e=e.$nL){this.e=$e,this.d=[...new Set(ae)].map(_=>({pattern:_,matches:S.$zk(t(_))}))}sort(ae){const $e=new Map(k.Iterable.map(ae,ge=>[ge,t(ge)]));let _=[];for(const{matches:ge}of this.d)for(const[se,ce]of $e)if(ge(ce)){_.push(se),$e.delete(se);break}return $e.size&&(_=_.concat([...$e.keys()].sort((ge,se)=>this.e.indexOf(ge)-this.e.indexOf(se)))),_}prioritize(ae,$e){const _=this.f(ae);if(_===-1){this.d.unshift({pattern:ae,matches:S.$zk(t(ae))});return}const ge=new Set($e.map(ce=>this.f(ce,_)));ge.delete(-1);const se=Array.from(ge).sort();this.d.splice(_+1,0,...se.map(ce=>this.d[ce]));for(let ce=se.length-1;ce>=0;ce--)this.d.splice(se[ce],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,$e=this.d.length){const _=t(ae);for(let ge=0;ge<$e;ge++)if(this.d[ge].matches(_))return ge;return-1}}e.$rL=c;function l(V,ae,$e,_=(ge,se)=>ge===se){const ge=[];function se(re,Pe,Me){if(Pe===0&&Me.length===0)return;const Y=ge[ge.length-1];Y&&Y.start+Y.deleteCount===re?(Y.deleteCount+=Pe,Y.toInsert.push(...Me)):ge.push({start:re,deleteCount:Pe,toInsert:Me})}let ce=0,we=0;for(;;){if(ce===V.length){se(ce,0,ae.slice(we));break}if(we===ae.length){se(ce,V.length-ce,[]);break}const re=V[ce],Pe=ae[we];if(_(re,Pe)){ce+=1,we+=1;continue}$e(Pe)?(se(ce,1,[]),ce+=1):(se(ce,0,[Pe]),we+=1)}return ge}e.$tL=new a.$Wj("notebookEditorCursorAtBoundary","none"),e.$uL=new a.$Wj("notebookEditorCursorAtLineBoundary","none");var m;(function(V){V.default="default",V.option="option"})(m||(e.NotebookEditorPriority=m={}));function d(V){const ae=V;return!!((typeof ae.include=="string"||S.$Ak(ae.include))&&(typeof ae.exclude=="string"||S.$Ak(ae.exclude)))}function $(V,ae,$e){if(Array.isArray(V.viewType)&&V.viewType.indexOf(ae)>=0||V.viewType===ae)return!0;if(V.filenamePattern){const _=d(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,ge=d(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(S.$yk(_,(0,T.$pc)($e.fsPath).toLowerCase()))return!(ge&&S.$yk(ge,(0,T.$pc)($e.fsPath).toLowerCase()))}return!1}e.$xL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class D{static{this.d="notebook/"}static create(ae){return`${D.d}${ae}`}static parse(ae){if(ae.startsWith(D.d))return ae.substring(D.d.length)}}e.$yL=D;function v(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const C=new TextDecoder;function P(V){const ae=[];let $e=!1;for(const ce of V)(ae.length===0||$e)&&(ae.push(ce),$e=!0);let _=M(ae);const ge=b.$Oe.concat(ae.map(ce=>b.$Oe.wrap(ce))),se=F(ge);return _=_||se.byteLength!==ge.byteLength,{data:se,didCompression:_}}e.$BL="\x1B[A";const g=e.$BL.split("").map(V=>V.charCodeAt(0)),w=10;function M(V){let ae=!1;return V.forEach(($e,_)=>{if(_===0||$e.length<e.$BL.length)return;const ge=V[_-1],se=$e.subarray(0,e.$BL.length);if(se[0]===g[0]&&se[1]===g[1]&&se[2]===g[2]){const ce=ge.lastIndexOf(w);if(ce===-1)return;ae=!0,V[_-1]=ge.subarray(0,ce),V[_]=$e.subarray(e.$BL.length)}}),ae}function N(V){let ae=V;do V=ae,ae=V.replace(/[^\n]\x08/gm,"");while(ae.length<V.length);return V}function L(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const ae=V.match(/^(.*)\r+/m)[1];let $e=V.match(/\r+(.*)$/m)[1];$e=$e+ae.slice($e.length,ae.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,$e)}return V}const G=8,B=13;function F(V){return!V.buffer.includes(G)&&!V.buffer.includes(B)?V:b.$Oe.fromString(L(N(C.decode(V.buffer))))}}),define(Ce[7],Ie([1,0,18,14,60,29,73,13,15,2,37,19,30,110,90]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f){"use strict";var n,s,o,h,i,r,t,c,l,m,d,$,I,D,v,C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fP=e.$eP=e.$dP=e.$cP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestRunProfileKind=e.TestResultState=e.$9O=e.$8O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7O=e.NotebookVariablesRequestKind=e.$6O=e.$5O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.ColorThemeKind=e.$XO=e.$WO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VO=e.$UO=e.DebugConsoleMode=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OO=e.$NO=e.FileChangeType=e.$MO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LO=e.$KO=e.$JO=e.$IO=e.InlineCompletionTriggerKind=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$vO=e.ConfigurationTarget=e.$uO=e.$tO=e.$sO=e.$rO=e.DocumentPasteTriggerKind=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kO=e.ViewBadge=e.ProgressLocation=e.$jO=e.$iO=e.TaskScope=e.ShellQuoting=e.$hO=e.$gO=e.$fO=e.TaskPanelKind=e.TaskRevealKind=e.$eO=e.TerminalLocation=e.$dO=e.$cO=e.$bO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aO=e.$_N=e.$$N=e.$0N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8N=e.$7N=e.$6N=e.$5N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4N=e.$3N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.LanguageStatusSeverity=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CodeActionTriggerKind=e.$QN=e.$PN=e.SymbolTag=e.SymbolKind=e.$ON=e.$NN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.DiagnosticSeverity=e.DiagnosticTag=e.$HN=e.$GN=e.FileEditType=e.$FN=e.$EN=e.$DN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=xe,e.$wO=Si,e.$bP=Ai;function g(W){return Object.assign(W,{apply:function(...ne){if(ne.length===0)return Reflect.construct(W,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(W,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(W,[]);{const[Se,...He]=ne;return Reflect.construct(W,He,Se.constructor)}}})}var w;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var M;(function(W){W[W.TerminalCommand=0]="TerminalCommand",W[W.Opener=1]="Opener",W[W.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=n=class{static from(...z){let ne=z;return new n(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wN=N,e.$wN=N=n=Qe([g],N);let L=s=class{static Min(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const He=z[Se];He.isBefore(ne)&&(ne=He)}return ne}static Max(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const He=z[Se];He.isAfter(ne)&&(ne=He)}return ne}static isPosition(z){if(!z)return!1;if(z instanceof s)return!0;const{line:ne,character:Se}=z;return typeof ne=="number"&&typeof Se=="number"}static of(z){if(z instanceof s)return z;if(this.isPosition(z))return new s(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ne){if(z<0)throw(0,S.$9)("line must be non-negative");if(ne<0)throw(0,S.$9)("character must be non-negative");this.c=z,this.e=ne}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ne=0){if(z===null||ne===null)throw(0,S.$9)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,ne=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&ne===0?this:new s(this.line+Se,this.character+ne)}with(z,ne=this.character){if(z===null||ne===null)throw(0,S.$9)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,ne=typeof z.character=="number"?z.character:this.character),Se===this.line&&ne===this.character?this:new s(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$xN=L,e.$xN=L=s=Qe([g],L);let G=o=class{static isRange(z){return z instanceof o?!0:z?L.isPosition(z.start)&&L.isPosition(z.end):!1}static of(z){if(z instanceof o)return z;if(this.isRange(z))return new o(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ne,Se,He){let it,dt;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new L(z,ne),dt=new L(Se,He)):L.isPosition(z)&&L.isPosition(ne)&&(it=L.of(z),dt=L.of(ne)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(z){return o.isRange(z)?this.contains(z.start)&&this.contains(z.end):L.isPosition(z)?!(L.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ne=L.Max(z.start,this.c),Se=L.Min(z.end,this.e);if(!ne.isAfter(Se))return new o(ne,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ne=L.Min(z.start,this.c),Se=L.Max(z.end,this.end);return new o(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ne=this.end){if(z===null||ne===null)throw(0,S.$9)();let Se;return z?L.isPosition(z)?Se=z:(Se=z.start||this.start,ne=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new o(Se,ne)}toJSON(){return[this.start,this.end]}};e.$yN=G,e.$yN=G=o=Qe([g],G);let B=h=class extends G{static isSelection(z){return z instanceof h?!0:z?G.isRange(z)&&L.isPosition(z.anchor)&&L.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ne,Se,He){let it,dt;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new L(z,ne),dt=new L(Se,He)):L.isPosition(z)&&L.isPosition(ne)&&(it=L.of(z),dt=L.of(ne)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zN=B,e.$zN=B=h=Qe([g],B);const F=W=>{if(typeof W!="string"||W.length===0||!/^[0-9A-Za-z_\-]+$/.test(W))throw(0,S.$9)("connectionToken")};class V{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne,Se){if(typeof z!="string"||z.length===0)throw(0,S.$9)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,S.$9)("port");typeof Se<"u"&&F(Se),this.host=z,this.port=Math.round(ne),this.connectionToken=Se}}e.$AN=V;class ae{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne){this.makeConnection=z,this.connectionToken=ne,typeof ne<"u"&&F(ne)}}e.$BN=ae;class $e extends Error{static NotAvailable(z,ne){return new $e(z,E.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(z){return new $e(z,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ne=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,$e.prototype)}}e.$CN=$e;var _;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var ge;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(ge||(e.EnvironmentVariableMutatorType=ge={}));let se=i=class{static isTextEdit(z){return z instanceof i?!0:z?G.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ne){return new i(z,ne)}static insert(z,ne){return i.replace(new G(z,z),ne)}static delete(z){return i.replace(z,"")}static setEndOfLine(z){const ne=new i(new G(new L(0,0),new L(0,0)),"");return ne.newEol=z,ne}get range(){return this.c}set range(z){if(z&&!G.isRange(z))throw(0,S.$9)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,S.$9)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,S.$9)("newEol");this.f=z}constructor(z,ne){this.c=z,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DN=se,e.$DN=se=i=Qe([g],se);let ce=r=class{static isNotebookCellEdit(z){return z instanceof r?!0:z?wt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ne){return new r(z,ne)}static insertCells(z,ne){return new r(new wt(z,z),ne)}static deleteCells(z){return new r(z,[])}static updateCellMetadata(z,ne){const Se=new r(new wt(z,z),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(z){const ne=new r(new wt(0,0),[]);return ne.newNotebookMetadata=z,ne}constructor(z,ne){this.range=z,this.newCells=ne}};e.$EN=ce,e.$EN=ce=r=Qe([g],ce);class we{static isSnippetTextEdit(z){return z instanceof we?!0:z?G.isRange(z.range)&&Me.isSnippetString(z.snippet):!1}static replace(z,ne){return new we(z,ne)}static insert(z,ne){return we.replace(new G(z,z),ne)}constructor(z,ne){this.range=z,this.snippet=ne}}e.$FN=we;var re;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ne,Se,He){this.c.push({_type:re.File,from:z,to:ne,options:Se,metadata:He})}createFile(z,ne,Se){this.c.push({_type:re.File,from:void 0,to:z,options:ne,metadata:Se})}deleteFile(z,ne,Se){this.c.push({_type:re.File,from:z,to:void 0,options:ne,metadata:Se})}e(z,ne,Se){this.c.push({_type:re.Cell,metadata:Se,uri:z,edit:{editType:f.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}f(z,ne,Se,He){const it=ne.start,dt=ne.end;(it!==dt||Se.length>0)&&this.c.push({_type:re.CellReplace,uri:z,index:it,count:dt-it,cells:Se,metadata:He})}g(z,ne,Se,He){this.c.push({_type:re.Cell,metadata:He,uri:z,edit:{editType:f.CellEditType.Metadata,index:ne,metadata:Se}})}replace(z,ne,Se,He){this.c.push({_type:re.Text,uri:z,edit:new se(ne,Se),metadata:He})}insert(z,ne,Se,He){this.replace(z,new G(ne,ne),Se,He)}delete(z,ne,Se){this.replace(z,ne,"",Se)}has(z){return this.c.some(ne=>ne._type===re.Text&&ne.uri.toString()===z.toString())}set(z,ne){if(ne)for(const Se of ne){if(!Se)continue;let He,it;Array.isArray(Se)?(He=Se[0],it=Se[1]):He=Se,ce.isNotebookCellEdit(He)?He.newCellMetadata?this.g(z,He.range.start,He.newCellMetadata,it):He.newNotebookMetadata?this.e(z,He.newNotebookMetadata,it):this.f(z,He.range,He.newCells,it):we.isSnippetTextEdit(He)?this.c.push({_type:re.Snippet,uri:z,range:He.range,edit:He.snippet,metadata:it}):this.c.push({_type:re.Text,uri:z,edit:He,metadata:it})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:He.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,b.$Kb)(this.c)}}get(z){const ne=[];for(const Se of this.c)Se._type===re.Text&&Se.uri.toString()===z.toString()&&ne.push(Se.edit);return ne}entries(){const z=new O.$Cc;for(const ne of this.c)if(ne._type===re.Text){let Se=z.get(ne.uri);Se||(Se=[ne.uri,[]],z.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GN=Pe,e.$GN=Pe=Qe([g],Pe);let Me=t=class{static isSnippetString(z){return z instanceof t?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=t.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ne=this.e++){if(typeof z=="function"){const Se=new t;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=t.c(z);return this.value+="${",this.value+=ne,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ne=this.e++){const Se=z.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,ne){if(typeof ne=="function"){const Se=new t;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$HN=Me,e.$HN=Me=t=Qe([g],Me);var Y;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var q;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(q||(e.DiagnosticSeverity=q={}));let ee=c=class{static isLocation(z){return z instanceof c?!0:z?G.isRange(z.range)&&a.URI.isUri(z.uri):!1}constructor(z,ne){if(this.uri=z,ne)if(G.isRange(ne))this.range=G.of(ne);else if(L.isPosition(ne))this.range=new G(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IN=ee,e.$IN=ee=c=Qe([g],ee);let ve=class{static is(z){return z?typeof z.message=="string"&&z.location&&G.isRange(z.location.range)&&a.URI.isUri(z.location.uri):!1}constructor(z,ne){this.location=z,this.message=ne}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.location.range.isEqual(ne.location.range)&&z.location.uri.toString()===ne.location.uri.toString()}};e.$JN=ve,e.$JN=ve=Qe([g],ve);let ue=class{constructor(z,ne,Se=q.Error){if(!G.isRange(z))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=z,this.message=ne,this.severity=Se}toJSON(){return{severity:q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.severity===ne.severity&&z.code===ne.code&&z.severity===ne.severity&&z.source===ne.source&&z.range.isEqual(ne.range)&&(0,b.$wb)(z.tags,ne.tags)&&(0,b.$wb)(z.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$KN=ue,e.$KN=ue=Qe([g],ue);let be=class{constructor(z,ne){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ne}};e.$LN=be,e.$LN=be=Qe([g],be);let de=class extends be{constructor(z,ne,Se,He){super(z,ne),this.canIncreaseHover=Se,this.canDecreaseHover=He}};e.$MN=de,e.$MN=de=Qe([g],de);var X;(function(W){W[W.Increase=0]="Increase",W[W.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var Z;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(Z||(e.DocumentHighlightKind=Z={}));let me=class{constructor(z,ne=Z.Text){this.range=z,this.kind=ne}toJSON(){return{range:this.range,kind:Z[this.kind]}}};e.$NN=me,e.$NN=me=Qe([g],me);let pe=class{constructor(z,ne){this.uri=z,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$ON=pe,e.$ON=pe=Qe([g],pe);var Oe;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(Oe||(e.SymbolKind=Oe={}));var ze;(function(W){W[W.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let ke=l=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ne,Se,He,it){this.name=z,this.kind=ne,this.containerName=it,typeof Se=="string"&&(this.containerName=Se),He instanceof ee?this.location=He:Se instanceof G&&(this.location=new ee(He,Se)),l.validate(this)}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};e.$PN=ke,e.$PN=ke=l=Qe([g],ke);let Ae=m=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(m.validate)}constructor(z,ne,Se,He,it){this.name=z,this.detail=ne,this.kind=Se,this.range=He,this.selectionRange=it,this.children=[],m.validate(this)}};e.$QN=Ae,e.$QN=Ae=m=Qe([g],Ae);var Ne;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Ne||(e.CodeActionTriggerKind=Ne={}));let j=class{constructor(z,ne){this.title=z,this.kind=ne}};e.$RN=j,e.$RN=j=Qe([g],j);let U=class{static{d=this}static{this.c="."}constructor(z){this.value=z}append(z){return new d(this.value?this.value+d.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+d.c)}};e.$SN=U,e.$SN=U=d=Qe([g],U),U.Empty=new U(""),U.QuickFix=U.Empty.append("quickfix"),U.Refactor=U.Empty.append("refactor"),U.RefactorExtract=U.Refactor.append("extract"),U.RefactorInline=U.Refactor.append("inline"),U.RefactorMove=U.Refactor.append("move"),U.RefactorRewrite=U.Refactor.append("rewrite"),U.Source=U.Empty.append("source"),U.SourceOrganizeImports=U.Source.append("organizeImports"),U.SourceFixAll=U.Source.append("fixAll"),U.Notebook=U.Empty.append("notebook");let K=class{constructor(z,ne){if(this.range=z,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TN=K,e.$TN=K=Qe([g],K);class H{constructor(z,ne,Se,He,it,dt){this.kind=z,this.name=ne,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$UN=H;class ie{constructor(z,ne){this.fromRanges=ne,this.from=z}}e.$VN=ie;class fe{constructor(z,ne){this.fromRanges=ne,this.to=z}}e.$WN=fe;var Re;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let Ue=class{constructor(z,ne){this.range=z,this.command=ne}get isResolved(){return!!this.command}};e.$XN=Ue,e.$XN=Ue=Qe([g],Ue);let Ke=$=class{#e;static isMarkdownString(z){return z instanceof $?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ne=!1){this.#e=new k.$3k(z,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ne){return this.#e.appendCodeblock(ne??"",z),this}};e.$YN=Ke,e.$YN=Ke=$=Qe([g],Ke);let _e=class{constructor(z,ne){this.label=z,this.documentation=ne}};e.$ZN=_e,e.$ZN=_e=Qe([g],_e);let tt=class{constructor(z,ne){this.label=z,this.documentation=ne,this.parameters=[]}};e.$1N=tt,e.$1N=tt=Qe([g],tt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2N=nt,e.$2N=nt=Qe([g],nt);var et;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let ft=class{constructor(z){this.value=z}};e.$3N=ft,e.$3N=ft=Qe([g],ft);let ct=class{constructor(z,ne,Se){this.position=z,this.label=ne,this.kind=Se}};e.$4N=ct,e.$4N=ct=Qe([g],ct);var st;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ut;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(ut||(e.CompletionItemKind=ut={}));var gt;(function(W){W[W.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let pt=class{constructor(z,ne){this.label=z,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&ut[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5N=pt,e.$5N=pt=Qe([g],pt);let Be=class{constructor(z=[],ne=!1){this.items=z,this.isIncomplete=ne}};e.$6N=Be,e.$6N=Be=Qe([g],Be);let je=class{constructor(z,ne,Se){this.insertText=z,this.range=ne,this.command=Se}};e.$7N=je,e.$7N=je=Qe([g],je);let Q=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$8N=Q,e.$8N=Q=Qe([g],Q);var x;(function(W){W[W.Unknown=0]="Unknown",W[W.Word=1]="Word",W[W.Line=2]="Line",W[W.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var De;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(De||(e.ViewColumn=De={}));var Je;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Je||(e.StatusBarAlignment=Je={}));function xe(W,z){return`${y.$qn.toKey(W)}.${z}`}var ht;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var $t;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})($t||(e.TextDocumentSaveReason=$t={}));var Ft;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var zt;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var Yt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Yt||(e.TextDocumentChangeReason=Yt={}));var fi;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(fi||(e.DecorationRangeBehavior=fi={})),function(W){function z(ne){switch(ne){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=z}(zt||(e.TextEditorSelectionChangeKind=zt={}));var Ze;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(W){function z(ne){switch(ne){case W.Other:return"other";case W.Comment:return"comment";case W.String:return"string";case W.RegEx:return"regex"}return"other"}W.toString=z}(Ze||(e.SyntaxTokenType=Ze={}));let Pt=class{constructor(z,ne){if(ne&&!a.URI.isUri(ne))throw(0,S.$9)("target");if(!G.isRange(z)||z.isEmpty)throw(0,S.$9)("range");this.range=z,this.target=ne}};e.$0N=Pt,e.$0N=Pt=Qe([g],Pt);let Kt=class{constructor(z,ne,Se,He){this.red=z,this.green=ne,this.blue=Se,this.alpha=He}};e.$$N=Kt,e.$$N=Kt=Qe([g],Kt);let Qt=class{constructor(z,ne){if(ne&&!(ne instanceof Kt))throw(0,S.$9)("color");if(!G.isRange(z)||z.isEmpty)throw(0,S.$9)("range");this.range=z,this.color=ne}};e.$_N=Qt,e.$_N=Qt=Qe([g],Qt);let mt=class{constructor(z){if(!z||typeof z!="string")throw(0,S.$9)("label");this.label=z}};e.$aO=mt,e.$aO=mt=Qe([g],mt);var vt;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(vt||(e.ColorFormat=vt={}));var ii;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Zt;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(Zt||(e.TerminalExitReason=Zt={}));var qt;(function(W){W[W.Low=0]="Low",W[W.Medium=1]="Medium",W[W.High=2]="High"})(qt||(e.TerminalShellExecutionCommandLineConfidence=qt={}));class yt{constructor(z,ne,Se){if(this.startIndex=z,this.length=ne,this.tooltip=Se,typeof z!="number"||z<0)throw(0,S.$9)("startIndex");if(typeof ne!="number"||ne<1)throw(0,S.$9)("length");if(Se!==void 0&&typeof Se!="string")throw(0,S.$9)("tooltip")}}e.$bO=yt;class Nt{constructor(z){this.uri=z}}e.$cO=Nt;class li{constructor(z){this.terminalCommand=z}}e.$dO=li;var Vt;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class Xe{constructor(z){if(this.options=z,typeof z!="object")throw(0,S.$9)("options")}}e.$eO=Xe;var xt;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(xt||(e.TaskRevealKind=xt={}));var ni;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let hi=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(z){switch(z){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(z,ne){if(this.label=ne,typeof z!="string"||typeof ne!="string")throw(0,S.$9)("name");this.c=z}get id(){return this.c}};e.$fO=hi,e.$fO=hi=I=Qe([g],hi);function kt(W){let z="";for(let ne=0;ne<W.length;ne++)z+=W[ne].replace(/,/g,",,")+",";return z}let Lt=class{constructor(z,ne,Se){if(typeof z!="string")throw(0,S.$9)("process");this.e=[],this.c=z,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,S.$9)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)z.push(ne);return kt(z)}};e.$gO=Lt,e.$gO=Lt=Qe([g],Lt);let At=class{constructor(z,ne,Se){if(this.f=[],Array.isArray(ne)){if(!z)throw(0,S.$9)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,S.$9)("command");this.e=z,this.f=ne,this.g=Se}else{if(typeof z!="string")throw(0,S.$9)("commandLine");this.c=z,this.g=ne}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,S.$9)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,S.$9)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)z.push(typeof ne=="string"?ne:ne.value);return kt(z)}};e.$hO=At,e.$hO=At=Qe([g],At);var Ut;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(Ut||(e.ShellQuoting=Ut={}));var ri;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class _t{constructor(z){this.c=z}computeId(){return"customExecution"+(0,R.$2g)()}set callback(z){this.c=z}get callback(){return this.c}}e.$iO=_t;let si=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ne,Se,He,it,dt){this.k=!1,this.l=this.definition=z;let Et;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=He,Et=it,this.k=!0):ne===ri.Global||ne===ri.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=He,this.execution=it,Et=dt):(this.target=ne,this.o=this.name=Se,this.w=this.source=He,this.execution=it,Et=dt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof At?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof _t?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,R.$2g)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,S.$9)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,S.$9)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ne=this.l.type;(D.g===ne||D.e===ne||D.f===ne||D.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,S.$9)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$jO=si,e.$jO=si=D=Qe([g],si);var jt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(jt||(e.ProgressLocation=jt={}));var Ht;(function(W){function z(ne){const Se=ne;return(0,p.$jg)(Se.value)?Se.tooltip&&!(0,p.$fg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}W.isViewBadge=z})(Ht||(e.ViewBadge=Ht={}));let oi=v=class{static isTreeItem(z,ne){const Se=z;if(Se.checkboxState!==void 0){const He=(0,p.$jg)(Se.checkboxState)?Se.checkboxState:(0,p.$hg)(Se.checkboxState)&&(0,p.$jg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,it=!(0,p.$jg)(Se.checkboxState)&&(0,p.$hg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==St.Checked&&He!==St.Unchecked||it!==void 0&&!(0,p.$fg)(it))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof v)return!0;if(Se.label!==void 0&&!(0,p.$fg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$fg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$fg)(Se.iconPath)&&!a.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$fg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,p.$fg)(He.light)&&!a.URI.isUri(He.light)&&!(0,p.$fg)(He.dark)&&!a.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$fg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!a.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$fg)(Se.tooltip)&&!(Se.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Rt.None&&Se.collapsibleState>Rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$fg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,ne=Rt.None){this.collapsibleState=ne,a.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$kO=oi,e.$kO=oi=v=Qe([g],oi);var Rt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Rt||(e.TreeItemCollapsibleState=Rt={}));var St;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$lO=bt,e.$lO=bt=Qe([g],bt);class ei extends bt{}e.$mO=ei;class Ct extends ei{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$nO=Ct;class di{constructor(z,ne,Se,He){this.name=z,this.uri=ne,this._itemId=Se,this.c=He}data(){return this.c()}}e.$oO=di;let Gt=class{#e=new Map;constructor(z){for(const[ne,Se]of z??[]){const He=this.#e.get(this.#t(ne));He?He.push(Se):this.#e.set(this.#t(ne),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ne){this.#e.set(this.#t(z),[ne])}forEach(z,ne){for(const[Se,He]of this.#e)for(const it of He)z.call(ne,it,Se,this)}*[Symbol.iterator](){for(const[z,ne]of this.#e)for(const Se of ne)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$pO=Gt,e.$pO=Gt=Qe([g],Gt);let bi=class{constructor(z,ne,Se){this.insertText=z,this.title=ne,this.kind=Se}};e.$qO=bi,e.$qO=bi=Qe([g],bi);var vi;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class gi{static{this.c="."}constructor(z){this.value=z}append(...z){return new gi((this.value?[this.value,...z]:z).join(gi.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+gi.c)}}e.$rO=gi,gi.Empty=new gi("");class Bt{constructor(z,ne,Se){this.title=ne,this.insertText=z,this.kind=Se}}e.$sO=Bt;let ai=class{constructor(z,ne){this.id=z,this.color=ne}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$tO=ai,e.$tO=ai=Qe([g],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ii=class{constructor(z){this.id=z}};e.$uO=Ii,e.$uO=Ii=Qe([g],Ii);var Tt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Tt||(e.ConfigurationTarget=Tt={}));let Di=class{get base(){return this.c}set base(z){this.c=z,this.e=a.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ne){if(typeof z!="string"&&(!z||!a.URI.isUri(z)&&!a.URI.isUri(z.uri)))throw(0,S.$9)("base");if(typeof ne!="string")throw(0,S.$9)("pattern");typeof z=="string"?this.baseUri=a.URI.file(z):a.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vO=Di,e.$vO=Di=Qe([g],Di);const Pi=new WeakMap;function Si(W,z){Pi.set(W,z)}let pi=class{constructor(z,ne,Se,He,it){this.enabled=typeof z=="boolean"?z:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Pi.get(this)??(0,R.$2g)()),this.c}};e.$xO=pi,e.$xO=pi=Qe([g],pi);let Ri=class extends pi{constructor(z,ne,Se,He,it,dt){if(super(ne,Se,He,it,dt),z===null)throw(0,S.$9)("location");this.location=z}};e.$yO=Ri,e.$yO=Ri=Qe([g],Ri);let Wt=class extends pi{constructor(z,ne,Se,He,it,dt){super(ne,Se,He,it,dt),this.functionName=z}};e.$zO=Wt,e.$zO=Wt=Qe([g],Wt);let ye=class extends pi{constructor(z,ne,Se,He,it,dt,Et,Xt){if(super(He,it,dt,Et,Xt),!ne)throw(0,S.$9)("dataId");this.label=z,this.dataId=ne,this.canPersist=Se}};e.$AO=ye,e.$AO=ye=Qe([g],ye);let Te=class{constructor(z,ne,Se){this.command=z,this.args=ne||[],this.options=Se}};e.$BO=Te,e.$BO=Te=Qe([g],Te);let le=class{constructor(z,ne){this.port=z,this.host=ne}};e.$CO=le,e.$CO=le=Qe([g],le);let J=class{constructor(z){this.path=z}};e.$DO=J,e.$DO=J=Qe([g],J);let Ee=class{constructor(z){this.implementation=z}};e.$EO=Ee,e.$EO=Ee=Qe([g],Ee);class We{constructor(z,ne,Se){this.session=z,this.threadId=ne,this.frameId=Se}}e.$FO=We;class Ye{constructor(z,ne){this.session=z,this.threadId=ne}}e.$GO=Ye;let Ge=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$HO=Ge,e.$HO=Ge=Qe([g],Ge);var lt;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let It=class{constructor(z,ne){this.range=z,this.text=ne}};e.$IO=It,e.$IO=It=Qe([g],It);let Jt=class{constructor(z,ne,Se=!0){this.range=z,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$JO=Jt,e.$JO=Jt=Qe([g],Jt);let ci=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$KO=ci,e.$KO=ci=Qe([g],ci);let Mt=class{constructor(z,ne){this.frameId=z,this.stoppedLocation=ne}};e.$LO=Mt,e.$LO=Mt=Qe([g],Mt);var ui;(function(W){W[W.AIGenerated=1]="AIGenerated"})(ui||(e.NewSymbolNameTag=ui={}));var qi;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(qi||(e.NewSymbolNameTriggerKind=qi={}));class $n{constructor(z,ne){this.newSymbolName=z,this.tags=ne}}e.$MO=$n;var Li;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Oi=C=class extends Error{static FileExists(z){return new C(z,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(z){return new C(z,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(z){return new C(z,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(z){return new C(z,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(z){return new C(z,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(z){return new C(z,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(z,ne=u.FileSystemProviderErrorCode.Unknown,Se){super(a.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,u.$ol)(this,ne),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$NO=Oi,e.$NO=Oi=C=Qe([g],Oi);let Vi=class{constructor(z,ne,Se){this.start=z,this.end=ne,this.kind=Se}};e.$OO=Vi,e.$OO=Vi=Qe([g],Vi);var xi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ki;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var _i;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Mi;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Mi||(e.CommentThreadState=Mi={}));var tn;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Gi{constructor(z,ne=[]){this.tokenTypes=z,this.tokenModifiers=ne}}e.$PO=Gi;function nn(W){return typeof W>"u"||(0,p.$gg)(W)}class Ki{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ne=0,Se=z.tokenTypes.length;ne<Se;ne++)this.k.set(z.tokenTypes[ne],ne);for(let ne=0,Se=z.tokenModifiers.length;ne<Se;ne++)this.l.set(z.tokenModifiers[ne],ne)}}push(z,ne,Se,He,it){if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(z,ne,Se,He,it);if(G.isRange(z)&&typeof ne=="string"&&nn(Se))return this.o(z,ne,Se);throw(0,S.$9)()}o(z,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const He=z.start.line,it=z.start.character,dt=z.end.character-z.start.character,Et=this.k.get(ne);let Xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get($i);Xt|=1<<wi>>>0}this.q(He,it,dt,Et,Xt)}q(z,ne,Se,He,it){if(this.f&&(z<this.c||z===this.c&&ne<this.e)){this.f=!1;const Xt=this.g.length/5|0;let $i=0,wi=0;for(let Ei=0;Ei<Xt;Ei++){let Ci=this.g[5*Ei],Yi=this.g[5*Ei+1];Ci===0?(Ci=$i,Yi+=wi):Ci+=$i,this.g[5*Ei]=Ci,this.g[5*Ei+1]=Yi,$i=Ci,wi=Yi}}let dt=z,Et=ne;this.f&&this.j>0&&(dt-=this.c,dt===0&&(Et-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=Et,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=it,this.c=z,this.e=ne}static r(z){const ne=[],Se=z.length/5|0;for(let Et=0;Et<Se;Et++)ne[Et]=Et;ne.sort((Et,Xt)=>{const $i=z[5*Et],wi=z[5*Xt];if($i===wi){const Ei=z[5*Et+1],Ci=z[5*Xt+1];return Ei-Ci}return $i-wi});const He=new Uint32Array(z.length);let it=0,dt=0;for(let Et=0;Et<Se;Et++){const Xt=5*ne[Et],$i=z[Xt+0],wi=z[Xt+1],Ei=z[Xt+2],Ci=z[Xt+3],Yi=z[Xt+4],jn=$i-it,kr=jn===0?wi-dt:wi,Zi=5*Et;He[Zi+0]=jn,He[Zi+1]=kr,He[Zi+2]=Ei,He[Zi+3]=Ci,He[Zi+4]=Yi,it=$i,dt=wi}return He}build(z){return this.f?new zi(new Uint32Array(this.g),z):new zi(Ki.r(this.g),z)}}e.$QO=Ki;class zi{constructor(z,ne){this.resultId=ne,this.data=z}}e.$RO=zi;class wn{constructor(z,ne,Se){this.start=z,this.deleteCount=ne,this.data=Se}}e.$SO=wn;class Ni{constructor(z,ne){this.resultId=ne,this.edits=z}}e.$TO=Ni;var rn;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class bn{constructor(z){this.name=z}}e.$UO=bn;let Qi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$VO=Qi,e.$VO=Qi=Qe([g],Qi);var Ui;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Ui||(e.QuickPickItemKind=Ui={}));var Hi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Hi||(e.InputBoxValidationSeverity=Hi={}));var Le;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Le||(e.ExtensionKind=Le={}));class yi{static validate(z){if(typeof z.badge=="string"){let ne=(0,T.$Qf)(z.badge,0);if(ne<z.badge.length&&(ne+=(0,T.$Qf)(z.badge,ne)),z.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!ai.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ne,Se){this.badge=z,this.tooltip=ne,this.color=Se}}e.$WO=yi;let ji=class{constructor(z){this.kind=z}};e.$XO=ji,e.$XO=ji=Qe([g],ji);var ot;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(ot||(e.ColorThemeKind=ot={}));class wt{static isNotebookRange(z){return z instanceof wt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ne){if(z<0)throw(0,S.$9)("start must be positive");if(ne<0)throw(0,S.$9)("end must be positive");z<=ne?(this.c=z,this.e=ne):(this.c=ne,this.e=z)}with(z){let ne=this.c,Se=this.e;return z.start!==void 0&&(ne=z.start),z.end!==void 0&&(Se=z.end),ne===this.c&&Se===this.e?this:new wt(ne,Se)}}e.$YO=wt;class Bi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ne=>Bi.isNotebookCellData(ne))}static isNotebookCellData(z){return!0}constructor(z,ne,Se,He,it,dt,Et){this.kind=z,this.value=ne,this.languageId=Se,this.mime=He,this.outputs=it??[],this.metadata=dt,this.executionSummary=Et,Bi.validate(this)}}e.$ZO=Bi;class vn{constructor(z){this.cells=z}}e.$1O=vn;class mi{static isNotebookCellOutputItem(z){return z instanceof mi?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ne={name:z.name,message:z.message,stack:z.stack};return mi.json(ne,"application/vnd.code.notebook.error")}static stdout(z){return mi.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return mi.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ne="application/octet-stream"){return new mi(z,ne)}static#e=new TextEncoder;static text(z,ne=A.$8s.text){const Se=mi.#e.encode(String(z));return new mi(Se,ne)}static json(z,ne="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return mi.text(Se,ne)}constructor(z,ne){this.data=z,this.mime=ne;const Se=(0,A.$_s)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$2O=mi;class Wi{static isNotebookCellOutput(z){return z instanceof Wi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ne=!1){const Se=new Set,He=new Set;for(let it=0;it<z.length;it++){const dt=z[it],Et=(0,A.$_s)(dt.mime);if(!Se.has(Et)||(0,f.$zL)(Et)){Se.add(Et);continue}He.add(it),ne&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return He.size===0?z:z.filter((it,dt)=>!He.has(dt))}constructor(z,ne,Se){this.items=Wi.ensureUniqueMimeTypes(z,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,R.$2g)(),this.metadata=ne??Se)}}e.$3O=Wi;var Fi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var sn;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(z,ne){this.text=z,this.alignment=ne}}e.$4O=cn;var un;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(un||(e.NotebookControllerAffinity=un={}));var ln;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class yn{constructor(z,ne=[]){this.uri=z,this.provides=(0,b.$4b)(ne)}}e.$5O=yn;class En{constructor(z){this.label=z}}e.$6O=En;var hn;(function(W){W[W.Named=1]="Named",W[W.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Ji=class{constructor(z,ne){this.label=z,this.timestamp=ne}};e.$7O=Ji,e.$7O=Ji=Qe([g],Ji);var dn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Dn{constructor(z,ne){this.ranges=z,this.wordPattern=ne}}e.$8O=Dn;class Sn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$9O=Sn;var te;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(te||(e.TestResultState=te={}));var he;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(he||(e.TestRunProfileKind=he={}));let Fe=class{constructor(z=void 0,ne=void 0,Se=void 0,He=!1,it=!0){this.include=z,this.exclude=ne,this.profile=Se,this.continuous=He,this.preserveFocus=it}};e.$0O=Fe,e.$0O=Fe=Qe([g],Fe);let at=P=class{static diff(z,ne,Se){const He=new P(z);return He.expectedOutput=ne,He.actualOutput=Se,He}constructor(z){this.message=z}};e.$$O=at,e.$$O=at=P=Qe([g],at);let Dt=class{constructor(z){this.id=z}};e.$_O=Dt,e.$_O=Dt=Qe([g],Dt);class Ot{constructor(z,ne){this.covered=z,this.total=ne,Ai(this)}}e.$aP=Ot;function Ai(W){if(W){if(W.covered>W.total)throw new Error(`The total number of covered items (${W.covered}) cannot be greater than the total (${W.total})`);if(W.total<0)throw new Error(`The number of covered items (${W.total}) cannot be negative`)}}class Xi{static fromDetails(z,ne){const Se=new Ot(0,0),He=new Ot(0,0),it=new Ot(0,0);for(const Et of ne)if("branches"in Et){Se.total+=1,Se.covered+=Et.executed?1:0;for(const Xt of Et.branches)He.total+=1,He.covered+=Xt.executed?1:0}else it.total+=1,it.covered+=Et.executed?1:0;const dt=new Xi(z,Se,He.total>0?He:void 0,it.total>0?it:void 0);return dt.detailedCoverage=ne,dt}constructor(z,ne,Se,He,it=[]){this.uri=z,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=it}}e.$cP=Xi;class qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se=[]){this.executed=z,this.location=ne,this.branches=Se}}e.$dP=qn;class Vn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.executed=z,this.location=ne,this.label=Se}}e.$eP=Vn;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.name=z,this.executed=ne,this.location=Se}}e.$fP=Gn;var kn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(z,ne,Se,He,it,dt){this.kind=z,this.name=ne,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$gP=Kn;class Qn{constructor(z){this.uri=z}}e.$hP=Qn;class Hn{constructor(z,ne){this.original=z,this.modified=ne}}e.$iP=Hn;class Jn{constructor(z,ne,Se,He){this.base=z,this.input1=ne,this.input2=Se,this.result=He}}e.$jP=Jn;class Xn{constructor(z,ne){this.uri=z,this.viewType=ne}}e.$kP=Xn;class Yn{constructor(z){this.viewType=z}}e.$lP=Yn;class Zn{constructor(z,ne){this.uri=z,this.notebookType=ne}}e.$mP=Zn;class xn{constructor(z,ne,Se){this.original=z,this.modified=ne,this.notebookType=Se}}e.$nP=xn;class _n{constructor(){}}e.$oP=_n;class er{constructor(z,ne){this.uri=z,this.inputBoxUri=ne}}e.$pP=er;class tr{constructor(){}}e.$qP=tr;class ir{constructor(z){this.textDiffs=z}}e.$rP=ir;var Pn;(function(W){W[W.Down=0]="Down",W[W.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(W){W[W.Action=1]="Action",W[W.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(W){W[W.Short=1]="Short",W[W.Medium=2]="Medium",W[W.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(z,ne,Se){this.id=z,this.label=ne,this.values=Se}}e.$sP=nr;var Tn;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful",W[W.Undone=2]="Undone",W[W.Accepted=3]="Accepted",W[W.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var On;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful"})(On||(e.ChatResultFeedbackKind=On={}));class rr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$tP=rr;class sr{constructor(z,ne){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z,this.vulnerabilities=ne}}e.$uP=sr;class or{constructor(z,ne){this.participant=z,this.command=ne}}e.$vP=or;class ar{constructor(z,ne,Se){this.title=z,this.message=ne,this.data=Se}}e.$wP=ar;class cr{constructor(z,ne){this.value=z,this.baseUri=ne}}e.$xP=cr;class ur{constructor(z,ne){this.value=z,this.title=ne}}e.$yP=ur;class lr{constructor(z){this.value=z}}e.$zP=lr;class hr{constructor(z,ne){this.value=z,this.task=ne}}e.$AP=hr;class dr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$BP=dr;class fr{constructor(z){this.value=z}}e.$CP=fr;class gr{constructor(z,ne){this.value=z,this.iconPath=ne}}e.$DP=gr;class mr{constructor(z,ne){this.uri=z,this.edits=Array.isArray(ne)?ne:[ne]}}e.$EP=mr;class pr{constructor(z,ne,Se,He){this.prompt=z,this.command=ne,this.references=Se,this.participant=He}}e.$FP=pr;class $r{constructor(z,ne,Se,He){this.response=z,this.result=ne,this.participant=Se,this.command=He}}e.$GP=$r;var Nn;(function(W){W[W.Panel=1]="Panel",W[W.Terminal=2]="Terminal",W[W.Notebook=3]="Notebook",W[W.Editor=4]="Editor"})(Nn||(e.ChatLocation=Nn={}));var mn;(function(W){W[W.User=1]="User",W[W.Assistant=2]="Assistant",W[W.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class wr{constructor(z,ne,Se){this.name=z,this.content=ne,this.isError=Se??!1}}e.$HP=wr;class pn{static User(z,ne){const Se=new pn(mn.User,typeof z=="string"?z:"",ne);return Se.content2=z,Se}static Assistant(z,ne){return new pn(mn.Assistant,z,ne)}constructor(z,ne,Se){this.role=z,this.content=ne,this.content2=ne,this.name=Se}}e.$IP=pn;class br{constructor(z,ne){this.name=z,this.parameters=ne}}e.$JP=br;class vr{constructor(z){this.value=z}}e.$KP=vr;class yr{constructor(z){this.content=z}}e.$LP=yr;class Er{constructor(z,ne){this.content=z,this.name=ne}}e.$MP=Er;class Dr{constructor(z,ne){this.content=z,this.name=ne}}e.$NP=Dr;class Ti extends Error{static NotFound(z){return new Ti(z,Ti.NotFound.name)}static NoPermissions(z){return new Ti(z,Ti.NoPermissions.name)}static Blocked(z){return new Ti(z,Ti.Blocked.name)}constructor(z,ne,Se){super(z,{cause:Se}),this.name="LanguageModelError",this.code=ne??""}}e.$OP=Ti;var Fn;(function(W){W[W.SymbolInformation=1]="SymbolInformation",W[W.CommandInformation=2]="CommandInformation",W[W.SearchInformation=3]="SearchInformation",W[W.SettingInformation=4]="SettingInformation"})(Fn||(e.RelatedInformationType=Fn={}));var Ln;(function(W){W[W.Started=1]="Started",W[W.Recognizing=2]="Recognizing",W[W.Recognized=3]="Recognized",W[W.Stopped=4]="Stopped",W[W.Error=5]="Error"})(Ln||(e.SpeechToTextStatus=Ln={}));var Mn;(function(W){W[W.Started=1]="Started",W[W.Stopped=2]="Stopped",W[W.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var zn;(function(W){W[W.Recognized=1]="Recognized",W[W.Stopped=2]="Stopped"})(zn||(e.KeywordRecognitionStatus=zn={}));class Sr{constructor(z,ne){this.text=z,this.range=ne}}e.$PP=Sr;var Un;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Un||(e.InlineEditTriggerKind=Un={}))}),define(Ce[269],Ie([1,0,5,7]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class k{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(b.$uN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(T,p)??[]}getRelatedInformation(A,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiRelatedInformationProvider(a,T),new S.$wN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$ioc=k}),define(Ce[91],Ie([1,0,6,5,7,19,117,3,17]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=e.$toc=void 0,e.$toc=(0,T.$Fi)("IExtHostAuthentication");let a=class{constructor(u){this.b=new Map,this.c=new b.$me,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=u.getProxy(S.$uN.MainThreadAuthentication)}async getSession(u,E,f,n={}){const s=O.$qn.toKey(u.identifier),o=[...f].sort().join(" ");return await this.d.getOrCreate(`${s} ${E} ${o}`,async()=>{await this.a.$ensureProvider(E);const h=u.displayName||u.name;return this.a.$getSession(E,f,s,h,n)})}async getSessions(u,E,f){const n=O.$qn.toKey(u.identifier),s=[...f].sort().join(" ");return await this.f.getOrCreate(`${n} ${s}`,async()=>{await this.a.$ensureProvider(E);const o=u.displayName||u.name;return this.a.$getSessions(E,f,n,o)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,E){const f=this.b.get(u);return f?f.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,f,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:f,options:n??{supportsMultipleAccounts:!1}});const s=f.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(u,o));return this.a.$registerAuthenticationProvider(u,E,n?.supportsMultipleAccounts??!1),new k.$wN(()=>{s.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,f){const n=this.b.get(u);if(n)return await n.provider.createSession(E,f);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const f=this.b.get(u);if(f)return await f.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E,f){const n=this.b.get(u);if(n)return await n.provider.getSessions(E,f);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(A.$wM)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$uoc=a,e.$uoc=a=Qe([Ve(0,p.$1P)],a);class R{constructor(){this.a=new Map}getOrCreate(u,E){const f=this.a.get(u);if(f)return f;const n=E().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(Ce[122],Ie([1,0,2,5,7,3,17,12,18,13,20,25]),function(oe,e,b,S,k,O,A,T,p,a,R,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=e.$ypc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(n,s){this.h=s,this.f=new Map,this.g=n.getProxy(S.$uN.MainThreadDecorations)}registerFileDecorationProvider(n,s){const o=u.c++;this.f.set(o,{provider:n,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const h=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,p.$4b)(i);if(r.length<=u.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,r.length);const t=r.map(m=>({uri:m,rank:(0,a.$jf)(m.path,"/")})),c=(0,p.$Bb)(t,(m,d)=>m.rank-d.rank||(0,a.$zf)(m.uri.path,d.uri.path)),l=[];e:for(const m of c){let d;for(const $ of m){const I=(0,R.$oc)($.uri.path);if(d!==I&&(d=I,l.push($.uri)>=u.d))break e}}this.g.$onDidChange(o,l)});return new k.$wN(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(n,s,o){if(!this.f.has(n))return Object.create(null);const h=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(s.map(async t=>{try{const{uri:c,id:l}=t,m=await Promise.resolve(i.provideFileDecoration(b.URI.revive(c),o));if(!m)return;try{k.$WO.validate(m),m.badge&&typeof m.badge!="string"&&(0,y.$7G)(r,"codiconDecoration"),h[l]=[m.propagate,m.tooltip,m.badge,m.color]}catch(d){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${d}`)}}catch(c){this.h.error(c)}})),h}};e.$ypc=E,e.$ypc=E=u=Qe([Ve(0,A.$1P),Ve(1,T.$_j)],E),e.$zpc=(0,O.$Fi)("IExtHostDecorations")}),define(Ce[270],Ie([1,0,14,2,7,5,16,22,13]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0;class a{static{this.a=0}constructor(y,u,E){this.d=u,this.e=E,this.b=new Map,this.c=y.getProxy(O.$uN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=a.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,y);let f;if(typeof u.onDidChange=="function"){let n;f=u.onDidChange(async s=>{if(s.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;n&&await n;const o=this.$provideTextDocumentContent(E,s).then(async h=>{if(!h&&typeof h!="string")return;const i=this.d.getDocument(s);if(!i)return;const r=(0,p.$tf)(h);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(s,h)}).catch(b.$3).finally(()=>{n===o&&(n=void 0)});n=o})}return new k.$wN(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(y,u){const E=this.b.get(y);return E?Promise.resolve(E.provideTextDocumentContent(S.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Bpc=a}),define(Ce[123],Ie([1,0,62,16,13,326,210,7,18]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$3P=R;const a=new Map;function R(f,n){n?a.set(f,n):a.delete(f)}function y(f){return a.get(f)}class u extends O.$lw{constructor(n,s,o,h,i,r,t){super(s,o,h,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,b.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,p.$wb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===S.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(s){return s?n.s(s):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(s){return n.t(s)},offsetAt(s){return n.u(s)},positionAt(s){return n.v(s)},validateRange(s){return n.w(s)},validatePosition(s){return n.x(s)},getWordRangeAtPosition(s,o){return n.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,b.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,b.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const s=this.w(n);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,h=s.start.line,i=s.end.line,r=[];r.push(this.f[h].substring(s.start.character));for(let t=h+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,s.end.character)),r.join(o)}t(n){let s;if(n instanceof T.$xN?s=n.line:typeof n=="number"&&(s=n),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new E(s,this.f[s],s===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),o=this.f[s.index].length;return new T.$xN(s.index,Math.min(s.remainder,o))}w(n){if(!(n instanceof T.$yN))throw new Error("Invalid argument");const s=this.x(n.start),o=this.x(n.end);return s===n.start&&o===n.end?n:new T.$yN(s.line,s.character,o.line,o.character)}x(n){if(!(n instanceof T.$xN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:s,character:o}=n,h=!1;if(s<0)s=0,o=0,h=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,h=!0;else{const i=this.f[s].length;o<0?(o=0,h=!0):o>i&&(o=i,h=!0)}return h?new T.$xN(s,o):n}y(n,s){const o=this.x(n);if(!s)s=y(this.m);else if((0,k.$sf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const h=(0,A.$nt)(o.character+1,(0,A.$lt)(s),this.f[o.line],0);if(h)return new T.$yN(o.line,h.startColumn-1,o.line,h.endColumn-1)}}e.$4P=u;class E{constructor(n,s,o){this.a=n,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$yN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$yN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$5P=E}),define(Ce[271],Ie([1,0,5,7]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class k{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(b.$uN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(A);if(!a)throw new Error("Embedding vector provider not found");const R=await a.provideEmbeddingVector(T,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiEmbeddingVectorProvider(T,a),new S.$wN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$Epc=k}),define(Ce[69],Ie([1,0,5,30,7,23,3,17,51,4,11,24,16]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=e.$Joc=void 0,S=qe(S);let f=E=class{constructor(s,o){this.b=new Map,this.c=new R.$Oh,this.a=s.getProxy(b.$uN.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{let r;const t=h.b.get(i.scheme);return t?(await h.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await h.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===S.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=h.b.get(i.scheme);return r&&!r.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(r.impl,r.extUri,i)):await h.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(t.impl,t.extUri,t.extUri.dirname(i)),await h.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await h.a.$writeFile(i,O.$Oe.wrap(r))}catch(t){return E.e(t)}},async delete(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await h.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await h.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return E.e(t)}},async rename(i,r,t){try{return await h.a.$rename(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},async copy(i,r,t){try{return await h.a.$copy(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&S.FileSystemProviderCapabilities.Readonly)}})}async d(s,o,h){const i=[];for(;!o.isEqual(h,o.dirname(h));)try{if(!((await s.stat(h)).type&S.FileType.Directory))throw k.$NO.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(S.$pl(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(h)),h=o.dirname(h)}for(let r=i.length-1;r>=0;r--){h=o.joinPath(h,i[r]);try{await s.createDirectory(h)}catch(t){if(S.$pl(t)!==S.FileSystemProviderErrorCode.FileExists)throw t}}}static e(s){if(s instanceof k.$NO)throw s;if(s instanceof S.$ll)switch(s.code){case S.FileSystemProviderErrorCode.FileExists:throw k.$NO.FileExists(s.message);case S.FileSystemProviderErrorCode.FileNotFound:throw k.$NO.FileNotFound(s.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw k.$NO.FileNotADirectory(s.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw k.$NO.FileIsADirectory(s.message);case S.FileSystemProviderErrorCode.NoPermissions:throw k.$NO.NoPermissions(s.message);case S.FileSystemProviderErrorCode.Unavailable:throw k.$NO.Unavailable(s.message);default:throw new k.$NO(s.message,s.name)}if(!(s instanceof Error))throw new k.$NO(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw k.$NO.Unavailable(s.message);switch(s.name){case S.FileSystemProviderErrorCode.FileExists:throw k.$NO.FileExists(s.message);case S.FileSystemProviderErrorCode.FileNotFound:throw k.$NO.FileNotFound(s.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw k.$NO.FileNotADirectory(s.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw k.$NO.FileIsADirectory(s.message);case S.FileSystemProviderErrorCode.NoPermissions:throw k.$NO.NoPermissions(s.message);case S.FileSystemProviderErrorCode.Unavailable:throw k.$NO.Unavailable(s.message);default:throw new k.$NO(s.message,s.name)}}addFileSystemProvider(s,o,h){return this.b.set(s,{impl:o,extUri:h?.isCaseSensitive?y.$9g:y.$$g,isReadonly:!!h?.isReadonly}),(0,a.$Uc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??y.$9g}};e.$Joc=f,e.$Joc=f=E=Qe([Ve(0,T.$1P),Ve(1,p.$noc)],f),e.$Koc=(0,A.$Fi)("IExtHostConsumerFileSystem")}),define(Ce[92],Ie([1,0,3,27,12,69,2]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=e.$Loc=void 0,e.$Loc=(0,b.$Fi)("IExtensionStoragePaths");let T=class{constructor(a,R,y){this.d=R,this.f=y,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(a){return A.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,R=await this.g(a);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(a){if(this.c)return A.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return A.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Moc=T,e.$Moc=T=Qe([Ve(0,S.$eQ),Ve(1,k.$_j),Ve(2,O.$Koc)],T)}),define(Ce[272],Ie([1,0,7,17,6]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0;let O=class{constructor(T){this.a=new b.$XO(b.ColorThemeKind.Dark),this.b=new k.$me}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=b.ColorThemeKind.Light;break;case"hcDark":p=b.ColorThemeKind.HighContrast;break;case"hcLight":p=b.ColorThemeKind.HighContrastLight;break;default:p=b.ColorThemeKind.Dark}this.a=new b.$XO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iqc=O,e.$iqc=O=Qe([Ve(0,S.$1P)],O)}),define(Ce[93],Ie([1,0,22,6,4,191,3,12,224,5,27,17,7]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YFb=e.$XFb=e.TunnelDtoConverter=void 0,O=qe(O),u=qe(u);class E extends p.$Kw{}var f;(function(s){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=o;function h(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=h})(f||(e.TunnelDtoConverter=f={})),e.$XFb=(0,A.$Fi)("IExtHostTunnelService");let n=class extends k.$Wc{constructor(o,h,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new S.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(a.$uN.MainThreadTunnelService)}async openTunnel(o,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const i=await this.a.$openTunnel(h,o.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,h){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:h}),this.a.$registerPortsAttributesProvider(o,i),new u.$wN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,h,i,r,t){const c=[];for(const m of o){const d=this.r.get(m);if(!d)return[];c.push(...await Promise.all(h.map(async $=>{let I;try{I=await d.provider.providePortAttributes({port:$,pid:i,commandLine:r},t)}catch{I=await d.provider.providePortAttributes($,i,r,t)}return{providedAttributes:I,port:$}})))}const l=c.filter(m=>!!m.providedAttributes);return l.length>0?l.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await o.provideTunnel(r,t,b.CancellationToken.None)??void 0;const i=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,k.$Uc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,h){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(h?this.w(h):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const t=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,k.$Uc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,h){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(h&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:t}),f.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const h=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,t)=>h[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$YFb=n,e.$YFb=n=Qe([Ve(0,y.$1P),Ve(1,R.$eQ),Ve(2,T.$_j)],n)}),define(Ce[8],Ie([1,0,18,23,148,273,60,29,137,49,73,26,143,24,35,15,2,106,33,152,94,52,108,77,116,115,235,249,81,90,55,56,246,7]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l,m,d,$,I,D,v,C,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=ce,e.$YP=re,e.$ZP=Pe,A=qe(A),h=qe(h),i=qe(i),r=qe(r),I=qe(I),v=qe(v),w=qe(w);var M;(function(ye){function Te(J){const{selectionStartLineNumber:Ee,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ge}=J,lt=new w.$xN(Ee-1,We-1),It=new w.$xN(Ye-1,Ge-1);return new w.$zN(lt,It)}ye.to=Te;function le(J){const{anchor:Ee,active:We}=J;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ye.from=le})(M||(e.Selection=M={}));var N;(function(ye){function Te(J){if(!J)return;const{start:Ee,end:We}=J;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ye.from=Te;function le(J){if(!J)return;const{startLineNumber:Ee,startColumn:We,endLineNumber:Ye,endColumn:Ge}=J;return new w.$yN(Ee-1,We-1,Ye-1,Ge-1)}ye.to=le})(N||(e.Range=N={}));var L;(function(ye){function Te(J){return{uri:J.uri,range:N.from(J.range)}}ye.from=Te;function le(J){return new w.$IN(s.URI.revive(J.uri),N.to(J.range))}ye.to=le})(L||(e.Location=L={}));var G;(function(ye){function Te(le){switch(le){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}ye.to=Te})(G||(e.TokenType=G={}));var B;(function(ye){function Te(J){return new w.$xN(J.lineNumber-1,J.column-1)}ye.to=Te;function le(J){return{lineNumber:J.line+1,column:J.character+1}}ye.from=le})(B||(e.Position=B={}));var F;(function(ye){function Te(Ee,We,Ye){return(0,b.$Jb)((0,b.$4b)(Ee).map(Ge=>le(Ge,We,Ye)))}ye.from=Te;function le(Ee,We,Ye){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ye?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:J(Ee.scheme,We),pattern:xe.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ye?.isBuiltin}}function J(Ee,We){return We&&typeof Ee=="string"?We.transformOutgoingScheme(Ee):Ee}})(F||(e.DocumentSelector=F={}));var V;(function(ye){function Te(J){switch(J){case w.DiagnosticTag.Unnecessary:return c.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return c.MarkerTag.Deprecated}}ye.from=Te;function le(J){switch(J){case c.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case c.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}ye.to=le})(V||(e.DiagnosticTag=V={}));var ae;(function(ye){function Te(J){let Ee;return J.code&&((0,n.$fg)(J.code)||(0,n.$jg)(J.code)?Ee=String(J.code):Ee={value:String(J.code.value),target:J.code.target}),{...N.from(J.range),message:J.message,source:J.source,code:Ee,severity:_.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map($e.from),tags:Array.isArray(J.tags)?(0,b.$Jb)(J.tags.map(V.from)):void 0}}ye.from=Te;function le(J){const Ee=new w.$KN(N.to(J),J.message,_.to(J.severity));return Ee.source=J.source,Ee.code=(0,n.$fg)(J.code)?J.code:J.code?.value,Ee.relatedInformation=J.relatedInformation&&J.relatedInformation.map($e.to),Ee.tags=J.tags&&(0,b.$Jb)(J.tags.map(V.to)),Ee}ye.to=le})(ae||(e.Diagnostic=ae={}));var $e;(function(ye){function Te(J){return{...N.from(J.location.range),message:J.message,resource:J.location.uri}}ye.from=Te;function le(J){return new w.$JN(new w.$IN(J.resource,N.to(J)),J.message)}ye.to=le})($e||(e.DiagnosticRelatedInformation=$e={}));var _;(function(ye){function Te(J){switch(J){case w.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Te;function le(J){switch(J){case c.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ye.to=le})(_||(e.DiagnosticSeverity=_={}));var ge;(function(ye){function Te(J){return typeof J=="number"&&J>=w.ViewColumn.One?J-1:J===w.ViewColumn.Beside?g.$pE:g.$oE}ye.from=Te;function le(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(ge||(e.ViewColumn=ge={}));function se(ye){return typeof ye.range<"u"}function ce(ye){return ye.length===0?!0:!!se(ye[0])}var we;(function(ye){function Te(Ge){return Ge.map(ye.from)}ye.fromMany=Te;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let lt;if(le(Ge)){const{language:Mt,value:ui}=Ge;lt={value:"```"+Mt+`
`+ui+"\n```\n"}}else w.$YN.isMarkdownString(Ge)?lt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?lt={value:Ge}:lt={value:""};const It=Object.create(null);lt.uris=It;const Jt=Mt=>{try{let ui=s.URI.parse(Mt,!0);ui=ui.with({query:Ee(ui.query,It)}),It[Mt]=ui}catch{}return""},ci=new p.marked.Renderer;return ci.link=Jt,ci.image=Mt=>typeof Mt=="string"?Jt(A.$$k(Mt).href):"",(0,p.marked)(lt.value,{renderer:ci}),lt}ye.from=J;function Ee(Ge,lt){if(!Ge)return Ge;let It;try{It=(0,a.$bi)(Ge)}catch{}if(!It)return Ge;let Jt=!1;return It=(0,y.$fo)(It,ci=>{if(s.URI.isUri(ci)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Mt]=ci,Jt=!0,Mt}else return}),Jt?JSON.stringify(It):Ge}function We(Ge){const lt=new w.$YN(Ge.value,Ge.supportThemeIcons);return lt.isTrusted=Ge.isTrusted,lt.supportHtml=Ge.supportHtml,lt.baseUri=Ge.baseUri?s.URI.from(Ge.baseUri):void 0,lt}ye.to=We;function Ye(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Ye})(we||(e.MarkdownString=we={}));function re(ye){return ce(ye)?ye.map(Te=>({range:N.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?we.fromMany(Te.hoverMessage):Te.hoverMessage?we.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):ye.map(Te=>({range:N.from(Te)}))}function Pe(ye){return typeof ye>"u"?ye:typeof ye=="string"?s.URI.file(ye):ye}var Me;(function(ye){function Te(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?Pe(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=Te})(Me||(e.ThemableDecorationAttachmentRenderOptions=Me={}));var Y;(function(ye){function Te(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Pe(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Me.from(le.before):void 0,after:le.after?Me.from(le.after):void 0}}ye.from=Te})(Y||(e.ThemableDecorationRenderOptions=Y={}));var q;(function(ye){function Te(le){if(typeof le>"u")return le;switch(le){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Te})(q||(e.DecorationRangeBehavior=q={}));var ee;(function(ye){function Te(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?q.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?Y.from(le.light):void 0,dark:le.dark?Y.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Pe(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Me.from(le.before):void 0,after:le.after?Me.from(le.after):void 0}}ye.from=Te})(ee||(e.DecorationRenderOptions=ee={}));var ve;(function(ye){function Te(J){return{text:J.newText,eol:J.newEol&&je.from(J.newEol),range:N.from(J.range)}}ye.from=Te;function le(J){const Ee=new w.$DN(N.to(J.range),J.text);return Ee.newEol=typeof J.eol>"u"?void 0:je.to(J.eol),Ee}ye.to=le})(ve||(e.TextEdit=ve={}));var ue;(function(ye){function Te(J,Ee){const We={edits:[]};if(J instanceof w.$GN){const Ye=new T.$Dc;for(const Ge of J._allEntries())Ge._type===w.FileEditType.File&&s.URI.isUri(Ge.to)&&Ge.from===void 0&&Ye.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===w.FileEditType.File){let lt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?lt={type:"base64",value:(0,S.$9e)(S.$Oe.wrap(Ge.options.contents))}:lt={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:lt},metadata:Ge.metadata})}else Ge._type===w.FileEditType.Text?We.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Snippet?We.edits.push({resource:Ge.uri,textEdit:{range:N.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Cell?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===w.FileEditType.CellReplace&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:v.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Pt.from)}})}return We}ye.from=Te;function le(J){const Ee=new w.$GN,We=new T.$Cc;for(const Ye of J.edits)if(Ye.textEdit){const Ge=Ye,lt=s.URI.revive(Ge.resource),It=N.to(Ge.textEdit.range),Jt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let Mt;ci?Mt=w.$FN.replace(It,new w.$HN(Jt)):Mt=w.$DN.replace(It,Jt);const ui=We.get(lt);ui?ui.push(Mt):We.set(lt,[Mt])}else Ee.renameFile(s.URI.revive(Ye.oldResource),s.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ge]of We)Ee.set(Ye,Ge);return Ee}ye.to=le})(ue||(e.WorkspaceEdit=ue={}));var be;(function(ye){const Te=Object.create(null);Te[w.SymbolKind.File]=r.SymbolKind.File,Te[w.SymbolKind.Module]=r.SymbolKind.Module,Te[w.SymbolKind.Namespace]=r.SymbolKind.Namespace,Te[w.SymbolKind.Package]=r.SymbolKind.Package,Te[w.SymbolKind.Class]=r.SymbolKind.Class,Te[w.SymbolKind.Method]=r.SymbolKind.Method,Te[w.SymbolKind.Property]=r.SymbolKind.Property,Te[w.SymbolKind.Field]=r.SymbolKind.Field,Te[w.SymbolKind.Constructor]=r.SymbolKind.Constructor,Te[w.SymbolKind.Enum]=r.SymbolKind.Enum,Te[w.SymbolKind.Interface]=r.SymbolKind.Interface,Te[w.SymbolKind.Function]=r.SymbolKind.Function,Te[w.SymbolKind.Variable]=r.SymbolKind.Variable,Te[w.SymbolKind.Constant]=r.SymbolKind.Constant,Te[w.SymbolKind.String]=r.SymbolKind.String,Te[w.SymbolKind.Number]=r.SymbolKind.Number,Te[w.SymbolKind.Boolean]=r.SymbolKind.Boolean,Te[w.SymbolKind.Array]=r.SymbolKind.Array,Te[w.SymbolKind.Object]=r.SymbolKind.Object,Te[w.SymbolKind.Key]=r.SymbolKind.Key,Te[w.SymbolKind.Null]=r.SymbolKind.Null,Te[w.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Te[w.SymbolKind.Struct]=r.SymbolKind.Struct,Te[w.SymbolKind.Event]=r.SymbolKind.Event,Te[w.SymbolKind.Operator]=r.SymbolKind.Operator,Te[w.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function le(Ee){return typeof Te[Ee]=="number"?Te[Ee]:r.SymbolKind.Property}ye.from=le;function J(Ee){for(const We in Te)if(Te[We]===Ee)return Number(We);return w.SymbolKind.Property}ye.to=J})(be||(e.SymbolKind=be={}));var de;(function(ye){function Te(J){switch(J){case w.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}ye.from=Te;function le(J){switch(J){case r.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}ye.to=le})(de||(e.SymbolTag=de={}));var X;(function(ye){function Te(J){return{name:J.name,kind:be.from(J.kind),tags:J.tags&&J.tags.map(de.from),containerName:J.containerName,location:ze.from(J.location)}}ye.from=Te;function le(J){const Ee=new w.$PN(J.name,be.to(J.kind),J.containerName,ze.to(J.location));return Ee.tags=J.tags&&J.tags.map(de.to),Ee}ye.to=le})(X||(e.WorkspaceSymbol=X={}));var Z;(function(ye){function Te(J){const Ee={name:J.name||"!!MISSING: name!!",detail:J.detail,range:N.from(J.range),selectionRange:N.from(J.selectionRange),kind:be.from(J.kind),tags:J.tags?.map(de.from)??[]};return J.children&&(Ee.children=J.children.map(Te)),Ee}ye.from=Te;function le(J){const Ee=new w.$QN(J.name,J.detail,be.to(J.kind),N.to(J.range),N.to(J.selectionRange));return(0,b.$Nb)(J.tags)&&(Ee.tags=J.tags.map(de.to)),J.children&&(Ee.children=J.children.map(le)),Ee}ye.to=le})(Z||(e.DocumentSymbol=Z={}));var me;(function(ye){function Te(J){const Ee=new w.$UN(be.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}ye.to=Te;function le(J,Ee,We){if(Ee=Ee??J._sessionId,We=We??J._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,name:J.name,detail:J.detail,kind:be.from(J.kind),uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(de.from)}}ye.from=le})(me||(e.CallHierarchyItem=me={}));var pe;(function(ye){function Te(le){return new w.$VN(me.to(le.from),le.fromRanges.map(J=>N.to(J)))}ye.to=Te})(pe||(e.CallHierarchyIncomingCall=pe={}));var Oe;(function(ye){function Te(le){return new w.$WN(me.to(le.to),le.fromRanges.map(J=>N.to(J)))}ye.to=Te})(Oe||(e.CallHierarchyOutgoingCall=Oe={}));var ze;(function(ye){function Te(J){return{range:J.range&&N.from(J.range),uri:J.uri}}ye.from=Te;function le(J){return new w.$IN(s.URI.revive(J.uri),N.to(J.range))}ye.to=le})(ze||(e.location=ze={}));var ke;(function(ye){function Te(J){const Ee=J,We=J;return{originSelectionRange:Ee.originSelectionRange?N.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:We.uri,range:N.from(Ee.targetRange?Ee.targetRange:We.range),targetSelectionRange:Ee.targetSelectionRange?N.from(Ee.targetSelectionRange):void 0}}ye.from=Te;function le(J){return{targetUri:s.URI.revive(J.uri),targetRange:N.to(J.range),targetSelectionRange:J.targetSelectionRange?N.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?N.to(J.originSelectionRange):void 0}}ye.to=le})(ke||(e.DefinitionLink=ke={}));var Ae;(function(ye){function Te(J){return{range:N.from(J.range),contents:we.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ye.from=Te;function le(J){const Ee=J.contents.map(we.to),We=N.to(J.range),Ye=J.canIncreaseVerbosity,Ge=J.canDecreaseVerbosity;return new w.$MN(Ee,We,Ye,Ge)}ye.to=le})(Ae||(e.Hover=Ae={}));var Ne;(function(ye){function Te(J){return{range:N.from(J.range),expression:J.expression}}ye.from=Te;function le(J){return new w.$HO(N.to(J.range),J.expression)}ye.to=le})(Ne||(e.EvaluatableExpression=Ne={}));var j;(function(ye){function Te(J){if(J instanceof w.$IO)return{type:"text",range:N.from(J.range),text:J.text};if(J instanceof w.$JO)return{type:"variable",range:N.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof w.$KO)return{type:"expression",range:N.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Te;function le(J){switch(J.type){case"text":return{range:N.to(J.range),text:J.text};case"variable":return{range:N.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:N.to(J.range),expression:J.expression}}}ye.to=le})(j||(e.InlineValue=j={}));var U;(function(ye){function Te(J){return{frameId:J.frameId,stoppedLocation:N.from(J.stoppedLocation)}}ye.from=Te;function le(J){return new w.$LO(J.frameId,N.to(J.stoppedLocation))}ye.to=le})(U||(e.InlineValueContext=U={}));var K;(function(ye){function Te(J){return{range:N.from(J.range),kind:J.kind}}ye.from=Te;function le(J){return new w.$NN(N.to(J.range),J.kind)}ye.to=le})(K||(e.DocumentHighlight=K={}));var H;(function(ye){function Te(J){return{uri:J.uri,highlights:J.highlights.map(K.from)}}ye.from=Te;function le(J){return new w.$ON(s.URI.revive(J.uri),J.highlights.map(K.to))}ye.to=le})(H||(e.MultiDocumentHighlight=H={}));var ie;(function(ye){function Te(le){switch(le){case r.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}ye.to=Te})(ie||(e.CompletionTriggerKind=ie={}));var fe;(function(ye){function Te(le){return{triggerKind:ie.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=Te})(fe||(e.CompletionContext=fe={}));var Re;(function(ye){function Te(J){switch(J){case w.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}ye.from=Te;function le(J){switch(J){case r.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}ye.to=le})(Re||(e.CompletionItemTag=Re={}));var Ue;(function(ye){const Te=new Map([[w.CompletionItemKind.Method,r.CompletionItemKind.Method],[w.CompletionItemKind.Function,r.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,r.CompletionItemKind.Field],[w.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[w.CompletionItemKind.Class,r.CompletionItemKind.Class],[w.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[w.CompletionItemKind.Module,r.CompletionItemKind.Module],[w.CompletionItemKind.Property,r.CompletionItemKind.Property],[w.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[w.CompletionItemKind.Value,r.CompletionItemKind.Value],[w.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,r.CompletionItemKind.Text],[w.CompletionItemKind.Color,r.CompletionItemKind.Color],[w.CompletionItemKind.File,r.CompletionItemKind.File],[w.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[w.CompletionItemKind.Event,r.CompletionItemKind.Event],[w.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[w.CompletionItemKind.User,r.CompletionItemKind.User]]);function le(We){return Te.get(We)??r.CompletionItemKind.Property}ye.from=le;const J=new Map([[r.CompletionItemKind.Method,w.CompletionItemKind.Method],[r.CompletionItemKind.Function,w.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,w.CompletionItemKind.Field],[r.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[r.CompletionItemKind.Class,w.CompletionItemKind.Class],[r.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[r.CompletionItemKind.Module,w.CompletionItemKind.Module],[r.CompletionItemKind.Property,w.CompletionItemKind.Property],[r.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[r.CompletionItemKind.Value,w.CompletionItemKind.Value],[r.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,w.CompletionItemKind.Text],[r.CompletionItemKind.Color,w.CompletionItemKind.Color],[r.CompletionItemKind.File,w.CompletionItemKind.File],[r.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[r.CompletionItemKind.Event,w.CompletionItemKind.Event],[r.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,w.CompletionItemKind.User],[r.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function Ee(We){return J.get(We)??w.CompletionItemKind.Property}ye.to=Ee})(Ue||(e.CompletionItemKind=Ue={}));var Ke;(function(ye){function Te(le,J){const Ee=new w.$5N(le.label);return Ee.insertText=le.insertText,Ee.kind=Ue.to(le.kind),Ee.tags=le.tags?.map(Re.to),Ee.detail=le.detail,Ee.documentation=A.$5k(le.documentation)?we.to(le.documentation):le.documentation,Ee.sortText=le.sortText,Ee.filterText=le.filterText,Ee.preselect=le.preselect,Ee.commitCharacters=le.commitCharacters,h.$Lt.isIRange(le.range)?Ee.range=N.to(le.range):typeof le.range=="object"&&(Ee.range={inserting:N.to(le.range.insert),replacing:N.to(le.range.replace)}),Ee.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new w.$HN(le.insertText):(Ee.insertText=le.insertText,Ee.textEdit=Ee.range instanceof w.$yN?new w.$DN(Ee.range,Ee.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ee.additionalTextEdits=le.additionalTextEdits.map(We=>ve.to(We))),Ee.command=J&&le.command?J.fromInternal(le.command):void 0,Ee}ye.to=Te})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Te(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:we.fromStrict(J.documentation)}}ye.from=Te;function le(J){return{label:J.label,documentation:A.$5k(J.documentation)?we.to(J.documentation):J.documentation}}ye.to=le})(_e||(e.ParameterInformation=_e={}));var tt;(function(ye){function Te(J){return{label:J.label,documentation:we.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(_e.from):[],activeParameter:J.activeParameter}}ye.from=Te;function le(J){return{label:J.label,documentation:A.$5k(J.documentation)?we.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(_e.to):[],activeParameter:J.activeParameter}}ye.to=le})(tt||(e.SignatureInformation=tt={}));var nt;(function(ye){function Te(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.from):[]}}ye.from=Te;function le(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.to):[]}}ye.to=le})(nt||(e.SignatureHelp=nt={}));var et;(function(ye){function Te(le,J){const Ee=new w.$4N(B.to(J.position),typeof J.label=="string"?J.label:J.label.map(rt.to.bind(void 0,le)),J.kind&&ft.to(J.kind));return Ee.textEdits=J.textEdits&&J.textEdits.map(ve.to),Ee.tooltip=A.$5k(J.tooltip)?we.to(J.tooltip):J.tooltip,Ee.paddingLeft=J.paddingLeft,Ee.paddingRight=J.paddingRight,Ee}ye.to=Te})(et||(e.InlayHint=et={}));var rt;(function(ye){function Te(le,J){const Ee=new w.$3N(J.label);return Ee.tooltip=A.$5k(J.tooltip)?we.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(Ee.command=le.fromInternal(J.command)),J.location&&(Ee.location=ze.to(J.location)),Ee}ye.to=Te})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(ye){function Te(J){return J}ye.from=Te;function le(J){return J}ye.to=le})(ft||(e.InlayHintKind=ft={}));var ct;(function(ye){function Te(J){return{range:N.from(J.range),url:J.target,tooltip:J.tooltip}}ye.from=Te;function le(J){let Ee;if(J.url)try{Ee=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}const We=new w.$0N(N.to(J.range),Ee);return We.tooltip=J.tooltip,We}ye.to=le})(ct||(e.DocumentLink=ct={}));var st;(function(ye){function Te(J){const Ee=new w.$aO(J.label);return J.textEdit&&(Ee.textEdit=ve.to(J.textEdit)),J.additionalTextEdits&&(Ee.additionalTextEdits=J.additionalTextEdits.map(We=>ve.to(We))),Ee}ye.to=Te;function le(J){return{label:J.label,textEdit:J.textEdit?ve.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}ye.from=le})(st||(e.ColorPresentation=st={}));var ut;(function(ye){function Te(J){return new w.$$N(J[0],J[1],J[2],J[3])}ye.to=Te;function le(J){return[J.red,J.green,J.blue,J.alpha]}ye.from=le})(ut||(e.Color=ut={}));var gt;(function(ye){function Te(J){return{range:N.from(J.range)}}ye.from=Te;function le(J){return new w.$TN(N.to(J.range))}ye.to=le})(gt||(e.SelectionRange=gt={}));var pt;(function(ye){function Te(le){switch(le){case d.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case d.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case d.SaveReason.FOCUS_CHANGE:case d.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}ye.to=Te})(pt||(e.TextDocumentSaveReason=pt={}));var Be;(function(ye){function Te(J){switch(J){case w.TextEditorLineNumbersStyle.Off:return o.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return o.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return o.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return o.RenderLineNumbersType.On}}ye.from=Te;function le(J){switch(J){case o.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case o.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case o.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case o.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}ye.to=le})(Be||(e.TextEditorLineNumbersStyle=Be={}));var je;(function(ye){function Te(J){if(J===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(J===w.EndOfLine.LF)return t.EndOfLineSequence.LF}ye.from=Te;function le(J){if(J===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(J===t.EndOfLineSequence.LF)return w.EndOfLine.LF}ye.to=le})(je||(e.EndOfLine=je={}));var Q;(function(ye){function Te(le){if(typeof le=="object")return le.viewId;switch(le){case w.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case w.ProgressLocation.Window:return l.ProgressLocation.Window;case w.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Te})(Q||(e.ProgressLocation=Q={}));var x;(function(ye){function Te(J){const Ee={start:J.start+1,end:J.end+1};return J.kind&&(Ee.kind=De.from(J.kind)),Ee}ye.from=Te;function le(J){const Ee={start:J.start-1,end:J.end-1};return J.kind&&(Ee.kind=De.to(J.kind)),Ee}ye.to=le})(x||(e.FoldingRange=x={}));var De;(function(ye){function Te(J){if(J)switch(J){case w.FoldingRangeKind.Comment:return r.$Lu.Comment;case w.FoldingRangeKind.Imports:return r.$Lu.Imports;case w.FoldingRangeKind.Region:return r.$Lu.Region}}ye.from=Te;function le(J){if(J)switch(J.value){case r.$Lu.Comment.value:return w.FoldingRangeKind.Comment;case r.$Lu.Imports.value:return w.FoldingRangeKind.Imports;case r.$Lu.Region.value:return w.FoldingRangeKind.Region}}ye.to=le})(De||(e.FoldingRangeKind=De={}));var Je;(function(ye){function Te(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?N.from(le.selection):void 0,override:typeof le.override=="boolean"?d.$SF.id:void 0}}ye.from=Te})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(ye){function Te(We){return We instanceof w.$vO?We.toJSON():typeof We=="string"?We:le(We)||J(We)?new w.$vO(We.baseUri??We.base,We.pattern).toJSON():We}ye.from=Te;function le(We){const Ye=We;return Ye?s.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function J(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ee(We){return typeof We=="string"?We:new w.$vO(s.URI.revive(We.baseUri),We.pattern)}ye.to=Ee})(xe||(e.GlobPattern=xe={}));var ht;(function(ye){function Te(le){if(le){if(Array.isArray(le))return le.map(Te);if(typeof le=="string")return le;{const J=le;return{language:J.language,scheme:J.scheme,pattern:xe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ye.from=Te})(ht||(e.LanguageSelector=ht={}));var $t;(function(ye){function Te(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ye=>Ye instanceof w.$yN)))}ye.is=Te;function le(J){return{documents:J.documents.map(Ee=>Ee.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ye=>N.from(Ye))})))}}ye.from=le})($t||(e.MappedEditsContext=$t={}));var Ft;(function(ye){function Te(J){return{start:J.start,end:J.end}}ye.from=Te;function le(J){return new w.$YO(J.start,J.end)}ye.to=le})(Ft||(e.NotebookRange=Ft={}));var zt;(function(ye){function Te(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ye.to=Te;function le(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ye.from=le})(zt||(e.NotebookCellExecutionSummary=zt={}));var Yt;(function(ye){function Te(le){if(le===v.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(le===v.NotebookCellExecutionState.Pending)return;if(le===v.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}ye.to=Te})(Yt||(e.NotebookCellExecutionState=Yt={}));var fi;(function(ye){function Te(J){switch(J){case w.NotebookCellKind.Markup:return v.CellKind.Markup;case w.NotebookCellKind.Code:default:return v.CellKind.Code}}ye.from=Te;function le(J){switch(J){case v.CellKind.Markup:return w.NotebookCellKind.Markup;case v.CellKind.Code:default:return w.NotebookCellKind.Code}}ye.to=le})(fi||(e.NotebookCellKind=fi={}));var Ze;(function(ye){function Te(J){const Ee={metadata:J.metadata??Object.create(null),cells:[]};for(const We of J.cells)w.$ZO.validate(We),Ee.cells.push(Pt.from(We));return Ee}ye.from=Te;function le(J){const Ee=new w.$1O(J.cells.map(Pt.to));return(0,n.$sg)(J.metadata)||(Ee.metadata=J.metadata),Ee}ye.to=le})(Ze||(e.NotebookData=Ze={}));var Pt;(function(ye){function Te(J){return{cellKind:fi.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:zt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Qt.from):[]}}ye.from=Te;function le(J){return new w.$ZO(fi.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Qt.to):void 0,J.metadata,J.internalMetadata?zt.to(J.internalMetadata):void 0)}ye.to=le})(Pt||(e.NotebookCellData=Pt={}));var Kt;(function(ye){function Te(J){return{mime:J.mime,valueBytes:S.$Oe.wrap(J.data)}}ye.from=Te;function le(J){return new w.$2O(J.valueBytes.buffer,J.mime)}ye.to=le})(Kt||(e.NotebookCellOutputItem=Kt={}));var Qt;(function(ye){function Te(J){return{outputId:J.id,items:J.items.map(Kt.from),metadata:J.metadata}}ye.from=Te;function le(J){const Ee=J.items.map(Kt.to);return new w.$3O(Ee,J.outputId,J.metadata)}ye.to=le})(Qt||(e.NotebookCellOutput=Qt={}));var mt;(function(ye){function Te(Ee){return J(Ee)?{include:xe.from(Ee.include)??void 0,exclude:xe.from(Ee.exclude)??void 0}:xe.from(Ee)??void 0}ye.from=Te;function le(Ee){return J(Ee)?{include:xe.to(Ee.include),exclude:xe.to(Ee.exclude)}:xe.to(Ee)}ye.to=le;function J(Ee){const We=Ee;return We?!(0,n.$og)(We.include)&&!(0,n.$og)(We.exclude):!1}})(mt||(e.NotebookExclusiveDocumentPattern=mt={}));var vt;(function(ye){function Te(le,J,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===w.NotebookCellStatusBarAlignment.Left?v.CellStatusbarAlignment.Left:v.CellStatusbarAlignment.Right,command:J.toInternal(We,Ee),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=Te})(vt||(e.NotebookStatusBarItem=vt={}));var ii;(function(ye){function Te(le,J,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:J.toInternal(We,Ee),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}ye.from=Te})(ii||(e.NotebookKernelSourceAction=ii={}));var Zt;(function(ye){function Te(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}ye.from=Te})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var qt;(function(ye){function Te(J){return{uri:J.uri,provides:J.provides}}ye.from=Te;function le(J){return new w.$5O(s.URI.revive(J.uri),J.provides)}ye.to=le})(qt||(e.NotebookRendererScript=qt={}));var yt;(function(ye){function Te(J){return{message:we.fromStrict(J.message)||"",type:P.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:N.from(J.location.range),uri:J.location.uri}}}ye.from=Te;function le(J){const Ee=new w.$$O(typeof J.message=="string"?J.message:we.to(J.message));return Ee.actualOutput=J.actual,Ee.expectedOutput=J.expected,Ee.contextValue=J.contextValue,Ee.location=J.location?ze.to(J.location):void 0,Ee}ye.to=le})(yt||(e.TestMessage=yt={}));var Nt;(function(ye){ye.namespace=P.$YI,ye.denamespace=P.$ZI})(Nt||(e.TestTag=Nt={}));var li;(function(ye){function Te(J){const Ee=(0,m.$WP)(J).controllerId;return{extId:C.$TI.fromExtHostTestItem(J,Ee).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(We=>Nt.namespace(Ee,We.id)),range:h.$Lt.lift(N.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&we.fromStrict(J.error)||null}}ye.from=Te;function le(J){return{parent:void 0,error:void 0,id:C.$TI.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(Ee=>{const{tagId:We}=Nt.denamespace(Ee);return new w.$_O(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ye.toPlain=le})(li||(e.TestItem=li={})),function(ye){function Te(J){return{id:J.id}}ye.from=Te;function le(J){return new w.$_O(J.id)}ye.to=le}(Nt||(e.TestTag=Nt={}));var Vt;(function(ye){const Te=(J,Ee)=>{const We=J.value;if(!We)return;const Ye={...li.toPlain(We.item),parent:Ee,taskStates:We.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(lt=>lt.type===P.TestMessageType.Error).map(yt.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const lt=Te(Ge,Ye);lt&&Ye.children.push(lt)}return Ye};function le(J){const Ee=new u.$SI;for(const Ge of J.items)Ee.insert(C.$TI.fromString(Ge.item.extId).path,Ge);const We=[Ee.nodes],Ye=[];for(;We.length;)for(const Ge of We.pop())Ge.value?Ye.push(Ge):Ge.children&&We.push(Ge.children.values());return{completedAt:J.completedAt,results:Ye.map(Ge=>Te(Ge)).filter(n.$ng)}}ye.to=le})(Vt||(e.TestResults=Vt={}));var Xe;(function(ye){function Te(We){return{covered:We.covered,total:We.total}}function le(We){return"line"in We?B.from(We):N.from(We)}function J(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:le(We.location),type:P.DetailType.Statement,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&le(Ye.location),label:Ye.label})):void 0}:{type:P.DetailType.Declaration,name:We.name,count:We.executed,location:le(We.location)}}ye.fromDetails=J;function Ee(We,Ye,Ge){return w.$bP(Ge.statementCoverage),w.$bP(Ge.branchCoverage),w.$bP(Ge.declarationCoverage),{id:Ye,uri:Ge.uri,statement:Te(Ge.statementCoverage),branch:Ge.branchCoverage&&Te(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Te(Ge.declarationCoverage),testIds:Ge instanceof w.$cP&&Ge.fromTests.length?Ge.fromTests.map(lt=>C.$TI.fromExtHostTestItem(lt,We).toString()):void 0}}ye.fromFile=Ee})(Xe||(e.TestCoverage=Xe={}));var xt;(function(ye){function Te(le){switch(le){case r.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}ye.to=Te})(xt||(e.CodeActionTriggerKind=xt={}));var ni;(function(ye){function Te(J){const Ee=new w.$gP(be.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}ye.to=Te;function le(J,Ee,We){if(Ee=Ee??J._sessionId,We=We??J._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,kind:be.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(de.from)}}ye.from=le})(ni||(e.TypeHierarchyItem=ni={}));var hi;(function(ye){function Te(le){if(le)return{value:le.value,tooltip:le.tooltip}}ye.from=Te})(hi||(e.ViewBadge=hi={}));var kt;(function(ye){function Te(We,Ye,Ge){const lt=Ye.fileData;return lt?new w.$nO(new w.$oO(lt.name,s.URI.revive(lt.uri),lt.id,(0,O.$fb)(()=>Ge(lt.id)))):We===R.$8s.uriList&&Ye.uriListData?new w.$mO(Ee(Ye.uriListData)):new w.$mO(Ye.asString)}ye.to=Te;async function le(We,Ye){const Ge=await Ye.asString();if(We===R.$8s.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const lt=Ye.asFile();return{asString:Ge,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}ye.from=le;function J(We){return k.$pu.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return s.URI.parse(Ye)}catch{}return Ye})}function Ee(We){return k.$pu.create(We.map(Ye=>typeof Ye=="string"?Ye:s.URI.revive(Ye)))}})(kt||(e.DataTransferItem=kt={}));var Lt;(function(ye){function Te(J,Ee){const We=J.items.map(([Ye,Ge])=>[Ye,kt.to(Ye,Ge,Ee)]);return new w.$pO(We)}ye.toDataTransfer=Te;async function le(J){const Ee={items:[]},We=[];for(const[Ye,Ge]of J)We.push((async()=>{Ee.items.push([Ye,await kt.from(Ye,Ge)])})());return await Promise.all(We),Ee}ye.from=le})(Lt||(e.DataTransfer=Lt={}));var At;(function(ye){function Te(J,Ee){return{kind:"reply",agentId:J.participant??Ee?.agentId??"",subCommand:J.command??Ee?.command,message:J.prompt,title:J.label}}ye.from=Te;function le(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ye.to=le})(At||(e.ChatFollowup=At={}));var Ut;(function(ye){function Te(J){switch(J){case I.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case I.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case I.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}ye.to=Te;function le(J){switch(J){case w.LanguageModelChatMessageRole.System:return I.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return I.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return I.ChatMessageRole.Assistant}return I.ChatMessageRole.User}ye.from=le})(Ut||(e.LanguageModelChatMessageRole=Ut={}));var ri;(function(ye){function Te(J){let Ee="",We;J.content.type==="text"?Ee=J.content.value:We=new w.$HP(J.content.name,J.content.value,J.content.isError);const Ye=Ut.to(J.role),Ge=new w.$IP(Ye,Ee,J.name);return We!==void 0&&(Ge.content2=We),Ge}ye.to=Te;function le(J){const Ee=Ut.from(J.role),We=J.name;let Ye;return J.content2 instanceof w.$HP?Ye={type:"function_result",name:J.content2.name,value:J.content2.content,isError:J.content2.isError}:Ye={type:"text",value:J.content},{role:Ee,name:We,content:Ye}}ye.from=le})(ri||(e.LanguageModelChatMessage=ri={}));var _t;(function(ye){function Te(J){return{kind:"markdownContent",content:we.from(J.value)}}ye.from=Te;function le(J){return new w.$tP(we.to(J.content))}ye.to=le})(_t||(e.ChatResponseMarkdownPart=_t={}));var si;(function(ye){function Te(J){return{kind:"markdownVuln",content:we.from(J.value),vulnerabilities:J.vulnerabilities}}ye.from=Te;function le(J){return new w.$uP(we.to(J.content),J.vulnerabilities)}ye.to=le})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var jt;(function(ye){function Te(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ye.from=Te;function le(J){return new w.$vP(J.agentId,J.command)}ye.to=le})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var Ht;(function(ye){function Te(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data}}ye.from=Te})(Ht||(e.ChatResponseConfirmationPart=Ht={}));var oi;(function(ye){function Te(J){const{value:Ee,baseUri:We}=J;function Ye(Ge,lt){return Ge.map(It=>{const Jt=s.URI.joinPath(lt,It.name);return{label:It.name,uri:Jt,children:It.children&&Ye(It.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,E.$dh)(We),uri:We,children:Ye(Ee,We)}}}ye.from=Te;function le(J){const Ee=(0,a.$ci)(J.treeData);function We(lt){return lt.map(It=>({name:It.label,children:It.children&&We(It.children)}))}const Ye=Ee.uri,Ge=Ee.children?We(Ee.children):[];return new w.$xP(Ge,Ye)}ye.to=le})(oi||(e.ChatResponseFilesPart=oi={}));var Rt;(function(ye){function Te(J){const Ee=We=>s.URI.isUri(We);return{kind:"inlineReference",name:J.title,inlineReference:Ee(J.value)?J.value:L.from(J.value)}}ye.from=Te;function le(J){const Ee=(0,a.$ci)(J);return new w.$yP(s.URI.isUri(Ee.inlineReference)?Ee.inlineReference:L.to(Ee.inlineReference),J.name)}ye.to=le})(Rt||(e.ChatResponseAnchorPart=Rt={}));var St;(function(ye){function Te(J){return{kind:"progressMessage",content:we.from(J.value)}}ye.from=Te;function le(J){return new w.$zP(J.content.value)}ye.to=le})(St||(e.ChatResponseProgressPart=St={}));var bt;(function(ye){function Te(J){return{kind:"warning",content:we.from(J.value)}}ye.from=Te;function le(J){return new w.$BP(J.content.value)}ye.to=le})(bt||(e.ChatResponseWarningPart=bt={}));var ei;(function(ye){function Te(le){return{kind:"progressTask",content:we.from(le.value)}}ye.from=Te})(ei||(e.ChatTask=ei={}));var Ct;(function(ye){function Te(le){return{kind:"progressTaskResult",content:typeof le=="string"?we.from(le):void 0}}ye.from=Te})(Ct||(e.ChatTaskResult=Ct={}));var di;(function(ye){function Te(J,Ee,We){return{kind:"command",command:Ee.toInternal(J.value,We)??{command:J.value.command,title:J.value.title}}}ye.from=Te;function le(J,Ee){return new w.$CP(Ee.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ye.to=le})(di||(e.ChatResponseCommandButtonPart=di={}));var Gt;(function(ye){function Te(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Ee=>ve.from(Ee))}}ye.from=Te;function le(J){return new w.$EP(s.URI.revive(J.uri),J.edits.map(Ee=>ve.to(Ee)))}ye.to=le})(Gt||(e.ChatResponseTextEditPart=Gt={}));var bi;(function(ye){function Te(J){const Ee=f.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:s.URI.isUri(J.iconPath)?{light:s.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:L.from(J.value.value)},iconPath:Ee}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:L.from(J.value),iconPath:Ee}}ye.from=Te;function le(J){const Ee=(0,a.$ci)(J),We=Ye=>s.URI.isUri(Ye)?Ye:L.to(Ye);return new w.$DP("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&We(Ee.reference.value)}:We(Ee.reference))}ye.to=le})(bi||(e.ChatResponseReferencePart=bi={}));var vi;(function(ye){function Te(Ee,We,Ye){return Ee instanceof w.$tP?_t.from(Ee):Ee instanceof w.$yP?Rt.from(Ee):Ee instanceof w.$DP?bi.from(Ee):Ee instanceof w.$zP?St.from(Ee):Ee instanceof w.$xP?oi.from(Ee):Ee instanceof w.$CP?di.from(Ee,We,Ye):Ee instanceof w.$EP?Gt.from(Ee):Ee instanceof w.$uP?si.from(Ee):Ee instanceof w.$vP?jt.from(Ee):Ee instanceof w.$BP?bt.from(Ee):{kind:"markdownContent",content:we.from("")}}ye.from=Te;function le(Ee,We){switch(Ee.kind){case"reference":return bi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Ee,We)}}ye.to=le;function J(Ee,We){switch(Ee.kind){case"markdownContent":return _t.to(Ee);case"inlineReference":return Rt.to(Ee);case"progressMessage":return;case"treeData":return oi.to(Ee);case"command":return di.to(Ee,We)}}ye.toContent=J})(vi||(e.ChatResponsePart=vi={}));var gi;(function(ye){function Te(le){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(ai.to),location:Bt.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData}}ye.to=Te})(gi||(e.ChatAgentRequest=gi={}));var Bt;(function(ye){function Te(J){switch(J){case $.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}ye.to=Te;function le(J){switch(J){case w.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ye.from=le})(Bt||(e.ChatLocation=Bt={}));var ai;(function(ye){function Te(le){const J=le.value;if(!J)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,s.$xc)(J)?s.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,s.$xc)(J.uri)?L.to((0,a.$ci)(J)):J,modelDescription:le.modelDescription}}ye.to=Te})(ai||(e.ChatAgentValueReference=ai={}));var Ii;(function(ye){function Te(le,J,Ee){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:J.toInternal(le.command,Ee)}}ye.from=Te})(Ii||(e.ChatAgentCompletionItem=Ii={}));var Tt;(function(ye){function Te(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}ye.to=Te})(Tt||(e.ChatAgentResult=Tt={}));var Di;(function(ye){function Te(le,J,Ee){if(J.action.kind==="vote")return;const We=Tt.to(le);if(J.action.kind==="command"){const Ye=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:We}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:At.to(J.action.followup)},result:We}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:We}:{action:J.action,result:We}}ye.to=Te})(Di||(e.ChatAgentUserActionEvent=Di={}));var Pi;(function(ye){function Te(le,J,Ee){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:J.toInternal(le,Ee)}ye.from=Te})(Pi||(e.TerminalQuickFix=Pi={}));var Si;(function(ye){function Te(le){return{kind:pi.to(le.kind)}}ye.to=Te})(Si||(e.PartialAcceptInfo=Si={}));var pi;(function(ye){function Te(le){switch(le){case r.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}ye.to=Te})(pi||(e.PartialAcceptTriggerKind=pi={}));var Ri;(function(ye){function Te(le,J){return{id:J,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}ye.from=Te})(Ri||(e.DebugTreeItem=Ri={}));var Wt;(function(ye){function Te(le){return{name:le.name,description:le.description,parametersSchema:le.parametersSchema}}ye.to=Te})(Wt||(e.LanguageModelToolDescription=Wt={}))}),define(Ce[274],Ie([1,0,5,17,8,39]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;let A=class{constructor(p,a){this.a=p.getProxy(b.$uN.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>a.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,a,R){const y=new O.$Tw(k.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,R?.isRefactoring??!1)}};e.$voc=A,e.$voc=A=Qe([Ve(0,S.$1P)],A)}),define(Ce[275],Ie([1,0,18,11,48,6,40,4,70,15,2,19,5,8,7,236,25]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,E=qe(E),f=qe(f);class o{constructor(t,c,l,m,d){this.j=t,this.k=c,this.l=l,this.m=m,this.n=d,this.b=p.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let c=function(m){if(t.c){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,m),d}};const t=this;this.b.reset();const l=(m,d)=>{if(typeof this.d>"u"&&"content"in m&&(this.d=this.b.elapsed()),d){const $=this.l.$handleProgressChunk(this.k.requestId,m),I={report:D=>{$?.then(v=>{v&&(f.$YN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(D),v):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(D),v))})}};Promise.all([$,d?.(I)]).then(([D,v])=>{D!==void 0&&v!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(v),D)})}else this.l.$handleProgressChunk(this.k.requestId,m)};this.g={markdown(m){c(this.markdown);const d=new f.$tP(m),$=E.ChatResponseMarkdownPart.from(d);return l($),this},markdownWithVulnerabilities(m,d){c(this.markdown),d&&(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new f.$uP(m,d),I=E.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return l(I),this},filetree(m,d){c(this.filetree);const $=new f.$xP(m,d),I=E.ChatResponseFilesPart.from($);return l(I),this},anchor(m,d){c(this.anchor);const $=new f.$yP(m,d),I=E.ChatResponseAnchorPart.from($);return l(I),this},button(m){c(this.anchor);const d=new f.$CP(m),$=E.ChatResponseCommandButtonPart.from(d,t.m,t.n);return l($),this},progress(m,d){c(this.progress);const $=new f.$AP(m,d),I=d?E.ChatTask.from($):E.ChatResponseProgressPart.from($);return l(I,d),this},warning(m){c(this.progress),(0,s.$7G)(t.j,"chatParticipantAdditions");const d=new f.$BP(m),$=E.ChatResponseWarningPart.from(d);return l($),this},reference(m,d){if(c(this.reference),"variableName"in m&&(0,s.$7G)(t.j,"chatParticipantAdditions"),"variableName"in m&&!m.value){const $=t.k.variables.variables.find(I=>I.name===m.variableName);if($){let I;if($.references?.length)I=$.references.map(D=>({kind:"reference",reference:{variableName:m.variableName,value:D.reference}}));else{const D=new f.$DP(m,d);I=[E.ChatResponseReferencePart.from(D)]}return I.forEach(D=>l(D)),this}}else{const $=new f.$DP(m,d),I=E.ChatResponseReferencePart.from($);l(I)}return this},textEdit(m,d){c(this.textEdit),(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new f.$EP(m,d),I=E.ChatResponseTextEditPart.from($);return l(I),this},detectedParticipant(m,d){c(this.detectedParticipant),(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new f.$vP(m,d),I=E.ChatResponseDetectedParticipantPart.from($);return l(I),this},confirmation(m,d,$){c(this.confirmation),(0,s.$7G)(t.j,"chatParticipantAdditions");const I=new f.$wP(m,d,$),D=E.ChatResponseConfirmationPart.from(I);return l(D),this},push(m){if(c(this.push),(m instanceof f.$EP||m instanceof f.$uP||m instanceof f.$vP||m instanceof f.$BP||m instanceof f.$wP)&&(0,s.$7G)(t.j,"chatParticipantAdditions"),m instanceof f.$DP)this.reference(m.value,m.iconPath);else{const d=E.ChatResponsePart.from(m,t.m,t.n);l(d)}return this}}}return this.g}}class h extends T.$Wc{static{this.b=0}constructor(t,c,l,m){super(),this.n=c,this.s=l,this.t=m,this.c=new Map,this.j=this.B(new T.$6c),this.m=this.B(new T.$6c),this.g=t.getProxy(u.$uN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,c,l){const m=h.b++,d=new i(t,this.t,c,this.g,m,l);return this.c.set(m,d),d.isAgentEnabled()&&this.g.$registerAgent(m,t.identifier,c,{},void 0),d.apiAgent}createDynamicChatAgent(t,c,l,m){const d=h.b++,$=new i(t,this.t,c,this.g,d,m);return this.c.set(d,$),this.g.$registerAgent(d,t.identifier,c,{isSticky:!0},l),$.apiAgent}async $invokeAgent(t,c,l,m){const d=this.c.get(t);if(!d)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(c.sessionId);$||($=new T.$Vc,this.j.set(c.sessionId,$));const I=new o(d.extension,c,this.g,this.s.converter,$);try{const D=await this.u(c.agentId,l),v=d.invoke(E.ChatAgentRequest.to(c),{history:D},I.apiObject,m);return await(0,S.$th)(Promise.resolve(v).then(C=>{if(C?.metadata)try{JSON.stringify(C.metadata)}catch(g){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.n.error(`[${d.extension.identifier.value}] [@${d.id}] ${w}`,d.extension),{errorDetails:{message:w},timings:I.timings}}let P;return C?.errorDetails&&(P={...C.errorDetails,responseIsIncomplete:!0}),P?.responseIsRedacted&&(0,s.$7G)(d.extension,"chatParticipantPrivate"),{errorDetails:P,timings:I.timings,metadata:C?.metadata}}),m)}catch(D){return this.n.error(D,d.extension),D instanceof f.$OP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,k.$qj)(D),responseIsIncomplete:!0}}}finally{I.close()}}async u(t,c){const l=[];for(const m of c.history){const d=E.ChatAgentResult.to(m.result),$=t===m.request.agentId?d:{...d,metadata:void 0};l.push(new f.$FP(m.request.message,m.request.command,m.request.variables.variables.map(E.ChatAgentValueReference.to),m.request.agentId));const I=(0,b.$Jb)(m.response.map(D=>E.ChatResponsePart.toContent(D,this.s.converter)));l.push(new f.$GP(I,$,m.request.agentId,m.request.command))}return l}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,c,l,m,d){const $=this.c.get(c);if(!$)return Promise.resolve([]);const I=await this.u($.id,m),D=E.ChatAgentResult.to(l);return(await $.provideFollowups(D,{history:I},d)).filter(v=>{const C=!v.participant||A.Iterable.some(this.c.values(),P=>P.id===v.participant&&y.$qn.equals(P.extension.identifier,$.extension.identifier));return C||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),C}).map(v=>E.ChatFollowup.from(v,t))}$acceptFeedback(t,c,l,m){const d=this.c.get(t);if(!d)return;const $=E.ChatAgentResult.to(c);let I;switch(l){case n.ChatAgentVoteDirection.Down:I=f.ChatResultFeedbackKind.Unhelpful;break;case n.ChatAgentVoteDirection.Up:I=f.ChatResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(m?{result:$,kind:I,reportIssue:m}:{result:$,kind:I}))}$acceptAction(t,c,l){const m=this.c.get(t);if(!m||l.action.kind==="vote")return;const d=E.ChatAgentUserActionEvent.to(c,l,this.s.converter);d&&m.acceptAction(Object.freeze(d))}async $invokeCompletionProvider(t,c,l){const m=this.c.get(t);if(!m)return[];let d=this.m.get(t);return d?d.clear():(d=new T.$Vc,this.m.set(t,d)),(await m.invokeCompletionProvider(c,l)).map(I=>E.ChatAgentCompletionItem.from(I,this.s.converter,d))}async $provideWelcomeMessage(t,c,l){const m=this.c.get(t);if(m)return await m.provideWelcomeMessage(E.ChatLocation.to(c),l)}async $provideSampleQuestions(t,c,l){const m=this.c.get(t);if(m)return(await m.provideSampleQuestions(E.ChatLocation.to(c),l)).map(d=>E.ChatFollowup.from(d,void 0))}}e.$woc=h;class i{constructor(t,c,l,m,d,$){this.extension=t,this.w=c,this.id=l,this.x=m,this.y=d,this.z=$,this.m=new O.$me,this.n=new O.$me}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,c){return this.q?await this.q.provider.provideCompletionItems(t,c)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,s.$6G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(t,c,l){if(!this.b)return[];const m=await this.b.provideFollowups(t,c,l);return m?m.filter(d=>!(d&&"commandId"in d)).filter(d=>!(d&&"message"in d)):[]}async provideWelcomeMessage(t,c){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(t,c);return l?l.map(m=>typeof m=="string"?m:E.MarkdownString.from(m)):[]}async provideSampleQuestions(t,c){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(t,c);return l||[]}get apiAgent(){let t=!1,c=!1;const l=()=>{t||c||(c=!0,queueMicrotask(()=>{m.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof R.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof f.$tO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),c=!1)}))},m=this;return{get id(){return m.id},get iconPath(){return m.c},set iconPath(d){m.c=d,l()},get requestHandler(){return m.z},set requestHandler(d){(0,a.$pg)(typeof d=="function","Invalid request handler"),m.z=d},get followupProvider(){return m.b},set followupProvider(d){m.b=d,l()},get isDefault(){return(0,s.$7G)(m.extension,"defaultChatParticipant"),m.d},set isDefault(d){(0,s.$7G)(m.extension,"defaultChatParticipant"),m.d=d,l()},get helpTextPrefix(){return(0,s.$7G)(m.extension,"defaultChatParticipant"),m.g},set helpTextPrefix(d){(0,s.$7G)(m.extension,"defaultChatParticipant"),m.g=d,l()},get helpTextVariablesPrefix(){return(0,s.$7G)(m.extension,"defaultChatParticipant"),m.j},set helpTextVariablesPrefix(d){(0,s.$7G)(m.extension,"defaultChatParticipant"),m.j=d,l()},get helpTextPostfix(){return(0,s.$7G)(m.extension,"defaultChatParticipant"),m.k},set helpTextPostfix(d){(0,s.$7G)(m.extension,"defaultChatParticipant"),m.k=d,l()},get isSecondary(){return(0,s.$7G)(m.extension,"defaultChatParticipant"),m.l},set isSecondary(d){(0,s.$7G)(m.extension,"defaultChatParticipant"),m.l=d,l()},get supportIssueReporting(){return(0,s.$7G)(m.extension,"chatParticipantPrivate"),m.o},set supportIssueReporting(d){(0,s.$7G)(m.extension,"chatParticipantPrivate"),m.o=d,l()},get onDidReceiveFeedback(){return m.m.event},set participantVariableProvider(d){if((0,s.$7G)(m.extension,"chatParticipantAdditions"),m.q=d,d){if(!d.triggerCharacters.length)throw new Error("triggerCharacters are required");m.x.$registerAgentCompletionsProvider(m.y,m.id,d.triggerCharacters)}else m.x.$unregisterAgentCompletionsProvider(m.y,m.id)},get participantVariableProvider(){return(0,s.$7G)(m.extension,"chatParticipantAdditions"),m.q},set welcomeMessageProvider(d){(0,s.$7G)(m.extension,"defaultChatParticipant"),m.s=d,l()},get welcomeMessageProvider(){return(0,s.$7G)(m.extension,"defaultChatParticipant"),m.s},onDidPerformAction:(0,s.$6G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(d){m.t=d,l()},get requester(){return m.t},set supportsSlowReferences(d){(0,s.$7G)(m.extension,"chatParticipantPrivate"),m.u=d,l()},get supportsSlowReferences(){return(0,s.$7G)(m.extension,"chatParticipantPrivate"),m.u},dispose(){t=!0,m.b=void 0,m.m.dispose(),m.x.$unregisterAgent(m.y)}}}invoke(t,c,l,m){return this.z(t,c,l,m)}}}),define(Ce[276],Ie([1,0,14,4,35,5,8,7,25]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0,A=qe(A),T=qe(T);class a{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(O.$uN.MainThreadChatVariables)}async $resolveVariable(u,E,f,n){const s=this.b.get(u);if(s)try{if(s.resolver.resolve2){(0,p.$7G)(s.extension,"chatParticipantAdditions");const o=new R(E,this.c),h=await s.resolver.resolve2(s.data.name,{prompt:f},o.apiObject,n);if(h&&h[0])return h[0].value}else{const o=await s.resolver.resolve(s.data.name,{prompt:f},n);if(o&&o[0])return o[0].value}}catch(o){(0,b.$4)(o)}}registerVariableResolver(u,E,f,n,s,o,h,i,r){const t=a.a++,c=r?k.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:u,data:{id:E,name:f,description:n,modelDescription:s,icon:c},resolver:h}),this.c.$registerVariable(t,{id:E,name:f,description:n,modelDescription:s,isSlow:o,fullName:i,icon:c}),(0,S.$Uc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$xoc=a;class R{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(n){if(u.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,n),s}};const u=this,f=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){E(this.progress);const s=new T.$zP(n),o=A.ChatResponseProgressPart.from(s);return f(o),this},reference(n){E(this.reference);const s=new T.$DP(n),o=A.ChatResponseReferencePart.from(s);return f(o),this},push(n){return E(this.push),n instanceof T.$DP?f(A.ChatResponseReferencePart.from(n)):n instanceof T.$zP&&f(A.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Ce[277],Ie([1,0,11,72,6,4,38,2,94,19,8,7,5,25]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=f,p=qe(p),R=qe(R),y=qe(y);function f(n,s,o){const h=n.getProxy(u.$uN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$sn,s.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===A.MarshalledId.CommentController){const C=this.b.get(v.handle);return C?C.value:v}else if(v&&v.$mid===A.MarshalledId.CommentThread){const C=v,P=this.b.get(C.commentControlHandle);if(!P)return C;const g=P.getCommentThread(C.commentThreadHandle);return g?g.value:C}else if(v&&(v.$mid===A.MarshalledId.CommentThreadReply||v.$mid===A.MarshalledId.CommentThreadInstance)){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const P=C.getCommentThread(v.thread.commentThreadHandle);return P?v.$mid===A.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:v.text}:v}else if(v&&v.$mid===A.MarshalledId.CommentNode){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const P=C.getCommentThread(v.thread.commentThreadHandle);if(!P)return v;const g=v.commentUniqueId,w=P.getCommentByUniqueId(g);return w||v}else if(v&&v.$mid===A.MarshalledId.CommentThreadNode){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const P=C.getCommentThread(v.thread.commentThreadHandle);if(!P)return v;const g=v.text,w=v.commentUniqueId,M=P.getCommentByUniqueId(w);return M?(typeof M.body=="string"?M.body=g:M.body=new y.$YN(g),M):v}return v}})}createCommentController(v,C,P){const g=i.a++,w=new t(v,g,C,P);this.b.set(w.handle,w);const M=this.c.get(v.identifier)||[];return M.push(w),this.c.set(v.identifier,M),w.value}async $createCommentThreadTemplate(v,C,P,g){const w=this.b.get(v);w&&w.$createCommentThreadTemplate(C,P,g)}async $setActiveComment(v,C){const P=this.b.get(v);P&&P.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(v,C,P){const g=this.b.get(v);g&&g.$updateCommentThreadTemplate(C,P)}$deleteCommentThread(v,C){this.b.get(v)?.$deleteCommentThread(C)}async $provideCommentingRanges(v,C,P){const g=this.b.get(v);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(T.URI.revive(C));return(0,b.$xh)(async()=>{const M=await g.commentingRangeProvider.provideCommentingRanges(w.document,P);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(L=>R.Range.from(L)),fileComments:M.fileComments}),N})}$toggleReaction(v,C,P,g,w){const M=this.b.get(v);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,b.$xh)(()=>{const N=M.getCommentThread(C);if(N){const L=N.getCommentByUniqueId(g.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,m(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,E.$7G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,C,P,g,w,M,N,L,G){this.m=C,this.n=P,this.o=g,this.p=w,this.q=M,this.extensionDescription=N,this.r=L,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Xc,this.l.value=new O.$Vc,this.n===void 0&&(this.n=`${v}.${this.handle}`),h.$createCommentThread(C,this.handle,this.n,this.o,R.Range.from(this.p),N.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this.i.push({dispose:()=>{h.$deleteCommentThread(C,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(F){B.range=F},get comments(){return B.comments},set comments(F){B.comments=F},get collapsibleState(){return B.collapsibleState},set collapsibleState(F){B.collapsibleState=F},get canReply(){return B.canReply},set canReply(F){B.canReply=F},get contextValue(){return B.contextValue},set contextValue(F){B.contextValue=F},get label(){return B.label},set label(F){B.label=F},get state(){return B.state},set state(F){B.state=F},reveal:F=>B.reveal(F),dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Vc);const v=P=>Object.prototype.hasOwnProperty.call(this.b,P),C={};v("range")&&(C.range=R.Range.from(this.p)),v("label")&&(C.label=this.label),v("contextValue")&&(C.contextValue=this.contextValue??null),v("comments")&&(C.comments=this.q.map(P=>c(this,P,this.k,this.extensionDescription))),v("collapsibleState")&&(C.collapseState=d(this.g)),v("canReply")&&(C.canReply=this.canReply),v("state")&&(C.state=$(this.h)),v("applicability")&&(C.applicability=I(this.h)),v("isTemplate")&&(C.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(v){for(const C of this.k){const P=C[0],g=C[1];if(v===g)return P}}async reveal(v){return(0,E.$7G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...v})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Qe([(0,S.$$h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,E.$7G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$7G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$7G)(this.h,"activeComment"),this.f}constructor(v,C,P,g){this.h=v,this.i=C,this.j=P,this.k=g,this.a=new Map,h.$registerCommentController(this.handle,P,g,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(M){w.options=M},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(M){w.commentingRangeProvider=M},get reactionHandler(){return w.reactionHandler},set reactionHandler(M){w.reactionHandler=M},get activeCommentThread(){return w.activeCommentThread},createCommentThread(M,N,L){return w.createCommentThread(M,N,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(v,C,P){C===void 0&&(0,E.$7G)(this.h,"fileComments");const g=new r(this.id,this.handle,void 0,v,C,P,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const C=this.a.get(v.commentThreadHandle);C&&(this.e=v.uniqueIdInThread?C.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(v,C,P){const g=new r(this.id,this.handle,void 0,T.URI.revive(v),R.Range.to(C),[],this.h,!0,P);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(v,C){const P=this.a.get(v);P&&(P.range=R.Range.to(C))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function c(D,v,C,P){let g=C.get(v);return g||(g=++D.commentHandle,C.set(v,g)),v.state!==void 0&&(0,E.$7G)(P,"commentsDraftState"),v.reactions?.some(w=>w.reactors!==void 0)&&(0,E.$7G)(P,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:g,body:typeof v.body=="string"?v.body:R.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(w=>l(w)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function l(D){return{label:D.label,iconPath:D.iconPath?R.$ZP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(v=>v.name):D.reactors}}function m(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(v=>({name:v}))}}function d(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(D){let v;if(typeof D=="object"?v=D.resolved:v=D,v!==void 0)switch(v){case y.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function I(D){let v;if(typeof D=="object"&&(v=D.applicability),v!==void 0)switch(v){case y.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ce[278],Ie([1,0,22,76,4,16,24,2,8,68,80,5,7]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0,p=qe(p),y=qe(y),u=qe(u);class E{constructor(l,m){this.document=l,this.b=m,this.a=1,this.c=new R.$hoc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,m){await this.f(l).undo(),m||this.disposeBackup()}async redo(l,m){await this.f(l).redo(),m||this.disposeBackup()}disposeEdits(l){for(const m of l)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,A.$gh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const m=this.c.get(l,0);if(!m)throw new Error("No edit found");return m}}class f{constructor(){this.a=new Map}get(l,m){return this.a.get(this.b(l,m))}add(l,m,d){const $=this.b(l,m.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${l} resource:${m.uri}`);const I=new E(m,d);return this.a.set($,I),I}delete(l,m){const d=this.b(l,m.uri);this.a.delete(d)}b(l,m){return`${l}@@@${m}`}}var n;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(n||(n={}));class s{constructor(){this.a=new Map}addTextProvider(l,m,d){return this.b(l,{type:n.Text,extension:m,provider:d})}addCustomProvider(l,m,d){return this.b(l,{type:n.Custom,extension:m,provider:d})}get(l){return this.a.get(l)}b(l,m){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,m),new u.$wN(()=>this.a.delete(l))}}class o{constructor(l,m,d,$,I){this.d=m,this.f=d,this.g=$,this.h=I,this.b=new s,this.c=new f,this.a=l.getProxy(y.$uN.MainThreadCustomEditors)}registerCustomEditorProvider(l,m,d,$){const I=new k.$Vc;return i(d)?(I.add(this.b.addTextProvider(m,l,d)),this.a.$registerTextEditorProvider((0,a.$Qoc)(l),m,$.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,a.$Ooc)(l))):(I.add(this.b.addCustomProvider(m,l,d)),h(d)&&I.add(d.onDidChangeCustomDocument(D=>{const v=this.i(m,D.document.uri);if(r(D)){const C=v.addEdit(D);this.a.$onDidEdit(D.document.uri,m,C,D.label)}else this.a.$onContentChange(D.document.uri,m)})),this.a.$registerCustomEditorProvider((0,a.$Qoc)(l),m,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,a.$Ooc)(l))),u.$wN.from(I,new u.$wN(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(l,m,d,$,I){const D=this.b.get(m);if(!D)throw new Error(`No provider found for '${m}'`);if(D.type!==n.Custom)throw new Error(`Invalid provide type for '${m}'`);const v=T.URI.revive(l),C=await D.provider.openCustomDocument(v,{backupId:d,untitledDocumentData:$?.buffer},I);let P;return h(D.provider)&&this.f&&(P=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(m,C,P),{editable:h(D.provider)}}async $disposeCustomDocument(l,m){const d=this.b.get(m);if(!d)throw new Error(`No provider found for '${m}'`);if(d.type!==n.Custom)throw new Error(`Invalid provider type for '${m}'`);const $=T.URI.revive(l),{document:I}=this.i(m,$);this.c.delete(m,I),I.dispose()}async $resolveCustomEditor(l,m,d,$,I,D){const v=this.b.get(d);if(!v)throw new Error(`No provider found for '${d}'`);const C=p.ViewColumn.to(I),P=this.g.createNewWebview(m,$.contentOptions,v.extension),g=this.h.createNewWebviewPanel(m,d,$.title,C,$.options,P,$.active),w=T.URI.revive(l);switch(v.type){case n.Custom:{const{document:M}=this.i(d,w);return v.provider.resolveCustomEditor(M,g,D)}case n.Text:{const M=this.d.getDocument(w);return v.provider.resolveCustomTextEditor(M,g,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,m,d){this.i(m,l).disposeEdits(d)}async $onMoveCustomEditor(l,m,d){const $=this.b.get(d);if(!$)throw new Error(`No provider found for '${d}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const I=this.h.getWebviewPanel(l);if(!I)throw new Error("No webview found");const D=T.URI.revive(m),v=this.d.getDocument(D);await $.provider.moveCustomTextEditor(v,I,b.CancellationToken.None)}async $undo(l,m,d,$){return this.i(m,l).undo(d,$)}async $redo(l,m,d,$){return this.i(m,l).redo(d,$)}async $revert(l,m,d){const $=this.i(m,l);await this.j(m).revertCustomDocument($.document,d),$.disposeBackup()}async $onSave(l,m,d){const $=this.i(m,l);await this.j(m).saveCustomDocument($.document,d),$.disposeBackup()}async $onSaveAs(l,m,d,$){const I=this.i(m,l);return this.j(m).saveCustomDocumentAs(I.document,T.URI.revive(d),$)}async $backup(l,m,d){const $=this.i(m,l),D=await this.j(m).backupCustomDocument($.document,{destination:$.getNewBackupUri()},d);return $.updateBackup(D),D.id}i(l,m){const d=this.c.get(l,T.URI.revive(m));if(!d)throw new Error("No custom document found");return d}j(l){const d=this.b.get(l)?.provider;if(!d||!h(d))throw new Error("Custom document is not editable");return d}}e.$Toc=o;function h(c){return!!c.onDidChangeCustomDocument}function i(c){return typeof c.resolveCustomTextEditor=="function"}function r(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function t(c){const l=c.scheme===O.Schemas.file||c.scheme===O.Schemas.untitled?c.fsPath:c.toString();return(0,S.$tj)(l)+""}}),define(Ce[279],Ie([1,0,181,108,2,5,7,8,6,12,29,51]),function(oe,e,b,S,k,O,A,T,p,a,R,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=e.$ooc=void 0,T=qe(T);class E{#e;#t;#i;constructor(s,o,h,i,r,t,c,l){this.d=s,this.e=o,this.f=h,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,h),this.#i=new R.$Cc(m=>t.getComparisonKey(m)),this.#e=c,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let h=[];if(k.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),h=[s]}else if(Array.isArray(s)){h=[];let t;s=[...s].sort(E.k);for(const c of s){const[l,m]=c;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,h.push(l),this.#i.set(l,[])),m)this.#i.get(l)?.push(...m);else{const d=this.#i.get(l);d&&(d.length=0)}}}if(this.#t.fire(h),!this.#e)return;const i=[];let r=0;for(const t of h){let c=[];const l=this.#i.get(t);if(l)if(l.length>this.g){c=[];const m=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const $ of l)if($.severity===m[d]&&c.push({...T.Diagnostic.from($),modelVersionId:this.h(t)})===this.g)break e;c.push({severity:S.MarkerSeverity.Info,message:(0,b.localize)(0,null,l.length-this.g),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=l.map(m=>({...T.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,c]),r+=c.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[h,i]of this)s.call(o,h,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$ooc=E;let f=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(s){const o=new R.$Cc;for(const h of s)o.set(h,h);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,h,i){this.j=o,this.k=h,this.l=i,this.g=new Map,this.h=new p.$qe({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=s.getProxy(O.$uN.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:h,f:i,h:r,j:t,k:c,l}=this,m=new class{$changeMany(I,D){i.$changeMany(I,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,I,D.length===0?"CLEARING":D)}$clear(I){i.$clear(I),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,I)}dispose(){i.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+u.c++,d=o;else if(!h.has(o))d=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+u.c++;while(h.has(d))}return new class extends E{constructor(){super(o,d,u.e,u.d,I=>l.getDocument(I)?.version,c.extUri,m,r),h.set(d,this)}dispose(){super.dispose(),h.delete(d)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,h=[];for(const i of this.g.values())i.forEach((r,t)=>{let c=o.get(r.toString());typeof c>"u"&&(c=h.length,o.set(r.toString(),c),h.push([r,[]])),h[c][1]=h[c][1].concat(...t)});return h}}m(s){let o=[];for(const h of this.g.values())h.has(s)&&(o=o.concat(h.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",h=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,h),this.n=h}for(const[o,h]of s)this.n.set(k.URI.revive(o),h.map(T.Diagnostic.to))}};e.$poc=f,e.$poc=f=u=Qe([Ve(1,a.$_j),Ve(2,y.$noc)],f)}),define(Ce[280],Ie([1,0,2,14,7,8,212,39]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0;class p{constructor(R,y,u,E={timeout:1500,errors:3}){this.c=R,this.d=y,this.f=u,this.g=E,this.a=new A.$7c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(y,u,E)=>{const n={dispose:this.a.push([y,u,R])};return Array.isArray(E)&&E.push(n),n}}async $participateInSave(R,y){const u=b.URI.revive(R);let E=!1;const f=setTimeout(()=>E=!0,this.g.timeout),n=[];try{for(const s of[...this.a]){if(E)break;const o=this.d.getDocument(u),h=await this.h(s,{document:o,reason:O.TextDocumentSaveReason.to(y)});n.push(h)}}finally{clearTimeout(f)}return n}h([R,y,u],E){const f=this.b.get(R);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(u,R,y,E).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const s=this.b.get(R);this.b.set(R,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,y,u,E){const f=[],n=Date.now(),{document:s,reason:o}=E,{version:h}=s,i=Object.freeze({document:s,reason:o,waitUntil(r){if(Object.isFrozen(f))throw(0,S.$0)("waitUntil can not be called async");f.push(Promise.resolve(r))}});try{y.apply(u,[i])}catch(r){return Promise.reject(r)}return Object.freeze(f),new Promise((r,t)=>{const c=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(f).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(c),r(l)}).catch(l=>{clearTimeout(c),t(l)})}).then(r=>{const t={edits:[]};for(const c of r)if(Array.isArray(c)&&c.every(l=>l instanceof k.$DN))for(const{newText:l,newEol:m,range:d}of c)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:d&&O.Range.from(d),text:l,eol:m&&O.EndOfLine.from(m)}});if(t.edits.length!==0)return h===s.version?this.f.$tryApplyWorkspaceEdit(new T.$Tw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Cpc=p}),define(Ce[281],Ie([1,0,6,4,2,5,123,8,15,26,7]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,T=qe(T);class y{constructor(E,f){this.a=new b.$me,this.b=new b.$me,this.c=new b.$me,this.d=new b.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new S.$Vc,this.h=new Map,this.f=E.getProxy(O.$uN.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(n=>{for(const s of n)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const s of n)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const f=this.g.getDocument(E);if(f)return f}getDocument(E){const f=this.getDocumentData(E);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this.g.getDocument(E);if(f)return Promise.resolve(f);let n=this.h.get(E.toString());return n||(n=this.f.$tryOpenDocument(E).then(s=>{this.h.delete(E.toString());const o=k.URI.revive(s);return(0,p.$qg)(this.g.getDocument(o))},s=>(this.h.delete(E.toString()),Promise.reject(s))),this.h.set(E.toString(),n)),n}createDocumentData(E){return this.f.$tryCreateDocument(E).then(f=>k.URI.revive(f))}$acceptModelLanguageChanged(E,f){const n=k.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(f),this.a.fire(s.document)}$acceptModelSaved(E){const f=k.URI.revive(E),n=this.g.getDocument(f);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(E,f){const n=k.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,f,n){const s=k.URI.revive(E),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(n),o.onEvents(f);let h;f.isUndoing?h=R.TextDocumentChangeReason.Undo:f.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this.c.fire((0,a.$eo)({document:o.document,contentChanges:f.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:h}))}setWordDefinitionFor(E,f){(0,A.$3P)(E,f)}}e.$qoc=y}),define(Ce[71],Ie([1,0,282,6,15,2,3,5,17,8,7]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0,a=qe(a),e.$Uoc=(0,A.$Fi)("IExtHostEditorTabs");class y{constructor(s,o,h){this.e=h,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new R.$hP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new R.$iP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new R.$jP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new R.$kP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new R.$lP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new R.$mP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new R.$nP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new R.$oP;case T.TabInputKind.InteractiveEditorInput:return new R.$pP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new R.$qP;case T.TabInputKind.MultiDiffEditorInput:return new R.$rP(this.b.input.diffEditors.map(s=>new R.$iP(O.URI.revive(s.original),O.URI.revive(s.modified))));default:return}}}class u{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const h of s.tabs)h.isActive&&(this.d=h.id),this.c.push(new y(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return a.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(h=>h.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(h=>h.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===T.TabModelOperationKind.TAB_OPEN){const h=new y(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,h),s.tabDto.isActive&&(this.d=h.tabId),h}else if(s.kind===T.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(s.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(s.kind===T.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(s.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,h),h}const o=this.c.find(h=>h.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(s){this.b=new S.$me,this.c=new S.$me,this.e=[],this.a=s.getProxy(T.$uN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(h=>h.apiObject))},get activeTabGroup(){const h=s.d;return(0,k.$qg)(s.e.find(r=>r.groupId===h)?.apiObject)},close:async(h,i)=>{const r=Array.isArray(h)?h:[h];return r.length?f(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(m=>m.groupId)),h=new Set(s.map(m=>m.groupId)),i=(0,b.$L)(o,h),r=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],c=[];this.e=s.map(m=>{const d=new u(m,()=>this.d);return i.added.includes(d.groupId)?t.push(d.apiObject):c.push(d.apiObject),d});const l=(0,k.$qg)(s.find(m=>m.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:r,changed:c}))}$acceptTabGroupUpdate(s){const o=this.e.find(h=>h.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const h=o.acceptTabOperation(s);switch(s.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(s){for(const o of this.e)for(const h of o.tabs)if(h.apiObject===s)return h}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const h=[];for(const i of s){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");h.push(r.tabId)}return this.a.$closeTab(h,o)}async j(s,o){const h=[];for(const i of s){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");h.push(r.groupId)}return this.a.$closeGroup(h,o)}};e.$Voc=E,e.$Voc=E=Qe([Ve(0,p.$1P)],E);function f(n){return n.tabs!==void 0}}),define(Ce[283],Ie([1,0,2,5,30,4,7,8,327,13,28,23,25,60]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,k=qe(k),T=qe(T);class f{constructor(){this.a=[]}add(o){this.b=void 0,this.a.push(o)}delete(o){const h=this.a.indexOf(o);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const o=this.a.sort(),h=[];let i,r,t=p.State.LastKnownState,c=p.State.LastKnownState;for(const l of o){let m=i?(0,a.$If)(i,l):0;for(m===0?r=p.State.Start:r=c;m<l.length;m++)m+1===l.length?(t=c,c=p.State.BeforeColon):c+=1,h.push([r,l.toUpperCase().charCodeAt(m),c]),h.push([r,l.toLowerCase().charCodeAt(m),c]),r=c;i=l,c=t}h.push([p.State.BeforeColon,R.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,R.CharCode.Slash,p.State.End]),this.b=new p.$p4(h)}}provideDocumentLinks(o){this.c();const h=[],i=p.$q4.computeLinks({getLineContent(r){return o.lineAt(r-1).text},getLineCount(){return o.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&h.push(t)}return h}}class n{constructor(o,h){this.i=h,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=o.getProxy(S.$uN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(o,h,i,r={}){if(n.j(i),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(o,"*",this.b));const t=this.h++;this.b.add(h),this.d.add(h),this.c.set(t,i);let c=k.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(c+=k.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(c+=k.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(c+=k.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$7G)(o,"fsChunks"),c+=k.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;r.isReadonly&&(0,E.$5k)(r.isReadonly)&&r.isReadonly.value!==""&&(l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,h,c,l).catch(d=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${h}`),console.error(d)});const m=i.onDidChangeFile(d=>{const $=[];for(const I of d){const{uri:D,type:v}=I;if(D.scheme!==h)continue;let C;switch(v){case A.FileChangeType.Changed:C=k.FileChangeType.UPDATED;break;case A.FileChangeType.Created:C=k.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:C=k.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:D,type:C})}this.a.$onFileSystemChange(t,$)});return(0,O.$Uc)(()=>{m.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static k(o){const{type:h,ctime:i,mtime:r,size:t,permissions:c}=o;return{type:h,ctime:i,mtime:r,size:t,permissions:c}}$stat(o,h){return Promise.resolve(this.l(o).stat(b.URI.revive(h))).then(i=>n.k(i))}$readdir(o,h){return Promise.resolve(this.l(o).readDirectory(b.URI.revive(h)))}$readFile(o,h){return Promise.resolve(this.l(o).readFile(b.URI.revive(h))).then(i=>y.$Oe.wrap(i))}$writeFile(o,h,i,r){return Promise.resolve(this.l(o).writeFile(b.URI.revive(h),i.buffer,r))}$delete(o,h,i){return Promise.resolve(this.l(o).delete(b.URI.revive(h),i))}$rename(o,h,i,r){return Promise.resolve(this.l(o).rename(b.URI.revive(h),b.URI.revive(i),r))}$copy(o,h,i,r){const t=this.l(o);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(b.URI.revive(h),b.URI.revive(i),r))}$mkdir(o,h){return Promise.resolve(this.l(o).createDirectory(b.URI.revive(h)))}$watch(o,h,i,r){const t=this.l(o).watch(b.URI.revive(i),r);this.f.set(h,t)}$unwatch(o,h){const i=this.f.get(h);i&&(i.dispose(),this.f.delete(h))}$open(o,h,i){const r=this.l(o);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(b.URI.revive(h),i))}$close(o,h){const i=this.l(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(h))}$read(o,h,i,r){const t=this.l(o);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$Oe.alloc(r);return Promise.resolve(t.read(h,i,c.buffer,0,r)).then(l=>c.slice(0,l))}$write(o,h,i,r){const t=this.l(o);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(h,i,r.buffer,0,r.byteLength))}l(o){const h=this.c.get(o);if(!h){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return h}}e.$Fpc=n}),define(Ce[284],Ie([1,0,6,41,2,5,8,7,30,47]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0,A=qe(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(f,n,s,o,h,i){this.a=Math.random(),this.b=new b.$me,this.c=new b.$me,this.d=new b.$me,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,S.$zk)(h),t=typeof h=="string",c=i?.correlate,l=o(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(c&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const d of m.created){const $=k.URI.revive(d);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.b.fire($)}if(!i?.ignoreChangeEvents)for(const d of m.changed){const $=k.URI.revive(d);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.c.fire($)}if(!i?.ignoreDeleteEvents)for(const d of m.deleted){const $=k.URI.revive(d);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=T.$wN.from(this.i(f,s,h,i,i?.correlate),this.b,this.c,this.d,l)}i(f,n,s,o,h){const i=T.$wN.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const r=f.getProxy(O.$uN.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(S.$vk)||s.pattern.includes(S.$wk))&&(t=!0);let c;return h&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(c=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,o?.ignoreChangeEvents&&(c&=~p.FileChangeFilter.UPDATED),o?.ignoreCreateEvents&&(c&=~p.FileChangeFilter.ADDED),o?.ignoreDeleteEvents&&(c&=~p.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,s.baseUri,{recursive:t,excludes:o?.excludes??[],filter:c},!!h),T.$wN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(f){this.a=f,this.session=this.a.session,this.b=new a.$X(()=>this.a.created.map(k.URI.revive)),this.c=new a.$X(()=>this.a.changed.map(k.URI.revive)),this.d=new a.$X(()=>this.a.deleted.map(k.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(f,n,s){this.j=f,this.k=n,this.l=s,this.a=new b.$me,this.b=new b.$me,this.c=new b.$me,this.d=new b.$me,this.g=new b.$oe,this.h=new b.$oe,this.i=new b.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(f,n,s,o){return new R(this.j,f,n,this.a.event,A.GlobPattern.from(s),o)}$onFileEvent(f){this.a.fire(new y(f))}$onDidRunFileOperation(f,n){switch(f){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(s=>({oldUri:k.URI.revive(s.source),newUri:k.URI.revive(s.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(s=>k.URI.revive(s.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(s=>k.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(f){return this.m(f,this.g)}getOnWillCreateFileEvent(f){return this.m(f,this.h)}getOnWillDeleteFileEvent(f){return this.m(f,this.i)}m(f,n){return(s,o,h)=>{const i=function(t){s.call(o,t)};return i.extension=f,n.event(i,void 0,h)}}async $onWillRunFileOperation(f,n,s,o){switch(f){case p.FileOperation.MOVE:return await this.n(this.g,{files:n.map(h=>({oldUri:k.URI.revive(h.source),newUri:k.URI.revive(h.target)}))},s,o);case p.FileOperation.DELETE:return await this.n(this.i,{files:n.map(h=>k.URI.revive(h.target))},s,o);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:n.map(h=>k.URI.revive(h.target))},s,o)}}async n(f,n,s,o){const h=new Set,i=[];if(await f.fireAsync(n,o,async(t,c)=>{const l=Date.now(),m=await Promise.resolve(t);m instanceof T.$GN&&(i.push([c.extension,m]),h.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-l>s&&this.k.warn("SLOW file-participant",c.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:c}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(c)}return{edit:r,extensionNames:Array.from(h)}}}e.$Gpc=u}),define(Ce[285],Ie([1,0,18,11,22,14,97,4,26,70,13,15,2,33,328,94,104,183,19,8,7,25,80,5]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0,n=qe(n),i=qe(i),l=qe(l);class m{constructor(j,U){this.d=j,this.e=U}async provideDocumentSymbols(j,U){const K=this.d.getDocument(j),H=await this.e.provideDocumentSymbols(K,U);if(!(0,b.$Mb)(H))return H[0]instanceof r.$QN?H.map(i.DocumentSymbol.from):m.f(H)}static f(j){j=j.slice(0).sort((H,ie)=>{let fe=H.location.range.start.compareTo(ie.location.range.start);return fe===0&&(fe=ie.location.range.end.compareTo(H.location.range.end)),fe});const U=[],K=[];for(const H of j){const ie={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ie),U.push(ie);break}const fe=K[K.length-1];if(E.$Lt.containsRange(fe.range,ie.range)&&!E.$Lt.equalsRange(fe.range,ie.range)){fe.children?.push(ie),K.push(ie);break}K.pop()}}return U}}class d{constructor(j,U,K,H,ie,fe){this.f=j,this.g=U,this.h=K,this.j=H,this.k=ie,this.l=fe,this.d=new c.$hoc("CodeLens"),this.e=new Map}async provideCodeLenses(j,U){const K=this.f.getDocument(j),H=await this.h.provideCodeLenses(K,U);if(!H||U.isCancellationRequested)return;const ie=this.d.add(H),fe=new T.$Vc;this.e.set(ie,fe);const Re={cacheId:ie,lenses:[]};for(let Ue=0;Ue<H.length;Ue++)Re.lenses.push({cacheId:[ie,Ue],range:i.Range.from(H[Ue].range),command:this.g.toInternal(H[Ue].command,fe)});return Re}async resolveCodeLens(j,U){const K=j.cacheId&&this.d.get(...j.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,U),H||(H=K),U.isCancellationRequested)return;const ie=j.cacheId&&this.e.get(j.cacheId[0]);if(ie){if(!H.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return j.command=this.g.toInternal(H.command,ie),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function $(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class I{constructor(j,U){this.d=j,this.e=U}async provideDefinition(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideDefinition(H,ie,K);return $(fe)}}class D{constructor(j,U){this.d=j,this.e=U}async provideDeclaration(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideDeclaration(H,ie,K);return $(fe)}}class v{constructor(j,U){this.d=j,this.e=U}async provideImplementation(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideImplementation(H,ie,K);return $(fe)}}class C{constructor(j,U){this.d=j,this.e=U}async provideTypeDefinition(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideTypeDefinition(H,ie,K);return $(fe)}}class P{static{this.f=10}constructor(j,U){this.g=j,this.h=U,this.d=0,this.e=new Map}async provideHover(j,U,K,H){const ie=this.g.getDocument(j),fe=i.Position.to(U);let Re;if(K&&K.verbosityRequest){const tt=K.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Re=await this.h.provideHover(ie,fe,H,et)}else Re=await this.h.provideHover(ie,fe,H);if(!Re||(0,b.$Mb)(Re.contents))return;Re.range||(Re.range=ie.getWordRangeAtPosition(fe)),Re.range||(Re.range=new r.$yN(fe,fe));const Ue=i.Hover.from(Re),Ke=this.d;if(this.e.size===P.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ke,Re),this.d+=1,{...Ue,id:Ke}}releaseHover(j){this.e.delete(j)}}class g{constructor(j,U){this.d=j,this.e=U}async provideEvaluatableExpression(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideEvaluatableExpression(H,ie,K);if(fe)return i.EvaluatableExpression.from(fe)}}class w{constructor(j,U){this.d=j,this.e=U}async provideInlineValues(j,U,K,H){const ie=this.d.getDocument(j),fe=await this.e.provideInlineValues(ie,i.Range.to(U),i.InlineValueContext.to(K),H);if(Array.isArray(fe))return fe.map(Re=>i.InlineValue.from(Re))}}class M{constructor(j,U){this.d=j,this.e=U}async provideDocumentHighlights(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideDocumentHighlights(H,ie,K);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class N{constructor(j,U){this.d=j,this.e=U}async provideMultiDocumentHighlights(j,U,K,H){const ie=this.d.getDocument(j),fe=K.map(Ke=>this.d.getDocument(Ke)),Re=i.Position.to(U),Ue=await this.e.provideMultiDocumentHighlights(ie,Re,fe,H);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class L{constructor(j,U){this.d=j,this.e=U}async provideLinkedEditingRanges(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideLinkedEditingRanges(H,ie,K);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,b.$Jb)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class G{constructor(j,U){this.d=j,this.e=U}async provideReferences(j,U,K,H){const ie=this.d.getDocument(j),fe=i.Position.to(U),Re=await this.e.provideReferences(ie,fe,K,H);if(Array.isArray(Re))return Re.map(i.location.from)}}class B{static{this.d=1e3}constructor(j,U,K,H,ie,fe,Re){this.g=j,this.h=U,this.j=K,this.k=H,this.l=ie,this.m=fe,this.n=Re,this.e=new c.$hoc("CodeAction"),this.f=new Map}async provideCodeActions(j,U,K,H){const ie=this.g.getDocument(j),fe=f.$Nt.isISelection(U)?i.Selection.to(U):i.Range.to(U),Re=[];for(const et of this.j.getDiagnostics(j))if(fe.intersection(et.range)&&Re.push(et)>B.d)break;const Ue={diagnostics:Re,only:K.only?new r.$SN(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ie,fe,Ue,H);if(!(0,b.$Nb)(Ke)||H.isCancellationRequested)return;const _e=this.e.add(Ke),tt=new T.$Vc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Ke.length;et++){const rt=Ke[et];if(rt)if(B.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$6G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$6G)(this.m,"codeActionRanges")?(0,b.$Jb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(j,U){const[K,H]=j,ie=this.e.get(K,H);if(!ie||B.o(ie))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ie,U)??ie;let Re;fe.edit&&(Re=i.WorkspaceEdit.from(fe.edit,void 0));let Ue;if(fe.command){const Ke=this.f.get(K);Ke&&(Ue=this.h.toInternal(fe.command,Ke))}return{edit:Re,command:Ue}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class F{constructor(j,U,K,H,ie){this.e=j,this.f=U,this.g=K,this.h=H,this.j=ie,this.d=new c.$hoc("DocumentPasteEdit")}async prepareDocumentPaste(j,U,K,H){if(!this.g.prepareDocumentPaste)return;const ie=this.f.getDocument(j),fe=U.map(Ke=>i.Range.to(Ke)),Re=i.DataTransfer.toDataTransfer(K,()=>{throw new O.$ab});if(await this.g.prepareDocumentPaste(ie,fe,Re,H),H.isCancellationRequested)return;const Ue=Array.from(Re).filter(([,Ke])=>!(Ke instanceof r.$mO));return i.DataTransfer.from(Ue)}async providePasteEdits(j,U,K,H,ie,fe){if(!this.g.provideDocumentPasteEdits)return[];const Re=this.f.getDocument(U),Ue=K.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolvePasteFileData(this.h,j,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Re,Ue,Ke,{only:ie.only?new r.$rO(ie.only):void 0,triggerKind:ie.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,U){const[K,H]=j,ie=this.d.get(K,H);if(!ie||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ie,U)??ie;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class V{constructor(j,U){this.d=j,this.e=U}async provideDocumentFormattingEdits(j,U,K){const H=this.d.getDocument(j),ie=await this.e.provideDocumentFormattingEdits(H,U,K);if(Array.isArray(ie))return ie.map(i.TextEdit.from)}}class ae{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeFormattingEdits(j,U,K,H){const ie=this.d.getDocument(j),fe=i.Range.to(U),Re=await this.e.provideDocumentRangeFormattingEdits(ie,fe,K,H);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,U,K,H){(0,y.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ie=this.d.getDocument(j),fe=U.map(i.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ie,fe,K,H);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}}class $e{constructor(j,U){this.d=j,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,U,K,H,ie){const fe=this.d.getDocument(j),Re=i.Position.to(U),Ue=await this.e.provideOnTypeFormattingEdits(fe,Re,K,H,ie);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class _{constructor(j,U){this.e=j,this.f=U,this.d=new c.$hoc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,U){const K=await this.e.provideWorkspaceSymbols(j,U);if(!(0,b.$Nb)(K))return{symbols:[]};const H=this.d.add(K),ie={cacheId:H,symbols:[]};for(let fe=0;fe<K.length;fe++){const Re=K[fe];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ie.symbols.push({...i.WorkspaceSymbol.from(Re),cacheId:[H,fe]})}return ie}async resolveWorkspaceSymbol(j,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const K=this.d.get(...j.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,U);return H&&(0,p.$go)(j,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class ge{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,U,K){this.d=j,this.e=U,this.f=K}async provideRenameEdits(j,U,K,H){const ie=this.d.getDocument(j),fe=i.Position.to(U);try{const Re=await this.e.provideRenameEdits(ie,fe,K,H);return Re?i.WorkspaceEdit.from(Re):void 0}catch(Re){const Ue=ge.g(Re);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(j,U,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(j),ie=i.Position.to(U);try{const fe=await this.e.prepareRename(H,ie,K);let Re,Ue;if(r.$yN.isRange(fe)?(Re=fe,Ue=H.getText(fe)):(0,y.$hg)(fe)&&(Re=fe.range,Ue=fe.placeholder),!Re||!Ue)return;if(Re.start.line>ie.line||Re.end.line<ie.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Re),text:Ue}}catch(fe){const Re=ge.g(fe);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(fe)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class se{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(j,U,K){this.e=j,this.f=U,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,U,K,H){const ie=this.e.getDocument(j),fe=i.Range.to(U);try{const Re=se.d[K],Ue=await this.f.provideNewSymbolNames(ie,fe,Re,H);return Ue?Ue.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Re){this.g.error(se.h(Re)??JSON.stringify(Re,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ce{constructor(j,U){this.resultId=j,this.tokens=U}}class we{constructor(j,U){this.f=j,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,U,K){const H=this.f.getDocument(j),ie=U!==0?this.d.get(U):null;let fe=typeof ie?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ie.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ie&&this.d.delete(U),fe?(fe=we.h(fe),this.o(we.n(ie,fe),fe)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return we.j(j)?we.k(j)?j:new r.$RO(new Uint32Array(j.data),j.resultId):we.l(j)?we.m(j)?j:new r.$TO(j.edits.map(U=>new r.$SO(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const U of j.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(j,U){if(!we.j(U)||!j||!j.tokens)return U;const K=j.tokens,H=K.length,ie=U.data,fe=ie.length;let Re=0;const Ue=Math.min(H,fe);for(;Re<Ue&&K[Re]===ie[Re];)Re++;if(Re===H&&Re===fe)return new r.$TO([],U.resultId);let Ke=0;const _e=Ue-Re;for(;Ke<_e&&K[H-Ke-1]===ie[fe-Ke-1];)Ke++;return new r.$TO([{start:Re,deleteCount:H-Re-Ke,data:ie.subarray(Re,fe-Ke)}],U.resultId)}o(j,U){if(we.j(j)){const K=this.e++;return this.d.set(K,new ce(j.resultId,j.data)),(0,s.$Fdb)({id:K,type:"full",data:j.data})}if(we.l(j)){const K=this.e++;return we.j(U)?this.d.set(K,new ce(U.resultId,U.data)):this.d.set(K,new ce(j.resultId)),(0,s.$Fdb)({id:K,type:"delta",deltas:(j.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class re{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeSemanticTokens(j,U,K){const H=this.d.getDocument(j),ie=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(U),K);return ie?this.f(ie):null}f(j){return(0,s.$Fdb)({id:0,type:"full",data:j.data})}}class Pe{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,U,K,H,ie){this.f=j,this.g=U,this.h=K,this.j=H,this.k=ie,this.d=new c.$hoc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,U,K,H){const ie=this.f.getDocument(j),fe=i.Position.to(U),Re=ie.getWordRangeAtPosition(fe)||new r.$yN(fe,fe),Ue=Re.with({end:fe}),Ke=new a.$ge,_e=await this.h.provideCompletionItems(ie,fe,H,i.CompletionContext.to(K));if(!_e||H.isCancellationRequested)return;const tt=Array.isArray(_e)?new r.$6N(_e):_e,nt=Pe.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Vc;this.e.set(nt,et);const rt=[],ft={x:nt,[l.ISuggestResultDtoField.completions]:rt,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Re),insert:i.Range.from(Ue)},[l.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ct=0;ct<tt.items.length;ct++){const st=tt.items[ct],ut=this.l(st,[nt,ct],Ue,Re);rt.push(ut)}return ft}async resolveCompletionItem(j,U){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...j);if(!K)return;const H=this.l(K,j),ie=await this.h.resolveCompletionItem(K,U);if(!ie)return;const fe=this.l(ie,j);return(H[l.ISuggestDataDtoField.insertText]!==fe[l.ISuggestDataDtoField.insertText]||H[l.ISuggestDataDtoField.insertTextRules]!==fe[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H[l.ISuggestDataDtoField.commandIdent]!==fe[l.ISuggestDataDtoField.commandIdent]||H[l.ISuggestDataDtoField.commandId]!==fe[l.ISuggestDataDtoField.commandId]||!(0,p.$ho)(H[l.ISuggestDataDtoField.commandArguments],fe[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,[l.ISuggestDataDtoField.documentation]:fe[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:fe[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:fe[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:fe[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:fe[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:fe[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:fe[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:fe[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U,K,H){const ie=this.e.get(U[0]);if(!ie)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(j.command,ie),Re={x:U,[l.ISuggestDataDtoField.label]:j.label,[l.ISuggestDataDtoField.kind]:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:j.detail,[l.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),[l.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[l.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[l.ISuggestDataDtoField.preselect]:j.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:fe?.$ident,[l.ISuggestDataDtoField.commandId]:fe?.id,[l.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re[l.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Re[l.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof r.$HN&&(Re[l.ISuggestDataDtoField.insertText]=j.insertText.value,Re[l.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return j.textEdit?Ue=j.textEdit.range:j.range&&(Ue=j.range),r.$yN.isRange(Ue)?Re[l.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!K?.isEqual(Ue.inserting)||!H?.isEqual(Ue.replacing))&&(Re[l.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Re}}class Me{async provideInlineCompletions(j,U,K,H){}async provideInlineEdits(j,U,K,H){}disposeCompletions(j){}handleDidShowCompletionItem(j,U,K){}handlePartialAccept(j,U,K,H){}}class Y extends Me{constructor(j,U,K,H){super(),this.f=j,this.g=U,this.h=K,this.j=H,this.d=new ee,this.e=(0,t.$6G)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$6G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,U,K,H){const ie=this.g.getDocument(j),fe=i.Position.to(U),Re=await this.h.provideInlineCompletionItems(ie,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],_e=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Vc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Vc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(j,U,K,H){if(!this.h.provideInlineEdits)return;(0,t.$7G)(this.f,"inlineCompletionsAdditions");const ie=this.g.getDocument(j),fe=i.Range.to(U),Re=await this.h.provideInlineEdits(ie,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind],userPrompt:K.userPrompt},H);if(!Re||H.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],_e=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Vc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Vc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,U,K){const H=this.d.get(j)?.items[U];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(j,U,K,H){const ie=this.d.get(j)?.items[U];ie&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ie,K),this.h.handleDidPartiallyAcceptCompletionItem(ie,i.PartialAcceptInfo.to(H)))}}class q{async provideInlineEdits(j,U,K){const H=this.f.getDocument(j),ie=await this.g.provideInlineEdit(H,{triggerKind:this.e[U.triggerKind]},K);if(!ie||K.isCancellationRequested)return;let fe;const Re=this.d.createReferenceId({dispose(){fe?.dispose()},item:ie});let Ue;ie.accepted&&(fe||(fe=new T.$Vc),Ue=this.h.toInternal(ie.accepted,fe));let Ke;return ie.rejected&&(fe||(fe=new T.$Vc),Ke=this.h.toInternal(ie.rejected,fe)),{pid:Re,text:ie.text,range:i.Range.from(ie.range),accepted:Ue,rejected:Ke}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,U,K,H){this.f=U,this.g=K,this.h=H,this.d=new ee,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class ee{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const U=this.e++;return this.d.set(U,j),U}disposeReferenceId(j){const U=this.d.get(j);return this.d.delete(j),U}get(j){return this.d.get(j)}}class ve{constructor(j,U){this.e=j,this.f=U,this.d=new c.$hoc("SignatureHelp")}async provideSignatureHelp(j,U,K,H){const ie=this.e.getDocument(j),fe=i.Position.to(U),Re=this.g(K),Ue=await this.f.provideSignatureHelp(ie,fe,H,Re);if(Ue){const Ke=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Ke}}}g(j){let U;if(j.activeSignatureHelp){const K=i.SignatureHelp.to(j.activeSignatureHelp),H=this.d.get(j.activeSignatureHelp.id,0);H?(U=H,U.activeSignature=K.activeSignature,U.activeParameter=K.activeParameter):U=K}return{...j,activeSignatureHelp:U}}releaseSignatureHelp(j){this.d.delete(j)}}class ue{constructor(j,U,K,H,ie){this.f=j,this.g=U,this.h=K,this.j=H,this.k=ie,this.d=new c.$hoc("InlayHints"),this.e=new Map}async provideInlayHints(j,U,K){const H=this.f.getDocument(j),ie=i.Range.to(U),fe=await this.h.provideInlayHints(H,ie,K);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`);return}if(K.isCancellationRequested)return;const Re=this.d.add(fe);this.e.set(Re,new T.$Vc);const Ue={hints:[],cacheId:Re};for(let Ke=0;Ke<fe.length;Ke++)this.l(fe[Ke],ie)&&Ue.hints.push(this.m(fe[Ke],[Re,Ke]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`),Ue}async resolveInlayHint(j,U){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...j);if(!K)return;const H=await this.h.resolveInlayHint(K,U);if(H&&this.l(H))return this.m(H,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U){return j.label.length===0||Array.isArray(j.label)&&j.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(U&&!U.contains(j.position))}m(j,U){const K=this.e.get(U[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:U,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")H.label=j.label;else{const ie=[];H.label=ie;for(const fe of j.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.$IN.isLocation(fe.location)&&(Re.location=i.location.from(fe.location)),fe.command&&(Re.command=this.g.toInternal(fe.command,K)),ie.push(Re)}}return H}}class be{constructor(j,U){this.e=j,this.f=U,this.d=new c.$hoc("DocumentLink")}async provideLinks(j,U){const K=this.e.getDocument(j),H=await this.f.provideDocumentLinks(K,U);if(!(!Array.isArray(H)||H.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(be.g).map(i.DocumentLink.from)};{const ie=this.d.add(H),fe={links:[],cacheId:ie};for(let Re=0;Re<H.length;Re++){if(!be.g(H[Re]))continue;const Ue=i.DocumentLink.from(H[Re]);Ue.cacheId=[ie,Re],fe.links.push(Ue)}return fe}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,U){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...j);if(!K)return;const H=await this.f.resolveDocumentLink(K,U);if(!(!H||!be.g(H)))return i.DocumentLink.from(H)}releaseLinks(j){this.d.delete(j)}}class de{constructor(j,U){this.d=j,this.e=U}async provideColors(j,U){const K=this.d.getDocument(j),H=await this.e.provideDocumentColors(K,U);return Array.isArray(H)?H.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(j,U,K){const H=this.d.getDocument(j),ie=i.Range.to(U.range),fe=i.Color.to(U.color),Re=await this.e.provideColorPresentations(fe,{document:H,range:ie},K);if(Array.isArray(Re))return Re.map(i.ColorPresentation.from)}}class X{constructor(j,U){this.d=j,this.e=U}async provideFoldingRanges(j,U,K){const H=this.d.getDocument(j),ie=await this.e.provideFoldingRanges(H,U,K);if(Array.isArray(ie))return ie.map(i.FoldingRange.from)}}class Z{constructor(j,U,K){this.d=j,this.e=U,this.f=K}async provideSelectionRanges(j,U,K){const H=this.d.getDocument(j),ie=U.map(i.Position.to),fe=await this.e.provideSelectionRanges(H,ie,K);if(!(0,b.$Nb)(fe))return[];if(fe.length!==ie.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Ue=0;Ue<ie.length;Ue++){const Ke=[];Re.push(Ke);let _e=ie[Ue],tt=fe[Ue];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Re}}class me{constructor(j,U){this.f=j,this.g=U,this.d=new A.$6P(""),this.e=new Map}async prepareSession(j,U,K){const H=this.f.getDocument(j),ie=i.Position.to(U),fe=await this.g.prepareCallHierarchy(H,ie,K);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideCallsTo(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ie)return ie.map(fe=>({from:this.h(j,fe.from),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}async provideCallsFrom(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ie)return ie.map(fe=>({to:this.h(j,fe.to),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}releaseSession(j){this.e.delete(j)}h(j,U){const K=this.e.get(j),H=i.CallHierarchyItem.from(U,j,K.size.toString(36));return K.set(H._itemId,U),H}j(j,U){return this.e.get(j)?.get(U)}}class pe{constructor(j,U){this.f=j,this.g=U,this.d=new A.$6P(""),this.e=new Map}async prepareSession(j,U,K){const H=this.f.getDocument(j),ie=i.Position.to(U),fe=await this.g.prepareTypeHierarchy(H,ie,K);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideSupertypes(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySupertypes(H,K);if(ie)return ie.map(fe=>this.h(j,fe))}async provideSubtypes(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySubtypes(H,K);if(ie)return ie.map(fe=>this.h(j,fe))}releaseSession(j){this.e.delete(j)}h(j,U){const K=this.e.get(j),H=i.TypeHierarchyItem.from(U,j,K.size.toString(36));return K.set(H._itemId,U),H}j(j,U){return this.e.get(j)?.get(U)}}class Oe{constructor(j,U,K,H,ie){this.e=j,this.f=U,this.g=K,this.h=H,this.j=ie,this.d=new c.$hoc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,U,K,H,ie){const fe=this.f.getDocument(U),Re=i.Position.to(K),Ue=i.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(fe,Re,Ue,ie);if(!Ke)return;const _e=(0,b.$4b)(Ke),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,U){const[K,H]=j,ie=this.d.get(K,H);if(!ie||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ie,U)??ie;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class ze{constructor(j,U){this.d=j,this.e=U}async provideMappedEdits(j,U,K,H){const ie=u.URI.revive(j),fe=this.d.getDocument(ie),Re=K.documents.map(_e=>_e.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),Ue={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(fe,U,Ue,H);return Ke?i.WorkspaceEdit.from(Ke):null}}class ke{constructor(j,U){this.adapter=j,this.extension=U}}class Ae{static{this.d=0}constructor(j,U,K,H,ie,fe,Re,Ue){this.g=U,this.h=K,this.j=H,this.k=ie,this.l=fe,this.m=Re,this.n=Ue,this.f=new Map,this.e=j.getProxy(l.$uN.MainThreadLanguageFeatures)}o(j,U){return i.DocumentSelector.from(j,this.g,U)}p(j){return new r.$wN(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,U,K,H,ie,fe=!1){const Re=this.f.get(j);if(!Re||!(Re.adapter instanceof U))return H;const Ue=Date.now();fe||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Re.adapter,Re.extension);return Promise.resolve(Ke).catch(_e=>{(0,O.$6)(_e)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Re.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),k.CancellationToken.isCancellationToken(ie)?(0,S.$uh)(Ke,ie):Ke}t(j,U){const K=this.q();return this.f.set(K,new ke(j,U)),K}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,U,K,H){const ie=this.t(new m(this.h,K),j),fe=H&&H.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(ie,this.o(U,j),fe),this.p(ie)}$provideDocumentSymbols(j,U,K){return this.s(j,m,H=>H.provideDocumentSymbols(u.URI.revive(U),K),void 0,K)}registerCodeLensProvider(j,U,K){const H=this.q(),ie=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new ke(new d(this.h,this.j.converter,K,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(H,this.o(U,j),ie);let fe=this.p(H);if(ie!==void 0){const Re=K.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(ie));fe=r.$wN.from(fe,Re)}return fe}$provideCodeLenses(j,U,K){return this.s(j,d,H=>H.provideCodeLenses(u.URI.revive(U),K),void 0,K)}$resolveCodeLens(j,U,K){return this.s(j,d,H=>H.resolveCodeLens(U,K),void 0,void 0)}$releaseCodeLenses(j,U){this.s(j,d,K=>Promise.resolve(K.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(j,U,K){const H=this.t(new I(this.h,K),j);return this.e.$registerDefinitionSupport(H,this.o(U,j)),this.p(H)}$provideDefinition(j,U,K,H){return this.s(j,I,ie=>ie.provideDefinition(u.URI.revive(U),K,H),[],H)}registerDeclarationProvider(j,U,K){const H=this.t(new D(this.h,K),j);return this.e.$registerDeclarationSupport(H,this.o(U,j)),this.p(H)}$provideDeclaration(j,U,K,H){return this.s(j,D,ie=>ie.provideDeclaration(u.URI.revive(U),K,H),[],H)}registerImplementationProvider(j,U,K){const H=this.t(new v(this.h,K),j);return this.e.$registerImplementationSupport(H,this.o(U,j)),this.p(H)}$provideImplementation(j,U,K,H){return this.s(j,v,ie=>ie.provideImplementation(u.URI.revive(U),K,H),[],H)}registerTypeDefinitionProvider(j,U,K){const H=this.t(new C(this.h,K),j);return this.e.$registerTypeDefinitionSupport(H,this.o(U,j)),this.p(H)}$provideTypeDefinition(j,U,K,H){return this.s(j,C,ie=>ie.provideTypeDefinition(u.URI.revive(U),K,H),[],H)}registerHoverProvider(j,U,K,H){const ie=this.t(new P(this.h,K),j);return this.e.$registerHoverProvider(ie,this.o(U,j)),this.p(ie)}$provideHover(j,U,K,H,ie){return this.s(j,P,fe=>fe.provideHover(u.URI.revive(U),K,H,ie),void 0,ie)}$releaseHover(j,U){this.s(j,P,K=>Promise.resolve(K.releaseHover(U)),void 0,void 0)}registerEvaluatableExpressionProvider(j,U,K,H){const ie=this.t(new g(this.h,K),j);return this.e.$registerEvaluatableExpressionProvider(ie,this.o(U,j)),this.p(ie)}$provideEvaluatableExpression(j,U,K,H){return this.s(j,g,ie=>ie.provideEvaluatableExpression(u.URI.revive(U),K,H),void 0,H)}registerInlineValuesProvider(j,U,K,H){const ie=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new w(this.h,K),j);this.e.$registerInlineValuesProvider(fe,this.o(U,j),ie);let Re=this.p(fe);if(ie!==void 0){const Ue=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ie));Re=r.$wN.from(Re,Ue)}return Re}$provideInlineValues(j,U,K,H,ie){return this.s(j,w,fe=>fe.provideInlineValues(u.URI.revive(U),K,H,ie),void 0,ie)}registerDocumentHighlightProvider(j,U,K){const H=this.t(new M(this.h,K),j);return this.e.$registerDocumentHighlightProvider(H,this.o(U,j)),this.p(H)}registerMultiDocumentHighlightProvider(j,U,K){const H=this.t(new N(this.h,K),j);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(U,j)),this.p(H)}$provideDocumentHighlights(j,U,K,H){return this.s(j,M,ie=>ie.provideDocumentHighlights(u.URI.revive(U),K,H),void 0,H)}$provideMultiDocumentHighlights(j,U,K,H,ie){return this.s(j,N,fe=>fe.provideMultiDocumentHighlights(u.URI.revive(U),K,H.map(Re=>u.URI.revive(Re)),ie),void 0,ie)}registerLinkedEditingRangeProvider(j,U,K){const H=this.t(new L(this.h,K),j);return this.e.$registerLinkedEditingRangeProvider(H,this.o(U,j)),this.p(H)}$provideLinkedEditingRanges(j,U,K,H){return this.s(j,L,async ie=>{const fe=await ie.provideLinkedEditingRanges(u.URI.revive(U),K,H);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Ae.y(fe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(j,U,K){const H=this.t(new G(this.h,K),j);return this.e.$registerReferenceSupport(H,this.o(U,j)),this.p(H)}$provideReferences(j,U,K,H,ie){return this.s(j,G,fe=>fe.provideReferences(u.URI.revive(U),K,H,ie),void 0,ie)}registerCodeActionProvider(j,U,K,H){const ie=new T.$Vc,fe=this.t(new B(this.h,this.j.converter,this.k,K,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(fe,this.o(U,j),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ie)}))},Ae.u(j),Ae.w(j),!!K.resolveCodeAction),ie.add(this.p(fe)),ie}$provideCodeActions(j,U,K,H,ie){return this.s(j,B,fe=>fe.provideCodeActions(u.URI.revive(U),K,H,ie),void 0,ie)}$resolveCodeAction(j,U,K){return this.s(j,B,H=>H.resolveCodeAction(U,K),{},void 0)}$releaseCodeActions(j,U){this.s(j,B,K=>Promise.resolve(K.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(j,U,K){const H=this.t(new V(this.h,K),j);return this.e.$registerDocumentFormattingSupport(H,this.o(U,j),j.identifier,j.displayName||j.name),this.p(H)}$provideDocumentFormattingEdits(j,U,K,H){return this.s(j,V,ie=>ie.provideDocumentFormattingEdits(u.URI.revive(U),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(j,U,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ie=this.t(new ae(this.h,K),j);return this.e.$registerRangeFormattingSupport(ie,this.o(U,j),j.identifier,j.displayName||j.name,H),this.p(ie)}$provideDocumentRangeFormattingEdits(j,U,K,H,ie){return this.s(j,ae,fe=>fe.provideDocumentRangeFormattingEdits(u.URI.revive(U),K,H,ie),void 0,ie)}$provideDocumentRangesFormattingEdits(j,U,K,H,ie){return this.s(j,ae,fe=>fe.provideDocumentRangesFormattingEdits(u.URI.revive(U),K,H,ie),void 0,ie)}registerOnTypeFormattingEditProvider(j,U,K,H){const ie=this.t(new $e(this.h,K),j);return this.e.$registerOnTypeFormattingSupport(ie,this.o(U,j),H,j.identifier),this.p(ie)}$provideOnTypeFormattingEdits(j,U,K,H,ie,fe){return this.s(j,$e,Re=>Re.provideOnTypeFormattingEdits(u.URI.revive(U),K,H,ie,fe),void 0,fe)}registerWorkspaceSymbolProvider(j,U){const K=this.t(new _(U,this.l),j);return this.e.$registerNavigateTypeSupport(K,typeof U.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(j,U,K){return this.s(j,_,H=>H.provideWorkspaceSymbols(U,K),{symbols:[]},K)}$resolveWorkspaceSymbol(j,U,K){return this.s(j,_,H=>H.resolveWorkspaceSymbol(U,K),void 0,void 0)}$releaseWorkspaceSymbols(j,U){this.s(j,_,K=>K.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(j,U,K){const H=this.t(new ge(this.h,K,this.l),j);return this.e.$registerRenameSupport(H,this.o(U,j),ge.supportsResolving(K)),this.p(H)}$provideRenameEdits(j,U,K,H,ie){return this.s(j,ge,fe=>fe.provideRenameEdits(u.URI.revive(U),K,H,ie),void 0,ie)}$resolveRenameLocation(j,U,K,H){return this.s(j,ge,ie=>ie.resolveRenameLocation(u.URI.revive(U),K,H),void 0,H)}registerNewSymbolNamesProvider(j,U,K){const H=this.t(new se(this.h,K,this.l),j);return this.e.$registerNewSymbolNamesProvider(H,this.o(U,j)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,se,U=>U.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,U,K,H,ie){return this.s(j,se,fe=>fe.provideNewSymbolNames(u.URI.revive(U),K,H,ie),void 0,ie)}registerDocumentSemanticTokensProvider(j,U,K,H){const ie=this.t(new we(this.h,K),j),fe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ie,this.o(U,j),H,fe);let Re=this.p(ie);if(fe){const Ue=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(fe));Re=r.$wN.from(Re,Ue)}return Re}$provideDocumentSemanticTokens(j,U,K,H){return this.s(j,we,ie=>ie.provideDocumentSemanticTokens(u.URI.revive(U),K,H),null,H)}$releaseDocumentSemanticTokens(j,U){this.s(j,we,K=>K.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,U,K,H){const ie=this.t(new re(this.h,K),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ie,this.o(U,j),H),this.p(ie)}$provideDocumentRangeSemanticTokens(j,U,K,H){return this.s(j,re,ie=>ie.provideDocumentRangeSemanticTokens(u.URI.revive(U),K,H),null,H)}registerCompletionItemProvider(j,U,K,H){const ie=this.t(new Pe(this.h,this.j.converter,K,this.m,j),j);return this.e.$registerCompletionsProvider(ie,this.o(U,j),H,Pe.supportsResolving(K),j.identifier),this.p(ie)}$provideCompletionItems(j,U,K,H,ie){return this.s(j,Pe,fe=>fe.provideCompletionItems(u.URI.revive(U),K,H,ie),void 0,ie)}$resolveCompletionItem(j,U,K){return this.s(j,Pe,H=>H.resolveCompletionItem(U,K),void 0,K)}$releaseCompletionItems(j,U){this.s(j,Pe,K=>K.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(j,U,K,H){const ie=new Y(j,this.h,K,this.j.converter),fe=this.t(ie,j);return this.e.$registerInlineCompletionsSupport(fe,this.o(U,j),ie.supportsHandleEvents,h.$qn.toKey(j.identifier.value),H?.yieldTo?.map(Re=>h.$qn.toKey(Re))||[]),this.p(fe)}$provideInlineCompletions(j,U,K,H,ie){return this.s(j,Me,fe=>fe.provideInlineCompletions(u.URI.revive(U),K,H,ie),void 0,ie)}$provideInlineEdits(j,U,K,H,ie){return this.s(j,Me,fe=>fe.provideInlineEdits(u.URI.revive(U),K,H,ie),void 0,ie)}$handleInlineCompletionDidShow(j,U,K,H){this.s(j,Me,async ie=>{ie.handleDidShowCompletionItem(U,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,U,K,H,ie){this.s(j,Me,async fe=>{fe.handlePartialAccept(U,K,H,ie)},void 0,void 0)}$freeInlineCompletionsList(j,U){this.s(j,Me,async K=>{K.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(j,U,K){const H=new q(j,this.h,K,this.j.converter),ie=this.t(H,j);return this.e.$registerInlineEditProvider(ie,this.o(U,j),j.identifier),this.p(ie)}$provideInlineEdit(j,U,K,H){return this.s(j,q,ie=>ie.provideInlineEdits(u.URI.revive(U),K,H),void 0,H)}$freeInlineEdit(j,U){this.s(j,q,async K=>{K.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(j,U,K,H){const ie=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,fe=this.t(new ve(this.h,K),j);return this.e.$registerSignatureHelpProvider(fe,this.o(U,j),ie),this.p(fe)}$provideSignatureHelp(j,U,K,H,ie){return this.s(j,ve,fe=>fe.provideSignatureHelp(u.URI.revive(U),K,H,ie),void 0,ie)}$releaseSignatureHelp(j,U){this.s(j,ve,K=>K.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(j,U,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ie=this.t(new ue(this.h,this.j.converter,K,this.l,j),j);this.e.$registerInlayHintsProvider(ie,this.o(U,j),typeof K.resolveInlayHint=="function",H,Ae.u(j));let fe=this.p(ie);if(H!==void 0){const Re=K.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(H));fe=r.$wN.from(fe,Re)}return fe}$provideInlayHints(j,U,K,H){return this.s(j,ue,ie=>ie.provideInlayHints(u.URI.revive(U),K,H),void 0,H)}$resolveInlayHint(j,U,K){return this.s(j,ue,H=>H.resolveInlayHint(U,K),void 0,K)}$releaseInlayHints(j,U){this.s(j,ue,K=>K.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(j,U,K){const H=this.t(new be(this.h,K),j);return this.e.$registerDocumentLinkProvider(H,this.o(U,j),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(j,U,K){return this.s(j,be,H=>H.provideLinks(u.URI.revive(U),K),void 0,K,U.scheme==="output")}$resolveDocumentLink(j,U,K){return this.s(j,be,H=>H.resolveLink(U,K),void 0,void 0,!0)}$releaseDocumentLinks(j,U){this.s(j,be,K=>K.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(j,U,K){const H=this.t(new de(this.h,K),j);return this.e.$registerDocumentColorProvider(H,this.o(U,j)),this.p(H)}$provideDocumentColors(j,U,K){return this.s(j,de,H=>H.provideColors(u.URI.revive(U),K),[],K)}$provideColorPresentations(j,U,K,H){return this.s(j,de,ie=>ie.provideColorPresentations(u.URI.revive(U),K,H),void 0,H)}registerFoldingRangeProvider(j,U,K){const H=this.q(),ie=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new ke(new X(this.h,K),j)),this.e.$registerFoldingRangeProvider(H,this.o(U,j),j.identifier,ie);let fe=this.p(H);if(ie!==void 0){const Re=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ie));fe=r.$wN.from(fe,Re)}return fe}$provideFoldingRanges(j,U,K,H){return this.s(j,X,ie=>ie.provideFoldingRanges(u.URI.revive(U),K,H),void 0,H)}registerSelectionRangeProvider(j,U,K){const H=this.t(new Z(this.h,K,this.l),j);return this.e.$registerSelectionRangeProvider(H,this.o(U,j)),this.p(H)}$provideSelectionRanges(j,U,K,H){return this.s(j,Z,ie=>ie.provideSelectionRanges(u.URI.revive(U),K,H),[],H)}registerCallHierarchyProvider(j,U,K){const H=this.t(new me(this.h,K),j);return this.e.$registerCallHierarchyProvider(H,this.o(U,j)),this.p(H)}$prepareCallHierarchy(j,U,K,H){return this.s(j,me,ie=>Promise.resolve(ie.prepareSession(u.URI.revive(U),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(j,U,K,H){return this.s(j,me,ie=>ie.provideCallsTo(U,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(j,U,K,H){return this.s(j,me,ie=>ie.provideCallsFrom(U,K,H),void 0,H)}$releaseCallHierarchy(j,U){this.s(j,me,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(j,U,K){const H=this.t(new pe(this.h,K),j);return this.e.$registerTypeHierarchyProvider(H,this.o(U,j)),this.p(H)}$prepareTypeHierarchy(j,U,K,H){return this.s(j,pe,ie=>Promise.resolve(ie.prepareSession(u.URI.revive(U),K,H)),void 0,H)}$provideTypeHierarchySupertypes(j,U,K,H){return this.s(j,pe,ie=>ie.provideSupertypes(U,K,H),void 0,H)}$provideTypeHierarchySubtypes(j,U,K,H){return this.s(j,pe,ie=>ie.provideSubtypes(U,K,H),void 0,H)}$releaseTypeHierarchy(j,U){this.s(j,pe,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(j,U,K,H){const ie=this.q();return this.f.set(ie,new ke(new Oe(this.e,this.h,K,ie,j),j)),this.e.$registerDocumentOnDropEditProvider(ie,this.o(U,j),(0,t.$6G)(j,"documentPaste")&&H?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ie)}$provideDocumentOnDropEdits(j,U,K,H,ie,fe){return this.s(j,Oe,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(U,u.URI.revive(K),H,ie,fe)),void 0,void 0)}$resolveDropEdit(j,U,K){return this.s(j,Oe,H=>H.resolveDropEdit(U,K),{},void 0)}$releaseDocumentOnDropEdits(j,U){this.s(j,Oe,K=>Promise.resolve(K.releaseDropEdits(U)),void 0,void 0)}registerMappedEditsProvider(j,U,K){const H=this.t(new ze(this.h,K),j);return this.e.$registerMappedEditsProvider(H,this.o(U,j)),this.p(H)}$provideMappedEdits(j,U,K,H,ie){return this.s(j,ze,fe=>Promise.resolve(fe.provideMappedEdits(U,K,H,ie)),null,ie)}registerDocumentPasteEditProvider(j,U,K,H){const ie=this.q();return this.f.set(ie,new ke(new F(this.e,this.h,K,ie,j),j)),this.e.$registerPasteEditProvider(ie,this.o(U,j),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ie)}$prepareDocumentPaste(j,U,K,H,ie){return this.s(j,F,fe=>fe.prepareDocumentPaste(u.URI.revive(U),K,H,ie),void 0,ie)}$providePasteEdits(j,U,K,H,ie,fe,Re){return this.s(j,F,Ue=>Ue.providePasteEdits(U,u.URI.revive(K),H,ie,fe,Re),void 0,Re)}$resolvePasteEdit(j,U,K){return this.s(j,F,H=>H.resolvePasteEdit(U,K),{},void 0)}$releasePasteEdits(j,U){this.s(j,F,K=>Promise.resolve(K.releasePasteEdits(U)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Ae.y(j.decreaseIndentPattern),increaseIndentPattern:Ae.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Ae.y(j.beforeText),afterText:j.afterText?Ae.y(j.afterText):void 0,previousLineText:j.previousLineText?Ae.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Ae.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(U=>r.SyntaxTokenType.toString(U)):void 0}}static E(j){return j.map(Ae.D)}setLanguageConfiguration(j,U,K){const{wordPattern:H}=K;if(H&&(0,R.$sf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(U,H):this.h.setWordDefinitionFor(U,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ie=this.q(),fe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ie,U,fe),this.p(ie)}$setWordDefinitions(j){for(const U of j)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.$roc=Ae}),define(Ce[286],Ie([1,0,4,5,8]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=void 0,k=qe(k);class O{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(S.$uN.MainThreadLanguageModelTools),this.b.$getTools().then(p=>{for(const a of p)this.c.set(a.name,a)})}async invokeTool(T,p,a){return await this.b.$invokeTool(T,p,a)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>k.LanguageModelToolDescription.to(T))}async $invokeTool(T,p,a){const R=this.a.get(T);if(!R)throw new Error(`Unknown tool ${T}`);return await R.tool.invoke(p,a)}registerTool(T,p,a){return this.a.set(p,{extension:T,tool:a}),this.b.$registerTool(p),(0,b.$Uc)(()=>{this.a.delete(p),this.b.$unregisterTool(p)})}}e.$rqc=O}),define(Ce[95],Ie([1,0,11,22,14,6,40,4,184,19,3,12,77,5,91,17,8,7,117,25]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0,s=qe(s),o=qe(o),e.$$oc=(0,R.$Fi)("IExtHostLanguageModels");class t{constructor(d,$){this.option=d,this.stream=new b.$9h,this.stream=$??new b.$9h}}class c{constructor(){this.a=new Map,this.b=new b.$9h,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable,text:b.$6h.map(d.b.asyncIterable,$=>{if($ instanceof o.$KP)return $.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let $=this.a.get(d.index);$||(this.a.size===0?$=new t(d.index,this.b):$=new t(d.index),this.a.set(d.index,$));let I;d.part.type==="text"?I=new o.$KP(d.part.value):I=new o.$JP(d.part.name,d.part.parameters),$.stream.emitOne(I)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const $ of this.f())$.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let l=class{static{r=this}static{this.a=1}constructor(d,$,I){this.j=$,this.k=I,this.c=new O.$me,this.d=new O.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new a.$sn,this.i=new Map,this.r=new Set,this.b=d.getProxy(E.$uN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,$,I,D){const v=r.a++;this.f.set(v,{extension:d.identifier,provider:I,languageModelId:$});let C;D.auth&&(C={providerLabel:d.displayName||d.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,`${a.$qn.toKey(d.identifier)}/${v}/${$}`,{extension:d.identifier,id:$,vendor:D.vendor??a.$qn.toKey(d.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:C,targetExtensions:D.extensions});const P=I.onDidReceiveLanguageModelResponse2?.(({extensionId:g,participant:w,tokenCount:M})=>{this.b.$whenLanguageModelChatRequestMade($,new a.$qn(g),w,M)});return(0,T.$Uc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v),P?.dispose()})}async $provideLanguageModelResponse(d,$,I,D,v,C){const P=this.f.get(d);if(!P)return;const g=new u.$vw(async w=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${P.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let M;if(w.part instanceof o.$JP?M={type:"function_use",name:w.part.name,parameters:w.part.parameters}:w.part instanceof o.$KP&&(M={type:"text",value:w.part.value}),!M){this.j.warn(`[CHAT](${P.extension.value}) UNKNOWN part ${JSON.stringify(w)}`);return}this.b.$handleProgressChunk($,{index:w.index,part:M})});if(P.provider.provideLanguageModelResponse2)return P.provider.provideLanguageModelResponse2(D.map(s.LanguageModelChatMessage.to),v,a.$qn.toKey(I),g,C);{const w=new u.$vw(async M=>{g.report({index:M.index,part:new o.$KP(M.part)})});return P.provider.provideLanguageModelResponse(D.map(s.LanguageModelChatMessage.to),v?.modelOptions??{},a.$qn.toKey(I),w,C)}}$provideTokenLength(d,$,I){const D=this.f.get(d);return D?Promise.resolve(D.provider.provideTokenCount($,I)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:$,metadata:I}of d.added)this.g.set($,{metadata:I,apiObjects:new a.$sn});if(d.removed)for(const $ of d.removed){this.g.delete($);for(const[I,D]of this.i)D.languageModelId===$&&(D.res.reject(new k.$7),this.i.delete(I))}d.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,$){const I=await this.b.$selectChatModels({...$,extension:d.identifier}),D=[],v=this;for(const C of I){const P=this.g.get(C);if(!P)continue;this.o(d.identifier,P.metadata)&&await this.p(P.metadata);let g=P.apiObjects.get(d.identifier);g||(g={id:C,vendor:P.metadata.vendor,family:P.metadata.family,version:P.metadata.version,name:P.metadata.name,maxInputTokens:P.metadata.maxInputTokens,countTokens(w,M){if(!v.g.has(C))throw o.$OP.NotFound(C);return v.q(C,w,M??S.CancellationToken.None)},sendRequest(w,M,N){if(!v.g.has(C))throw o.$OP.NotFound(C);return v.l(d,C,w,M??{},N??S.CancellationToken.None)}},Object.freeze(g),P.apiObjects.set(d.identifier,g)),D.push(g)}return D}async l(d,$,I,D,v){const C=this.m(d,I),P=d.identifier,g=this.g.get($)?.metadata;if(!g||!this.g.has($))throw o.$OP.NotFound(`Language model '${$}' is unknown.`);if(this.o(P,g)&&(!await this.n(d,{identifier:g.extension,displayName:g.auth.providerLabel},D.justification,!1)||!this.h.get(P)?.has(g.extension)))throw o.$OP.NoPermissions(`Language model '${$}' cannot be used by '${P.value}'.`);const w=Math.random()*1e6|0,M=this.b.$fetchResponse(P,$,w,C,D,v),N=new b.$Eh,L=new c;this.i.set(w,{languageModelId:$,res:L});let G;if(M.catch(B=>{N.isOpen()?L.reject(B):G=B}).finally(()=>{this.i.delete(w),L.resolve(),N.open()}),await N.wait(),G)throw G.name===o.$OP.name?G:new o.$OP(`Language model '${$}' errored, check cause for more details`,"Unknown",G);return L.apiObject}m(d,$){const I=[];for(const D of $)D.role===o.LanguageModelChatMessageRole.System&&(0,i.$7G)(d,"languageModelSystem"),D.content2 instanceof o.$HP&&(0,i.$7G)(d,"lmTools"),I.push(s.LanguageModelChatMessage.from(D));return I}async $handleResponseFragment(d,$){const I=this.i.get(d);I&&I.res.handleFragment($)}async n(d,$,I,D){const v=h.$wM+$.identifier.value;if(await this.k.getSession(d,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:$.identifier,enabled:!0}]),!0;if(D)return!1;try{const P=I?(0,p.localize)(0,null,$.displayName,I):void 0;return await this.k.getSession(d,v,[],{forceNewSession:{detail:P}}),this.$updateModelAccesslist([{from:d.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(d,$){return!!$.auth&&!a.$qn.equals($.extension,d)}async p(d){if(d.auth)for(const $ of this.r)try{await this.n($,{identifier:d.extension,displayName:""},void 0,!0)}catch(I){this.j.error("Fake Auth request failed"),this.j.error(I)}}async q(d,$,I){if(!this.g.get(d))throw o.$OP.NotFound(`Language model '${d}' is unknown.`);const v=A.Iterable.find(this.f.values(),C=>C.languageModelId===d);return v?v.provider.provideTokenCount($,I):this.b.$countTokens(d,typeof $=="string"?$:s.LanguageModelChatMessage.from($),I)}$updateModelAccesslist(d){const $=new Array;for(const{from:I,to:D,enabled:v}of d){const C=this.h.get(I)??new a.$rn;if(C.has(D)!==v){v?C.add(D):C.delete(D),this.h.set(I,C);const g={from:I,to:D};$.push(g),this.c.fire(g)}}}createLanguageModelAccessInformation(d){this.r.add(d);const $=this,I=O.Event.signal(O.Event.filter(this.c.event,v=>a.$qn.equals(v.from,d.identifier))),D=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(I,D)},canSendRequest(v){let C;e:for(const[g,w]of $.g)for(const M of w.apiObjects.values())if(M===v){C=w.metadata;break e}if(!C)return;if(!$.o(d.identifier,C))return!0;const P=$.h.get(d.identifier);if(P)return P.has(C.extension)}}}};e.$_oc=l,e.$_oc=l=r=Qe([Ve(0,n.$1P),Ve(1,y.$_j),Ve(2,f.$toc)],l)});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[287],Ie([1,0,5,8,7,36,11,4,25]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0,S=qe(S),O=ti(O);class a{constructor(y,u,E,f){this.c=u,this.d=E,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(b.$uN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const E=this.c.getDocumentData(y);if(!E)throw new Error(`document '${y.toString()}' NOT found`);return E.document}async tokenAtPosition(y,u){const E=y.version,f=S.Position.from(u),n=await this.a.$tokensAtPosition(y.uri,f),s={type:k.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new k.$yN(u.line,u.character,u.line,u.character)};if(!n)return s;const o={range:S.Range.to(n.range),type:S.TokenType.to(n.type)};return!o.range.contains(u)||E!==y.version?s:o}createLanguageStatusItem(y,u,E){const f=this.f++,n=this.a,s=this.g,o=`${y.identifier.value}/${u}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);s.add(o);const h={selector:E,id:u,name:y.displayName??y.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Vc,t=()=>{if(i?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Hh)(()=>{r.clear(),this.a.$setLanguageStatus(f,{id:o,name:h.name??y.displayName??y.name,source:y.displayName??y.name,selector:S.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===k.LanguageStatusSeverity.Error?O.default.Error:h.severity===k.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,r),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},c={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(f),s.delete(o)},get id(){return h.id},get name(){return h.name},set name(l){h.name=l,t()},get selector(){return h.selector},set selector(l){h.selector=l,t()},get text(){return h.text},set text(l){h.text=l,t()},set text2(l){(0,p.$7G)(y,"languageStatusText"),h.text=l,t()},get text2(){return(0,p.$7G)(y,"languageStatusText"),h.text},get detail(){return h.detail},set detail(l){h.detail=l,t()},get severity(){return h.severity},set severity(l){h.severity=l,t()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(l){h.accessibilityInformation=l,t()},get command(){return h.command},set command(l){h.command=l,t()},get busy(){return h.busy},set busy(l){h.busy=l,t()}};return t(),c}}e.$Vpc=a}),define(Ce[288],Ie([1,0,16,2,8,7,90]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0,k=qe(k),A=qe(A);class T{constructor(y,u,E,f){this.start=y,this.deletedCount=u,this.deletedItems=E,this.items=f}asApiEvent(){return{range:new O.$YO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,E){this.notebook=y,this.h=u,this.j=E,this.handle=E.handle,this.uri=S.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(k.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(f){y.g=f},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(E)}return this.f}setOutputs(y){this.a=y.map(k.NotebookCellOutput.to)}setOutputItems(y,u,E){const f=E.map(k.NotebookCellOutputItem.to),n=this.a.find(s=>s.id===y);if(n&&(u||(n.items.length=0),n.items.push(...f),n.items.length>1&&n.items.every(s=>A.$zL(s.mime)))){const s=new Map,o=[];n.items.forEach(h=>{let i;s.has(h.mime)?i=s.get(h.mime):(i=[],s.set(h.mime,i),o.push(h.mime)),i.push(h.data)}),n.items.length=0,o.forEach(h=>{const i=A.$AL(s.get(h));n.items.push({mime:h,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Hpc=p;class a{static{this.a=0}constructor(y,u,E,f,n){this.k=y,this.l=u,this.m=E,this.uri=f,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===b.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(E){return E=y.n(E),y.b[E].apiCell},getCells(E){return(E?y.p(E):y.b).map(n=>n.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,E){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const f={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},n=[];for(const o of y.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,f.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,f.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),n.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),n.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<n.length;o++){const h=n[o],i=s.get(h.cell);if(i===void 0){const r=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});s.set(h.cell,r-1)}else f.cellChanges[i]={...f.cellChanges[i],...h}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,E=y.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),y.with({start:u,end:E})}p(y){y=this.o(y);const u=[];for(let E=y.start;E<y.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,E){if(this.j)return;const f=[],n=[],s=[];if(y.reverse().forEach(o=>{const i=o[2].map(c=>{const l=new p(this,this.l,c);return u||n.push(p.asModelAddData(c)),l}),r=new T(o[0],o[1],[],i),t=this.b.splice(o[0],o[1],...i);for(const c of t)s.push(c.uri),r.deletedItems.push(c.apiCell);f.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:s}),E)for(const o of f)E.push(o.asApiEvent())}s(y,u,E,f){const n=this.b.splice(y,u);this.b.splice(E,0,...n);const s=[new T(y,u,n.map(o=>o.apiCell),[]),new T(E,0,[],n)];for(const o of s)f.push(o.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,E,f){this.b[y].setOutputItems(u,E,f)}v(y,u){const E=this.b[y];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(y,u){const E=this.b[y];E.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Ipc=a}),define(Ce[289],Ie([1,0,6,2,8,7,39]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0;class T{constructor(a,R,y,u={timeout:1500,errors:3}){this.b=a,this.c=R,this.d=y,this.f=u,this.a=new b.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(R,y,u)=>{const E=function(n){R.call(y,n)};return E.extension=a,this.a.event(E,void 0,u)}}async $participateInSave(a,R,y){const u=S.URI.revive(a),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:k.TextDocumentSaveReason.to(R)},y,async(s,o)=>{const h=Date.now(),i=await await Promise.resolve(s);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$GN?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(f.length===0)return!0;const n={edits:[]};for(const s of f){const{edits:o}=k.WorkspaceEdit.from(s);n.edits=n.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new A.$Tw(n))}}e.$Xpc=T}),define(Ce[124],Ie([1,0,14,8,7]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0,S=qe(S),k=qe(k);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,a,R,y,u){this.id=T,this.f=p,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=R,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(k.$YO.isNotebookRange))throw(0,b.$9)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,a){T.f.$tryRevealRange(T.id,S.NotebookRange.from(p),a??k.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(S.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Jpc=O}),define(Ce[290],Ie([1,0,6,12,8]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,k=qe(k);let O=class{constructor(T,p){this.c=T,this.d=p,this.a=new b.$me,this.b=new b.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const a=this.d.getEditorById(T);p.visibleRanges&&a._acceptVisibleRanges(p.visibleRanges.ranges.map(k.NotebookRange.to)),p.selections&&a._acceptSelections(p.selections.selections.map(k.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(k.ViewColumn.to(T[p]))}};e.$Zpc=O,e.$Zpc=O=Qe([Ve(0,S.$_j)],O)}),define(Ce[291],Ie([1,0,6,5,124]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0;class O{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(S.$uN.MainThreadNotebookRenderers)}$postRendererMessage(T,p,a){const R=this.c.getEditorById(T);this.a.get(p)?.fire({editor:R.apiEditor,message:a})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,y,u)=>this.d(p).event(R,y,u),postMessage:(R,y)=>{k.$Jpc.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const u=y&&k.$Jpc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,p,R)}}}d(T){let p=this.a.get(T);return p||(p=new b.$me({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$3pc=O}),define(Ce[292],Ie([1,0,8,77,22,72,14]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,E){const f=this.b++,{title:n,location:s,cancellable:o}=u,h={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(f,{location:b.ProgressLocation.from(s),title:n,source:h,cancellable:o},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$4),this.d(f,E,!!o)}d(y,u,E){let f;E&&(f=new k.$xe,this.c.set(y,f));const n=o=>{this.a.$progressEnd(o),this.c.delete(o),f?.dispose()};let s;try{s=u(new a(this.a,y),E&&f?f.token:k.CancellationToken.None)}catch(o){throw n(y),o}return s.then(o=>n(y),o=>n(y)),s}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$7pc=T;function p(R,y){return R.message=y.message,typeof y.increment=="number"&&(typeof R.increment=="number"?R.increment+=y.increment:R.increment=y.increment),R}class a extends S.$vw{constructor(y,u){super(E=>this.throttledReport(E)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Qe([(0,O.$_h)(100,(R,y)=>p(R,y),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Ce[293],Ie([1,0,2,5,11,8]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class A{static{this.a=0}constructor(p,a){this.d=a,this.c=new Map,this.b=p.getProxy(S.$uN.MainThreadQuickDiff)}$provideOriginalResource(p,a,R){const y=b.URI.revive(a),u=this.c.get(p);return u?(0,k.$xh)(()=>u.provideOriginalResource(y,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,a,R,y){const u=A.a++;return this.c.set(u,a),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(p,this.d),R,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$8pc=A});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[294],Ie([1,0,22,6,4,5,2,7,14,18,36,35,25,8]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=f,R=ti(R);function f(n,s,o){const h=n.getProxy(O.$uN.MainThreadQuickOpen);class i{constructor(D,v){this.e=new Map,this.f=0,this.a=D,this.b=v}showQuickPick(D,v,C,P=b.CancellationToken.None){this.c=void 0;const g=Promise.resolve(v),w=++this.f,M=h.$show(w,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},P),N={},L=M.then(()=>N);return Promise.race([L,g]).then(G=>{if(G===N)return;const B=(0,u.$6G)(D,"quickPickItemTooltip");return g.then(F=>{const V=[];for(let ae=0;ae<F.length;ae++){const $e=F[ae];if(typeof $e=="string")V.push({label:$e,handle:ae});else if($e.kind===T.QuickPickItemKind.Separator)V.push({type:"separator",label:$e.label});else{$e.tooltip&&!B&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const _=$e.iconPath?m($e.iconPath):void 0;V.push({label:$e.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:$e.description,detail:$e.detail,picked:$e.picked,alwaysShow:$e.alwaysShow,tooltip:B?E.MarkdownString.fromStrict($e.tooltip):void 0,handle:ae})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=ae=>{C.onDidSelectItem(F[ae])}),h.$setItems(w,V),M.then(ae=>{if(typeof ae=="number")return F[ae];if(Array.isArray(ae))return ae.map($e=>F[$e])})})}).then(void 0,G=>{if(!(0,p.$6)(G))return h.$setError(w,G),Promise.reject(G)})}$onItemSelected(D){this.c?.(D)}showInput(D,v=b.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",v).then(void 0,C=>{if(!(0,p.$6)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const v=await this.d(D);if(!v||typeof v=="string")return v;let C;switch(v.severity){case T.InputBoxValidationSeverity.Info:C=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:C=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:C=R.default.Error;break;default:C=v.message?R.default.Error:R.default.Ignore;break}return{content:v.message,severity:C}}async showWorkspaceFolderPick(D,v=b.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(g=>g.uri.toString()===C.uri.toString())}createQuickPick(D){const v=new d(D,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}createInputBox(D){const v=new $(D,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}$onDidChangeValue(D,v){this.e.get(D)?._fireDidChangeValue(v)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,v){const C=this.e.get(D);C instanceof d&&C._fireDidChangeActive(v)}$onDidChangeSelection(D,v){const C=this.e.get(D);C instanceof d&&C._fireDidChangeSelection(v)}$onDidTriggerButton(D,v){this.e.get(D)?._fireDidTriggerButton(v)}$onDidTriggerItemButton(D,v,C){const P=this.e.get(D);P instanceof d&&P._fireDidTriggerItemButton(v,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class r{static{this.a=1}constructor(D,v){this.x=D,this.y=v,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new S.$me,this.q=new S.$me,this.r=new S.$me,this.s=new S.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((v,C)=>{const P=v===T.$VO.Back?-1:C;this.o.set(P,v)}),this.z({buttons:D.map((v,C)=>({...m(v.iconPath),tooltip:v.tooltip,handle:v===T.$VO.Back?-1:C}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const v=this.o.get(D);v&&this.r.fire(v)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.$Rc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const v of Object.keys(D)){const C=D[v];this.u[v]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function t(I){if(I instanceof T.$tO)return{id:I.id};const D=l(I),v=c(I);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof v=="string"?A.URI.file(v):v}}function c(I){return typeof I=="object"&&"light"in I?I.light:I}function l(I){return typeof I=="object"&&"dark"in I?I.dark:I}function m(I){const D=t(I);let v,C;return"id"in D?C=y.ThemeIcon.asClassName(D):v=D,{iconPath:v,iconClass:C}}class d extends r{constructor(D,v){super(D.identifier,v),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new S.$me,this.L=[],this.M=new S.$me,this.N=new S.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((P,g)=>{this.C.set(g,P),this.D.set(P,g)});const v=(0,u.$6G)(this.O,"quickPickItemTooltip"),C=[];for(let P=0;P<D.length;P++){const g=D[P];if(g.kind===T.QuickPickItemKind.Separator)C.push({type:"separator",label:g.label});else{g.tooltip&&!v&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const w=g.iconPath?m(g.iconPath):void 0;C.push({handle:P,label:g.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:v?E.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((M,N)=>({...m(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(v=>this.D.has(v)),this.z({activeItems:this.J.map(v=>this.D.get(v))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(v=>this.D.has(v)),this.z({selectedItems:this.L.map(v=>this.D.get(v))})}_fireDidChangeActive(D){const v=(0,a.$Jb)(D.map(C=>this.C.get(C)));this.J=v,this.K.fire(v)}_fireDidChangeSelection(D){const v=(0,a.$Jb)(D.map(C=>this.C.get(C)));this.L=v,this.M.fire(v)}_fireDidTriggerItemButton(D,v){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const P=C.buttons[v];P&&this.N.fire({button:P,item:C})}}class $ extends r{constructor(D,v){super(D.identifier,v),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(s,o)}}),define(Ce[295],Ie([1,0,2,6,72,4,11,5,18,160,12,19,38,35,8,25,16,21]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=void 0;function i(N){return N instanceof b.URI}function r(N,L){return N.scheme===s.Schemas.file&&L.scheme===s.Schemas.file&&o.$k?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?b.URI.file(N.iconPath):b.URI.isUri(N.iconPath)||E.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function c(N){if(N){if(b.URI.isUri(N))return N;if(E.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function l(N){const L=c(N.icon),G=N.labels?.map(B=>({title:B.title,icon:c(B.icon)}));return{...N,icon:L,labels:G}}function m(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const G=typeof N.iconPath=="string"?N.iconPath:b.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,B=typeof L.iconPath=="string"?L.iconPath:b.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,a.$Hr)(G,B)}function d(N,L){let G=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(G=m(N,L),G!==0)return G;if(N.light&&L.light)G=m(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(G!==0)return G;if(N.dark&&L.dark)G=m(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return G}function $(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let G=0;G<N.arguments.length;G++){const B=N.arguments[G],F=L.arguments[G];if(B!==F&&!(i(B)&&i(F)&&r(B,F)))return B<F?-1:1}return 0}function I(N,L){let G=(0,a.$Hr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(G!==0)return G;if(N.command&&L.command)G=$(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(G!==0)return G;if(N.decorations&&L.decorations)G=d(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)G=(0,a.$Hr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)G=(0,a.$Hr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return G}function D(N,L){for(let G=0;G<N.length;G++)if(N[G]!==L[G])return!1;return!0}function v(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function C(N,L){return(0,p.$wb)(N,L,v)}class P{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,n.$7G)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,n.$7G)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,n.$7G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,G,B,F,V){this.k=L,this.m=F,this.n=V,this.d="",this.e=new S.$me,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=B}showValidationMessage(L,G){(0,n.$7G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,G)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$0pc=P;class g{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,G,B,F,V,ae,$e){this.s=L,this.t=G,this.u=B,this.v=F,this.w=V,this.multiDiffEditorEnableViewChanges=ae,this.x=$e,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new S.$me,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new S.$me,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=g.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,G){const B=this.h.get(L);return B?(0,A.$xh)(()=>this.t.executeCommand(B.command,...B.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(I),B=(0,p.$Fb)(this.p,L,I).map(ae=>{const $e=ae.toInsert.map(_=>{const ge=this.e++;this.g.set(ge,_);const se=_.resourceUri;let ce;if(_.command)if(_.command.command==="vscode.open"||_.command.command==="vscode.diff"||_.command.command==="vscode.changes"){const Z=new O.$Vc;ce=this.t.converter.toInternal(_.command,Z),this.j.set(ge,Z)}else this.h.set(ge,_.command);const we=(0,n.$6G)(this.x,"scmMultiDiffEditor"),re=we?_.multiDiffEditorOriginalUri:void 0,Pe=we?_.multiFileDiffEditorModifiedUri:void 0,Me=t(_.decorations),Y=_.decorations&&t(_.decorations.light)||Me,q=_.decorations&&t(_.decorations.dark)||Me,ee=[Y,q],ve=_.decorations&&_.decorations.tooltip||"",ue=_.decorations&&!!_.decorations.strikeThrough,be=_.decorations&&!!_.decorations.faded,de=_.contextValue||"";return{rawResource:[ge,se,ee,ve,ue,be,de,ce,re,Pe],handle:ge}});return{start:ae.start,deleteCount:ae.deleteCount,toInsert:$e}}),F=B.map(({start:ae,deleteCount:$e,toInsert:_})=>[ae,$e,_.map(ge=>ge.rawResource)]),V=B.reverse();for(const{start:ae,deleteCount:$e,toInsert:_}of V){const ge=_.map(ce=>ce.handle),se=this.o.splice(ae,$e,...ge);for(const ce of se)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=L,F}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.B}get label(){return this.C}get rootUri(){return this.D}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let G;(0,n.$6G)(this.y,"quickDiffProvider")&&(G=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:G})}get historyProvider(){return(0,n.$7G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,n.$7G)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Vc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new O.$Vc,this.p=L;const G=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:G})}get actionButton(){return(0,n.$7G)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,n.$7G)(this.y,"scmActionButton"),this.q.value=new O.$Vc,this.s=L;const G=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(B=>B.map(F=>this.z.converter.toInternal(F,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:G??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.A.info("ExtHostSourceControl#statusBarCommands",(L??[]).map(B=>B.command).join(", ")),this.u&&L&&C(this.u,L)){this.A.info("ExtHostSourceControl#statusBarCommands are equal");return}this.t.value=new O.$Vc,this.u=L;const G=(L||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:G})}get selected(){return this.v}constructor(L,G,B,F,V,ae,$e,_){this.y=L,this.z=F,this.A=V,this.B=ae,this.C=$e,this.D=_,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Xc,this.n=void 0,this.o=new O.$Xc,this.p=void 0,this.q=new O.$Xc,this.t=new O.$Xc,this.u=void 0,this.v=!1,this.w=new S.$me,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.E=new Map,this.F=new Set,this.#e=B;const ge=b.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${ae}/scm${this.x}/input`,query:_?`rootUri=${encodeURIComponent(_.toString())}`:void 0});this.f=new P(L,G,this.#e,this.x,ge),this.#e.$registerSourceControl(this.x,ae,$e,_,ge)}createResourceGroup(L,G,B){const F=(0,n.$6G)(this.y,"scmMultiDiffEditor")&&B?.multiDiffEditorEnableViewChanges===!0,V=new g(this.#e,this.z,this.x,L,G,F,this.y),ae=S.Event.once(V.onDidDispose)(()=>this.E.delete(V));return this.E.set(V,ae),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const L=[],G=[];for(const[B,F]of this.E){F.dispose();const V=B.onDidUpdateResourceStates(()=>{this.F.add(B),this.eventuallyUpdateResourceStates()});S.Event.once(B.onDidDispose)(()=>{this.F.delete(B),V.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),L.push([B.handle,B.id,B.label,B.features,B.multiDiffEditorEnableViewChanges]);const ae=B._takeResourceStateSnapshot();ae.length>0&&G.push([B.handle,ae]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,L,G),this.E.clear()}eventuallyUpdateResourceStates(){const L=[];this.F.forEach(G=>{const B=G._takeResourceStateSnapshot();B.length!==0&&L.push([G.handle,B])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.F.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Qe([(0,k.$$h)(100)],w.prototype,"eventuallyAddResourceGroups",null),Qe([(0,k.$$h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,G,B,F){this.m=G,this.n=B,this.o=F,this.g=new Map,this.h=new y.$sn,this.j=new S.$me,this.e=L.getProxy(T.$uN.MainThreadSCM),this.f=L.getProxy(T.$uN.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===u.MarshalledId.ScmResource){const ae=this.g.get(V.sourceControlHandle);if(!ae)return V;const $e=ae.getResourceGroup(V.groupHandle);return $e?$e.getResourceState(V.handle):V}else if(V&&V.$mid===u.MarshalledId.ScmResourceGroup){const ae=this.g.get(V.sourceControlHandle);return ae?ae.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===u.MarshalledId.ScmProvider){const ae=this.g.get(V.handle);return ae||V}return V}})}createSourceControl(L,G,B,F){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,G,B,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const V=h.d++,ae=new w(L,this.n,this.e,this.m,this.o,G,B,F);this.g.set(V,ae);const $e=this.h.get(L.identifier)||[];return $e.push(ae),this.h.set(L.identifier,$e),ae}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const G=this.h.get(L.identifier),B=G&&G[G.length-1];return B&&B.inputBox}$provideOriginalResource(L,G,B){const F=b.URI.revive(G);this.o.trace("ExtHostSCM#$provideOriginalResource",L,F.toString());const V=this.g.get(L);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xh)(()=>V.quickDiffProvider.provideOriginalResource(F,B)).then(ae=>ae||null)}$onInputBoxValueChange(L,G){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const B=this.g.get(L);return B&&B.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(L,G,B,F){this.o.trace("ExtHostSCM#$executeResourceCommand",L,G,B);const V=this.g.get(L);if(!V)return Promise.resolve(void 0);const ae=V.getResourceGroup(G);return ae?ae.$executeResourceCommand(B,F):Promise.resolve(void 0)}$validateInput(L,G,B){this.o.trace("ExtHostSCM#$validateInput",L);const F=this.g.get(L);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xh)(()=>F.inputBox.validateInput(G,B)).then(V=>{if(!V)return Promise.resolve(void 0);const ae=f.MarkdownString.fromStrict(V.message);return ae?Promise.resolve([ae,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,G,B,F){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,B,F)??void 0}async $provideHistoryItems(L,G,B,F){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(G,B,F))?.map($e=>l($e))??void 0}async $provideHistoryItems2(L,G,B){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(G,B))?.map(ae=>l(ae))??void 0}async $provideHistoryItemSummary(L,G,B,F){const V=this.g.get(L)?.historyProvider;if(typeof V?.provideHistoryItemSummary!="function")return;const ae=await V.provideHistoryItemSummary(G,B,F);return ae?l(ae):void 0}async $provideHistoryItemChanges(L,G,B,F){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(G,B,F)??void 0}};e.$$pc=M,e.$$pc=M=h=Qe([Ve(3,R.$_j)],M)}),define(Ce[296],Ie([1,0,5,8,2]),function(oe,e,b,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class O{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(b.$uN.MainThreadShare)}async $provideShare(T,p,a){return await this.c.get(T)?.provideShare({selection:S.Range.to(p.selection),resourceUri:k.URI.revive(p.resourceUri)},a)??void 0}registerShareProvider(T,p){const a=O.a++;return this.c.set(a,p),this.b.$registerShareProvider(a,S.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$_pc=O}),define(Ce[297],Ie([1,0,7,5,187,4,8,15]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=e.$bqc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new b.$uO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new b.$uO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,f,n,s,o=b.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new O.$Vc,this.#e=u,this.#t=E,s&&n){this.c=(0,b.$9N)(n.identifier,s);const i=f.get(this.c);i&&(o=i.alignLeft?b.StatusBarAlignment.Left:b.StatusBarAlignment.Right,h=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=n,this.f=s,this.g=o,this.h=this.u(h)}u(u){if((0,T.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Vc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,k.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=p.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,n,this.r?.internal,f,this.o,this.g===b.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$bqc=p;class a{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",b.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new b.$wN(()=>{const f=this.b.indexOf(E);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(u,E){this.e=new Map,this.a=u.getProxy(S.$uN.MainThreadStatusBar),this.b=E,this.c=new a(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,f,n){return new p(this.a,this.b,this.e,u,E,f,n)}setStatusBarMessage(u,E){const f=this.c.setMessage(u);let n;return typeof E=="number"?n=setTimeout(()=>f.dispose(),E):typeof E<"u"&&E.then(()=>f.dispose(),()=>f.dispose()),new b.$wN(()=>{f.dispose(),clearTimeout(n)})}}e.$cqc=R}),define(Ce[125],Ie([1,0,33,116,55,82,56,8,2]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,b=qe(b),T=qe(T);const a=(i,r,t,c)=>{let l=r;return{enumerable:!0,configurable:!1,get(){return l},set(m){if(!t(l,m)){const d=l;l=m,i.listener?.(c(m,d))}}}},R=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(c=>t.id===c.id)))},u=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),E=(i,r)=>({range:(()=>{let t;const c=u(l=>({range:b.$Lt.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,l)||(t=l,i.listener?.(c(l)))}}})(),label:a(i,r,y.label,u(t=>({label:t}))),description:a(i,void 0,y.description,u(t=>({description:t}))),sortText:a(i,void 0,y.sortText,u(t=>({sortText:t}))),canResolveChildren:a(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(i,!1,y.busy,u(t=>({busy:t}))),error:a(i,void 0,y.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:a(i,[],y.tags,(t,c)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:c.map(T.TestTag.from)}))}),f=i=>{const r=k.$TI.fromString(i.extId),t=new s(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(c=>T.TestTag.to({id:(0,A.$ZI)(c).tagId})),t},n=i=>{let r;for(const t of i.tests){const c=f(t.item);(0,S.$WP)(c).parent=r,r=c}return r};e.$aQ=n;class s{constructor(r,t,c,l){if(t.includes(k.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,S.$VP)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof o?void 0:m.parent}},children:{value:(0,O.$UP)(m,S.$WP,s),enumerable:!0,writable:!1},...E(m,c)})}}e.$bQ=s;class o extends s{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$cQ=o;class h extends O.$QP{constructor(r,t,c){super({controllerId:r,getDocumentVersion:l=>l&&c.getDocument(l)?.version,getApiFor:S.$WP,getChildren:l=>l.children,root:new o(r,t),toITestItem:T.TestItem.from})}}e.$dQ=h}),define(Ce[34],Ie([1,0,15,7,8,26,5,18,12,49,33,101,2,4,3,17,125,23,39,48,70,64,67,37]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,S=qe(S),k=qe(k);let m=class{#e;#t;#i;constructor(C,P,g){this.b=new Map,this.c=new Map,this.#e=C.getProxy(A.$uN.MainThreadCommands),this.d=P,this.#i=g,this.#t=C.getProxy(A.$uN.MainThreadTelemetry),this.converter=new d(this,w=>{const M=this.c.get(w);return M?.result===I.Void?M:void 0},P),this.f=[{processArgument(w){return(0,a.$ci)(w)}},{processArgument(w){return(0,O.$fo)(w,function(M){if(R.$Lt.isIRange(M))return k.Range.to(M);if(y.$Kt.isIPosition(M))return k.Position.to(M);if(R.$Lt.isIRange(M.range)&&u.URI.isUri(M.uri))return k.location.to(M);if(M instanceof o.$Oe)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const P=this.registerCommand(!1,C.id,async(...g)=>{const w=C.args.map((N,L)=>{if(!N.validate(g[L]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof g[L]=="object"?JSON.stringify(g[L],null,"	"):g[L]} `);return N.convert(g[L])}),M=await this.executeCommand(C.internalId,...w);return C.result.convert(M,g,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new S.$wN(()=>{P.dispose(),this.c.delete(C.id)})}registerCommand(C,P,g,w,M,N){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:g,thisArg:w,metadata:M,extension:N}),C&&this.#e.$registerCommand(P),new S.$wN(()=>{this.b.delete(P)&&C&&this.#e.$unregisterCommand(P)})}executeCommand(C,...P){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,P,!0)}async g(C,P,g){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,P,!1);{let w=!1;const M=(0,O.$fo)(P,function(N){if(N instanceof S.$xN)return k.Position.from(N);if(N instanceof S.$yN)return k.Range.from(N);if(N instanceof S.$IN)return k.location.from(N);if(S.$YO.isNotebookRange(N))return k.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,o.$Oe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,o.$Oe.wrap(N);if(N instanceof o.$Oe)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,w?new h.$Tw(M):M,g);return(0,a.$ci)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,P,!1);throw N}}}async h(C,P,g){const w=this.b.get(C);if(!w)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:L}=w;if(L?.args)for(let B=0;B<L.args.length;B++)try{(0,b.$wg)(P[B],L.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[B].name}' - ${L.args[B].description}`)}const G=r.$ge.create();try{return await M.apply(N,P)}catch(B){if(C===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...P);F&&(C=F.command)}if(this.d.error(B,C,w.extension?.identifier),!g)throw B;if(w.extension?.identifier){const F=this.#i.onExtensionError(w.extension.identifier,B);this.d.trace("forwarded error to extension?",F,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$qj)(B)),this.id=C,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,C,G.elapsed())}}j(C,P,g){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$up(P),duration:g})}$executeContributedCommand(C,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const g=this.b.get(C);return g?(P=P.map(w=>this.f.reduce((M,N)=>N.processArgument(M,g.extension?.identifier),w)),this.h(C,P,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(P=>(C&&(P=P.filter(g=>g[0]!=="_")),P))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[P,g]of this.b){const{metadata:w}=g;w&&(C[P]=w)}return Promise.resolve(C)}};e.$jQ=m,e.$jQ=m=Qe([Ve(0,n.$1P),Ve(1,p.$_j),Ve(2,c.$iQ)],m),e.$kQ=(0,f.$Fi)("IExtHostCommands");class d{constructor(C,P,g){this.d=C,this.f=P,this.g=g,this.delegatingCommandId=`__vsc${(0,l.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,P){if(!C)return;const g={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return g;const w=this.f(C.command);if(w)g.id=w.internalId,g.arguments=w.args.map((M,N)=>M.convert(C.arguments&&C.arguments[N]));else if((0,T.$Nb)(C.arguments)){const M=`${C.command} /${++this.c}`;this.b.set(M,C),P.add((0,E.$Uc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),g.$ident=M,g.id=this.delegatingCommandId,g.arguments=[M],this.g.trace("CommandsConverter#CREATE",C.command,M)}return g}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const P=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$lQ=d;class ${static{this.Uri=new $("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new $("position","A position in a text document",C=>S.$xN.isPosition(C),k.Position.from)}static{this.Range=new $("range","A range in a text document",C=>S.$yN.isRange(C),k.Range.from)}static{this.Selection=new $("selection","A selection in a text document",C=>S.$zN.isSelection(C),k.Selection.from)}static{this.Number=new $("number","",C=>typeof C=="number",C=>C)}static{this.String=new $("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=$.Arr($.String)}static Arr(C){return new $(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,P=>Array.isArray(P)&&P.every(g=>C.validate(g)),P=>P.map(g=>C.convert(g)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",C=>C instanceof S.$UN,k.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",C=>C instanceof S.$gP,k.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",C=>C instanceof s.$bQ,k.TestItem.from)}constructor(C,P,g,w){this.name=C,this.description=P,this.validate=g,this.convert=w}optional(){return new $(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,P){return new $(C??this.name,P??this.description,this.validate,this.convert)}}e.$mQ=$;class I{static{this.Void=new I("no result",C=>C)}constructor(C,P){this.description=C,this.convert=P}}e.$nQ=I;class D{constructor(C,P,g,w,M){this.id=C,this.internalId=P,this.description=g,this.args=w,this.result=M}}e.$oQ=D}),define(Ce[298],Ie([1,0,18,16,2,94,104,32,34,8,7]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0,O=qe(O),a=qe(a),R=qe(R);const y=[new p.$oQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of DocumentHighlight-instances.",E(a.DocumentHighlight.to))),new p.$oQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,s)=>{if((0,b.$Mb)(n))return;class o extends R.$PN{static to(i){const r=new o(i.name,a.SymbolKind.to(i.kind),i.containerName||"",new R.$IN(s[0],a.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=a.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return n.map(o.to)})),new p.$oQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$mQ.Uri,new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$mQ.Uri,p.$mQ.Range,new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$mQ.Uri,p.$mQ.Position,new p.$mQ("ch","Trigger character",n=>typeof n=="string",n=>n),new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$oQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$oQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$oQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$oQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location-instances.",E(a.location.to))),new p.$oQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Hover-instances.",E(a.Hover.to))),new p.$oQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$mQ.Uri,new p.$mQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(s=>R.$xN.isPosition(s)),n=>n.map(a.Position.from))],new p.$nQ("A promise that resolves to an array of ranges.",n=>n.map(s=>{let o;for(const h of s.reverse())o=new R.$TN(a.Range.to(h),o);return o}))),new p.$oQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$mQ.String.with("query","Search string")],new p.$nQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new p.$oQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(a.CallHierarchyItem.to))),new p.$oQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$mQ.CallHierarchyItem],new p.$nQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(a.CallHierarchyIncomingCall.to))),new p.$oQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$mQ.CallHierarchyItem],new p.$nQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(a.CallHierarchyOutgoingCall.to))),new p.$oQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:a.Range.to(n.range),placeholder:n.text}})),new p.$oQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("newName","The new symbol name")],new p.$nQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new p.$oQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$mQ.Uri,p.$mQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$nQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new p.$oQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$mQ.Uri],new p.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$PO(n.tokenTypes,n.tokenModifiers)})),new p.$oQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$mQ.Uri],new p.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$Gdb)(n);if(s.type==="full")return new R.$RO(s.data,void 0)})),new p.$oQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$mQ.Uri,p.$mQ.Range.optional()],new p.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$PO(n.tokenTypes,n.tokenModifiers)})),new p.$oQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$mQ.Uri,p.$mQ.Range],new p.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$Gdb)(n);if(s.type==="full")return new R.$RO(s.data,void 0)})),new p.$oQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$mQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$nQ("A promise that resolves to a CompletionList-instance.",(n,s,o)=>{if(!n)return new R.$6N([]);const h=n.suggestions.map(i=>a.CompletionItem.to(i,o));return new R.$6N(h,n.incomplete)})),new p.$oQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$nQ("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new p.$oQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$mQ.Uri,p.$mQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$nQ("A promise that resolves to an array of CodeLens-instances.",(n,s,o)=>E(h=>new R.$XN(a.Range.to(h.range),h.command&&o.fromInternal(h.command)))(n))),new p.$oQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$mQ.Uri,new p.$mQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$yN.isRange(n),n=>R.$zN.isSelection(n)?a.Selection.from(n):a.Range.from(n)),p.$mQ.String.with("kind","Code action kind to return code actions for").optional(),p.$mQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$nQ("A promise that resolves to an array of Command-instances.",(n,s,o)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(h.command)}else{const i=new R.$RN(h.title,h.kind?new R.$SN(h.kind):void 0);return h.edit&&(i.edit=a.WorkspaceEdit.to(h.edit)),h.command&&(i.command=o.fromInternal(h.command)),i.isPreferred=h.isPreferred,i}})(n))),new p.$oQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(s=>new R.$_N(a.Range.to(s.range),a.Color.to(s.color))):[])),new p.$oQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$mQ("color","The color to show and insert",n=>n instanceof R.$$N,a.Color.from),new p.$mQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new p.$nQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new p.$oQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$mQ.Uri,p.$mQ.Range],new p.$nQ("A promise that resolves to an array of Inlay objects",(n,s,o)=>n.map(a.InlayHint.to.bind(void 0,o)))),new p.$oQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of FoldingRange objects",(n,s)=>{if(n)return n.map(a.FoldingRange.to)})),new p.$oQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$nQ("A promise that resolves to an array of NotebookContentProvider static info objects.",E(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(s=>a.NotebookExclusiveDocumentPattern.to(s))})))),new p.$oQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$mQ.Uri,p.$mQ.Range,new p.$mQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$yN,n=>a.InlineValueContext.from(n))],new p.$nQ("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new p.$oQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$mQ("uriOrString","Uri-instance or string (only http/https)",n=>k.URI.isUri(n)||typeof n=="string"&&(0,S.$Pg)(n,S.Schemas.http,S.Schemas.https),n=>n),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),p.$mQ.String.with("label","").optional()],p.$nQ.Void),new p.$oQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$mQ.Uri.with("resource","Resource to open"),p.$mQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],p.$nQ.Void),new p.$oQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$mQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$mQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$mQ.String.with("title","Human readable title for the diff editor").optional(),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],p.$nQ.Void),new p.$oQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$mQ.String.with("title","Human readable title for the changes editor"),new p.$mQ("resourceList","List of resources to compare",n=>{for(const s of n){if(s.length!==3)return!1;const[o,h,i]=s;if(!k.URI.isUri(o)||!k.URI.isUri(h)&&h!==void 0&&h!==null||!k.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],p.$nQ.Void),new p.$oQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$mQ.TypeHierarchyItem],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$mQ.TypeHierarchyItem],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$mQ.TestItem],p.$nQ.Void),new p.$oQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$mQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$nQ.Void),new p.$oQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$mQ.String.with("name","The context key name"),new p.$mQ("value","The context key value",()=>!0,n=>n)],p.$nQ.Void),new p.$oQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$mQ.Uri,p.$mQ.StringArray,new p.$mQ("MappedEditsContext","Mapped Edits Context",n=>a.MappedEditsContext.is(n),n=>a.MappedEditsContext.from(n))],new p.$nQ("A promise that resolves to a workspace edit or null",n=>n?a.WorkspaceEdit.to(n):null)),new p.$oQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$mQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?a.Range.from(n.initialRange):void 0,initialSelection:R.$zN.isSelection(n.initialSelection)?a.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?a.Position.from(n.position):void 0}})],p.$nQ.Void)];class u{static register(s){y.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",T.$Ej)}}e.$soc=u;function E(n){return s=>{if(Array.isArray(s))return s.map(n)}}function f(n){if(!Array.isArray(n))return;const s=[];for(const o of n)O.$Hu(o)?s.push(a.DefinitionLink.to(o)):s.push(a.location.to(o));return s}}),define(Ce[299],Ie([1,0,2,34]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0;class k{constructor(A,T,p,a,R){this.a=T,this.b=p,this.c=a;const y=new S.$oQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new S.$mQ("showOptions","Show Options",u=>!0,u=>u),new S.$mQ("resource","Interactive resource Uri",u=>!0,u=>u),new S.$mQ("controllerId","Notebook controller Id",u=>!0,u=>u),new S.$mQ("title","Interactive editor title",u=>!0,u=>u)],new S.$nQ("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:b.URI.revive(u.notebookUri),inputUri:b.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:b.URI.revive(u.notebookUri),inputUri:b.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,p,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Tpc=k}),define(Ce[300],Ie([1,0,18,11,22,6,4,29,2,19,12,5,34,8,7,83,239,25,39,240]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0,e.$2pc=$,E=qe(E);let r=class{constructor(D,v,C,P,g){this.m=v,this.n=C,this.o=P,this.q=g,this.b=new T.$Cc,this.c=new T.$Cc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$uN.MainThreadNotebookKernels);const w=new u.$oQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$mQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],u.$nQ.Void),M=new u.$oQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$mQ.Uri],new u.$nQ("A promise that resolves to an array of variables",(N,L)=>N.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(M)}createNotebookController(D,v,C,P,g,w){for(const re of this.j.values())if(re.controller.id===v&&a.$qn.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${v}`);const L=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${D.identifier}'`);let G=!1;const B=new O.$me,F=new O.$me,V={id:$(D.identifier,v),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:P||D.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let ae=g??L,$e,_;this.a.$addKernel(M,V).catch(re=>{console.log(re),G=!0});let ge=0;const se=()=>{if(G)return;const re=++ge;Promise.resolve().then(()=>{re===ge&&this.a.$updateKernel(M,V)})},ce=new T.$Cc,we={get id(){return v},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return V.label},set label(re){V.label=re??D.displayName??D.name,se()},get detail(){return V.detail??""},set detail(re){V.detail=re,se()},get description(){return V.description??""},set description(re){V.description=re,se()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(re){V.supportedLanguages=re,se()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(re){V.supportsExecutionOrder=re,se()},get rendererScripts(){return V.preloads?V.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ae},set executeHandler(re){ae=re??L},get interruptHandler(){return $e},set interruptHandler(re){$e=re,V.supportsInterrupt=!!re,se()},set variableProvider(re){(0,o.$7G)(D,"notebookVariableProvider"),_=re,V.hasVariableProvider=!!re,re?.onDidChangeVariables(Pe=>N.a.$variablesUpdated(Pe.uri)),se()},get variableProvider(){return _},createNotebookCellExecution(re){if(G)throw new Error("notebook controller is DISPOSED");if(!ce.has(re.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,$(D.identifier,this.id))},createNotebookExecution(re){if((0,o.$7G)(D,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!ce.has(re.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,$(D.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${M}], DISPOSED`),G=!0,this.j.delete(M),B.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(re,Pe){Pe===f.NotebookControllerAffinity2.Hidden&&(0,o.$7G)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,re.uri,Pe)},onDidReceiveMessage:F.event,postMessage(re,Pe){return(0,o.$7G)(D,"notebookMessaging"),N.a.$postMessage(M,Pe&&N.n.getIdByEditor(Pe),re)},asWebviewUri(re){return(0,o.$7G)(D,"notebookMessaging"),(0,n.$dDb)(re,N.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:we,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:ce}),we}getIdByController(D){for(const[v,C]of this.j)if(C.controller===D)return $(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,v){const C=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,v);const g={dispose:()=>{this.f.delete(C),P.a.$removeKernelDetectionTask(C)}};return this.f.set(C,g),g}registerKernelSourceActionProvider(D,v,C){const P=this.i++,g=typeof C.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,w=this;this.h.set(P,C),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,v);let M;return g!==void 0&&(M=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.h.delete(P),w.a.$removeKernelSourceActionProvider(P,P),M?.dispose()}}}async $provideKernelSourceActions(D,v){const C=this.h.get(D);if(C){const P=new A.$Vc;return(await C.provideNotebookKernelSourceActions(v)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.o.converter,P))}return[]}$acceptNotebookAssociation(D,v,C){const P=this.j.get(D);if(P){const g=this.n.getNotebookDocument(p.URI.revive(v));C?P.associatedNotebooks.set(g.uri,!0):P.associatedNotebooks.delete(g.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,g.uri.toString(),C),P.onDidChangeSelection.fire({selected:C,notebook:g.apiNotebook})}}async $executeCells(D,v,C){const P=this.j.get(D);if(!P)return;const g=this.n.getNotebookDocument(p.URI.revive(v)),w=[];for(const M of C){const N=g.getCell(M);N&&w.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,g.uri.toString(),w.length),await P.controller.executeHandler.call(P.controller,w,g.apiNotebook,P.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,v,C){const P=this.j.get(D);if(!P)return;const g=this.n.getNotebookDocument(p.URI.revive(v));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,g.apiNotebook);else for(const w of C){const M=g.getCell(w);M&&this.b.get(M.uri)?.cancel()}if(P.controller.interruptHandler){const w=this.c.get(g.uri);this.c.delete(g.uri),C.length&&Array.isArray(w)&&w.length&&w.forEach(M=>M.dispose())}}async $provideVariables(D,v,C,P,g,w,M){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument(p.URI.revive(C)),G=N.controller.variableProvider;if(!G)return;let B;if(P!==void 0){if(B=this.s[P],!B)return}else this.s={};const F=g==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,V=G.provideVariables(L.apiNotebook,B,F,w,M);let ae=0;for await(const $e of V){if(M.isCancellationRequested)return;const _={id:this.r++,name:$e.variable.name,value:$e.variable.value,type:$e.variable.type,interfaces:$e.variable.interfaces,language:$e.variable.language,expression:$e.variable.expression,hasNamedChildren:$e.hasNamedChildren,indexedChildrenCount:$e.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[_.id]=$e.variable,this.a.$receiveVariable(v,_),ae++>=i.$WK)return}}$acceptKernelMessageFromRenderer(D,v,C){const P=this.j.get(D);if(!P)return;const g=this.n.getEditorById(v);P.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:C}))}$cellExecutionChanged(D,v,C){const g=this.n.getNotebookDocument(p.URI.revive(D)).getCell(v);if(g){const w=C?E.NotebookCellExecutionState.to(C):f.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:g.apiCell,state:w})}}_createNotebookCellExecution(D,v){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const g=new c(v,P,this.a);this.b.set(P.uri,g);const w=g.onDidChangeState(()=>{g.state===t.Resolved&&(g.dispose(),w.dispose(),this.b.delete(P.uri))});return g.asApiObject()}_createNotebookExecution(D,v){const C=this.n.getNotebookDocument(D.uri),P=D.getCells().find(M=>{const N=C.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const g=new m(v,C,this.a),w=g.onDidChangeState(()=>{g.state===l.Resolved&&(g.dispose(),w.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[g,w]),g.asApiObject()}};e.$1pc=r,e.$1pc=r=Qe([Ve(4,R.$_j)],r);var t;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(t||(t={}));class c extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,v,C){super(),this.m=v,this.n=C,this.b=c.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new k.$xe),this.h=new d(10,P=>this.s(P)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const v=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Tw(v))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let v=this.m;if(D&&(v=this.m.notebook.getCellFromApiCell(D)),!v)throw new Error("INVALID cell");return v.handle}y(D){return D.map(v=>{const C=f.$3O.ensureUniqueMimeTypes(v.items,!0);return C===v.items?E.NotebookCellOutput.from(v):E.NotebookCellOutput.from({items:C,id:v.id,metadata:v.metadata})})}async z(D,v,C){const P=this.w(v),g=this.y((0,b.$4b)(D));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:P,append:C,outputs:g})}async C(D,v,C){return D=f.$3O.ensureUniqueMimeTypes((0,b.$4b)(D),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:D.map(E.NotebookCellOutputItem.from),outputId:v.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,P,g){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const w=g?{message:g.message,stack:g.stack,location:g?.location?{startLineNumber:g.location.start.line,startColumn:g.location.start.character,endLineNumber:g.location.end.line,endColumn:g.location.end.character}:void 0,uri:g.uri}:void 0;D.n.$completeExecution(D.b,new h.$Tw({runEndTime:P,lastRunSuccess:C,error:w}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,P){return D.t(),D.z(C,P,!0)},replaceOutput(C,P){return D.t(),D.z(C,P,!1)},appendOutputItems(C,P){return D.t(),D.C(C,P,!0)},replaceOutputItems(C,P){return D.t(),D.C(C,P,!1)}})}}var l;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(l||(l={}));class m extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,v,C){super(),this.h=v,this.j=C,this.b=m.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new k.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(D,v){this.f=D,this.g=v,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new S.$3h,this.b=Date.now(),(0,S.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const v=this.a;return this.a=[],this.g(v).finally(()=>D.complete())}}function $(I,D){return`${I.value}/${D}`}}),define(Ce[57],Ie([1,0,6,5,3,2,17,4,7,189,14,220,22,37,221,222,35,11,8,34,38]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=e.$8oc=e.$7oc=void 0,e.$7oc=(0,k.$Fi)("IExtHostTerminalService");class t extends T.$Wc{constructor(g,w,M,N){super(),this.u=g,this._id=w,this.w=M,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new b.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(G,B=!0){L.C(),L.u.$sendText(L._id,G,B)},show(G){L.C(),L.u.$show(L._id,G)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??w?.cwd??void 0,env:g.env??void 0,icon:D(g.iconPath)??void 0,color:s.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(g.location,w?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,w,M,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z(g,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,w){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in g?{viewColumn:h.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,w){this.j=Object.freeze({code:g,reason:w})}setDimensions(g,w){return g===this.f&&w===this.h||g===0||w===0?!1:(this.f=g,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(w=>{w!==g&&(this.b=Promise.resolve(g))})}}e.$8oc=t;class c{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new b.$me,this.onProcessData=this.a.event,this.b=new b.$me,this.d=new b.$me,this.onDidChangeProperty=this.d.event,this.f=new b.$me,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,w){this.g.setDimensions?.({columns:g,rows:w})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:f.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:f.ProcessPropertyType.Title,value:w})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,m=class extends T.$Wc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,w,M){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Xc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new b.$me,this.onDidCloseTerminal=this.H.event,this.I=new b.$me,this.onDidOpenTerminal=this.I.event,this.J=new b.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new b.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new b.$me,this.onDidChangeTerminalState=this.M.event,this.N=new b.$me,this.onDidChangeShell=this.N.event,this.O=new b.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new b.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(S.$uN.MainThreadTerminalService),this.y=new n.$wxb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:N=>{const L=G=>{const B=G;return this.getTerminalById(B.instanceId)?.value};switch(N?.$mid){case r.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let G=0;G<N.length&&N[G].$mid===r.MarshalledId.TerminalContext;G++)N[G]=L(N[G]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,w){const M=new t(this.a,(0,E.$2g)(),g,g.name),N=new c(g.pty);return M.createExtensionTerminal(g.location,w,this.R(g,w).resolvedExtHostIdentifier,D(g.iconPath),v(g.color)).then(L=>{const G=this.S(L,N);this.h[L]=G}),this.f.push(M),M.value}R(g,w){if(w=w||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const M=g.location.parentTerminal;if(M){const N=this.f.find(L=>L.value===M);N&&(w.resolvedExtHostIdentifier=N._id)}}else g.location&&typeof g.location!="object"?w.location=g.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(g,w){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const N=new c(w),L=this.S(g,N);this.h[g]=L}async $acceptActiveTerminalChanged(g){const w=this.b;if(g===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(g);M&&(this.b=M,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,w){const M=this.getTerminalById(g);M&&this.O.fire({terminal:M.value,data:w})}async $acceptTerminalDimensions(g,w,M){const N=this.getTerminalById(g);N&&N.setDimensions(w,M)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(g,w){const M=this.getTerminalById(g);M&&this.P.fire({terminal:M.value,...w})}async $acceptTerminalMaximumDimensions(g,w,M){this.g.get(g)?.resize(w,M)}async $acceptTerminalTitleChange(g,w){const M=this.getTerminalById(g);M&&(M.name=w)}async $acceptTerminalClosed(g,w,M){const N=this.X(this.f,g);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(w,M),this.H.fire(L.value)}}$acceptTerminalOpened(g,w,M,N){if(w){const B=this.X(this.f,w);if(B!==null){this.f[B]._id=g,this.I.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},G=new t(this.a,g,L,M);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,w){this.getTerminalById(g)?._setProcessId(w)}async $startExtensionTerminal(g,w){const M=this.getTerminalById(g);if(!M)return{message:(0,a.localize)(0,null,g)};M.isOpen||await new Promise(L=>{const G=this.onDidOpenTerminal(async B=>{B===M.value&&(G.dispose(),L())})});const N=this.g.get(g);N?N.startSendingEvents(w):this.j[g]={initialDimensions:w}}S(g,w){const M=new T.$Vc;M.add(w.onProcessReady(L=>this.a.$sendProcessReady(g,L.pid,L.cwd,L.windowsPty))),M.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty(g,L))),this.y.startBuffering(g,w.onProcessData),M.add(w.onProcessExit(L=>this.U(g,L))),this.g.set(g,w);const N=this.j[g];return N&&w instanceof c&&(w.startSendingEvents(N.initialDimensions),delete this.j[g]),M}$acceptProcessAckDataEvent(g,w){this.g.get(g)?.acknowledgeDataEvent(w)}$acceptProcessInput(g,w){this.g.get(g)?.input(w)}$acceptTerminalInteraction(g){const w=this.getTerminalById(g);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(g,w){this.getTerminalById(g)?.setSelection(w)}$acceptProcessResize(g,w,M){try{this.g.get(g)?.resize(w,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(g,w){this.g.get(g)?.shutdown(w)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(g,{type:f.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(w=>this.a.$sendProcessProperty(g,{type:f.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new p.$wN(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,w,M){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,M),this.a.$registerProfileProvider(w,g.identifier.value),new p.$wN(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(g,w,M){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,M),this.a.$registerQuickFixProvider(g,w),new p.$wN(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,w){const M=new u.$xe().token;if(M.isCancellationRequested)return;const N=this.D.get(g);if(!N)return;const L=await N.provideTerminalQuickFixes(w,M);if(L===null||Array.isArray(L)&&L.length===0)return;const G=new T.$Vc;if(this.w.value=G,!Array.isArray(L))return L?h.TerminalQuickFix.from(L,this.Q.converter,G):void 0;const B=[];for(const F of L){const V=h.TerminalQuickFix.from(F,this.Q.converter,G);V&&B.push(V)}return B}async $createContributedProfileTerminal(g,w){const M=new u.$xe().token;let N=await this.C.get(g)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,w);return}this.createTerminalFromOptions(N.options,w)}}async $provideLinks(g,w){const M=this.getTerminalById(g);if(!M)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const L=new u.$xe;this.G.set(g,L);const G=[],B={terminal:M.value,line:w},F=[];for(const $e of this.z)F.push(o.Promises.withAsyncBody(async _=>{L.token.onCancellationRequested(()=>_({provider:$e,links:[]}));const ge=await $e.provideTerminalLinks(B,L.token)||[];L.token.isCancellationRequested||_({provider:$e,links:ge})}));const V=await Promise.all(F);if(L.token.isCancellationRequested)return[];const ae=new Map;for(const $e of V)$e&&$e.links.length>0&&G.push(...$e.links.map(_=>{const ge={id:l++,startIndex:_.startIndex,length:_.length,label:_.tooltip};return ae.set(ge.id,{provider:$e.provider,link:_}),ge}));return this.F.set(g,ae),G}$activateLink(g,w){const M=this.F.get(g)?.get(w);M&&M.provider.handleTerminalLink(M.link)}U(g,w){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const M=this.h[g];M&&(M.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,w)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const w=this.f.findIndex(M=>M.value===g);return w>=0?w:null}W(g,w){const M=this.X(g,w);return M!==null?g[M]:null}X(g,w){const M=g.findIndex(N=>N._id===w);return M>=0?M:null}getEnvironmentVariableCollection(g){let w=this.n.get(g.identifier.value);return w||(w=this.B(new d),this.Z(g.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(g,w){const M=(0,y.$Cs)(w.map),N=(0,y.$Ds)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(g,w.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections(g){g.forEach(w=>{const M=w[0],N=this.B(new d(w[1]));this.Z(M,N)})}$acceptDefaultProfile(g,w){const M=this.s;this.s=g,this.u=w,M?.path!==g.path&&this.N.fire(g.path)}Z(g,w){this.n.set(g,w),this.B(w.onDidChangeCollection(()=>{this.Y(g,w)}))}};e.$9oc=m,e.$9oc=m=Qe([Ve(1,i.$kQ),Ve(2,A.$1P)],m);class d extends T.$Wc{get persistent(){return this.b}set persistent(g){this.b=g,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(g){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new b.$me,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const w=this.j(g);let M=this.a.get(w);return M||(M=new $(this,g),this.a.set(w,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(g,w,M,N){this.g(g,{value:w,type:p.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append(g,w,M,N){this.g(g,{value:w,type:p.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend(g,w,M,N){this.g(g,{value:w,type:p.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}g(g,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(g,w.scope),N=this.map.get(M),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==w.value||N.type!==w.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const G=this.h(g,w.scope),B={variable:g,...w,options:L};this.map.set(G,B),this.f.fire()}}get(g,w){const M=this.h(g,w),N=this.map.get(M);return N?C(N):void 0}h(g,w){const M=this.j(w);return M.length?`${g}:::${M}`:g}j(g){return this.m(g?.workspaceFolder)??""}m(g){return g?g.uri.toString():void 0}getVariableMap(g){const w=new Map;for(const[M,N]of this.map)this.j(N.scope)===this.j(g)&&w.set(N.variable,C(N));return w}delete(g,w){const M=this.h(g,w);this.map.delete(M),this.f.fire()}clear(g){if(g?.workspaceFolder){for(const[w,M]of this.map)M.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(w);this.n(g)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(g,w){const M=this.j(w),N=this.descriptionMap.get(M);if(!N||N.description!==g){let L;typeof g=="string"?L=g:L=g?.value.split(`

`)[0];const G={description:L,scope:w};this.descriptionMap.set(M,G),this.f.fire()}}getDescription(g){const w=this.j(g);return this.descriptionMap.get(w)?.description}n(g){const w=this.j(g);this.descriptionMap.delete(w)}}class ${get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,w){this.b=g,this.d=w,this.a=new b.$me}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,w,M){this.b.replace(g,w,M,this.d)}append(g,w,M){this.b.append(g,w,M,this.d)}prepend(g,w,M){this.b.prepend(g,w,M,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,w){this.b.getVariableMap(this.d).forEach((M,N)=>g.call(w,N,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let I=class extends m{constructor(g,w){super(!1,g,w)}createTerminal(g,w,M){throw new R.$bb}createTerminalFromOptions(g,w){throw new R.$bb}};e.$0oc=I,e.$0oc=I=Qe([Ve(0,i.$kQ),Ve(1,A.$1P)],I);function D(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function v(P){return s.ThemeColor.isThemeColor(P)?P:void 0}function C(P){const g={...P};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[126],Ie([1,0,7,4,3,5,17,57,6,2,11]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=e.$gqc=void 0,e.$gqc=(0,k.$Fi)("IExtHostTerminalShellIntegration");let y=class extends S.$Wc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new p.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(O.$uN.MainThreadTerminalShellIntegration),this.B((0,S.$Uc)(()=>{for(const[h,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const h=o.value;let i=this.b.get(s);i||(i=new u(o.value,this.f),this.b.set(s,i),i.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(s,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),o.shellIntegration=i.value),this.c.fire({terminal:h,shellIntegration:i.value})}$shellExecutionStart(s,o,h,i,r){this.b.has(s)||this.$shellIntegrationChange(s);const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.startShellExecution(t,r)}$shellExecutionEnd(s,o,h,i,r){const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.endShellExecution(t,r)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,a.$xc)(o)?a.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$hqc=y,e.$hqc=y=Qe([Ve(0,A.$1P),Ve(1,T.$7oc)],y);class u extends S.$Wc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new S.$Vc),this.f=this.B(new p.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$me),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(t);const c={value:t,confidence:b.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=h.startShellExecution(c,h.c,!0).value;return h.b=!0,l}}}startShellExecution(s,o,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(s,o);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;a.URI.isUri(this.c)?o=!a.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return R.$6h.EMPTY;this.a=new f}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends S.$Wc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Eh);const s=this.a;return new R.$6h(async h=>{this.b.push(h),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[127],Ie([1,0,62,14,97,8,7]),function(oe,e,b,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0,O=qe(O);class T{static{this.c=new k.$6P("TextEditorDecorationType")}constructor(u,E,f){const n=T.c.nextId();u.$registerTextEditorDecorationType(E.identifier,n,O.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$8P=T;class p{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let f=null;if(u instanceof A.$xN)f=new A.$yN(u,u);else if(u instanceof A.$yN)f=u;else throw new Error("Unrecognized location");this.l(f,E,!1)}insert(u,E){this.k(),this.l(new A.$yN(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof A.$yN)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,f){const n=this.c.validateRange(u);this.g.push({range:n,text:E,forceMoveMarkers:f})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,S.$9)("endOfLine");this.h=u}}class a{constructor(u,E,f,n){this.c=u,this.d=E,this._accept(f),this.e=n;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let f=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(f=!0,E.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,f=!0,E.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(f=!0,E.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,f=!0,E.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(f=!0,E.insertSpaces=n):this.j!==n&&(this.j=n,f=!0,E.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,f=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,f=!0,E.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(f)})}}e.$9P=a;class R{constructor(u,E,f,n,s,o,h,i){this.id=u,this.j=E,this.k=f,this.g=!1,this.h=new Set,this.c=s,this.d=new a(this.j,this.id,o,f),this.e=h,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new S.$$("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof A.$zN))throw(0,S.$9)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(c=>!(c instanceof A.$zN)))throw(0,S.$9)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new S.$$("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new S.$$("viewColumn")},edit(t,c={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new p(n.value,c);return t(l),r.m(l)},insertSnippet(t,c,l={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!c||Array.isArray(c)&&c.length===0)m=r.c.map(d=>O.Range.from(d));else if(c instanceof A.$xN){const{lineNumber:d,column:$}=O.Position.from(c);m=[{startLineNumber:d,startColumn:$,endLineNumber:d,endColumn:$}]}else if(c instanceof A.$yN)m=[O.Range.from(c)];else{m=[];for(const d of c)if(d instanceof A.$yN)m.push(O.Range.from(d));else{const{lineNumber:$,column:I}=O.Position.from(d);m.push({startLineNumber:$,startColumn:I,endLineNumber:$,endColumn:I})}}return E.$tryInsertSnippet(u,n.value.version,t.value,m,l)},setDecorations(t,c){const l=c.length===0;l&&!r.h.has(t.key)||(l?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(O.$XP(c))return E.$trySetDecorations(u,t.key,O.$YP(c));{const m=new Array(4*c.length);for(let d=0,$=c.length;d<$;d++){const I=c[d];m[4*d]=I.start.line+1,m[4*d+1]=I.start.character+1,m[4*d+2]=I.end.line+1,m[4*d+3]=I.end.character+1}return E.$trySetDecorationsFast(u,t.key,m)}}))},revealRange(t,c){r.n(()=>E.$tryRevealRange(u,O.Range.from(t),c||A.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(u,O.ViewColumn.from(t))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,b.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,b.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,b.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,b.ok)(!this.g),this.f=u}_acceptSelections(u){(0,b.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const f=E.edits.map(s=>s.range);f.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=f.length-1;s<o;s++){const h=f[s].end;if(f[s+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=E.edits.map(s=>({range:O.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,n,{setEndOfLine:typeof E.setEndOfLine=="number"?O.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$0P=R}),define(Ce[58],Ie([1,0,62,6,4,2,3,5,123,17,127,8,12,29,16,40,47]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0,b=qe(b),y=qe(y);class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Cc,this.d=new S.$me,this.e=new S.$me,this.f=new S.$me,this.g=new S.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],c=[],l=[];if(r.removedDocuments)for(const m of r.removedDocuments){const d=O.URI.revive(m),$=this.c.get(d);$?.unref()&&(this.c.delete(d),t.push($.value))}if(r.addedDocuments)for(const m of r.addedDocuments){const d=O.URI.revive(m.uri);let $=this.c.get(d);if($&&d.scheme!==f.Schemas.vscodeNotebookCell&&d.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);$||($=new o(new p.$4P(this.h.getProxy(T.$uN.MainThreadDocuments),d,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(d,$),c.push($.value)),$.ref()}if(r.removedEditors)for(const m of r.removedEditors){const d=this.b.get(m);this.b.delete(m),d&&l.push(d)}if(r.addedEditors)for(const m of r.addedEditors){const d=O.URI.revive(m.documentUri);b.ok(this.c.has(d),`document '${d}' does not exist`),b.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const $=this.c.get(d).value,I=new R.$0P(m.id,this.h.getProxy(T.$uN.MainThreadTextEditors),this.i,new s.$X(()=>$.document),m.selections.map(y.Selection.to),m.options,m.visibleRanges.map(D=>y.Range.to(D)),typeof m.editorPosition=="number"?y.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,I)}r.newActiveEditor!==void 0&&(b.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,k.$Rc)(t),(0,k.$Rc)(l),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(c),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$$P=h,e.$$P=h=Qe([Ve(0,a.$1P),Ve(1,u.$_j)],h),e.$_P=(0,A.$Fi)("IExtHostDocumentsAndEditors")}),define(Ce[96],Ie([1,0,11,23,22,6,273,76,4,38,15,37,3,12,5,34,58,17,125,8,7,242,55,82,56,25]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=e.$rpc=e.$qpc=e.$ppc=e.$opc=void 0,i=qe(i);let $=0;const I=new WeakMap;e.$opc=(0,u.$Fi)("IExtHostTesting");let D=class extends p.$Wc{constructor(_,ge,se,ce){super(),this.C=ge,this.D=se,this.F=ce,this.f=this.B(new O.$me),this.g=new Map,this.w=this.B(new O.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(f.$uN.MainThreadTesting),this.m=new G(this.h),this.j=new g(this.h,ge),se.registerArgumentProcessor({processArgument:we=>{switch(we?.$mid){case a.MarshalledId.TestItemContext:{const re=we,Pe=re.tests[re.tests.length-1].item.extId;return this.g.get(c.$TI.root(Pe))?.collection.tree.get(Pe)?.actual??(0,h.$aQ)(we)}case a.MarshalledId.TestMessageMenuArgs:{const{test:re,message:Pe}=we,Me=re.item.extId;return{test:this.g.get(c.$TI.root(Me))?.collection.tree.get(Me)?.actual??(0,h.$aQ)({$mid:a.MarshalledId.TestItemContext,tests:[re]}),message:i.TestMessage.to(Pe)}}default:return we}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const we=await se.executeCommand(t.TestCommandId.GetExplorerSelection),re=Pe=>{const Me=this.g.get(c.$TI.root(Pe));if(Me)return c.$TI.isRoot(Pe)?Me.controller:Me.collection.tree.get(Pe)?.actual};return{include:we?.include.map(re).filter(R.$ng)||[],exclude:we?.exclude.map(re).filter(R.$ng)||[]}})}createTestController(_,ge,se,ce){if(this.g.has(ge))throw new Error(`Attempt to insert a duplicate controller with ID "${ge}"`);const we=new p.$Vc,re=we.add(new h.$dQ(ge,se,this.F));re.root.label=se;const Pe=new Map,Me=new Set,Y=this.h,q={items:re.root.children,get label(){return se},set label(ve){se=ve,re.root.label=ve,Y.$updateController(ge,{label:se})},get refreshHandler(){return ce},set refreshHandler(ve){ce=ve,Y.$updateController(ge,{canRefresh:!!ve})},get id(){return ge},createRunProfile:(ve,ue,be,de,X,Z)=>{let me=(0,T.$tj)(ve);for(;Pe.has(me);)me++;return new F(this.h,Pe,Me,this.w.event,ge,me,ve,ue,be,de,X,Z)},createTestItem(ve,ue,be){return new h.$bQ(ge,ve,ue,be)},createTestRun:(ve,ue,be=!0)=>this.j.createTestRun(_,ge,re,ve,ue,be),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ue=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ue.map(be=>c.$TI.fromExtHostTestItem(be,ge).toString()))}},set resolveHandler(ve){re.resolveHandler=ve},get resolveHandler(){return re.resolveHandler},dispose:()=>{we.dispose()}};Y.$registerTestController(ge,se,!!ce),we.add((0,p.$Uc)(()=>Y.$unregisterTestController(ge)));const ee={controller:q,collection:re,profiles:Pe,extension:_,activeProfiles:Me};return this.g.set(ge,ee),we.add((0,p.$Uc)(()=>this.g.delete(ge))),we.add(re.onDidGenerateDiff(ve=>Y.$publishDiff(ge,ve.map(m.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(_,ge=k.CancellationToken.None){const se=w(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(se.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:V[se.kind],targets:[{testIds:_.include?.map(we=>c.$TI.fromExtHostTestItem(we,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map(we=>we.id)},ge)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,ge,se){return(await this.j.getCoverageDetails(_,ge,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,ge){this.g.get(_)?.profiles.get(ge)?.configureHandler?.()}$setDefaultRunProfiles(_){const ge=new Map;for(const[se,ce]of Object.entries(_)){const we=this.g.get(se);if(!we)continue;const re=new Map,Pe=ce.filter(Y=>!we.activeProfiles.has(Y)),Me=[...we.activeProfiles].filter(Y=>!ce.includes(Y));for(const Y of Pe)re.set(Y,!0),we.activeProfiles.add(Y);for(const Y of Me)re.set(Y,!1),we.activeProfiles.delete(Y);re.size&&ge.set(se,re)}this.w.fire(ge)}async $refreshTests(_,ge){await this.g.get(_)?.controller.refreshHandler?.(ge)}$publishTestResults(_){this.results=Object.freeze(_.map(ge=>{const se=i.TestResults.to(ge);return I.set(se,ge.id),se}).concat(this.results).sort((ge,se)=>se.completedAt-ge.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,ge){const se=this.g.get(c.$TI.fromString(_).controllerId)?.collection;se&&(await se.expand(_,ge<0?1/0:ge),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(ge=>m.TestsDiffOp.deserialize({asCanonicalUri:se=>se},ge)))}async $runControllerTests(_,ge){return Promise.all(_.map(se=>this.G(se,!1,ge)))}async $startContinuousRun(_,ge){const se=new k.$xe(ge),ce=await Promise.all(_.map(we=>this.G(we,!0,se.token)));return!ge.isCancellationRequested&&!ce.some(we=>we.error)&&await new Promise(we=>ge.onCancellationRequested(we)),se.dispose(!0),ce}async $provideTestFollowups(_,ge){const se=this.results.find(re=>I.get(re)===_.resultId),ce=se&&ae(c.$TI.fromString(_.extId),se?.results);if(!ce)return[];let we=[];return await Promise.all([...this.y].map(async re=>{try{const Pe=await re.provideFollowup(se,ce,_.taskIndex,_.messageIndex,ge);Pe&&(we=we.concat(Pe))}catch(Pe){this.C.error("Error thrown while providing followup for test message",Pe)}})),ge.isCancellationRequested?[]:we.map(re=>{const Pe=$++;return this.z.set(Pe,re),{title:re.title,id:Pe}})}$disposeTestFollowups(_){for(const ge of _)this.z.delete(ge)}$executeTestFollowup(_){const ge=this.z.get(_);return ge?this.D.executeCommand(ge.command,...ge.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_)}getMetadataForRun(_){for(const ge of this.j.trackers){const se=ge.getTaskIdForRun(_);if(se)return{taskId:se,runId:ge.id}}}async G(_,ge,se){const ce=this.g.get(_.controllerId);if(!ce)return{};const{collection:we,profiles:re,extension:Pe}=ce,Me=re.get(_.profileId);if(!Me)return{};const Y=_.testIds.map(ue=>we.tree.get(ue)).filter(R.$ng),q=_.excludeExtIds.map(ue=>ce.collection.tree.get(ue)).filter(R.$ng).filter(ue=>Y.some(be=>be.fullId.compare(ue.fullId)===c.TestPosition.IsChild));if(!Y.length)return{};const ee=new r.$0O(Y.some(ue=>ue.actual instanceof h.$cQ)?void 0:Y.map(ue=>ue.actual),q.map(ue=>ue.actual),Me,ge),ve=(0,m.$WI)(_)&&this.j.prepareForMainThreadTestRun(Pe,ee,M.fromInternal(_,ce.collection),Me,se);try{return await Me.runHandler(ee,se),{}}catch(ue){return{error:String(ue)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await O.Event.toPromise(ve.onEnd)}}};e.$ppc=D,e.$ppc=D=Qe([Ve(0,o.$1P),Ve(1,E.$_j),Ve(2,n.$kQ),Ve(3,s.$_P)],D);const v=1e4;var C;(function($e){$e[$e.Running=0]="Running",$e[$e.Cancelling=1]="Cancelling",$e[$e.Ended=2]="Ended"})(C||(C={}));class P extends p.$Wc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(_,ge,se,ce,we,re){super(),this.z=_,this.C=ge,this.D=se,this.F=ce,this.G=we,this.c=C.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$me),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new k.$xe(re));const Pe=this.B(new b.$Rh(()=>this.H(),v));this.B(this.j.token.onCancellationRequested(()=>Pe.schedule()));const Me=new O.$me;this.w=Me.event,this.B((0,p.$Uc)(()=>{Me.fire(),Me.dispose()}))}getTaskIdForRun(_){for(const[ge,{run:se}]of this.g)if(se===_)return ge}cancel(){this.c===C.Running?(this.j.cancel(),this.c=C.Cancelling):this.c===C.Cancelling&&this.H()}async getCoverageDetails(_,ge,se){const[,ce]=c.$TI.fromString(_).path,we=this.y.get(_);if(!we)return[];const{report:re,extIds:Pe}=we,Me=this.g.get(ce);if(!Me)throw new Error("unreachable: run task was not found");let Y;if(ge&&re instanceof r.$cP){const ee=Pe.indexOf(ge);if(ee===-1)return[];Y=re.fromTests[ee]}return await(Y?this.F?.loadDetailedCoverageForTest?.(Me.run,re,Y,se):this.F?.loadDetailedCoverage?.(Me.run,re,se))??[]}createRun(_){const ge=this.z.id,se=this.z.controllerId,ce=(0,y.$2g)(),we=Y=>(q,...ee)=>{if(Pe){this.D.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.J(q),Y(q,...ee)},re=(Y,q)=>{const ee=q instanceof Array?q.map(i.TestMessage.from):[i.TestMessage.from(q)];if(Y.uri&&Y.range){const ve={range:i.Range.from(Y.range),uri:Y.uri};for(const ue of ee)ue.location=ue.location||ve}this.C.$appendTestMessagesInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),ee)};let Pe=!1;const Me={isPersisted:this.z.isPersisted,token:this.j.token,name:_,onDidDispose:this.w,addCoverage:Y=>{if(Pe)return;const q=Y instanceof r.$cP?Y.fromTests:[];if(q.length){(0,d.$7G)(this.G,"attributableCoverage");for(const ue of q)this.J(ue)}const ee=Y.uri.toString(),ve=new c.$TI([ge,ce,ee]).toString();this.y.set(ve,{report:Y,extIds:q.map(ue=>c.$TI.fromExtHostTestItem(ue,se).toString())}),this.C.$appendCoverage(ge,ce,i.TestCoverage.fromFile(se,ve,Y))},enqueued:we(Y=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Queued)}),skipped:we(Y=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Skipped)}),started:we(Y=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Running)}),errored:we((Y,q,ee)=>{re(Y,q),this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Errored,ee)}),failed:we((Y,q,ee)=>{re(Y,q),this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Failed,ee)}),passed:we((Y,q)=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,this.z.controllerId).toString(),m.TestResultState.Passed,q)}),appendOutput:(Y,q,ee)=>{Pe||(ee&&this.J(ee),this.C.$appendOutputToRun(ge,ce,S.$Oe.fromString(Y),q&&i.location.from(q),ee&&c.$TI.fromExtHostTestItem(ee,se).toString()))},end:()=>{Pe||(Pe=!0,this.C.$finishedTestRunTask(ge,ce),--this.f||this.I())}};return this.f++,this.g.set(ce,{run:Me}),this.C.$startedTestRunTask(ge,{id:ce,name:_,running:!0}),Me}H(){for(const{run:_}of this.g.values())_.end()}I(){this.c!==C.Ended&&(this.c=C.Ended,this.m.fire())}J(_){if(!(_ instanceof h.$bQ))throw new l.$SP(_.id);if(this.h.has(c.$TI.fromExtHostTestItem(_,this.z.controllerId).toString()))return;const ge=[],se=this.z.colllection.root;for(;;){const ce=i.TestItem.from(_);if(ge.unshift(ce),this.h.has(ce.extId)||(this.h.add(ce.extId),_===se))break;_=_.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,ge)}dispose(){this.I(),super.dispose()}}class g{get trackers(){return this.c.values()}constructor(_,ge){this.g=_,this.h=ge,this.c=new Map,this.f=new Map}getCoverageDetails(_,ge,se){const ce=c.$TI.root(_);return this.f.get(ce)?.getCoverageDetails(_,ge,se)||[]}disposeTestRun(_){this.f.get(_)?.dispose(),this.f.delete(_);for(const[ge,{id:se}]of this.c)se===_&&this.c.delete(ge)}prepareForMainThreadTestRun(_,ge,se,ce,we){return this.j(ge,se,ce,_,we)}cancelRunById(_){this.f.get(_)?.cancel()}cancelAllRuns(){for(const _ of this.c.values())_.cancel()}createTestRun(_,ge,se,ce,we,re){const Pe=this.c.get(ce);if(Pe)return Pe.createRun(we);const Me=M.fromPublic(ge,se,ce,re),Y=w(ce);this.g.$startedExtensionTestRun({controllerId:ge,continuous:!!ce.continuous,profile:Y&&{group:V[Y.kind],id:Y.profileId},exclude:ce.exclude?.map(ee=>c.$TI.fromExtHostTestItem(ee,se.root.id).toString())??[],id:Me.id,include:ce.include?.map(ee=>c.$TI.fromExtHostTestItem(ee,se.root.id).toString())??[se.root.id],preserveFocus:ce.preserveFocus??!0,persist:re});const q=this.j(ce,Me,ce.profile,_);return O.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(Me.id)}),q.createRun(we)}j(_,ge,se,ce,we){const re=new P(ge,this.g,this.h,se,ce,we);return this.c.set(_,re),this.f.set(re.id,re),re}}e.$qpc=g;const w=$e=>{if($e.profile){if(!($e.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $e.profile}};class M{static fromPublic(_,ge,se,ce){return new M(_,(0,y.$2g)(),ce,ge)}static fromInternal(_,ge){return new M(_.controllerId,_.runId,!0,ge)}constructor(_,ge,se,ce){this.controllerId=_,this.id=ge,this.isPersisted=se,this.colllection=ce}}e.$rpc=M;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(_){this.j=_,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(_){this.c.add(_)}update(_){Object.assign(_.revived,i.TestItem.toPlain(_.item)),this.c.has(_)||this.f.add(_)}remove(_){if(this.c.has(_)){this.c.delete(_);return}this.f.delete(_);const ge=c.$TI.parentId(_.item.extId);if(ge&&this.h.has(ge.toString())){this.h.add(_.item.extId);return}this.g.add(_)}getChangeEvent(){const{c:_,f:ge,g:se}=this;return{get added(){return[..._].map(ce=>ce.revived)},get updated(){return[...ge].map(ce=>ce.revived)},get removed(){return[...se].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class L extends m.$3I{constructor(){super(...arguments),this.y=new O.$me,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(_){return this.f.get(_)}getMirroredTestDataByReference(_){return this.f.get(_.id)}x(_,ge){return{..._,revived:i.TestItem.toPlain(_.item),depth:ge?ge.depth+1:0,children:new Set}}w(){return new N(this.y)}}class G{constructor(_){this.f=_}checkout(){this.c||(this.c=this.g());const _=this.c;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(ge=>ge.revived)},dispose:(0,A.$fb)(()=>{--_.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(_){return this.c?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.c?.tests.apply(_)}g(){const _=new L({asCanonicalUri:ge=>ge});return this.f.$subscribeToDiffs(),{observers:0,tests:_}}}const B=($e,_,ge,se)=>{ge?Object.assign(ge,se):_.$updateTestRunConfig($e.controllerId,$e.profileId,se)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(_){_!==this.f&&(this.f=_,B(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(_){_!==this.g&&(this.g=_,B(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),B(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,B(this,this.#e,this.#n,{tag:_?i.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.c}set configureHandler(_){_!==this.c&&(this.c=_,B(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return O.Event.chain(this.#i,_=>_.map(ge=>ge.get(this.controllerId)?.get(this.profileId)).filter(R.$ng))}constructor(_,ge,se,ce,we,re,Pe,Me,Y,q=!1,ee=void 0,ve=!1){this.controllerId=we,this.profileId=re,this.f=Pe,this.kind=Me,this.runHandler=Y,this._tag=ee,this.g=ve,this.#e=_,this.#s=ge,this.#t=se,this.#i=ce,ge.set(re,this);const ue=V[Me];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${Me}`);q&&se.add(re),this.#n={profileId:re,controllerId:we,tag:ee?i.TestTag.namespace(this.controllerId,ee.id):null,label:Pe,group:ue,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$spc=F;const V={[r.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function ae($e,_){for(let ge=0;ge<$e.path.length;ge++){const se=_.find(ce=>ce.id===$e.path[ge]);if(!se)return;if(ge===$e.path.length-1)return se;_=se.children}}}),define(Ce[301],Ie([1,0,18,6,4,5,127,8,7]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,b=qe(b),T=qe(T);class a extends k.$Wc{constructor(y,u){super(),this.m=u,this.a=new S.$me,this.b=new S.$me,this.c=new S.$me,this.f=new S.$me,this.g=new S.$me,this.h=new S.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$uN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(E=>E.value)}async showTextDocument(y,u,E){let f;typeof u=="number"?f={position:T.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?f={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:f={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,f),s=n&&this.m.getEditor(n);if(s)return s.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new A.$8P(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const E=this.m.getEditor(y);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const f=u.selections.selections.map(T.Selection.to);E._acceptSelections(f)}if(u.visibleRanges){const f=b.$Jb(u.visibleRanges.map(T.Range.to));E._acceptVisibleRanges(f)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const f=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),n=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:E.value,selections:n,kind:f})}if(u.visibleRanges){const f=b.$Jb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:E.value,visibleRanges:f})}}$acceptEditorPositionData(y){for(const u in y){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const f=T.ViewColumn.to(y[u]);E.value.viewColumn!==f&&(E._acceptViewColumn(f),this.f.fire({textEditor:E.value,viewColumn:f}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$zoc=a}),define(Ce[302],Ie([1,0,2,3,5,4,7,8,19,38,15]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,e.$jqc=(0,S.$Fi)("IExtHostTimeline");class y{constructor(f,n){this.b=new Map,this.c=new Map,this.a=f.getProxy(k.$uN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(s.source)&&p.$qn.equals(o,this.b.get(s.source)?.extension)){const h=s.uri===void 0?void 0:b.URI.revive(s.uri);return this.c.get(s.source)?.get(u(h))?.get(s.handle)}else return;return s}})}async $getTimeline(f,n,s,o){return this.b.get(f)?.provider.provideTimeline(b.URI.revive(n),s,o)}registerTimelineProvider(f,n,s,o){const h=new O.$Vc,i=this.d(n.id,o,h).bind(this);let r;n.onDidChange&&(r=n.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:n.id}),this));const t=this.c;return this.f({...n,scheme:f,onDidChange:void 0,async provideTimeline(c,l,m){l?.resetCache&&(h.clear(),t.get(n.id)?.clear());const d=await n.provideTimeline(c,l,m);if(d==null)return;const $=i(c,l);return{...d,source:n.id,items:d.items.map($)}},dispose(){for(const c of t.values())c.get(n.id)?.clear();r?.dispose(),h.dispose()}},s)}d(f,n,s){return(o,h)=>{let i;if(h?.cacheResults){let r=this.c.get(f);r===void 0&&(r=new Map,this.c.set(f,r));const t=u(o);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...c}=r,l=`${f}|${r.id??r.timestamp}`;i?.set(l,r);let m,d,$;r.iconPath&&(t instanceof A.$tO?$={id:t.id,color:t.color}:b.URI.isUri(t)?(m=t,d=t):{light:m,dark:d}=t);let I;return A.$YN.isMarkdownString(c.tooltip)?I=T.MarkdownString.from(c.tooltip):(0,R.$fg)(c.tooltip)?I=c.tooltip:A.$YN.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=T.MarkdownString.from(c.detail)):(0,R.$fg)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=c.detail),{...c,id:c.id??void 0,handle:l,source:f,command:r.command?n.toInternal(r.command,s):void 0,icon:m,iconDark:d,themeIcon:$,tooltip:I,accessibilityInformation:r.accessibilityInformation}}}}f(f,n){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,{provider:f,extension:n}),(0,O.$Uc)(()=>{for(const o of this.c.values())o.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.$kqc=y;function u(E){return E?.toString()}}),define(Ce[303],Ie([1,0,190,24,2,6,4,233,11,7,15,18,8,60,22,154,25]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0,a=qe(a);function o(r,t){if((0,R.$fg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let c;return Array.isArray(r.highlights)&&(c=r.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),c=c.length?c:void 0),{label:r.label,highlights:c}}}class h extends A.$Wc{constructor(t,c,l){super(),this.f=t,this.g=c,this.h=l,this.a=new Map,this.b=new n.$v_;function m(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}c.registerArgumentProcessor({processArgument:d=>m(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map($=>m($)?this.r($):$):d})}registerTreeDataProvider(t,c,l){const m=this.createTreeView(t,{treeDataProvider:c},l);return{dispose:()=>m.dispose()}}createTreeView(t,c,l){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=c.dragAndDropController?.dropMimeTypes??[],d=c.dragAndDropController?.dragMimeTypes??[],$=!!c.dragAndDropController?.handleDrag,I=!!c.dragAndDropController?.handleDrop,D=this.m(t,c,l),v={showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:m,dragMimeTypes:d,hasHandleDrag:$,hasHandleDrop:I,manuallyManageCheckboxes:!!c.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,v),P={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$7G)(l,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$7G)(l,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(g){(0,E.$5k)(g)&&(0,s.$7G)(l,"treeViewMarkdownMessage"),D.message=g},get title(){return D.title},set title(g){D.title=g},get description(){return D.description},set description(g){D.description=g},get badge(){return D.badge},set badge(g){g!==void 0&&a.ViewBadge.isViewBadge(g)?D.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(D.badge=void 0)},reveal:(g,w)=>D.reveal(g,w),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(P),P}$getChildren(t,c){const l=this.a.get(t);return l?l.getChildren(c):Promise.reject(new T.$qG(t))}async $handleDrop(t,c,l,m,d,$,I,D){const v=this.a.get(t);if(!v)return Promise.reject(new T.$qG(t));const C=u.DataTransfer.toDataTransfer(l,async P=>(await this.f.$resolveDropFileData(t,c,P)).buffer);return I===t&&D&&await this.j(C,v,D,d,$),v.onDrop(C,m,d)}async j(t,c,l,m,d){const $=this.b.removeDragOperationTransfer(d);if($)(await $)?.forEach((I,D)=>{I&&t.set(D,I)});else if(d&&c.handleDrag){const I=c.handleDrag(l,t,m);this.b.addDragOperationTransfer(d,I),await I}return t}async $handleDrag(t,c,l,m){const d=this.a.get(t);if(!d)return Promise.reject(new T.$qG(t));const $=await this.j(new a.$pO,d,c,m,l);if(!(!$||m.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(t){const c=this.a.get(t);if(!c)throw new T.$qG(t);return c.hasResolve}$resolve(t,c,l){const m=this.a.get(t);if(!m)throw new T.$qG(t);return m.resolveTreeItem(c,l)}$setExpanded(t,c,l){const m=this.a.get(t);if(!m)throw new T.$qG(t);m.setExpanded(c,l)}$setSelectionAndFocus(t,c,l){const m=this.a.get(t);if(!m)throw new T.$qG(t);m.setSelectionAndFocus(c,l)}$setVisible(t,c){const l=this.a.get(t);if(!l){if(!c)return;throw new T.$qG(t)}l.setVisible(c)}$changeCheckboxState(t,c){const l=this.a.get(t);if(!l)throw new T.$qG(t);l.setCheckboxState(c)}m(t,c,l){const m=this.B(new i(t,c,this.f,this.g.converter,this.h,l));return this.a.set(t,m),m}r(t){const c=this.a.get(t.$treeViewId);return c&&"$treeItemHandle"in t?c.getExtensionElement(t.$treeItemHandle):c&&"$focusedTreeItem"in t&&t.$focusedTreeItem?c.focusedElement:null}}e.$lqc=h;class i extends A.$Wc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,R.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,c,l,m,d,$){if(super(),this.I=t,this.J=l,this.L=m,this.M=d,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$xe,$.contributes&&$.contributes.views)for(const C in $.contributes.views)for(const P of $.contributes.views[C])P.id===t&&(this.P=P.name);this.f=c.treeDataProvider,this.g=c.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let I,D;const v=O.Event.debounce(this.F.event,(C,P)=>(C||(C={message:!1,elements:[]}),P.element!==!1&&(I||(I=new Promise(g=>D=g),this.G=this.G.then(()=>I)),Array.isArray(P.element)?C.elements.push(...P.element):C.elements.push(P.element)),P.message&&(C.message=!0),C),200,!0);this.B(v(({message:C,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const g=D;return I=null,this.$(P).then(()=>g())})),C&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const c=t?this.getExtensionElement(t):void 0;if(t&&!c)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(c)),l?l.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,c){c=c||{select:!0,focus:!1};const l=(0,R.$og)(c.select)?!0:c.select,m=(0,R.$og)(c.focus)?!1:c.focus,d=(0,R.$og)(c.expand)?!1:c.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then($=>this.W(t,$[$.length-1]).then(I=>this.J.$reveal(this.I,{item:I.item,parentChain:$.map(D=>D.item)},{select:l,focus:m,expand:d})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:l,focus:m,expand:d})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,c){const l=this.getExtensionElement(t);l&&(c?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,c){const l=!(0,y.$wb)(this.s,t);this.s=t;const m=this.t!==c;this.t=c,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const c=(await Promise.all(t.map(async l=>{const m=this.getExtensionElement(l.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);c.forEach(l=>{l.treeItem.checkboxState=l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:c.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,c,l){const m=[];for(const d of t){const $=this.getExtensionElement(d);$&&m.push($)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,c,l),c}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,c,l){const m=c?this.getExtensionElement(c):void 0;if(!(!m&&c||!this.g?.handleDrop))return(0,p.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,c){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const m=this.m.get(l);if(m){const d=await this.f.resolveTreeItem(m.extensionItem,l,c)??m.extensionItem;return this.hb(d),m.item.tooltip=this.eb(d.tooltip),m.item.command=this.fb(m.disposableStore,d.command),m.item}}}S(t){return this.U(t).then(c=>c?this.S(c).then(l=>this.W(c,l[l.length-1]).then(m=>(l.push(m),l))):Promise.resolve([]))}U(t){const c=this.m.get(t);return c?Promise.resolve(c.parent?this.j.get(c.parent.item.handle):void 0):(0,p.$xh)(()=>this.f.getParent(t))}W(t,c){const l=this.m.get(t);return l?Promise.resolve(l):(0,p.$xh)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,c,!0)).then(m=>this.getChildren(c?c.item.handle:void 0).then(()=>{const d=this.getExtensionElement(m);if(d){const $=this.m.get(d);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let c;if(typeof t=="string"){const l=this.getExtensionElement(t);c=l?this.m.get(l):void 0}else c=t;return c&&c.children||void 0}return this.h}async Y(t){this.rb(t);const c=new f.$xe(this.Z.token);try{const l=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(c.token.isCancellationRequested)return;const d=(0,y.$Jb)(m||[]),$=await Promise.all((0,y.$Jb)(d).map(D=>this.f.getTreeItem(D)));if(c.token.isCancellationRequested)return;const I=$.map((D,v)=>D?this.db(d[v],D,l):null);return(0,y.$Jb)(I)}finally{c.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new f.$xe,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const c=new Set,l=t.map(d=>this.m.get(d));for(const d of l)if(d&&!c.has(d.item.handle)){let $=d;for(;$&&$.parent&&l.findIndex(I=>$&&$.parent&&I&&I.item.handle===$.parent.item.handle)===-1;){const I=this.j.get($.parent.item.handle);$=I?this.m.get(I):void 0}$&&!$.parent&&c.add(d.item.handle)}const m=[];return c.forEach(d=>{const $=this.j.get(d);if($){const I=this.m.get($);I&&(!I.parent||!c.has(I.parent.item.handle))&&m.push(d)}}),m}bb(t){const c={};return Promise.all(t.map(l=>this.cb(l).then(m=>{m&&(c[l]=m.item)}))).then(()=>Object.keys(c).length?this.J.$refresh(this.I,c):void 0)}cb(t){const c=this.getExtensionElement(t);if(c){const l=this.m.get(c);if(l)return this.rb(c),(0,p.$xh)(()=>this.f.getTreeItem(c)).then(m=>{if(m){const d=this.ib(c,m,l.parent);return this.pb(c,d,l,l.parent),l.dispose(),d}return null})}return Promise.resolve(null)}db(t,c,l){const m=this.ib(t,c,l);if(c.id&&this.j.has(m.item.handle))throw new Error((0,b.localize)(0,null,c.id));return this.ob(t,m),this.qb(m,l),m}eb(t){return a.$YN.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,c){return c?{...this.L.toInternal(c,t),originalId:c.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let c,l,m;return typeof t.checkboxState=="number"?c=t.checkboxState:(c=t.checkboxState.state,l=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:c===a.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:m}}hb(t){if(!a.$kO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,c,l){this.hb(c);const m=this.B(new A.$Vc),d=this.kb(t,c,l),$=this.lb(c);return{item:{handle:d,parentHandle:l?l.item.handle:void 0,label:o(c.label,this.N),description:c.description,resourceUri:c.resourceUri,tooltip:this.eb(c.tooltip),command:this.fb(m,c.command),contextValue:c.contextValue,icon:$,iconDark:this.mb(c)||$,themeIcon:this.jb(c),collapsibleState:(0,R.$og)(c.collapsibleState)?a.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation,checkbox:this.gb(c)},extensionItem:c,parent:l,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof a.$tO?t.iconPath:void 0}kb(t,{id:c,label:l,resourceUri:m},d,$){if(c)return`${i.b}/${c}`;const I=o(l,this.N),D=d?d.item.handle:i.a;let v=I?I.label:m?(0,S.$dh)(m):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,P=this.X(d)||[];let g,w=0;do{if(g=`${D}/${w}:${v}`,$||!this.j.has(g)||C===g)break;w++}while(w<=P.length);return g}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO))return typeof t.iconPath=="string"||k.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return k.URI.isUri(t)?t:k.URI.file(t)}ob(t,c){this.j.set(c.item.handle,t),this.m.set(t,c)}pb(t,c,l,m){this.j.delete(c.item.handle),this.m.delete(t),c.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,c);const d=this.X(m)||[],$=d.filter(I=>I.item.handle===l.item.handle)[0];$&&d.splice(d.indexOf($),1,c)}qb(t,c){c?(c.children||(c.children=[]),c.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}c.children=void 0}}else this.tb()}sb(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(c.item.handle),c.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[304],Ie([1,0,6,4,2,37,8,68,5,7]),function(oe,e,b,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0,A=qe(A),p=qe(p),a=qe(a);class R extends S.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,n,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new b.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new b.$me),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=n,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,k.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends S.$Wc{static c(){return(0,O.$2g)()}constructor(f,n,s){super(),this.j=n,this.m=s,this.g=new Map,this.h=new Map,this.f=f.getProxy(p.$uN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,n,s,o,h={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},t=(0,T.$Ooc)(f),c=y.c();this.f.$createWebviewPanel((0,T.$Qoc)(f),c,n,{title:s,panelOptions:u(h),webviewOptions:(0,T.$Roc)(f,this.m,h),serializeBuffersForPostMessage:t},r);const l=this.j.createNewWebview(c,h,f);return this.createNewWebviewPanel(c,n,s,i,h,l,!0)}$onDidChangeWebviewPanelViewStates(f){const n=Object.keys(f);n.sort((s,o)=>{const h=f[s],i=f[o];return h.active?1:i.active?-1:+h.visible-+i.visible});for(const s of n){const o=this.getWebviewPanel(s);if(!o)continue;const h=f[s];o._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,n,s){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:s,extension:f}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$Ooc)(f)}),new a.$wN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(f,n,s,o){const h=this.h.get(n);if(!h)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=h,t=this.j.createNewWebview(f,s.webviewOptions,r),c=this.createNewWebviewPanel(f,n,s.title,o,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(c,s.state)}createNewWebviewPanel(f,n,s,o,h,i,r){const t=new R(f,this.f,i,{viewType:n,title:s,viewColumn:o,panelOptions:h,active:r});return this.g.set(f,t),t}getWebviewPanel(f){return this.g.get(f)}}e.$Soc=y;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[305],Ie([1,0,6,4,68,8,5,7]),function(oe,e,b,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0,A=qe(A),T=qe(T);class p extends S.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,E,f,n,s){super(),this.#s=!1,this.#u=this.B(new b.$me),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new b.$me),this.onDidDispose=this.#l.event,this.#i=E,this.#a=f,this.#e=y,this.#t=u,this.#n=n,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$uN.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,E,f){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:y}),this.a.$registerWebviewViewProvider((0,k.$Qoc)(y),u,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.$Ooc)(y)}),new T.$wN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,E,f,n){const s=this.b.get(u);if(!s)throw new Error(`No view provider found for '${u}'`);const{provider:o,extension:h}=s,i=this.d.createNewWebview(y,{},h),r=new p(y,this.a,u,E,i,!0);this.c.set(y,r),await o.resolveWebviewView(r,{state:f},n)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$oqc=a}),define(Ce[306],Ie([1,0,6,31,32,3]),function(oe,e,b,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.OutputChannelUpdateMode=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0,e.$CM="text/x-code-output",e.$DM="output",e.$EM="Log",e.$FM="text/x-code-log-output",e.$GM="log",e.$HM="workbench.panel.output",e.$IM=new k.$Wj("inOutput",!1),e.$JM=new k.$Wj("activeLogOutput",!1),e.$KM=new k.$Wj("activeLogOutput.levelSettable",!1),e.$LM=new k.$Wj("activeLogOutput.level",""),e.$MM=new k.$Wj("activeLogOutput.levelIsDefault",!1),e.$NM=new k.$Wj("outputView.scrollLock",!1),e.$OM=(0,O.$Fi)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$PM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new b.$me,this.onDidRegisterChannel=this.b.event,this.c=new b.$me,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(R=>a.push(R)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}S.$qo.add(e.$PM.OutputChannels,new T),e.$QM=new k.$Wj("activeOutputChannel","")}),define(Ce[128],Ie([1,0,5,3,17,19,12,306,69,27,51,158,23,15,30,6,4]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0;class o extends A.$fk{get disposed(){return this.n}constructor(t,c,l,m,d){super(),this.id=t,this.name=c,this.r=l,this.s=m,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const c=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,c),this.visible&&this.r.flush()}show(t,c){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:c))}hide(){this.s.$close(this.id)}g(t,c){this.m+=u.$Oe.fromString(c).byteLength,(0,A.log)(this.r,t,c),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends o{appendLine(t){this.append(t)}}let i=class{constructor(t,c,l,m,d,$){this.i=c,this.j=l,this.k=m,this.l=d,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(b.$uN.MainThreadOutputService),this.b=this.k.extUri.joinPath(c.logsLocation,`output_logging_${(0,y.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[c,l]of this.g)l.visible=c===this.h}createOutputChannel(t,c,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof c=="object"&&c.log,d=(0,E.$fg)(c)?c:void 0;if((0,E.$fg)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const I=this.i.environment.extensionLogLevel?.find(([v])=>O.$qn.equals(l.identifier,v))?.[1];I&&($=(0,A.$qk)(I));const D=m?this.o(t,$,l):this.n(t,d,l);return D.then(v=>{this.g.set(v.id,v),v.visible=v.id===this.h}),m?this.r(t,$??this.m.getLevel(),D):this.q(t,D)}async n(t,c,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,d=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(t,d,c,l.identifier.value);return new o(I,t,$,this.a,l)}async o(t,c,l){const m=await this.p(l),d=t.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(m,`${d}.log`),I=`${l.identifier.value}.${d}`,D=this.l.createLogger($,{id:I,name:t,logLevel:c,extensionId:l.identifier.value});return new h(I,t,D,this.a,l)}p(t){let c=this.d.get(t.identifier.value);if(!c){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,c=(async()=>{try{await this.j.value.createDirectory(l)}catch(m){if((0,f.$pl)(m)!==f.FileSystemProviderErrorCode.FileExists)throw m}return l})())}return c}q(t,c){let l=!1;const m=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(d){m(),c.then($=>$.append(d))},appendLine(d){m(),c.then($=>$.appendLine(d))},clear(){m(),c.then(d=>d.clear())},replace(d){m(),c.then($=>$.replace(d))},show(d,$){m(),c.then(I=>I.show(d,$))},hide(){m(),c.then(d=>d.hide())},dispose(){l=!0,c.then(d=>d.dispose())}}}r(t,c,l){const m=new s.$Vc,d=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},$=m.add(new n.$me);function I(D){c=D,$.fire(D)}return l.then(D=>{m.add(D),D.logLevel!==c&&I(D.logLevel),m.add(D.onDidChangeLogLevel(v=>I(v)))}),{...this.q(t,l),get logLevel(){return c},onDidChangeLogLevel:$.event,trace(D,...v){d(),l.then(C=>C.trace(D,...v))},debug(D,...v){d(),l.then(C=>C.debug(D,...v))},info(D,...v){d(),l.then(C=>C.info(D,...v))},warn(D,...v){d(),l.then(C=>C.warn(D,...v))},error(D,...v){d(),l.then(C=>C.error(D,...v))},dispose(){m.dispose()}}}};e.$4pc=i,e.$4pc=i=Qe([Ve(0,k.$1P),Ve(1,a.$eQ),Ve(2,p.$Koc),Ve(3,R.$noc),Ve(4,A.$ak),Ve(5,A.$_j)],i),e.$5pc=(0,S.$Fi)("IExtHostOutputService")}),define(Ce[129],Ie([1,0,3,11]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,b.$Fi)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(k){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await k.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,S.$Gh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[307],Ie([1,0,193,54,31,50,42,4,6,129,21,26,11,114]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=void 0,e.$7K=Object.freeze({id:"application",order:100,title:(0,b.localize)(0,null),type:"object"}),e.$8K=Object.freeze({id:"workbench",order:7,title:(0,b.localize)(1,null),type:"object"}),e.$9K=Object.freeze({id:"security",scope:S.ConfigurationScope.APPLICATION,title:(0,b.localize)(2,null),type:"object",order:7}),e.$0K=Object.freeze({id:"problems",title:(0,b.localize)(3,null),type:"object",order:101}),e.$$K=Object.freeze({id:"window",order:8,title:(0,b.localize)(4,null),type:"object"}),e.$_K={ConfigurationMigration:"base.contributions.configuration.migration"};class f{constructor(){this.migrations=[],this.a=new p.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new f;k.$qo.add(e.$_K.ConfigurationMigration,n);let s=class extends T.$Wc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const l of c.added)await this.f(l,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(c=>this.g(c,r?.uri))])}async g(r,t){const c=this.a.inspect(r.key,{resource:t}),l=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[m,d]of l){const $=c[m];if(!$)continue;const I=[];if($.value!==void 0){const D=await this.h(r,m,$.value,t,void 0);for(const v of D??[])I.push([v,[]])}for(const{identifiers:D,value:v}of $.overrides??[])if(v!==void 0){const C=await this.h(r,m,v,t,D);for(const P of C??[])I.push([P,D])}I.length&&await Promise.allSettled(I.map(async([[D,v],C])=>this.a.updateValue(D,v.value,{resource:t,overrideIdentifiers:C},d)))}}async h(r,t,c,l,m){const d=I=>{const v=this.a.inspect(I,{resource:l})[t];if(v)return m?v.overrides?.find(({identifiers:C})=>(0,y.$ho)(C,m))?.value:v.value},$=await r.migrateFn(c,d);return Array.isArray($)?$:[[r.key,$]]}};e.$aL=s,e.$aL=s=Qe([Ve(0,A.$_i),Ve(1,O.$Oi)],s);let o=class extends T.$Wc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;k.$qo.as(S.$vo.Configuration).registerConfiguration({...e.$9K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,b.localize)(5,null)},default:[],markdownDescription:(0,b.localize)(6,null),scope:S.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,b.localize)(7,null),scope:S.ConfigurationScope.MACHINE}}})}};e.$bL=o,e.$bL=o=Qe([Ve(0,a.$Vm)],o),e.$cL="window.newWindowProfile";let h=class extends T.$Wc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(c=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(c=>{c.source!==A.ConfigurationTarget.DEFAULT&&c.affectsConfiguration(e.$cL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=k.$qo.as(S.$vo.Configuration),t={...e.$$K,properties:{[e.$cL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(c=>c.name),null],enumItemLabels:[...this.c.profiles.map(c=>""),(0,b.localize)(8,null)],description:(0,b.localize)(9,null),scope:S.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$cL);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$cL);if(!r)return;const t=this.b?this.c.profiles.find(c=>c.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$cL,t?.name)}};e.$dL=h,e.$dL=h=Qe([Ve(0,E.$Ll),Ve(1,A.$_i)],h)}),define(Ce[308],Ie([1,0,41,16,20,24,204,307,54,3,31]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$fL=e.$eL=void 0,e.$gL=n,e.$hL=s,b=qe(b),e.$eL=(0,a.$Fi)("editorResolverService"),e.$fL="workbench.editorAssociations";const y=R.$qo.as(p.$vo.Configuration),u={...T.$8K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var f;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function n(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function s(o,h){if(new Set([S.Schemas.extension,S.Schemas.webviewPanel,S.Schemas.vscodeWorkspaceTrust,S.Schemas.vscodeSettings]).has(h.scheme))return!1;const t=typeof o=="string"&&o.indexOf(k.$ic.sep)>=0?`${h.scheme}:${h.path}`:(0,O.$dh)(h);return b.$yk(typeof o=="string"?o.toLowerCase():o,t.toLowerCase())}}),define(Ce[309],Ie([1,0,53,16,20,21,24,2,3,227,50,247,129]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0,e.$9M=(0,p.$Fi)("pathService");let f=E=class{constructor(s,o,h,i){this.d=s,this.e=o,this.f=h,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??s})()}hasValidBasename(s,o,h){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(s,i,o)):this.h(s,o,h)}h(s,o,h){return s.scheme===S.Schemas.file||s.scheme===S.Schemas.vscodeRemote?(0,b.$Cg)(h??(0,A.$dh)(s),o===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return S.Schemas.vscodeRemote;const h=(0,a.$6M)(o.getWorkspace());if(h)return h;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:S.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===O.OperatingSystem.Windows?k.$hc:k.$ic)}async fileURI(s){let o="";if(await this.a===O.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(o=s.substring(2),s="/"):(o=s.substring(2,i),s=s.substring(i)||"/")}return T.URI.from({scheme:S.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$0M=f,e.$0M=f=E=Qe([Ve(1,u.$Vm),Ve(2,y.$RM),Ve(3,R.$Oi)],f)}),define(Ce[130],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$KL=e.$JL=void 0;class b{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new b(0,0)}with(A){return new b(0,0)}}e.$JL=b;class S{constructor(A,T,p,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(A,T),this.end=new b(p,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new S(0,0,0,0)}with(A){return new S(0,0,0,0)}}e.$KL=S;var k;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}))}),define(Ce[43],Ie([1,0,18,41,26,53,13,3,20,14,130,11]),function(oe,e,b,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$9L=e.$2L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$YL=e.$XL=e.$WL=e.$VL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.TextSearchCompleteMessageType=void 0,e.$SL=o,e.$TL=h,e.$UL=i,e.$ZL=D,e.$1L=v,e.$3L=g,e.$4L=w,e.$5L=M,e.$6L=N,e.$7L=L,e.$8L=G,e.$0L=F,e.$_L=$e,e.$aM=_,S=qe(S),k=qe(k),O=qe(O),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$LL="workbench.view.search",e.$ML="workbench.panel.search",e.$NL="workbench.view.search",e.$OL="search-result",e.$PL="search.exclude",e.$QL=2e4;const u="\u27EA ",E=" characters skipped \u27EB",f=(u.length+E.length+5)*2;e.$RL=(0,T.$Fi)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var s;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(se){return!!se.preview}function h(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$VL=t;class c{constructor(ce,we,re,Pe){this.ranges=we,this.webviewIndex=Pe;const Me=Array.isArray(we)?we:[we];if(re&&re.matchLines===1&&l(Me)){ce=(0,A.$$f)(ce,re.matchLines);let Y="",q=0,ee=0;const ve=Math.floor(re.charsPerLine/5),ue=[];for(const be of Me){const de=Math.max(be.startColumn-ve,0),X=be.startColumn+re.charsPerLine;if(de>ee+ve+f){const Z=u+(de-ee)+E;Y+=Z+ce.slice(de,X),q+=de-(ee+Z.length)}else Y+=ce.slice(ee,X);ue.push(new d(0,be.startColumn-q,be.endColumn-q)),ee=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?ue:ue[0]}}else{const Y=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:ce,matches:(0,b.$3b)(we,q=>new m(q.startLineNumber-Y,q.startColumn,q.endLineNumber-Y,q.endColumn))}}}}e.$WL=c;function l(se){const ce=se[0].startLineNumber;for(const we of se)if(we.startLineNumber!==ce||we.endLineNumber!==ce)return!1;return!0}class m{constructor(ce,we,re,Pe){this.startLineNumber=ce,this.startColumn=we,this.endLineNumber=re,this.endColumn=Pe}}e.$XL=m;class d extends m{constructor(ce,we,re){super(ce,we,ce,re)}}e.$YL=d;var $;(function(se){se.List="list",se.Tree="tree"})($||(e.ViewMode=$={}));var I;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function D(se,ce=!0){const we=se&&se.files&&se.files.exclude,re=ce&&se&&se.search&&se.search.exclude;if(!we&&!re)return;if(!we||!re)return we||re;let Pe=Object.create(null);return Pe=k.$go(Pe,k.$do(we)),Pe=k.$go(Pe,k.$do(re),!0),Pe}function v(se,ce){return se.excludePattern&&S.$yk(se.excludePattern,ce)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&S.$yk(se.includePattern,ce)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(we=>{const re=we.folder.fsPath;if(O.$Eg(ce,re)){const Pe=p.$nc(re,ce);return!we.includePattern||!!S.$yk(we.includePattern,Pe)}else return!1}):!1:!0}var C;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class P extends Error{constructor(ce,we){super(ce),this.code=we}}e.$2L=P;function g(se){const ce=se.message;if((0,a.$6)(se))return new P(ce,C.canceled);try{const we=JSON.parse(ce);return new P(we.message,we.code)}catch{return new P(ce,C.other)}}function w(se){const ce={message:se.message,code:se.code};return new Error(JSON.stringify(ce))}function M(se){return se.type==="error"?!0:se.type==="success"}function N(se){return se.type==="success"}function L(se){return!!se.path}function G(se,ce,we=!0){const re=se.searchPath?se.searchPath:se.relativePath;return we?(0,A.$8f)(re,ce):S.$yk(ce,re)}class B{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9L=B;function F(se,ce){const we={...se||{},...ce||{}};return Object.keys(we).filter(re=>{const Pe=we[re];return typeof Pe=="boolean"&&Pe})}class V{constructor(ce,we){this.c=null,this.a={...ce.excludePattern||{},...we.excludePattern||{}},this.b=S.$zk(this.a);let re=ce.includePattern;we.includePattern&&(re?re={...re,...we.includePattern}:re=we.includePattern),re&&(this.c=S.$zk(re))}matchesExcludesSync(ce,we,re){return!!(this.b&&this.b(ce,we,re))}includedInQuerySync(ce,we,re){return!(this.b&&this.b(ce,we,re)||this.c&&!this.c(ce,we,re))}includedInQuery(ce,we,re){const Pe=this.b(ce,we,re),Me=()=>this.c?!!this.c(ce,we,re):!0;return(0,y.$rh)(Pe)?Pe.then(Y=>Y?!1:Me()):Me()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$$L=V;function ae(se){for(const ce in se)if(typeof se[ce]!="boolean")return!0;return!1}function $e(se){if(!se)return;let ce;return we=>(ce||(ce=(se()||Promise.resolve([])).then(re=>re?ge(re):{})),ce.then(re=>!!re[we]))}function _(se){if(!se)return;let ce;return we=>{if(!ce){const re=se();ce=re?ge(re):{}}return!!ce[we]}}function ge(se){const ce={};for(const we of se)ce[we]=!0;return ce}}),define(Ce[44],Ie([1,0,18,11,22,6,4,59,16,139,24,13,2,192,30,3,12,214,50,51,27,17,8,7,66,43,5,49]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l,m,d,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=e.$Eoc=void 0;function D(L,G,B){return new R.$8g(F=>g(F,B)).isEqual(L,G)}function v(L,G,B){return D(L.uri,G.uri,B)?0:(0,y.$zf)(L.uri.toString(),G.uri.toString())}function C(L,G,B){return L.index!==G.index?L.index<G.index?-1:1:D(L.uri,G.uri,B)?(0,y.$zf)(L.name,G.name):(0,y.$zf)(L.uri.toString(),G.uri.toString())}function P(L,G,B,F){const V=L.slice(0).sort(($e,_)=>B($e,_,F)),ae=G.slice(0).sort(($e,_)=>B($e,_,F));return(0,b.$Gb)(V,ae,($e,_)=>B($e,_,F))}function g(L,G){const B=G.getCapabilities(L.scheme);return!(B&&B&f.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends h.$Yi{static toExtHostWorkspace(G,B,F,V){if(!G)return{workspace:null,added:[],removed:[]};const{id:ae,name:$e,folders:_,configuration:ge,transient:se,isUntitled:ce}=G,we=[],re=B;B?_.forEach((q,ee)=>{const ve=u.URI.revive(q.uri),ue=w.o(F||B,ve,V);ue?(ue.name=q.name,ue.index=q.index,we.push(ue)):we.push({uri:ve,name:q.name,index:ee})}):we.push(..._.map(({uri:q,name:ee,index:ve})=>({uri:u.URI.revive(q),name:ee,index:ve}))),we.sort((q,ee)=>q.index<ee.index?-1:1);const Pe=new w(ae,$e,we,!!se,ge?u.URI.revive(ge):null,!!ce,q=>g(q,V)),{added:Me,removed:Y}=P(re?re.workspaceFolders:[],Pe.workspaceFolders,v,V);return{workspace:Pe,added:Me,removed:Y}}static o(G,B,F){for(let V=0;V<G.folders.length;V++){const ae=G.workspaceFolders[V];if(D(ae.uri,B,F))return ae}}constructor(G,B,F,V,ae,$e,_){super(G,F.map(ge=>new h.$Zi(ge)),V,ae,_),this.t=B,this.u=$e,this.q=[],this.s=T.$Li.forUris(_,()=>!0),F.forEach(ge=>{this.q.push(ge),this.s.set(ge.uri,ge)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,B){return B&&this.s.get(G)&&(G=(0,R.$fh)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let M=class{constructor(G,B,F,V,ae){this.c=new O.$me,this.onDidChangeWorkspace=this.c.event,this.g=new O.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$oe,this.C=new Map,this.h=V,this.s=F,this.t=ae,this.j=new a.$Mm,this.k=new S.$Eh,this.o=G.getProxy($.$uN.MainThreadWorkspace),this.q=G.getProxy($.$uN.MainThreadMessageService);const $e=B.workspace;this.l=$e?new w($e.id,$e.name,[],!!$e.transient,$e.configuration?u.URI.revive($e.configuration):null,!!$e.isUntitled,_=>g(_,F)):void 0}$initializeWorkspace(G,B){this.v=B,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,R.$dh)((0,R.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,B,F,...V){const ae=[];if(Array.isArray(V)&&V.forEach(ce=>{u.URI.isUri(ce.uri)&&!ae.some(we=>D(we.uri,ce.uri,this.s))&&ae.push({uri:ce.uri,name:ce.name||(0,R.$ch)(ce.uri)})}),this.n||[B,F].some(ce=>typeof ce!="number"||ce<0)||F===0&&ae.length===0)return!1;const $e=this.x?this.x.workspaceFolders:[];if(B+F>$e.length)return!1;const _=$e.slice(0);_.splice(B,F,...ae.map(ce=>({uri:ce.uri,name:ce.name||(0,R.$ch)(ce.uri),index:void 0})));for(let ce=0;ce<_.length;ce++){const we=_[ce];if(_.some((re,Pe)=>Pe!==ce&&D(we.uri,re.uri,this.s)))return!1}_.forEach((ce,we)=>ce.index=we);const{added:ge,removed:se}=P($e,_,C,this.s);if(ge.length===0&&se.length===0)return!1;if(this.o){const ce=G.displayName||G.name;this.o.$updateWorkspaceFolders(ce,B,F,ae).then(void 0,we=>{this.n=void 0;const re={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(o.Severity.Error,(0,E.localize)(0,null,ce,we.toString()),re,[])})}return this.y(_),!0}getWorkspaceFolder(G,B){if(this.x)return this.x.getWorkspaceFolder(G,B)}async getWorkspaceFolder2(G,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,B)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,B){let F,V="";if(typeof G=="string"?(F=u.URI.file(G),V=G):typeof G<"u"&&(F=G,V=G.fsPath),!F)return V;const ae=this.getWorkspaceFolder(F,!0);if(!ae)return V;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let $e=(0,R.$ih)(ae.uri,F);return B&&ae.name&&($e=`${ae.name}/${$e}`),$e}y(G){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:B,added:F,removed:V}=w.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:V}))}findFiles(G,B,F,V,ae=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let $e="",_=!0;return B===null?_=!1:B!==void 0&&(typeof B=="string"?$e=B:$e=B.pattern),this.z(G,void 0,{exclude:$e,maxResults:F,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ae)}findFiles2(G,B={},F,V=k.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,G,B,V)}async z(G,B,F,V=k.CancellationToken.None){if(V&&V.isCancellationRequested)return Promise.resolve([]);const ae=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,$e={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:ae,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let _;if(G){const{includePattern:ge,folder:se}=N(c.GlobPattern.from(G));_=se,$e.includePattern=ge}else{const{includePattern:ge,folder:se}=N(c.GlobPattern.from(B));_=se,$e.filePattern=ge}return this.o.$startFileSearch(_??null,$e,V).then(ge=>Array.isArray(ge)?ge.map(se=>u.URI.revive(se)):[])}async findTextInFiles(G,B,F,V,ae=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const $e=this.j.getNext(),_=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ge,folder:se}=N(c.GlobPattern.from(B.include)),ce=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,we={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:_,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ge,excludePattern:ce},re=!1;if(this.u[$e]=Pe=>{if(re)return;const Me=u.URI.revive(Pe.resource);Pe.results.forEach(Y=>{const q=(0,I.$ci)(Y);(0,d.$SL)(q)?F({uri:Me,preview:{text:q.preview.text,matches:(0,b.$3b)(q.preview.matches,ee=>new l.$yN(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,b.$3b)(q.ranges,ee=>new l.$yN(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):F({uri:Me,text:q.text,lineNumber:q.lineNumber})})},ae.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(G,se??null,we,$e,ae);return delete this.u[$e],Pe||{}}catch(Pe){throw delete this.u[$e],Pe}}$handleTextSearchResult(G,B){this.u[B]?.(G)}async save(G){const B=await this.o.$save(G,{saveAs:!1});return u.URI.revive(B)}async saveAs(G){const B=await this.o.$save(G,{saveAs:!0});return u.URI.revive(B)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,B){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,B);const F=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerEditSessionIdentityProvider(V,F),(0,A.$Uc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(G,B){this.h.info("Getting edit session identifier for workspaceFolder",G);const F=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const V=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!V),!V)return;const ae=await V.provideEditSessionIdentity(F,B);if(this.h.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch(G,B,F,V){this.h.info("Getting edit session identifier for workspaceFolder",G);const ae=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!ae){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const $e=this.w.get(ae.uri.scheme);if(this.h.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!$e),!$e)return;const _=await $e.provideEditSessionIdentityMatch?.(B,F,V);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(G){return(B,F,V)=>{const ae=function(_){B.call(F,_)};return ae.extension=G,this.B.event(ae,void 0,V)}}async $onWillCreateEditSessionIdentity(G,B,F){const V=await this.resolveWorkspaceFolder(u.URI.revive(G));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:V},B,async(ae,$e)=>{const _=Date.now();await Promise.resolve(ae),Date.now()-_>F&&this.h.warn("SLOW edit session create-participant",$e.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(G,B){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,B);const F=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerCanonicalUriProvider(V,F),(0,A.$Uc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri(G,B,F){const V=this.C.get(G.scheme);if(!V)return;const ae=await V.provideCanonicalUri?.(u.URI.revive(G),B,F);if(ae)return ae}async $provideCanonicalUri(G,B,F){return this.provideCanonicalUri(u.URI.revive(G),{targetScheme:B},F)}};e.$Eoc=M,e.$Eoc=M=Qe([Ve(0,t.$1P),Ve(1,r.$eQ),Ve(2,i.$noc),Ve(3,s.$_j),Ve(4,m.$Coc)],M),e.$Foc=(0,n.$Fi)("IExtHostWorkspace");function N(L){let G,B;return L&&(typeof L=="string"?G=L:(G=L.pattern,B=u.URI.revive(L.baseUri))),{includePattern:G,folder:B}}}),define(Ce[45],Ie([1,0,26,6,44,5,7,42,215,54,15,11,3,17,12,2]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=e.$Hoc=e.$Goc=void 0;function s(m,d){if(d){const $=d.split(".");let I=m;for(let D=0;I&&D<$.length;D++)I=I[$[D]];return I}}function o(m){return m instanceof n.URI}function h(m){return m&&m.uri instanceof n.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function r(m){return m&&m.uri instanceof n.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(o(m))return{resource:m};if(h(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(r(m))return{resource:m.uri};if(m===null)return{resource:null}}let c=class{constructor(d,$,I){this.a=d.getProxy(O.$uN.MainThreadConfiguration),this.c=$,this.b=I,this.d=new y.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new l(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,$){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(d,$))}};e.$Goc=c,e.$Goc=c=Qe([Ve(0,E.$1P),Ve(1,k.$Foc),Ve(2,f.$_j)],c);class l{constructor(d,$,I,D){this.a=new S.$me,this.b=d,this.f=D,this.c=$,this.e=p.$Oo.parse(I,D),this.d=this.k(I.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,$){const I={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Oo.parse(d,this.f),this.d=this.k(d.configurationScopes),this.a.fire(this.j($,I))}getConfiguration(d,$,I){const D=t($)||{},v=this.g(d?s(this.e.getValue(void 0,D,this.c.workspace),d):this.e.getValue(void 0,D,this.c.workspace));d&&this.h(d,D,I?.identifier);function C(g){if(g==null)return null;if(typeof g=="boolean")return g?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(g){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(g){return typeof s(v,g)<"u"},get:(g,w)=>{this.h(d?`${d}.${g}`:g,D,I?.identifier);let M=s(v,g);if(typeof M>"u")M=w;else{let N;const L=(G,B)=>{if((0,R.$hg)(G)){let F;const V=()=>{N=N||(0,b.$do)(v),F=F||s(N,B)};return new Proxy(G,{get:(ae,$e)=>{if(typeof $e=="string"&&$e.toLowerCase()==="tojson")return V(),()=>F;if(N)return F=F||s(N,B),F[$e];const _=ae[$e];return typeof $e=="string"?L(_,`${B}.${$e}`):_},set:(ae,$e,_)=>(V(),F&&(F[$e]=_),!0),deleteProperty:(ae,$e)=>(V(),F&&delete F[$e],!0),defineProperty:(ae,$e,_)=>(V(),F&&Object.defineProperty(F,$e,_),!0)})}return Array.isArray(G)?(0,b.$do)(G):G};M=L(M,g)}return M},update:(g,w,M,N)=>{g=d?`${d}.${g}`:g;const L=C(M);return w!==void 0?this.b.$updateConfigurationOption(L,g,w,D,N):this.b.$removeConfigurationOption(L,g,D,N)},inspect:g=>{g=d?`${d}.${g}`:g;const w=this.e.inspect(g,D,this.c.workspace);if(w)return{key:g,defaultValue:(0,b.$do)(w.policy?.value??w.default?.value),globalValue:(0,b.$do)(w.user?.value??w.application?.value),workspaceValue:(0,b.$do)(w.workspace?.value),workspaceFolderValue:(0,b.$do)(w.workspaceFolder?.value),defaultLanguageValue:(0,b.$do)(w.default?.override),globalLanguageValue:(0,b.$do)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,b.$do)(w.workspace?.override),workspaceFolderLanguageValue:(0,b.$do)(w.workspaceFolder?.override),languageIds:(0,b.$do)(w.overrideIdentifiers)}}};return typeof v=="object"&&(0,b.$go)(P,v,!1),Object.freeze(P)}g(d){const $=I=>(0,R.$hg)(I)?new Proxy(I,{get:(D,v)=>$(D[v]),set:(D,v,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(D,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(D,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return $(d)}h(d,$,I){const D=a.$Fo.test(d)?a.ConfigurationScope.RESOURCE:this.d.get(d),v=I?`[${I.value}] `:"";if(a.ConfigurationScope.RESOURCE===D){typeof $?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===D){$?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,$){const I=new p.$Qo(d,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,v)=>I.affectsConfiguration(D,t(v))})}k(d){return d.reduce(($,I)=>($.set(I[0],I[1]),$),new Map)}}e.$Hoc=l,e.$Ioc=(0,u.$Fi)("IExtHostConfiguration")}),define(Ce[131],Ie([1,0,2,11,6,5,7,44,58,45,22,57,17,27,3,16,21,12,85,251,14]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=e.$eqc=e.$dqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),s=qe(s);var t;(function(N){function L(B){if(B!=null)return B}N.from=L;function G(B){if(B!=null)return B}N.to=G})(t||(t={}));var c;(function(N){function L(B){if(B!=null)return B}N.from=L;function G(B){if(B!=null)return B}N.to=G})(c||(c={}));var l;(function(N){function L(B){if(B!=null)return B}N.from=L;function G(B){if(B!=null)return B}N.to=G})(l||(l={}));var m;(function(N){function L(F){if(F){const V=F;return V&&!!V.process}else return!1}N.is=L;function G(F){if(F==null)return;const V={process:F.process,args:F.args};return F.options&&(V.options=l.from(F.options)),V}N.from=G;function B(F){if(F!=null)return new A.$gO(F.process,F.args,F.options)}N.to=B})(m||(m={}));var d;(function(N){function L(B){if(B!=null)return B}N.from=L;function G(B){if(B!=null)return B}N.to=G})(d||(d={}));var $;(function(N){function L(F){if(F){const V=F;return V&&(!!V.commandLine||!!V.command)}else return!1}N.is=L;function G(F){if(F==null)return;const V={};return F.commandLine!==void 0?V.commandLine=F.commandLine:(V.command=F.command,V.args=F.args),F.options&&(V.options=d.from(F.options)),V}N.from=G;function B(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$hO(F.commandLine,F.options):new A.$hO(F.command,F.args?F.args:[],F.options)}N.to=B})($||($={}));var I;(function(N){function L(F){if(F){const V=F;return V&&V.customExecution==="customExecution"}else return!1}N.is=L;function G(F){return{customExecution:"customExecution"}}N.from=G;function B(F,V){return V.get(F)}N.to=B})(I||(e.CustomExecutionDTO=I={}));var D;(function(N){function L(G,B){let F;return G.scope!==void 0&&typeof G.scope!="number"?F=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===A.TaskScope.Workspace&&B&&B.workspaceFile?F=B.workspaceFile:F=i.$II),{id:G._id,workspaceFolder:F}}N.from=L})(D||(e.TaskHandleDTO=D={}));var v;(function(N){function L(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}N.from=L})(v||(v={}));var C;(function(N){function L(F,V){if(F==null)return[];const ae=[];for(const $e of F){const _=G($e,V);_&&ae.push(_)}return ae}N.fromMany=L;function G(F,V){if(F==null)return;let ae;F.execution instanceof A.$gO?ae=m.from(F.execution):F.execution instanceof A.$hO?ae=$.from(F.execution):F.execution&&F.execution instanceof A.$iO&&(ae=I.from(F.execution));const $e=t.from(F.definition);let _;return F.scope?typeof F.scope=="number"?_=F.scope:_=F.scope.uri:_=A.TaskScope.Workspace,!$e||!_?void 0:{_id:F._id,definition:$e,name:F.name,source:{extensionId:V.identifier.value,label:F.source,scope:_},execution:ae,isBackground:F.isBackground,group:v.from(F.group),presentationOptions:c.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=G;async function B(F,V,ae){if(F==null)return;let $e;m.is(F.execution)?$e=m.to(F.execution):$.is(F.execution)?$e=$.to(F.execution):I.is(F.execution)&&($e=I.to(F._id,ae));const _=t.to(F.definition);let ge;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ge=F.source.scope:ge=await V.resolveWorkspaceFolder(b.URI.revive(F.source.scope)):ge=A.TaskScope.Workspace),!_||!ge)return;const se=new A.$jO(_,ge,F.name,F.source.label,$e,F.problemMatchers);return F.isBackground!==void 0&&(se.isBackground=F.isBackground),F.group!==void 0&&(se.group=A.$fO.from(F.group._id),se.group&&F.group.isDefault&&(se.group=new A.$fO(se.group.id,se.group.label),F.group.isDefault===!0&&(se.group.isDefault=F.group.isDefault))),F.presentationOptions&&(se.presentationOptions=c.to(F.presentationOptions)),F._id&&(se._id=F._id),F.detail&&(se.detail=F.detail),se}N.to=B})(C||(e.TaskDTO=C={}));var P;(function(N){function L(B){return B}N.from=L;function G(B){if(B)return Object.assign(Object.create(null),B)}N.to=G})(P||(P={}));class g{#e;constructor(L,G,B){this._id=G,this.a=B,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,G,B,F,V,ae,$e,_){this.q=new k.$me,this.r=new k.$me,this.s=new k.$me,this.u=new k.$me,this.a=L.getProxy(O.$uN.MainThreadTask),this.b=B,this.c=F,this.d=V,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=$e,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,G,B){if(!B)return new A.$wN(()=>{});const F=this.x();return this.j.set(F,{type:G,provider:B,extension:L}),this.a.$registerTaskProvider(F,G),new A.$wN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(L,G){this.a.$registerTaskSystem(L,G)}fetchTasks(L){return this.a.$fetchTasks(P.from(L)).then(async G=>{const B=[];for(const F of G){const V=await C.to(F,this.b,this.m);V&&B.push(V)}return B})}get taskExecutions(){const L=[];return this.k.forEach(G=>L.push(G)),L}terminateTask(L){if(!(L instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,G,B){const F=this.m.get(L.id);F&&(this.o.set(L.id,F),this.e.attachPtyToTerminal(G,await F.callback(B))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const G=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:G})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const G=await this.z(L.id);this.s.fire({execution:G,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const G=await this.z(L.id);this.u.fire({execution:G,exitCode:L.exitCode})}$provideTasks(L,G){const B=this.j.get(L);if(!B)return Promise.reject(new Error("no handler found"));const F=[],V=(0,S.$xh)(()=>B.provider.provideTasks(R.CancellationToken.None)).then(ae=>this.v(G,F,B,ae));return new Promise(ae=>{V.then($e=>{Promise.all(F).then(()=>{ae($e)})})})}async $resolveTask(L,G){const B=this.j.get(L);if(!B)return Promise.reject(new Error("no handler found"));if(G.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${B.type}].`);const F=await C.to(G,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const V=await B.provider.resolveTask(F,R.CancellationToken.None);if(!V)return;this.A(V,B);const ae=C.from(V,B.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(ae.execution)&&await this.y(ae,V,!0),await this.w(ae)}x(){return this.h++}async y(L,G,B){const F=await this.a.$createTaskId(L);!B&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,G.execution)),this.m.set(F,G.execution)}async z(L,G){if(typeof L=="string"){const V=this.l.get(L);if(!V)throw new r.$db("Unexpected: The specified task is missing an execution");return V}const B=this.l.get(L.id);if(B)return B;let F;return G?F=Promise.resolve(new g(this,L.id,G)):F=C.to(L.task,this.b,this.m).then(V=>{if(!V)throw new r.$db("Unexpected: Task does not exist.");return new g(this,L.id,V)}),this.l.set(L.id,F),F.then(V=>(this.k.set(L.id,V),V))}A(L,G){L._deprecated&&this.g.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const B=this.n.values();let F=B.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=B.next()}};e.$dqc=w,e.$dqc=w=Qe([Ve(0,u.$1P),Ve(1,E.$eQ),Ve(2,T.$Foc),Ve(3,p.$_P),Ve(4,a.$Ioc),Ve(5,y.$7oc),Ve(6,o.$_j),Ve(7,h.$joc)],w);let M=class extends w{constructor(L,G,B,F,V,ae,$e,_){super(L,G,B,F,V,ae,$e,_),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:s.$h(s.Platform.Web)})}async executeTask(L,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const B=C.from(G,L);if(B===void 0)throw new Error("Task is not valid");if(I.is(B.execution))await this.y(B,G,!1);else throw new r.$bb;const F=await this.z(await this.a.$getTaskExecution(B),G);return this.a.$executeTask(B).catch(V=>{throw new Error(V)}),F}v(L,G,B,F){const V=[];if(F)for(const ae of F){if(this.A(ae,B),!ae.definition||!L[ae.definition.type]){const _=ae.source?ae.source:"No task source";this.f.warn(`The task [${_}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const $e=C.from(ae,B.extension);$e&&I.is($e.execution)?(V.push($e),G.push(this.y($e,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:B.extension}}async w(L){if(I.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,G,B){}};e.$eqc=M,e.$eqc=M=Qe([Ve(0,u.$1P),Ve(1,E.$eQ),Ve(2,T.$Foc),Ve(3,p.$_P),Ve(4,a.$Ioc),Ve(5,y.$7oc),Ve(6,o.$_j),Ve(7,h.$joc)],M),e.$fqc=(0,f.$Fi)("IExtHostTask")}),define(Ce[310],Ie([1,0,43,33]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=void 0,e.$gM=k,e.$iM=O;function k(A){return"cellResults"in A}e.$hM="rawCell#";function O(A,T){let p=-1;const a=[];let R=[];return A.forEach(u=>{u.range.startLineNumber!==p&&R.length>0&&(a.push([...R]),R=[]),R.push(u),p=u.range.endLineNumber}),R.length>0&&a.push([...R]),a.map(u=>{const E=[],f=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let s=f;s<=n;s++)E.push(T.getLineContent(s));return new b.$WL(E.join(`
`)+`
`,u.map(s=>new S.$Lt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Ce[311],Ie([1,0,186,23,6,4,29,38,13,15,2,30,80,5,34,8,7,39,288,124,26,16,43,241,310,308]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,y=qe(y),n=qe(n),s=qe(s);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,v,C,P,g,w,M){this.q=C,this.r=P,this.s=g,this.t=w,this.u=M,this.f=new Map,this.g=new A.$Cc,this.h=new Map,this.j=new k.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$hoc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(E.$uN.MainThreadNotebook),this.c=D.getProxy(E.$uN.MainThreadNotebookDocuments),this.d=D.getProxy(E.$uN.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,G=N.cell.handle,F=this.g.get(L)?.getCell(G);if(F)return F.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const L=N.uri,G=this.g.get(L);if(G)return G.apiNotebook}return N}}),$.C(v)}getEditorById(D){const v=this.h.get(D);if(!v)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(D){for(const[v,C]of this.h)if(C.apiEditor===D)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,v){const C=this.g.get(D);if(!C&&!v)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,v){if(!v)return;const C=v.filenamePattern.map(P=>n.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(v.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:v.displayName,filenamePattern:C,priority:v.exclusive?d.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,v,C){const P=$.a++,g=typeof C.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(P,C),this.b.$registerNotebookCellStatusBarItemProvider(P,g,v);let w;return g!==void 0&&(w=C.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(g))),new s.$wN(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,g),w?.dispose()})}async createNotebookDocument(D){const v=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&n.NotebookData.from(D.content)});return R.URI.revive(v)}async openNotebookDocument(D){const v=this.g.get(D);if(v)return v.apiNotebook;const C=await this.c.$tryOpenNotebook(D),P=this.g.get(R.URI.revive(C));return(0,a.$qg)(P?.apiNotebook)}async showNotebookDocument(D,v){R.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof v=="object"?C={position:n.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(n.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:C={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),g=P&&this.h.get(P)?.apiEditor;if(g)return g;throw P?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,v,C,P){const g=this.f.get(D),w=R.URI.revive(v),M=this.g.get(w);if(!M||!g)return;const N=M.getCellFromIndex(C);if(!N)return;const L=await g.provideCellStatusBarItems(N.apiCell,P);if(!L)return;const G=new O.$Vc,B=this.p.add([G]),V=(Array.isArray(L)?L:[L]).map(ae=>n.NotebookStatusBarItem.from(ae,this.i,G));return{cacheId:B,items:V}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,v,C,P,g){if((0,p.$df)(v))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:v,serializer:C,options:P}),this.b.$registerNotebookSerializer(w,{id:D.identifier,location:D.extensionLocation},v,n.NotebookDocumentContentOptions.from(P),$.w(D,g)),(0,O.$Uc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(D,v,C){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const g=await P.serializer.deserializeNotebook(v.buffer,C);return new o.$Tw(n.NotebookData.from(g))}async $notebookToData(D,v,C){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const g=await P.serializer.serializeNotebook(n.NotebookData.to(v.value),C);return S.$Oe.wrap(g)}async $saveNotebook(D,v,C,P,g){const w=R.URI.revive(v),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${w.toString()})`),!M)throw new Error("NO serializer found");const N=this.g.get(w);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new y.$ul((0,b.localize)(0,null,this.A(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,r.$lo)(N.apiNotebook.metadata,ae=>!(M.options?.transientDocumentMetadata??{})[ae]),cells:[]};for(const ae of N.apiNotebook.getCells()){const $e=new s.$ZO(ae.kind,ae.document.getText(),ae.document.languageId,ae.mime,M.options?.transientOutputs?[]:[...ae.outputs],ae.metadata,ae.executionSummary);$e.metadata=(0,r.$lo)(ae.metadata,_=>!(M.options?.transientCellMetadata??{})[_]),L.cells.push($e)}if(await this.z(w,P),g.isCancellationRequested)throw new Error("canceled");const G=await M.serializer.serializeNotebook(L,g);if(g.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${w.toString()}`),await this.s.value.writeFile(w,G),this.D(`Finished write versionId: ${C} ${w.toString()}`);const B=this.s.getFileSystemProviderExtUri(w.scheme),F=await this.s.value.stat(w),V={name:B.basename(w),isFile:(F.type&y.FileType.File)!==0,isDirectory:(F.type&y.FileType.Directory)!==0,isSymbolicLink:(F.type&y.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((F.permissions??0)&y.FilePermission.Locked),etag:y.$Fl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${w.toString()})`),V}async $searchInNotebooks(D,v,C,P,g){const w=this.y.get(D)?.serializer;if(!w)return{limitHit:!1,results:[]};const M=new A.$Dc;await(async(F,V,ae)=>{await Promise.all(F.map(async $e=>await Promise.all($e.filenamePatterns.map(_=>{const ge={_reason:ae._reason,folderQueries:ae.folderQueries,includePattern:ae.includePattern,excludePattern:ae.excludePattern,maxResults:ae.maxResults,type:c.QueryType.File,filePattern:_};return this.t.doInternalFileSearchWithCustomCallback(ge,V,se=>{se.forEach(ce=>{M.has(ce)||P.some(re=>$e.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Pe=>(0,d.$hL)(Pe,ce)))||M.add(ce)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(C,g,v);const L=new A.$Cc;let G=!1;const B=Array.from(M).map(async F=>{const V=[];try{if(g.isCancellationRequested)return;if(v.maxResults&&[...L.values()].reduce((ge,se)=>ge+se.cellResults.length,0)>v.maxResults){G=!0;return}const ae=[],$e=this.g.get(F);if($e)$e.apiNotebook.getCells().forEach(se=>ae.push({input:se.document.getText(),outputs:se.outputs.flatMap(ce=>ce.items.map(we=>we.data.toString()))}));else{const ge=await this.s.value.readFile(F),se=S.$Oe.fromString(ge.toString()),ce=await w.deserializeNotebook(se.buffer,g);if(g.isCancellationRequested)return;n.NotebookData.from(ce).cells.forEach(re=>ae.push({input:re.source,outputs:re.outputs.flatMap(Pe=>Pe.items.map(Me=>Me.valueBytes.toString()))}))}if(g.isCancellationRequested)return;ae.forEach((ge,se)=>{const ce=v.contentPattern.pattern,we=new l.$wZb(ge.input,void 0,ge.outputs),re=we.findInInputs(ce),Pe=we.findInOutputs(ce),Me=Pe.flatMap(Y=>(0,m.$iM)(Y.matches,Y.textBuffer)).map((Y,q)=>(Y.webviewIndex=q,Y));if(re.length>0||Pe.length>0){const Y={index:se,contentResults:(0,m.$iM)(re,we.inputTextBuffer),webviewResults:Me};V.push(Y)}});const _={resource:F,cellResults:V};L.set(F,_);return}catch{return}});return await Promise.all(B),{limitHit:G,results:[...L.values()]}}async z(D,v){const C=await this.s.value.stat(D);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==y.$El&&typeof C.mtime=="number"&&typeof C.size=="number"&&v.mtime<C.mtime&&v.etag!==y.$Fl({mtime:v.mtime,size:C.size}))throw new y.$ul((0,b.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,v)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,v,C){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const P=new i.$Jpc(v,this.d,D,C.visibleRanges.map(n.NotebookRange.to),C.selections.map(n.NotebookRange.to),typeof C.viewColumn=="number"?n.ViewColumn.to(C.viewColumn):void 0);this.h.set(v,P)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const P=R.URI.revive(C),g=this.g.get(P);g&&(g.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(g.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===P.toString()&&this.h.delete(w.id)}if(D.value.addedDocuments){const C=[];for(const P of D.value.addedDocuments){const g=R.URI.revive(P.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const w=new h.$Ipc(this.c,this.q,this.r,g,P);C.push(...P.cells.map(M=>h.$Hpc.asModelAddData(M))),this.g.get(g)?.dispose(),this.g.set(g,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(w.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const P=R.URI.revive(C.documentUri),g=this.g.get(P);g&&this.B(g,C.id,C)}const v=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const P=this.h.get(C);P&&(this.h.delete(C),this.k?.id===P.id&&(this.k=void 0),v.push(P))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const C=new Set;this.l.forEach(P=>C.add(P.id));for(const P of this.h.values()){const g=C.has(P.id);P._acceptVisibility(g)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const v=f.$mQ.String.with("notebookType","A notebook type"),C=new f.$oQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new f.$mQ("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>S.$Oe.wrap(g))],new f.$nQ("Notebook Data",g=>n.NotebookData.to(g.value))),P=new f.$oQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new f.$mQ("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$Tw(n.NotebookData.from(g)))],new f.$nQ("Bytes",g=>g.buffer));D.registerApiCommand(C),D.registerApiCommand(P)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Spc=$}),define(Ce[312],Ie([1,0,20,22,48,41,24,70,43]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0,b=qe(b),O=qe(O),A=qe(A);class a{constructor(u,E,f){this.k=u,this.l=E,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$zk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$zk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const E=this.k.folderQueries||[];return new Promise((f,n)=>{const s=o=>{this.f++,u(o)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const h=o.toString(),i=b.$pc(h);this.j&&this.j(h,i)||this.v(s,{base:o,basename:i})}),Promise.all(E.map(o=>this.p(o,s))).then(o=>{f({limitHit:this.e,stats:o[0]||void 0})},o=>{n(new Error((0,k.$qj)(o)))})})}async p(u,E){const f=new S.$xe,n=this.q(u),s=this.r(),o=new p.$$L(this.k,u),h=!o.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=T.$ge.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,f.token),t=i.elapsed(),c=T.$ge.create();return this.g&&!this.e||(r&&r.forEach(l=>{const m=b.$ic.relative(u.folder.path,l.path);if(h){const d=b.$pc(l.path);this.v(E,{base:u.folder,relativePath:m,basename:d});return}this.s(s,u.folder,m,E)}),this.g&&!this.e)?null:(this.u(s,o,E),{providerTime:t,postProcessTime:c.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(u){const E=(0,p.$0L)(this.k.includePattern,u.includePattern),f=(0,p.$0L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:f,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},E,f,n){if(f===this.a){const o=b.$pc(this.a);this.v(n,{base:E,relativePath:this.a,basename:o})}function s(o){const h=b.$pc(o),i=b.$oc(o);let r=u[i];r||(r=u[i]=[],s(i)),r.push({base:E,relativePath:o,basename:h})}s(f)}u({rootEntries:u,pathToEntries:E},f,n){const s=this,o=this.a;function h(i){const r=(0,p.$aM)(()=>i.map(t=>t.basename));for(let t=0,c=i.length;t<c;t++){const l=i[t],{relativePath:m,basename:d}=l;if(f.matchesExcludesSync(m,d,o!==d?r:void 0))continue;const $=E[m];if($)h($);else{if(m===o)continue;s.v(n,l)}if(s.e)break}}h(u)}v(u,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,E,f,n){const s=this.c(u.cacheKey),o=new a(u,E,s&&s.token);let h=0;const i=r=>{h+=r.length,f(r.map(t=>this.d(t)))};return this.e(o,R.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:r.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new S.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:A.$gh(u.base,u.relativePath)}:{resource:u.base}}e(u,E,f,n){const s=n.onCancellationRequested(()=>{u.cancel()}),o=i=>{i&&(h.push(i),E>0&&h.length>=E&&(f(h),h=[]))};let h=[];return u.search(o).then(i=>(h.length&&f(h),s.dispose(),i),i=>(h.length&&f(h),s.dispose(),Promise.reject(i)))}}e.$Kpc=R}),define(Ce[313],Ie([1,0,18,282,41,103,29,16,20,24,13,15,2,102,206,42,12,50,118,309,43]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0,e.$_M=v,b=qe(b),S=qe(S),k=qe(k),p=qe(p),R=qe(R),f=qe(f);let t=class{constructor(P,g,w,M,N){this.a=P,this.b=g,this.c=w,this.d=M,this.e=N}text(P,g,w={}){P=this.f(P,w);const M=this.a.getValue(),N=g&&g.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(g?.map(o.$1i),w),type:r.QueryType.Text,contentPattern:P,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(P,g){const w=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const M={...P,wordSeparators:w.editor.wordSeparators};return this.j(P,g)&&(M.isCaseSensitive=!0),this.k(P)&&(M.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),M}file(P,g={}){return{...this.h(P,g),type:r.QueryType.File,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey,shouldGlobMatchFilePattern:g.shouldGlobSearch}}g(P,g){return P?(P=Array.isArray(P)?P.map($):$(P),g?this.parseSearchPaths(P):{pattern:l(...Array.isArray(P)?P:[P])}):{}}h(P=[],g={}){const w=this.g(g.includePattern,g.expandPatterns),M=this.g(g.excludePattern,g.expandPatterns),N=P.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(F=>this.q(F,g,M)):P.map(F=>this.r(F,g,M,N))).filter(F=>!!F),G={_reason:g._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:M.pattern,includePattern:w.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const F=b.$Jb(this.c.groups.flatMap($e=>$e.editors.map(_=>_.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const V=F.filter($e=>(0,r.$1L)(G,$e.fsPath)),ae=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...G,...ae}}const B=g.extraFileResources&&g.extraFileResources.filter(F=>(0,r.$1L)(G,F.fsPath));return G.extraFileResources=B&&B.length?B:void 0,G}i(P){const g=[],w=new A.$Cc,M={};let N=!1;return P.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,a.$kh)(L)){const B=this.b.getWorkspaceFolder(L)?.uri??L.with({path:p.$oc(L.fsPath)});let F=w.get(B);F||(N=!0,F={folder:B,includePattern:{}},g.push(F),w.set(B,F));const V=p.$nc(B.fsPath,L.fsPath);(0,y.$qg)(F.includePattern)[V.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,M[L.fsPath]=!0)}),{folderQueries:g,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(P,g){if(g.isSmartCase){if(P.isRegExp){if(R.$9f(P.pattern,!0))return!0}else if(R.$9f(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,E.$bD)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const g=ae=>p.$kc(ae)||/^\.\.?([\/\\]|$)/.test(ae),M=(Array.isArray(P)?P:m(P)).map(ae=>{const $e=this.e.resolvedUserHome;return $e?(0,O.$Yw)(ae,$e.scheme===T.Schemas.file?$e.fsPath:$e.path):ae}),N=S.$K(M,ae=>g(ae)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(ae=>R.$of(ae,"/")).map(ae=>R.$of(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),d(ae))),G={},B=this.m(N.searchPaths||[]);B&&B.length&&(G.searchPaths=B);const F=L.flat(),V=l(...F);return V&&(G.pattern=V),G}l(P,g){return g.disregardExcludeSettings?void 0:(0,r.$ZL)(P,!g.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const g=P.flatMap(M=>{let{pathPortion:N,globPortion:L}=c(M);return L&&(L=I(L)),this.n(N).flatMap(B=>this.o(B,L))}),w=new Map;return g.forEach(M=>{const N=M.searchPath.toString(),L=w.get(N);L?M.pattern&&(L.pattern=L.pattern||{},L.pattern[M.pattern]=!0):w.set(N,{searchPath:M.searchPath,pattern:M.pattern?l(M.pattern):void 0})}),Array.from(w.values())}n(P){if(p.$kc(P)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==T.Schemas.file?[{searchPath:g[0].uri.with({path:P})}]:[{searchPath:u.URI.file(p.$jc(P))}]}if(this.b.getWorkbenchState()===o.WorkbenchState.FOLDER){const g=this.b.getWorkspace().folders[0].uri;if(P=$(P),P.startsWith("../")||P===".."){const M=p.$ic.resolve(g.path,P);return[{searchPath:g.with({path:M})}]}const w=I(P);return[{searchPath:g,pattern:w}]}else{if(P==="./"||P===".\\")return[];{const g=P.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(N=>{const L=g.match(new RegExp(`^${R.$if(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(y.$ng);if(M.length)return M.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&I(L)}});{const N=P.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:P,G=f.localize(0,null,L);throw new Error(G)}}}}o(P,g){const w=P.pattern&&g?`${P.pattern}/${g}`:P.pattern||g,M=[{searchPath:P.searchPath,pattern:w}];return w&&!w.endsWith("**")&&M.push({searchPath:P.searchPath,pattern:w+"/**"}),M}q(P,g,w){const M=this.r((0,o.$1i)(P.searchPath),g,w,!1);return M?{...M,includePattern:P.pattern}:null}r(P,g,w,M){let N;const L=u.URI.isUri(P)?P:P.uri;if(w.searchPaths){const ae=w.searchPaths.filter($e=>(0,a.$_g)($e.searchPath,L))[0];if(ae&&!ae.pattern)return null;ae&&(N=ae.pattern)}const G=this.a.getValue({resource:L}),F={...this.l(G,g)||{},...N||{}},V=u.URI.isUri(P)?(0,a.$dh)(P):P.name;return{folder:L,folderName:M?V:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!G.search.followSymlinks}}};e.$$M=t,e.$$M=t=Qe([Ve(0,n.$_i),Ve(1,o.$Oi),Ve(2,h.$jE),Ve(3,s.$_j),Ve(4,i.$9M)],t);function c(C){const P=C.match(/[\*\{\}\(\)\[\]\?]/);if(P){const g=P.index,w=C.substr(0,g).match(/[/|\\][^/\\]*$/);if(w){let M=C.substr(0,w.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:C.substr((w.index||0)+1)}}}return{pathPortion:C}}function l(...C){return C.length?C.reduce((P,g)=>(P[g]=!0,P),Object.create(null)):void 0}function m(C){return k.$xk(C,",").map(P=>P.trim()).filter(P=>!!P.length)}function d(C){return[`**/${C}/**`,`**/${C}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function $(C){return C.replace(/\\/g,"/")}function I(C){return $(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function v(C,P){C=b.$Ob(C,M=>M.toString());const g=[],w=P.getWorkspace();return C&&C.forEach(M=>{let N;if(P.getWorkbenchState()===o.WorkbenchState.FOLDER)N=(0,a.$ih)(w.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const L=P.getWorkspaceFolder(M);if(L){const G=L.name;if(w.folders.filter(F=>F.name===G).length===1){const F=(0,a.$ih)(L.uri,M);F===""?N=`./${L.name}`:N=`./${L.name}/${F}`}else N=M.fsPath}}N&&g.push(D(N))}),g}}),define(Ce[314],Ie([1,0,24,2,22,14,3,313,43,50,11]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cyb=u,e.$dyb=n,b=qe(b),O=qe(O);const y=7e3;function u(s,o){const h=o.activationEvents;if(!h)return Promise.resolve(void 0);const i=[],r=[];for(const $ of h)if(/^workspaceContains:/.test($)){const I=$.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||s.forceUsingSearch?r.push(I):i.push(I)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:c}=(0,R.$yh)(),l=$=>c({activationEvent:$}),m=Promise.all(i.map($=>E(s,$,l))).then(()=>{}),d=f(s,o.identifier,r,l);return Promise.all([m,d]).then(()=>{c(void 0)}),t}async function E(s,o,h){for(const i of s.folders)if(await s.exists(b.$gh(S.URI.revive(i),o))){h(`workspaceContains:${o}`);return}}async function f(s,o,h,i){if(h.length===0)return Promise.resolve(void 0);const r=new k.$xe,t=s.checkExists(s.folders,h,r.token),c=setTimeout(async()=>{r.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},y);let l=!1;try{l=await t}catch(m){O.$6(m)||O.$3(m)}r.dispose(),clearTimeout(c),l&&i(`workspaceContains:${h.join(",")}`)}function n(s,o,h,i){const r=s.get(A.$Ei),t=s.get(p.$RL),l=r.createInstance(T.$$M).file(o.map(m=>(0,a.$1i)(S.URI.revive(m))),{_reason:"checkExists",includePattern:h,exists:!0});return t.fileSearch(l,i).then(m=>!!m.limitHit,m=>O.$6(m)?!1:Promise.reject(m))}}),define(Ce[46],Ie([1,0,182,20,65,24,11,4,59,2,12,5,45,248,89,44,25,119,14,19,23,230,7,110,3,27,92,17,75,93,57,95,6,314,88,232,16,86,70,21,87]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l,m,d,$,I,D,v,C,P,g,w,M,N,L,G,B,F,V){"use strict";var ae;Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=e.$kpc=e.$jpc=e.$ipc=e.$hpc=void 0,b=qe(b),S=qe(S),k=qe(k),h=qe(h),e.$hpc=(0,m.$Fi)("IHostUtils");let $e=ae=class extends T.$Wc{constructor(Y,q,ee,ve,ue,be,de,X,Z,me,pe,Oe,ze){super(),this.Y=Oe,this.Z=ze,this.a=this.B(new g.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=ee,this.f=de,this.j=ve,this.m=ue,this.s=be,this.t=Z,this.u=me,this.w=pe,this.y=this.g.getProxy(y.$uN.MainThreadWorkspace),this.z=this.g.getProxy(y.$uN.MainThreadTelemetry),this.C=this.g.getProxy(y.$uN.MainThreadExtensionService),this.D=new A.$Eh,this.F=new A.$Eh,this.G=new A.$Eh,this.H=new A.$Eh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new o.$Kcc(this.I,this.f.extensions.allExtensions);const ke=new i.$rn(this.f.extensions.myExtensions);this.J=new o.$Kcc(this.I,we(this.L,ke)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new f.$3oc(this.g,this.s),this.N=new M.$apc(this.g),this.O=X,this.h=Y.createChild(new D.$Di([f.$4oc,this.M],[M.$bpc,this.N])),this.P=this.B(new E.$2oc(this.J,this.L,{onExtensionActivationError:(Ae,Ne,j)=>{this.C.$onExtensionActivationError(Ae,h.$5(Ne),j)},actualActivateExtension:async(Ae,Ne)=>{if(o.$Kcc.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Ne),new E.$1oc;const j=this.J.getExtensionDescription(Ae);return this.fb(j,Ne)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){h.$3(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this.eb(ue))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const ee=this.$();Promise.race([(0,A.$Gh)(5e3),ee]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new i.$qn(q.identifier.value),extensionLocation:a.URI.revive(q.extensionLocation)}}ab(Y,q){return this.P.activateByEvent(Y,q)}bb(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.bb(Y,q).then(()=>{const ee=this.P.getActivatedExtension(Y);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const q=Y.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const ee=await this.R.get(q);return a.URI.file(ee)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new re(Y))),this.Q}async db(Y){const q=p.$Li.forUris(ee=>O.$0g.ignorePathCasing(ee));return await Promise.all(Y.map(async ee=>{if(this.wb(ee)){const ve=await this.cb(ee.extensionLocation);q.set(ve,ee)}})),q}eb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const ee=this.P.getActivatedExtension(Y);if(!ee)return q;try{typeof ee.module.deactivate=="function"&&(q=Promise.resolve(ee.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{(0,T.$Rc)(ee.subscriptions)}catch(ve){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return q}async fb(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,q).then(ee=>{const ve=ee.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,q),this.gb(Y,q,"success",ve),ee},ee=>{throw this.gb(Y,q,"failure"),ee})}gb(Y,q,ee,ve){const ue=ge(Y,q);this.z.$publicLog2("extensionActivationTimes",{...ue,...ve||{},outcome:ee})}hb(Y,q){const ee=ge(Y,q);this.z.$publicLog2("activatePlugin",ee);const ve=this.wb(Y);if(!ve)return Promise.resolve(new E.$Zoc(E.$Woc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ue=new E.$Xoc(q.startup);return Promise.all([this.xb(Y,(0,O.$gh)(Y.extensionLocation,ve),ue),this.ib(Y)]).then(be=>(k.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),ae.jb(this.s,Y.identifier,be[0],be[1],ue))).then(be=>(k.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),be))}ib(Y){const q=this.Z.createLanguageModelAccessInformation(Y),ee=new t.$6oc(Y,this.M),ve=new t.$5oc(Y.identifier.value,!1,this.M),ue=new N.$cpc(Y,this.N),be=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,de=this.f.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ee.whenReady,ve.whenReady,this.O.whenReady]).then(()=>{const X=this;let Z,me;const pe=(0,s.$6G)(Y,"ipc")?this.f.messagePorts?.get(i.$qn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ee,workspaceState:ve,secrets:ue,subscriptions:[],get languageModelAccessInformation(){return q},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Oe){return S.$lc(Y.extensionLocation.fsPath,Oe)},get storagePath(){return X.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return X.O.globalValue(Y).fsPath},get logPath(){return S.$lc(X.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return a.URI.joinPath(X.f.logsLocation,Y.identifier.value)},get storageUri(){return X.O.workspaceValue(Y)},get globalStorageUri(){return X.O.globalValue(Y)},get extensionMode(){return be},get extension(){return Z===void 0&&(Z=new ce(X,Y.identifier,Y,de,!1)),Z},get extensionRuntime(){return(0,s.$7G)(Y,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!me){if(!pe)return;const Oe=g.Event.buffer(g.Event.fromDOMEventEmitter(pe,"message",ze=>ze.data));pe.start(),me={onDidReceiveMessage:Oe,postMessage:pe.postMessage.bind(pe)}}return me}})})}static jb(Y,q,ee,ve,ue){return ee=ee||{activate:void 0,deactivate:void 0},this.kb(Y,q,ee,ve,ue).then(be=>new E.$Yoc(!1,null,ue.build(),ee,be,ve.subscriptions))}static kb(Y,q,ee,ve,ue){if(typeof ee.activate=="function")try{ue.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const be=typeof global=="object"?global:self,de=ee.activate.apply(be,[ve]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(de).then(X=>(ue.activateResolveStop(),X))}catch(be){return Promise.reject(be)}else return Promise.resolve(ee)}lb(Y,q){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,ee=>{this.s.error(ee)})}mb(Y,q=0){const ve=Date.now();(0,F.$B)(()=>{for(let ue=q;ue<Y.length;ue+=1){const be=Y[ue];for(const de of be.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,ue);break}else this.lb(be,de)}})}nb(){this.C.$setPerformanceMarks(k.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ee=this.J.getAllExtensionDescriptions();if(q)this.mb(ee);else for(const ve of ee)if(ve.activationEvents)for(const ue of ve.activationEvents)ue==="onStartupFinished"&&this.lb(ve,ue)})}ob(){const Y=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const q=this.j.workspace?this.j.workspace.folders:[],ee=this.pb(q),ve=this.rb(),ue=Promise.all([ve,Y,ee]).then(()=>{});return Promise.race([ue,(0,A.$Gh)(1e4)]).then(()=>{this.nb()}),ue}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Y,q))).then(()=>{})}async qb(Y,q){if(this.isActivated(q.identifier))return;const ee=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(be=>be.uri),forceUsingSearch:ee||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,de,X)=>this.y.$checkExists(be,de,X)},ue=await(0,w.$cyb)(ve,q);if(ue)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ue.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(b.localize(0,null));const ee=await this.xb(null,q,new E.$Xoc(!1));if(!ee||typeof ee.run!="function")throw new Error(b.localize(1,null,q.toString()));return new Promise((ve,ue)=>{const be=(Z,me)=>{Z?(F.$t&&this.s.error("Test runner called back with error",Z),ue(Z)):(F.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof me=="number"&&me>0?1:0))},de=(0,O.$7g)(q),X=ee.run(de,be);X&&X.then&&X.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ve(0)}).catch(Z=>{F.$t&&this.s.error("Test runner finished with error",Z),ue(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.S[Y]=q,(0,T.$Uc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.ub(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const q=Y.indexOf("+");if(q===-1)throw new c.$CN("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ee=Y.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this.S[ee]}}async $resolveAuthority(Y,q){const ee=B.$ge.create(!1),ve=()=>`[resolveAuthority(${(0,l.$Ul)(Y)},${q})][${ee.elapsed()}ms] `,ue=U=>this.s.info(`${ve()}${U}`),be=U=>this.s.warn(`${ve()}${U}`),de=(U,K=void 0)=>this.s.error(`${ve()}${U}`,K),X=U=>{if(U instanceof c.$CN)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},Z=async U=>{ue(`activating resolver for ${U}...`);const{resolver:K,authorityPrefix:H}=await this.ub(U);if(!K)throw de(`no resolver for ${H}`),new c.$CN(`No remote extension installed to resolve ${H}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:U}},me=Y.split(/@|%40/g).reverse();ue(`activating remote resolvers ${me.join(" -> ")}`);let pe;try{pe=await Promise.all(me.map(Z)).catch(async U=>{if(!(U instanceof c.$CN)||U._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return be(`resolving nested authorities failed: ${U.message}`),[await Z(Y)]})}catch(U){return X(U)}const Oe=new A.$Qh;Oe.cancelAndSet(()=>ue("waiting..."),1e3);let ze,ke;for(const[U,{authorityPrefix:K,resolver:H,remoteAuthority:ie}]of pe.entries())try{if(U===pe.length-1)ue("invoking final resolve()..."),k.mark(`code/extHost/willResolveAuthority/${K}`),ze=await H.resolve(ie,{resolveAttempt:q,execServer:ke}),k.mark(`code/extHost/didResolveAuthorityOK/${K}`),ue("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,c.$BN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ue(`invoking resolveExecServer() for ${ie}`),k.mark(`code/extHost/willResolveExecServer/${K}`),ke=await H.resolveExecServer?.(ie,{resolveAttempt:q,execServer:ke}),!ke)throw new c.$CN(`Exec server was not available for ${ie}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);k.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(fe){return k.mark(`code/extHost/didResolveAuthorityError/${K}`),de("returned an error",fe),Oe.dispose(),X(fe)}Oe.dispose();const Ae={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ue(`returned ${c.$BN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let j;if(c.$BN.isManagedResolvedAuthority(ze)){const U=q;this.Y.setFactory(U,ze.makeConnection),j={authority:Y,connectTo:new l.$Rl(U),connectionToken:ze.connectionToken}}else j={authority:Y,connectTo:new l.$Sl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:j,options:Ne,tunnelInformation:Ae}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Ul)(Y)})`);const{resolver:ee}=await this.ub(Y);if(!ee)return null;const ve=a.URI.revive(q);if(typeof ee.getCanonicalURI>"u")return ve;const ue=await(0,A.$xh)(()=>ee.getCanonicalURI(ve));return ue||ve}async $startExtensionHost(Y){Y.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:q,myExtensions:ee}=_(this.I,this.L,this.J,Y),ve=await this.db(ee);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ee),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(Y,q){return q===s.ActivationKind.Immediate?this.D.wait().then(ee=>this.ab(Y,!1)):this.G.wait().then(ee=>this.ab(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:q,myExtensions:ee}=_(this.I,this.L,this.J,Y),ve=await this.db(ee);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ee),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=r.$Oe.alloc(Y),ee=Math.random()%256;for(let ve=0;ve<Y;ve++)q.writeUInt8(ee,ve);return q}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$ipc=$e,e.$ipc=$e=ae=Qe([Ve(0,m.$Ei),Ve(1,e.$hpc),Ve(2,I.$1P),Ve(3,n.$Foc),Ve(4,u.$Ioc),Ve(5,R.$_j),Ve(6,d.$eQ),Ve(7,$.$Loc),Ve(8,v.$XFb),Ve(9,C.$7oc),Ve(10,G.$epc),Ve(11,V.$fpc),Ve(12,P.$$oc)],$e);function _(Me,Y,q,ee){Me.addActivationEvents(ee.addActivationEvents);const ve=new o.$Kcc(Me,Y.getAllExtensionDescriptions());ve.deltaExtensions(ee.toAdd,ee.toRemove);const ue=new i.$rn(q.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ee.myToRemove)ue.delete(de);for(const de of ee.myToAdd)ue.add(de);const be=we(ve,ue);return{globalRegistry:ve,myExtensions:be}}function ge(Me,Y){return{id:Me.identifier.value,name:Me.name,extensionVersion:Me.version,publisherDisplayName:Me.publisher,activationEvents:Me.activationEvents?Me.activationEvents.join(","):null,isBuiltin:Me.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function se(Me){return Me.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$jpc=(0,m.$Fi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(Y,q,ee,ve,ue){this.#e=Y,this.#t=q,this.#i=ee.identifier,this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=S.$jc((0,O.$7g)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=ve,this.isFromDifferentExtensionHost=ue}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$kpc=ce;function we(Me,Y){return Me.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class re{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$lpc=re;class Pe{constructor(Y){this.a=new i.$sn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Ce[315],Ie([1,0,65,2,5,45,25,19,17,27,3,46,12,13]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0,b=qe(b);let n=class{constructor(r,t,c,l,m,d,$){this.c=r,this.d=t,this.e=c,this.f=l,this.g=m,this.h=d,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),b.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new o(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$wqc=n,e.$wqc=n=Qe([Ve(2,R.$Ei),Ve(3,O.$Ioc),Ve(4,y.$jpc),Ve(5,a.$eQ),Ve(6,u.$_j)],n);let s=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&f.a.size){const t=(0,E.$if)(this.c(r.environment.appRoot.fsPath)),c="[a-z0-9_.-]",l=`@${c}+\\/${c}+|${c}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,c,l,m]=t,d=f.a.get(l);if(d!==void 0)return console.warn(`${l} as been renamed to ${d}, please update your imports`),c+d+m}c(r){return r.replace(/\\/g,"/")}};s=f=Qe([Ve(0,a.$eQ)],s);class o{constructor(r,t,c,l,m){this.c=r,this.d=t,this.e=c,this.f=l,this.g=m,this.nodeModuleName="vscode",this.a=new T.$sn}load(r,t){const c=this.d.findSubstr(t);if(c){let l=this.a.get(c.identifier);return l||(l=this.c(c,this.e,this.f),this.a.set(c.identifier,l)),l}if(!this.b){let l="";this.d.forEach((m,d)=>l+=`	${d} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(A.$1G,this.e,this.f)}return this.b}}let h=class{constructor(r,t,c){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=c.getProxy(k.$uN.MainThreadTelemetry);const l=c.getProxy(k.$uN.MainThreadWindow);this.c=(m,d)=>{const $=S.URI.parse(m);return d?this.g(m,d):$.scheme==="http"||$.scheme==="https"?l.$openUri($,m,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?l.$openUri($,m,{}):this.g(m,d)}}load(r,t,c){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=c(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=Qe([Ve(2,p.$1P)],h)}),define(Ce[132],Ie([1,0,47,4,20,79,3,58,71,46,7,44,245,45]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=e.$mpc=void 0,k=qe(k),O=qe(O),e.$mpc=(0,A.$Fi)("IExtHostVariableResolverProvider");class f extends u.$5Q{constructor(o,h,i,r,t,c,l){function m(){if(i){const d=i.activeEditor();if(d)return d.document.uri;const $=r.tabGroups.all.find(I=>I.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$iP||$.input instanceof R.$nP)return $.input.modified;if($.input instanceof R.$hP||$.input instanceof R.$mP||$.input instanceof R.$kP)return $.input.uri}}}super({getFolderUri:d=>{const $=c.folders.filter(I=>I.name===d);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>c.folders.length,getConfigurationValue:(d,$)=>t.getConfiguration(void 0,d).get($),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=m();if(d)return k.$jc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const d=m();if(d){const $=h.getWorkspaceFolder(d);if($)return k.$jc($.uri.fsPath)}}},getSelectedText:()=>{if(i){const d=i.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(i){const d=i.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>o.getExtension(d)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(O.env))}}let n=class extends S.$Wc{constructor(o,h,i,r,t){super(),this.b=o,this.c=h,this.g=i,this.h=r,this.j=t,this.a=new b.$X(async()=>{const c=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,c,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$npc=n,e.$npc=n=Qe([Ve(0,a.$jpc),Ve(1,y.$Foc),Ve(2,T.$_P),Ve(3,E.$Ioc),Ve(4,p.$Uoc)],n)}),define(Ce[133],Ie([1,0,11,6,2,4,19,3,5,71,46,17,7,44,237,81,238,45,132,35,34,8,18,96]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=e.$wpc=e.$vpc=e.$upc=e.$tpc=void 0,t=qe(t),e.$tpc=(0,T.$Fi)("IExtHostDebugService");let m=class extends O.$Wc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(P,g,w,M,N,L,G,B){super(),this.Y=g,this.Z=w,this.$=M,this.ab=N,this.bb=L,this.cb=G,this.db=B,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new S.$me),this.z=this.B(new S.$me),this.C=this.B(new S.$me),this.F=this.B(new S.$me),this.u=P.getProxy(p.$uN.MainThreadDebugService),this.I=this.B(new S.$me),this.L=this.B(new S.$me),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(V=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(P,g){const w=this.gb(g);if(!w)return;const M=await this.Q.get(P)?.getTreeItem?.(w);return M?this.eb(P,M):void 0}registerDebugVisualizationTree(P,g,w){const M=A.$qn.toKey(P.identifier),N=this.ub(M,g);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.Q.set(N,w),this.u.$registerDebugVisualizerTree(N,!!w.editItem),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(g)})}async $getVisualizerTreeItemChildren(P,g){const w=this.S.get(g)?.item;return w?(await this.Q.get(P)?.getChildren?.(w))?.map(N=>this.eb(P,N))||[]:[]}async $editVisualizerTreeItem(P,g){const w=this.S.get(P);if(!w)return;const M=await this.Q.get(w.provider)?.editItem?.(w.item,g);return this.eb(w.provider,M||w.item)}$disposeVisualizedTree(P){const g=this.S.get(P);if(!g)return;const w=[g.children];for(const M of w)if(M)for(const N of M)w.push(this.S.get(N)?.children),this.S.delete(N)}eb(P,g){let w=this.R.get(g);return w||(w=this.O++,this.R.set(g,w),this.S.set(w,{provider:P,item:g})),t.DebugTreeItem.from(g,w)}asDebugSourceUri(P,g){const w=P;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let M=`debug:${encodeURIComponent(w.path||"")}`,N="?";return g&&(M+=`${N}session=${encodeURIComponent(g.id)}`,N="&"),M+=`${N}ref=${w.sourceReference}`,k.URI.parse(M)}else{if(w.path)return k.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(P){const g=[];for(const w of P.getAllExtensionDescriptions())if(w.contributes){const M=w.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,s.$YH)(N)&&g.push(N.type)}this.u.$registerDebugTypes(g)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const P=[];return this.H.forEach(g=>P.push(g)),P}async $resolveDebugVisualizer(P,g){const w=this.W.get(P);if(!w)throw new Error(`No debug visualizer found with id '${P}'`);let{v:M,provider:N,extensionId:L}=w;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,g)||M,w.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(P){const g=this.W.get(P);if(!g)throw new Error(`No debug visualizer found with id '${P}'`);const w=g.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(P){const g=this.w.get(P.sessionId);return g&&{session:g.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId}}async $provideDebugVisualizers(P,g,w,M){const N=this.gb(w),L=this.ub(P,g),G=this.P.get(L);if(!N||!G)return[];const B=await G.provideDebugVisualization(N,M);return B?B.map(F=>{const V=++this.X;this.W.set(V,{v:F,provider:G,extensionId:P});const ae=F.iconPath?this.wb(F.iconPath):void 0;return{id:V,name:F.name,iconClass:ae?.iconClass,iconPath:ae?.iconPath,visualization:this.vb(P,F.visualization)}}):[]}$disposeDebugVisualizers(P){for(const g of P)this.W.delete(g)}registerDebugVisualizationProvider(P,g,w){if(!P.contributes?.debugVisualizers?.some(L=>L.id===g))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${g})`);const M=A.$qn.toKey(P.identifier),N=this.ub(M,g);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.P.set(N,w),this.u.$registerDebugVisualizer(M,g),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizer(M,g),this.P.delete(g)})}addBreakpoints(P){const g=P.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(g,[],[]);const w=[],M=new Map;for(const N of g)if(N instanceof u.$yO){let L=M.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),L),w.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$zO&&w.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(P){const g=P.filter(L=>this.H.delete(L.id));this.rb([],g,[]);const w=g.filter(L=>L instanceof u.$yO).map(L=>L.id),M=g.filter(L=>L instanceof u.$zO).map(L=>L.id),N=g.filter(L=>L instanceof u.$AO).map(L=>L.id);return this.u.$unregisterBreakpoints(w,M,N)}startDebugging(P,g,w){const M=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(P?P.uri:void 0,g,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(P){return this.u.$stopDebugging(P?P.id:void 0)}registerDebugConfigurationProvider(P,g,w){if(!g)return new u.$wN(()=>{});const M=this.f++;return this.g.push({type:P,handle:M,provider:g}),this.u.$registerDebugConfigurationProvider(P,w,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,M),new u.$wN(()=>{this.g=this.g.filter(N=>N.provider!==g),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(P,g,w){if(!w)return new u.$wN(()=>{});if(!this.nb(P,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.kb(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:g,handle:M,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(g,M),new u.$wN(()=>{this.j=this.j.filter(N=>N.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(P,g){if(!g)return new u.$wN(()=>{});const w=this.m++;return this.n.push({type:P,handle:w,factory:g}),new u.$wN(()=>{this.n=this.n.filter(M=>M.factory!==g)})}async $runInTerminal(P,g){return Promise.resolve(void 0)}async $substituteVariables(P,g){let w;const M=await this.tb(P);return M&&(w={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,g)}hb(P,g){if(P.type==="implementation")return new D(P.implementation)}ib(){}async $startDASession(P,g){const w=this,M=await this.sb(g);return this.pb(this.kb(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(N),G=this.hb(L,M);if(!G)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const B=G;return this.M.set(P,B),this.ob(M).then(F=>(F&&this.N.set(P,F),B.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const ae=V,$e={type:"response",seq:0,command:ae.command,request_seq:ae.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const _=await this.U.sign(ae.arguments.value);$e.body={signature:_},B.sendResponse($e)}else throw new Error("no signer")}catch(_){$e.success=!1,$e.message=_.message,B.sendResponse($e)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(V),V=(0,s.$4H)(V,!0),w.u.$acceptDAMessage(P,V)}),B.onError(V=>{F&&F.onError&&F.onError(V),this.u.$acceptDAError(P,V.name,V.message,V.stack)}),B.onExit(V=>{F&&F.onExit&&F.onExit(V??void 0,void 0),this.u.$acceptDAExit(P,V??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),B.startSession()))})}$sendDAMessage(P,g){g=(0,s.$3H)(g,!1);const w=this.N.get(P);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(g),this.M.get(P)?.sendMessage(g)}$stopDASession(P){const g=this.N.get(P);this.N.delete(P),g&&g.onWillStopSession&&g.onWillStopSession();const w=this.M.get(P);return this.M.delete(P),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(P){const g=[],w=[],M=[];if(P.added)for(const N of P.added){const L=N.id;if(L&&!this.H.has(L)){let G;if(N.type==="function")G=new u.$zO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")G=new u.$AO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const B=k.URI.revive(N.uri);G=new u.$yO(new u.$IN(B,new u.$xN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$wO)(G,L),this.H.set(L,G),g.push(G)}}if(P.removed)for(const N of P.removed){const L=this.H.get(N);L&&(this.H.delete(N),w.push(L))}if(P.changed){for(const N of P.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof u.$zO&&N.type==="function"){const G=L;G.enabled=N.enabled,G.condition=N.condition,G.hitCondition=N.hitCondition,G.logMessage=N.logMessage,G.functionName=N.functionName}else if(L instanceof u.$yO&&N.type==="source"){const G=L;G.enabled=N.enabled,G.condition=N.condition,G.hitCondition=N.hitCondition,G.logMessage=N.logMessage,G.location=new u.$IN(k.URI.revive(N.uri),new u.$xN(N.line,N.character))}M.push(L)}}}this.rb(g,w,M)}async $acceptStackFrameFocus(P){let g;if(P){const w=await this.sb(P.sessionId);P.kind==="thread"?g=new u.$GO(w.api,P.threadId):g=new u.$FO(w.api,P.threadId,P.frameId)}this.J=g,this.L.fire(this.J)}$provideDebugConfigurations(P,g,w){return(0,b.$xh)(async()=>{const M=this.mb(P);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(g);return M.provideDebugConfigurations(N,w)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(P,g,w,M){return(0,b.$xh)(async()=>{const N=this.mb(P);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(g);return N.resolveDebugConfiguration(L,w,M)})}$resolveDebugConfigurationWithSubstitutedVariables(P,g,w,M){return(0,b.$xh)(async()=>{const N=this.mb(P);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(g);return N.resolveDebugConfigurationWithSubstitutedVariables(L,w,M)})}async $provideDebugAdapter(P,g){const w=this.lb(P);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(g);return this.pb(w,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(P){const g=await this.sb(P);this.y.fire(g.api)}async $acceptDebugSessionTerminated(P){const g=await this.sb(P);g&&(this.z.fire(g.api),this.w.delete(g.id))}async $acceptDebugSessionActiveChanged(P){this.D=P?await this.sb(P):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(P,g){(await this.sb(P))?._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(P,g){const M={session:(await this.sb(P)).api,event:g.event,body:g.body};this.F.fire(M)}jb(P){if(P instanceof u.$BO)return{type:"executable",command:P.command,args:P.args,options:P.options};if(P instanceof u.$CO)return{type:"server",port:P.port,host:P.host};if(P instanceof u.$DO)return{type:"pipeServer",path:P.path};if(P instanceof u.$EO)return{type:"implementation",implementation:P.implementation};throw new Error("convertToDto unexpected type")}kb(P){const g=this.j.filter(w=>w.type===P);if(g.length>0)return g[0].factory}lb(P){const g=this.j.filter(w=>w.handle===P);if(g.length>0)return g[0].factory}mb(P){const g=this.g.filter(w=>w.handle===P);if(g.length>0)return g[0].provider}nb(P,g){if(P.contributes){const w=P.contributes.debuggers;if(w&&w.length>0){for(const M of w)if(M.label&&M.type&&M.type===g)return!0}}return!1}ob(P){const w=P.configuration.type,M=this.n.filter(N=>N.type===w||N.type==="*").map(N=>(0,b.$xh)(()=>N.factory.createDebugAdapterTracker(P.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(N=>{const L=(0,c.$Jb)(N);if(L.length>0)return new I(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(P,g){const w=g.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new u.$CO(w));if(P){const N=await this.Z.getExtensionRegistry();return(0,b.$xh)(()=>P.createDebugAdapterDescriptor(g.api,this.qb(g,N))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(g,M))}qb(P,g){}rb(P,g,w){(P.length>0||g.length>0||w.length>0)&&this.I.fire(Object.freeze({added:P,removed:g,changed:w}))}async sb(P){if(P)if(typeof P=="string"){const g=this.w.get(P);if(g)return g}else{let g=this.w.get(P.id);if(!g){const w=await this.tb(P.folderUri),M=P.parent?this.w.get(P.parent):void 0;g=new d(this.u,P.id,P.type,P.name,w,P.configuration,M?.api),this.w.set(g.id,g),this.u.$sessionCached(g.id)}return g}throw new Error("cannot find session")}tb(P){if(P){const g=k.URI.revive(P);return this.Y.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}ub(P,g){return`${P}\0${g}`}vb(P,g){if(g){if("title"in g&&"command"in g)return{type:n.DebugVisualizationType.Command};if("treeId"in g)return{type:n.DebugVisualizationType.Tree,id:`${P}\0${g.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(P){const g=this.xb(P);let w,M;return"id"in g?M=i.ThemeIcon.asClassName(g):w=g,{iconPath:w,iconClass:M}}xb(P){if(P instanceof u.$tO)return{id:P.id};const g=typeof P=="object"&&"dark"in P?P.dark:P,w=typeof P=="object"&&"light"in P?P.light:P;return{dark:typeof g=="string"?k.URI.file(g):g,light:typeof w=="string"?k.URI.file(w):w}}};e.$upc=m,e.$upc=m=Qe([Ve(0,y.$1P),Ve(1,E.$Foc),Ve(2,R.$jpc),Ve(3,o.$Ioc),Ve(4,a.$Uoc),Ve(5,h.$mpc),Ve(6,r.$kQ),Ve(7,l.$opc)],m);class d{constructor(P,g,w,M,N,L,G){this.f=P,this.g=g,this.h=w,this.j=M,this.k=N,this.l=L,this.m=G}get api(){const P=this;return this.d??=Object.freeze({id:P.g,type:P.h,get name(){return P.j},set name(g){P.j=g,P.f.$setDebugSessionName(P.g,g)},parentSession:P.m,workspaceFolder:P.k,configuration:P.l,customRequest(g,w){return P.f.$customDebugAdapterRequest(P.g,g,w)},getDebugProtocolBreakpoint(g){return P.f.$getDebugProtocolBreakpoint(P.g,g.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(P){this.j=P}get configuration(){return this.l}}e.$vpc=d;class ${constructor(P){this.value=Object.freeze({append(g){P.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.$wpc=$;class I{constructor(P){this.d=P}onWillStartSession(){this.d.forEach(P=>P.onWillStartSession?P.onWillStartSession():void 0)}onWillReceiveMessage(P){this.d.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(P):void 0)}onDidSendMessage(P){this.d.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(P):void 0)}onWillStopSession(){this.d.forEach(P=>P.onWillStopSession?P.onWillStopSession():void 0)}onError(P){this.d.forEach(g=>g.onError?g.onError(P):void 0)}onExit(P,g){this.d.forEach(w=>w.onExit?w.onExit(P,g):void 0)}}class D extends f.$Itb{constructor(P){super(),this.h=P,P.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(P){this.h.handleMessage(P)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends m{constructor(P,g,w,M,N,L,G,B){super(P,g,w,M,N,L,G,B)}};e.$xpc=v,e.$xpc=v=Qe([Ve(0,y.$1P),Ve(1,E.$Foc),Ve(2,R.$jpc),Ve(3,o.$Ioc),Ve(4,a.$Uoc),Ve(5,h.$mpc),Ve(6,r.$kQ),Ve(7,l.$opc)],v)}),define(Ce[316],Ie([1,0,14,65,2,5,266,12,61,75,27,211,17,66,46,67]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=e.$xqc=void 0,b=qe(b),S=qe(S);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$_j),c=i.get(u.$1P).getProxy(O.$uN.MainThreadErrors);b.setUnexpectedErrorHandler(l=>{r.error(l);const m=b.$5(l);c.$onUnexpectedError(m)})}static async installFullHandler(i){const r=i.get(T.$_j),t=i.get(u.$1P),c=i.get(f.$jpc),l=i.get(n.$iQ),m=t.getProxy(O.$uN.MainThreadExtensionService),d=t.getProxy(O.$uN.MainThreadErrors),$=await c.getExtensionPathIndex(),I=new WeakMap;function D(P,g){if(I.has(P))return I.get(P).stack;let w="",M,N;for(const G of g)w+=`
	at ${G.toString()}`,N=G.getFileName(),!M&&N&&(M=$.findSubstr(k.URI.file(N)));const L=`${P.name||"Error"}: ${P.message||""}${w}`;return I.set(P,{extensionIdentifier:M?.identifier,stack:L}),L}const v=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(P){if(P===D||!P||P[v]){C=P||D;return}C=function(g,w){return D(g,w),P.call(Error,g,w)},Object.assign(C,{[v]:!0})}}),b.setUnexpectedErrorHandler(P=>{r.error(P);const g=b.$5(P),w=I.get(P);if(!w?.extensionIdentifier){d.$onUnexpectedError(g);return}m.$onExtensionRuntimeError(w.extensionIdentifier,g);const M=l.onExtensionError(w.extensionIdentifier,P);r.trace("forwarded error to extension?",M,w)})}}e.$xqc=s;class o{constructor(i,r,t,c,l){this.a=t,this.b=new A.$Scc(i,null,c),r=o.e(r,this.b);const m=new a.$Di(...(0,p.$Ps)());m.set(R.$eQ,{_serviceBrand:void 0,...r,messagePorts:l}),m.set(u.$1P,new u.$2P(this.b)),m.set(E.$Coc,new E.$Doc(c)),m.set(f.$hpc,t);const d=new y.$tr(m,!0);d.invokeFunction(s.installEarlyHandler),this.d=d.invokeFunction($=>$.get(T.$_j)),S.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=d.invokeFunction($=>$.get(f.$jpc)),this.c.initialize(),d.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(O.$uN.MainThreadExtensionService);return k.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(c=>{c.extensionLocation=k.URI.revive(r.transformIncomingURIs(c.extensionLocation))}),i.environment.appRoot=k.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(c=>k.URI.revive(r.transformIncomingURIs(c)))),i.environment.extensionTestsLocationURI=k.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=k.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=k.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=k.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=k.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=k.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$yqc=o}),define(Ce[317],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Mpc=e.$Lpc=void 0,e.$Npc=n,T=qe(T),p=qe(p);class y{constructor(h,i,r){this.d=h,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,i){const r=this.g.folderQueries||[],t=new k.$xe(i);return new Promise((c,l)=>{this.a=new E(h);let m=!1;const d=($,I)=>{if(!m&&!this.b){const D=this.h($);n($)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,m=!0,t.cancel(),$=this.j($,this.g.maxResults-this.c));const v=this.h($);this.c+=v,(v>0||!n($))&&this.a.add($,I)}};Promise.all(r.map(($,I)=>this.k($,D=>d(D,I),t.token))).then($=>{t.dispose(),this.a.flush();const I=$.some(D=>!!D&&!!D.limitHit);c({limitHit:this.b||I,messages:$.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},$=>{t.dispose();const I=(0,O.$qj)($);l(new Error(I))})})}h(h){return n(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,i){const r=Array.isArray(h.ranges)?h.ranges:[h.ranges],t=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:h.preview.text},uri:h.uri}}async k(h,i,r){const t=new R.$$L(this.g,h),c=[],l={report:$=>{if(!this.l($))return;const I=h.folder.scheme===A.Schemas.file?(0,R.$_L)(()=>this.e.readdir(p.$fh($.uri))):void 0,D=p.$ih(h.folder,$.uri);if(D){const v=t.includedInQuery(D,T.$pc(D),I);(0,S.$rh)(v)?c.push(v.then(C=>{C&&i($)})):v&&i($)}}},m=this.n(h);let d;return this.d.query.type===R.QueryType.aiText?d=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,m,l,r):d=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),m,l,r),c.length&&await Promise.all(c),d}l(h){if(n(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const i=(0,R.$0L)(this.g.includePattern,h.includePattern),r=(0,R.$0L)(this.g.excludePattern,h.excludePattern),t={folder:a.URI.from(h.folder),excludes:r,includes:i,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$QL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Lpc=y;function u(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(h,i){this.d&&(this.b!==i||!p.$_g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:h.uri,results:[]}),this.d.results.push(f(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$Mpc=E;function f(o){return n(o)?{preview:{matches:(0,b.$3b)(o.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:o.preview.text},ranges:(0,b.$3b)(o.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function n(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(h,i){this.g=h,this.h=i,this.c=0,this.d=[],this.e=0}addItem(h,i){h&&this.j(h,i)}addItems(h,i){h&&this.k(h,i)}j(h,i){this.d.push(h),this.e+=i,this.l()}k(h,i){this.d=this.d.concat(h),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Opc=s}),define(Ce[134],Ie([1,0,4,5,3,312,17,66,12,2,317]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=e.$Ppc=void 0,e.$Rpc=u,e.$Ppc=(0,k.$Fi)("IExtHostSearch");let y=class{constructor(n,s,o){this.n=n,this.o=s,this.q=o,this.c=this.n.getProxy(S.$uN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Kpc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,s){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(n)),(0,b.$Uc)(()=>{this.g.delete(n),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(n,s){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(n)),(0,b.$Uc)(()=>{this.i.delete(n),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(n,s){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(n)),(0,b.$Uc)(()=>{this.k.delete(n),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(n,s,o,h){const i=u(o),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,s,t.map(c=>c.resource))},h);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,s,o){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,s,o,h){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=u(o);return this.t(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$provideAITextSearchResults(n,s,o,h){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=u(o);return this.v(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$enableExtensionHostSearch(){}t(n,s){return new R.$Lpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(n,s){return new R.$Lpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Qpc=y,e.$Qpc=y=Qe([Ve(0,A.$1P),Ve(1,T.$Coc),Ve(2,p.$_j)],y);function u(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(E),extraFileResources:f.extraFileResources&&f.extraFileResources.map(n=>a.URI.revive(n))}}function E(f){return{...f,folder:a.URI.revive(f.folder)}}});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[318],Ie([1,0,22,14,6,4,16,36,2,106,165,151,52,19,30,12,63,64,226,5,269,298,85,91,274,275,276,253,243,34,277,45,278,133,122,279,255,270,280,281,58,71,256,271,46,283,69,284,51,27,299,257,285,95,287,86,87,259,311,289,231,290,300,291,128,260,292,293,294,17,295,134,88,296,261,297,89,92,131,67,57,126,96,301,272,302,303,93,8,7,262,66,263,68,304,305,121,44,81,84,25,130,286]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l,m,d,$,I,D,v,C,P,g,w,M,N,L,G,B,F,V,ae,$e,_,ge,se,ce,we,re,Pe,Me,Y,q,ee,ve,ue,be,de,X,Z,me,pe,Oe,ze,ke,Ae,Ne,j,U,K,H,ie,fe,Re,Ue,Ke,_e,tt,nt,et,rt,ft,ct,st,ut,gt,pt,Be,je,Q,x,De,Je,xe,ht,$t,Ft,zt,Yt,fi,Ze,Pt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=Qt,S=qe(S),T=ti(T),y=qe(y),f=qe(f),je=qe(je),Q=qe(Q);function Qt(mt){const vt=mt.get(Pe.$eQ),ii=mt.get(re.$noc),Zt=mt.get(ce.$Koc),qt=mt.get(ge.$jpc),yt=mt.get(zt.$Foc),Nt=mt.get(et.$iQ),li=mt.get(P.$Ioc),Vt=mt.get(De.$Coc),Xe=mt.get(K.$1P),xt=mt.get(_e.$4oc),ni=mt.get(tt.$Loc),hi=mt.get(n.$ak),kt=mt.get(n.$_j),Lt=mt.get(Be.$XFb),At=mt.get(c.$joc),Ut=mt.get(Ft.$qqc),ri=mt.get(fe.$bpc),_t=mt.get(ae.$Uoc),si=mt.get(be.$fpc),jt=mt.get(l.$toc),Ht=mt.get(ee.$$oc);Xe.set(i.$vN.ExtHostFileSystemInfo,ii),Xe.set(i.$vN.ExtHostLogLevelServiceShape,hi),Xe.set(i.$vN.ExtHostWorkspace,yt),Xe.set(i.$vN.ExtHostConfiguration,li),Xe.set(i.$vN.ExtHostExtensionService,qt),Xe.set(i.$vN.ExtHostStorage,xt),Xe.set(i.$vN.ExtHostTunnelService,Lt),Xe.set(i.$vN.ExtHostWindow,Ut),Xe.set(i.$vN.ExtHostSecretState,ri),Xe.set(i.$vN.ExtHostTelemetry,Nt),Xe.set(i.$vN.ExtHostEditorTabs,_t),Xe.set(i.$vN.ExtHostManagedSockets,si),Xe.set(i.$vN.ExtHostAuthentication,jt),Xe.set(i.$vN.ExtHostChatProvider,Ht);const oi=Xe.set(i.$vN.ExtHostDecorations,mt.get(M.$zpc)),Rt=Xe.set(i.$vN.ExtHostDocumentsAndEditors,mt.get(V.$_P)),St=Xe.set(i.$vN.ExtHostCommands,mt.get(v.$kQ)),bt=Xe.set(i.$vN.ExtHostTerminalService,mt.get(rt.$7oc)),ei=Xe.set(i.$vN.ExtHostTerminalShellIntegration,mt.get(ft.$gqc)),Ct=Xe.set(i.$vN.ExtHostDebugService,mt.get(w.$tpc)),di=Xe.set(i.$vN.ExtHostSearch,mt.get(ie.$Ppc)),Gt=Xe.set(i.$vN.ExtHostTask,mt.get(nt.$fqc)),bi=Xe.set(i.$vN.ExtHostOutputService,mt.get(ke.$5pc)),vi=Xe.set(i.$vN.ExtHostLocalization,mt.get(ue.$epc)),gi=Xe.set(i.$vN.ExtHostUrls,new Je.$nqc(Xe)),Bt=Xe.set(i.$vN.ExtHostDocuments,new F.$qoc(Xe,Rt)),ai=Xe.set(i.$vN.ExtHostDocumentContentProviders,new G.$Bpc(Xe,Rt,kt)),Ii=Xe.set(i.$vN.ExtHostDocumentSaveParticipant,new B.$Cpc(kt,Bt,Xe.getProxy(i.$uN.MainThreadBulkEdits))),Tt=Xe.set(i.$vN.ExtHostNotebook,new X.$Spc(Xe,St,Rt,Bt,Zt,di,kt)),Di=Xe.set(i.$vN.ExtHostNotebookDocuments,new me.$Ypc(Tt)),Pi=Xe.set(i.$vN.ExtHostNotebookEditors,new pe.$Zpc(kt,Tt)),Si=Xe.set(i.$vN.ExtHostNotebookKernels,new Oe.$1pc(Xe,vt,Tt,St,kt)),pi=Xe.set(i.$vN.ExtHostNotebookRenderers,new ze.$3pc(Xe,Tt)),Ri=Xe.set(i.$vN.ExtHostNotebookDocumentSaveParticipant,new Z.$Xpc(kt,Tt,Xe.getProxy(i.$uN.MainThreadBulkEdits))),Wt=Xe.set(i.$vN.ExtHostEditors,new st.$zoc(Xe,Rt)),ye=Xe.set(i.$vN.ExtHostTreeViews,new pt.$lqc(Xe.getProxy(i.$uN.MainThreadTreeViews),St,kt)),Te=Xe.set(i.$vN.ExtHostEditorInsets,new D.$Aoc(Xe.getProxy(i.$uN.MainThreadEditorInsets),Wt,vt.remote)),le=Xe.set(i.$vN.ExtHostDiagnostics,new N.$poc(Xe,kt,ii,Rt)),J=Xe.set(i.$vN.ExtHostLanguages,new ve.$Vpc(Xe,Bt,St.converter,Vt)),Ee=Xe.set(i.$vN.ExtHostLanguageFeatures,new q.$roc(Xe,Vt,Bt,St,le,kt,At,Nt)),We=Xe.set(i.$vN.ExtHostFileSystem,new se.$Fpc(Xe,Ee)),Ye=Xe.set(i.$vN.ExtHostFileSystemEventService,new we.$Gpc(Xe,kt,Rt)),Ge=Xe.set(i.$vN.ExtHostQuickOpen,(0,U.$9pc)(Xe,yt,St)),lt=Xe.set(i.$vN.ExtHostSCM,new H.$$pc(Xe,St,Bt,kt)),It=Xe.set(i.$vN.ExtHostQuickDiff,new j.$8pc(Xe,Vt)),Jt=Xe.set(i.$vN.ExtHostShare,new Re.$_pc(Xe,Vt)),ci=Xe.set(i.$vN.ExtHostComments,(0,C.$Boc)(Xe,St,Bt)),Mt=Xe.set(i.$vN.ExtHostProgress,new Ne.$7pc(Xe.getProxy(i.$uN.MainThreadProgress))),ui=Xe.set(i.$vN.ExtHostLabelService,new Y.$Upc(Xe)),qi=Xe.set(i.$vN.ExtHostTheming,new ut.$iqc(Xe)),$n=Xe.set(i.$vN.ExtHostTimeline,new gt.$kqc(Xe,St)),Li=Xe.set(i.$vN.ExtHostWebviews,new xe.$Poc(Xe,vt.remote,yt,kt,At)),Oi=Xe.set(i.$vN.ExtHostWebviewPanels,new ht.$Soc(Xe,Li,yt)),Vi=Xe.set(i.$vN.ExtHostCustomEditors,new g.$Toc(Xe,Bt,ni,Li,Oi)),xi=Xe.set(i.$vN.ExtHostWebviewViews,new $t.$oqc(Xe,Li)),ki=Xe.set(i.$vN.ExtHostTesting,mt.get(ct.$opc)),_i=Xe.set(i.$vN.ExtHostUriOpeners,new x.$mqc(Xe)),en=Xe.set(i.$vN.ExtHostProfileContentHandlers,new Ae.$6pc(Xe));Xe.set(i.$vN.ExtHostInteractive,new Me.$Tpc(Xe,Tt,Rt,St,kt));const Mi=Xe.set(i.$vN.ExtHostChatAgents2,new d.$woc(Xe,kt,St,vt.quality)),tn=Xe.set(i.$vN.ExtHostChatVariables,new $.$xoc(Xe)),Gi=Xe.set(i.$vN.ExtHostLanguageModelTools,new Kt.$rqc(Xe)),nn=Xe.set(i.$vN.ExtHostAiRelatedInformation,new r.$ioc(Xe)),Ki=Xe.set(i.$vN.ExtHostAiEmbeddingVector,new _.$Epc(Xe)),zi=Xe.set(i.$vN.ExtHostStatusBar,new Ke.$cqc(Xe,St.converter)),wn=Xe.set(i.$vN.ExtHostSpeech,new Ue.$aqc(Xe)),Ni=Xe.set(i.$vN.ExtHostEmbeddings,new $e.$Dpc(Xe)),rn=Object.values(i.$vN);Xe.assertRegistered(rn);const bn=new m.$voc(Xe,Rt),Qi=new I.$yoc(Xe),Ui=new de.$Wpc(Xe,kt),Hi=new L.$Apc(Xe);return t.$soc.register(St),function(Le,yi,ji){function ot(te){return(he,Fe,at)=>{const Dt=te(Ot=>{try{he.call(Fe,Ot)}catch(Ai){S.$4(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Nt.onExtensionError(Le.identifier,Ai)}});return at?.push(Dt),Dt}}const wt=function(){let te=!Le.isUnderDevelopment;function he(){te||(kt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(at){if(Array.isArray(at))at.forEach(Fe);else if(typeof at=="string")he();else{const Dt=at;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,Ze.$7G)(Le,"documentFiltersExclusive")}return at}}(),Bi={getSession(te,he,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ze.$7G)(Le,"authLearnMore"),Fe?.account&&(0,Ze.$7G)(Le,"authGetSessions"),jt.getSession(Le,te,he,Fe)},getSessions(te,he){return(0,Ze.$7G)(Le,"authGetSessions"),jt.getSessions(Le,te,he)},getAccounts(te){return(0,Ze.$7G)(Le,"authGetSessions"),jt.getAccounts(te)},async hasSession(te,he){return(0,Ze.$7G)(Le,"authSession"),!!await jt.getSession(Le,te,he,{silent:!0})},get onDidChangeSessions(){return ot(jt.onDidChangeSessions)},registerAuthenticationProvider(te,he,Fe,at){return jt.registerAuthenticationProvider(te,he,Fe,at)}},vn={registerCommand(te,he,Fe){return St.registerCommand(!0,te,he,Fe,void 0,Le)},registerTextEditorCommand(te,he,Fe){return St.registerCommand(!0,te,(...at)=>{const Dt=Wt.getActiveTextEditor();if(!Dt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}return Dt.edit(Ot=>{he.apply(Fe,[Dt,Ot,...at])}).then(Ot=>{Ot||kt.warn("Edits from command "+te+" were not applied.")},Ot=>{kt.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,he,Fe)=>((0,Ze.$7G)(Le,"diffCommand"),St.registerCommand(!0,te,async(...at)=>{const Dt=Rt.activeEditor(!0);if(!Dt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await Wt.getDiffInformation(Dt.id);he.apply(Fe,[Ot,...at])},void 0,void 0,Le)),executeCommand(te,...he){return St.executeCommand(te,...he)},getCommands(te=!1){return St.getCommands(te)}},mi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Qi.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$7G)(Le,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$7G)(Le,"telemetry"),ot(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,et.$hQ)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,he){return et.$gQ.validateSender(te),Nt.instantiateLogger(Le,te,he)},openExternal(te,he){return Ut.openUri(te,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===vt.environment.appUriScheme)return gi.createAppUri(te);try{return await Ut.asExternalUri(te,{allowTunneling:!!vt.remote.authority})}catch(he){if((0,A.$Og)(te,A.Schemas.http)||(0,A.$Og)(te,A.Schemas.https))return te;throw he}},get remoteName(){return(0,s.$hn)(vt.remote.authority)},get remoteAuthority(){return(0,Ze.$7G)(Le,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ot(kt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$7G)(Le,"resolvers"),vt.quality},get appCommit(){return(0,Ze.$7G)(Le,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(mi);const Wi={createTestController(te,he,Fe){return ki.createTestController(Le,te,he,Fe)},createTestObserver(){return(0,Ze.$7G)(Le,"testObserver"),ki.createTestObserver()},runTests(te){return(0,Ze.$7G)(Le,"testObserver"),ki.runTests(te)},registerTestFollowupProvider(te){return(0,Ze.$7G)(Le,"testObserver"),ki.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Ze.$7G)(Le,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,Ze.$7G)(Le,"testObserver"),ki.results}},Fi=vt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,sn={getExtension(te,he){(0,Ze.$6G)(Le,"extensionsAny")||(he=!1);const Fe=yi.mine.getExtensionDescription(te);if(Fe)return new ge.$kpc(qt,Le.identifier,Fe,Fi,!1);if(he){const at=yi.all.getExtensionDescription(te);if(at)return new ge.$kpc(qt,Le.identifier,at,Fi,!0)}},get all(){const te=[];for(const he of yi.mine.getAllExtensionDescriptions())te.push(new ge.$kpc(qt,Le.identifier,he,Fi,!1));return te},get allAcrossExtensionHosts(){(0,Ze.$7G)(Le,"extensionsAny");const te=new E.$rn(yi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),he=[];for(const Fe of yi.all.getAllExtensionDescriptions()){const at=!te.has(Fe.identifier);he.push(new ge.$kpc(qt,Le.identifier,Fe,Fi,at))}return he},get onDidChange(){return(0,Ze.$6G)(Le,"extensionsAny")?ot(k.Event.any(yi.mine.onDidChange,yi.all.onDidChange)):ot(yi.mine.onDidChange)}},on={createDiagnosticCollection(te){return le.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return ot(le.onDidChangeDiagnostics)},getDiagnostics:te=>le.getDiagnostics(te),getLanguages(){return J.getLanguages()},setTextDocumentLanguage(te,he){return J.changeLanguage(te.uri,he)},match(te,he){const Fe=je.LanguageSelector.from(te);let at;return(0,R.$tu)(Fe)&&(at=Tt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ot=>Ot.document===he))?.apiNotebook),(0,R.$su)(Fe,he.uri,he.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(te,he,Fe){return Ee.registerCodeActionProvider(Le,wt(te),he,Fe)},registerDocumentPasteEditProvider(te,he,Fe){return(0,Ze.$7G)(Le,"documentPaste"),Ee.registerDocumentPasteEditProvider(Le,wt(te),he,Fe)},registerCodeLensProvider(te,he){return Ee.registerCodeLensProvider(Le,wt(te),he)},registerDefinitionProvider(te,he){return Ee.registerDefinitionProvider(Le,wt(te),he)},registerDeclarationProvider(te,he){return Ee.registerDeclarationProvider(Le,wt(te),he)},registerImplementationProvider(te,he){return Ee.registerImplementationProvider(Le,wt(te),he)},registerTypeDefinitionProvider(te,he){return Ee.registerTypeDefinitionProvider(Le,wt(te),he)},registerHoverProvider(te,he){return Ee.registerHoverProvider(Le,wt(te),he,Le.identifier)},registerEvaluatableExpressionProvider(te,he){return Ee.registerEvaluatableExpressionProvider(Le,wt(te),he,Le.identifier)},registerInlineValuesProvider(te,he){return Ee.registerInlineValuesProvider(Le,wt(te),he,Le.identifier)},registerDocumentHighlightProvider(te,he){return Ee.registerDocumentHighlightProvider(Le,wt(te),he)},registerMultiDocumentHighlightProvider(te,he){return Ee.registerMultiDocumentHighlightProvider(Le,wt(te),he)},registerLinkedEditingRangeProvider(te,he){return Ee.registerLinkedEditingRangeProvider(Le,wt(te),he)},registerReferenceProvider(te,he){return Ee.registerReferenceProvider(Le,wt(te),he)},registerRenameProvider(te,he){return Ee.registerRenameProvider(Le,wt(te),he)},registerNewSymbolNamesProvider(te,he){return(0,Ze.$7G)(Le,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Le,wt(te),he)},registerDocumentSymbolProvider(te,he,Fe){return Ee.registerDocumentSymbolProvider(Le,wt(te),he,Fe)},registerWorkspaceSymbolProvider(te){return Ee.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,he){return Ee.registerDocumentFormattingEditProvider(Le,wt(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return Ee.registerDocumentRangeFormattingEditProvider(Le,wt(te),he)},registerOnTypeFormattingEditProvider(te,he,Fe,...at){return Ee.registerOnTypeFormattingEditProvider(Le,wt(te),he,[Fe].concat(at))},registerDocumentSemanticTokensProvider(te,he,Fe){return Ee.registerDocumentSemanticTokensProvider(Le,wt(te),he,Fe)},registerDocumentRangeSemanticTokensProvider(te,he,Fe){return Ee.registerDocumentRangeSemanticTokensProvider(Le,wt(te),he,Fe)},registerSignatureHelpProvider(te,he,Fe,...at){return typeof Fe=="object"?Ee.registerSignatureHelpProvider(Le,wt(te),he,Fe):Ee.registerSignatureHelpProvider(Le,wt(te),he,typeof Fe>"u"?[]:[Fe,...at])},registerCompletionItemProvider(te,he,...Fe){return Ee.registerCompletionItemProvider(Le,wt(te),he,Fe)},registerInlineCompletionItemProvider(te,he,Fe){return he.handleDidShowCompletionItem&&(0,Ze.$7G)(Le,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$7G)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ze.$7G)(Le,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Le,wt(te),he,Fe)},registerInlineEditProvider(te,he){return(0,Ze.$7G)(Le,"inlineEdit"),Ee.registerInlineEditProvider(Le,wt(te),he)},registerDocumentLinkProvider(te,he){return Ee.registerDocumentLinkProvider(Le,wt(te),he)},registerColorProvider(te,he){return Ee.registerColorProvider(Le,wt(te),he)},registerFoldingRangeProvider(te,he){return Ee.registerFoldingRangeProvider(Le,wt(te),he)},registerSelectionRangeProvider(te,he){return Ee.registerSelectionRangeProvider(Le,te,he)},registerCallHierarchyProvider(te,he){return Ee.registerCallHierarchyProvider(Le,te,he)},registerTypeHierarchyProvider(te,he){return Ee.registerTypeHierarchyProvider(Le,te,he)},setLanguageConfiguration:(te,he)=>Ee.setLanguageConfiguration(Le,te,he),getTokenInformationAtPosition(te,he){return(0,Ze.$7G)(Le,"tokenInformation"),J.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return Ee.registerInlayHintsProvider(Le,te,he)},createLanguageStatusItem(te,he){return J.createLanguageStatusItem(Le,te,he)},registerDocumentDropEditProvider(te,he,Fe){return Ee.registerDocumentOnDropEditProvider(Le,te,he,(0,Ze.$6G)(Le,"documentPaste")?Fe:void 0)}},an={get activeTextEditor(){return Wt.getActiveTextEditor()},get visibleTextEditors(){return Wt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(te,he,Fe){p.URI.isUri(te)&&te.scheme===A.Schemas.vscodeRemote&&!te.authority&&At.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(te)?Promise.resolve(cn.openTextDocument(te)):Promise.resolve(te));return Wt.showTextDocument(at,he,Fe)},createTextEditorDecorationType(te){return Wt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,he,Fe){return ot(Wt.onDidChangeActiveTextEditor)(te,he,Fe)},onDidChangeVisibleTextEditors(te,he,Fe){return ot(Wt.onDidChangeVisibleTextEditors)(te,he,Fe)},onDidChangeTextEditorSelection(te,he,Fe){return ot(Wt.onDidChangeTextEditorSelection)(te,he,Fe)},onDidChangeTextEditorOptions(te,he,Fe){return ot(Wt.onDidChangeTextEditorOptions)(te,he,Fe)},onDidChangeTextEditorVisibleRanges(te,he,Fe){return ot(Wt.onDidChangeTextEditorVisibleRanges)(te,he,Fe)},onDidChangeTextEditorViewColumn(te,he,Fe){return ot(Wt.onDidChangeTextEditorViewColumn)(te,he,Fe)},onDidCloseTerminal(te,he,Fe){return ot(bt.onDidCloseTerminal)(te,he,Fe)},onDidOpenTerminal(te,he,Fe){return ot(bt.onDidOpenTerminal)(te,he,Fe)},onDidChangeActiveTerminal(te,he,Fe){return ot(bt.onDidChangeActiveTerminal)(te,he,Fe)},onDidChangeTerminalDimensions(te,he,Fe){return(0,Ze.$7G)(Le,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(te,he,Fe)},onDidChangeTerminalState(te,he,Fe){return ot(bt.onDidChangeTerminalState)(te,he,Fe)},onDidWriteTerminalData(te,he,Fe){return(0,Ze.$7G)(Le,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(te,he,Fe)},onDidExecuteTerminalCommand(te,he,Fe){return(0,Ze.$7G)(Le,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(te,he,Fe)},onDidChangeTerminalShellIntegration(te,he,Fe){return(0,Ze.$7G)(Le,"terminalShellIntegration"),ot(ei.onDidChangeTerminalShellIntegration)(te,he,Fe)},onDidStartTerminalShellExecution(te,he,Fe){return(0,Ze.$7G)(Le,"terminalShellIntegration"),ot(ei.onDidStartTerminalShellExecution)(te,he,Fe)},onDidEndTerminalShellExecution(te,he,Fe){return(0,Ze.$7G)(Le,"terminalShellIntegration"),ot(ei.onDidEndTerminalShellExecution)(te,he,Fe)},get state(){return Ut.getState()},onDidChangeWindowState(te,he,Fe){return ot(Ut.onDidChangeWindowState)(te,he,Fe)},showInformationMessage(te,...he){return Ui.showMessage(Le,T.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return Ui.showMessage(Le,T.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return Ui.showMessage(Le,T.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Fe){return Ge.showQuickPick(Le,te,he,Fe)},showWorkspaceFolderPick(te){return Ge.showWorkspaceFolderPick(te)},showInputBox(te,he){return Ge.showInput(te,he)},showOpenDialog(te){return Hi.showOpenDialog(Le,te)},showSaveDialog(te){return Hi.showSaveDialog(te)},createStatusBarItem(te,he,Fe){let at,Dt,Ot;return typeof te=="string"?(at=te,Dt=he,Ot=Fe):(Dt=te,Ot=he),zi.createStatusBarEntry(Le,at,Dt,Ot)},setStatusBarMessage(te,he){return zi.setStatusBarMessage(te,he)},withScmProgress(te){return At.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Mt.withProgress(Le,{location:Q.ProgressLocation.SourceControl},(he,Fe)=>te({report(at){}}))},withProgress(te,he){return Mt.withProgress(Le,te,he)},createOutputChannel(te,he){return bi.createOutputChannel(te,he,Le)},createWebviewPanel(te,he,Fe,at){return Oi.createWebviewPanel(Le,te,he,Fe,at)},createWebviewTextEditorInset(te,he,Fe,at){return(0,Ze.$7G)(Le,"editorInsets"),Te.createWebviewEditorInset(te,he,Fe,at,Le)},createTerminal(te,he,Fe){return typeof te=="object"?"pty"in te?bt.createExtensionTerminal(te):bt.createTerminalFromOptions(te):bt.createTerminal(te,he,Fe)},registerTerminalLinkProvider(te){return bt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return bt.registerProfileProvider(Le,te,he)},registerTerminalQuickFixProvider(te,he){return(0,Ze.$7G)(Le,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(te,Le.identifier.value,he)},registerTreeDataProvider(te,he){return ye.registerTreeDataProvider(te,he,Le)},createTreeView(te,he){return ye.createTreeView(te,he,Le)},registerWebviewPanelSerializer:(te,he)=>Oi.registerWebviewPanelSerializer(Le,te,he),registerCustomEditorProvider:(te,he,Fe={})=>Vi.registerCustomEditorProvider(Le,te,he,Fe),registerFileDecorationProvider(te){return oi.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return gi.registerUriHandler(Le,te)},createQuickPick(){return Ge.createQuickPick(Le)},createInputBox(){return Ge.createInputBox(Le)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(te,he,Fe){return ot(qi.onDidChangeActiveColorTheme)(te,he,Fe)},registerWebviewViewProvider(te,he,Fe){return xi.registerWebviewViewProvider(Le,te,he,Fe?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Fe){return ot(Tt.onDidChangeActiveNotebookEditor)(te,he,Fe)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,he,Fe){return ot(Pi.onDidChangeNotebookEditorSelection)(te,he,Fe)},onDidChangeNotebookEditorVisibleRanges(te,he,Fe){return ot(Pi.onDidChangeNotebookEditorVisibleRanges)(te,he,Fe)},showNotebookDocument(te,he){return Tt.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Fe){return(0,Ze.$7G)(Le,"externalUriOpener"),_i.registerExternalUriOpener(Le.identifier,te,he,Fe)},registerProfileContentHandler(te,he){return(0,Ze.$7G)(Le,"profileContentHandlers"),en.registerProfileContentHandler(Le,te,he)},registerQuickDiffProvider(te,he,Fe,at){return(0,Ze.$7G)(Le,"quickDiffProvider"),It.registerQuickDiffProvider(wt(te),he,Fe,at)},get tabGroups(){return _t.tabGroups},registerShareProvider(te,he){return(0,Ze.$7G)(Le,"shareProvider"),Jt.registerShareProvider(wt(te),he)}},cn={get rootPath(){return At.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),yt.getPath()},set rootPath(te){throw new S.$$("rootPath")},getWorkspaceFolder(te){return yt.getWorkspaceFolder(te)},get workspaceFolders(){return yt.getWorkspaceFolders()},get name(){return yt.name},set name(te){throw new S.$$("name")},get workspaceFile(){return yt.workspaceFile},set workspaceFile(te){throw new S.$$("workspaceFile")},updateWorkspaceFolders:(te,he,...Fe)=>yt.updateWorkspaceFolders(Le,te,he||0,...Fe),onDidChangeWorkspaceFolders:function(te,he,Fe){return ot(yt.onDidChangeWorkspace)(te,he,Fe)},asRelativePath:(te,he)=>yt.getRelativePath(te,he),findFiles:(te,he,Fe,at)=>yt.findFiles(te,he,Fe,Le.identifier,at),findFiles2:(te,he,Fe)=>((0,Ze.$7G)(Le,"findFiles2"),yt.findFiles2(te,he,Le.identifier,Fe)),findTextInFiles:(te,he,Fe,at)=>{(0,Ze.$7G)(Le,"findTextInFiles");let Dt,Ot;return typeof he=="object"?(Dt=he,Ot=Fe):(Dt={},Ot=he,at=Fe),yt.findTextInFiles(te,Dt||{},Ot,Le.identifier,at)},save:te=>yt.save(te),saveAs:te=>yt.saveAs(te),saveAll:te=>yt.saveAll(te),applyEdit(te,he){return bn.applyWorkspaceEdit(te,Le,he)},createFileSystemWatcher:(te,he,Fe,at)=>{let Dt;return typeof he=="boolean"?Dt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!at,correlate:!1}:he&&((0,Ze.$7G)(Le,"createFileSystemWatcher"),Dt={...he,correlate:!0}),Ye.createFileSystemWatcher(yt,Le,te,Dt)},get textDocuments(){return Bt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new S.$$("textDocuments")},openTextDocument(te){let he;const Fe=te;if(typeof te=="string")he=Promise.resolve(p.URI.file(te));else if(p.URI.isUri(te))he=Promise.resolve(te);else if(!Fe||typeof Fe=="object")he=Bt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Bt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(te,he,Fe)=>ot(Bt.onDidAddDocument)(te,he,Fe),onDidCloseTextDocument:(te,he,Fe)=>ot(Bt.onDidRemoveDocument)(te,he,Fe),onDidChangeTextDocument:(te,he,Fe)=>ot(Bt.onDidChangeDocument)(te,he,Fe),onDidSaveTextDocument:(te,he,Fe)=>ot(Bt.onDidSaveDocument)(te,he,Fe),onWillSaveTextDocument:(te,he,Fe)=>ot(Ii.getOnWillSaveTextDocumentEvent(Le))(te,he,Fe),get notebookDocuments(){return Tt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Fe;if(p.URI.isUri(te))Fe=te,await Tt.openNotebookDocument(te);else if(typeof te=="string")Fe=p.URI.revive(await Tt.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,he,Fe){return ot(Di.onDidSaveNotebookDocument)(te,he,Fe)},onDidChangeNotebookDocument(te,he,Fe){return ot(Di.onDidChangeNotebookDocument)(te,he,Fe)},onWillSaveNotebookDocument(te,he,Fe){return ot(Ri.getOnWillSaveNotebookDocumentEvent(Le))(te,he,Fe)},get onDidOpenNotebookDocument(){return ot(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,he,Fe,at){return Tt.registerNotebookSerializer(Le,te,he,Fe,(0,Ze.$6G)(Le,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(te,he,Fe)=>ot(ji.onDidChangeConfiguration)(te,he,Fe),getConfiguration(te,he){return he=arguments.length===1?void 0:he,ji.getConfiguration(te,he,Le)},registerTextDocumentContentProvider(te,he){return ai.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(At.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Le,te,he)),registerFileSystemProvider(te,he,Fe){return(0,O.$Tc)(We.registerFileSystemProvider(Le,te,he,Fe),Zt.addFileSystemProvider(te,he,Fe))},get fs(){return Zt.value},registerFileSearchProvider:(te,he)=>((0,Ze.$7G)(Le,"fileSearchProvider"),di.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,Ze.$7G)(Le,"textSearchProvider"),di.registerTextSearchProvider(te,he)),registerAITextSearchProvider:(te,he)=>((0,Ze.$7G)(Le,"aiTextSearchProvider"),(0,Ze.$7G)(Le,"textSearchProvider"),di.registerAITextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,Ze.$7G)(Le,"resolvers"),qt.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,Ze.$7G)(Le,"resolvers"),ui.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ze.$7G)(Le,"resolvers"),qt.getRemoteExecServer(te)),onDidCreateFiles:(te,he,Fe)=>ot(Ye.onDidCreateFile)(te,he,Fe),onDidDeleteFiles:(te,he,Fe)=>ot(Ye.onDidDeleteFile)(te,he,Fe),onDidRenameFiles:(te,he,Fe)=>ot(Ye.onDidRenameFile)(te,he,Fe),onWillCreateFiles:(te,he,Fe)=>ot(Ye.getOnWillCreateFileEvent(Le))(te,he,Fe),onWillDeleteFiles:(te,he,Fe)=>ot(Ye.getOnWillDeleteFileEvent(Le))(te,he,Fe),onWillRenameFiles:(te,he,Fe)=>ot(Ye.getOnWillRenameFileEvent(Le))(te,he,Fe),openTunnel:te=>((0,Ze.$7G)(Le,"tunnels"),Lt.openTunnel(Le,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ze.$7G)(Le,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(te,he,Fe)=>((0,Ze.$7G)(Le,"tunnels"),ot(Lt.onDidChangeTunnels)(te,he,Fe)),registerPortAttributesProvider:(te,he)=>((0,Ze.$7G)(Le,"portsAttributes"),Lt.registerPortsAttributesProvider(te,he)),registerTunnelProvider:(te,he)=>((0,Ze.$7G)(Le,"tunnelFactory"),Lt.registerTunnelProvider(te,he)),registerTimelineProvider:(te,he)=>((0,Ze.$7G)(Le,"timeline"),$n.registerTimelineProvider(te,he,Le.identifier,St.converter)),get isTrusted(){return yt.trusted},requestWorkspaceTrust:te=>((0,Ze.$7G)(Le,"workspaceTrust"),yt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Fe)=>ot(yt.onDidGrantWorkspaceTrust)(te,he,Fe),registerEditSessionIdentityProvider:(te,he)=>((0,Ze.$7G)(Le,"editSessionIdentityProvider"),yt.registerEditSessionIdentityProvider(te,he)),onWillCreateEditSessionIdentity:(te,he,Fe)=>((0,Ze.$7G)(Le,"editSessionIdentityProvider"),ot(yt.getOnWillCreateEditSessionIdentityEvent(Le))(te,he,Fe)),registerCanonicalUriProvider:(te,he)=>((0,Ze.$7G)(Le,"canonicalUriProvider"),yt.registerCanonicalUriProvider(te,he)),getCanonicalUri:(te,he,Fe)=>((0,Ze.$7G)(Le,"canonicalUriProvider"),yt.provideCanonicalUri(te,he,Fe))},un={get inputBox(){return At.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),lt.getLastInputBox(Le)},createSourceControl(te,he,Fe){return lt.createSourceControl(Le,te,he,Fe)}},ln={createCommentController(te,he){return ci.createCommentController(Le,te,he)}},yn={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){return Ct.activeStackItem},registerDebugVisualizationProvider(te,he){return(0,Ze.$7G)(Le,"debugVisualization"),Ct.registerDebugVisualizationProvider(Le,te,he)},registerDebugVisualizationTreeProvider(te,he){return(0,Ze.$7G)(Le,"debugVisualization"),Ct.registerDebugVisualizationTree(Le,te,he)},onDidStartDebugSession(te,he,Fe){return ot(Ct.onDidStartDebugSession)(te,he,Fe)},onDidTerminateDebugSession(te,he,Fe){return ot(Ct.onDidTerminateDebugSession)(te,he,Fe)},onDidChangeActiveDebugSession(te,he,Fe){return ot(Ct.onDidChangeActiveDebugSession)(te,he,Fe)},onDidReceiveDebugSessionCustomEvent(te,he,Fe){return ot(Ct.onDidReceiveDebugSessionCustomEvent)(te,he,Fe)},onDidChangeBreakpoints(te,he,Fe){return ot(Ct.onDidChangeBreakpoints)(te,he,Fe)},onDidChangeActiveStackItem(te,he,Fe){return ot(Ct.onDidChangeActiveStackItem)(te,he,Fe)},registerDebugConfigurationProvider(te,he,Fe){return Ct.registerDebugConfigurationProvider(te,he,Fe||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return Ct.registerDebugAdapterDescriptorFactory(Le,te,he)},registerDebugAdapterTrackerFactory(te,he){return Ct.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?Ct.startDebugging(te,he,{parentSession:Fe}):Ct.startDebugging(te,he,Fe||{})},stopDebugging(te){return Ct.stopDebugging(te)},addBreakpoints(te){return Ct.addBreakpoints(te)},removeBreakpoints(te){return Ct.removeBreakpoints(te)},asDebugSourceUri(te,he){return Ct.asDebugSourceUri(te,he)}},En={registerTaskProvider:(te,he)=>Gt.registerTaskProvider(Le,te,he),fetchTasks:te=>Gt.fetchTasks(te),executeTask:te=>Gt.executeTask(Le,te),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(te,he,Fe)=>ot(Gt.onDidStartTask)(te,he,Fe),onDidEndTask:(te,he,Fe)=>ot(Gt.onDidEndTask)(te,he,Fe),onDidStartTaskProcess:(te,he,Fe)=>ot(Gt.onDidStartTaskProcess)(te,he,Fe),onDidEndTaskProcess:(te,he,Fe)=>ot(Gt.onDidEndTaskProcess)(te,he,Fe)},hn={createNotebookController(te,he,Fe,at,Dt){return Si.createNotebookController(Le,te,he,Fe,at,(0,Ze.$6G)(Le,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>Tt.registerNotebookCellStatusBarItemProvider(Le,te,he),createRendererMessaging(te){return pi.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Ze.$7G)(Le,"notebookKernelSource"),Si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,he){return(0,Ze.$7G)(Le,"notebookKernelSource"),Si.registerKernelSourceActionProvider(Le,te,he)},onDidChangeNotebookCellExecutionState(te,he,Fe){return(0,Ze.$7G)(Le,"notebookCellExecutionState"),ot(Si.onDidChangeNotebookCellExecutionState)(te,he,Fe)}},Ji={t(...te){if(typeof te[0]=="string"){const he=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return vi.getMessage(Le.identifier.value,{message:he,args:Fe})}return vi.getMessage(Le.identifier.value,te[0])},get bundle(){return vi.getBundle(Le.identifier.value)},get uri(){return vi.getBundleUri(Le.identifier.value)}},dn={_version:1,transferActiveChat(te){return(0,Ze.$7G)(Le,"interactive"),Mi.transferActiveChat(te)}},fn={getRelatedInformation(te,he){return(0,Ze.$7G)(Le,"aiRelatedInformation"),nn.getRelatedInformation(Le,te,he)},registerRelatedInformationProvider(te,he){return(0,Ze.$7G)(Le,"aiRelatedInformation"),nn.registerRelatedInformationProvider(Le,te,he)},registerEmbeddingVectorProvider(te,he){return(0,Ze.$7G)(Le,"aiRelatedInformation"),Ki.registerEmbeddingVectorProvider(Le,te,he)}},gn={_version:1,registerChatResponseProvider(te,he,Fe){return(0,Ze.$7G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,te,he,Fe)},registerChatVariableResolver(te,he,Fe,at,Dt,Ot,Ai,Xi){return(0,Ze.$7G)(Le,"chatVariableResolver"),tn.registerVariableResolver(Le,te,he,Fe,at,Dt,Ot,Ai,Xi?.id)},registerMappedEditsProvider(te,he){return(0,Ze.$7G)(Le,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Le,te,he)},createChatParticipant(te,he){return Mi.createChatAgent(Le,te,he)},createDynamicChatParticipant(te,he,Fe){return(0,Ze.$7G)(Le,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Le,te,he,Fe)}},Dn={selectChatModels:te=>vt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Le.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),Promise.resolve([])):Ht.selectLanguageModels(Le,te??{}),onDidChangeChatModels:(te,he,Fe)=>vt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Le.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),k.Event.None(te,he,Fe)):Ht.onDidChangeProviders(te,he,Fe),registerChatModelProvider:(te,he,Fe)=>((0,Ze.$7G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,te,he,Fe)),get embeddingModels(){return(0,Ze.$7G)(Le,"embeddings"),Ni.embeddingsModels},onDidChangeEmbeddingModels:(te,he,Fe)=>((0,Ze.$7G)(Le,"embeddings"),Ni.onDidChange(te,he,Fe)),registerEmbeddingsProvider(te,he){return(0,Ze.$7G)(Le,"embeddings"),Ni.registerEmbeddingsProvider(Le,te,he)},async computeEmbeddings(te,he,Fe){return(0,Ze.$7G)(Le,"embeddings"),Ni.computeEmbeddings(te,he,Fe)},registerTool(te,he){return(0,Ze.$7G)(Le,"lmTools"),Gi.registerTool(Le,te,he)},invokeTool(te,he,Fe){return(0,Ze.$7G)(Le,"lmTools"),Gi.invokeTool(te,he,Fe)},get tools(){return(0,Ze.$7G)(Le,"lmTools"),Gi.tools}},Sn={registerSpeechProvider(te,he){return(0,Ze.$7G)(Le,"speech"),wn.registerProvider(Le.identifier,te,he)}};return{version:vt.version,ai:fn,authentication:Bi,commands:vn,comments:ln,chat:gn,debug:yn,env:mi,extensions:sn,interactive:dn,l10n:Ji,languages:on,lm:Dn,notebooks:hn,scm:un,speech:Sn,tasks:En,tests:Wi,window:an,workspace:cn,Breakpoint:Q.$xO,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$sP,CallHierarchyIncomingCall:Q.$VN,CallHierarchyItem:Q.$UN,CallHierarchyOutgoingCall:Q.$WN,CancellationError:S.$7,CancellationTokenSource:b.$xe,CandidatePortSource:i.CandidatePortSource,CodeAction:Q.$RN,CodeActionKind:Q.$SN,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$XN,Color:Q.$$N,ColorInformation:Q.$_N,ColorPresentation:Q.$aO,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CompletionItem:Q.$5N,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$6N,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$iO,DebugAdapterExecutable:Q.$BO,DebugAdapterInlineImplementation:Q.$EO,DebugAdapterNamedPipeServer:Q.$DO,DebugAdapterServer:Q.$CO,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$UO,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$KN,DiagnosticRelatedInformation:Q.$JN,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$wN,DocumentHighlight:Q.$NN,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$ON,DocumentLink:Q.$0N,DocumentSymbol:Q.$QN,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$HO,InlineValueText:Q.$IO,InlineValueVariableLookup:Q.$JO,InlineValueEvaluatableExpression:Q.$KO,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:k.$me,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$WO,FileDecoration2:Q.$WO,FileSystemError:Q.$NO,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:Q.$OO,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$zO,InlineCompletionItem:Q.$7N,InlineCompletionList:Q.$8N,Hover:Q.$LN,VerboseHover:Q.$MN,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:Q.$IN,MarkdownString:Q.$YN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Q.$ZN,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$xN,ProcessExecution:Q.$gO,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$VO,Range:Q.$yN,RelativePattern:Q.$vO,Selection:Q.$zN,SelectionRange:Q.$TN,SemanticTokens:Q.$RO,SemanticTokensBuilder:Q.$QO,SemanticTokensEdit:Q.$SO,SemanticTokensEdits:Q.$TO,SemanticTokensLegend:Q.$PO,ShellExecution:Q.$hO,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$2N,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$1N,SnippetString:Q.$HN,SourceBreakpoint:Q.$yO,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$PN,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$jO,TaskGroup:Q.$fO,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$bO,TerminalQuickFixTerminalCommand:Q.$dO,TerminalQuickFixOpener:Q.$cO,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$eO,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$DN,SnippetTextEdit:Q.$FN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$uO,ThemeIcon:Q.$tO,TreeItem:Q.$kO,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$gP,UIKind:fi.UIKind,Uri:p.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$GN,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$qO,DocumentDropOrPasteEditKind:Q.$rO,DocumentPasteEdit:Q.$sO,InlayHint:Q.$4N,InlayHintLabelPart:Q.$3N,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$CN,ResolvedAuthority:Q.$AN,ManagedResolvedAuthority:Q.$BN,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$7O,NotebookRange:Q.$YO,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$ZO,NotebookData:Q.$1O,NotebookRendererScript:Q.$5O,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$3O,NotebookCellOutputItem:Q.$2O,NotebookCellStatusBarItem:Q.$4O,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$EN,NotebookKernelSourceAction:Q.$6O,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$9O,LinkedEditingRanges:Q.$8O,TestResultState:Q.TestResultState,TestRunRequest:Q.$0O,TestMessage:Q.$$O,TestTag:Q.$_O,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:Pt.TextSearchCompleteMessageType,DataTransfer:Q.$pO,DataTransferItem:Q.$lO,TestCoverageCount:Q.$aP,FileCoverage:Q.$cP,FileCoverage2:Q.$cP,StatementCoverage:Q.$dP,BranchCoverage:Q.$eP,DeclarationCoverage:Q.$fP,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$hP,TabInputTextDiff:Q.$iP,TabInputTextMerge:Q.$jP,TabInputCustom:Q.$kP,TabInputNotebook:Q.$mP,TabInputNotebookDiff:Q.$nP,TabInputWebview:Q.$lP,TabInputTerminal:Q.$oP,TabInputInteractiveWindow:Q.$pP,TabInputChat:Q.$qP,TabInputTextMultiDiff:Q.$rP,TelemetryTrustedValue:o.$up,LogLevel:n.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$FO,DebugThread:Q.$GO,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$tP,ChatResponseFileTreePart:Q.$xP,ChatResponseAnchorPart:Q.$yP,ChatResponseProgressPart:Q.$zP,ChatResponseProgressPart2:Q.$AP,ChatResponseReferencePart:Q.$DP,ChatResponseWarningPart:Q.$BP,ChatResponseTextEditPart:Q.$EP,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$uP,ChatResponseCommandButtonPart:Q.$CP,ChatResponseDetectedParticipantPart:Q.$vP,ChatResponseConfirmationPart:Q.$wP,ChatRequestTurn:Q.$FP,ChatResponseTurn:Q.$GP,ChatLocation:Q.ChatLocation,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$IP,LanguageModelChatMessageFunctionResultPart:Q.$HP,LanguageModelChatResponseTextPart:Q.$KP,LanguageModelChatResponseFunctionUsePart:Q.$JP,LanguageModelChatMessage2:Q.$IP,LanguageModelChatSystemMessage:Q.$LP,LanguageModelChatUserMessage:Q.$MP,LanguageModelChatAssistantMessage:Q.$NP,LanguageModelError:Q.$OP,NewSymbolName:Q.$MO,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$PP,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(Ce[319],Ie([1,0,61,128,44,122,45,34,58,57,131,133,134,89,93,85,121,69,51,88,67,71,258,12,132,86,87,91,95,126,96]),function(oe,e,b,S,k,O,A,T,p,a,R,y,u,E,f,n,s,o,h,i,r,t,c,l,m,d,$,I,D,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.$Os)(d.$epc,d.$dpc,b.InstantiationType.Delayed),(0,b.$Os)(l.$ak,c.$tqc,b.InstantiationType.Delayed),(0,b.$Os)(n.$joc,n.$koc,b.InstantiationType.Delayed),(0,b.$Os)(T.$kQ,T.$jQ,b.InstantiationType.Eager),(0,b.$Os)(I.$toc,I.$uoc,b.InstantiationType.Eager),(0,b.$Os)(D.$$oc,D.$_oc,b.InstantiationType.Eager),(0,b.$Os)(A.$Ioc,A.$Goc,b.InstantiationType.Eager),(0,b.$Os)(o.$Koc,o.$Joc,b.InstantiationType.Eager),(0,b.$Os)(C.$opc,C.$ppc,b.InstantiationType.Eager),(0,b.$Os)(y.$tpc,y.$xpc,b.InstantiationType.Eager),(0,b.$Os)(O.$zpc,O.$ypc,b.InstantiationType.Eager),(0,b.$Os)(p.$_P,p.$$P,b.InstantiationType.Eager),(0,b.$Os)($.$fpc,$.$gpc,b.InstantiationType.Eager),(0,b.$Os)(h.$noc,h.$moc,b.InstantiationType.Eager),(0,b.$Os)(S.$5pc,S.$4pc,b.InstantiationType.Delayed),(0,b.$Os)(u.$Ppc,u.$Qpc,b.InstantiationType.Eager),(0,b.$Os)(E.$4oc,E.$3oc,b.InstantiationType.Eager),(0,b.$Os)(R.$fqc,R.$eqc,b.InstantiationType.Eager),(0,b.$Os)(a.$7oc,a.$0oc,b.InstantiationType.Eager),(0,b.$Os)(v.$gqc,v.$hqc,b.InstantiationType.Eager),(0,b.$Os)(f.$XFb,f.$YFb,b.InstantiationType.Eager),(0,b.$Os)(s.$qqc,s.$pqc,b.InstantiationType.Eager),(0,b.$Os)(k.$Foc,k.$Eoc,b.InstantiationType.Eager),(0,b.$Os)(i.$bpc,i.$apc,b.InstantiationType.Eager),(0,b.$Os)(r.$iQ,r.$fQ,b.InstantiationType.Eager),(0,b.$Os)(t.$Uoc,t.$Voc,b.InstantiationType.Eager),(0,b.$Os)(m.$mpc,m.$npc,b.InstantiationType.Eager)}),define(Ce[320],Ie([1,0,318,46,2,315,7,11,265]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsc=void 0;class a extends O.$wqc{j(){}getModule(E,f){for(const n of this.b){const s=n(E);if(s){E=s;break}}if(this.a.has(E))return this.a.get(E).load(E,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends S.$ipc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$Esc);const E=this.h.invokeFunction(b.$sqc);this.r=this.h.createInstance(a,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,f,n){f=f.with({path:y(f.path,".js")});const s=E?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=k.URI.revive(await this.C.$asBrowserUri(f)),h=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),h.status!==200)throw new Error(h.statusText);const i=await h.text(),r=`${f.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let c;try{c=new Function("module","exports","require",t)}catch($){throw console.error(s?`Loading code for extension ${s} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${f.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}E&&await this.w.initializeLocalizedMessages(E);const l={},m={exports:l},d=$=>{const I=this.r.getModule($,f);if(I===void 0)throw new Error(`Cannot load module '${$}'`);return I};try{return n.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),c(m,l,d),m.exports!==l?m.exports:l}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),n.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+E;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Gh)(10)}}e.$Fsc=R;function y(u,E){return u.endsWith(E)?u:u+E}}),define(Ce[321],Ie([1,0,74,61,12,46,229,92,320]),function(oe,e,b,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$Os)(k.$_j,new b.$Ci(A.$vqc,[!0],!0)),(0,S.$Os)(O.$jpc,p.$Fsc,S.InstantiationType.Eager),(0,S.$Os)(T.$Loc,T.$Moc,S.InstantiationType.Eager)}),define(Ce[329],Ie([1,0,23,6,84,316,267,20,65,16,2,319,321]),function(oe,e,b,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=qe(T),p=qe(p);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(c){return/^(file|vscode-remote):/i.test(c)}const f=fetch.bind(self);function n(c){self.fetch=async function(l,m){return l instanceof Request||E(String(l))&&(l=(await c(R.URI.parse(String(l)))).toString(!0)),f(l,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,m,d,$,I){(async()=>(E(m.toString())&&(m=(await c(R.URI.parse(m.toString()))).toString(!0)),super.open(l,m,d??!0,$,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const c=self.Worker;Worker=function(l,m){if(/^file:/i.test(l.toString()))l=a.$Zg.uriToBrowserUri(R.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(C){function P(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const g=fetch.bind(self);self.fetch=function(M,N){return M instanceof Request?g(M,N):g(P(M),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,N,L,G,B){return super.open(M,P(N),L??!0,G,B)}};const w=importScripts.bind(self);self.importScripts=(...M)=>{w(...M.map(P))},w(C)}.toString()}('${l}'))`;m=m||{},m.name=`${name} -> ${m.name||T.$pc(l.toString())}`;const I=new Blob([$],{type:"application/javascript"}),D=URL.createObjectURL(I);return new c(D,m)}}else self.Worker=class extends A.$Gsc{constructor(c,l){super(u,c,{name:T.$pc(c.toString()),...l})}};const s=new class{constructor(){this.pid=void 0}exit(c){y()}};class o{constructor(){const l=new MessageChannel,m=new S.$me;let d=!1;u(l.port2,[l.port2]),l.port1.onmessage=$=>{const{data:I}=$;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const D=b.$Oe.wrap(new Uint8Array(I,0,I.byteLength));if((0,k.$Bn)(D,k.MessageType.Terminate)){d=!0,i("received terminate message from renderer");return}m.fire(D)},this.protocol={onMessage:m.event,send:$=>{if(!d){const I=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);l.port1.postMessage(I,[I])}}}}}function h(c){return new Promise(l=>{const m=c.onMessage(d=>{m.dispose();const $=JSON.parse(d.toString());c.send((0,k.$An)(k.MessageType.Initialized)),l({protocol:c,initData:$})});c.send((0,k.$An)(k.MessageType.Ready))})}let i=c=>y();function r(c){return!!c&&typeof c=="object"&&c.type==="vscode.init"&&c.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const c=new o;return{onmessage(l){r(l)&&h(c.protocol).then(m=>{p.mark("code/extHost/didWaitForInitData");const d=new O.$yqc(m.protocol,m.initData,s,null,l.data);n($=>d.asBrowserUri($)),i=$=>d.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/4bbebd8af922ed3b5a7a14eb0848c04918454c38/core/vs/workbench/api/worker/extensionHostWorker.js.map
